/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/
(function(){
var e,t=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/strings","vs/base/common/platform","vs/workbench/api/common/extHostTypes","vs/platform/log/common/log","vs/base/common/types","vs/base/common/arrays","vs/workbench/api/common/extHostRpcService","vs/nls","vs/base/common/async","vs/nls!vs/workbench/services/extensions/node/extensionHostProcess","vs/base/common/objects","vs/base/common/errors","vs/base/common/network","vs/workbench/api/common/extHostTypeConverters","vs/base/common/cancellation","vs/base/common/resources","vs/base/node/pfs","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/base/common/glob","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostWorkspace","child_process","vs/workbench/services/search/common/search","vs/base/common/extpath","fs","vs/base/common/process","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/workbench/api/common/extHostDocumentsAndEditors","os","vs/base/common/uuid","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDebugService","vs/platform/files/common/files","vs/base/common/errorMessage","vs/editor/common/core/range","vs/platform/registry/common/platform","vs/editor/common/core/position","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/extHostApiDeprecationService","vs/base/common/marshalling","vs/workbench/api/common/extHostTunnelService","vs/base/common/json","vs/base/common/assert","util","vs/workbench/api/common/extHostStoragePaths","vs/workbench/services/search/node/ripgrepSearchUtils","vs/workbench/api/common/extHostOutput","vs/platform/workspaces/common/workspaces","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/amd","vs/workbench/api/common/extHostSearch","vs/workbench/api/common/extHostTask","vs/workbench/contrib/terminal/common/terminal","vs/platform/instantiation/common/serviceCollection","vs/workbench/api/common/shared/webview","vs/editor/common/modes/languageSelector","vs/platform/contextkey/common/contextkey","vs/editor/common/modes","vs/base/common/linkedList","vs/platform/instantiation/common/extensions","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostStorage","vs/base/common/decorators","vs/base/common/codicons","vs/base/node/processes","vs/platform/configuration/common/configuration","vs/base/common/severity","vs/workbench/contrib/terminal/node/terminalEnvironment","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/editor/common/viewModel/prefixSumComputer","vs/editor/common/model/wordHelper","vs/platform/log/node/spdlogService","vs/platform/markers/common/markers","vs/platform/product/common/product","net","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/base/parts/ipc/node/ipc.net","vs/platform/workspace/common/workspace","vs/workbench/api/common/cache","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/common/ipc","string_decoder","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/node/terminal","vs/platform/instantiation/common/descriptors","vs/base/common/uriIpc","vs/workbench/api/common/extHostTextEditor","vs/base/common/labels","vs/workbench/services/extensions/common/proxyIdentifier","vs/base/common/htmlContent","vs/base/common/fuzzyScorer","vs/workbench/api/common/extHostDecorations","vs/base/common/filters","vs/base/common/uint","vs/base/common/comparers","vs/base/common/iterator","vs/base/common/idGenerator","vs/workbench/services/search/common/searchExtTypes","vs/workbench/services/search/common/textSearchManager","vs/base/common/functional","vs/base/common/collections","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/editor/common/editorService","vs/editor/common/modes/languageConfiguration","vs/base/common/date","vs/platform/instantiation/common/instantiationService","vs/editor/common/model","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/platform/notification/common/notification","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/platform/progress/common/progress","vs/editor/common/core/selection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/editor/common/core/characterClassifier","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/platform/configuration/common/configurationModels","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/platform/sign/node/signService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/workbench/api/common/extHost.api.impl","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostMemento","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/base/node/extpath","vs/workbench/services/extensions/node/extensionHostProcessSetup","vs/workbench/api/node/extHost.services","vs/workbench/api/common/extHostTheming","vs/base/node/encoding","vs/workbench/api/common/shared/semanticTokensDto","vs/nls!vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostCodeInsets","vs/workbench/api/node/extHostStoragePaths","vs/workbench/common/resources","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/contrib/externalTerminal/common/externalTerminal","vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/contrib/debug/node/terminals","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/base/node/decoder","vs/workbench/contrib/terminal/common/terminalDataBuffering","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/workbench/contrib/terminal/node/terminalProcess","vs/workbench/api/node/extHostSearch","vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/base/node/processes","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/common/apiCommands","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/contrib/externalTerminal/node/externalTerminalService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/nls!vs/workbench/contrib/terminal/common/terminal","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/node/extHostLogService","vs/workbench/services/extensions/common/lazyPromise","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/base/common/date","vs/platform/extensionManagement/common/extensionManagementUtil","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostClipboard","vs/base/common/codicon","vs/workbench/api/common/extHostComments","vs/nls!vs/base/common/severity","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/editor/common/model/mirrorTextModel","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/platform/instantiation/common/graph","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/base/common/hash","vs/base/common/stream","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/base/common/processes","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostWindow","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/node/outputAppender","vs/workbench/api/node/extHostOutputService","vs/nls!vs/base/common/errorMessage","vs/base/common/numbers","vs/base/common/jsonEdit","vs/base/common/jsonFormatter","vs/editor/common/services/modeService","vs/workbench/api/common/extHostRequireInterceptor","vs/editor/common/services/modelService","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostTerminalService","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes/tokenizationRegistry","vs/platform/commands/common/commands","vs/workbench/api/common/extHost.api.impl","vs/editor/common/modes/linkComputer","vs/platform/environment/common/environment","vs/workbench/services/extensions/node/proxyResolver","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/ripgrepSearchProvider","vs/platform/extensionManagement/common/extensionManagement","vs/workbench/services/search/node/fileSearch","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepFileSearch","vscode-ripgrep","graceful-fs","vscode-proxy-agent","events","tls","https","vs/base/common/marked/marked","url","node-pty","iconv-lite","stream","minimist","vs/workbench/services/extensions/node/extensionHostProcess"],i=function(e){
for(var i=[],n=0,r=e.length;n<r;n++)i[n]=t[e[n]];return i};define(t[56],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0,t.ok=function(e,t){if(!e)throw new Error(t?`Assertion failed (${t})`:"Assertion Failed")}})),define(t[117],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.fromMap=t.groupBy=t.forEach=t.first=t.size=t.values=void 0;const i=Object.prototype.hasOwnProperty;t.values=function(e){const t=[];for(let n in e)i.call(e,n)&&t.push(e[n]);return t},t.size=function(e){let t=0;for(let n in e)i.call(e,n)&&(t+=1);return t},t.first=function(e){for(const t in e)if(i.call(e,t))return e[t]},t.forEach=function(e,t){for(let n in e)if(i.call(e,n)){if(!1===t({key:n,value:e[n]},(function(){delete e[n]})))return}},t.groupBy=function(e,t){const i=Object.create(null);for(const n of e){const e=t(n);let r=i[e];r||(r=i[e]=[]),r.push(n)}return i},t.fromMap=function(e){const t=Object.create(null);return e&&e.forEach((e,i)=>{
t[i]=e}),t};t.SetMap=class{constructor(){this.map=new Map}add(e,t){let i=this.map.get(e);i||(i=new Set,this.map.set(e,i)),i.add(t)}delete(e,t){const i=this.map.get(e);i&&(i.delete(t),0===i.size&&this.map.delete(e))}forEach(e,t){const i=this.map.get(e);i&&i.forEach(t)}}})),define(t[77],i([1,0]),(function(e,t){"use strict";function i(e){return(t,i,n)=>{let r=null,o=null;if("function"==typeof n.value?(r="value",o=n.value):"function"==typeof n.get&&(r="get",o=n.get),!o)throw new Error("not supported");n[r]=e(o,i)}}Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createMemoizer=t.createDecorator=void 0,t.createDecorator=i;let n=0;function r(){const e=`$memoize${n++}`;let t=void 0;const i=function(i,n,r){let o=null,s=null;if("function"==typeof r.value?(o="value",0!==(s=r.value).length&&console.warn("Memoize should only be used in functions with zero parameters")):"function"==typeof r.get&&(o="get",s=r.get),!s)throw new Error("not supported");const a=`${e}:${n}`;r[o]=function(...e){
return t=this,this.hasOwnProperty(a)||Object.defineProperty(this,a,{configurable:!0,enumerable:!1,writable:!0,value:s.apply(this,e)}),this[a]}};return i.clear=()=>{void 0!==t&&Object.getOwnPropertyNames(t).forEach(i=>{0===i.indexOf(e)&&delete t[i]})},i}t.createMemoizer=r,t.memoize=function(e,t,i){return r()(e,t,i)},t.debounce=function(e,t,n){return i((i,r)=>{const o=`$debounce$${r}`,s=`$debounce$result$${r}`;return function(...r){this[s]||(this[s]=n?n():void 0),clearTimeout(this[o]),t&&(this[s]=t(this[s],...r),r=[this[s]]),this[o]=setTimeout(()=>{i.apply(this,r),this[s]=n?n():void 0},e)}})},t.throttle=function(e,t,n){return i((i,r)=>{const o=`$throttle$timer$${r}`,s=`$throttle$result$${r}`,a=`$throttle$lastRun$${r}`,c=`$throttle$pending$${r}`;return function(...r){if(this[s]||(this[s]=n?n():void 0),null!==this[a]&&void 0!==this[a]||(this[a]=-Number.MAX_VALUE),t&&(this[s]=t(this[s],...r)),this[c])return;const l=this[a]+e;l<=Date.now()?(this[a]=Date.now(),i.apply(this,[this[s]]),
this[s]=n?n():void 0):(this[c]=!0,this[o]=setTimeout(()=>{this[c]=!1,this[a]=Date.now(),i.apply(this,[this[s]]),this[s]=n?n():void 0},l-Date.now()))}})}})),define(t[19],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.isPromiseCanceledError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class i{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(e){setTimeout(()=>{if(e.stack)throw new Error(e.message+"\n\n"+e.stack);throw e},0)}}addListener(e){return this.listeners.push(e),()=>{this._removeListener(e)}}emit(e){this.listeners.forEach(t=>{t(e)})}_removeListener(e){this.listeners.splice(this.listeners.indexOf(e),1)}setUnexpectedErrorHandler(e){this.unexpectedErrorHandler=e}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(e){
this.unexpectedErrorHandler(e),this.emit(e)}onUnexpectedExternalError(e){this.unexpectedErrorHandler(e)}}t.ErrorHandler=i,t.errorHandler=new i,t.setUnexpectedErrorHandler=function(e){t.errorHandler.setUnexpectedErrorHandler(e)},t.onUnexpectedError=function(e){r(e)||t.errorHandler.onUnexpectedError(e)},t.onUnexpectedExternalError=function(e){r(e)||t.errorHandler.onUnexpectedExternalError(e)},t.transformErrorForSerialization=function(e){if(e instanceof Error){let{name:t,message:i}=e;return{$isError:!0,name:t,message:i,stack:e.stacktrace||e.stack}}return e};const n="Canceled";function r(e){return e instanceof Error&&e.name===n&&e.message===n}t.isPromiseCanceledError=r,t.canceled=function(){const e=new Error(n);return e.name=e.message,e},t.illegalArgument=function(e){return e?new Error(`Illegal argument: ${e}`):new Error("Illegal argument")},t.illegalState=function(e){return e?new Error(`Illegal state: ${e}`):new Error("Illegal state")},t.readonly=function(e){
return e?new Error(`readonly property '${e} cannot be changed'`):new Error("readonly property cannot be changed")},t.disposed=function(e){const t=new Error(`${e} has been disposed`);return t.name="DISPOSED",t},t.getErrorMessage=function(e){return e?e.message?e.message:e.stack?e.stack.split("\n")[0]:String(e):"Error"};class o extends Error{constructor(e){super("NotImplemented"),e&&(this.message=e)}}t.NotImplementedError=o})),define(t[13],i([1,0,19]),(function(e,t,i){"use strict";function n(e,t){let i=0,n=e.length;if(0===n)return 0;for(;i<n;){const r=Math.floor((i+n)/2);t(e[r])?n=r:i=r+1}return i}function r(e,t){return function e(t,i,n,r,o){if(r<=n)return;const s=n+(r-n)/2|0;e(t,i,n,s,o);e(t,i,s+1,r,o);if(i(t[s],t[s+1])<=0)return;!function(e,t,i,n,r,o){let s=i,a=n+1;for(let t=i;t<=r;t++)o[t]=e[t];for(let c=i;c<=r;c++)s>n?e[c]=o[a++]:a>r?e[c]=o[s++]:t(o[a],o[s])<0?e[c]=o[a++]:e[c]=o[s++]}(t,i,n,s,r,o)}(e,t,0,e.length-1,[]),e}function o(e,t,i){const n=[];function r(e,t,i){if(0===t&&0===i.length)return
;const r=n[n.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...i)):n.push({start:e,deleteCount:t,toInsert:i})}let o=0,s=0;for(;;){if(o===e.length){r(o,0,t.slice(s));break}if(s===t.length){r(o,e.length-o,[]);break}const n=e[o],a=t[s],c=i(n,a);0===c?(o+=1,s+=1):c<0?(r(o,1,[]),o+=1):c>0&&(r(o,0,[a]),s+=1)}return n}function s(e,t,i,r,o){for(const s=i.length;r<o;r++){const o=e[r];if(t(o,i[s-1])<0){i.pop();const e=n(i,e=>t(o,e)<0);i.splice(e,0,o)}}}function a(e,t){for(let i=0;i<e.length;i++){if(t(e[i]))return i}return-1}Object.defineProperty(t,"__esModule",{value:!0}),
t.getRandomElement=t.asArray=t.mapArrayOrNot=t.find=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.first=t.firstIndex=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.mergeSort=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0,t.tail=function(e,t=0){return e[e.length-(1+t)]},t.tail2=function(e){if(0===e.length)throw new Error("Invalid tail call");return[e.slice(0,e.length-1),e[e.length-1]]},t.equals=function(e,t,i=((e,t)=>e===t)){if(e===t)return!0;if(!e||!t)return!1;if(e.length!==t.length)return!1;for(let n=0,r=e.length;n<r;n++)if(!i(e[n],t[n]))return!1;return!0},t.binarySearch=function(e,t,i){let n=0,r=e.length-1;for(;n<=r;){const o=(n+r)/2|0,s=i(e[o],t);if(s<0)n=o+1;else{if(!(s>0))return o;r=o-1}}return-(n+1)},t.findFirstInSorted=n,t.mergeSort=r,t.groupBy=function(e,t){const i=[];let n=void 0
;for(const o of r(e.slice(0),t))n&&0===t(n[0],o)?n.push(o):(n=[o],i.push(n));return i},t.sortedDiff=o,t.delta=function(e,t,i){const n=o(e,t,i),r=[],s=[];for(const t of n)r.push(...e.slice(t.start,t.start+t.deleteCount)),s.push(...t.toInsert);return{removed:r,added:s}},t.top=function(e,t,i){if(0===i)return[];const n=e.slice(0,i).sort(t);return s(e,t,n,i,e.length),n},t.topAsync=function(e,t,n,r,o){return 0===n?Promise.resolve([]):new Promise((a,c)=>{(async()=>{const a=e.length,c=e.slice(0,n).sort(t);for(let l=n,u=Math.min(n+r,a);l<a;l=u,u=Math.min(u+r,a)){if(l>n&&await new Promise(e=>setTimeout(e)),o&&o.isCancellationRequested)throw i.canceled();s(e,t,c,l,u)}return c})().then(a,c)})},t.coalesce=function(e){return e.filter(e=>!!e)},t.coalesceInPlace=function(e){let t=0;for(let i=0;i<e.length;i++)e[i]&&(e[t]=e[i],t+=1);e.length=t},t.move=function(e,t,i){e.splice(i,0,e.splice(t,1)[0])},t.isFalsyOrEmpty=function(e){return!Array.isArray(e)||0===e.length},t.isNonEmptyArray=function(e){
return Array.isArray(e)&&e.length>0},t.distinct=function(e,t){if(!t)return e.filter((t,i)=>e.indexOf(t)===i);const i=Object.create(null);return e.filter(e=>{const n=t(e);return!i[n]&&(i[n]=!0,!0)})},t.distinctES6=function(e){const t=new Set;return e.filter(e=>!t.has(e)&&(t.add(e),!0))},t.uniqueFilter=function(e){const t=Object.create(null);return i=>{const n=e(i);return!t[n]&&(t[n]=!0,!0)}},t.lastIndex=function(e,t){for(let i=e.length-1;i>=0;i--){if(t(e[i]))return i}return-1},t.firstIndex=a,t.first=function(e,t,i){const n=a(e,t);return n<0?i:e[n]},t.firstOrDefault=function(e,t){return e.length>0?e[0]:t},t.commonPrefixLength=function(e,t,i=((e,t)=>e===t)){let n=0;for(let r=0,o=Math.min(e.length,t.length);r<o&&i(e[r],t[r]);r++)n++;return n},t.flatten=function(e){return[].concat(...e)},t.range=function(e,t){let i="number"==typeof t?e:0;"number"==typeof t?i=e:(i=0,t=e);const n=[];if(i<=t)for(let e=i;e<t;e++)n.push(e);else for(let e=i;e>t;e--)n.push(e);return n},t.index=function(e,t,i=(e=>e)){
return e.reduce((e,n)=>{const r=t(n);return e[r]=i(n,e[r]),e},Object.create(null))},t.insert=function(e,t){return e.push(t),()=>{const i=e.indexOf(t);i>-1&&e.splice(i,1)}},t.arrayInsert=function(e,t,i){const n=e.slice(0,t),r=e.slice(t);return n.concat(i,r)},t.shuffle=function(e,t){let i;if("number"==typeof t){let e=t;i=()=>{const t=179426549*Math.sin(e++);return t-Math.floor(t)}}else i=Math.random;for(let t=e.length-1;t>0;t-=1){const n=Math.floor(i()*(t+1)),r=e[t];e[t]=e[n],e[n]=r}},t.pushToStart=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.unshift(t))},t.pushToEnd=function(e,t){const i=e.indexOf(t);i>-1&&(e.splice(i,1),e.push(t))},t.find=function(e,t){for(let i=0;i<e.length;i++){const n=e[i];if(t(n,i,e))return n}},t.mapArrayOrNot=function(e,t){return Array.isArray(e)?e.map(t):t(e)},t.asArray=function(e){return Array.isArray(e)?e:[e]},t.getRandomElement=function(e){return e[Math.floor(Math.random()*e.length)]}})),define(t[116],i([1,0]),(function(e,t){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0,t.once=function(e){const t=this;let i,n=!1;return function(){return n?i:(n=!0,i=e.apply(t,arguments))}}})),define(t[113],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class i{constructor(e){this._prefix=e,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=i,t.defaultGenerator=new i("id#")})),define(t[112],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0,function(e){e.is=function(e){return e&&"object"==typeof e&&"function"==typeof e[Symbol.iterator]};const t=Object.freeze([]);e.empty=function(){return t},e.single=function*(e){yield e},e.from=function(e){return e||t},e.first=function(e){return e[Symbol.iterator]().next().value},e.some=function(e,t){for(const i of e)if(t(i))return!0;return!1},e.filter=function*(e,t){for(const i of e)t(i)&&(yield i)},e.map=function*(e,t){
for(const i of e)yield t(i)},e.concat=function*(...e){for(const t of e)for(const e of t)yield e},e.consume=function(t,i=Number.POSITIVE_INFINITY){const n=[];if(0===i)return[n,t];const r=t[Symbol.iterator]();for(let t=0;t<i;t++){const t=r.next();if(t.done)return[n,e.empty()];n.push(t.value)}return[n,{[Symbol.iterator]:()=>r}]}}(t.Iterable||(t.Iterable={}))})),define(t[55],i([1,0]),(function(e,t){"use strict";var i,n;function r(e,t=!1){let i=0,n=e.length,r="",c=0,l=16,u=0;function d(t){let n=0,r=0;for(;n<t;){const t=e.charCodeAt(i);if(t>=48&&t<=57)r=16*r+t-48;else if(t>=65&&t<=70)r=16*r+t-65+10;else{if(!(t>=97&&t<=102))break;r=16*r+t-97+10}i++,n++}return n<t&&(r=-1),r}function h(){if(r="",u=0,c=i,i>=n)return c=n,l=17;let t=e.charCodeAt(i);if(o(t)){do{i++,r+=String.fromCharCode(t),t=e.charCodeAt(i)}while(o(t));return l=15}if(s(t))return i++,r+=String.fromCharCode(t),13===t&&10===e.charCodeAt(i)&&(i++,r+="\n"),l=14;switch(t){case 123:return i++,l=1;case 125:return i++,l=2;case 91:return i++,l=3;case 93:
return i++,l=4;case 58:return i++,l=6;case 44:return i++,l=5;case 34:return i++,r=function(){let t="",r=i;for(;;){if(i>=n){t+=e.substring(r,i),u=2;break}const o=e.charCodeAt(i);if(34===o){t+=e.substring(r,i),i++;break}if(92!==o){if(o>=0&&o<=31){if(s(o)){t+=e.substring(r,i),u=2;break}u=6}i++}else{if(t+=e.substring(r,i),++i>=n){u=2;break}switch(e.charCodeAt(i++)){case 34:t+='"';break;case 92:t+="\\";break;case 47:t+="/";break;case 98:t+="\b";break;case 102:t+="\f";break;case 110:t+="\n";break;case 114:t+="\r";break;case 116:t+="\t";break;case 117:const e=d(4);e>=0?t+=String.fromCharCode(e):u=4;break;default:u=5}r=i}}return t}(),l=10;case 47:const o=i-1;if(47===e.charCodeAt(i+1)){for(i+=2;i<n&&!s(e.charCodeAt(i));)i++;return r=e.substring(o,i),l=12}if(42===e.charCodeAt(i+1)){i+=2;const t=n-1;let s=!1;for(;i<t;){if(42===e.charCodeAt(i)&&47===e.charCodeAt(i+1)){i+=2,s=!0;break}i++}return s||(i++,u=1),r=e.substring(o,i),l=13}return r+=String.fromCharCode(t),i++,l=16;case 45:if(r+=String.fromCharCode(t),
++i===n||!a(e.charCodeAt(i)))return l=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=function(){const t=i;if(48===e.charCodeAt(i))i++;else for(i++;i<e.length&&a(e.charCodeAt(i));)i++;if(i<e.length&&46===e.charCodeAt(i)){if(!(++i<e.length&&a(e.charCodeAt(i))))return u=3,e.substring(t,i);for(i++;i<e.length&&a(e.charCodeAt(i));)i++}let n=i;if(i<e.length&&(69===e.charCodeAt(i)||101===e.charCodeAt(i)))if((++i<e.length&&43===e.charCodeAt(i)||45===e.charCodeAt(i))&&i++,i<e.length&&a(e.charCodeAt(i))){for(i++;i<e.length&&a(e.charCodeAt(i));)i++;n=i}else u=3;return e.substring(t,n)}(),l=11;default:for(;i<n&&p(t);)i++,t=e.charCodeAt(i);if(c!==i){switch(r=e.substring(c,i)){case"true":return l=8;case"false":return l=9;case"null":return l=7}return l=16}return r+=String.fromCharCode(t),i++,l=16}}function p(e){if(o(e)||s(e))return!1;switch(e){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}return{setPosition:function(e){i=e,r="",c=0,l=16,u=0},
getPosition:()=>i,scan:t?function(){let e;do{e=h()}while(e>=12&&e<=15);return e}:h,getToken:()=>l,getTokenValue:()=>r,getTokenOffset:()=>c,getTokenLength:()=>i-c,getTokenError:()=>u}}function o(e){return 32===e||9===e||11===e||12===e||160===e||5760===e||e>=8192&&e<=8203||8239===e||8287===e||12288===e||65279===e}function s(e){return 10===e||13===e||8232===e||8233===e}function a(e){return e>=48&&e<=57}function c(e,t,i=!1){return t>=e.offset&&t<e.offset+e.length||i&&t===e.offset+e.length}function l(e,t,n=i.DEFAULT){const o=r(e,!1);function s(e){return e?()=>e(o.getTokenOffset(),o.getTokenLength()):()=>!0}function a(e){return e?t=>e(t,o.getTokenOffset(),o.getTokenLength()):()=>!0}const c=s(t.onObjectBegin),l=a(t.onObjectProperty),u=s(t.onObjectEnd),d=s(t.onArrayBegin),h=s(t.onArrayEnd),p=a(t.onLiteralValue),m=a(t.onSeparator),f=s(t.onComment),g=a(t.onError),v=n&&n.disallowComments,_=n&&n.allowTrailingComma;function y(){for(;;){const e=o.scan();switch(o.getTokenError()){case 4:w(14);break;case 5:w(15);break
;case 3:w(13);break;case 1:v||w(11);break;case 2:w(12);break;case 6:w(16)}switch(e){case 12:case 13:v?w(10):f();break;case 16:w(1);break;case 15:case 14:break;default:return e}}}function w(e,t=[],i=[]){if(g(e),t.length+i.length>0){let e=o.getToken();for(;17!==e;){if(-1!==t.indexOf(e)){y();break}if(-1!==i.indexOf(e))break;e=y()}}}function b(e){const t=o.getTokenValue();return e?p(t):l(t),y(),!0}function E(){switch(o.getToken()){case 3:return function(){d(),y();let e=!1;for(;4!==o.getToken()&&17!==o.getToken();){if(5===o.getToken()){if(e||w(4,[],[]),m(","),y(),4===o.getToken()&&_)break}else e&&w(6,[],[]);E()||w(4,[],[4,5]),e=!0}return h(),4!==o.getToken()?w(8,[4],[]):y(),!0}();case 1:return function(){c(),y();let e=!1;for(;2!==o.getToken()&&17!==o.getToken();){if(5===o.getToken()){if(e||w(4,[],[]),m(","),y(),2===o.getToken()&&_)break}else e&&w(6,[],[]);(10!==o.getToken()?(w(3,[],[2,5]),0):(b(!1),6===o.getToken()?(m(":"),y(),E()||w(4,[],[2,5])):w(5,[],[2,5]),1))||w(4,[],[2,5]),e=!0}return u(),
2!==o.getToken()?w(7,[2],[]):y(),!0}();case 10:return b(!0);default:return function(){switch(o.getToken()){case 11:let e=0;try{"number"!=typeof(e=JSON.parse(o.getTokenValue()))&&(w(2),e=0)}catch(e){w(2)}p(e);break;case 7:p(null);break;case 8:p(!0);break;case 9:p(!1);break;default:return!1}return y(),!0}()}}return y(),17===o.getToken()?!!n.allowEmptyContent||(w(4,[],[]),!1):E()?(17!==o.getToken()&&w(9,[],[]),!0):(w(4,[],[]),!1)}function u(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":return e?Array.isArray(e)?"array":"object":"null";default:return"null"}}Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0,function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",
e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"}(t.ScanError||(t.ScanError={})),function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"}(t.SyntaxKind||(t.SyntaxKind={})),function(e){e[e.InvalidSymbol=1]="InvalidSymbol",
e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"}(t.ParseErrorCode||(t.ParseErrorCode={})),function(e){e.DEFAULT={allowTrailingComma:!0}}(i=t.ParseOptions||(t.ParseOptions={})),t.createScanner=r,function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",
e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",
e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",
e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"}(n||(n={})),t.getLocation=function(e,t){const i=[],n=new Object;let r=void 0;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let s=!1;function a(e,t,i,n){o.value=e,o.offset=t,o.length=i,o.type=n,o.colonOffset=void 0,r=o}try{l(e,{onObjectBegin:(e,o)=>{if(t<=e)throw n;r=void 0,s=t>e,i.push("")},onObjectProperty:(e,r,o)=>{if(t<r)throw n;if(a(e,r,o,"property"),i[i.length-1]=e,t<=r+o)throw n},
onObjectEnd:(e,o)=>{if(t<=e)throw n;r=void 0,i.pop()},onArrayBegin:(e,o)=>{if(t<=e)throw n;r=void 0,i.push(0)},onArrayEnd:(e,o)=>{if(t<=e)throw n;r=void 0,i.pop()},onLiteralValue:(e,i,r)=>{if(t<i)throw n;if(a(e,i,r,u(e)),t<=i+r)throw n},onSeparator:(e,o,a)=>{if(t<=o)throw n;if(":"===e&&r&&"property"===r.type)r.colonOffset=o,s=!1,r=void 0;else if(","===e){const e=i[i.length-1];"number"==typeof e?i[i.length-1]=e+1:(s=!0,i[i.length-1]=""),r=void 0}}})}catch(e){if(e!==n)throw e}return{path:i,previousNode:r,isAtPropertyKey:s,matches:e=>{let t=0;for(let n=0;t<e.length&&n<i.length;n++)if(e[t]===i[n]||"*"===e[t])t++;else if("**"!==e[t])return!1;return t===e.length}}},t.parse=function(e,t=[],n=i.DEFAULT){let r=null,o=[];const s=[];function a(e){Array.isArray(o)?o.push(e):null!==r&&(o[r]=e)}return l(e,{onObjectBegin:()=>{const e={};a(e),s.push(o),o=e,r=null},onObjectProperty:e=>{r=e},onObjectEnd:()=>{o=s.pop()},onArrayBegin:()=>{const e=[];a(e),s.push(o),o=e,r=null},onArrayEnd:()=>{o=s.pop()},onLiteralValue:a,
onError:(e,i,n)=>{t.push({error:e,offset:i,length:n})}},n),o[0]},t.parseTree=function(e,t=[],n=i.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(e){"property"===r.type&&(r.length=e-r.offset,r=r.parent)}function s(e){return r.children.push(e),e}l(e,{onObjectBegin:e=>{r=s({type:"object",offset:e,length:-1,parent:r,children:[]})},onObjectProperty:(e,t,i)=>{(r=s({type:"property",offset:t,length:-1,parent:r,children:[]})).children.push({type:"string",value:e,offset:t,length:i,parent:r})},onObjectEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,o(e+t)},onArrayBegin:(e,t)=>{r=s({type:"array",offset:e,length:-1,parent:r,children:[]})},onArrayEnd:(e,t)=>{r.length=e+t-r.offset,r=r.parent,o(e+t)},onLiteralValue:(e,t,i)=>{s({type:u(e),offset:t,length:i,parent:r,value:e}),o(t+i)},onSeparator:(e,t,i)=>{"property"===r.type&&(":"===e?r.colonOffset=t:","===e&&o(t))},onError:(e,i,n)=>{t.push({error:e,offset:i,length:n})}},n);const a=r.children[0];return a&&delete a.parent,a},
t.findNodeAtLocation=function(e,t){if(!e)return;let i=e;for(let e of t)if("string"==typeof e){if("object"!==i.type||!Array.isArray(i.children))return;let t=!1;for(const n of i.children)if(Array.isArray(n.children)&&n.children[0].value===e){i=n.children[1],t=!0;break}if(!t)return}else{const t=e;if("array"!==i.type||t<0||!Array.isArray(i.children)||t>=i.children.length)return;i=i.children[t]}return i},t.getNodePath=function e(t){if(!t.parent||!t.parent.children)return[];const i=e(t.parent);if("property"===t.parent.type){const e=t.parent.children[0].value;i.push(e)}else if("array"===t.parent.type){const e=t.parent.children.indexOf(t);-1!==e&&i.push(e)}return i},t.getNodeValue=function e(t){switch(t.type){case"array":return t.children.map(e);case"object":const i=Object.create(null);for(let n of t.children){const t=n.children[1];t&&(i[n.children[0].value]=e(t))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}},t.contains=c,t.findNodeAtOffset=function e(t,i,n=!1){
if(c(t,i,n)){const r=t.children;if(Array.isArray(r))for(let t=0;t<r.length&&r[t].offset<=i;t++){const o=e(r[t],i,n);if(o)return o}return t}},t.visit=l,t.stripComments=function(e,t){let i,n,o=r(e),s=[],a=0;do{switch(n=o.getPosition(),i=o.scan()){case 12:case 13:case 17:a!==n&&s.push(e.substring(a,n)),void 0!==t&&s.push(o.getTokenValue().replace(/[^\r\n]/g,t)),a=o.getPosition()}}while(17!==i);return s.join("")},t.getNodeType=u})),define(t[230],i([1,0,55]),(function(e,t,i){"use strict";function n(e,t){let i="";for(let n=0;n<t;n++)i+=e;return i}function r(e,t){for(let e=0;e<t.length;e++){const i=t.charAt(e);if("\r"===i)return e+1<t.length&&"\n"===t.charAt(e+1)?"\r\n":"\r";if("\n"===i)return"\n"}return e&&e.eol||"\n"}function o(e,t){return-1!=="\r\n".indexOf(e.charAt(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.isEOL=t.getEOL=t.format=void 0,t.format=function(e,t,s){let a,c,l,u,d;if(t){for(u=t.offset,d=u+t.length,l=u;l>0&&!o(e,l-1);)l--;let i=d;for(;i<e.length&&!o(e,i);)i++;c=e.substring(l,i),
a=function(e,t){let i=0,n=0;const r=t.tabSize||4;for(;i<e.length;){const t=e.charAt(i);if(" "===t)n++;else{if("\t"!==t)break;n+=r}i++}return Math.floor(n/r)}(c,s)}else c=e,a=0,l=0,u=0,d=e.length;const h=r(s,e);let p,m=!1,f=0;p=s.insertSpaces?n(" ",s.tabSize||4):"\t";const g=i.createScanner(c,!1);let v=!1;function _(){return h+n(p,a+f)}function y(){let e=g.scan();for(m=!1;15===e||14===e;)m=m||14===e,e=g.scan();return v=16===e||0!==g.getTokenError(),e}const w=[];function b(t,i,n){!v&&i<d&&n>u&&e.substring(i,n)!==t&&w.push({offset:i,length:n-i,content:t})}let E=y();if(17!==E){const e=g.getTokenOffset()+l;b(n(p,a),l,e)}for(;17!==E;){let e=g.getTokenOffset()+g.getTokenLength()+l,t=y(),i="";for(;!m&&(12===t||13===t);){b(" ",e,g.getTokenOffset()+l),e=g.getTokenOffset()+g.getTokenLength()+l,i=12===t?_():"",t=y()}if(2===t)1!==E&&(f--,i=_());else if(4===t)3!==E&&(f--,i=_());else{switch(E){case 3:case 1:f++,i=_();break;case 5:case 12:i=_();break;case 13:i=m?_():" ";break;case 6:i=" ";break;case 10:if(6===t){i="";break}
case 7:case 8:case 9:case 11:case 2:case 4:12===t||13===t?i=" ":5!==t&&17!==t&&(v=!0);break;case 16:v=!0}!m||12!==t&&13!==t||(i=_())}b(i,e,g.getTokenOffset()+l),E=t}return w},t.getEOL=r,t.isEOL=o})),define(t[229],i([1,0,55,230,13]),(function(e,t,i,n,r){"use strict";function o(e,t,n,r,o){const a=t.slice(),c=i.parseTree(e,[]);let l=void 0,u=void 0;for(;a.length>0&&(u=a.pop(),void 0===(l=i.findNodeAtLocation(c,a))&&void 0!==n);)n="string"==typeof u?{[u]:n}:[n];if(l){if("object"===l.type&&"string"==typeof u&&Array.isArray(l.children)){const t=i.findNodeAtLocation(l,[u]);if(void 0!==t){if(void 0===n){if(!t.parent)throw new Error("Malformed AST");const i=l.children.indexOf(t.parent);let n,o=t.parent.offset+t.parent.length;if(i>0){const e=l.children[i-1];n=e.offset+e.length}else if(n=l.offset+1,l.children.length>1){o=l.children[1].offset}return s(e,{offset:n,length:o-n,content:""},r)}return s(e,{offset:t.offset,length:t.length,content:JSON.stringify(n)},r)}{if(void 0===n)return[]
;const t=`${JSON.stringify(u)}: ${JSON.stringify(n)}`,i=o?o(l.children.map(e=>e.children[0].value)):l.children.length;let a;if(i>0){const e=l.children[i-1];a={offset:e.offset+e.length,length:0,content:","+t}}else a=0===l.children.length?{offset:l.offset+1,length:0,content:t}:{offset:l.offset+1,length:0,content:t+","};return s(e,a,r)}}if("array"===l.type&&"number"==typeof u&&Array.isArray(l.children)){if(void 0!==n){const t=`${JSON.stringify(n)}`;let i;if(0===l.children.length||0===u)i={offset:l.offset+1,length:0,content:0===l.children.length?t:t+","};else{const e=-1===u||u>l.children.length?l.children.length:u,n=l.children[e-1];i={offset:n.offset+n.length,length:0,content:","+t}}return s(e,i,r)}{const t=u,i=l.children[t];let n;if(1===l.children.length)n={offset:l.offset+1,length:l.length-2,content:""};else if(l.children.length-1===t){const e=l.children[t-1],i=e.offset+e.length;n={offset:i,length:l.offset+l.length-2-i,content:""}}else n={offset:i.offset,length:l.children[t+1].offset-i.offset,content:""}
;return s(e,n,r)}}throw new Error(`Can not add ${"number"!=typeof u?"index":"property"} to parent of type ${l.type}`)}if(void 0===n)throw new Error("Can not delete in empty document");return s(e,{offset:c?c.offset:0,length:c?c.length:0,content:JSON.stringify(n)},r)}function s(e,t,i){let r=a(e,t),o=t.offset,s=t.offset+t.content.length;if(0===t.length||0===t.content.length){for(;o>0&&!n.isEOL(r,o-1);)o--;for(;s<r.length&&!n.isEOL(r,s);)s++}const c=n.format(r,{offset:o,length:s-o},i);for(let e=c.length-1;e>=0;e--){const t=c[e];r=a(r,t),o=Math.min(o,t.offset),s=Math.max(s,t.offset+t.length),s+=t.content.length-t.length}return[{offset:o,length:e.length-(r.length-s)-o,content:r.substring(o,s)}]}function a(e,t){return e.substring(0,t.offset)+t.content+e.substring(t.offset+t.length)}Object.defineProperty(t,"__esModule",{value:!0}),t.applyEdits=t.applyEdit=t.withFormatting=t.setProperty=t.removeProperty=void 0,t.removeProperty=function(e,t,i){return o(e,t,void 0,i)},t.setProperty=o,t.withFormatting=s,t.applyEdit=a,
t.applyEdits=function(e,t){let i=r.mergeSort(t,(e,t)=>{const i=e.offset-t.offset;return 0===i?e.length-t.length:i}),n=e.length;for(let t=i.length-1;t>=0;t--){let r=i[t];if(!(r.offset+r.length<=n))throw new Error("Overlapping edit");e=a(e,r),n=r.offset}return e}})),define(t[6],i([1,0,116,112]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ImmortalReference=t.ReferenceCollection=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=void 0;const r=!1,o="__is_disposable_tracked__";function s(e){if(r&&e&&e!==u.None)try{e[o]=!0}catch(e){}}function a(e){if(!r)return e;const t=new Error("Potentially leaked disposable").stack;return setTimeout(()=>{e[o]||console.log(t)},3e3),e}function c(e){if(n.Iterable.is(e)){for(let t of e)t&&(s(t),t.dispose());return e}if(e)return s(e),e.dispose(),e}t.isDisposable=function(e){return"function"==typeof e.dispose&&0===e.dispose.length},t.dispose=c,t.combinedDisposable=function(...e){
return e.forEach(s),a({dispose:()=>c(e)})},t.toDisposable=function(e){const t=a({dispose:()=>{s(t),e()}});return t};let l=(()=>{class e{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(s(this),this._isDisposed=!0,this.clear())}clear(){this._toDispose.forEach(e=>e.dispose()),this._toDispose.clear()}add(t){if(!t)return t;if(t===this)throw new Error("Cannot register a disposable on itself!");return s(t),this._isDisposed?e.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(t),t}}return e.DISABLE_DISPOSED_WARNING=!1,e})();t.DisposableStore=l;let u=(()=>{class e{constructor(){this._store=new l,a(this)}dispose(){s(this),this._store.dispose()}_register(e){if(e===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(e)}}return e.None=Object.freeze({dispose(){}}),e})();t.Disposable=u
;t.MutableDisposable=class{constructor(){this._isDisposed=!1,a(this)}get value(){return this._isDisposed?void 0:this._value}set value(e){this._isDisposed||e===this._value||(this._value&&this._value.dispose(),e&&s(e),this._value=e)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,s(this),this._value&&this._value.dispose(),this._value=void 0}};t.ReferenceCollection=class{constructor(){this.references=new Map}acquire(e){let t=this.references.get(e);t||(t={counter:0,object:this.createReferencedObject(e)},this.references.set(e,t));const{object:n}=t,r=i.once(()=>{0==--t.counter&&(this.destroyReferencedObject(e,t.object),this.references.delete(e))});return t.counter++,{object:n,dispose:r}}};t.ImmortalReference=class{constructor(e){this.object=e}dispose(){}}})),define(t[73],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;let i=(()=>{class e{constructor(t){this.element=t,this.next=e.Undefined,this.prev=e.Undefined}}return e.Undefined=new e(void 0),e})()
;t.LinkedList=class{constructor(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===i.Undefined}clear(){this._first=i.Undefined,this._last=i.Undefined,this._size=0}unshift(e){return this._insert(e,!1)}push(e){return this._insert(e,!0)}_insert(e,t){const n=new i(e);if(this._first===i.Undefined)this._first=n,this._last=n;else if(t){const e=this._last;this._last=n,n.prev=e,e.next=n}else{const e=this._first;this._first=n,n.next=e,e.prev=n}this._size+=1;let r=!1;return()=>{r||(r=!0,this._remove(n))}}shift(){if(this._first!==i.Undefined){const e=this._first.element;return this._remove(this._first),e}}pop(){if(this._last!==i.Undefined){const e=this._last.element;return this._remove(this._last),e}}_remove(e){if(e.prev!==i.Undefined&&e.next!==i.Undefined){const t=e.prev;t.next=e.next,e.next.prev=t}else e.prev===i.Undefined&&e.next===i.Undefined?(this._first=i.Undefined,this._last=i.Undefined):e.next===i.Undefined?(this._last=this._last.prev,
this._last.next=i.Undefined):e.prev===i.Undefined&&(this._first=this._first.next,this._first.prev=i.Undefined);this._size-=1}*[Symbol.iterator](){let e=this._first;for(;e!==i.Undefined;)yield e.element,e=e.next}toArray(){const e=[];for(let t=this._first;t!==i.Undefined;t=t.next)e.push(t.element);return e}}})),define(t[3],i([1,0,19,116,6,73]),(function(e,t,i,n,r,o){"use strict";var s;Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.AsyncEmitter=t.PauseableEmitter=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0,function(e){function t(e){return(t,i=null,n)=>{let r,o=!1;return r=e(e=>{if(!o)return r?r.dispose():o=!0,t.call(i,e)},null,n),o&&r.dispose(),r}}function i(e,t){return a((i,n=null,r)=>e(e=>i.call(n,t(e)),null,r))}function n(e,t){return a((i,n=null,r)=>e(e=>{t(e),i.call(n,e)},null,r))}function o(e,t){return a((i,n=null,r)=>e(e=>t(e)&&i.call(n,e),null,r))}function s(e,t,n){let r=n;return i(e,e=>r=t(r,e))}function a(e){let t;const i=new l({
onFirstListenerAdd(){t=e(i.fire,i)},onLastListenerRemove(){t.dispose()}});return i.event}function c(e,t,i=100,n=!1,r){let o,s=void 0,a=void 0,c=0;const u=new l({leakWarningThreshold:r,onFirstListenerAdd(){o=e(e=>{c++,s=t(s,e),n&&!a&&(u.fire(s),s=void 0),clearTimeout(a),a=setTimeout(()=>{const e=s;s=void 0,a=void 0,(!n||c>1)&&u.fire(e),c=0},i)})},onLastListenerRemove(){o.dispose()}});return u.event}function u(e){let t,i=!0;return o(e,e=>{const n=i||e!==t;return i=!1,t=e,n})}e.None=()=>r.Disposable.None,e.once=t,e.map=i,e.forEach=n,e.filter=o,e.signal=function(e){return e},e.any=function(...e){return(t,i=null,n)=>r.combinedDisposable(...e.map(e=>e(e=>t.call(i,e),null,n)))},e.reduce=s,e.snapshot=a,e.debounce=c,e.stopwatch=function(e){const n=(new Date).getTime();return i(t(e),e=>(new Date).getTime()-n)},e.latch=u,e.buffer=function(e,t=!1,i=[]){let n=i.slice(),r=e(e=>{n?n.push(e):s.fire(e)});const o=()=>{n&&n.forEach(e=>s.fire(e)),n=null},s=new l({onFirstListenerAdd(){r||(r=e(e=>s.fire(e)))},
onFirstListenerDidAdd(){n&&(t?setTimeout(o):o())},onLastListenerRemove(){r&&r.dispose(),r=null}});return s.event};class d{constructor(e){this.event=e}map(e){return new d(i(this.event,e))}forEach(e){return new d(n(this.event,e))}filter(e){return new d(o(this.event,e))}reduce(e,t){return new d(s(this.event,e,t))}latch(){return new d(u(this.event))}debounce(e,t=100,i=!1,n){return new d(c(this.event,e,t,i,n))}on(e,t,i){return this.event(e,t,i)}once(e,i,n){return t(this.event)(e,i,n)}}e.chain=function(e){return new d(e)},e.fromNodeEventEmitter=function(e,t,i=(e=>e)){const n=(...e)=>r.fire(i(...e)),r=new l({onFirstListenerAdd:()=>e.on(t,n),onLastListenerRemove:()=>e.removeListener(t,n)});return r.event},e.fromDOMEventEmitter=function(e,t,i=(e=>e)){const n=(...e)=>r.fire(i(...e)),r=new l({onFirstListenerAdd:()=>e.addEventListener(t,n),onLastListenerRemove:()=>e.removeEventListener(t,n)});return r.event},e.fromPromise=function(e){const t=new l;let i=!1;return e.then(void 0,()=>null).then(()=>{
i?t.fire(void 0):setTimeout(()=>t.fire(void 0),0)}),i=!0,t.event},e.toPromise=function(e){return new Promise(i=>t(e)(i))}}(s=t.Event||(t.Event={}));let a=-1;t.setGlobalLeakWarningThreshold=function(e){const t=a;return a=e,{dispose(){a=t}}};class c{constructor(e,t=Math.random().toString(18).slice(2,5)){this.customThreshold=e,this.name=t,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(e){let t=a;if("number"==typeof this.customThreshold&&(t=this.customThreshold),t<=0||e<t)return;this._stacks||(this._stacks=new Map);const i=(new Error).stack.split("\n").slice(3).join("\n"),n=this._stacks.get(i)||0;if(this._stacks.set(i,n+1),this._warnCountdown-=1,this._warnCountdown<=0){let i;this._warnCountdown=.5*t;let n=0;this._stacks.forEach((e,t)=>{(!i||n<e)&&(i=t,n=e)}),console.warn(`[${this.name}] potential listener LEAK detected, having ${e} listeners already. MOST frequent listener (${n}):`),console.warn(i)}return()=>{const e=this._stacks.get(i)||0;this._stacks.set(i,e-1)}}}let l=(()=>{class e{
constructor(e){this._disposed=!1,this._options=e,this._leakageMon=a>0?new c(this._options&&this._options.leakWarningThreshold):void 0}get event(){return this._event||(this._event=(t,i,n)=>{this._listeners||(this._listeners=new o.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const a=this._listeners.push(i?[t,i]:t);let c,l;return s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,t,i),this._leakageMon&&(c=this._leakageMon.check(this._listeners.size)),l={dispose:()=>{if(c&&c(),l.dispose=e._noop,!this._disposed&&(a(),this._options&&this._options.onLastListenerRemove)){this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)}}},n instanceof r.DisposableStore?n.add(l):Array.isArray(n)&&n.push(l),l}),this._event}fire(e){if(this._listeners){
this._deliveryQueue||(this._deliveryQueue=new o.LinkedList);for(let t of this._listeners)this._deliveryQueue.push([t,e]);for(;this._deliveryQueue.size>0;){const[e,t]=this._deliveryQueue.shift();try{"function"==typeof e?e.call(void 0,t):e[0].call(e[1],t)}catch(e){i.onUnexpectedError(e)}}}}dispose(){this._listeners&&this._listeners.clear(),this._deliveryQueue&&this._deliveryQueue.clear(),this._leakageMon&&this._leakageMon.dispose(),this._disposed=!0}}return e._noop=function(){},e})();t.Emitter=l;t.PauseableEmitter=class extends l{constructor(e){super(e),this._isPaused=0,this._eventQueue=new o.LinkedList,this._mergeFn=e&&e.merge}pause(){this._isPaused++}resume(){if(0!==this._isPaused&&0==--this._isPaused)if(this._mergeFn){const e=this._eventQueue.toArray();this._eventQueue.clear(),super.fire(this._mergeFn(e))}else for(;!this._isPaused&&0!==this._eventQueue.size;)super.fire(this._eventQueue.shift())}fire(e){this._listeners&&(0!==this._isPaused?this._eventQueue.push(e):super.fire(e))}}
;t.AsyncEmitter=class extends l{async fireAsync(e,t,n){if(this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new o.LinkedList);for(const t of this._listeners)this._asyncDeliveryQueue.push([t,e]);for(;this._asyncDeliveryQueue.size>0&&!t.isCancellationRequested;){const[e,t]=this._asyncDeliveryQueue.shift(),r=[],o=Object.assign(Object.assign({},t),{waitUntil:t=>{if(Object.isFrozen(r))throw new Error("waitUntil can NOT be called asynchronous");n&&(t=n(t,"function"==typeof e?e:e[0])),r.push(t)}});try{"function"==typeof e?e.call(void 0,o):e[0].call(e[1],o)}catch(e){i.onUnexpectedError(e);continue}Object.freeze(r),await Promise.all(r).catch(e=>i.onUnexpectedError(e))}}}};t.EventMultiplexer=class{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new l({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(e){const t={event:e,listener:null};this.events.push(t),this.hasListeners&&this.hook(t)
;return r.toDisposable(n.once(()=>{this.hasListeners&&this.unhook(t);const e=this.events.indexOf(t);this.events.splice(e,1)}))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(e=>this.hook(e))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(e=>this.unhook(e))}hook(e){e.listener=e.event(e=>this.emitter.fire(e))}unhook(e){e.listener&&e.listener.dispose(),e.listener=null}dispose(){this.emitter.dispose()}};t.EventBufferer=class{constructor(){this.buffers=[]}wrapEvent(e){return(t,i,n)=>e(e=>{const n=this.buffers[this.buffers.length-1];n?n.push(()=>t.call(i,e)):t.call(i,e)},void 0,n)}bufferEvents(e){const t=[];this.buffers.push(t);const i=e();return this.buffers.pop(),t.forEach(e=>e()),i}};t.Relay=class{constructor(){this.listening=!1,this.inputEvent=s.None,this.inputEventListener=r.Disposable.None,this.emitter=new l({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,
this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(e){this.inputEvent=e,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=e(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}})),define(t[22],i([1,0,3]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const n=Object.freeze((function(e,t){const i=setTimeout(e.bind(t),0);return{dispose(){clearTimeout(i)}}}));var r;!function(e){e.isCancellationToken=function(t){return t===e.None||t===e.Cancelled||(t instanceof o||!(!t||"object"!=typeof t)&&("boolean"==typeof t.isCancellationRequested&&"function"==typeof t.onCancellationRequested))},e.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:i.Event.None}),e.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})}(r=t.CancellationToken||(t.CancellationToken={}));class o{constructor(){
this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new i.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}t.CancellationTokenSource=class{constructor(e){this._token=void 0,this._parentListener=void 0,this._parentListener=e&&e.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new o),this._token}cancel(){this._token?this._token instanceof o&&this._token.cancel():this._token=r.Cancelled}dispose(e=!1){e&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof o&&this._token.dispose():this._token=r.None}}})),define(t[16],i([1,0,22,19,3,6]),(function(e,t,i,n,r,o){"use strict";function s(e){return e&&"function"==typeof e.then}function a(e){
const t=new i.CancellationTokenSource,r=e(t.token),o=new Promise((e,i)=>{t.token.onCancellationRequested(()=>{i(n.canceled())}),Promise.resolve(r).then(i=>{t.dispose(),e(i)},e=>{t.dispose(),i(e)})});return new class{cancel(){t.cancel()}then(e,t){return o.then(e,t)}catch(e){return this.then(void 0,e)}finally(e){return o.finally(e)}}}Object.defineProperty(t,"__esModule",{value:!0}),t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.RunOnceWorker=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.first=t.sequence=t.ignoreErrors=t.disposableTimeout=t.timeout=t.Barrier=t.ThrottledDelayer=t.Delayer=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0,t.isThenable=s,t.createCancelablePromise=a,t.raceCancellation=function(e,t,i){return Promise.race([e,new Promise(e=>t.onCancellationRequested(()=>e(i)))])},t.raceTimeout=function(e,t,i){let n=void 0;const r=setTimeout(()=>{null==n||n(),null==i||i()},t)
;return Promise.race([e.finally(()=>clearTimeout(r)),new Promise(e=>n=e)])},t.asPromise=function(e){return new Promise((t,i)=>{const n=e();s(n)?n.then(t,i):t(n)})};class c{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(e){if(this.activePromise){if(this.queuedPromiseFactory=e,!this.queuedPromise){const e=()=>{this.queuedPromise=null;const e=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,e};this.queuedPromise=new Promise(t=>{this.activePromise.then(e,e).then(t)})}return new Promise((e,t)=>{this.queuedPromise.then(e,t)})}return this.activePromise=e(),new Promise((e,t)=>{this.activePromise.then(t=>{this.activePromise=null,e(t)},e=>{this.activePromise=null,t(e)})})}}t.Throttler=c;t.Sequencer=class{constructor(){this.current=Promise.resolve(null)}queue(e){return this.current=this.current.then(()=>e())}};class l{constructor(e){this.defaultDelay=e,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,
this.task=null}trigger(e,t=this.defaultDelay){return this.task=e,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((e,t)=>{this.doResolve=e,this.doReject=t}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const e=this.task;return this.task=null,e()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},t),this.completionPromise}isTriggered(){return null!==this.timeout}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(n.canceled()),this.completionPromise=null)}cancelTimeout(){null!==this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}t.Delayer=l;t.ThrottledDelayer=class{constructor(e){this.delayer=new l(e),this.throttler=new c}trigger(e,t){return this.delayer.trigger(()=>this.throttler.queue(e),t)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}};function u(e,t){
return t?new Promise((i,r)=>{const o=setTimeout(i,e);t.onCancellationRequested(()=>{clearTimeout(o),r(n.canceled())})}):a(t=>u(e,t))}t.Barrier=class{constructor(){this._isOpen=!1,this._promise=new Promise((e,t)=>{this._completePromise=e})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}},t.timeout=u,t.disposableTimeout=function(e,t=0){const i=setTimeout(e,t);return o.toDisposable(()=>clearTimeout(i))},t.ignoreErrors=function(e){return e.then(void 0,e=>void 0)},t.sequence=function(e){const t=[];let i=0;const n=e.length;return Promise.resolve(null).then((function r(o){null!=o&&t.push(o);const s=i<n?e[i++]():null;return s?s.then(r):Promise.resolve(t)}))},t.first=function(e,t=(e=>!!e),i=null){let n=0;const r=e.length,o=()=>{if(n>=r)return Promise.resolve(i);const s=e[n++];return Promise.resolve(s()).then(e=>t(e)?Promise.resolve(e):o())};return o()};class d{constructor(e){this._size=0,this.maxDegreeOfParalellism=e,this.outstandingPromises=[],
this.runningPromises=0,this._onFinished=new r.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(e){return this._size++,new Promise((t,i)=>{this.outstandingPromises.push({factory:e,c:t,e:i}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const e=this.outstandingPromises.shift();this.runningPromises++;const t=e.factory();t.then(e.c,e.e),t.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}t.Limiter=d;class h extends d{constructor(){super(1)}}t.Queue=h;t.ResourceQueue=class{constructor(){this.queues=new Map}queueFor(e){const t=e.toString();if(!this.queues.has(t)){const e=new h;e.onFinished(()=>{e.dispose(),this.queues.delete(t)}),this.queues.set(t,e)}return this.queues.get(t)}dispose(){this.queues.forEach(e=>e.dispose()),this.queues.clear()}}
;t.TimeoutTimer=class{constructor(e,t){this._token=-1,"function"==typeof e&&"number"==typeof t&&this.setIfNotSet(e,t)}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setTimeout(()=>{this._token=-1,e()},t)}setIfNotSet(e,t){-1===this._token&&(this._token=setTimeout(()=>{this._token=-1,e()},t))}};t.IntervalTimer=class{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){-1!==this._token&&(clearInterval(this._token),this._token=-1)}cancelAndSet(e,t){this.cancel(),this._token=setInterval(()=>{e()},t)}};class p{constructor(e,t){this.timeoutToken=-1,this.runner=e,this.timeout=t,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(e=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,e)}isScheduled(){return-1!==this.timeoutToken}onTimeout(){this.timeoutToken=-1,
this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}t.RunOnceScheduler=p;t.RunOnceWorker=class extends p{constructor(e,t){super(e,t),this.units=[]}work(e){this.units.push(e),this.isScheduled()||this.schedule()}doRun(){const e=this.units;this.units=[],this.runner&&this.runner(e)}dispose(){this.units=[],super.dispose()}},function(){if("function"!=typeof requestIdleCallback||"function"!=typeof cancelIdleCallback){const e=Object.freeze({didTimeout:!0,timeRemaining:()=>15});t.runWhenIdle=t=>{const i=setTimeout(()=>t(e));let n=!1;return{dispose(){n||(n=!0,clearTimeout(i))}}}}else t.runWhenIdle=(e,t)=>{const i=requestIdleCallback(e,"number"==typeof t?{timeout:t}:void 0);let n=!1;return{dispose(){n||(n=!0,cancelIdleCallback(i))}}}}();t.IdleValue=class{constructor(e){this._didRun=!1,this._executor=()=>{try{this._value=e()}catch(e){this._error=e}finally{this._didRun=!0}},this._handle=t.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),
this._executor()),this._error)throw this._error;return this._value}},t.retry=async function(e,t,i){let n;for(let r=0;r<i;r++)try{return await e()}catch(e){n=e,await u(t)}throw n};t.TaskSequentializer=class{hasPending(e){return!!this._pending&&("number"==typeof e?this._pending.taskId===e:!!this._pending)}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var e;null===(e=this._pending)||void 0===e||e.cancel()}setPending(e,t,i){return this._pending={taskId:e,cancel:()=>null==i?void 0:i(),promise:t},t.then(()=>this.donePending(e),()=>this.donePending(e)),t}donePending(e){this._pending&&e===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const e=this._next;this._next=void 0,e.run().then(e.promiseResolve,e.promiseReject)}}setNext(e){if(this._next)this._next.run=e;else{let t,i;const n=new Promise((e,n)=>{t=e,i=n});this._next={run:e,promise:n,promiseResolve:t,promiseReject:i}}return this._next.promise}}})),function(t){"use strict";var i={
newline:/^\n+/,code:/^( {4}[^\n]+\n*)+/,fences:g,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ *(#{1,6}) *([^\n]+?) *(?:#+ *)?(?:\n+|$)/,nptable:g,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?!\1bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?\\?>\\n*|<![A-Z][\\s\\S]*?>\\n*|<!\\[CDATA\\[[\\s\\S]*?\\]\\]>\\n*|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:g,lheading:/^([^\n]+)\n *(=|-){2,} *(?:\n+|$)/,paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading| {0,3}>|<\/?(?:tag)(?: +|\n|\/?>)|<(?:script|pre|style|!--))[^\n]+)*)/,text:/^[^\n]+/};function n(e){this.tokens=[],
this.tokens.links=Object.create(null),this.options=e||b.defaults,this.rules=i.normal,this.options.pedantic?this.rules=i.pedantic:this.options.gfm&&(this.options.tables?this.rules=i.tables:this.rules=i.gfm)}i._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,i._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,i.def=h(i.def).replace("label",i._label).replace("title",i._title).getRegex(),i.bullet=/(?:[*+-]|\d{1,9}\.)/,i.item=/^( *)(bull) ?[^\n]*(?:\n(?!\1bull ?)[^\n]*)*/,i.item=h(i.item,"gm").replace(/bull/g,i.bullet).getRegex(),i.list=h(i.list).replace(/bull/g,i.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+i.def.source+")").getRegex(),
i._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",i._comment=/<!--(?!-?>)[\s\S]*?-->/,i.html=h(i.html,"i").replace("comment",i._comment).replace("tag",i._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),i.paragraph=h(i.paragraph).replace("hr",i.hr).replace("heading",i.heading).replace("lheading",i.lheading).replace("tag",i._tag).getRegex(),i.blockquote=h(i.blockquote).replace("paragraph",i.paragraph).getRegex(),i.normal=v({},i),i.gfm=v({},i.normal,{fences:/^ {0,3}(`{3,}|~{3,})([^`\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,paragraph:/^/,heading:/^ *(#{1,6}) +([^\n]+?) *#* *(?:\n+|$)/}),
i.gfm.paragraph=h(i.paragraph).replace("(?!","(?!"+i.gfm.fences.source.replace("\\1","\\2")+"|"+i.list.source.replace("\\1","\\3")+"|").getRegex(),i.tables=v({},i.gfm,{nptable:/^ *([^|\n ].*\|.*)\n *([-:]+ *\|[-| :]*)(?:\n((?:.*[^>\n ].*(?:\n|$))*)\n*|$)/,table:/^ *\|(.+)\n *\|?( *[-:]+[-| :]*)(?:\n((?: *[^>\n ].*(?:\n|$))*)\n*|$)/}),i.pedantic=v({},i.normal,{html:h("^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:\"[^\"]*\"|'[^']*'|\\s[^'\"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))").replace("comment",i._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/}),n.rules=i,n.lex=function(e,t){return new n(t).lex(e)},n.prototype.lex=function(e){return e=e.replace(/\r\n|\r/g,"\n").replace(/\t/g,"    ").replace(/\u00a0/g," ").replace(/\u2424/g,"\n"),this.token(e,!0)},
n.prototype.token=function(e,t){var n,r,o,s,a,c,l,u,d,h,p,m,f,g,v,w;for(e=e.replace(/^ +$/gm,"");e;)if((o=this.rules.newline.exec(e))&&(e=e.substring(o[0].length),o[0].length>1&&this.tokens.push({type:"space"})),o=this.rules.code.exec(e))e=e.substring(o[0].length),o=o[0].replace(/^ {4}/gm,""),this.tokens.push({type:"code",text:this.options.pedantic?o:y(o,"\n")});else if(o=this.rules.fences.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"code",lang:o[2]?o[2].trim():o[2],text:o[3]||""});else if(o=this.rules.heading.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"heading",depth:o[1].length,text:o[2]});else if((o=this.rules.nptable.exec(e))&&(c={type:"table",header:_(o[1].replace(/^ *| *\| *$/g,"")),align:o[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:o[3]?o[3].replace(/\n$/,"").split("\n"):[]}).header.length===c.align.length){for(e=e.substring(o[0].length),
p=0;p<c.align.length;p++)/^ *-+: *$/.test(c.align[p])?c.align[p]="right":/^ *:-+: *$/.test(c.align[p])?c.align[p]="center":/^ *:-+ *$/.test(c.align[p])?c.align[p]="left":c.align[p]=null;for(p=0;p<c.cells.length;p++)c.cells[p]=_(c.cells[p],c.header.length);this.tokens.push(c)}else if(o=this.rules.hr.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"hr"});else if(o=this.rules.blockquote.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"blockquote_start"}),o=o[0].replace(/^ *> ?/gm,""),this.token(o,t),this.tokens.push({type:"blockquote_end"});else if(o=this.rules.list.exec(e)){for(e=e.substring(o[0].length),l={type:"list_start",ordered:g=(s=o[2]).length>1,start:g?+s:"",loose:!1},this.tokens.push(l),u=[],n=!1,f=(o=o[0].match(this.rules.item)).length,p=0;p<f;p++)h=(c=o[p]).length,~(c=c.replace(/^ *([*+-]|\d+\.) */,"")).indexOf("\n ")&&(h-=c.length,c=this.options.pedantic?c.replace(/^ {1,4}/gm,""):c.replace(new RegExp("^ {1,"+h+"}","gm"),"")),p!==f-1&&(a=i.bullet.exec(o[p+1])[0],
(s.length>1?1===a.length:a.length>1||this.options.smartLists&&a!==s)&&(e=o.slice(p+1).join("\n")+e,p=f-1)),r=n||/\n\n(?!\s*$)/.test(c),p!==f-1&&(n="\n"===c.charAt(c.length-1),r||(r=n)),r&&(l.loose=!0),w=void 0,(v=/^\[[ xX]\] /.test(c))&&(w=" "!==c[1],c=c.replace(/^\[[ xX]\] +/,"")),d={type:"list_item_start",task:v,checked:w,loose:r},u.push(d),this.tokens.push(d),this.token(c,!1),this.tokens.push({type:"list_item_end"});if(l.loose)for(f=u.length,p=0;p<f;p++)u[p].loose=!0;this.tokens.push({type:"list_end"})}else if(o=this.rules.html.exec(e))e=e.substring(o[0].length),this.tokens.push({type:this.options.sanitize?"paragraph":"html",pre:!this.options.sanitizer&&("pre"===o[1]||"script"===o[1]||"style"===o[1]),text:o[0]});else if(t&&(o=this.rules.def.exec(e)))e=e.substring(o[0].length),o[3]&&(o[3]=o[3].substring(1,o[3].length-1)),m=o[1].toLowerCase().replace(/\s+/g," "),this.tokens.links[m]||(this.tokens.links[m]={href:o[2],title:o[3]});else if((o=this.rules.table.exec(e))&&(c={type:"table",
header:_(o[1].replace(/^ *| *\| *$/g,"")),align:o[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:o[3]?o[3].replace(/\n$/,"").split("\n"):[]}).header.length===c.align.length){for(e=e.substring(o[0].length),p=0;p<c.align.length;p++)/^ *-+: *$/.test(c.align[p])?c.align[p]="right":/^ *:-+: *$/.test(c.align[p])?c.align[p]="center":/^ *:-+ *$/.test(c.align[p])?c.align[p]="left":c.align[p]=null;for(p=0;p<c.cells.length;p++)c.cells[p]=_(c.cells[p].replace(/^ *\| *| *\| *$/g,""),c.header.length);this.tokens.push(c)}else if(o=this.rules.lheading.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"heading",depth:"="===o[2]?1:2,text:o[1]});else if(t&&(o=this.rules.paragraph.exec(e)))e=e.substring(o[0].length),this.tokens.push({type:"paragraph",text:"\n"===o[1].charAt(o[1].length-1)?o[1].slice(0,-1):o[1]});else if(o=this.rules.text.exec(e))e=e.substring(o[0].length),this.tokens.push({type:"text",text:o[0]});else if(e)throw new Error("Infinite loop on byte: "+e.charCodeAt(0));return this.tokens};var r={
escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:g,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(href(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,strong:/^__([^\s_])__(?!_)|^\*\*([^\s*])\*\*(?!\*)|^__([^\s][\s\S]*?[^\s])__(?!_)|^\*\*([^\s][\s\S]*?[^\s])\*\*(?!\*)/,em:/^_([^\s_])_(?!_)|^\*([^\s*"<\[])\*(?!\*)|^_([^\s][\s\S]*?[^\s_])_(?!_|[^\spunctuation])|^_([^\s_][\s\S]*?[^\s])_(?!_|[^\spunctuation])|^\*([^\s"<\[][\s\S]*?[^\s*])\*(?!\*)|^\*([^\s*"<\[][\s\S]*?[^\s])\*(?!\*)/,code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:g,text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*]|\b_|$)|[^ ](?= {2,}\n))|(?= {2,}\n))/};function o(e,t){if(this.options=t||b.defaults,this.links=e,this.rules=r.normal,
this.renderer=this.options.renderer||new s,this.renderer.options=this.options,!this.links)throw new Error("Tokens array requires a `links` property.");this.options.pedantic?this.rules=r.pedantic:this.options.gfm&&(this.options.breaks?this.rules=r.breaks:this.rules=r.gfm)}function s(e){this.options=e||b.defaults}function a(){}function c(e){this.tokens=[],this.token=null,this.options=e||b.defaults,this.options.renderer=this.options.renderer||new s,this.renderer=this.options.renderer,this.renderer.options=this.options,this.slugger=new l}function l(){this.seen={}}function u(e,t){if(t){if(u.escapeTest.test(e))return e.replace(u.escapeReplace,(function(e){return u.replacements[e]}))}else if(u.escapeTestNoEncode.test(e))return e.replace(u.escapeReplaceNoEncode,(function(e){return u.replacements[e]}));return e}function d(e){return e.replace(/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/gi,(function(e,t){
return"colon"===(t=t.toLowerCase())?":":"#"===t.charAt(0)?"x"===t.charAt(1)?String.fromCharCode(parseInt(t.substring(2),16)):String.fromCharCode(+t.substring(1)):""}))}function h(e,t){return e=e.source||e,t=t||"",{replace:function(t,i){return i=(i=i.source||i).replace(/(^|[^\[])\^/g,"$1"),e=e.replace(t,i),this},getRegex:function(){return new RegExp(e,t)}}}function p(e,t,i){if(e){try{var n=decodeURIComponent(d(i)).replace(/[^\w:]/g,"").toLowerCase()}catch(e){return null}if(0===n.indexOf("javascript:")||0===n.indexOf("vbscript:")||0===n.indexOf("data:"))return null}t&&!f.test(i)&&(i=function(e,t){m[" "+e]||(/^[^:]+:\/*[^/]*$/.test(e)?m[" "+e]=e+"/":m[" "+e]=y(e,"/",!0));return e=m[" "+e],"//"===t.slice(0,2)?e.replace(/:[\s\S]*/,":")+t:"/"===t.charAt(0)?e.replace(/(:\/*[^/]*)[\s\S]*/,"$1")+t:e+t}(t,i));try{i=encodeURI(i).replace(/%25/g,"%")}catch(e){return null}return i}r._punctuation="!\"#$%&'()*+,\\-./:;<=>?@\\[^_{|}~",r.em=h(r.em).replace(/punctuation/g,r._punctuation).getRegex(),
r._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,r._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,r._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,r.autolink=h(r.autolink).replace("scheme",r._scheme).replace("email",r._email).getRegex(),r._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,r.tag=h(r.tag).replace("comment",i._comment).replace("attribute",r._attribute).getRegex(),r._label=/(?:\[[^\[\]]*\]|\\[\[\]]?|`[^`]*`|`(?!`)|[^\[\]\\`])*?/,r._href=/\s*(<(?:\\[<>]?|[^\s<>\\])*>|[^\s\x00-\x1f]*)/,r._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,r.link=h(r.link).replace("label",r._label).replace("href",r._href).replace("title",r._title).getRegex(),r.reflink=h(r.reflink).replace("label",r._label).getRegex(),r.normal=v({},r),r.pedantic=v({},r.normal,{strong:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,
em:/^_(?=\S)([\s\S]*?\S)_(?!_)|^\*(?=\S)([\s\S]*?\S)\*(?!\*)/,link:h(/^!?\[(label)\]\((.*?)\)/).replace("label",r._label).getRegex(),reflink:h(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",r._label).getRegex()}),r.gfm=v({},r.normal,{escape:h(r.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^~+(?=\S)([\s\S]*?\S)~+/,text:/^(`+|[^`])(?:[\s\S]*?(?:(?=[\\<!\[`*~]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?= {2,}\n|[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),r.gfm.url=h(r.gfm.url,"i").replace("email",r.gfm._extended_email).getRegex(),r.breaks=v({},r.gfm,{br:h(r.br).replace("{2,}","*").getRegex(),text:h(r.gfm.text).replace(/\{2,\}/g,"*").getRegex()}),o.rules=r,o.output=function(e,t,i){
return new o(t,i).output(e)},o.prototype.output=function(e){for(var t,i,n,r,s,a,c="";e;)if(s=this.rules.escape.exec(e))e=e.substring(s[0].length),c+=u(s[1]);else if(s=this.rules.tag.exec(e))!this.inLink&&/^<a /i.test(s[0])?this.inLink=!0:this.inLink&&/^<\/a>/i.test(s[0])&&(this.inLink=!1),!this.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(s[0])?this.inRawBlock=!0:this.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(s[0])&&(this.inRawBlock=!1),e=e.substring(s[0].length),c+=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(s[0]):u(s[0]):s[0];else if(s=this.rules.link.exec(e)){var l=w(s[2],"()");if(l>-1){var d=s[0].length-(s[2].length-l)-(s[3]||"").length;s[2]=s[2].substring(0,l),s[0]=s[0].substring(0,d).trim(),s[3]=""}e=e.substring(s[0].length),this.inLink=!0,n=s[2],this.options.pedantic?(t=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(n))?(n=t[1],r=t[3]):r="":r=s[3]?s[3].slice(1,-1):"",n=n.trim().replace(/^<([\s\S]*)>$/,"$1"),c+=this.outputLink(s,{href:o.escapes(n),title:o.escapes(r)}),
this.inLink=!1}else if((s=this.rules.reflink.exec(e))||(s=this.rules.nolink.exec(e))){if(e=e.substring(s[0].length),t=(s[2]||s[1]).replace(/\s+/g," "),!(t=this.links[t.toLowerCase()])||!t.href){c+=s[0].charAt(0),e=s[0].substring(1)+e;continue}this.inLink=!0,c+=this.outputLink(s,t),this.inLink=!1}else if(s=this.rules.strong.exec(e))e=e.substring(s[0].length),c+=this.renderer.strong(this.output(s[4]||s[3]||s[2]||s[1]));else if(s=this.rules.em.exec(e))e=e.substring(s[0].length),c+=this.renderer.em(this.output(s[6]||s[5]||s[4]||s[3]||s[2]||s[1]));else if(s=this.rules.code.exec(e))e=e.substring(s[0].length),c+=this.renderer.codespan(u(s[2].trim(),!0));else if(s=this.rules.br.exec(e))e=e.substring(s[0].length),c+=this.renderer.br();else if(s=this.rules.del.exec(e))e=e.substring(s[0].length),c+=this.renderer.del(this.output(s[1]));else if(s=this.rules.autolink.exec(e))e=e.substring(s[0].length),n="@"===s[2]?"mailto:"+(i=u(this.mangle(s[1]))):i=u(s[1]),
c+=this.renderer.link(n,null,i);else if(this.inLink||!(s=this.rules.url.exec(e))){if(s=this.rules.text.exec(e))e=e.substring(s[0].length),this.inRawBlock?c+=this.renderer.text(s[0]):c+=this.renderer.text(u(this.smartypants(s[0])));else if(e)throw new Error("Infinite loop on byte: "+e.charCodeAt(0))}else{if("@"===s[2])n="mailto:"+(i=u(s[0]));else{do{a=s[0],s[0]=this.rules._backpedal.exec(s[0])[0]}while(a!==s[0]);i=u(s[0]),n="www."===s[1]?"http://"+i:i}e=e.substring(s[0].length),c+=this.renderer.link(n,null,i)}return c},o.escapes=function(e){return e?e.replace(o.rules._escapes,"$1"):e},o.prototype.outputLink=function(e,t){var i=t.href,n=t.title?u(t.title):null;return"!"!==e[0].charAt(0)?this.renderer.link(i,n,this.output(e[1])):this.renderer.image(i,n,u(e[1]))},o.prototype.smartypants=function(e){
return this.options.smartypants?e.replace(/---/g,"—").replace(/--/g,"–").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1‘").replace(/'/g,"’").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1“").replace(/"/g,"”").replace(/\.{3}/g,"…"):e},o.prototype.mangle=function(e){if(!this.options.mangle)return e;for(var t,i="",n=e.length,r=0;r<n;r++)t=e.charCodeAt(r),Math.random()>.5&&(t="x"+t.toString(16)),i+="&#"+t+";";return i},s.prototype.code=function(e,t,i){var n=(t||"").match(/\S*/)[0];if(this.options.highlight){var r=this.options.highlight(e,n);null!=r&&r!==e&&(i=!0,e=r)}return n?'<pre><code class="'+this.options.langPrefix+u(n,!0)+'">'+(i?e:u(e,!0))+"</code></pre>\n":"<pre><code>"+(i?e:u(e,!0))+"</code></pre>"},s.prototype.blockquote=function(e){return"<blockquote>\n"+e+"</blockquote>\n"},s.prototype.html=function(e){return e},s.prototype.heading=function(e,t,i,n){return this.options.headerIds?"<h"+t+' id="'+this.options.headerPrefix+n.slug(i)+'">'+e+"</h"+t+">\n":"<h"+t+">"+e+"</h"+t+">\n"},s.prototype.hr=function(){
return this.options.xhtml?"<hr/>\n":"<hr>\n"},s.prototype.list=function(e,t,i){var n=t?"ol":"ul";return"<"+n+(t&&1!==i?' start="'+i+'"':"")+">\n"+e+"</"+n+">\n"},s.prototype.listitem=function(e){return"<li>"+e+"</li>\n"},s.prototype.checkbox=function(e){return"<input "+(e?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},s.prototype.paragraph=function(e){return"<p>"+e+"</p>\n"},s.prototype.table=function(e,t){return t&&(t="<tbody>"+t+"</tbody>"),"<table>\n<thead>\n"+e+"</thead>\n"+t+"</table>\n"},s.prototype.tablerow=function(e){return"<tr>\n"+e+"</tr>\n"},s.prototype.tablecell=function(e,t){var i=t.header?"th":"td";return(t.align?"<"+i+' align="'+t.align+'">':"<"+i+">")+e+"</"+i+">\n"},s.prototype.strong=function(e){return"<strong>"+e+"</strong>"},s.prototype.em=function(e){return"<em>"+e+"</em>"},s.prototype.codespan=function(e){return"<code>"+e+"</code>"},s.prototype.br=function(){return this.options.xhtml?"<br/>":"<br>"},s.prototype.del=function(e){return"<del>"+e+"</del>"
},s.prototype.link=function(e,t,i){if(null===(e=p(this.options.sanitize,this.options.baseUrl,e)))return i;var n='<a href="'+u(e)+'"';return t&&(n+=' title="'+t+'"'),n+=">"+i+"</a>"},s.prototype.image=function(e,t,i){if(null===(e=p(this.options.sanitize,this.options.baseUrl,e)))return i;var n='<img src="'+e+'" alt="'+i+'"';return t&&(n+=' title="'+t+'"'),n+=this.options.xhtml?"/>":">"},s.prototype.text=function(e){return e},a.prototype.strong=a.prototype.em=a.prototype.codespan=a.prototype.del=a.prototype.text=function(e){return e},a.prototype.link=a.prototype.image=function(e,t,i){return""+i},a.prototype.br=function(){return""},c.parse=function(e,t){return new c(t).parse(e)},c.prototype.parse=function(e){this.inline=new o(e.links,this.options),this.inlineText=new o(e.links,v({},this.options,{renderer:new a})),this.tokens=e.reverse();for(var t="";this.next();)t+=this.tok();return t},c.prototype.next=function(){return this.token=this.tokens.pop()},c.prototype.peek=function(){
return this.tokens[this.tokens.length-1]||0},c.prototype.parseText=function(){for(var e=this.token.text;"text"===this.peek().type;)e+="\n"+this.next().text;return this.inline.output(e)},c.prototype.tok=function(){switch(this.token.type){case"space":return"";case"hr":return this.renderer.hr();case"heading":return this.renderer.heading(this.inline.output(this.token.text),this.token.depth,d(this.inlineText.output(this.token.text)),this.slugger);case"code":return this.renderer.code(this.token.text,this.token.lang,this.token.escaped);case"table":var e,t,i,n,r="",o="";for(i="",e=0;e<this.token.header.length;e++)i+=this.renderer.tablecell(this.inline.output(this.token.header[e]),{header:!0,align:this.token.align[e]});for(r+=this.renderer.tablerow(i),e=0;e<this.token.cells.length;e++){for(t=this.token.cells[e],i="",n=0;n<t.length;n++)i+=this.renderer.tablecell(this.inline.output(t[n]),{header:!1,align:this.token.align[n]});o+=this.renderer.tablerow(i)}return this.renderer.table(r,o);case"blockquote_start":
for(o="";"blockquote_end"!==this.next().type;)o+=this.tok();return this.renderer.blockquote(o);case"list_start":o="";for(var s=this.token.ordered,a=this.token.start;"list_end"!==this.next().type;)o+=this.tok();return this.renderer.list(o,s,a);case"list_item_start":o="";var c=this.token.loose,l=this.token.checked,u=this.token.task;for(this.token.task&&(o+=this.renderer.checkbox(l));"list_item_end"!==this.next().type;)o+=c||"text"!==this.token.type?this.tok():this.parseText();return this.renderer.listitem(o,u,l);case"html":return this.renderer.html(this.token.text);case"paragraph":return this.renderer.paragraph(this.inline.output(this.token.text));case"text":return this.renderer.paragraph(this.parseText());default:var h='Token with "'+this.token.type+'" type was not found.';if(!this.options.silent)throw new Error(h);console.log(h)}},l.prototype.slug=function(e){var t=e.toLowerCase().trim().replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")
;if(this.seen.hasOwnProperty(t)){var i=t;do{this.seen[i]++,t=i+"-"+this.seen[i]}while(this.seen.hasOwnProperty(t))}return this.seen[t]=0,t},u.escapeTest=/[&<>"']/,u.escapeReplace=/[&<>"']/g,u.replacements={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},u.escapeTestNoEncode=/[<>"']|&(?!#?\w+;)/,u.escapeReplaceNoEncode=/[<>"']|&(?!#?\w+;)/g;var m={},f=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(){}function v(e){for(var t,i,n=1;n<arguments.length;n++)for(i in t=arguments[n])Object.prototype.hasOwnProperty.call(t,i)&&(e[i]=t[i]);return e}function _(e,t){var i=e.replace(/\|/g,(function(e,t,i){for(var n=!1,r=t;--r>=0&&"\\"===i[r];)n=!n;return n?"|":" |"})).split(/ \|/),n=0;if(i.length>t)i.splice(t);else for(;i.length<t;)i.push("");for(;n<i.length;n++)i[n]=i[n].trim().replace(/\\\|/g,"|");return i}function y(e,t,i){if(0===e.length)return"";for(var n=0;n<e.length;){var r=e.charAt(e.length-n-1);if(r!==t||i){if(r===t||!i)break;n++}else n++}return e.substr(0,e.length-n)}function w(e,t){
if(-1===e.indexOf(t[1]))return-1;for(var i=0,n=0;n<e.length;n++)if("\\"===e[n])n++;else if(e[n]===t[0])i++;else if(e[n]===t[1]&&--i<0)return n;return-1}function b(e,t,i){if(null==e)throw new Error("marked(): input parameter is undefined or null");if("string"!=typeof e)throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(e)+", string expected");if(i||"function"==typeof t){i||(i=t,t=null);var r,o,s=(t=v({},b.defaults,t||{})).highlight,a=0;try{r=n.lex(e,t)}catch(e){return i(e)}o=r.length;var l=function(e){if(e)return t.highlight=s,i(e);var n;try{n=c.parse(r,t)}catch(t){e=t}return t.highlight=s,e?i(e):i(null,n)};if(!s||s.length<3)return l();if(delete t.highlight,!o)return l();for(;a<r.length;a++)!function(e){"code"!==e.type?--o||l():s(e.text,e.lang,(function(t,i){return t?l(t):null==i||i===e.text?--o||l():(e.text=i,e.escaped=!0,void(--o||l()))}))}(r[a])}else try{return t&&(t=v({},b.defaults,t)),c.parse(n.lex(e,t),t)}catch(e){
if(e.message+="\nPlease report this to https://github.com/markedjs/marked.",(t||b.defaults).silent)return"<p>An error occurred:</p><pre>"+u(e.message+"",!0)+"</pre>";throw e}}g.exec=g,b.options=b.setOptions=function(e){return v(b.defaults,e),b},b.getDefaults=function(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:new s,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tables:!0,xhtml:!1}},b.defaults=b.getDefaults(),b.Parser=c,b.parser=c.parse,b.Renderer=s,b.TextRenderer=a,b.Lexer=n,b.lexer=n.lex,b.InlineLexer=o,b.inlineLexer=o.output,b.Slugger=l,b.parse=b,e=b}.call(this),define("vs/base/common/marked/marked",(function(){return e})),define(t[228],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MovingAverage=t.Counter=t.rot=t.clamp=void 0,t.clamp=function(e,t,i){return Math.min(Math.max(e,t),i)},t.rot=function(e,t){return(t+e%t)%t};t.Counter=class{constructor(){
this._next=0}getNext(){return this._next++}};t.MovingAverage=class{constructor(){this._n=1,this._val=0}update(e){return this._val=this._val+(e-this._val)/this._n,this._n+=1,this}get value(){return this._val}}})),define(t[9],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLittleEndian=t.OS=t.OperatingSystem=t.setImmediate=t.globals=t.translationsConfigFile=t.locale=t.Language=t.language=t.isRootUser=t.userAgent=t.platform=t.isIOS=t.isWeb=t.isNative=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=void 0;let i=!1,n=!1,r=!1,o=!1,s=!1,a=!1,c=void 0,l="en",u=void 0,d=void 0;const h="undefined"!=typeof process&&void 0!==process.versions&&void 0!==process.versions.electron&&"renderer"===process.type;if("object"!=typeof navigator||h){if("object"==typeof process){i="win32"===process.platform,n="darwin"===process.platform,r="linux"===process.platform,c="en",l="en";const e=process.env.VSCODE_NLS_CONFIG;if(e)try{const t=JSON.parse(e),i=t.availableLanguages["*"]
;c=t.locale,l=i||"en",u=t._translationsConfigFile}catch(e){}o=!0}}else d=navigator.userAgent,i=d.indexOf("Windows")>=0,n=d.indexOf("Macintosh")>=0,a=d.indexOf("Macintosh")>=0&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,r=d.indexOf("Linux")>=0,s=!0,l=c=navigator.language;!function(e){e[e.Web=0]="Web",e[e.Mac=1]="Mac",e[e.Linux=2]="Linux",e[e.Windows=3]="Windows"}(t.Platform||(t.Platform={})),t.PlatformToString=function(e){switch(e){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}};let p=0;n?p=1:i?p=3:r&&(p=2),t.isWindows=i,t.isMacintosh=n,t.isLinux=r,t.isNative=o,t.isWeb=s,t.isIOS=a,t.platform=p,t.userAgent=d,t.isRootUser=function(){return o&&!i&&0===process.getuid()},t.language=l,function(e){e.value=function(){return t.language},e.isDefaultVariant=function(){return 2===t.language.length?"en"===t.language:t.language.length>=3&&("e"===t.language[0]&&"n"===t.language[1]&&"-"===t.language[2])},e.isDefault=function(){return"en"===t.language}
}(t.Language||(t.Language={})),t.locale=c,t.translationsConfigFile=u;const m="object"==typeof self?self:"object"==typeof global?global:{};t.globals=m,t.setImmediate=function(){if(t.globals.setImmediate)return t.globals.setImmediate.bind(t.globals);if("function"==typeof t.globals.postMessage&&!t.globals.importScripts){let e=[];t.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeSetImmediateId)for(let i=0,n=e.length;i<n;i++){const n=e[i];if(n.id===t.data.vscodeSetImmediateId)return e.splice(i,1),void n.callback()}});let i=0;return n=>{const r=++i;e.push({id:r,callback:n}),t.globals.postMessage({vscodeSetImmediateId:r},"*")}}if("undefined"!=typeof process&&"function"==typeof process.nextTick)return process.nextTick.bind(process);const e=Promise.resolve();return t=>e.then(t)}(),function(e){e[e.Windows=1]="Windows",e[e.Macintosh=2]="Macintosh",e[e.Linux=3]="Linux"}(t.OperatingSystem||(t.OperatingSystem={})),t.OS=n?2:i?1:3;let f=!0,g=!1;t.isLittleEndian=function(){if(!g){g=!0;const e=new Uint8Array(2)
;e[0]=1,e[1]=2;const t=new Uint16Array(e.buffer);f=513===t[0]}return f}})),define(t[36],i([1,0,9]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.nextTick=t.platform=t.env=t.cwd=void 0;const n="undefined"==typeof process?{cwd:()=>"/",env:Object.create(null),get platform(){return i.isWindows?"win32":i.isMacintosh?"darwin":"linux"},nextTick:e=>i.setImmediate(e)}:process;t.cwd=n.cwd,t.env=n.env,t.platform=n.platform,t.nextTick=n.nextTick})),define(t[7],i([1,0,36]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const n=65,r=97,o=90,s=122,a=46,c=47,l=92;class u extends Error{constructor(e,t,i){let n;"string"==typeof t&&0===t.indexOf("not ")?(n="must not be",t=t.replace(/^not /,"")):n="must be";const r=-1!==e.indexOf(".")?"property":"argument";let o=`The "${e}" ${r} ${n} of type ${t}`
;super(o+=`. Received type ${typeof i}`),this.code="ERR_INVALID_ARG_TYPE"}}function d(e,t){if("string"!=typeof e)throw new u(t,"string",e)}function h(e){return e===c||e===l}function p(e){return e===c}function m(e){return e>=n&&e<=o||e>=r&&e<=s}function f(e,t,i,n){let r="",o=0,s=-1,l=0,u=0;for(let d=0;d<=e.length;++d){if(d<e.length)u=e.charCodeAt(d);else{if(n(u))break;u=c}if(n(u)){if(s===d-1||1===l);else if(2===l){if(r.length<2||2!==o||r.charCodeAt(r.length-1)!==a||r.charCodeAt(r.length-2)!==a){if(r.length>2){const e=r.lastIndexOf(i);-1===e?(r="",o=0):o=(r=r.slice(0,e)).length-1-r.lastIndexOf(i),s=d,l=0;continue}if(0!==r.length){r="",o=0,s=d,l=0;continue}}t&&(r+=r.length>0?`${i}..`:"..",o=2)}else r.length>0?r+=`${i}${e.slice(s+1,d)}`:r=e.slice(s+1,d),o=d-s-1;s=d,l=0}else u===a&&-1!==l?++l:l=-1}return r}function g(e,t){if(null===t||"object"!=typeof t)throw new u("pathObject","Object",t);const i=t.dir||t.root,n=t.base||`${t.name||""}${t.ext||""}`;return i?i===t.root?`${i}${n}`:`${i}${e}${n}`:n}t.win32={
resolve(...e){let t="",n="",r=!1;for(let o=e.length-1;o>=-1;o--){let s;if(o>=0){if(d(s=e[o],"path"),0===s.length)continue}else 0===t.length?s=i.cwd():(void 0===(s=i.env[`=${t}`]||i.cwd())||s.slice(0,2).toLowerCase()!==t.toLowerCase()&&s.charCodeAt(2)===l)&&(s=`${t}\\`);const a=s.length;let c=0,u="",p=!1;const f=s.charCodeAt(0);if(1===a)h(f)&&(c=1,p=!0);else if(h(f))if(p=!0,h(s.charCodeAt(1))){let e=2,t=e;for(;e<a&&!h(s.charCodeAt(e));)e++;if(e<a&&e!==t){const i=s.slice(t,e);for(t=e;e<a&&h(s.charCodeAt(e));)e++;if(e<a&&e!==t){for(t=e;e<a&&!h(s.charCodeAt(e));)e++;e!==a&&e===t||(u=`\\\\${i}\\${s.slice(t,e)}`,c=e)}}}else c=1;else m(f)&&58===s.charCodeAt(1)&&(u=s.slice(0,2),c=2,a>2&&h(s.charCodeAt(2))&&(p=!0,c=3));if(u.length>0)if(t.length>0){if(u.toLowerCase()!==t.toLowerCase())continue}else t=u;if(r){if(t.length>0)break}else if(n=`${s.slice(c)}\\${n}`,r=p,p&&t.length>0)break}return n=f(n,!r,"\\",h),r?`${t}\\${n}`:`${t}${n}`||"."},normalize(e){d(e,"path");const t=e.length;if(0===t)return".";let i,n=0,r=!1
;const o=e.charCodeAt(0);if(1===t)return p(o)?"\\":e;if(h(o))if(r=!0,h(e.charCodeAt(1))){let r=2,o=r;for(;r<t&&!h(e.charCodeAt(r));)r++;if(r<t&&r!==o){const s=e.slice(o,r);for(o=r;r<t&&h(e.charCodeAt(r));)r++;if(r<t&&r!==o){for(o=r;r<t&&!h(e.charCodeAt(r));)r++;if(r===t)return`\\\\${s}\\${e.slice(o)}\\`;r!==o&&(i=`\\\\${s}\\${e.slice(o,r)}`,n=r)}}}else n=1;else m(o)&&58===e.charCodeAt(1)&&(i=e.slice(0,2),n=2,t>2&&h(e.charCodeAt(2))&&(r=!0,n=3));let s=n<t?f(e.slice(n),!r,"\\",h):"";return 0!==s.length||r||(s="."),s.length>0&&h(e.charCodeAt(t-1))&&(s+="\\"),void 0===i?r?`\\${s}`:s:r?`${i}\\${s}`:`${i}${s}`},isAbsolute(e){d(e,"path");const t=e.length;if(0===t)return!1;const i=e.charCodeAt(0);return h(i)||t>2&&m(i)&&58===e.charCodeAt(1)&&h(e.charCodeAt(2))},join(...e){if(0===e.length)return".";let i,n;for(let t=0;t<e.length;++t){const r=e[t];d(r,"path"),r.length>0&&(void 0===i?i=n=r:i+=`\\${r}`)}if(void 0===i)return".";let r=!0,o=0;if("string"==typeof n&&h(n.charCodeAt(0))){++o;const e=n.length
;e>1&&h(n.charCodeAt(1))&&(++o,e>2&&(h(n.charCodeAt(2))?++o:r=!1))}if(r){for(;o<i.length&&h(i.charCodeAt(o));)o++;o>=2&&(i=`\\${i.slice(o)}`)}return t.win32.normalize(i)},relative(e,i){if(d(e,"from"),d(i,"to"),e===i)return"";const n=t.win32.resolve(e),r=t.win32.resolve(i);if(n===r)return"";if((e=n.toLowerCase())===(i=r.toLowerCase()))return"";let o=0;for(;o<e.length&&e.charCodeAt(o)===l;)o++;let s=e.length;for(;s-1>o&&e.charCodeAt(s-1)===l;)s--;const a=s-o;let c=0;for(;c<i.length&&i.charCodeAt(c)===l;)c++;let u=i.length;for(;u-1>c&&i.charCodeAt(u-1)===l;)u--;const h=u-c,p=a<h?a:h;let m=-1,f=0;for(;f<p;f++){const t=e.charCodeAt(o+f);if(t!==i.charCodeAt(c+f))break;t===l&&(m=f)}if(f!==p){if(-1===m)return r}else{if(h>p){if(i.charCodeAt(c+f)===l)return r.slice(c+f+1);if(2===f)return r.slice(c+f)}a>p&&(e.charCodeAt(o+f)===l?m=f:2===f&&(m=3)),-1===m&&(m=0)}let g="";for(f=o+m+1;f<=s;++f)f!==s&&e.charCodeAt(f)!==l||(g+=0===g.length?"..":"\\..");return c+=m,g.length>0?`${g}${r.slice(c,u)}`:(r.charCodeAt(c)===l&&++c,
r.slice(c,u))},toNamespacedPath(e){if("string"!=typeof e)return e;if(0===e.length)return"";const i=t.win32.resolve(e);if(i.length<=2)return e;if(i.charCodeAt(0)===l){if(i.charCodeAt(1)===l){const e=i.charCodeAt(2);if(63!==e&&e!==a)return`\\\\?\\UNC\\${i.slice(2)}`}}else if(m(i.charCodeAt(0))&&58===i.charCodeAt(1)&&i.charCodeAt(2)===l)return`\\\\?\\${i}`;return e},dirname(e){d(e,"path");const t=e.length;if(0===t)return".";let i=-1,n=0;const r=e.charCodeAt(0);if(1===t)return h(r)?e:".";if(h(r)){if(i=n=1,h(e.charCodeAt(1))){let r=2,o=r;for(;r<t&&!h(e.charCodeAt(r));)r++;if(r<t&&r!==o){for(o=r;r<t&&h(e.charCodeAt(r));)r++;if(r<t&&r!==o){for(o=r;r<t&&!h(e.charCodeAt(r));)r++;if(r===t)return e;r!==o&&(i=n=r+1)}}}}else m(r)&&58===e.charCodeAt(1)&&(n=i=t>2&&h(e.charCodeAt(2))?3:2);let o=-1,s=!0;for(let i=t-1;i>=n;--i)if(h(e.charCodeAt(i))){if(!s){o=i;break}}else s=!1;if(-1===o){if(-1===i)return".";o=i}return e.slice(0,o)},basename(e,t){void 0!==t&&d(t,"ext"),d(e,"path");let i,n=0,r=-1,o=!0
;if(e.length>=2&&m(e.charCodeAt(0))&&58===e.charCodeAt(1)&&(n=2),void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let s=t.length-1,a=-1;for(i=e.length-1;i>=n;--i){const c=e.charCodeAt(i);if(h(c)){if(!o){n=i+1;break}}else-1===a&&(o=!1,a=i+1),s>=0&&(c===t.charCodeAt(s)?-1==--s&&(r=i):(s=-1,r=a))}return n===r?r=a:-1===r&&(r=e.length),e.slice(n,r)}for(i=e.length-1;i>=n;--i)if(h(e.charCodeAt(i))){if(!o){n=i+1;break}}else-1===r&&(o=!1,r=i+1);return-1===r?"":e.slice(n,r)},extname(e){d(e,"path");let t=0,i=-1,n=0,r=-1,o=!0,s=0;e.length>=2&&58===e.charCodeAt(1)&&m(e.charCodeAt(0))&&(t=n=2);for(let c=e.length-1;c>=t;--c){const t=e.charCodeAt(c);if(h(t)){if(!o){n=c+1;break}}else-1===r&&(o=!1,r=c+1),t===a?-1===i?i=c:1!==s&&(s=1):-1!==i&&(s=-1)}return-1===i||-1===r||0===s||1===s&&i===r-1&&i===n+1?"":e.slice(i,r)},format:g.bind(null,"\\"),parse(e){d(e,"path");const t={root:"",dir:"",base:"",ext:"",name:""};if(0===e.length)return t;const i=e.length;let n=0,r=e.charCodeAt(0);if(1===i)return h(r)?(t.root=t.dir=e,
t):(t.base=t.name=e,t);if(h(r)){if(n=1,h(e.charCodeAt(1))){let t=2,r=t;for(;t<i&&!h(e.charCodeAt(t));)t++;if(t<i&&t!==r){for(r=t;t<i&&h(e.charCodeAt(t));)t++;if(t<i&&t!==r){for(r=t;t<i&&!h(e.charCodeAt(t));)t++;t===i?n=t:t!==r&&(n=t+1)}}}}else if(m(r)&&58===e.charCodeAt(1)){if(i<=2)return t.root=t.dir=e,t;if(n=2,h(e.charCodeAt(2))){if(3===i)return t.root=t.dir=e,t;n=3}}n>0&&(t.root=e.slice(0,n));let o=-1,s=n,c=-1,l=!0,u=e.length-1,p=0;for(;u>=n;--u)if(h(r=e.charCodeAt(u))){if(!l){s=u+1;break}}else-1===c&&(l=!1,c=u+1),r===a?-1===o?o=u:1!==p&&(p=1):-1!==o&&(p=-1);return-1!==c&&(-1===o||0===p||1===p&&o===c-1&&o===s+1?t.base=t.name=e.slice(s,c):(t.name=e.slice(s,o),t.base=e.slice(s,c),t.ext=e.slice(o,c))),t.dir=s>0&&s!==n?e.slice(0,s-1):t.root,t},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...e){let t="",n=!1;for(let r=e.length-1;r>=-1&&!n;r--){const o=r>=0?e[r]:i.cwd();d(o,"path"),0!==o.length&&(t=`${o}/${t}`,n=o.charCodeAt(0)===c)}return t=f(t,!n,"/",p),n?`/${t}`:t.length>0?t:"."},
normalize(e){if(d(e,"path"),0===e.length)return".";const t=e.charCodeAt(0)===c,i=e.charCodeAt(e.length-1)===c;return 0===(e=f(e,!t,"/",p)).length?t?"/":i?"./":".":(i&&(e+="/"),t?`/${e}`:e)},isAbsolute:e=>(d(e,"path"),e.length>0&&e.charCodeAt(0)===c),join(...e){if(0===e.length)return".";let i;for(let t=0;t<e.length;++t){const n=e[t];d(n,"path"),n.length>0&&(void 0===i?i=n:i+=`/${n}`)}return void 0===i?".":t.posix.normalize(i)},relative(e,i){if(d(e,"from"),d(i,"to"),e===i)return"";if((e=t.posix.resolve(e))===(i=t.posix.resolve(i)))return"";const n=e.length,r=n-1,o=i.length-1,s=r<o?r:o;let a=-1,l=0;for(;l<s;l++){const t=e.charCodeAt(1+l);if(t!==i.charCodeAt(1+l))break;t===c&&(a=l)}if(l===s)if(o>s){if(i.charCodeAt(1+l)===c)return i.slice(1+l+1);if(0===l)return i.slice(1+l)}else r>s&&(e.charCodeAt(1+l)===c?a=l:0===l&&(a=0));let u="";for(l=1+a+1;l<=n;++l)l!==n&&e.charCodeAt(l)!==c||(u+=0===u.length?"..":"/..");return`${u}${i.slice(1+a)}`},toNamespacedPath:e=>e,dirname(e){if(d(e,"path"),0===e.length)return"."
;const t=e.charCodeAt(0)===c;let i=-1,n=!0;for(let t=e.length-1;t>=1;--t)if(e.charCodeAt(t)===c){if(!n){i=t;break}}else n=!1;return-1===i?t?"/":".":t&&1===i?"//":e.slice(0,i)},basename(e,t){void 0!==t&&d(t,"ext"),d(e,"path");let i,n=0,r=-1,o=!0;if(void 0!==t&&t.length>0&&t.length<=e.length){if(t===e)return"";let s=t.length-1,a=-1;for(i=e.length-1;i>=0;--i){const l=e.charCodeAt(i);if(l===c){if(!o){n=i+1;break}}else-1===a&&(o=!1,a=i+1),s>=0&&(l===t.charCodeAt(s)?-1==--s&&(r=i):(s=-1,r=a))}return n===r?r=a:-1===r&&(r=e.length),e.slice(n,r)}for(i=e.length-1;i>=0;--i)if(e.charCodeAt(i)===c){if(!o){n=i+1;break}}else-1===r&&(o=!1,r=i+1);return-1===r?"":e.slice(n,r)},extname(e){d(e,"path");let t=-1,i=0,n=-1,r=!0,o=0;for(let s=e.length-1;s>=0;--s){const l=e.charCodeAt(s);if(l!==c)-1===n&&(r=!1,n=s+1),l===a?-1===t?t=s:1!==o&&(o=1):-1!==t&&(o=-1);else if(!r){i=s+1;break}}return-1===t||-1===n||0===o||1===o&&t===n-1&&t===i+1?"":e.slice(t,n)},format:g.bind(null,"/"),parse(e){d(e,"path");const t={root:"",dir:"",base:"",
ext:"",name:""};if(0===e.length)return t;const i=e.charCodeAt(0)===c;let n;i?(t.root="/",n=1):n=0;let r=-1,o=0,s=-1,l=!0,u=e.length-1,h=0;for(;u>=n;--u){const t=e.charCodeAt(u);if(t!==c)-1===s&&(l=!1,s=u+1),t===a?-1===r?r=u:1!==h&&(h=1):-1!==r&&(h=-1);else if(!l){o=u+1;break}}if(-1!==s){const n=0===o&&i?1:o;-1===r||0===h||1===h&&r===s-1&&r===o+1?t.base=t.name=e.slice(n,s):(t.name=e.slice(n,r),t.base=e.slice(n,s),t.ext=e.slice(r,s))}return o>0?t.dir=e.slice(0,o-1):i&&(t.dir="/"),t},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize="win32"===i.platform?t.win32.normalize:t.posix.normalize,t.isAbsolute="win32"===i.platform?t.win32.isAbsolute:t.posix.isAbsolute,t.join="win32"===i.platform?t.win32.join:t.posix.join,t.resolve="win32"===i.platform?t.win32.resolve:t.posix.resolve,t.relative="win32"===i.platform?t.win32.relative:t.posix.relative,t.dirname="win32"===i.platform?t.win32.dirname:t.posix.dirname,
t.basename="win32"===i.platform?t.win32.basename:t.posix.basename,t.extname="win32"===i.platform?t.win32.extname:t.posix.extname,t.format="win32"===i.platform?t.win32.format:t.posix.format,t.parse="win32"===i.platform?t.win32.parse:t.posix.parse,t.toNamespacedPath="win32"===i.platform?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep="win32"===i.platform?t.win32.sep:t.posix.sep,t.delimiter="win32"===i.platform?t.win32.delimiter:t.posix.delimiter})),define(t[111],i([1,0,7,16]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.compareByPrefix=t.compareAnything=t.comparePaths=t.compareFileExtensionsNumeric=t.compareFileExtensions=t.noIntlCompareFileNames=t.compareFileNamesNumeric=t.compareFileNames=void 0;const r=new n.IdleValue(()=>{const e=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:e,collatorIsNumeric:e.resolvedOptions().numeric}}),o=new n.IdleValue(()=>{return{collator:new Intl.Collator(void 0,{numeric:!0})}}),s=new n.IdleValue(()=>{return{
collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}});function a(e,t,i=!1){const n=e||"",o=t||"",s=r.value.collator.compare(n,o);return r.value.collatorIsNumeric&&0===s&&n!==o?n<o?-1:1:s}t.compareFileNames=a,t.compareFileNamesNumeric=function(e,t){const[i,n]=l(e,!0),[r,a]=l(t,!0),c=o.value.collator,d=s.value.collator;let h;return 0!==(h=u(c,i,r))?h:0!==(h=u(d,n,a))?h:n!==a?c.compare(n,a):0};const c=/^(.*?)(\.([^.]*))?$/;function l(e,t=!1){const i=e?c.exec(e):[];let n=[i&&i[1]||"",i&&i[3]||""];return t&&(!n[0]&&n[1]||n[0]&&"."===n[0].charAt(0))&&(n=[n[0]+"."+n[1],""]),n}function u(e,t,i){let n=e.compare(t,i);return 0!==n?n:t.length!==i.length?t.length<i.length?-1:1:0}function d(e,t,i=!1){return i||(e=e&&e.toLowerCase(),t=t&&t.toLowerCase()),e===t?0:e<t?-1:1}function h(e,t,i){const n=e.toLowerCase(),r=t.toLowerCase(),o=n.startsWith(i),s=r.startsWith(i);if(o!==s)return o?-1:1;if(o&&s){if(n.length<r.length)return-1;if(n.length>r.length)return 1}return 0}
t.noIntlCompareFileNames=function(e,t,i=!1){i||(e=e&&e.toLowerCase(),t=t&&t.toLowerCase());const[n,r]=l(e),[o,s]=l(t);return n!==o?n<o?-1:1:r===s?0:r<s?-1:1},t.compareFileExtensions=function(e,t){const[i,n]=l(e),[o,s]=l(t);let a=r.value.collator.compare(n,s);if(0===a){if(r.value.collatorIsNumeric&&n!==s)return n<s?-1:1;if(a=r.value.collator.compare(i,o),r.value.collatorIsNumeric&&0===a&&i!==o)return i<o?-1:1}return a},t.compareFileExtensionsNumeric=function(e,t){const[i,n]=l(e,!0),[r,a]=l(t,!0),c=o.value.collator;let d;return 0!==(d=u(s.value.collator,n,a))?d:0!==(d=u(c,i,r))?d:n!==a?c.compare(n,a):0},t.comparePaths=function(e,t,n=!1){const r=e.split(i.sep),o=t.split(i.sep),s=r.length-1,c=o.length-1;let l,u;for(let e=0;;e++){if(u=c===e,(l=s===e)&&u)return a(r[e],o[e],n);if(l)return-1;if(u)return 1;const t=d(r[e],o[e],n);if(0!==t)return t}},t.compareAnything=function(e,t,i){const n=e.toLowerCase(),r=t.toLowerCase(),o=h(e,t,i);if(o)return o;const s=n.endsWith(i);if(s!==r.endsWith(i))return s?-1:1;const c=a(n,r)
;return 0!==c?c:n.localeCompare(r)},t.compareByPrefix=h})),define(t[216],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0,function(e){e[e.stdout=0]="stdout",e[e.stderr=1]="stderr"}(t.Source||(t.Source={})),function(e){e[e.Success=0]="Success",e[e.Unknown=1]="Unknown",e[e.AccessDenied=2]="AccessDenied",e[e.ProcessNotFound=3]="ProcessNotFound"}(t.TerminateResponseCode||(t.TerminateResponseCode={})),t.sanitizeProcessEnvironment=function(e,...t){const i=t.reduce((e,t)=>(e[t]=!0,e),{}),n=[/^ELECTRON_.+$/,/^GOOGLE_API_KEY$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/];Object.keys(e).filter(e=>!i[e]).forEach(t=>{for(let i=0;i<n.length;i++)if(-1!==t.search(n[i])){delete e[t];break}})}})),define(t[63],i([1,0,9]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const n=i.globals.performance&&"function"==typeof i.globals.performance.now;class r{constructor(e){
this._highResolution=n&&e,this._startTime=this._now(),this._stopTime=-1}static create(e=!0){return new r(e)}stop(){this._stopTime=this._now()}elapsed(){return-1!==this._stopTime?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?i.globals.performance.now():(new Date).getTime()}}t.StopWatch=r})),define(t[213],i([1,0]),(function(e,t){"use strict";function i(e){return new n(e)}Object.defineProperty(t,"__esModule",{value:!0}),t.transform=t.toReadable=t.toStream=t.consumeStreamWithLimit=t.consumeStream=t.consumeReadableWithLimit=t.consumeReadable=t.newWriteableStream=t.isReadableStream=void 0,t.isReadableStream=function(e){const t=e;return t&&[t.on,t.pause,t.resume,t.destroy].every(e=>"function"==typeof e)},t.newWriteableStream=i;class n{constructor(e){this.reducer=e,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]}}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){
this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(e){this.state.destroyed||(this.state.flowing?this.listeners.data.forEach(t=>t(e)):this.buffer.data.push(e))}error(e){this.state.destroyed||(this.state.flowing?this.listeners.error.forEach(t=>t(e)):this.buffer.error.push(e))}end(e){this.state.destroyed||(e instanceof Error?this.error(e):e&&this.write(e),this.state.flowing?(this.listeners.end.forEach(e=>e()),this.destroy()):this.state.ended=!0)}on(e,t){if(!this.state.destroyed)switch(e){case"data":this.listeners.data.push(t),this.resume();break;case"end":this.listeners.end.push(t),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(t),this.state.flowing&&this.flowErrors()}}flowData(){if(this.buffer.data.length>0){const e=this.reducer(this.buffer.data);this.listeners.data.forEach(t=>t(e)),this.buffer.data.length=0}}flowErrors(){if(this.listeners.error.length>0){
for(const e of this.buffer.error)this.listeners.error.forEach(t=>t(e));this.buffer.error.length=0}}flowEnd(){return!!this.state.ended&&(this.listeners.end.forEach(e=>e()),this.listeners.end.length>0)}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0)}}t.consumeReadable=function(e,t){const i=[];let n;for(;null!==(n=e.read());)i.push(n);return t(i)},t.consumeReadableWithLimit=function(e,t,i){const n=[];let r=void 0;for(;null!==(r=e.read())&&n.length<i;)n.push(r);return null===r&&n.length>0?t(n):{read:()=>{if(n.length>0)return n.shift();if(void 0!==r){const e=r;return r=void 0,e}return e.read()}}},t.consumeStream=function(e,t){return new Promise((i,n)=>{const r=[];e.on("data",e=>r.push(e)),e.on("error",e=>n(e)),e.on("end",()=>i(t(r)))})},t.consumeStreamWithLimit=function(e,t,n){return new Promise((r,o)=>{const s=[];let a=void 0;e.on("data",e=>{
if(!a&&s.length===n){for(a=i(t);s.length;)a.write(s.shift());return a.write(e),r(a)}a?a.write(e):s.push(e)}),e.on("error",e=>{if(!a)return o(e);a.error(e)}),e.on("end",()=>{if(!a)return r(t(s));for(;s.length;)a.write(s.shift());a.end()})})},t.toStream=function(e,t){const n=i(t);return n.end(e),n},t.toReadable=function(e){let t=!1;return{read:()=>t?null:(t=!0,e)}},t.transform=function(e,t,n){const r=i(n);return e.on("data",e=>r.write(t.data(e))),e.on("end",()=>r.end()),e.on("error",e=>r.error(t.error?t.error(e):e)),r}})),define(t[8],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.GraphemeBreakType=t.breakBetweenGraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.repeat=t.safeBtoa=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsEmoji=t.containsRTL=t.decodeUTF8=t.encodeUTF8=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.endsWith=t.startsWith=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.escapeRegExpCharacters=t.escape=t.format=t.pad=t.isFalsyOrWhitespace=void 0,
t.isFalsyOrWhitespace=function(e){return!e||"string"!=typeof e||0===e.trim().length},t.pad=function(e,t,i="0"){const n=""+e,r=[n];for(let e=n.length;e<t;e++)r.push(i);return r.reverse().join("")};const i=/{(\d+)}/g;function n(e){return e.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}function r(e,t){if(!e||!t)return e;const i=t.length;if(0===i||0===e.length)return e;let n=0;for(;e.indexOf(t,n)===n;)n+=i;return e.substring(n)}function o(e,t){if(!e||!t)return e;const i=t.length,n=e.length;if(0===i||0===n)return e;let r=n,o=-1;for(;-1!==(o=e.lastIndexOf(t,r-1))&&o+i===r;){if(0===o)return"";r=o}return e.substring(0,r)}function s(e,t,i=0,n=e.length,r=0,o=t.length){for(;i<n&&r<o;i++,r++){let n=e.charCodeAt(i),o=t.charCodeAt(r);if(n<o)return-1;if(n>o)return 1}const s=n-i,a=o-r;return s<a?-1:s>a?1:0}function a(e,t,i=0,n=e.length,r=0,o=t.length){for(;i<n&&r<o;i++,r++){let a=e.charCodeAt(i),u=t.charCodeAt(r);if(a===u)continue;const d=a-u
;if((32!==d||!l(u))&&(-32!==d||!l(a)))return c(a)&&c(u)?d:s(e.toLowerCase(),t.toLowerCase(),i,n,r,o)}const a=n-i,u=o-r;return a<u?-1:a>u?1:0}function c(e){return e>=97&&e<=122}function l(e){return e>=65&&e<=90}function u(e){return c(e)||l(e)}function d(e,t,i=e.length){for(let n=0;n<i;n++){const i=e.charCodeAt(n),r=t.charCodeAt(n);if(i!==r)if(u(i)&&u(r)){const e=Math.abs(i-r);if(0!==e&&32!==e)return!1}else if(String.fromCharCode(i).toLowerCase()!==String.fromCharCode(r).toLowerCase())return!1}return!0}function h(e){return 55296<=e&&e<=56319}function p(e){return 56320<=e&&e<=57343}function m(e,t){return t-56320+(e-55296<<10)+65536}function f(e,t,i){const n=e.charCodeAt(i);if(h(n)&&i+1<t){const t=e.charCodeAt(i+1);if(p(t))return m(n,t)}return n}function g(e,t){const i=e.charCodeAt(t-1);if(p(i)&&t>1){const n=e.charCodeAt(t-2);if(h(n))return m(n,i)}return i}function v(e,t){const i=T.getInstance(),n=e.length,r=t,o=f(e,n,t),s=i.getGraphemeBreakType(o);t+=o>=65536?2:1;let a=s;for(;t<n;){
const r=f(e,n,t),o=i.getGraphemeBreakType(r);if(k(a,o))break;t+=r>=65536?2:1,a=o}const c=t;for(t=r,a=s;t>0;){const n=g(e,t),r=i.getGraphemeBreakType(n);if(k(r,a))break;t-=n>=65536?2:1,a=r}return[t,c]}t.format=function(e,...t){return 0===t.length?e:e.replace(i,(function(e,i){const n=parseInt(i,10);return isNaN(n)||n<0||n>=t.length?e:t[n]}))},t.escape=function(e){return e.replace(/[<>&]/g,(function(e){switch(e){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return e}}))},t.escapeRegExpCharacters=n,t.trim=function(e,t=" "){return o(r(e,t),t)},t.ltrim=r,t.rtrim=o,t.convertSimple2RegExpPattern=function(e){return e.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")},t.stripWildcards=function(e){return e.replace(/\*/g,"")},t.startsWith=function(e,t){if(e.length<t.length)return!1;if(e===t)return!0;for(let i=0;i<t.length;i++)if(e[i]!==t[i])return!1;return!0},t.endsWith=function(e,t){const i=e.length-t.length;return i>0?e.indexOf(t,i)===i:0===i&&e===t},
t.createRegExp=function(e,t,i={}){if(!e)throw new Error("Cannot create regex from empty string");t||(e=n(e)),i.wholeWord&&(/\B/.test(e.charAt(0))||(e="\\b"+e),/\B/.test(e.charAt(e.length-1))||(e+="\\b"));let r="";return i.global&&(r+="g"),i.matchCase||(r+="i"),i.multiline&&(r+="m"),i.unicode&&(r+="u"),new RegExp(e,r)},t.regExpLeadsToEndlessLoop=function(e){return"^"!==e.source&&"^$"!==e.source&&"$"!==e.source&&"^\\s*$"!==e.source&&!(!e.exec("")||0!==e.lastIndex)},t.regExpContainsBackreference=function(e){return!!e.match(/([^\\]|^)(\\\\)*\\\d+/)},t.regExpFlags=function(e){return(e.global?"g":"")+(e.ignoreCase?"i":"")+(e.multiline?"m":"")+(e.unicode?"u":"")},t.firstNonWhitespaceIndex=function(e){for(let t=0,i=e.length;t<i;t++){const i=e.charCodeAt(t);if(32!==i&&9!==i)return t}return-1},t.getLeadingWhitespace=function(e,t=0,i=e.length){for(let n=t;n<i;n++){const i=e.charCodeAt(n);if(32!==i&&9!==i)return e.substring(t,n)}return e.substring(t,i)},t.lastNonWhitespaceIndex=function(e,t=e.length-1){
for(let i=t;i>=0;i--){const t=e.charCodeAt(i);if(32!==t&&9!==t)return i}return-1},t.compare=function(e,t){return e<t?-1:e>t?1:0},t.compareSubstring=s,t.compareIgnoreCase=function(e,t){return a(e,t,0,e.length,0,t.length)},t.compareSubstringIgnoreCase=a,t.isLowerAsciiLetter=c,t.isUpperAsciiLetter=l,t.equalsIgnoreCase=function(e,t){return e.length===t.length&&d(e,t)},t.startsWithIgnoreCase=function(e,t){const i=t.length;return!(t.length>e.length)&&d(e,t,i)},t.commonPrefixLength=function(e,t){let i,n=Math.min(e.length,t.length);for(i=0;i<n;i++)if(e.charCodeAt(i)!==t.charCodeAt(i))return i;return n},t.commonSuffixLength=function(e,t){let i,n=Math.min(e.length,t.length);const r=e.length-1,o=t.length-1;for(i=0;i<n;i++)if(e.charCodeAt(r-i)!==t.charCodeAt(o-i))return i;return n},t.isHighSurrogate=h,t.isLowSurrogate=p,t.computeCodePoint=m,t.getNextCodePoint=f,t.nextCharLength=function(e,t){const i=T.getInstance(),n=t,r=e.length,o=f(e,r,t);t+=o>=65536?2:1;let s=i.getGraphemeBreakType(o);for(;t<r;){
const n=f(e,r,t),o=i.getGraphemeBreakType(n);if(k(s,o))break;t+=n>=65536?2:1,s=o}return t-n},t.prevCharLength=function(e,t){const i=T.getInstance(),n=t,r=g(e,t);t-=r>=65536?2:1;let o=i.getGraphemeBreakType(r);for(;t>0;){const n=g(e,t),r=i.getGraphemeBreakType(n);if(k(r,o))break;t-=n>=65536?2:1,o=r}return n-t},t.getCharContainingOffset=function(e,t){return t>0&&p(e.charCodeAt(t))?v(e,t-1):v(e,t)},t.encodeUTF8=function(e){const t=e.length;let i=0,n=0;for(;n<t;){const r=f(e,t,n);n+=r>=65536?2:1,i+=r<128?1:r<2048?2:r<65536?3:4}const r=new Uint8Array(i);n=0;let o=0;for(;n<t;){const i=f(e,t,n);n+=i>=65536?2:1,i<128?r[o++]=i:i<2048?(r[o++]=192|(1984&i)>>>6,r[o++]=128|(63&i)>>>0):i<65536?(r[o++]=224|(61440&i)>>>12,r[o++]=128|(4032&i)>>>6,r[o++]=128|(63&i)>>>0):(r[o++]=240|(1835008&i)>>>18,r[o++]=128|(258048&i)>>>12,r[o++]=128|(4032&i)>>>6,r[o++]=128|(63&i)>>>0)}return r},t.decodeUTF8=function(e){const t=e.byteLength,i=[];let n=0;for(;n<t;){const r=e[n];let o
;if((o=r>=240&&n+3<t?(7&e[n++])<<18>>>0|(63&e[n++])<<12>>>0|(63&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:r>=224&&n+2<t?(15&e[n++])<<12>>>0|(63&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:r>=192&&n+1<t?(31&e[n++])<<6>>>0|(63&e[n++])<<0>>>0:e[n++])>=0&&o<=55295||o>=57344&&o<=65535)i.push(String.fromCharCode(o));else if(o>=65536&&o<=1114111){const e=o-65536,t=55296+((1047552&e)>>>10),n=56320+((1023&e)>>>0);i.push(String.fromCharCode(t)),i.push(String.fromCharCode(n))}else i.push(String.fromCharCode(65533))}return i.join("")};const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/
;t.containsRTL=function(e){return _.test(e)};const y=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDE73\uDE78-\uDE82\uDE90-\uDE95])/;t.containsEmoji=function(e){return y.test(e)};const w=/^[\t\n\r\x20-\x7E]*$/;function b(e){return(e=+e)>=11904&&e<=55215||e>=63744&&e<=64255||e>=65281&&e<=65374}t.isBasicASCII=function(e){return w.test(e)},t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/,t.containsUnusualLineTerminators=function(e){return t.UNUSUAL_LINE_TERMINATORS.test(e)},t.containsFullWidthCharacter=function(e){for(let t=0,i=e.length;t<i;t++)if(b(e.charCodeAt(t)))return!0;return!1},t.isFullWidthCharacter=b,t.isEmojiImprecise=function(e){return e>=127462&&e<=127487||e>=9728&&e<=10175||e>=127744&&e<=128591||e>=128640&&e<=128764||e>=128992&&e<=129003||e>=129280&&e<=129535||e>=129648&&e<=129651||e>=129656&&e<=129666||e>=129680&&e<=129685},t.lcut=function(e,t){if(e.length<t)return e;const i=/\b/g
;let n=0;for(;i.test(e)&&!(e.length-i.lastIndex<t);)n=i.lastIndex,i.lastIndex+=1;return e.substring(n).replace(/^\s/,"")};const E=/\x1B\x5B[12]?K/g,x=/\x1b\[\d+m/g,C=/\x1b\[0?m/g;function S(e){return!!(e&&e.length>0&&65279===e.charCodeAt(0))}function k(e,t){return 0===e?5!==t&&7!==t:(2!==e||3!==t)&&(4===e||2===e||3===e||(4===t||2===t||3===t||(8!==e||8!==t&&9!==t&&11!==t&&12!==t)&&((11!==e&&9!==e||9!==t&&10!==t)&&((12!==e&&10!==e||10!==t)&&(5!==t&&13!==t&&(7!==t&&(1!==e&&((13!==e||14!==t)&&(6!==e||6!==t)))))))))}t.removeAnsiEscapeCodes=function(e){return e&&(e=(e=(e=e.replace(E,"")).replace(x,"")).replace(C,"")),e},t.UTF8_BOM_CHARACTER=String.fromCharCode(65279),t.startsWithUTF8BOM=S,t.stripUTF8BOM=function(e){return S(e)?e.substr(1):e},t.safeBtoa=function(e){return btoa(encodeURIComponent(e))},t.repeat=function(e,t){let i="";for(let n=0;n<t;n++)i+=e;return i},t.fuzzyContains=function(e,t){if(!e||!t)return!1;if(e.length<t.length)return!1;const i=t.length,n=e.toLowerCase();let r=0,o=-1;for(;r<i;){
const e=n.indexOf(t[r],o+1);if(e<0)return!1;o=e,r++}return!0},t.containsUppercaseCharacter=function(e,t=!1){return!!e&&(t&&(e=e.replace(/\\./g,"")),e.toLowerCase()!==e)},t.uppercaseFirstLetter=function(e){return e.charAt(0).toUpperCase()+e.slice(1)},t.getNLines=function(e,t=1){if(0===t)return"";let i=-1;do{i=e.indexOf("\n",i+1),t--}while(t>0&&i>=0);return i>=0?e.substr(0,i):e},t.singleLetterHash=function(e){return(e%=52)<26?String.fromCharCode(97+e):String.fromCharCode(65+e-26)},t.getGraphemeBreakType=function(e){return T.getInstance().getGraphemeBreakType(e)},t.breakBetweenGraphemeBreakType=k,function(e){e[e.Other=0]="Other",e[e.Prepend=1]="Prepend",e[e.CR=2]="CR",e[e.LF=3]="LF",e[e.Control=4]="Control",e[e.Extend=5]="Extend",e[e.Regional_Indicator=6]="Regional_Indicator",e[e.SpacingMark=7]="SpacingMark",e[e.L=8]="L",e[e.V=9]="V",e[e.T=10]="T",e[e.LV=11]="LV",e[e.LVT=12]="LVT",e[e.ZWJ=13]="ZWJ",e[e.Extended_Pictographic=14]="Extended_Pictographic"}(t.GraphemeBreakType||(t.GraphemeBreakType={}));let T=(()=>{
class e{constructor(){
this._data=JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")
}static getInstance(){return e._INSTANCE||(e._INSTANCE=new e),e._INSTANCE}getGraphemeBreakType(e){if(e<32)return 10===e?3:13===e?2:4;if(e<127)return 0;const t=this._data,i=t.length/3;let n=1;for(;n<=i;)if(e<t[3*n])n*=2;else{if(!(e>t[3*n+1]))return t[3*n+2];n=2*n+1}return 0}}return e._INSTANCE=null,e})()})),define(t[29],i([1,0,8,213]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const r="undefined"!=typeof Buffer,o="undefined"!=typeof TextEncoder,s="undefined"!=typeof TextDecoder;let a,c;class l{constructor(e){this.buffer=e,this.byteLength=this.buffer.byteLength}static alloc(e){return new l(r?Buffer.allocUnsafe(e):new Uint8Array(e))}static wrap(e){
return r&&!Buffer.isBuffer(e)&&(e=Buffer.from(e.buffer,e.byteOffset,e.byteLength)),new l(e)}static fromString(e){return r?new l(Buffer.from(e)):o?(a||(a=new TextEncoder),new l(a.encode(e))):new l(i.encodeUTF8(e))}static concat(e,t){if(void 0===t){t=0;for(let i=0,n=e.length;i<n;i++)t+=e[i].byteLength}const i=l.alloc(t);let n=0;for(let t=0,r=e.length;t<r;t++){const r=e[t];i.set(r,n),n+=r.byteLength}return i}toString(){return r?this.buffer.toString():s?(c||(c=new TextDecoder),c.decode(this.buffer)):i.decodeUTF8(this.buffer)}slice(e,t){return new l(this.buffer.subarray(e,t))}set(e,t){e instanceof l?this.buffer.set(e.buffer,t):this.buffer.set(e,t)}readUInt32BE(e){return u(this.buffer,e)}writeUInt32BE(e,t){d(this.buffer,e,t)}readUInt32LE(e){return h(this.buffer,e)}writeUInt32LE(e,t){p(this.buffer,e,t)}readUInt8(e){return m(this.buffer,e)}writeUInt8(e,t){f(this.buffer,e,t)}}function u(e,t){return e[t]*2**24+65536*e[t+1]+256*e[t+2]+e[t+3]}function d(e,t,i){e[i+3]=t,t>>>=8,e[i+2]=t,t>>>=8,e[i+1]=t,t>>>=8,e[i]=t}
function h(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0|e[t+2]<<16>>>0|e[t+3]<<24>>>0}function p(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t,t>>>=8,e[i+2]=255&t,t>>>=8,e[i+3]=255&t}function m(e,t){return e[t]}function f(e,t,i){e[i]=t}t.VSBuffer=l,t.readUInt16LE=function(e,t){return e[t+0]<<0>>>0|e[t+1]<<8>>>0},t.writeUInt16LE=function(e,t,i){e[i+0]=255&t,t>>>=8,e[i+1]=255&t},t.readUInt32BE=u,t.writeUInt32BE=d,t.readUInt32LE=h,t.writeUInt32LE=p,t.readUInt8=m,t.writeUInt8=f,t.readableToBuffer=function(e){return n.consumeReadable(e,e=>l.concat(e))},t.bufferToReadable=function(e){return n.toReadable(e)},t.streamToBuffer=function(e){return n.consumeStream(e,e=>l.concat(e))},t.bufferToStream=function(e){return n.toStream(e,e=>l.concat(e))},t.streamToBufferReadableStream=function(e){return n.transform(e,{data:e=>"string"==typeof e?l.fromString(e):l.wrap(e)},e=>l.concat(e))},t.newWriteableBufferStream=function(){return n.newWriteableStream(e=>l.concat(e))}})),define(t[212],i([1,0,8]),(function(e,t,i){"use strict"
;function n(e,t=0){switch(typeof e){case"object":return null===e?r(349,t):Array.isArray(e)?(i=e,s=r(104579,s=t),i.reduce((e,t)=>n(t,e),s)):function(e,t){return t=r(181387,t),Object.keys(e).sort().reduce((t,i)=>(t=o(i,t),n(e[i],t)),t)}(e,t);case"string":return o(e,t);case"boolean":return function(e,t){return r(e?433:863,t)}(e,t);case"number":return r(e,t);case"undefined":return r(0,937);default:return r(0,617)}var i,s}function r(e,t){return(t<<5)-t+e|0}function o(e,t){t=r(149417,t);for(let i=0,n=e.length;i<n;i++)t=r(e.charCodeAt(i),t);return t}Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.Hasher=t.stringHash=t.hash=void 0,t.hash=n,t.stringHash=o;var s;function a(e,t,i=32){const n=i-t;return(e<<t|(~((1<<n)-1)&e)>>>n)>>>0}function c(e,t=0,i=e.byteLength,n=0){for(let r=0;r<i;r++)e[t+r]=n}function l(e,t=32){return function(e,t,i="0"){for(;e.length<t;)e=i+e;return e}((e>>>0).toString(16),t/4)}t.Hasher=class{constructor(){this._value=0}get value(){return this._value}hash(e){
return this._value=n(e,this._value),this._value}},function(e){e[e.BLOCK_SIZE=64]="BLOCK_SIZE",e[e.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"}(s||(s={}));let u=(()=>{class e{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(67),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(e){const t=e.length;if(0===t)return;const n=this._buff;let r,o,s=this._buffLen,a=this._leftoverHighSurrogate;for(0!==a?(r=a,o=-1,a=0):(r=e.charCodeAt(0),o=0);;){let c=r;if(i.isHighSurrogate(r)){if(!(o+1<t)){a=r;break}{const t=e.charCodeAt(o+1);i.isLowSurrogate(t)?(o++,c=i.computeCodePoint(r,t)):c=65533}}else i.isLowSurrogate(r)&&(c=65533);if(s=this._push(n,s,c),!(++o<t))break;r=e.charCodeAt(o)}this._buffLen=s,this._leftoverHighSurrogate=a}_push(e,t,i){return i<128?e[t++]=i:i<2048?(e[t++]=192|(1984&i)>>>6,e[t++]=128|(63&i)>>>0):i<65536?(e[t++]=224|(61440&i)>>>12,
e[t++]=128|(4032&i)>>>6,e[t++]=128|(63&i)>>>0):(e[t++]=240|(1835008&i)>>>18,e[t++]=128|(258048&i)>>>12,e[t++]=128|(4032&i)>>>6,e[t++]=128|(63&i)>>>0),t>=64&&(this._step(),t-=64,this._totalLen+=64,e[0]=e[64],e[1]=e[65],e[2]=e[66]),t}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),l(this._h0)+l(this._h1)+l(this._h2)+l(this._h3)+l(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,c(this._buff,this._buffLen),this._buffLen>56&&(this._step(),c(this._buff));const e=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(e/4294967296),!1),this._buffDV.setUint32(60,e%4294967296,!1),this._step()}_step(){const t=e._bigBlock32,i=this._buffDV;for(let e=0;e<64;e+=4)t.setUint32(e,i.getUint32(e,!1),!1);for(let e=64;e<320;e+=4)t.setUint32(e,a(t.getUint32(e-12,!1)^t.getUint32(e-32,!1)^t.getUint32(e-56,!1)^t.getUint32(e-64,!1),1),!1)
;let n,r,o,s=this._h0,c=this._h1,l=this._h2,u=this._h3,d=this._h4;for(let e=0;e<80;e++)e<20?(n=c&l|~c&u,r=1518500249):e<40?(n=c^l^u,r=1859775393):e<60?(n=c&l|c&u|l&u,r=2400959708):(n=c^l^u,r=3395469782),o=a(s,5)+n+d+r+t.getUint32(4*e,!1)&4294967295,d=u,u=l,l=a(c,30),c=s,s=o;this._h0=this._h0+s&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+l&4294967295,this._h3=this._h3+u&4294967295,this._h4=this._h4+d&4294967295}}return e._bigBlock32=new DataView(new ArrayBuffer(320)),e})();t.StringSHA1=u})),define(t[12],i([1,0]),(function(e,t){"use strict";function i(e){return"string"==typeof e}function n(e){return!("object"!=typeof e||null===e||Array.isArray(e)||e instanceof RegExp||e instanceof Date)}function r(e){return void 0===e}function o(e){return r(e)||null===e}Object.defineProperty(t,"__esModule",{value:!0}),
t.NotImplementedProxy=t.withUndefinedAsNull=t.withNullAsUndefined=t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isUndefined=t.isBoolean=t.isNumber=t.isObject=t.isStringArray=t.isString=t.isArray=void 0,t.isArray=function(e){return Array.isArray(e)},t.isString=i,t.isStringArray=function(e){return Array.isArray(e)&&e.every(e=>i(e))},t.isObject=n,t.isNumber=function(e){return"number"==typeof e&&!isNaN(e)},t.isBoolean=function(e){return!0===e||!1===e},t.isUndefined=r,t.isUndefinedOrNull=o,t.assertType=function(e,t){if(!e)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")},t.assertIsDefined=function(e){if(o(e))throw new Error("Assertion Failed: argument is undefined or null");return e},t.assertAllDefined=function(...e){const t=[];for(let i=0;i<e.length;i++){const n=e[i]
;if(o(n))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(n)}return t};const s=Object.prototype.hasOwnProperty;function a(e){return"function"==typeof e}function c(e,t){if(i(t)){if(typeof e!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(a(t)){try{if(e instanceof t)return}catch(e){}if(!o(e)&&e.constructor===t)return;if(1===t.length&&!0===t.call(void 0,e))return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}function l(e){let t=[],i=Object.getPrototypeOf(e);for(;Object.prototype!==i;)t=t.concat(Object.getOwnPropertyNames(i)),i=Object.getPrototypeOf(i);return t}t.isEmptyObject=function(e){if(!n(e))return!1;for(let t in e)if(s.call(e,t))return!1;return!0},t.isFunction=a,t.areFunctions=function(...e){return e.length>0&&e.every(a)},t.validateConstraints=function(e,t){const i=Math.min(e.length,t.length);for(let n=0;n<i;n++)c(e[n],t[n])},
t.validateConstraint=c,t.getAllPropertyNames=l,t.getAllMethodNames=function(e){const t=[];for(const i of l(e))"function"==typeof e[i]&&t.push(i);return t},t.createProxyObject=function(e,t){const i=e=>(function(){const i=Array.prototype.slice.call(arguments,0);return t(e,i)});let n={};for(const t of e)n[t]=i(t);return n},t.withNullAsUndefined=function(e){return null===e?void 0:e},t.withUndefinedAsNull=function(e){return void 0===e?null:e},t.NotImplementedProxy=function(e){return class{constructor(){return new Proxy({},{get(t,i){if(t[i])return t[i];throw new Error(`Not Implemented: ${e}->${String(i)}`)}})}}}})),define(t[34],i([1,0,9,8,7,12]),(function(e,t,i,n,r,o){"use strict";function s(e){return 47===e||92===e}Object.defineProperty(t,"__esModule",{value:!0}),t.parseLineAndColumnAware=t.indexOfPath=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toSlashes=t.isPathSeparator=void 0,t.isPathSeparator=s,t.toSlashes=function(e){
return e.replace(/[\\/]/g,r.posix.sep)},t.getRoot=function(e,t=r.posix.sep){if(!e)return"";const i=e.length,n=e.charCodeAt(0);if(s(n)){if(s(e.charCodeAt(1))&&!s(e.charCodeAt(2))){let n=3;const r=n;for(;n<i&&!s(e.charCodeAt(n));n++);if(r!==n&&!s(e.charCodeAt(n+1)))for(n+=1;n<i;n++)if(s(e.charCodeAt(n)))return e.slice(0,n+1).replace(/[\\/]/g,t)}return t}if(u(n)&&58===e.charCodeAt(1))return s(e.charCodeAt(2))?e.slice(0,2)+t:e.slice(0,2);let o=e.indexOf("://");if(-1!==o)for(o+=3;o<i;o++)if(s(e.charCodeAt(o)))return e.slice(0,o+1);return""},t.isUNC=function(e){if(!i.isWindows)return!1;if(!e||e.length<5)return!1;let t=e.charCodeAt(0);if(92!==t)return!1;if(92!==(t=e.charCodeAt(1)))return!1;let n=2;const r=n;for(;n<e.length&&92!==(t=e.charCodeAt(n));n++);return r!==n&&(t=e.charCodeAt(n+1),!isNaN(t)&&92!==t)};const a=/[\\/:\*\?"<>\|]/g,c=/[\\/]/g,l=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])$/i;function u(e){return e>=65&&e<=90||e>=97&&e<=122}t.isValidBasename=function(e,t=i.isWindows){const n=t?a:c
;return!(!e||0===e.length||/^\s+$/.test(e))&&(n.lastIndex=0,!n.test(e)&&((!t||!l.test(e))&&("."!==e&&".."!==e&&((!t||"."!==e[e.length-1])&&((!t||e.length===e.trim().length)&&!(e.length>255))))))},t.isEqual=function(e,t,i){const r=e===t;return!i||r?r:!(!e||!t)&&n.equalsIgnoreCase(e,t)},t.isEqualOrParent=function(e,t,i,o=r.sep){if(e===t)return!0;if(!e||!t)return!1;if(t.length>e.length)return!1;if(i){if(!n.startsWithIgnoreCase(e,t))return!1;if(t.length===e.length)return!0;let i=t.length;return t.charAt(t.length-1)===o&&i--,e.charAt(i)===o}return t.charAt(t.length-1)!==o&&(t+=o),0===e.indexOf(t)},t.isWindowsDriveLetter=u,t.sanitizeFilePath=function(e,t){return i.isWindows&&e.endsWith(":")&&(e+=r.sep),r.isAbsolute(e)||(e=r.join(t,e)),e=r.normalize(e),i.isWindows?(e=n.rtrim(e,r.sep)).endsWith(":")&&(e+=r.sep):(e=n.rtrim(e,r.sep))||(e=r.sep),e},t.isRootOrDriveLetter=function(e){const t=r.normalize(e)
;return i.isWindows?!(e.length>3)&&(u(t.charCodeAt(0))&&58===t.charCodeAt(1)&&(2===e.length||92===t.charCodeAt(2))):t===r.posix.sep},t.indexOfPath=function(e,t,i){return t.length>e.length?-1:e===t?0:(i&&(e=e.toLowerCase(),t=t.toLowerCase()),e.indexOf(t))},t.parseLineAndColumnAware=function(e){const t=e.split(":");let i=void 0,n=void 0,r=void 0;if(t.forEach(e=>{const t=Number(e);o.isNumber(t)?void 0===n?n=t:void 0===r&&(r=t):i=i?[i,e].join(":"):e}),!i)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:i,line:void 0!==n?n:void 0,column:void 0!==r?r:void 0!==n?1:void 0}}})),define(t[18],i([1,0,12]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.assign=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0,t.deepClone=function e(t){if(!t||"object"!=typeof t)return t;if(t instanceof RegExp)return t;const i=Array.isArray(t)?[]:{};return Object.keys(t).forEach(n=>{
t[n]&&"object"==typeof t[n]?i[n]=e(t[n]):i[n]=t[n]}),i},t.deepFreeze=function(e){if(!e||"object"!=typeof e)return e;const t=[e];for(;t.length>0;){const e=t.shift();Object.freeze(e);for(const i in e)if(n.call(e,i)){const n=e[i];"object"!=typeof n||Object.isFrozen(n)||t.push(n)}}return e};const n=Object.prototype.hasOwnProperty;function r(e,t){if(e===t)return!0;if(null==e||null==t)return!1;if(typeof e!=typeof t)return!1;if("object"!=typeof e)return!1;if(Array.isArray(e)!==Array.isArray(t))return!1;let i,n;if(Array.isArray(e)){if(e.length!==t.length)return!1;for(i=0;i<e.length;i++)if(!r(e[i],t[i]))return!1}else{const o=[];for(n in e)o.push(n);o.sort();const s=[];for(n in t)s.push(n);if(s.sort(),!r(o,s))return!1;for(i=0;i<o.length;i++)if(!r(e[o[i]],t[o[i]]))return!1}return!0}t.cloneAndChange=function(e,t){return function e(t,r,o){if(i.isUndefinedOrNull(t))return t;const s=r(t);if(void 0!==s)return s;if(i.isArray(t)){const i=[];for(const n of t)i.push(e(n,r,o));return i}if(i.isObject(t)){
if(o.has(t))throw new Error("Cannot clone recursive data-structure");o.add(t);const i={};for(let s in t)n.call(t,s)&&(i[s]=e(t[s],r,o));return o.delete(t),i}return t}(e,t,new Set)},t.mixin=function e(t,n,r=!0){return i.isObject(t)?(i.isObject(n)&&Object.keys(n).forEach(o=>{o in t?r&&(i.isObject(t[o])&&i.isObject(n[o])?e(t[o],n[o],r):t[o]=n[o]):t[o]=n[o]}),t):n},t.assign=function(e,...t){return t.forEach(t=>Object.keys(t).forEach(i=>e[i]=t[i])),e},t.equals=r,t.safeStringify=function(e){const t=[];return JSON.stringify(e,(e,n)=>{if(i.isObject(n)||Array.isArray(n)){if(-1!==t.indexOf(n))return"[Circular]";t.push(n)}return n})},t.getOrDefault=function(e,t,i){const n=t(e);return void 0===n?i:n},t.distinct=function(e,t){const i=Object.create(null);return e&&t?(Object.keys(t).forEach(n=>{const o=e[n],s=t[n];r(o,s)||(i[n]=s)}),i):i}})),define(t[110],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toUint32=t.toUint8=t.Constants=void 0,function(e){
e[e.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",e[e.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",e[e.MAX_UINT_8=255]="MAX_UINT_8",e[e.MAX_UINT_16=65535]="MAX_UINT_16",e[e.MAX_UINT_32=4294967295]="MAX_UINT_32",e[e.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"}(t.Constants||(t.Constants={})),t.toUint8=function(e){return e<0?0:e>255?255:0|e},t.toUint32=function(e){return e<0?0:e>4294967295?4294967295:0|e}})),define(t[2],i([1,0,9,7]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const r=/^\w[\w\d+.-]*$/,o=/^\//,s=/^\/\//;const a="",c="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class u{constructor(e,t,i,n,l,u=!1){"object"==typeof e?(this.scheme=e.scheme||a,this.authority=e.authority||a,this.path=e.path||a,this.query=e.query||a,this.fragment=e.fragment||a):(this.scheme=function(e,t){return e||t?e:"file"}(e,u),this.authority=t||a,this.path=function(e,t){switch(e){
case"https":case"http":case"file":t?t[0]!==c&&(t=c+t):t=c}return t}(this.scheme,i||a),this.query=n||a,this.fragment=l||a,function(e,t){if(!e.scheme&&t)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${e.authority}", path: "${e.path}", query: "${e.query}", fragment: "${e.fragment}"}`);if(e.scheme&&!r.test(e.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(e.path)if(e.authority){if(!o.test(e.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(s.test(e.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}(this,u))}static isUri(e){
return e instanceof u||!!e&&("string"==typeof e.authority&&"string"==typeof e.fragment&&"string"==typeof e.path&&"string"==typeof e.query&&"string"==typeof e.scheme&&"function"==typeof e.fsPath&&"function"==typeof e.with&&"function"==typeof e.toString)}get fsPath(){return g(this,!1)}with(e){if(!e)return this;let{scheme:t,authority:i,path:n,query:r,fragment:o}=e;return void 0===t?t=this.scheme:null===t&&(t=a),void 0===i?i=this.authority:null===i&&(i=a),void 0===n?n=this.path:null===n&&(n=a),void 0===r?r=this.query:null===r&&(r=a),void 0===o?o=this.fragment:null===o&&(o=a),t===this.scheme&&i===this.authority&&n===this.path&&r===this.query&&o===this.fragment?this:new h(t,i,n,r,o)}static parse(e,t=!1){const i=l.exec(e);return i?new h(i[2]||a,y(i[4]||a),y(i[5]||a),y(i[7]||a),y(i[9]||a),t):new h(a,a,a,a,a)}static file(e){let t=a;if(i.isWindows&&(e=e.replace(/\\/g,c)),e[0]===c&&e[1]===c){const i=e.indexOf(c,2);-1===i?(t=e.substring(2),e=c):(t=e.substring(2,i),e=e.substring(i)||c)}return new h("file",t,e,a,a)}
static from(e){return new h(e.scheme,e.authority,e.path,e.query,e.fragment)}static joinPath(e,...t){if(!e.path)throw new Error("[UriError]: cannot call joinPaths on URI without path");let r;return r=i.isWindows&&"file"===e.scheme?u.file(n.win32.join(g(e,!0),...t)).path:n.posix.join(e.path,...t),e.with({path:r})}toString(e=!1){return v(this,e)}toJSON(){return this}static revive(e){if(e){if(e instanceof u)return e;{const t=new h(e);return t._formatted=e.external,t._fsPath=e._sep===d?e.fsPath:null,t}}return e}}t.URI=u;const d=i.isWindows?1:void 0;class h extends u{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=g(this,!1)),this._fsPath}toString(e=!1){return e?v(this,!0):(this._formatted||(this._formatted=v(this,!1)),this._formatted)}toJSON(){const e={$mid:1};return this._fsPath&&(e.fsPath=this._fsPath,e._sep=d),this._formatted&&(e.external=this._formatted),this.path&&(e.path=this.path),this.scheme&&(e.scheme=this.scheme),
this.authority&&(e.authority=this.authority),this.query&&(e.query=this.query),this.fragment&&(e.fragment=this.fragment),e}}const p={58:"%3A",47:"%2F",63:"%3F",35:"%23",91:"%5B",93:"%5D",64:"%40",33:"%21",36:"%24",38:"%26",39:"%27",40:"%28",41:"%29",42:"%2A",43:"%2B",44:"%2C",59:"%3B",61:"%3D",32:"%20"};function m(e,t){let i=void 0,n=-1;for(let r=0;r<e.length;r++){const o=e.charCodeAt(r);if(o>=97&&o<=122||o>=65&&o<=90||o>=48&&o<=57||45===o||46===o||95===o||126===o||t&&47===o)-1!==n&&(i+=encodeURIComponent(e.substring(n,r)),n=-1),void 0!==i&&(i+=e.charAt(r));else{void 0===i&&(i=e.substr(0,r));const t=p[o];void 0!==t?(-1!==n&&(i+=encodeURIComponent(e.substring(n,r)),n=-1),i+=t):-1===n&&(n=r)}}return-1!==n&&(i+=encodeURIComponent(e.substring(n))),void 0!==i?i:e}function f(e){let t=void 0;for(let i=0;i<e.length;i++){const n=e.charCodeAt(i);35===n||63===n?(void 0===t&&(t=e.substr(0,i)),t+=p[n]):void 0!==t&&(t+=e[i])}return void 0!==t?t:e}function g(e,t){let n
;return n=e.authority&&e.path.length>1&&"file"===e.scheme?`//${e.authority}${e.path}`:47===e.path.charCodeAt(0)&&(e.path.charCodeAt(1)>=65&&e.path.charCodeAt(1)<=90||e.path.charCodeAt(1)>=97&&e.path.charCodeAt(1)<=122)&&58===e.path.charCodeAt(2)?t?e.path.substr(1):e.path[1].toLowerCase()+e.path.substr(2):e.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}function v(e,t){const i=t?f:m;let n="",{scheme:r,authority:o,path:s,query:a,fragment:l}=e;if(r&&(n+=r,n+=":"),(o||"file"===r)&&(n+=c,n+=c),o){let e=o.indexOf("@");if(-1!==e){const t=o.substr(0,e);o=o.substr(e+1),-1===(e=t.indexOf(":"))?n+=i(t,!1):(n+=i(t.substr(0,e),!1),n+=":",n+=i(t.substr(e+1),!1)),n+="@"}-1===(e=(o=o.toLowerCase()).indexOf(":"))?n+=i(o,!1):(n+=i(o.substr(0,e),!1),n+=o.substr(e))}if(s){if(s.length>=3&&47===s.charCodeAt(0)&&58===s.charCodeAt(2)){const e=s.charCodeAt(1);e>=65&&e<=90&&(s=`/${String.fromCharCode(e+32)}:${s.substr(3)}`)}else if(s.length>=2&&58===s.charCodeAt(1)){const e=s.charCodeAt(0)
;e>=65&&e<=90&&(s=`${String.fromCharCode(e+32)}:${s.substr(2)}`)}n+=i(s,!0)}return a&&(n+="?",n+=i(a,!1)),l&&(n+="#",n+=t?l:m(l,!1)),n}t.uriToFsPath=g;const _=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function y(e){return e.match(_)?e.replace(_,e=>(function e(t){try{return decodeURIComponent(t)}catch(i){return t.length>3?t.substr(0,3)+e(t.substr(3)):t}})(e)):e}})),define(t[64],i([1,0,2]),(function(e,t,i){"use strict";function n(e,t){return i.URI.parse(e.toUrl(t))}Object.defineProperty(t,"__esModule",{value:!0}),t.getUriFromAmdModule=t.getPathFromAmdModule=void 0,t.getPathFromAmdModule=function(e,t){return n(e,t).fsPath},t.getUriFromAmdModule=n})),define(t[53],i([1,0,2,8]),(function(e,t,i,n){"use strict";function r(e,t){return t instanceof RegExp?{$mid:2,source:t.source,flags:n.regExpFlags(t)}:t}function o(e,t=0){if(!e||t>200)return e;if("object"==typeof e){switch(e.$mid){case 1:return i.URI.revive(e);case 2:return new RegExp(e.source,e.flags)}for(let i in e)Object.hasOwnProperty.call(e,i)&&(e[i]=o(e[i],t+1))}return e}
Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0,t.stringify=function(e){return JSON.stringify(e,r)},t.parse=function(e){let t=JSON.parse(e);return t=o(t)},t.revive=o})),define(t[20],i([1,0,2,9]),(function(e,t,i,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorities=t.Schemas=void 0,function(e){e.inMemory="inmemory",e.vscode="vscode",e.internal="private",e.walkThrough="walkThrough",e.walkThroughSnippet="walkThroughSnippet",e.http="http",e.https="https",e.file="file",e.mailto="mailto",e.untitled="untitled",e.data="data",e.command="command",e.vscodeRemote="vscode-remote",e.vscodeRemoteResource="vscode-remote-resource",e.userData="vscode-userdata",e.vscodeCustomEditor="vscode-custom-editor",e.vscodeSettings="vscode-settings",e.webviewPanel="webview-panel",e.oldVscodeWebviewResource="vscode-resource",e.vscodeWebviewResource="vscode-webview-resource"}(r=t.Schemas||(t.Schemas={}));t.RemoteAuthorities=new class{constructor(){
this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(e){this._preferredWebSchema=e}setDelegate(e){this._delegate=e}set(e,t,i){this._hosts[e]=t,this._ports[e]=i}setConnectionToken(e,t){this._connectionTokens[e]=t}rewrite(e){if(this._delegate)return this._delegate(e);const t=e.authority;let o=this._hosts[t];o&&-1!==o.indexOf(":")&&(o=`[${o}]`);const s=this._ports[t],a=this._connectionTokens[t];let c=`path=${encodeURIComponent(e.path)}`;return"string"==typeof a&&(c+=`&tkn=${encodeURIComponent(a)}`),i.URI.from({scheme:n.isWeb?this._preferredWebSchema:r.vscodeRemoteResource,authority:`${o}:${s}`,path:"/vscode-remote-resource",query:c})}}})),define(t[26],i([1,0,2,8,20,9]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.LRUCache=t.LinkedMap=t.Touch=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=t.keys=t.values=void 0,t.values=function(e){const t=[];return e.forEach(e=>t.push(e)),t},t.keys=function(e){const t=[];return e.forEach((e,i)=>t.push(i)),t},t.getOrSet=function(e,t,i){let n=e.get(t);return void 0===n&&(n=i,e.set(t,n)),n},t.mapToString=function(e){const t=[];return e.forEach((e,i)=>{t.push(`${i} => ${e}`)}),`Map(${e.size}) {${t.join(", ")}}`},t.setToString=function(e){const t=[];return e.forEach(e=>{t.push(e)}),`Set(${e.size}) {${t.join(", ")}}`};class s{constructor(){this._value="",this._pos=0}reset(e){return this._value=e,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(e){return e.charCodeAt(0)-this._value.charCodeAt(this._pos)}value(){return this._value[this._pos]}}t.StringIterator=s;class a{constructor(e=!0,t=!0){this._splitOnBackslash=e,this._caseSensitive=t}reset(e){
return this._value=e.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let e=!0;for(;this._to<this._value.length;this._to++){const t=this._value.charCodeAt(this._to);if(47===t||this._splitOnBackslash&&92===t){if(!e)break;this._from++}else e=!1}return this}cmp(e){return this._caseSensitive?n.compareSubstring(e,this._value,0,e.length,this._from,this._to):n.compareSubstringIgnoreCase(e,this._value,0,e.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}var c;t.PathIterator=a,function(e){e[e.Scheme=1]="Scheme",e[e.Authority=2]="Authority",e[e.Path=3]="Path",e[e.Query=4]="Query",e[e.Fragment=5]="Fragment"}(c||(c={}));class l{constructor(){this._states=[],this._stateIdx=0}reset(e){if(this._value=e,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path){const t=e.scheme===r.Schemas.file&&o.isLinux;this._pathIterator=new a(!1,t),
this._pathIterator.reset(e.path),this._pathIterator.value()&&this._states.push(3)}return this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return 3===this._states[this._stateIdx]&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(e){if(1===this._states[this._stateIdx])return n.compare(e,this._value.scheme);if(2===this._states[this._stateIdx])return n.compareSubstringIgnoreCase(e,this._value.authority);if(3===this._states[this._stateIdx])return this._pathIterator.cmp(e);if(4===this._states[this._stateIdx])return n.compare(e,this._value.query);if(5===this._states[this._stateIdx])return n.compare(e,this._value.fragment);throw new Error}value(){if(1===this._states[this._stateIdx])return this._value.scheme;if(2===this._states[this._stateIdx])return this._value.authority
;if(3===this._states[this._stateIdx])return this._pathIterator.value();if(4===this._states[this._stateIdx])return this._value.query;if(5===this._states[this._stateIdx])return this._value.fragment;throw new Error}}t.UriIterator=l;class u{isEmpty(){return!(this.left||this.mid||this.right||this.value)}}class d{constructor(e){this._iter=e}static forUris(){return new d(new l)}static forPaths(){return new d(new a)}static forStrings(){return new d(new s)}clear(){this._root=void 0}set(e,t){const i=this._iter.reset(e);let n;for(this._root||(this._root=new u,this._root.segment=i.value()),n=this._root;;){const e=i.cmp(n.segment);if(e>0)n.left||(n.left=new u,n.left.segment=i.value()),n=n.left;else if(e<0)n.right||(n.right=new u,n.right.segment=i.value()),n=n.right;else{if(!i.hasNext())break;i.next(),n.mid||(n.mid=new u,n.mid.segment=i.value()),n=n.mid}}const r=n.value;return n.value=t,n.key=e,r}get(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment)
;if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),i=i.mid}}return i?i.value:void 0}delete(e){const t=this._iter.reset(e),i=[];let n=this._root;for(;n;){const e=t.cmp(n.segment);if(e>0)i.push([1,n]),n=n.left;else if(e<0)i.push([-1,n]),n=n.right;else{if(!t.hasNext()){for(n.value=void 0;i.length>0&&n.isEmpty();){let[e,t]=i.pop();switch(e){case 1:t.left=void 0;break;case 0:t.mid=void 0;break;case-1:t.right=void 0}n=t}break}t.next(),i.push([0,n]),n=n.mid}}}findSubstr(e){const t=this._iter.reset(e);let i=this._root,n=void 0;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())break;t.next(),n=i.value||n,i=i.mid}}return i&&i.value||n}findSuperstr(e){const t=this._iter.reset(e);let i=this._root;for(;i;){const e=t.cmp(i.segment);if(e>0)i=i.left;else if(e<0)i=i.right;else{if(!t.hasNext())return i.mid?this._nodeIterator(i.mid):void 0;t.next(),i=i.mid}}}_nodeIterator(e){let t,i,n;return{next:()=>(n||(n=[],i=0,this._forEach(e,e=>n.push(e))),i>=n.length?{
done:!0,value:void 0}:(t?t.value=n[i++]:t={done:!1,value:n[i++]},t))}}forEach(e){this._forEach(this._root,e)}_forEach(e,t){e&&(this._forEach(e.left,t),e.value&&t(e.value,e.key),this._forEach(e.mid,t),this._forEach(e.right,t))}}t.TernarySearchTree=d;t.ResourceMap=class{constructor(e){this[Symbol.toStringTag]="ResourceMap",this.map=e?new Map(e.map):new Map}set(e,t){return this.map.set(this.toKey(e),t),this}get(e){return this.map.get(this.toKey(e))}has(e){return this.map.has(this.toKey(e))}get size(){return this.map.size}clear(){this.map.clear()}delete(e){return this.map.delete(this.toKey(e))}forEach(e,t){void 0!==t&&(e=e.bind(t));for(let[t,n]of this.map)e(n,i.URI.parse(t),this)}values(){return this.map.values()}*keys(){for(let e of this.map.keys())yield i.URI.parse(e)}*entries(){for(let e of this.map.entries())yield[i.URI.parse(e[0]),e[1]]}*[Symbol.iterator](){for(let e of this.map)yield[i.URI.parse(e[0]),e[1]]}toKey(e){return e.toString()}},function(e){e[e.None=0]="None",e[e.AsOld=1]="AsOld",
e[e.AsNew=2]="AsNew"}(t.Touch||(t.Touch={}));class h{constructor(){this[Symbol.toStringTag]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var e;return null===(e=this._head)||void 0===e?void 0:e.value}get last(){var e;return null===(e=this._tail)||void 0===e?void 0:e.value}has(e){return this._map.has(e)}get(e,t=0){const i=this._map.get(e);if(i)return 0!==t&&this.touch(i,t),i.value}set(e,t,i=0){let n=this._map.get(e);if(n)n.value=t,0!==i&&this.touch(n,i);else{switch(n={key:e,value:t,next:void 0,previous:void 0},i){case 0:this.addItemLast(n);break;case 1:this.addItemFirst(n);break;case 2:default:this.addItemLast(n)}this._map.set(e,n),this._size++}return this}delete(e){return!!this.remove(e)}remove(e){const t=this._map.get(e);if(t)return this._map.delete(e),this.removeItem(t),this._size--,t.value}
shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const e=this._head;return this._map.delete(e.key),this.removeItem(e),this._size--,e.value}forEach(e,t){const i=this._state;let n=this._head;for(;n;){if(t?e.bind(t)(n.value,n.key,this):e(n.value,n.key,this),this._state!==i)throw new Error("LinkedMap got modified during iteration.");n=n.next}}keys(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.key,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return n}values(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:i.value,done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return n}entries(){const e=this,t=this._state;let i=this._head;const n={[Symbol.iterator]:()=>n,next(){
if(e._state!==t)throw new Error("LinkedMap got modified during iteration.");if(i){const e={value:[i.key,i.value],done:!1};return i=i.next,e}return{value:void 0,done:!0}}};return n}[Symbol.iterator](){return this.entries()}trimOld(e){if(e>=this.size)return;if(0===e)return void this.clear();let t=this._head,i=this.size;for(;t&&i>e;)this._map.delete(t.key),t=t.next,i--;this._head=t,this._size=i,t&&(t.previous=void 0),this._state++}addItemFirst(e){if(this._head||this._tail){if(!this._head)throw new Error("Invalid list");e.next=this._head,this._head.previous=e}else this._tail=e;this._head=e,this._state++}addItemLast(e){if(this._head||this._tail){if(!this._tail)throw new Error("Invalid list");e.previous=this._tail,this._tail.next=e}else this._head=e;this._tail=e,this._state++}removeItem(e){if(e===this._head&&e===this._tail)this._head=void 0,this._tail=void 0;else if(e===this._head){if(!e.next)throw new Error("Invalid list");e.next.previous=void 0,this._head=e.next}else if(e===this._tail){
if(!e.previous)throw new Error("Invalid list");e.previous.next=void 0,this._tail=e.previous}else{const t=e.next,i=e.previous;if(!t||!i)throw new Error("Invalid list");t.previous=i,i.next=t}e.next=void 0,e.previous=void 0,this._state++}touch(e,t){if(!this._head||!this._tail)throw new Error("Invalid list");if(1===t||2===t)if(1===t){if(e===this._head)return;const t=e.next,i=e.previous;e===this._tail?(i.next=void 0,this._tail=i):(t.previous=i,i.next=t),e.previous=void 0,e.next=this._head,this._head.previous=e,this._head=e,this._state++}else if(2===t){if(e===this._tail)return;const t=e.next,i=e.previous;e===this._head?(t.previous=void 0,this._head=t):(t.previous=i,i.next=t),e.next=void 0,e.previous=this._tail,this._tail.next=e,this._tail=e,this._state++}}toJSON(){const e=[];return this.forEach((t,i)=>{e.push([i,t])}),e}fromJSON(e){this.clear();for(const[t,i]of e)this.set(t,i)}}t.LinkedMap=h;t.LRUCache=class extends h{constructor(e,t=1){super(),this._limit=e,this._ratio=Math.min(Math.max(0,t),1)}get limit(){
return this._limit}set limit(e){this._limit=e,this.checkTrim()}get ratio(){return this._ratio}set ratio(e){this._ratio=Math.min(Math.max(0,e),1),this.checkTrim()}get(e,t=2){return super.get(e,t)}peek(e){return super.get(e,0)}set(e,t){return super.set(e,t,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}})),define(t[109],i([1,0,26,8]),(function(e,t,i,n){"use strict";function r(...e){return function(t,i){for(let n=0,r=e.length;n<r;n++){const r=e[n](t,i);if(r)return r}return null}}function o(e,t,i){if(!i||i.length<t.length)return null;let r;return(r=e?n.startsWithIgnoreCase(i,t):0===i.indexOf(t))?t.length>0?[{start:0,end:t.length}]:[]:null}function s(e,t){const i=t.toLowerCase().indexOf(e.toLowerCase());return-1===i?null:[{start:i,end:i+e.length}]}function a(e,t){return function e(t,i,n,r){if(n===t.length)return[];if(r===i.length)return null;if(t[n]===i[r]){let o=null;return(o=e(t,i,n+1,r+1))?f({start:r,end:r+1},o):null}return e(t,i,n,r+1)
}(e.toLowerCase(),t.toLowerCase(),0,0)}function c(e){return 97<=e&&e<=122}function l(e){return 65<=e&&e<=90}function u(e){return 48<=e&&e<=57}function d(e){return 32===e||9===e||10===e||13===e}Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0,t.or=r,t.matchesStrictPrefix=o.bind(void 0,!1),t.matchesPrefix=o.bind(void 0,!0),t.matchesContiguousSubString=s,t.matchesSubString=a,t.isUpper=l;const h=new Set;function p(e){return d(e)||h.has(e)}function m(e){return c(e)||l(e)||u(e)}function f(e,t){return 0===t.length?t=[e]:e.end===t[0].start?t[0].start=e.start:t.unshift(e),t}function g(e,t){for(let i=t;i<e.length;i++){const t=e.charCodeAt(i);if(l(t)||u(t)||i>0&&!m(e.charCodeAt(i-1)))return i}return e.length}function v(e,t,i,n){
if(i===e.length)return[];if(n===t.length)return null;if(e[i]!==t[n].toLowerCase())return null;{let r=null,o=n+1;for(r=v(e,t,i+1,n+1);!r&&(o=g(t,o))<t.length;)r=v(e,t,i+1,o),o++;return null===r?null:f({start:n,end:n+1},r)}}function _(e,t){if(!t)return null;if(0===(t=t.trim()).length)return null;if(!function(e){let t=0,i=0,n=0,r=0;for(let o=0;o<e.length;o++)l(n=e.charCodeAt(o))&&t++,c(n)&&i++,d(n)&&r++;return 0!==t&&0!==i||0!==r?t<=5:e.length<=30}(e))return null;if(t.length>60)return null;const i=function(e){let t=0,i=0,n=0,r=0,o=0;for(let s=0;s<e.length;s++)l(o=e.charCodeAt(s))&&t++,c(o)&&i++,m(o)&&n++,u(o)&&r++;return{upperPercent:t/e.length,lowerPercent:i/e.length,alphaPercent:n/e.length,numericPercent:r/e.length}}(t);if(!function(e){const{upperPercent:t,lowerPercent:i,alphaPercent:n,numericPercent:r}=e;return i>.2&&t<.8&&n>.6&&r<.2}(i)){if(!function(e){const{upperPercent:t,lowerPercent:i}=e;return 0===i&&t>.6}(i))return null;t=t.toLowerCase()}let n=null,r=0
;for(e=e.toLowerCase();r<t.length&&null===(n=v(e,t,0,r));)r=g(t,r+1);return n}function y(e,t,i,n,r){if(i===e.length)return[];if(n===t.length)return null;if(o=e.charCodeAt(i),s=t.charCodeAt(n),o===s||p(o)&&p(s)){let o=null,s=n+1;if(o=y(e,t,i+1,n+1,r),!r)for(;!o&&(s=w(t,s))<t.length;)o=y(e,t,i+1,s,r),s++;return null===o?null:f({start:n,end:n+1},o)}return null;var o,s}function w(e,t){for(let i=t;i<e.length;i++)if(p(e.charCodeAt(i))||i>0&&p(e.charCodeAt(i-1)))return i;return e.length}"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(e=>h.add(e.charCodeAt(0))),t.matchesCamelCase=_,t.matchesWords=function(e,t,i=!1){if(!t||0===t.length)return null;let n=null,r=0;for(e=e.toLowerCase(),t=t.toLowerCase();r<t.length&&null===(n=y(e,t,0,r,i));)r=w(t,r+1);return n};const b=r(t.matchesPrefix,_,s),E=r(t.matchesPrefix,_,a),x=new i.LRUCache(1e4);function C(e){if(void 0===e)return[];const t=e[1].toString(2),i=[];for(let n=e[2];n<S;n++)if("1"===t[t.length-(n+1)]){const e=i[i.length-1];e&&e.end===n?e.end=n+1:i.push({start:n,
end:n+1})}return i}t.matchesFuzzy=function(e,t,i=!1){if("string"!=typeof e||"string"!=typeof t)return null;let r=x.get(e);r||(r=new RegExp(n.convertSimple2RegExpPattern(e),"i"),x.set(e,r));const o=r.exec(t);return o?[{start:o.index,end:o.index+o[0].length}]:i?E(e,t):b(e,t)},t.matchesFuzzy2=function(e,t){const i=N(e,e.toLowerCase(),0,t,t.toLowerCase(),0,!0);return i?C(i):null},t.anyScore=function(e,t,i,n,r,o){const s=N(e,t,0,n,r,0,!0);if(s)return s;let a=0,c=0,l=o;for(let e=0;e<t.length&&e<S;++e){const i=r.indexOf(t.charAt(e),l);if(i>=0)c+=1,a+=2**i,l=i+1;else if(0!==a)break}return[c,a,o]},t.createMatches=C;const S=128;function k(){const e=[],t=[0];for(let e=1;e<=S;e++)t.push(-e);for(let i=0;i<=S;i++){const n=t.slice(0);n[0]=-i,e.push(n)}return e}const T=k(),I=k(),D=k(),P=!1;function R(e,t,i,n,r){function o(e,t,i=" "){for(;e.length<t;)e=i+e;return e}let s=` |   |${n.split("").map(e=>o(e,3)).join("|")}\n`;for(let n=0;n<=i;n++)s+=0===n?" |":`${t[n-1]}|`,
s+=e[n].slice(0,r+1).map(e=>o(e.toString(),3)).join("|")+"\n";return s}function A(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:return!0;default:return!1}}function O(e,t,i){return t[e]!==i[e]}function L(e,t,i,n,r,o){for(;t<i&&r<o;)e[t]===n[r]&&(t+=1),r+=1;return t===i}var M;function N(e,t,i,n,r,o,s){const a=e.length>S?S:e.length,c=n.length>S?S:n.length;if(i>=a||o>=c||a-i>c-o)return;if(!L(t,i,a,r,o,c))return;let l=1,u=1,d=i,h=o,p=!1;for(l=1,d=i;d<a;l++,d++)for(u=1,h=o;h<c;u++,h++){const o=F(e,t,d,i,n,r,h);d===i&&o>1&&(p=!0),I[l][u]=o;const s=T[l-1][u-1]+(o>1?1:o),a=T[l-1][u]+-1,c=T[l][u-1]+-1;c>=a?c>s?(T[l][u]=c,D[l][u]=4):c===s?(T[l][u]=c,D[l][u]=6):(T[l][u]=s,D[l][u]=2):a>s?(T[l][u]=a,D[l][u]=1):a===s?(T[l][u]=a,D[l][u]=3):(T[l][u]=s,D[l][u]=2)}return P&&function(e,t,i,n){e=e.substr(t),i=i.substr(n),console.log(R(T,e,e.length,i,i.length)),console.log(R(D,e,e.length,i,i.length)),console.log(R(I,e,e.length,i,i.length))
}(e,i,n,o),(p||s)&&(U=0,$=-100,W=o,z=s,function e(t,i,n,r,o){if(U>=10||n<-25)return;let s=0;for(;t>0&&i>0;){const a=I[t][i],c=D[t][i];if(4===c)i-=1,o?n-=5:0!==r&&(n-=1),o=!1,s=0;else{if(!(2&c))return;if(4&c&&e(t,i-1,0!==r?n-1:n,r,o),n+=a,t-=1,o=!0,r+=2**((i-=1)+W),1===a){if(s+=1,0===t&&!z)return}else n+=1+s*(a-1),s=0}}n-=i>=3?9:3*i;U+=1;n>$&&($=n,H=r)}(l-1,u-1,a===c?1:0,0,!1),0!==U)?[$,H,o]:void 0}function F(e,t,i,n,r,o,s){return t[i]!==o[s]?-1:s===i-n?e[i]===r[s]?7:5:!O(s,r,o)||0!==s&&O(s-1,r,o)?!A(o,s)||0!==s&&A(o,s-1)?A(o,s-1)||function(e,t){if(t<0||t>=e.length)return!1;switch(e.charCodeAt(t)){case 32:case 9:return!0;default:return!1}}(o,s-1)?5:1:5:e[i]===r[s]?7:5}t.isPatternInWord=L,function(e){e[e.Top=1]="Top",e[e.Diag=2]="Diag",e[e.Left=4]="Left"}(M||(M={})),function(e){e.Default=Object.freeze([-100,0,0]),e.isDefault=function(e){return!e||-100===e[0]&&0===e[1]&&0===e[2]}}(t.FuzzyScore||(t.FuzzyScore={})),t.fuzzyScore=N;let U=0,H=0,$=0,W=0,z=!1;function B(e,t,i,n,r,o,s,a){let c=N(e,t,i,n,r,o,a)
;if(c&&!s)return c;if(e.length>=3){const t=Math.min(7,e.length-1);for(let s=i+1;s<t;s++){const t=j(e,s);if(t){const e=N(t,t.toLowerCase(),i,n,r,o,a);e&&(e[0]-=3,(!c||e[0]>c[0])&&(c=e))}}}return c}function j(e,t){if(t+1>=e.length)return;const i=e[t],n=e[t+1];return i!==n?e.slice(0,t)+n+i+e.slice(t+2):void 0}t.fuzzyScoreGracefulAggressive=function(e,t,i,n,r,o,s){return B(e,t,i,n,r,o,!0,s)},t.fuzzyScoreGraceful=function(e,t,i,n,r,o,s){return B(e,t,i,n,r,o,!1,s)}})),define(t[193],i([1,0,109,8]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyCodiconAware=t.parseCodicons=t.codiconStartMarker=void 0,t.codiconStartMarker="$(",t.parseCodicons=function(e){const i=e.indexOf(t.codiconStartMarker);return-1===i?{text:e}:function(e,i){const n=[];let r="";function o(e){if(e){r+=e;for(const t of e)n.push(u)}}let s,a,c=-1,l="",u=0,d=i;const h=e.length;o(e.substr(0,i));for(;d<h;){if(s=e[d],a=e[d+1],s===t.codiconStartMarker[0]&&a===t.codiconStartMarker[1])c=d,o(l),
l=t.codiconStartMarker,d++;else if(")"===s&&-1!==c){u+=d-c+1,c=-1,l=""}else-1!==c?/^[a-z0-9\-]$/i.test(s)?l+=s:(o(l),c=-1,l=""):o(s);d++}return o(l),{text:r,codiconOffsets:n}}(e,i)},t.matchesFuzzyCodiconAware=function(e,t,r=!1){const{text:o,codiconOffsets:s}=t;if(!s||0===s.length)return i.matchesFuzzy(e,o,r);const a=n.ltrim(o," "),c=o.length-a.length,l=i.matchesFuzzy(e,a,r);if(l)for(const e of l){const t=s[e.start+c]+c;e.start+=t,e.end+=t}return l}})),define(t[78],i([1,0,193,3]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stripCodicons=t.renderCodicons=t.markdownUnescapeCodicons=t.markdownEscapeEscapedCodicons=t.escapeCodicons=t.Codicon=t.registerIcon=t.iconRegistry=void 0;const r=new class{constructor(){this._icons=new Map,this._onDidRegister=new n.Emitter}add(e){this._icons.has(e.id)?console.error(`Duplicate registration of codicon ${e.id}`):(this._icons.set(e.id,e),this._onDidRegister.fire(e))}get(e){return this._icons.get(e)}get all(){return this._icons.values()}
get onDidRegister(){return this._onDidRegister.event}};t.iconRegistry=r,t.registerIcon=function(e,t,i){return new o(e,t)};class o{constructor(e,t,i){this.id=e,this.definition=t,this.description=i,r.add(this)}get classNames(){return"codicon codicon-"+this.id}get cssSelector(){return".codicon.codicon-"+this.id}}t.Codicon=o,function(e){e.add=new e("add",{character:"\\ea60"}),e.plus=new e("plus",{character:"\\ea60"}),e.gistNew=new e("gist-new",{character:"\\ea60"}),e.repoCreate=new e("repo-create",{character:"\\ea60"}),e.lightbulb=new e("lightbulb",{character:"\\ea61"}),e.lightBulb=new e("light-bulb",{character:"\\ea61"}),e.repo=new e("repo",{character:"\\ea62"}),e.repoDelete=new e("repo-delete",{character:"\\ea62"}),e.gistFork=new e("gist-fork",{character:"\\ea63"}),e.repoForked=new e("repo-forked",{character:"\\ea63"}),e.gitPullRequest=new e("git-pull-request",{character:"\\ea64"}),e.gitPullRequestAbandoned=new e("git-pull-request-abandoned",{character:"\\ea64"}),e.recordKeys=new e("record-keys",{
character:"\\ea65"}),e.keyboard=new e("keyboard",{character:"\\ea65"}),e.tag=new e("tag",{character:"\\ea66"}),e.tagAdd=new e("tag-add",{character:"\\ea66"}),e.tagRemove=new e("tag-remove",{character:"\\ea66"}),e.person=new e("person",{character:"\\ea67"}),e.personAdd=new e("person-add",{character:"\\ea67"}),e.personFollow=new e("person-follow",{character:"\\ea67"}),e.personOutline=new e("person-outline",{character:"\\ea67"}),e.personFilled=new e("person-filled",{character:"\\ea67"}),e.gitBranch=new e("git-branch",{character:"\\ea68"}),e.gitBranchCreate=new e("git-branch-create",{character:"\\ea68"}),e.gitBranchDelete=new e("git-branch-delete",{character:"\\ea68"}),e.sourceControl=new e("source-control",{character:"\\ea68"}),e.mirror=new e("mirror",{character:"\\ea69"}),e.mirrorPublic=new e("mirror-public",{character:"\\ea69"}),e.star=new e("star",{character:"\\ea6a"}),e.starAdd=new e("star-add",{character:"\\ea6a"}),e.starDelete=new e("star-delete",{character:"\\ea6a"}),e.starEmpty=new e("star-empty",{
character:"\\ea6a"}),e.comment=new e("comment",{character:"\\ea6b"}),e.commentAdd=new e("comment-add",{character:"\\ea6b"}),e.alert=new e("alert",{character:"\\ea6c"}),e.warning=new e("warning",{character:"\\ea6c"}),e.search=new e("search",{character:"\\ea6d"}),e.searchSave=new e("search-save",{character:"\\ea6d"}),e.logOut=new e("log-out",{character:"\\ea6e"}),e.signOut=new e("sign-out",{character:"\\ea6e"}),e.logIn=new e("log-in",{character:"\\ea6f"}),e.signIn=new e("sign-in",{character:"\\ea6f"}),e.eye=new e("eye",{character:"\\ea70"}),e.eyeUnwatch=new e("eye-unwatch",{character:"\\ea70"}),e.eyeWatch=new e("eye-watch",{character:"\\ea70"}),e.circleFilled=new e("circle-filled",{character:"\\ea71"}),e.primitiveDot=new e("primitive-dot",{character:"\\ea71"}),e.closeDirty=new e("close-dirty",{character:"\\ea71"}),e.debugBreakpoint=new e("debug-breakpoint",{character:"\\ea71"}),e.debugBreakpointDisabled=new e("debug-breakpoint-disabled",{character:"\\ea71"}),e.debugHint=new e("debug-hint",{character:"\\ea71"}),
e.primitiveSquare=new e("primitive-square",{character:"\\ea72"}),e.edit=new e("edit",{character:"\\ea73"}),e.pencil=new e("pencil",{character:"\\ea73"}),e.info=new e("info",{character:"\\ea74"}),e.issueOpened=new e("issue-opened",{character:"\\ea74"}),e.gistPrivate=new e("gist-private",{character:"\\ea75"}),e.gitForkPrivate=new e("git-fork-private",{character:"\\ea75"}),e.lock=new e("lock",{character:"\\ea75"}),e.mirrorPrivate=new e("mirror-private",{character:"\\ea75"}),e.close=new e("close",{character:"\\ea76"}),e.removeClose=new e("remove-close",{character:"\\ea76"}),e.x=new e("x",{character:"\\ea76"}),e.repoSync=new e("repo-sync",{character:"\\ea77"}),e.sync=new e("sync",{character:"\\ea77"}),e.clone=new e("clone",{character:"\\ea78"}),e.desktopDownload=new e("desktop-download",{character:"\\ea78"}),e.beaker=new e("beaker",{character:"\\ea79"}),e.microscope=new e("microscope",{character:"\\ea79"}),e.vm=new e("vm",{character:"\\ea7a"}),e.deviceDesktop=new e("device-desktop",{character:"\\ea7a"}),
e.file=new e("file",{character:"\\ea7b"}),e.fileText=new e("file-text",{character:"\\ea7b"}),e.more=new e("more",{character:"\\ea7c"}),e.ellipsis=new e("ellipsis",{character:"\\ea7c"}),e.kebabHorizontal=new e("kebab-horizontal",{character:"\\ea7c"}),e.mailReply=new e("mail-reply",{character:"\\ea7d"}),e.reply=new e("reply",{character:"\\ea7d"}),e.organization=new e("organization",{character:"\\ea7e"}),e.organizationFilled=new e("organization-filled",{character:"\\ea7e"}),e.organizationOutline=new e("organization-outline",{character:"\\ea7e"}),e.newFile=new e("new-file",{character:"\\ea7f"}),e.fileAdd=new e("file-add",{character:"\\ea7f"}),e.newFolder=new e("new-folder",{character:"\\ea80"}),e.fileDirectoryCreate=new e("file-directory-create",{character:"\\ea80"}),e.trash=new e("trash",{character:"\\ea81"}),e.trashcan=new e("trashcan",{character:"\\ea81"}),e.history=new e("history",{character:"\\ea82"}),e.clock=new e("clock",{character:"\\ea82"}),e.folder=new e("folder",{character:"\\ea83"}),
e.fileDirectory=new e("file-directory",{character:"\\ea83"}),e.symbolFolder=new e("symbol-folder",{character:"\\ea83"}),e.logoGithub=new e("logo-github",{character:"\\ea84"}),e.markGithub=new e("mark-github",{character:"\\ea84"}),e.github=new e("github",{character:"\\ea84"}),e.terminal=new e("terminal",{character:"\\ea85"}),e.console=new e("console",{character:"\\ea85"}),e.repl=new e("repl",{character:"\\ea85"}),e.zap=new e("zap",{character:"\\ea86"}),e.symbolEvent=new e("symbol-event",{character:"\\ea86"}),e.error=new e("error",{character:"\\ea87"}),e.stop=new e("stop",{character:"\\ea87"}),e.variable=new e("variable",{character:"\\ea88"}),e.symbolVariable=new e("symbol-variable",{character:"\\ea88"}),e.array=new e("array",{character:"\\ea8a"}),e.symbolArray=new e("symbol-array",{character:"\\ea8a"}),e.symbolModule=new e("symbol-module",{character:"\\ea8b"}),e.symbolPackage=new e("symbol-package",{character:"\\ea8b"}),e.symbolNamespace=new e("symbol-namespace",{character:"\\ea8b"}),
e.symbolObject=new e("symbol-object",{character:"\\ea8b"}),e.symbolMethod=new e("symbol-method",{character:"\\ea8c"}),e.symbolFunction=new e("symbol-function",{character:"\\ea8c"}),e.symbolConstructor=new e("symbol-constructor",{character:"\\ea8c"}),e.symbolBoolean=new e("symbol-boolean",{character:"\\ea8f"}),e.symbolNull=new e("symbol-null",{character:"\\ea8f"}),e.symbolNumeric=new e("symbol-numeric",{character:"\\ea90"}),e.symbolNumber=new e("symbol-number",{character:"\\ea90"}),e.symbolStructure=new e("symbol-structure",{character:"\\ea91"}),e.symbolStruct=new e("symbol-struct",{character:"\\ea91"}),e.symbolParameter=new e("symbol-parameter",{character:"\\ea92"}),e.symbolTypeParameter=new e("symbol-type-parameter",{character:"\\ea92"}),e.symbolKey=new e("symbol-key",{character:"\\ea93"}),e.symbolText=new e("symbol-text",{character:"\\ea93"}),e.symbolReference=new e("symbol-reference",{character:"\\ea94"}),e.goToFile=new e("go-to-file",{character:"\\ea94"}),e.symbolEnum=new e("symbol-enum",{
character:"\\ea95"}),e.symbolValue=new e("symbol-value",{character:"\\ea95"}),e.symbolRuler=new e("symbol-ruler",{character:"\\ea96"}),e.symbolUnit=new e("symbol-unit",{character:"\\ea96"}),e.activateBreakpoints=new e("activate-breakpoints",{character:"\\ea97"}),e.archive=new e("archive",{character:"\\ea98"}),e.arrowBoth=new e("arrow-both",{character:"\\ea99"}),e.arrowDown=new e("arrow-down",{character:"\\ea9a"}),e.arrowLeft=new e("arrow-left",{character:"\\ea9b"}),e.arrowRight=new e("arrow-right",{character:"\\ea9c"}),e.arrowSmallDown=new e("arrow-small-down",{character:"\\ea9d"}),e.arrowSmallLeft=new e("arrow-small-left",{character:"\\ea9e"}),e.arrowSmallRight=new e("arrow-small-right",{character:"\\ea9f"}),e.arrowSmallUp=new e("arrow-small-up",{character:"\\eaa0"}),e.arrowUp=new e("arrow-up",{character:"\\eaa1"}),e.bell=new e("bell",{character:"\\eaa2"}),e.bold=new e("bold",{character:"\\eaa3"}),e.book=new e("book",{character:"\\eaa4"}),e.bookmark=new e("bookmark",{character:"\\eaa5"}),
e.debugBreakpointConditionalUnverified=new e("debug-breakpoint-conditional-unverified",{character:"\\eaa6"}),e.debugBreakpointConditional=new e("debug-breakpoint-conditional",{character:"\\eaa7"}),e.debugBreakpointConditionalDisabled=new e("debug-breakpoint-conditional-disabled",{character:"\\eaa7"}),e.debugBreakpointDataUnverified=new e("debug-breakpoint-data-unverified",{character:"\\eaa8"}),e.debugBreakpointData=new e("debug-breakpoint-data",{character:"\\eaa9"}),e.debugBreakpointDataDisabled=new e("debug-breakpoint-data-disabled",{character:"\\eaa9"}),e.debugBreakpointLogUnverified=new e("debug-breakpoint-log-unverified",{character:"\\eaaa"}),e.debugBreakpointLog=new e("debug-breakpoint-log",{character:"\\eaab"}),e.debugBreakpointLogDisabled=new e("debug-breakpoint-log-disabled",{character:"\\eaab"}),e.briefcase=new e("briefcase",{character:"\\eaac"}),e.broadcast=new e("broadcast",{character:"\\eaad"}),e.browser=new e("browser",{character:"\\eaae"}),e.bug=new e("bug",{character:"\\eaaf"}),
e.calendar=new e("calendar",{character:"\\eab0"}),e.caseSensitive=new e("case-sensitive",{character:"\\eab1"}),e.check=new e("check",{character:"\\eab2"}),e.checklist=new e("checklist",{character:"\\eab3"}),e.chevronDown=new e("chevron-down",{character:"\\eab4"}),e.chevronLeft=new e("chevron-left",{character:"\\eab5"}),e.chevronRight=new e("chevron-right",{character:"\\eab6"}),e.chevronUp=new e("chevron-up",{character:"\\eab7"}),e.chromeClose=new e("chrome-close",{character:"\\eab8"}),e.chromeMaximize=new e("chrome-maximize",{character:"\\eab9"}),e.chromeMinimize=new e("chrome-minimize",{character:"\\eaba"}),e.chromeRestore=new e("chrome-restore",{character:"\\eabb"}),e.circleOutline=new e("circle-outline",{character:"\\eabc"}),e.debugBreakpointUnverified=new e("debug-breakpoint-unverified",{character:"\\eabc"}),e.circleSlash=new e("circle-slash",{character:"\\eabd"}),e.circuitBoard=new e("circuit-board",{character:"\\eabe"}),e.clearAll=new e("clear-all",{character:"\\eabf"}),e.clippy=new e("clippy",{
character:"\\eac0"}),e.closeAll=new e("close-all",{character:"\\eac1"}),e.cloudDownload=new e("cloud-download",{character:"\\eac2"}),e.cloudUpload=new e("cloud-upload",{character:"\\eac3"}),e.code=new e("code",{character:"\\eac4"}),e.collapseAll=new e("collapse-all",{character:"\\eac5"}),e.colorMode=new e("color-mode",{character:"\\eac6"}),e.commentDiscussion=new e("comment-discussion",{character:"\\eac7"}),e.compareChanges=new e("compare-changes",{character:"\\eafd"}),e.creditCard=new e("credit-card",{character:"\\eac9"}),e.dash=new e("dash",{character:"\\eacc"}),e.dashboard=new e("dashboard",{character:"\\eacd"}),e.database=new e("database",{character:"\\eace"}),e.debugContinue=new e("debug-continue",{character:"\\eacf"}),e.debugDisconnect=new e("debug-disconnect",{character:"\\ead0"}),e.debugPause=new e("debug-pause",{character:"\\ead1"}),e.debugRestart=new e("debug-restart",{character:"\\ead2"}),e.debugStart=new e("debug-start",{character:"\\ead3"}),e.debugStepInto=new e("debug-step-into",{
character:"\\ead4"}),e.debugStepOut=new e("debug-step-out",{character:"\\ead5"}),e.debugStepOver=new e("debug-step-over",{character:"\\ead6"}),e.debugStop=new e("debug-stop",{character:"\\ead7"}),e.debug=new e("debug",{character:"\\ead8"}),e.deviceCameraVideo=new e("device-camera-video",{character:"\\ead9"}),e.deviceCamera=new e("device-camera",{character:"\\eada"}),e.deviceMobile=new e("device-mobile",{character:"\\eadb"}),e.diffAdded=new e("diff-added",{character:"\\eadc"}),e.diffIgnored=new e("diff-ignored",{character:"\\eadd"}),e.diffModified=new e("diff-modified",{character:"\\eade"}),e.diffRemoved=new e("diff-removed",{character:"\\eadf"}),e.diffRenamed=new e("diff-renamed",{character:"\\eae0"}),e.diff=new e("diff",{character:"\\eae1"}),e.discard=new e("discard",{character:"\\eae2"}),e.editorLayout=new e("editor-layout",{character:"\\eae3"}),e.emptyWindow=new e("empty-window",{character:"\\eae4"}),e.exclude=new e("exclude",{character:"\\eae5"}),e.extensions=new e("extensions",{character:"\\eae6"}),
e.eyeClosed=new e("eye-closed",{character:"\\eae7"}),e.fileBinary=new e("file-binary",{character:"\\eae8"}),e.fileCode=new e("file-code",{character:"\\eae9"}),e.fileMedia=new e("file-media",{character:"\\eaea"}),e.filePdf=new e("file-pdf",{character:"\\eaeb"}),e.fileSubmodule=new e("file-submodule",{character:"\\eaec"}),e.fileSymlinkDirectory=new e("file-symlink-directory",{character:"\\eaed"}),e.fileSymlinkFile=new e("file-symlink-file",{character:"\\eaee"}),e.fileZip=new e("file-zip",{character:"\\eaef"}),e.files=new e("files",{character:"\\eaf0"}),e.filter=new e("filter",{character:"\\eaf1"}),e.flame=new e("flame",{character:"\\eaf2"}),e.foldDown=new e("fold-down",{character:"\\eaf3"}),e.foldUp=new e("fold-up",{character:"\\eaf4"}),e.fold=new e("fold",{character:"\\eaf5"}),e.folderActive=new e("folder-active",{character:"\\eaf6"}),e.folderOpened=new e("folder-opened",{character:"\\eaf7"}),e.gear=new e("gear",{character:"\\eaf8"}),e.gift=new e("gift",{character:"\\eaf9"}),e.gistSecret=new e("gist-secret",{
character:"\\eafa"}),e.gist=new e("gist",{character:"\\eafb"}),e.gitCommit=new e("git-commit",{character:"\\eafc"}),e.gitCompare=new e("git-compare",{character:"\\eafd"}),e.gitMerge=new e("git-merge",{character:"\\eafe"}),e.githubAction=new e("github-action",{character:"\\eaff"}),e.githubAlt=new e("github-alt",{character:"\\eb00"}),e.globe=new e("globe",{character:"\\eb01"}),e.grabber=new e("grabber",{character:"\\eb02"}),e.graph=new e("graph",{character:"\\eb03"}),e.gripper=new e("gripper",{character:"\\eb04"}),e.heart=new e("heart",{character:"\\eb05"}),e.home=new e("home",{character:"\\eb06"}),e.horizontalRule=new e("horizontal-rule",{character:"\\eb07"}),e.hubot=new e("hubot",{character:"\\eb08"}),e.inbox=new e("inbox",{character:"\\eb09"}),e.issueClosed=new e("issue-closed",{character:"\\eb0a"}),e.issueReopened=new e("issue-reopened",{character:"\\eb0b"}),e.issues=new e("issues",{character:"\\eb0c"}),e.italic=new e("italic",{character:"\\eb0d"}),e.jersey=new e("jersey",{character:"\\eb0e"}),
e.json=new e("json",{character:"\\eb0f"}),e.kebabVertical=new e("kebab-vertical",{character:"\\eb10"}),e.key=new e("key",{character:"\\eb11"}),e.law=new e("law",{character:"\\eb12"}),e.lightbulbAutofix=new e("lightbulb-autofix",{character:"\\eb13"}),e.linkExternal=new e("link-external",{character:"\\eb14"}),e.link=new e("link",{character:"\\eb15"}),e.listOrdered=new e("list-ordered",{character:"\\eb16"}),e.listUnordered=new e("list-unordered",{character:"\\eb17"}),e.liveShare=new e("live-share",{character:"\\eb18"}),e.loading=new e("loading",{character:"\\eb19"}),e.location=new e("location",{character:"\\eb1a"}),e.mailRead=new e("mail-read",{character:"\\eb1b"}),e.mail=new e("mail",{character:"\\eb1c"}),e.markdown=new e("markdown",{character:"\\eb1d"}),e.megaphone=new e("megaphone",{character:"\\eb1e"}),e.mention=new e("mention",{character:"\\eb1f"}),e.milestone=new e("milestone",{character:"\\eb20"}),e.mortarBoard=new e("mortar-board",{character:"\\eb21"}),e.move=new e("move",{character:"\\eb22"}),
e.multipleWindows=new e("multiple-windows",{character:"\\eb23"}),e.mute=new e("mute",{character:"\\eb24"}),e.noNewline=new e("no-newline",{character:"\\eb25"}),e.note=new e("note",{character:"\\eb26"}),e.octoface=new e("octoface",{character:"\\eb27"}),e.openPreview=new e("open-preview",{character:"\\eb28"}),e.package_=new e("package",{character:"\\eb29"}),e.paintcan=new e("paintcan",{character:"\\eb2a"}),e.pin=new e("pin",{character:"\\eb2b"}),e.play=new e("play",{character:"\\eb2c"}),e.run=new e("run",{character:"\\eb2c"}),e.plug=new e("plug",{character:"\\eb2d"}),e.preserveCase=new e("preserve-case",{character:"\\eb2e"}),e.preview=new e("preview",{character:"\\eb2f"}),e.project=new e("project",{character:"\\eb30"}),e.pulse=new e("pulse",{character:"\\eb31"}),e.question=new e("question",{character:"\\eb32"}),e.quote=new e("quote",{character:"\\eb33"}),e.radioTower=new e("radio-tower",{character:"\\eb34"}),e.reactions=new e("reactions",{character:"\\eb35"}),e.references=new e("references",{character:"\\eb36"
}),e.refresh=new e("refresh",{character:"\\eb37"}),e.regex=new e("regex",{character:"\\eb38"}),e.remoteExplorer=new e("remote-explorer",{character:"\\eb39"}),e.remote=new e("remote",{character:"\\eb3a"}),e.remove=new e("remove",{character:"\\eb3b"}),e.replaceAll=new e("replace-all",{character:"\\eb3c"}),e.replace=new e("replace",{character:"\\eb3d"}),e.repoClone=new e("repo-clone",{character:"\\eb3e"}),e.repoForcePush=new e("repo-force-push",{character:"\\eb3f"}),e.repoPull=new e("repo-pull",{character:"\\eb40"}),e.repoPush=new e("repo-push",{character:"\\eb41"}),e.report=new e("report",{character:"\\eb42"}),e.requestChanges=new e("request-changes",{character:"\\eb43"}),e.rocket=new e("rocket",{character:"\\eb44"}),e.rootFolderOpened=new e("root-folder-opened",{character:"\\eb45"}),e.rootFolder=new e("root-folder",{character:"\\eb46"}),e.rss=new e("rss",{character:"\\eb47"}),e.ruby=new e("ruby",{character:"\\eb48"}),e.saveAll=new e("save-all",{character:"\\eb49"}),e.saveAs=new e("save-as",{character:"\\eb4a"
}),e.save=new e("save",{character:"\\eb4b"}),e.screenFull=new e("screen-full",{character:"\\eb4c"}),e.screenNormal=new e("screen-normal",{character:"\\eb4d"}),e.searchStop=new e("search-stop",{character:"\\eb4e"}),e.server=new e("server",{character:"\\eb50"}),e.settingsGear=new e("settings-gear",{character:"\\eb51"}),e.settings=new e("settings",{character:"\\eb52"}),e.shield=new e("shield",{character:"\\eb53"}),e.smiley=new e("smiley",{character:"\\eb54"}),e.sortPrecedence=new e("sort-precedence",{character:"\\eb55"}),e.splitHorizontal=new e("split-horizontal",{character:"\\eb56"}),e.splitVertical=new e("split-vertical",{character:"\\eb57"}),e.squirrel=new e("squirrel",{character:"\\eb58"}),e.starFull=new e("star-full",{character:"\\eb59"}),e.starHalf=new e("star-half",{character:"\\eb5a"}),e.symbolClass=new e("symbol-class",{character:"\\eb5b"}),e.symbolColor=new e("symbol-color",{character:"\\eb5c"}),e.symbolConstant=new e("symbol-constant",{character:"\\eb5d"}),
e.symbolEnumMember=new e("symbol-enum-member",{character:"\\eb5e"}),e.symbolField=new e("symbol-field",{character:"\\eb5f"}),e.symbolFile=new e("symbol-file",{character:"\\eb60"}),e.symbolInterface=new e("symbol-interface",{character:"\\eb61"}),e.symbolKeyword=new e("symbol-keyword",{character:"\\eb62"}),e.symbolMisc=new e("symbol-misc",{character:"\\eb63"}),e.symbolOperator=new e("symbol-operator",{character:"\\eb64"}),e.symbolProperty=new e("symbol-property",{character:"\\eb65"}),e.wrench=new e("wrench",{character:"\\eb65"}),e.wrenchSubaction=new e("wrench-subaction",{character:"\\eb65"}),e.symbolSnippet=new e("symbol-snippet",{character:"\\eb66"}),e.tasklist=new e("tasklist",{character:"\\eb67"}),e.telescope=new e("telescope",{character:"\\eb68"}),e.textSize=new e("text-size",{character:"\\eb69"}),e.threeBars=new e("three-bars",{character:"\\eb6a"}),e.thumbsdown=new e("thumbsdown",{character:"\\eb6b"}),e.thumbsup=new e("thumbsup",{character:"\\eb6c"}),e.tools=new e("tools",{character:"\\eb6d"}),
e.triangleDown=new e("triangle-down",{character:"\\eb6e"}),e.triangleLeft=new e("triangle-left",{character:"\\eb6f"}),e.triangleRight=new e("triangle-right",{character:"\\eb70"}),e.triangleUp=new e("triangle-up",{character:"\\eb71"}),e.twitter=new e("twitter",{character:"\\eb72"}),e.unfold=new e("unfold",{character:"\\eb73"}),e.unlock=new e("unlock",{character:"\\eb74"}),e.unmute=new e("unmute",{character:"\\eb75"}),e.unverified=new e("unverified",{character:"\\eb76"}),e.verified=new e("verified",{character:"\\eb77"}),e.versions=new e("versions",{character:"\\eb78"}),e.vmActive=new e("vm-active",{character:"\\eb79"}),e.vmOutline=new e("vm-outline",{character:"\\eb7a"}),e.vmRunning=new e("vm-running",{character:"\\eb7b"}),e.watch=new e("watch",{character:"\\eb7c"}),e.whitespace=new e("whitespace",{character:"\\eb7d"}),e.wholeWord=new e("whole-word",{character:"\\eb7e"}),e.window=new e("window",{character:"\\eb7f"}),e.wordWrap=new e("word-wrap",{character:"\\eb80"}),e.zoomIn=new e("zoom-in",{character:"\\eb81"
}),e.zoomOut=new e("zoom-out",{character:"\\eb82"}),e.listFilter=new e("list-filter",{character:"\\eb83"}),e.listFlat=new e("list-flat",{character:"\\eb84"}),e.listSelection=new e("list-selection",{character:"\\eb85"}),e.selection=new e("selection",{character:"\\eb85"}),e.listTree=new e("list-tree",{character:"\\eb86"}),e.debugBreakpointFunctionUnverified=new e("debug-breakpoint-function-unverified",{character:"\\eb87"}),e.debugBreakpointFunction=new e("debug-breakpoint-function",{character:"\\eb88"}),e.debugBreakpointFunctionDisabled=new e("debug-breakpoint-function-disabled",{character:"\\eb88"}),e.debugStackframeActive=new e("debug-stackframe-active",{character:"\\eb89"}),e.debugStackframeDot=new e("debug-stackframe-dot",{character:"\\eb8a"}),e.debugStackframe=new e("debug-stackframe",{character:"\\eb8b"}),e.debugStackframeFocused=new e("debug-stackframe-focused",{character:"\\eb8b"}),e.debugBreakpointUnsupported=new e("debug-breakpoint-unsupported",{character:"\\eb8c"}),
e.symbolString=new e("symbol-string",{character:"\\eb8d"}),e.debugReverseContinue=new e("debug-reverse-continue",{character:"\\eb8e"}),e.debugStepBack=new e("debug-step-back",{character:"\\eb8f"}),e.debugRestartFrame=new e("debug-restart-frame",{character:"\\eb90"}),e.callIncoming=new e("call-incoming",{character:"\\eb92"}),e.callOutgoing=new e("call-outgoing",{character:"\\eb93"}),e.menu=new e("menu",{character:"\\eb94"}),e.expandAll=new e("expand-all",{character:"\\eb95"}),e.feedback=new e("feedback",{character:"\\eb96"}),e.groupByRefType=new e("group-by-ref-type",{character:"\\eb97"}),e.ungroupByRefType=new e("ungroup-by-ref-type",{character:"\\eb98"}),e.account=new e("account",{character:"\\eb99"}),e.bellDot=new e("bell-dot",{character:"\\eb9a"}),e.debugConsole=new e("debug-console",{character:"\\eb9b"}),e.library=new e("library",{character:"\\eb9c"}),e.output=new e("output",{character:"\\eb9d"}),e.runAll=new e("run-all",{character:"\\eb9e"}),e.syncIgnored=new e("sync-ignored",{character:"\\eb9f"}),
e.pinned=new e("pinned",{character:"\\eba0"}),e.githubInverted=new e("github-inverted",{character:"\\eba1"}),e.debugAlt=new e("debug-alt",{character:"\\eb91"}),e.serverProcess=new e("server-process",{character:"\\eba2"}),e.serverEnvironment=new e("server-environment",{character:"\\eba3"}),e.pass=new e("pass",{character:"\\eba4"}),e.stopCircle=new e("stop-circle",{character:"\\eba5"}),e.playCircle=new e("play-circle",{character:"\\eba6"}),e.record=new e("record",{character:"\\eba7"})}(o=t.Codicon||(t.Codicon={}));const s=/(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;t.escapeCodicons=function(e){return e.replace(s,(e,t)=>t?e:`\\${e}`)};const a=/\\\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)/gi;t.markdownEscapeEscapedCodicons=function(e){return e.replace(a,e=>`\\${e}`)};const c=/(\\)?\$\\\(([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?)\\\)/gi;t.markdownUnescapeCodicons=function(e){return e.replace(c,(e,t,i)=>t?e:`$(${i})`)};const l=/(\\)?\$\((([a-z0-9\-]+?)(?:~([a-z0-9\-]*?))?)\)/gi;t.renderCodicons=function(e){
return e.replace(l,(e,t,i,n,r)=>t?`$(${i})`:`<span class="codicon codicon-${n}${r?` codicon-animation-${r}`:""}"></span>`)};const u=/(\s)?(\\)?\$\([a-z0-9\-]+?(?:~[a-z0-9\-]*?)?\)(\s)?/gi;t.stripCodicons=function(e){return-1===e.indexOf(i.codiconStartMarker)?e:e.replace(u,(e,t,i,n)=>i?e:t||n||"")}})),define(t[107],i([1,0,111,109,7,9,8]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.pieceToQuery=t.prepareQuery=t.compareItemsByFuzzyScore=t.scoreItemFuzzy=t.scoreFuzzy2=t.scoreFuzzy=void 0;const a=0,c=[a,[]];function l(e,t,i,n){if(!e||!t)return c;const r=e.length,o=t.length;if(r<o)return c;const s=e.toLowerCase();if(!n){if(-1===s.indexOf(i))return c}return function(e,t,i,n,r,o){const s=[],c=[];for(let l=0;l<i;l++){const i=l*o,d=i-o,h=l>0,p=e[l],m=t[l];for(let e=0;e<o;e++){const t=e>0,o=i+e,l=o-1,f=d+e-1,g=t?s[l]:0,v=h&&t?s[f]:0,_=h&&t?c[f]:0;let y;(y=!v&&h?0:u(p,m,n,r,e,_))&&v+y>=g?(c[o]=_+1,s[o]=v+y):(c[o]=a,s[o]=g)}}const l=[];let d=i-1,h=o-1;for(;d>=0&&h>=0;){
c[d*o+h]===a?h--:(l.push(h),d--,h--)}return[s[i*o-1],l.reverse()]}(t,i,o,e,s,r)}function u(e,t,i,r,o,s){let a=0;if(!function(e,t){if(e===t)return!0;if("/"===e||"\\"===e)return"/"===t||"\\"===t;return!1}(t,r[o]))return a;if(a+=1,s>0&&(a+=5*s),e===i[o]&&(a+=1),0===o)a+=8;else{const e=function(e){switch(e){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}(i.charCodeAt(o-1));e?a+=e:n.isUpper(i.charCodeAt(o))&&(a+=1)}return a}t.scoreFuzzy=l;const d=[void 0,[]];function h(e,t,i,r){const o=n.fuzzyScore(t.original,t.originalLowercase,i,e,e.toLowerCase(),r,!0);return o?[o[0],n.createMatches(o)]:d}t.scoreFuzzy2=function(e,t,i=0,n=0){const r=t;return r.values&&r.values.length>1?function(e,t,i,n){let r=0;const o=[];for(const s of t){const[t,a]=h(e,s,i,n);if("number"!=typeof t)return d;r+=t,o.push(...a)}return[r,E(o)]}(e,r.values,i,n):h(e,t,i,n)};const p=Object.freeze({score:0}),m=1<<18,f=1<<17,g=65536,v=32768,_=16384;function y(e,t,i,n,r){
if(!e||!t.normalized)return p;const c=n.getItemLabel(e);if(!c)return p;const l=n.getItemDescription(e);let u;const d=r[u=l?`${c}${l}${t.normalized}${i}`:`${c}${t.normalized}${i}`];if(d)return d;const h=function(e,t,i,n,r){const c=!i||!n.containsPathSeparator;if(i&&(o.isLinux?n.pathNormalized===i:s.equalsIgnoreCase(n.pathNormalized,i)))return{score:m,labelMatch:[{start:0,end:e.length}],descriptionMatch:t?[{start:0,end:t.length}]:void 0};if(n.values&&n.values.length>1)return function(e,t,i,n,r,o){let s=0;const c=[],l=[];for(const u of n){const{score:n,labelMatch:d,descriptionMatch:h}=w(e,t,i,u,r,o);if(n===a)return p;s+=n,d&&c.push(...d),h&&l.push(...h)}return{score:s,labelMatch:E(c),descriptionMatch:E(l)}}(e,t,i,n.values,c,r);return w(e,t,i,n,c,r)}(c,l,n.getItemPath(e),t,i);return r[u]=h,h}function w(e,t,i,o,s,a){if(s){const t=n.matchesPrefix(o.normalized,e);if(t){const i=n.matchesStrictPrefix(o.normalized,e);return{score:i?f:g,labelMatch:i||t}}const i=n.matchesCamelCase(o.normalized,e);if(i)return{score:v,
labelMatch:i};const[r,s]=l(e,o.normalized,o.normalizedLowercase,a);if(r)return{score:r+_,labelMatch:b(s)}}if(t){let n=t;i&&(n=`${t}${r.sep}`);const s=n.length,c=`${n}${e}`,[u,d]=l(c,o.normalized,o.normalizedLowercase,a);if(u){const e=b(d),t=[],i=[];return e.forEach(e=>{e.start<s&&e.end>s?(t.push({start:0,end:e.end-s}),i.push({start:e.start,end:s})):e.start>=s?t.push({start:e.start-s,end:e.end-s}):i.push(e)}),{score:u,labelMatch:t,descriptionMatch:i}}}return p}function b(e){const t=[];if(!e)return t;let i;for(const n of e)i&&i.end===n?i.end+=1:(i={start:n,end:n+1},t.push(i));return t}function E(e){const t=e.sort((e,t)=>e.start-t.start),i=[];let n=void 0;for(const e of t)n&&x(n,e)?(n.start=Math.min(n.start,e.start),n.end=Math.max(n.end,e.end)):(n=e,i.push(e));return i}function x(e,t){return!(e.end<t.start)&&!(t.end<e.start)}function C(e,t,i){let n=-1,r=-1;if(t.descriptionMatch&&t.descriptionMatch.length?n=t.descriptionMatch[0].start:t.labelMatch&&t.labelMatch.length&&(n=t.labelMatch[0].start),
t.labelMatch&&t.labelMatch.length){if(r=t.labelMatch[t.labelMatch.length-1].end,t.descriptionMatch&&t.descriptionMatch.length){const t=i.getItemDescription(e);t&&(r+=t.length)}}else t.descriptionMatch&&t.descriptionMatch.length&&(r=t.descriptionMatch[t.descriptionMatch.length-1].end);return r-n}t.scoreItemFuzzy=y,t.compareItemsByFuzzyScore=function(e,t,n,r,o,s){const a=y(e,n,r,o,s),c=y(t,n,r,o,s),l=a.score,u=c.score;if((l===m||u===m)&&l!==u)return l===m?-1:1;if(l===f||u===f){if(l!==u)return l===f?-1:1;const i=o.getItemLabel(e)||"",n=o.getItemLabel(t)||"";if(i.length!==n.length)return i.length-n.length}if(l===g||u===g){if(l!==u)return l===g?-1:1;const i=o.getItemLabel(e)||"",n=o.getItemLabel(t)||"";if(i.length!==n.length)return i.length-n.length}if(l===v||u===v){if(l!==u)return l===v?-1:1;const i=o.getItemLabel(e)||"",n=o.getItemLabel(t)||"",r=function(e,t){if(!((e||t)&&(e&&e.length||t&&t.length)))return 0;if(!t||!t.length)return-1;if(!e||!e.length)return 1
;const i=e[0].start,n=e[e.length-1].end-i,r=t[0].start,o=t[t.length-1].end-r;return n===o?0:o<n?1:-1}(a.labelMatch,c.labelMatch);if(0!==r)return r;if(i.length!==n.length)return i.length-n.length}if(l>_||u>_){if(u<_)return-1;if(l<_)return 1}if(l!==u)return l>u?-1:1;const d=Array.isArray(a.labelMatch)&&a.labelMatch.length>0,h=Array.isArray(c.labelMatch)&&c.labelMatch.length>0;if(d&&!h)return-1;if(h&&!d)return 1;const p=C(e,a,o),w=C(t,c,o);return p&&w&&p!==w?w>p?-1:1:function(e,t,n,r){const o=r.getItemLabel(e)||"",s=r.getItemLabel(t)||"",a=r.getItemDescription(e),c=r.getItemDescription(t),l=o.length+(a?a.length:0),u=s.length+(c?c.length:0);if(l!==u)return l-u;const d=r.getItemPath(e),h=r.getItemPath(t);if(d&&h&&d.length!==h.length)return d.length-h.length;if(o!==s)return i.compareAnything(o,s,n.normalized);if(a&&c&&a!==c)return i.compareAnything(a,c,n.normalized);if(d&&h&&d!==h)return i.compareAnything(d,h,n.normalized);return 0}(e,t,n,o)};const S=" ";function k(e){"string"!=typeof e&&(e="")
;const t=e.toLowerCase(),{pathNormalized:i,normalized:n,normalizedLowercase:o}=T(e),s=i.indexOf(r.sep)>=0;let a=void 0;const c=e.split(S);if(c.length>1)for(const e of c){const{pathNormalized:t,normalized:i,normalizedLowercase:n}=T(e);i&&(a||(a=[]),a.push({original:e,originalLowercase:e.toLowerCase(),pathNormalized:t,normalized:i,normalizedLowercase:n}))}return{original:e,originalLowercase:t,pathNormalized:i,normalized:n,normalizedLowercase:o,values:a,containsPathSeparator:s}}function T(e){let t;t=o.isWindows?e.replace(/\//g,r.sep):e.replace(/\\/g,r.sep);const i=s.stripWildcards(t).replace(/\s/g,"");return{pathNormalized:t,normalized:i,normalizedLowercase:i.toLowerCase()}}t.prepareQuery=k,t.pieceToQuery=function(e){return Array.isArray(e)?k(e.map(e=>e.original).join(S)):k(e.original)}})),define(t[27],i([1,0,13,8,34,7,26,16]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0,t.getEmptyExpression=function(){return Object.create(null)};const c="**",l="/",u="[/\\\\]",d="[^/\\\\]",h=/\//g;function p(e){switch(e){case 0:return"";case 1:return`${d}*?`;default:return`(?:${u}|${d}+${u}|${u}${d}+)*?`}}function m(e,t){if(!e)return[];const i=[];let n=!1,r=!1,o="";for(const s of e){switch(s){case t:if(!n&&!r){i.push(o),o="";continue}break;case"{":n=!0;break;case"}":n=!1;break;case"[":r=!0;break;case"]":r=!1}o+=s}return o&&i.push(o),i}t.splitGlobAware=m;const f=/^\*\*\/\*\.[\w\.-]+$/,g=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,_=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,y=/^\*\*((\/[\w\.-]+)+)\/?$/,w=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,b=new s.LRUCache(1e4),E=function(){return!1},x=function(){return null};function C(e,t){if(!e)return x;let r
;const o=`${r=(r="string"!=typeof e?e.pattern:e).trim()}_${!!t.trimForExclusions}`;let s,a=b.get(o);if(a)return S(a,e);if(f.test(r)){const e=r.substr(4);a=function(t,i){return"string"==typeof t&&t.endsWith(e)?r:null}}else a=(s=g.exec(k(r,t)))?function(e,t){const i=`/${e}`,n=`\\${e}`,r=function(r,o){return"string"!=typeof r?null:o?o===e?t:null:r===e||r.endsWith(i)||r.endsWith(n)?t:null},o=[e];return r.basenames=o,r.patterns=[t],r.allBasenames=o,r}(s[1],r):(t.trimForExclusions?_:v).test(r)?function(e,t){const n=R(e.slice(1,-1).split(",").map(e=>C(e,t)).filter(e=>e!==x),e),r=n.length;if(!r)return x;if(1===r)return n[0];const o=function(t,i){for(let r=0,o=n.length;r<o;r++)if(n[r](t,i))return e;return null},s=i.first(n,e=>!!e.allBasenames);s&&(o.allBasenames=s.allBasenames);const a=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);a.length&&(o.allPaths=a);return o}(r,t):(s=y.exec(k(r,t)))?T(s[1].substr(1),r,!0):(s=w.exec(k(r,t)))?T(s[1],r,!1):function(e){try{const t=new RegExp(`^${function e(t){if(!t)return""
;let i="";const r=m(t,l);if(r.every(e=>e===c))i=".*";else{let t=!1;r.forEach((o,s)=>{if(o===c)return void(t||(i+=p(2),t=!0));let a=!1,h="",f=!1,g="";for(const t of o)if("}"!==t&&a)h+=t;else if(!f||"]"===t&&g)switch(t){case"{":a=!0;continue;case"[":f=!0;continue;case"}":const r=`(?:${m(h,",").map(t=>e(t)).join("|")})`;i+=r,a=!1,h="";break;case"]":i+="["+g+"]",f=!1,g="";break;case"?":i+=d;continue;case"*":i+=p(1);continue;default:i+=n.escapeRegExpCharacters(t)}else{let e;g+=e="-"===t?t:"^"!==t&&"!"!==t||g?t===l?"":n.escapeRegExpCharacters(t):"^"}s<r.length-1&&(r[s+1]!==c||s+2<r.length)&&(i+=u),t=!1})}return i}(e)}$`);return function(i){return t.lastIndex=0,"string"==typeof i&&t.test(i)?e:null}}catch(e){return x}}(r);return b.set(o,a),S(a,e)}function S(e,t){return"string"==typeof t?e:function(i,n){return r.isEqualOrParent(i,t.base)?e(o.relative(t.base,i),n):null}}function k(e,t){return t.trimForExclusions&&e.endsWith("/**")?e.substr(0,e.length-2):e}function T(e,t,i){
const n=o.sep!==o.posix.sep?e.replace(h,o.sep):e,r=o.sep+n,s=i?function(e,i){return"string"!=typeof e||e!==n&&!e.endsWith(r)?null:t}:function(e,i){return"string"==typeof e&&e===n?t:null};return s.allPaths=[(i?"*/":"./")+e],s}function I(e,t={}){if(!e)return E;if("string"==typeof e||P(e)){const i=C(e,t);if(i===x)return E;const n=function(e,t){return!!i(e,t)};return i.allBasenames&&(n.allBasenames=i.allBasenames),i.allPaths&&(n.allPaths=i.allPaths),n}return function(e,t){const n=R(Object.getOwnPropertyNames(e).map(i=>(function(e,t,i){if(!1===t)return x;const n=C(e,i);if(n===x)return x;if("boolean"==typeof t)return n;if(t){const i=t.when;if("string"==typeof i){const t=(t,r,o,s)=>{if(!s||!n(t,r))return null;const c=s(i.replace("$(basename)",o));return a.isThenable(c)?c.then(t=>t?e:null):c?e:null};return t.requiresSiblings=!0,t}}return n})(i,e[i],t)).filter(e=>e!==x)),r=n.length;if(!r)return x;if(!n.some(e=>!!e.requiresSiblings)){if(1===r)return n[0];const e=function(e,t){for(let i=0,r=n.length;i<r;i++){
const r=n[i](e,t);if(r)return r}return null},t=i.first(n,e=>!!e.allBasenames);t&&(e.allBasenames=t.allBasenames);const o=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);return o.length&&(e.allPaths=o),e}const s=function(e,t,i){let r=void 0;for(let s=0,a=n.length;s<a;s++){const a=n[s];a.requiresSiblings&&i&&(t||(t=o.basename(e)),r||(r=t.substr(0,t.length-o.extname(e).length)));const c=a(e,t,r,i);if(c)return c}return null},c=i.first(n,e=>!!e.allBasenames);c&&(s.allBasenames=c.allBasenames);const l=n.reduce((e,t)=>t.allPaths?e.concat(t.allPaths):e,[]);l.length&&(s.allPaths=l);return s}(e,t)}function D(e){const t={};for(const i of e)t[i]=!0;return t}function P(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}function R(e,t){const i=e.filter(e=>!!e.basenames);if(i.length<2)return e;const n=i.reduce((e,t)=>{const i=t.basenames;return i?e.concat(i):e},[]);let r;if(t){r=[];for(let e=0,i=n.length;e<i;e++)r.push(t)}else r=i.reduce((e,t)=>{const i=t.patterns;return i?e.concat(i):e},[])
;const o=function(e,t){if("string"!=typeof e)return null;if(!t){let i;for(i=e.length;i>0;i--){const t=e.charCodeAt(i-1);if(47===t||92===t)break}t=e.substr(i)}const i=n.indexOf(t);return-1!==i?r[i]:null};o.basenames=n,o.patterns=r,o.allBasenames=n;const s=e.filter(e=>!e.basenames);return s.push(o),s}t.match=function(e,t,i){return!(!e||"string"!=typeof t)&&I(e)(t,void 0,i)},t.parse=I,t.hasSiblingPromiseFn=function(e){if(!e)return;let t;return i=>(t||(t=(e()||Promise.resolve([])).then(e=>e?D(e):{})),t.then(e=>!!e[i]))},t.hasSiblingFn=function(e){if(!e)return;let t;return i=>{if(!t){const i=e();t=i?D(i):{}}return!!t[i]}},t.isRelativePattern=P,t.getBasenameTerms=function(e){return e.allBasenames||[]},t.getPathTerms=function(e){return e.allPaths||[]}})),define(t[106],i([1,0,13,78]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.markedStringsEquals=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=void 0;class r{
constructor(e="",t=!1){var i,n;this._value=e,"boolean"==typeof t?(this._isTrusted=t,this._supportThemeIcons=!1):(this._isTrusted=null!==(i=t.isTrusted)&&void 0!==i&&i,this._supportThemeIcons=null!==(n=t.supportThemeIcons)&&void 0!==n&&n)}get value(){return this._value}get isTrusted(){return this._isTrusted}get supportThemeIcons(){return this._supportThemeIcons}appendText(e){return this._value+=(this._supportThemeIcons?n.escapeCodicons(e):e).replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&").replace("\n","\n\n"),this}appendMarkdown(e){return this._value+=e,this}appendCodeblock(e,t){return this._value+="\n```",this._value+=e,this._value+="\n",this._value+=t,this._value+="\n```\n",this}}function o(e){return e instanceof r||!(!e||"object"!=typeof e)&&!("string"!=typeof e.value||"boolean"!=typeof e.isTrusted&&void 0!==e.isTrusted||"boolean"!=typeof e.supportThemeIcons&&void 0!==e.supportThemeIcons)}function s(e,t){
return e===t||!(!e||!t)&&(e.value===t.value&&e.isTrusted===t.isTrusted&&e.supportThemeIcons===t.supportThemeIcons)}t.MarkdownString=r,t.isEmptyMarkdownString=function e(t){return o(t)?!t.value:!Array.isArray(t)||t.every(e)},t.isMarkdownString=o,t.markedStringsEquals=function(e,t){return!e&&!t||!(!e||!t)&&(Array.isArray(e)&&Array.isArray(t)?i.equals(e,t,s):!(!o(e)||!o(t))&&s(e,t))},t.removeMarkdownEscapes=function(e){return e?e.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1"):e},t.parseHrefAndDimensions=function(e){const t=[],i=e.split("|").map(e=>e.trim());e=i[0];const n=i[1];if(n){const e=/height=(\d+)/.exec(n),i=/width=(\d+)/.exec(n),r=e?e[1]:"",o=i?i[1]:"",s=isFinite(parseInt(o)),a=isFinite(parseInt(r));s&&t.push(`width="${o}"`),a&&t.push(`height="${r}"`)}return{href:e,dimensions:t}}})),define(t[62],i([1,0,26]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeAccents=t.normalizeNFD=t.normalizeNFC=t.canNormalize=void 0,
t.canNormalize="function"==typeof String.prototype.normalize;const n=new i.LRUCache(1e4);t.normalizeNFC=function(e){return a(e,"NFC",n)};const r=new i.LRUCache(1e4);function o(e){return a(e,"NFD",r)}t.normalizeNFD=o;const s=/[^\u0000-\u0080]/;function a(e,i,n){if(!t.canNormalize||!e)return e;const r=n.get(e);if(r)return r;let o;return o=s.test(e)?e.normalize(i):e,n.set(e,o),o}t.removeAccents=function(){if(t.canNormalize){const e=/[\u0300-\u036f]/g;return function(t){return o(t).replace(e,"")}}return function(e){return e}}()})),define(t[23],i([1,0,34,7,2,8,20,9,27,26]),(function(e,t,i,n,r,o,s,a,c,l){"use strict";function u(e){return r.uriToFsPath(e,!0)}Object.defineProperty(t,"__esModule",{value:!0}),
t.toLocalResource=t.ResourceGlobMatcher=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0,t.originalFSPath=u;class d{constructor(e){this._ignorePathCasing=e}compare(e,t,i=!1){return e===t?0:o.compare(this.getComparisonKey(e,i),this.getComparisonKey(t,i))}isEqual(e,t,i=!1){return e===t||!(!e||!t)&&this.getComparisonKey(e,i)===this.getComparisonKey(t,i)}getComparisonKey(e,t=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:t?null:void 0}).toString()}isEqualOrParent(e,n,r=!1){if(e.scheme===n.scheme){if(e.scheme===s.Schemas.file)return i.isEqualOrParent(u(e),u(n),this._ignorePathCasing(e))&&e.query===n.query&&(r||e.fragment===n.fragment)
;if(t.isEqualAuthority(e.authority,n.authority))return i.isEqualOrParent(e.path,n.path,this._ignorePathCasing(e),"/")&&e.query===n.query&&(r||e.fragment===n.fragment)}return!1}joinPath(e,...t){return r.URI.joinPath(e,...t)}basenameOrAuthority(e){return t.basename(e)||e.authority}basename(e){return n.posix.basename(e.path)}extname(e){return n.posix.extname(e.path)}dirname(e){if(0===e.path.length)return e;let t;return e.scheme===s.Schemas.file?t=r.URI.file(n.dirname(u(e))).path:(t=n.posix.dirname(e.path),e.authority&&t.length&&47!==t.charCodeAt(0)&&(console.error(`dirname("${e.toString})) resulted in a relative path`),t="/")),e.with({path:t})}normalizePath(e){if(!e.path.length)return e;let t;return t=e.scheme===s.Schemas.file?r.URI.file(n.normalize(u(e))).path:n.posix.normalize(e.path),e.with({path:t})}relativePath(e,r){if(e.scheme!==r.scheme||!t.isEqualAuthority(e.authority,r.authority))return;if(e.scheme===s.Schemas.file){const t=n.relative(u(e),u(r));return a.isWindows?i.toSlashes(t):t}
let o=e.path||"/",c=r.path||"/";if(this._ignorePathCasing(e)){let e=0;for(const t=Math.min(o.length,c.length);e<t&&(o.charCodeAt(e)===c.charCodeAt(e)||o.charAt(e).toLowerCase()===c.charAt(e).toLowerCase());e++);o=c.substr(0,e)+o.substr(e)}return n.posix.relative(o,c)}resolvePath(e,t){if(e.scheme===s.Schemas.file){const i=r.URI.file(n.resolve(u(e),t));return e.with({authority:i.authority,path:i.path})}return-1===t.indexOf("/")&&(t=i.toSlashes(t),/^[a-zA-Z]:(\/|$)/.test(t)&&(t="/"+t)),e.with({path:n.posix.resolve(e.path,t)})}isAbsolutePath(e){return!!e.path&&"/"===e.path[0]}isEqualAuthority(e,t){return e===t||o.equalsIgnoreCase(e,t)}hasTrailingPathSeparator(e,t=n.sep){if(e.scheme===s.Schemas.file){const n=u(e);return n.length>i.getRoot(n).length&&n[n.length-1]===t}{const t=e.path;return t.length>1&&47===t.charCodeAt(t.length-1)&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,i=n.sep){return t.hasTrailingPathSeparator(e,i)?e.with({path:e.path.substr(0,e.path.length-1)}):e}
addTrailingPathSeparator(e,r=n.sep){let o=!1;if(e.scheme===s.Schemas.file){const t=u(e);o=void 0!==t&&t.length===i.getRoot(t).length&&t[t.length-1]===r}else{r="/";const t=e.path;o=1===t.length&&47===t.charCodeAt(t.length-1)}return o||t.hasTrailingPathSeparator(e,r)?e:e.with({path:e.path+"/"})}}t.ExtUri=d,t.extUri=new d(()=>!1),t.extUriIgnorePathCase=new d(e=>!0);const h=new d(e=>!e||e.scheme!==s.Schemas.file||!a.isLinux);t.isEqual=h.isEqual.bind(h),t.isEqualOrParent=h.isEqualOrParent.bind(h),t.getComparisonKey=h.getComparisonKey.bind(h),t.basenameOrAuthority=h.basenameOrAuthority.bind(h),t.basename=h.basename.bind(h),t.extname=h.extname.bind(h),t.dirname=h.dirname.bind(h),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=h.normalizePath.bind(h),t.relativePath=h.relativePath.bind(h),t.resolvePath=h.resolvePath.bind(h),t.isAbsolutePath=h.isAbsolutePath.bind(h),t.isEqualAuthority=h.isEqualAuthority.bind(h),t.hasTrailingPathSeparator=h.hasTrailingPathSeparator.bind(h),
t.removeTrailingPathSeparator=h.removeTrailingPathSeparator.bind(h),t.addTrailingPathSeparator=h.addTrailingPathSeparator.bind(h),t.distinctParents=function(e,i){const n=[];for(let r=0;r<e.length;r++){const o=i(e[r]);e.some((e,n)=>n!==r&&t.isEqualOrParent(o,i(e)))||n.push(e[r])}return n},function(e){e.META_DATA_LABEL="label",e.META_DATA_DESCRIPTION="description",e.META_DATA_SIZE="size",e.META_DATA_MIME="mime",e.parseMetaData=function(t){const i=new Map;t.path.substring(t.path.indexOf(";")+1,t.path.lastIndexOf(";")).split(";").forEach(e=>{const[t,n]=e.split(":");t&&n&&i.set(t,n)});const n=t.path.substring(0,t.path.indexOf(";"));return n&&i.set(e.META_DATA_MIME,n),i}}(t.DataUri||(t.DataUri={}));t.ResourceGlobMatcher=class{constructor(e,t){this.expressionsByRoot=l.TernarySearchTree.forUris(),this.globalExpression=c.parse(e);for(const e of t)this.expressionsByRoot.set(e.root,{root:e.root,expression:c.parse(e.expression)})}matches(e){const i=this.expressionsByRoot.findSubstr(e);if(i){
const n=t.relativePath(i.root,e);if(n&&i.expression(n))return!0}return!!this.globalExpression(e.path)}},t.toLocalResource=function(e,t){if(t){let i=e.path;return i&&i[0]!==n.posix.sep&&(i=n.posix.sep+i),e.with({scheme:s.Schemas.vscodeRemote,authority:t,path:i})}return e.with({scheme:s.Schemas.file})}})),define(t[104],i([1,0,2,7,8,20,9,23]),(function(e,t,i,n,r,o,s,a){"use strict";function c(e){return!(!s.isWindows||!e||":"!==e[1])}function l(e){return c(e)?e.charAt(0).toUpperCase()+e.slice(1):e}Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0,t.getPathLabel=function(e,t,r){if("string"==typeof e&&(e=i.URI.file(e)),r){const t=r.getWorkspaceFolder(e);if(t){const i=r.getWorkspace().folders.length>1;let n;if(n=a.isEqual(t.uri,e)?"":a.relativePath(t.uri,e),i){const e=t.name?t.name:a.basename(t.uri);n=n?e+" • "+n:e}return n}}
if(e.scheme!==o.Schemas.file&&e.scheme!==o.Schemas.untitled)return e.with({query:null,fragment:null}).toString(!0);if(c(e.fsPath))return n.normalize(l(e.fsPath));let u=n.normalize(e.fsPath);return!s.isWindows&&(null==t?void 0:t.userHome)&&(u=d(u,t.userHome.fsPath)),u},t.getBaseLabel=function(e){if(!e)return;"string"==typeof e&&(e=i.URI.file(e));const t=a.basename(e)||(e.scheme===o.Schemas.file?e.fsPath:e.path);return c(t)?l(t):t},t.normalizeDriveLetter=l;let u=Object.create(null);function d(e,t){if(s.isWindows||!e||!t)return e;let i=u.original===t?u.normalized:void 0;return i||(i=`${r.rtrim(t,n.posix.sep)}${n.posix.sep}`,u={original:t,normalized:i}),(s.isLinux?e.startsWith(i):r.startsWithIgnoreCase(e,i))&&(e=`~/${e.substr(i.length)}`),e}t.tildify=d,t.untildify=function(e,t){return e.replace(/^~($|\/|\\)/,`${t}$1`)};const h="…",p="\\\\",m="~";var f;t.shorten=function(e,t=n.sep){const i=new Array(e.length);let r=!1;for(let n=0;n<e.length;n++){let o=e[n];if(""===o){i[n]=`.${t}`;continue}if(!o){i[n]=o;continue}
r=!0;let s="";0===o.indexOf(p)?(s=o.substr(0,o.indexOf(p)+p.length),o=o.substr(o.indexOf(p)+p.length)):0===o.indexOf(t)?(s=o.substr(0,o.indexOf(t)+t.length),o=o.substr(o.indexOf(t)+t.length)):0===o.indexOf(m)&&(s=o.substr(0,o.indexOf(m)+m.length),o=o.substr(o.indexOf(m)+m.length));const a=o.split(t);for(let o=1;r&&o<=a.length;o++)for(let c=a.length-o;r&&c>=0;c--){r=!1;let l=a.slice(c,c+o).join(t);for(let i=0;!r&&i<e.length;i++)if(i!==n&&e[i]&&e[i].indexOf(l)>-1){const n=c+o===a.length,s=c>0&&e[i].indexOf(t)>-1?t+l:l,u=e[i].endsWith(s);r=!n||u}if(!r){let e="";(a[0].endsWith(":")||""!==s)&&(1===c&&(c=0,o++,l=a[0]+t+l),c>0&&(e=a[0]+t),e=s+e),c>0&&(e=e+h+t),e+=l,c+o<a.length&&(e=e+t+h),i[n]=e}}r&&(i[n]=o)}return i},function(e){e[e.TEXT=0]="TEXT",e[e.VARIABLE=1]="VARIABLE",e[e.SEPARATOR=2]="SEPARATOR"}(f||(f={})),t.template=function(e,t=Object.create(null)){const i=[];let n=!1,r="";for(const o of e)if("$"===o||n&&"{"===o)r&&i.push({value:r,type:f.TEXT}),r="",n=!0;else if("}"===o&&n){const e=t[r]
;if("string"==typeof e)e.length&&i.push({value:e,type:f.VARIABLE});else if(e){const t=i[i.length-1];t&&t.type===f.SEPARATOR||i.push({value:e.label,type:f.SEPARATOR})}r="",n=!1}else r+=o;return r&&!n&&i.push({value:r,type:f.TEXT}),i.filter((e,t)=>{if(e.type===f.SEPARATOR){return[i[t-1],i[t+1]].every(e=>e&&(e.type===f.VARIABLE||e.type===f.TEXT)&&e.value.length>0)}return!0}).map(e=>e.value).join("")},t.mnemonicMenuLabel=function(e,t){return s.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,"").replace(/&/g,s.isMacintosh?"&":"&&"):e.replace(/&&|&/g,e=>"&"===e?"&&":"&")},t.mnemonicButtonLabel=function(e,t){return s.isMacintosh||t?e.replace(/\(&&\w\)|&&/g,""):s.isWindows?e.replace(/&&|&/g,e=>"&"===e?"&&":"&"):e.replace(/&&/g,"_")},t.unmnemonicLabel=function(e){return e.replace(/&/g,"&&")},t.splitName=function(e){const t=-1!==e.indexOf("/")?n.posix:n.win32,i=t.basename(e),r=t.dirname(e);return i.length?{name:i,parentPath:r}:{name:r,parentPath:""}}})),define(t[102],i([1,0,2]),(function(e,t,i){"use strict";function n(e){
return e.toJSON()}Object.defineProperty(t,"__esModule",{value:!0}),t.transformAndReviveIncomingURIs=t.transformIncomingURIs=t.transformOutgoingURIs=t.DefaultURITransformer=t.URITransformer=void 0;function r(e,t,n,o){if(!e||o>200)return null;if("object"==typeof e){if(1===e.$mid)return n?i.URI.revive(t.transformIncoming(e)):t.transformIncoming(e);for(let i in e)if(Object.hasOwnProperty.call(e,i)){const s=r(e[i],t,n,o+1);null!==s&&(e[i]=s)}}return null}t.URITransformer=class{constructor(e){this._uriTransformer=e}transformIncoming(e){const t=this._uriTransformer.transformIncoming(e);return t===e?e:n(i.URI.from(t))}transformOutgoing(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:n(i.URI.from(t))}transformOutgoingURI(e){const t=this._uriTransformer.transformOutgoing(e);return t===e?e:i.URI.from(t)}transformOutgoingScheme(e){return this._uriTransformer.transformOutgoingScheme(e)}},t.DefaultURITransformer=new class{transformIncoming(e){return e}transformOutgoing(e){return e}
transformOutgoingURI(e){return e}transformOutgoingScheme(e){return e}},t.transformOutgoingURIs=function(e,t){const n=function e(t,n,r){if(!t||r>200)return null;if("object"==typeof t){if(t instanceof i.URI)return n.transformOutgoing(t);for(let i in t)if(Object.hasOwnProperty.call(t,i)){const o=e(t[i],n,r+1);null!==o&&(t[i]=o)}}return null}(e,t,0);return null===n?e:n},t.transformIncomingURIs=function(e,t){const i=r(e,t,!1,0);return null===i?e:i},t.transformAndReviveIncomingURIs=function(e,t){const i=r(e,t,!0,0);return null===i?e:i}})),define(t[41],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const i=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;t.isUUID=function(e){return i.test(e)};const n=new Uint8Array(16),r=[];for(let e=0;e<256;e++)r.push(e.toString(16).padStart(2,"0"));const o=function(e){for(let t=0;t<e.length;t++)e[t]=Math.floor(256*Math.random());return e};t.generateUuid=function(){o(n),n[6]=15&n[6]|64,
n[8]=63&n[8]|128;let e=0,t="";return t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+="-",t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]],t+=r[n[e++]]}})),define(t[165],i([1,0,97]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;t.LineDecoder=class{constructor(e="utf8"){this.stringDecoder=new i.StringDecoder(e),this.remaining=null}write(e){const t=[],i=this.remaining?this.remaining+this.stringDecoder.write(e):this.stringDecoder.write(e);if(i.length<1)return t;let n,r=0,o=r;for(;o<i.length;)if(13===(n=i.charCodeAt(o))||10===n){if(t.push(i.substring(r,o)),++o<i.length){const e=n;n=i.charCodeAt(o),(13===e&&10===n||10===e&&13===n)&&o++}r=o}else o++;return this.remaining=r<i.length?i.substr(r):null,t}end(){return this.remaining}}})),define(t[147],i([1,0,261,262]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.detectEncodingFromBuffer=t.toCanonicalName=t.detectEncodingByBOMFromBuffer=t.toNodeEncoding=t.encodeStream=t.encodingExists=t.toDecodeStream=t.UTF8_BOM=t.UTF16le_BOM=t.UTF16be_BOM=t.isUTFEncoding=t.UTF16le=t.UTF16be=t.UTF8_with_bom=t.UTF8=void 0,t.UTF8="utf8",t.UTF8_with_bom="utf8bom",t.UTF16be="utf16be",t.UTF16le="utf16le",t.isUTFEncoding=function(e){return[t.UTF8,t.UTF8_with_bom,t.UTF16be,t.UTF16le].some(t=>t===e)},t.UTF16be_BOM=[254,255],t.UTF16le_BOM=[255,254],t.UTF8_BOM=[239,187,191];const r=512,o=512,s=4096,a=65536;function c(e){return e===t.UTF8_with_bom||null===e?t.UTF8:e}function l(e,i){if(!e||i<t.UTF16be_BOM.length)return null;const n=e.readUInt8(0),r=e.readUInt8(1);if(n===t.UTF16be_BOM[0]&&r===t.UTF16be_BOM[1])return t.UTF16be;if(n===t.UTF16le_BOM[0]&&r===t.UTF16le_BOM[1])return t.UTF16le;if(i<t.UTF8_BOM.length)return null;const o=e.readUInt8(2);return n===t.UTF8_BOM[0]&&r===t.UTF8_BOM[1]&&o===t.UTF8_BOM[2]?t.UTF8_with_bom:null}t.toDecodeStream=function(e,t){
return t.minBytesRequiredForDetection||(t.minBytesRequiredForDetection=t.guessEncoding?s:o),new Promise((r,o)=>{const s=new class extends n.Writable{constructor(){super(...arguments),this.bufferedChunks=[],this.bytesBuffered=0}_write(e,i,n){if(!Buffer.isBuffer(e))return n(new Error("toDecodeStream(): data must be a buffer"));this.decodeStream?this.decodeStream.write(e,n):(this.bufferedChunks.push(e),this.bytesBuffered+=e.byteLength,this.decodeStreamPromise?this.decodeStreamPromise.then(()=>n(null),e=>n(e)):"number"==typeof t.minBytesRequiredForDetection&&this.bytesBuffered>=t.minBytesRequiredForDetection?this._startDecodeStream(n):n(null))}_startDecodeStream(e){this.decodeStreamPromise=Promise.resolve(p({buffer:Buffer.concat(this.bufferedChunks),bytesRead:this.bytesBuffered},t.guessEncoding)).then(n=>{n.encoding=t.overwriteEncoding(n.encoding),this.decodeStream=function(e){return i.decodeStream(c(e))}(n.encoding),this.decodeStream.write(Buffer.concat(this.bufferedChunks),e),this.bufferedChunks.length=0,r({
detected:n,stream:this.decodeStream})},t=>{this.emit("error",t),e(t)})}_final(e){this.decodeStream?this.decodeStream.end(e):this._startDecodeStream(()=>{this.decodeStream&&this.decodeStream.end(e)})}};e.on("error",o),e.pipe(s)})},t.encodingExists=function(e){return i.encodingExists(c(e))},t.encodeStream=function(e,t){return i.encodeStream(c(e),t)},t.toNodeEncoding=c,t.detectEncodingByBOMFromBuffer=l;const u=["ascii","utf-16","utf-32"];async function d(t){const i=(await new Promise((t,i)=>{e(["jschardet"],t,i)})).detect(t.slice(0,a));if(!i||!i.encoding)return null;const n=i.encoding.toLowerCase();return 0<=u.indexOf(n)?null:function(e){const t=e.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return h[t]||t}(i.encoding)}const h={ibm866:"cp866",big5:"cp950"};function p({buffer:e,bytesRead:i},n){let o=l(e,i),s=!1;if(o!==t.UTF16be&&o!==t.UTF16le&&e){let n=!0,a=!0,c=!1;for(let t=0;t<i&&t<r;t++){const i=t%2==1,r=0===e.readInt8(t);if(r&&(c=!0),n&&(i&&!r||!i&&r)&&(n=!1),a&&(i&&r||!i&&!r)&&(a=!1),r&&!n&&!a)break}
c&&(n?o=t.UTF16le:a?o=t.UTF16be:s=!0)}return n&&!s&&!o&&e?d(e.slice(0,i)).then(e=>({seemsBinary:!1,encoding:e})):{seemsBinary:s,encoding:o}}t.toCanonicalName=function(e){switch(e){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:const t=e.match(/windows(\d+)/);return t?"windows-"+t[1]:e}},t.detectEncodingFromBuffer=p})),define(t[24],i([1,0,7,16,35,40,9,3,57,34,41,62]),(function(e,t,i,n,r,o,s,a,c,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.copy=t.move=t.whenDeleted=t.fileExists=t.dirExists=t.readDirsInDir=t.writeFileSync=t.writeFile=t.mkdirp=t.readFile=t.truncate=t.symlink=t.unlink=t.renameIgnoreError=t.rename=t.lstat=t.statLink=t.stat=t.chmod=t.exists=t.readdirSync=t.readdirWithFileTypes=t.readdir=t.rimrafSync=t.rimraf=t.RimRafMode=t.MAX_HEAP_SIZE=t.MAX_FILE_SIZE=void 0;var h;async function p(e,t=h.UNLINK){if(l.isRootOrDriveLetter(e))throw new Error("rimraf - will refuse to recursively delete root");return t===h.UNLINK?m(e):async function(e){try{const t=i.join(o.tmpdir(),u.generateUuid());try{await b(e,t)}catch(t){return m(e)}m(t)}catch(e){if("ENOENT"!==e.code)throw e}}(e)}async function m(e){try{const t=await w(e);if(!t.isDirectory()||t.isSymbolicLink()){const i=t.mode;return 128&i||await _(e,128|i),E(e)}{const t=await f(e);await Promise.all(t.map(t=>m(i.join(e,t)))),await c.promisify(r.rmdir)(e)}}catch(e){if("ENOENT"!==e.code)throw e}}async function f(e){return v(await c.promisify(r.readdir)(e))}function g(e){return v(r.readdirSync(e))}
function v(e){return s.isMacintosh?e.map(e=>d.normalizeNFC(e)):e}function _(e,t){return c.promisify(r.chmod)(e,t)}function y(e){return c.promisify(r.stat)(e)}function w(e){return c.promisify(r.lstat)(e)}function b(e,t){return c.promisify(r.rename)(e,t)}function E(e){return c.promisify(r.unlink)(e)}async function x(e,t){return c.promisify(r.mkdir)(e,{mode:t,recursive:!0})}t.MAX_FILE_SIZE="ia32"===process.arch?314572800:17179869184,t.MAX_HEAP_SIZE="ia32"===process.arch?734003200:1468006400,function(e){e[e.UNLINK=0]="UNLINK",e[e.MOVE=1]="MOVE"}(h=t.RimRafMode||(t.RimRafMode={})),t.rimraf=p,t.rimrafSync=function e(t){if(l.isRootOrDriveLetter(t))throw new Error("rimraf - will refuse to recursively delete root");try{const n=r.lstatSync(t);if(!n.isDirectory()||n.isSymbolicLink()){const e=n.mode;return 128&e||r.chmodSync(t,128|e),r.unlinkSync(t)}g(t).map(n=>e(i.join(t,n))),r.rmdirSync(t)}catch(e){if("ENOENT"!==e.code)throw e}},t.readdir=f,t.readdirWithFileTypes=async function(e){
const t=await c.promisify(r.readdir)(e,{withFileTypes:!0});if(s.isMacintosh)for(const e of t)e.name=d.normalizeNFC(e.name);return t},t.readdirSync=g,t.exists=function(e){return c.promisify(r.exists)(e)},t.chmod=_,t.stat=y,t.statLink=async function(e){let t;try{if(!(t=await w(e)).isSymbolicLink())return{stat:t}}catch(e){}try{return{stat:await y(e),symbolicLink:(null==t?void 0:t.isSymbolicLink())?{dangling:!1}:void 0}}catch(e){if("ENOENT"===e.code&&t)return{stat:t,symbolicLink:{dangling:!0}};throw e}},t.lstat=w,t.rename=b,t.renameIgnoreError=function(e,t){return new Promise(i=>r.rename(e,t,()=>i()))},t.unlink=E,t.symlink=function(e,t,i){return c.promisify(r.symlink)(e,t,i)},t.truncate=function(e,t){return c.promisify(r.truncate)(e,t)},t.readFile=function(e,t){return c.promisify(r.readFile)(e,t)},t.mkdirp=x;const C=new Map;t.writeFile=function(e,t,i){return function(e){const t=C.get(e);if(t)return t;const i=new n.Queue;return C.set(e,i),a.Event.once(i.onFinished)(()=>{C.delete(e),i.dispose()}),i}(function(e){
let t=e;(s.isWindows||s.isMacintosh)&&(t=t.toLowerCase());return t}(e)).queue(()=>{const n=k(i);return new Promise((i,o)=>(function(e,t,i,n){if(!S)return r.writeFile(e,t,{mode:i.mode,flag:i.flag},n);r.open(e,i.flag,i.mode,(e,i)=>{if(e)return n(e);r.writeFile(i,t,e=>{if(e)return r.close(i,()=>n(e));r.fdatasync(i,e=>(e&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",e),S=!1),r.close(i,e=>n(e))))})})})(e,t,n,e=>e?o(e):i()))})};let S=!0;function k(e){return e?{mode:"number"==typeof e.mode?e.mode:438,flag:"string"==typeof e.flag?e.flag:"w"}:{mode:438,flag:"w"}}async function T(e){try{return(await y(e)).isDirectory()}catch(e){return!1}}async function I(e,t,n){const o=n||Object.create(null),s=await y(e);if(!s.isDirectory())return async function(e,t,i){return new Promise((n,o)=>{const s=r.createReadStream(e),a=r.createWriteStream(t,{mode:i});let c=!1;const l=e=>{if(!c){if(c=!0,e)return o(e);r.chmod(t,i,e=>e?o(e):n())}};s.once("error",e=>l(e)),a.once("error",e=>l(e)),
a.once("close",()=>l()),s.pipe(a)})}(e,t,511&s.mode);if(o[e])return Promise.resolve();o[e]=!0,await x(t,511&s.mode);const a=await f(e);for(let n=0;n<a.length;n++){const r=a[n];await I(i.join(e,r),i.join(t,r),o)}}t.writeFileSync=function(e,t,i){const n=k(i);if(!S)return r.writeFileSync(e,t,{mode:n.mode,flag:n.flag});const o=r.openSync(e,n.flag,n.mode);try{r.writeFileSync(o,t);try{r.fdatasyncSync(o)}catch(e){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",e),S=!1}}finally{r.closeSync(o)}},t.readDirsInDir=async function(e){const t=await f(e),n=[];for(const r of t)await T(i.join(e,r))&&n.push(r);return n},t.dirExists=T,t.fileExists=async function(e){try{return(await y(e)).isFile()}catch(e){return!1}},t.whenDeleted=function(e){return new Promise(t=>{let i=!1;const n=setInterval(()=>{i||(i=!0,r.exists(e,e=>{i=!1,e||(clearInterval(n),t(void 0))}))},1e3)})},t.move=async function(e,t){if(e===t)return Promise.resolve();async function i(e){const t=await w(e)
;if(t.isDirectory()||t.isSymbolicLink())return Promise.resolve();const i=await c.promisify(r.open)(e,"a");try{await c.promisify(r.futimes)(i,t.atime,new Date)}catch(e){}return c.promisify(r.close)(i)}try{await b(e,t),await i(t)}catch(n){if(!(e.toLowerCase()!==t.toLowerCase()&&"EXDEV"===n.code||e.endsWith(".")))throw n;await I(e,t),await p(e,h.MOVE),await i(t)}},t.copy=I})),define(t[143],i([1,0,35,8,7,24,57]),(function(e,t,i,n,r,o,s){"use strict";function a(e){return n.rtrim(r.normalize(e),r.sep)}Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0,t.realcaseSync=function e(t){const i=r.dirname(t);if(t===i)return t;const n=(r.basename(t)||t).toLowerCase();try{const t=o.readdirSync(i).filter(e=>e.toLowerCase()===n);if(1===t.length){const n=e(i);if(n)return r.join(n,t[0])}else if(t.length>1){const o=t.indexOf(n);if(o>=0){const n=e(i);if(n)return r.join(n,t[o])}}}catch(e){}return null},t.realpath=async function(e){try{return await s.promisify(i.realpath)(e)}catch(t){
const n=a(e);return await s.promisify(i.access)(n,i.constants.R_OK),n}},t.realpathSync=function(e){try{return i.realpathSync(e)}catch(t){const n=a(e);return i.accessSync(n,i.constants.R_OK),n}}})),define(t[96],i([1,0,3,6,16,22,19,29,13,12,53,8]),(function(e,t,i,n,r,o,s,a,c,l,u,d){"use strict";var h,p;Object.defineProperty(t,"__esModule",{value:!0}),t.createChannelSender=t.createChannelReceiver=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.ChannelServer=t.ResponseType=t.RequestType=void 0,function(e){e[e.Promise=100]="Promise",e[e.PromiseCancel=101]="PromiseCancel",e[e.EventListen=102]="EventListen",e[e.EventDispose=103]="EventDispose"}(t.RequestType||(t.RequestType={})),function(e){e[e.Initialize=200]="Initialize",e[e.PromiseSuccess=201]="PromiseSuccess",e[e.PromiseError=202]="PromiseError",e[e.PromiseErrorObj=203]="PromiseErrorObj",e[e.EventFire=204]="EventFire"}(t.ResponseType||(t.ResponseType={})),function(e){e[e.Uninitialized=0]="Uninitialized",
e[e.Idle=1]="Idle"}(h||(h={}));class m{constructor(e){this.buffer=e,this.pos=0}read(e){const t=this.buffer.slice(this.pos,this.pos+e);return this.pos+=t.byteLength,t}}class f{constructor(){this.buffers=[]}get buffer(){return a.VSBuffer.concat(this.buffers)}write(e){this.buffers.push(e)}}function g(e){const t=a.VSBuffer.alloc(4);return t.writeUInt32BE(e,0),t}function v(e){return e.read(4).readUInt32BE(0)}function _(e){const t=a.VSBuffer.alloc(1);return t.writeUInt8(e,0),t}!function(e){e[e.Undefined=0]="Undefined",e[e.String=1]="String",e[e.Buffer=2]="Buffer",e[e.VSBuffer=3]="VSBuffer",e[e.Array=4]="Array",e[e.Object=5]="Object"}(p||(p={}));const y={Undefined:_(p.Undefined),String:_(p.String),Buffer:_(p.Buffer),VSBuffer:_(p.VSBuffer),Array:_(p.Array),Object:_(p.Object)},w="undefined"!=typeof Buffer;function b(e,t){if(void 0===t)e.write(y.Undefined);else if("string"==typeof t){const i=a.VSBuffer.fromString(t);e.write(y.String),e.write(g(i.byteLength)),e.write(i)}else if(w&&Buffer.isBuffer(t)){
const i=a.VSBuffer.wrap(t);e.write(y.Buffer),e.write(g(i.byteLength)),e.write(i)}else if(t instanceof a.VSBuffer)e.write(y.VSBuffer),e.write(g(t.byteLength)),e.write(t);else if(Array.isArray(t)){e.write(y.Array),e.write(g(t.length));for(const i of t)b(e,i)}else{const i=a.VSBuffer.fromString(JSON.stringify(t));e.write(y.Object),e.write(g(i.byteLength)),e.write(i)}}function E(e){switch(e.read(1).readUInt8(0)){case p.Undefined:return;case p.String:return e.read(v(e)).toString();case p.Buffer:return e.read(v(e)).buffer;case p.VSBuffer:return e.read(v(e));case p.Array:{const t=v(e),i=[];for(let n=0;n<t;n++)i.push(E(e));return i}case p.Object:return JSON.parse(e.read(v(e)).toString())}}class x{constructor(e,t,i=1e3){this.protocol=e,this.ctx=t,this.timeoutDelay=i,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(e=>this.onRawMessage(e)),this.sendResponse({type:200})}registerChannel(e,t){this.channels.set(e,t),
setTimeout(()=>this.flushPendingRequests(e),0)}sendResponse(e){switch(e.type){case 200:return this.send([e.type]);case 201:case 202:case 204:case 203:return this.send([e.type,e.id],e.data)}}send(e,t){const i=new f;b(i,e),b(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{this.protocol.send(e)}catch(e){}}onRawMessage(e){const t=new m(e),i=E(t),n=E(t),r=i[0];switch(r){case 100:return this.onPromise({type:r,id:i[1],channelName:i[2],name:i[3],arg:n});case 102:return this.onEventListen({type:r,id:i[1],channelName:i[2],name:i[3],arg:n});case 101:case 103:return this.disposeActiveRequest({type:r,id:i[1]})}}onPromise(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=new o.CancellationTokenSource;let r;try{r=t.call(this.ctx,e.name,e.arg,i.token)}catch(e){r=Promise.reject(e)}const s=e.id;r.then(t=>{this.sendResponse({id:s,data:t,type:201}),this.activeRequests.delete(e.id)},t=>{t instanceof Error?this.sendResponse({id:s,data:{message:t.message,name:t.name,
stack:t.stack?t.stack.split?t.stack.split("\n"):t.stack:void 0},type:202}):this.sendResponse({id:s,data:t,type:203}),this.activeRequests.delete(e.id)});const a=n.toDisposable(()=>i.cancel());this.activeRequests.set(e.id,a)}onEventListen(e){const t=this.channels.get(e.channelName);if(!t)return void this.collectPendingRequest(e);const i=e.id,n=t.listen(this.ctx,e.name,e.arg)(e=>this.sendResponse({id:i,data:e,type:204}));this.activeRequests.set(e.id,n)}disposeActiveRequest(e){const t=this.activeRequests.get(e.id);t&&(t.dispose(),this.activeRequests.delete(e.id))}collectPendingRequest(e){let t=this.pendingRequests.get(e.channelName);t||(t=[],this.pendingRequests.set(e.channelName,t));const i=setTimeout(()=>{console.error(`Unknown channel: ${e.channelName}`),100===e.type&&this.sendResponse({id:e.id,data:{name:"Unknown channel",message:`Channel name '${e.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);t.push({request:e,timeoutTimer:i})}flushPendingRequests(e){
const t=this.pendingRequests.get(e);if(t){for(const e of t)switch(clearTimeout(e.timeoutTimer),e.request.type){case 100:this.onPromise(e.request);break;case 102:this.onEventListen(e.request)}this.pendingRequests.delete(e)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelServer=x;class C{constructor(e){this.protocol=e,this.state=h.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new i.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(e=>this.onBuffer(e))}getChannel(e){const t=this;return{call:(i,n,r)=>t.requestPromise(e,i,n,r),listen:(i,n)=>t.requestEvent(e,i,n)}}requestPromise(e,t,i,a=o.CancellationToken.None){const c=this.lastRequestId++,l={id:c,type:100,channelName:e,name:t,arg:i};if(a.isCancellationRequested)return Promise.reject(s.canceled());let u
;return new Promise((e,t)=>{if(a.isCancellationRequested)return t(s.canceled());let i=r.createCancelablePromise(e=>this.whenInitialized());i.then(()=>{i=null;this.handlers.set(c,i=>{switch(i.type){case 201:this.handlers.delete(c),e(i.data);break;case 202:this.handlers.delete(c);const n=new Error(i.data.message);n.stack=i.data.stack,n.name=i.data.name,t(n);break;case 203:this.handlers.delete(c),t(i.data)}}),this.sendRequest(l)});const o=()=>{i?(i.cancel(),i=null):this.sendRequest({id:c,type:101}),t(s.canceled())},d=a.onCancellationRequested(o);u=n.combinedDisposable(n.toDisposable(o),d),this.activeRequests.add(u)}).finally(()=>{this.activeRequests.delete(u)})}requestEvent(e,t,n){const o=this.lastRequestId++,s={id:o,type:102,channelName:e,name:t,arg:n};let a=null;const c=new i.Emitter({onFirstListenerAdd:()=>{(a=r.createCancelablePromise(e=>this.whenInitialized())).then(()=>{a=null,this.activeRequests.add(c),this.sendRequest(s)})},onLastListenerRemove:()=>{a?(a.cancel(),a=null):(this.activeRequests.delete(c),
this.sendRequest({id:o,type:103}))}});return this.handlers.set(o,e=>c.fire(e.data)),c.event}sendRequest(e){switch(e.type){case 100:case 102:return this.send([e.type,e.id,e.channelName,e.name],e.arg);case 101:case 103:return this.send([e.type,e.id])}}send(e,t){const i=new f;b(i,e),b(i,t),this.sendBuffer(i.buffer)}sendBuffer(e){try{this.protocol.send(e)}catch(e){}}onBuffer(e){const t=new m(e),i=E(t),n=E(t);switch(i[0]){case 200:return this.onResponse({type:i[0]});case 201:case 202:case 204:case 203:return this.onResponse({type:i[0],id:i[1],data:n})}}onResponse(e){if(200===e.type)return this.state=h.Idle,void this._onDidInitialize.fire();const t=this.handlers.get(e.id);t&&t(e)}whenInitialized(){return this.state===h.Idle?Promise.resolve():i.Event.toPromise(this.onDidInitialize)}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(e=>e.dispose()),this.activeRequests.clear()}}t.ChannelClient=C;t.IPCServer=class{constructor(e){
this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new i.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new i.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,e(({protocol:e,onDidClientDisconnect:t})=>{i.Event.once(e.onMessage)(i=>{const n=E(new m(i)),r=new x(e,n),o=new C(e);this.channels.forEach((e,t)=>r.registerChannel(t,e));const s={channelServer:r,channelClient:o,ctx:n};this._connections.add(s),this._onDidAddConnection.fire(s),t(()=>{r.dispose(),o.dispose(),this._connections.delete(s),this._onDidRemoveConnection.fire(s)})})})}get connections(){const e=[];return this._connections.forEach(t=>e.push(t)),e}getChannel(e,t){const n=this;return{call(r,o,s){let a;if(l.isFunction(t)){let e=c.getRandomElement(n.connections.filter(t));a=e?Promise.resolve(e):i.Event.toPromise(i.Event.filter(n.onDidAddConnection,t))}else a=t.routeCall(n,r,o);return S(a.then(t=>t.channelClient.getChannel(e))).call(r,o,s)},listen(i,r){
if(l.isFunction(t))return n.getMulticastEvent(e,t,i,r);return S(t.routeEvent(n,i,r).then(t=>t.channelClient.getChannel(e))).listen(i,r)}}}getMulticastEvent(e,t,r,o){const s=this;let a=new n.DisposableStore;const c=new i.Emitter({onFirstListenerAdd:()=>{a=new n.DisposableStore;const l=new i.EventMultiplexer,u=new Map,d=t=>{const i=t.channelClient.getChannel(e).listen(r,o),n=l.add(i);u.set(t,n)};s.connections.filter(t).forEach(d),i.Event.filter(s.onDidAddConnection,t)(d,void 0,a),s.onDidRemoveConnection(e=>{const t=u.get(e);t&&(t.dispose(),u.delete(e))},void 0,a),l.event(c.fire,c,a),a.add(l)},onLastListenerRemove:()=>{a.dispose()}});return c.event}registerChannel(e,t){this.channels.set(e,t),this._connections.forEach(i=>{i.channelServer.registerChannel(e,t)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}};function S(e){return{call:(t,i,n)=>e.then(e=>e.call(t,i,n)),listen(t,n){const r=new i.Relay
;return e.then(e=>r.input=e.listen(t,n)),r.event}}}t.IPCClient=class{constructor(e,t){const i=new f;b(i,t),e.send(i.buffer),this.channelClient=new C(e),this.channelServer=new x(e,t)}getChannel(e){return this.channelClient.getChannel(e)}registerChannel(e,t){this.channelServer.registerChannel(e,t)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}},t.getDelayedChannel=S,t.getNextTickChannel=function(e){let t=!1;return{call:(i,n,o)=>t?e.call(i,n,o):r.timeout(0).then(()=>t=!0).then(()=>e.call(i,n,o)),listen(n,o){if(t)return e.listen(n,o);const s=new i.Relay;return r.timeout(0).then(()=>t=!0).then(()=>s.input=e.listen(n,o)),s.event}}};function k(e){return"o"===e[0]&&"n"===e[1]&&d.isUpperAsciiLetter(e.charCodeAt(2))}t.StaticRouter=class{constructor(e){this.fn=e}routeCall(e){return this.route(e)}routeEvent(e){return this.route(e)}async route(e){for(const t of e.connections)if(await Promise.resolve(this.fn(t.ctx)))return Promise.resolve(t);return await i.Event.toPromise(e.onDidAddConnection),
await this.route(e)}},t.createChannelReceiver=function(e,t){const n=e,r=t&&t.disableMarshalling,o=new Map;for(const e in n)k(e)&&o.set(e,i.Event.buffer(n[e],!0));return new class{listen(e,t){const i=o.get(t);if(i)return i;throw new Error(`Event not found: ${t}`)}call(e,t,i){const o=n[t];if("function"==typeof o){if(!r&&Array.isArray(i))for(let e=0;e<i.length;e++)i[e]=u.revive(i[e]);return o.apply(n,i)}throw new Error(`Method not found: ${t}`)}}},t.createChannelSender=function(e,t){const i=t&&t.disableMarshalling;return new Proxy({},{get(n,r){var o;if("string"==typeof r)return(null===(o=null==t?void 0:t.properties)||void 0===o?void 0:o.has(r))?t.properties.get(r):k(r)?e.listen(r):async function(...n){let o;o=t&&!l.isUndefinedOrNull(t.context)?[t.context,...n]:n;const s=await e.call(r,o);return i?s:u.revive(s)};throw new Error(`Property not found: ${String(r)}`)}})}})),define(t[95],i([1,0,3,96,6,29,9,36]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.PersistentProtocol=t.BufferedEmitter=t.Client=t.Protocol=t.ProtocolConstants=t.ChunkStream=void 0;let c=null;function l(){return c||(c=o.VSBuffer.alloc(0)),c}class u{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(e){this._chunks.push(e),this._totalLength+=e.byteLength}read(e){return this._read(e,!0)}peek(e){return this._read(e,!1)}_read(e,t){if(0===e)return l();if(e>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===e){const i=this._chunks[0];return t&&(this._chunks.shift(),this._totalLength-=e),i}if(this._chunks[0].byteLength>e){const i=this._chunks[0].slice(0,e);return t&&(this._chunks[0]=this._chunks[0].slice(e),this._totalLength-=e),i}let i=o.VSBuffer.alloc(e),n=0,r=0;for(;e>0;){const o=this._chunks[r];if(o.byteLength>e){const s=o.slice(0,e);i.set(s,n),n+=e,t&&(this._chunks[r]=o.slice(e),this._totalLength-=e),e-=e}else i.set(o,n),n+=o.byteLength,t?(this._chunks.shift(),
this._totalLength-=o.byteLength):r++,e-=o.byteLength}return i}}var d;t.ChunkStream=u,function(e){e[e.None=0]="None",e[e.Regular=1]="Regular",e[e.Control=2]="Control",e[e.Ack=3]="Ack",e[e.KeepAlive=4]="KeepAlive",e[e.Disconnect=5]="Disconnect"}(d||(d={})),function(e){e[e.HeaderLength=13]="HeaderLength",e[e.AcknowledgeTime=2e3]="AcknowledgeTime",e[e.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",e[e.KeepAliveTime=5e3]="KeepAliveTime",e[e.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",e[e.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",e[e.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"}(t.ProtocolConstants||(t.ProtocolConstants={}));class h{constructor(e,t,i,n){this.type=e,this.id=t,this.ack=i,this.data=n,this.writtenTime=0}get size(){return this.data.byteLength}}class p extends r.Disposable{constructor(e){super(),this._onMessage=this._register(new i.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=e,
this._isDisposed=!1,this._incomingData=new u,this._register(this._socket.onData(e=>this.acceptChunk(e))),this.lastReadTime=Date.now()}acceptChunk(e){if(e&&0!==e.byteLength)for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;){const e=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=e.readUInt32BE(9),this._state.messageType=e.readUInt8(0),this._state.id=e.readUInt32BE(1),this._state.ack=e.readUInt32BE(5);else{const t=this._state.messageType,i=this._state.id,n=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new h(t,i,n,e)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(e){this._isDisposed=!1,this._socket=e,this._data=[],this._totalLength=0,this.lastWriteTime=0}
dispose(){this.flush(),this._isDisposed=!0}flush(){this._writeNow()}write(e){if(this._isDisposed)return;e.writtenTime=Date.now(),this.lastWriteTime=Date.now();const t=o.VSBuffer.alloc(13);t.writeUInt8(e.type,0),t.writeUInt32BE(e.id,1),t.writeUInt32BE(e.ack,5),t.writeUInt32BE(e.data.byteLength,9),this._writeSoon(t,e.data)}_bufferAdd(e,t){const i=0===this._totalLength;return this._data.push(e,t),this._totalLength+=e.byteLength+t.byteLength,i}_bufferTake(){const e=o.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,e}_writeSoon(e,t){this._bufferAdd(e,t)&&s.setImmediate(()=>{this._writeNow()})}_writeNow(){0!==this._totalLength&&this._socket.write(this._bufferTake())}}class f extends r.Disposable{constructor(e){super(),this._onMessage=new i.Emitter,this.onMessage=this._onMessage.event,this._onClose=new i.Emitter,this.onClose=this._onClose.event,this._socket=e,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new p(this._socket)),
this._register(this._socketReader.onMessage(e=>{1===e.type&&this._onMessage.fire(e.data)})),this._register(this._socket.onClose(()=>this._onClose.fire()))}getSocket(){return this._socket}sendDisconnect(){}send(e){this._socketWriter.write(new h(1,0,0,e))}}t.Protocol=f;class g extends n.IPCClient{constructor(e,t){super(e,t),this.protocol=e}static fromSocket(e,t){return new g(new f(e),t)}get onClose(){return this.protocol.onClose}dispose(){super.dispose();const e=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),e.end()}}t.Client=g;class v{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new i.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,a.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){
for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(e){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(e):this._emitter.fire(e):this._bufferedMessages.push(e)}flushBuffer(){this._bufferedMessages=[]}}t.BufferedEmitter=v;class _{constructor(e){this.data=e,this.next=null}}class y{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let e=[],t=0,i=this._first;for(;i;)e[t++]=i.data,i=i.next;return e}pop(){if(this._first)return this._first===this._last?(this._first=null,void(this._last=null)):void(this._first=this._first.next)}push(e){const t=new _(e);if(!this._first)return this._first=t,void(this._last=t);this._last.next=t,this._last=t}}t.PersistentProtocol=class{constructor(e,t=null){this._onControlMessage=new v,this.onControlMessage=this._onControlMessage.event,this._onMessage=new v,
this.onMessage=this._onMessage.event,this._onClose=new v,this.onClose=this._onClose.event,this._onSocketClose=new v,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new v,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new y,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._socketDisposables=[],this._socket=e,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),t&&this._socketReader.acceptChunk(t),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}
get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=r.dispose(this._socketDisposables)}sendDisconnect(){const e=new h(5,0,0,l());this._socketWriter.write(e),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const e=Date.now()-this._socketWriter.lastWriteTime;if(e>=5e3){const e=new h(4,0,0,l());return this._socketWriter.write(e),void this._sendKeepAliveCheck()}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-e+5)}_recvKeepAliveCheck(){
if(this._incomingKeepAliveTimeout)return;const e=Date.now()-this._socketReader.lastReadTime;e>=2e4?this._onSocketTimeout.fire(void 0):this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},2e4-e+5)}getSocket(){return this._socket}beginAcceptReconnection(e,t){this._isReconnecting=!0,this._socketDisposables=r.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._socket=e,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new p(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(e=>this._receiveMessage(e))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(t)}endAcceptReconnection(){this._isReconnecting=!1;const e=this._outgoingUnackMsg.toArray()
;for(let t=0,i=e.length;t<i;t++)this._socketWriter.write(e[t]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onClose.fire()}_receiveMessage(e){if(e.ack>this._outgoingAckId)for(this._outgoingAckId=e.ack;;){const t=this._outgoingUnackMsg.peek();if(!(t&&t.id<=e.ack))break;this._outgoingUnackMsg.pop()}1===e.type?e.id>this._incomingMsgId&&(e.id!==this._incomingMsgId+1&&console.error(`PROTOCOL CORRUPTION, LAST SAW MSG ${this._incomingMsgId} AND HAVE NOW RECEIVED MSG ${e.id}`),this._incomingMsgId=e.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(e.data)):2===e.type?this._onControlMessage.fire(e.data):5===e.type&&this._onClose.fire()}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(e){const t=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const i=new h(1,t,this._incomingAckId,e);this._outgoingUnackMsg.push(i),this._isReconnecting||(this._socketWriter.write(i),
this._recvAckCheck())}sendControl(e){const t=new h(2,0,0,e);this._socketWriter.write(t)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId)return;if(this._incomingAckTimeout)return;const e=Date.now()-this._incomingMsgLastTime;e>=2e3?this._sendAck():this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-e+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId)return;if(this._outgoingAckTimeout)return;const e=this._outgoingUnackMsg.peek(),t=Date.now()-e.writtenTime;t>=2e4?this._onSocketTimeout.fire(void 0):this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},2e4-t+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const e=new h(3,0,this._incomingAckId,l());this._socketWriter.write(e)}}})),define(t[92],i([1,0,89,3,96,7,40,41,6,29,95]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.connect=t.serve=t.Server=t.generateRandomPipeName=t.WebSocketNodeSocket=t.NodeSocket=void 0;class d{constructor(e){this.socket=e}dispose(){this.socket.destroy()}onData(e){const t=t=>e(l.VSBuffer.wrap(t));return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(e){return this.socket.on("close",e),{dispose:()=>this.socket.off("close",e)}}onEnd(e){return this.socket.on("end",e),{dispose:()=>this.socket.off("end",e)}}write(e){this.socket.destroyed||this.socket.write(e.buffer)}end(){this.socket.end()}}var h,p;t.NodeSocket=d,function(e){e[e.MinHeaderByteSize=2]="MinHeaderByteSize"}(h||(h={})),function(e){e[e.PeekHeader=1]="PeekHeader",e[e.ReadHeader=2]="ReadHeader",e[e.ReadBody=3]="ReadBody",e[e.Fin=4]="Fin"}(p||(p={}));class m extends c.Disposable{constructor(e){super(),this._onData=this._register(new n.Emitter),this._state={state:1,readLen:2,mask:0},this.socket=e,this._incomingData=new u.ChunkStream,this._register(this.socket.onData(e=>this._acceptChunk(e)))}dispose(){
this.socket.dispose()}onData(e){return this._onData.event(e)}onClose(e){return this.socket.onClose(e)}onEnd(e){return this.socket.onEnd(e)}write(e){let t=2;e.byteLength<126?t+=0:e.byteLength<65536?t+=2:t+=8;const i=l.VSBuffer.alloc(t);if(i.writeUInt8(130,0),e.byteLength<126)i.writeUInt8(e.byteLength,1);else if(e.byteLength<65536){i.writeUInt8(126,1);let t=1;i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}else{i.writeUInt8(127,1);let t=1;i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(0,++t),i.writeUInt8(e.byteLength>>>24&255,++t),i.writeUInt8(e.byteLength>>>16&255,++t),i.writeUInt8(e.byteLength>>>8&255,++t),i.writeUInt8(e.byteLength>>>0&255,++t)}this.socket.write(l.VSBuffer.concat([i,e]))}end(){this.socket.end()}_acceptChunk(e){if(0!==e.byteLength)for(this._incomingData.acceptChunk(e);this._incomingData.byteLength>=this._state.readLen;)if(1===this._state.state){const e=this._incomingData.peek(this._state.readLen).readUInt8(1),t=(128&e)>>>7,i=127&e
;this._state.state=2,this._state.readLen=2+(t?4:0)+(126===i?2:0)+(127===i?8:0),this._state.mask=0}else if(2===this._state.state){const e=this._incomingData.read(this._state.readLen),t=e.readUInt8(1),i=(128&t)>>>7;let n=127&t,r=1;126===n?n=256*e.readUInt8(++r)+e.readUInt8(++r):127===n&&(n=0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+0*e.readUInt8(++r)+e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r));let o=0;i&&(o=e.readUInt8(++r)*2**24+65536*e.readUInt8(++r)+256*e.readUInt8(++r)+e.readUInt8(++r)),this._state.state=3,this._state.readLen=n,this._state.mask=o}else if(3===this._state.state){const e=this._incomingData.read(this._state.readLen);f(e,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._onData.fire(e)}}}function f(e,t){if(0===t)return;let i=e.byteLength>>>2;for(let n=0;n<i;n++){const i=e.readUInt32BE(4*n);e.writeUInt32BE(i^t,4*n)}let n=4*i,r=e.byteLength-n;const o=t>>>24&255,s=t>>>16&255,a=t>>>8&255
;r>=1&&e.writeUInt8(e.readUInt8(n)^o,n),r>=2&&e.writeUInt8(e.readUInt8(n+1)^s,n+1),r>=3&&e.writeUInt8(e.readUInt8(n+2)^a,n+2)}t.WebSocketNodeSocket=m,t.generateRandomPipeName=function(){const e=a.generateUuid();return"win32"===process.platform?`\\\\.\\pipe\\vscode-ipc-${e}-sock`:o.join(s.tmpdir(),`vscode-ipc-${e}.sock`)};class g extends r.IPCServer{constructor(e){super(g.toClientConnectionEvent(e)),this.server=e}static toClientConnectionEvent(e){const t=n.Event.fromNodeEventEmitter(e,"connection");return n.Event.map(t,e=>({protocol:new u.Protocol(new d(e)),onDidClientDisconnect:n.Event.once(n.Event.fromNodeEventEmitter(e,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}t.Server=g,t.serve=function(e){return new Promise((t,n)=>{const r=i.createServer();r.on("error",n),r.listen(e,()=>{r.removeListener("error",n),t(new g(r))})})},t.connect=function(e,t){return new Promise((n,r)=>{const o=i.createConnection(e,()=>{o.removeListener("error",r),
n(u.Client.fromSocket(new d(o),t))});o.once("error",r)})}})),define(t[131],i([1,0,110]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CharacterSet=t.CharacterClassifier=void 0;class n{constructor(e){let t=i.toUint8(e);this._defaultValue=t,this._asciiMap=n._createAsciiMap(t),this._map=new Map}static _createAsciiMap(e){let t=new Uint8Array(256);for(let i=0;i<256;i++)t[i]=e;return t}set(e,t){let n=i.toUint8(t);e>=0&&e<256?this._asciiMap[e]=n:this._map.set(e,n)}get(e){return e>=0&&e<256?this._asciiMap[e]:this._map.get(e)||this._defaultValue}}var r;t.CharacterClassifier=n,function(e){e[e.False=0]="False",e[e.True=1]="True"}(r||(r={}));t.CharacterSet=class{constructor(){this._actual=new n(0)}add(e){this._actual.set(e,1)}has(e){return 1===this._actual.get(e)}}})),define(t[49],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Position=void 0;class i{constructor(e,t){this.lineNumber=e,this.column=t}with(e=this.lineNumber,t=this.column){
return e===this.lineNumber&&t===this.column?this:new i(e,t)}delta(e=0,t=0){return this.with(this.lineNumber+e,this.column+t)}equals(e){return i.equals(this,e)}static equals(e,t){return!e&&!t||!!e&&!!t&&e.lineNumber===t.lineNumber&&e.column===t.column}isBefore(e){return i.isBefore(this,e)}static isBefore(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<t.column}isBeforeOrEqual(e){return i.isBeforeOrEqual(this,e)}static isBeforeOrEqual(e,t){return e.lineNumber<t.lineNumber||!(t.lineNumber<e.lineNumber)&&e.column<=t.column}static compare(e,t){let i=0|e.lineNumber,n=0|t.lineNumber;if(i===n){return(0|e.column)-(0|t.column)}return i-n}clone(){return new i(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(e){return new i(e.lineNumber,e.column)}static isIPosition(e){return e&&"number"==typeof e.lineNumber&&"number"==typeof e.column}}t.Position=i})),define(t[47],i([1,0,49]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.Range=void 0;class n{constructor(e,t,i,n){e>i||e===i&&t>n?(this.startLineNumber=i,this.startColumn=n,this.endLineNumber=e,this.endColumn=t):(this.startLineNumber=e,this.startColumn=t,this.endLineNumber=i,this.endColumn=n)}isEmpty(){return n.isEmpty(this)}static isEmpty(e){return e.startLineNumber===e.endLineNumber&&e.startColumn===e.endColumn}containsPosition(e){return n.containsPosition(this,e)}static containsPosition(e,t){return!(t.lineNumber<e.startLineNumber||t.lineNumber>e.endLineNumber)&&(!(t.lineNumber===e.startLineNumber&&t.column<e.startColumn)&&!(t.lineNumber===e.endLineNumber&&t.column>e.endColumn))}containsRange(e){return n.containsRange(this,e)}static containsRange(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>e.endColumn)))}strictContainsRange(e){
return n.strictContainsRange(this,e)}static strictContainsRange(e,t){return!(t.startLineNumber<e.startLineNumber||t.endLineNumber<e.startLineNumber)&&(!(t.startLineNumber>e.endLineNumber||t.endLineNumber>e.endLineNumber)&&(!(t.startLineNumber===e.startLineNumber&&t.startColumn<=e.startColumn)&&!(t.endLineNumber===e.endLineNumber&&t.endColumn>=e.endColumn)))}plusRange(e){return n.plusRange(this,e)}static plusRange(e,t){let i,r,o,s;return t.startLineNumber<e.startLineNumber?(i=t.startLineNumber,r=t.startColumn):t.startLineNumber===e.startLineNumber?(i=t.startLineNumber,r=Math.min(t.startColumn,e.startColumn)):(i=e.startLineNumber,r=e.startColumn),t.endLineNumber>e.endLineNumber?(o=t.endLineNumber,s=t.endColumn):t.endLineNumber===e.endLineNumber?(o=t.endLineNumber,s=Math.max(t.endColumn,e.endColumn)):(o=e.endLineNumber,s=e.endColumn),new n(i,r,o,s)}intersectRanges(e){return n.intersectRanges(this,e)}static intersectRanges(e,t){
let i=e.startLineNumber,r=e.startColumn,o=e.endLineNumber,s=e.endColumn,a=t.startLineNumber,c=t.startColumn,l=t.endLineNumber,u=t.endColumn;return i<a?(i=a,r=c):i===a&&(r=Math.max(r,c)),o>l?(o=l,s=u):o===l&&(s=Math.min(s,u)),i>o?null:i===o&&r>s?null:new n(i,r,o,s)}equalsRange(e){return n.equalsRange(this,e)}static equalsRange(e,t){return!!e&&!!t&&e.startLineNumber===t.startLineNumber&&e.startColumn===t.startColumn&&e.endLineNumber===t.endLineNumber&&e.endColumn===t.endColumn}getEndPosition(){return n.getEndPosition(this)}static getEndPosition(e){return new i.Position(e.endLineNumber,e.endColumn)}getStartPosition(){return n.getStartPosition(this)}static getStartPosition(e){return new i.Position(e.startLineNumber,e.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(e,t){return new n(this.startLineNumber,this.startColumn,e,t)}setStartPosition(e,t){return new n(e,t,this.endLineNumber,this.endColumn)}collapseToStart(){
return n.collapseToStart(this)}static collapseToStart(e){return new n(e.startLineNumber,e.startColumn,e.startLineNumber,e.startColumn)}static fromPositions(e,t=e){return new n(e.lineNumber,e.column,t.lineNumber,t.column)}static lift(e){return e?new n(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn):null}static isIRange(e){return e&&"number"==typeof e.startLineNumber&&"number"==typeof e.startColumn&&"number"==typeof e.endLineNumber&&"number"==typeof e.endColumn}static areIntersectingOrTouching(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<e.startColumn)}static areIntersecting(e,t){return!(e.endLineNumber<t.startLineNumber||e.endLineNumber===t.startLineNumber&&e.endColumn<=t.startColumn)&&!(t.endLineNumber<e.startLineNumber||t.endLineNumber===e.startLineNumber&&t.endColumn<=e.startColumn)}static compareRangesUsingStarts(e,t){if(e&&t){
const i=0|e.startLineNumber,n=0|t.startLineNumber;if(i===n){const i=0|e.startColumn,n=0|t.startColumn;if(i===n){const i=0|e.endLineNumber,n=0|t.endLineNumber;if(i===n){return(0|e.endColumn)-(0|t.endColumn)}return i-n}return i-n}return i-n}return(e?1:0)-(t?1:0)}static compareRangesUsingEnds(e,t){return e.endLineNumber===t.endLineNumber?e.endColumn===t.endColumn?e.startLineNumber===t.startLineNumber?e.startColumn-t.startColumn:e.startLineNumber-t.startLineNumber:e.endColumn-t.endColumn:e.endLineNumber-t.endLineNumber}static spansMultipleLines(e){return e.endLineNumber>e.startLineNumber}}t.Range=n})),define(t[129],i([1,0,49,47]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Selection=t.SelectionDirection=void 0,function(e){e[e.LTR=0]="LTR",e[e.RTL=1]="RTL"}(t.SelectionDirection||(t.SelectionDirection={}));class r extends n.Range{constructor(e,t,i,n){super(e,t,i,n),this.selectionStartLineNumber=e,this.selectionStartColumn=t,this.positionLineNumber=i,this.positionColumn=n}
toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(e){return r.selectionsEqual(this,e)}static selectionsEqual(e,t){return e.selectionStartLineNumber===t.selectionStartLineNumber&&e.selectionStartColumn===t.selectionStartColumn&&e.positionLineNumber===t.positionLineNumber&&e.positionColumn===t.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(e,t){return 0===this.getDirection()?new r(this.startLineNumber,this.startColumn,e,t):new r(e,t,this.startLineNumber,this.startColumn)}getPosition(){return new i.Position(this.positionLineNumber,this.positionColumn)}setStartPosition(e,t){return 0===this.getDirection()?new r(e,t,this.endLineNumber,this.endColumn):new r(this.endLineNumber,this.endColumn,e,t)}static fromPositions(e,t=e){return new r(e.lineNumber,e.column,t.lineNumber,t.column)}static liftSelection(e){
return new r(e.selectionStartLineNumber,e.selectionStartColumn,e.positionLineNumber,e.positionColumn)}static selectionsArrEqual(e,t){if(e&&!t||!e&&t)return!1;if(!e&&!t)return!0;if(e.length!==t.length)return!1;for(let i=0,n=e.length;i<n;i++)if(!this.selectionsEqual(e[i],t[i]))return!1;return!0}static isISelection(e){return e&&"number"==typeof e.selectionStartLineNumber&&"number"==typeof e.selectionStartColumn&&"number"==typeof e.positionLineNumber&&"number"==typeof e.positionColumn}static createWithDirection(e,t,i,n,o){return 0===o?new r(e,t,i,n):new r(i,n,e,t)}}t.Selection=r})),define(t[123],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ApplyEditsResult=t.ValidAnnotatedEditOperation=t.ModelConstants=t.TrackedRangeStickiness=t.FindMatch=t.TextModelResolvedOptions=t.EndOfLineSequence=t.DefaultEndOfLine=t.EndOfLinePreference=t.MinimapPosition=t.OverviewRulerLane=void 0,function(e){e[e.Left=1]="Left",e[e.Center=2]="Center",e[e.Right=4]="Right",e[e.Full=7]="Full"
}(t.OverviewRulerLane||(t.OverviewRulerLane={})),function(e){e[e.Inline=1]="Inline",e[e.Gutter=2]="Gutter"}(t.MinimapPosition||(t.MinimapPosition={})),function(e){e[e.TextDefined=0]="TextDefined",e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLinePreference||(t.EndOfLinePreference={})),function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.DefaultEndOfLine||(t.DefaultEndOfLine={})),function(e){e[e.LF=0]="LF",e[e.CRLF=1]="CRLF"}(t.EndOfLineSequence||(t.EndOfLineSequence={}));t.TextModelResolvedOptions=class{constructor(e){this.tabSize=Math.max(1,0|e.tabSize),this.indentSize=0|e.tabSize,this.insertSpaces=Boolean(e.insertSpaces),this.defaultEOL=0|e.defaultEOL,this.trimAutoWhitespace=Boolean(e.trimAutoWhitespace)}equals(e){return this.tabSize===e.tabSize&&this.indentSize===e.indentSize&&this.insertSpaces===e.insertSpaces&&this.defaultEOL===e.defaultEOL&&this.trimAutoWhitespace===e.trimAutoWhitespace}createChangeEvent(e){return{tabSize:this.tabSize!==e.tabSize,indentSize:this.indentSize!==e.indentSize,
insertSpaces:this.insertSpaces!==e.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==e.trimAutoWhitespace}}};t.FindMatch=class{constructor(e,t){this.range=e,this.matches=t}},function(e){e[e.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",e[e.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",e[e.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",e[e.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"}(t.TrackedRangeStickiness||(t.TrackedRangeStickiness={})),function(e){e[e.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"}(t.ModelConstants||(t.ModelConstants={}));t.ValidAnnotatedEditOperation=class{constructor(e,t,i,n,r,o){this.identifier=e,this.range=t,this.text=i,this.forceMoveMarkers=n,this.isAutoWhitespaceEdit=r,this._isTracked=o}};t.ApplyEditsResult=class{constructor(e,t,i){this.reverseEdits=e,this.changes=t,this.trimAutoWhitespaceLineNumbers=i}}})),define(t[85],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.getWordAtText=t.ensureValidWordDefinition=t.DEFAULT_WORD_REGEXP=t.USUAL_WORD_SEPARATORS=void 0,t.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?",t.DEFAULT_WORD_REGEXP=function(e=""){let i="(-?\\d*\\.\\d\\w*)|([^";for(const n of t.USUAL_WORD_SEPARATORS)e.indexOf(n)>=0||(i+="\\"+n);return i+="\\s]+)",new RegExp(i,"g")}(),t.ensureValidWordDefinition=function(e){let i=t.DEFAULT_WORD_REGEXP;if(e&&e instanceof RegExp)if(e.global)i=e;else{let t="g";e.ignoreCase&&(t+="i"),e.multiline&&(t+="m"),e.unicode&&(t+="u"),i=new RegExp(e.source,t)}return i.lastIndex=0,i};const i={maxLen:1e3,windowSize:15,timeBudget:150};function n(e,t,i,n){let r;for(;r=e.exec(t);){const t=r.index||0;if(t<=i&&e.lastIndex>=i)return r;if(n>0&&t>n)return null}return null}t.getWordAtText=function e(t,r,o,s,a=i){if(o.length>a.maxLen){let i=t-a.maxLen/2;return i<0?(s+=t,i=0):s+=i,e(t,r,o=o.substring(i,t+a.maxLen/2),s,a)}Date.now();const c=t-1-s;let l=-1,u=null;for(let e=1;;e++){Date.now(),a.timeBudget;const t=c-a.windowSize*e
;r.lastIndex=Math.max(0,t);const i=n(r,o,c,l);if(!i&&u)break;if(u=i,t<=0)break;l=t}if(u){let e={word:u[0],startColumn:s+1+u.index,endColumn:s+1+u.index+u[0].length};return r.lastIndex=0,e}return null}})),define(t[120],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardAutoClosingPairConditional=t.IndentAction=void 0,function(e){e[e.None=0]="None",e[e.Indent=1]="Indent",e[e.IndentOutdent=2]="IndentOutdent",e[e.Outdent=3]="Outdent"}(t.IndentAction||(t.IndentAction={}));t.StandardAutoClosingPairConditional=class{constructor(e){if(this.open=e.open,this.close=e.close,this._standardTokenMask=0,Array.isArray(e.notIn))for(let t=0,i=e.notIn.length;t<i;t++){switch(e.notIn[t]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4}}}isOK(e){return 0==(this._standardTokenMask&e)}}})),define(t[70],i([1,0,27]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.score=void 0,
t.score=function e(t,n,r,o){if(Array.isArray(t)){let i=0;for(const s of t){const t=e(s,n,r,o);if(10===t)return t;t>i&&(i=t)}return i}if("string"==typeof t)return o?"*"===t?5:t===r?10:0:0;if(t){const{language:e,pattern:s,scheme:a,hasAccessToAllModels:c}=t;if(!o&&!c)return 0;let l=0;if(a)if(a===n.scheme)l=10;else{if("*"!==a)return 0;l=5}if(e)if(e===r)l=10;else{if("*"!==e)return 0;l=Math.max(l,5)}if(s){if(s!==n.fsPath&&!i.match(s,n.fsPath))return 0;l=10}return l}return 0}})),define(t[243],i([1,0,131]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeLinks=t.LinkComputer=t.StateMachine=t.Uint8Matrix=t.State=void 0,function(e){e[e.Invalid=0]="Invalid",e[e.Start=1]="Start",e[e.H=2]="H",e[e.HT=3]="HT",e[e.HTT=4]="HTT",e[e.HTTP=5]="HTTP",e[e.F=6]="F",e[e.FI=7]="FI",e[e.FIL=8]="FIL",e[e.BeforeColon=9]="BeforeColon",e[e.AfterColon=10]="AfterColon",e[e.AlmostThere=11]="AlmostThere",e[e.End=12]="End",e[e.Accept=13]="Accept",e[e.LastKnownState=14]="LastKnownState"
}(t.State||(t.State={}));class n{constructor(e,t,i){const n=new Uint8Array(e*t);for(let r=0,o=e*t;r<o;r++)n[r]=i;this._data=n,this.rows=e,this.cols=t}get(e,t){return this._data[e*this.cols+t]}set(e,t,i){this._data[e*this.cols+t]=i}}t.Uint8Matrix=n;class r{constructor(e){let t=0,i=0;for(let n=0,r=e.length;n<r;n++){let[r,o,s]=e[n];o>t&&(t=o),r>i&&(i=r),s>i&&(i=s)}let r=new n(++i,++t,0);for(let t=0,i=e.length;t<i;t++){let[i,n,o]=e[t];r.set(i,n,o)}this._states=r,this._maxCharCode=t}nextState(e,t){return t<0||t>=this._maxCharCode?0:this._states.get(e,t)}}t.StateMachine=r;let o=null;var s;!function(e){e[e.None=0]="None",e[e.ForceTermination=1]="ForceTermination",e[e.CannotEndIn=2]="CannotEndIn"}(s||(s={}));let a=null;class c{static _createLink(e,t,i,n,r){let o=r-1;do{const i=t.charCodeAt(o);if(2!==e.get(i))break;o--}while(o>n);if(n>0){const e=t.charCodeAt(n-1),i=t.charCodeAt(o);(40===e&&41===i||91===e&&93===i||123===e&&125===i)&&o--}return{range:{startLineNumber:i,startColumn:n+1,endLineNumber:i,endColumn:o+2},
url:t.substring(n,o+1)}}static computeLinks(e,t=(null===o&&(o=new r([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),o)){const n=function(){if(null===a){a=new i.CharacterClassifier(0);const e=" \t<>'\"、。｡､，．：；？！＠＃＄％＆＊‘“〈《「『【〔（［｛｢｣｝］）〕】』」》〉”’｀～…";for(let t=0;t<e.length;t++)a.set(e.charCodeAt(t),1);const t=".,;";for(let e=0;e<t.length;e++)a.set(t.charCodeAt(e),2)}return a}();let s=[];for(let i=1,r=e.getLineCount();i<=r;i++){const r=e.getLineContent(i),o=r.length;let a=0,l=0,u=0,d=1,h=!1,p=!1,m=!1,f=!1;for(;a<o;){let e=!1;const o=r.charCodeAt(a);if(13===d){let t;switch(o){case 40:h=!0,t=0;break;case 41:t=h?0:1;break;case 91:m=!0,p=!0,t=0;break;case 93:m=!1,t=p?0:1;break;case 123:f=!0,t=0;break;case 125:t=f?0:1;break;case 39:t=34===u||96===u?0:1;break;case 34:t=39===u||96===u?0:1;break;case 96:t=39===u||34===u?0:1;break;case 42:t=42===u?1:0;break
;case 124:t=124===u?1:0;break;case 32:t=m?0:1;break;default:t=n.get(o)}1===t&&(s.push(c._createLink(n,r,i,l,a)),e=!0)}else if(12===d){let t;91===o?(p=!0,t=0):t=n.get(o),1===t?e=!0:d=13}else 0===(d=t.nextState(d,o))&&(e=!0);e&&(d=1,h=!1,p=!1,f=!1,l=a+1,u=o),a++}13===d&&s.push(c._createLink(n,r,i,l,o))}return s}}t.LinkComputer=c,t.computeLinks=function(e){return e&&"function"==typeof e.getLineCount&&"function"==typeof e.getLineContent?c.computeLinks(e):[]}})),define(t[240],i([1,0,3,6,12,26]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TokenizationRegistryImpl=void 0;t.TokenizationRegistryImpl=class{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new i.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(e){this._onDidChange.fire({changedLanguages:e,changedColorMap:!1})}register(e,t){return this._map.set(e,t),this.fire([e]),n.toDisposable(()=>{this._map.get(e)===t&&(this._map.delete(e),this.fire([e]))})}registerPromise(e,t){
let i=null,r=!1;return this._promises.set(e,t.then(t=>{this._promises.delete(e),!r&&t&&(i=this.register(e,t))})),n.toDisposable(()=>{r=!0,i&&i.dispose()})}getPromise(e){const t=this.get(e);if(t)return Promise.resolve(t);const i=this._promises.get(e);return i?i.then(t=>this.get(e)):null}get(e){return r.withUndefinedAsNull(this._map.get(e))}setColorMap(e){this._colorMap=e,this._onDidChange.fire({changedLanguages:o.keys(this._map),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}})),define(t[84],i([1,0,110]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PrefixSumComputer=t.PrefixSumIndexOfResult=void 0;class n{constructor(e,t){this.index=e,this.remainder=t}}t.PrefixSumIndexOfResult=n;t.PrefixSumComputer=class{constructor(e){this.values=e,this.prefixSum=new Uint32Array(e.length),this.prefixSumValidIndex=new Int32Array(1),this.prefixSumValidIndex[0]=-1}getCount(){
return this.values.length}insertValues(e,t){e=i.toUint32(e);const n=this.values,r=this.prefixSum,o=t.length;return 0!==o&&(this.values=new Uint32Array(n.length+o),this.values.set(n.subarray(0,e),0),this.values.set(n.subarray(e),e+o),this.values.set(t,e),e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),this.prefixSum=new Uint32Array(this.values.length),this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(r.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}changeValue(e,t){return e=i.toUint32(e),t=i.toUint32(t),this.values[e]!==t&&(this.values[e]=t,e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),!0)}removeValues(e,t){e=i.toUint32(e),t=i.toUint32(t);const n=this.values,r=this.prefixSum;if(e>=n.length)return!1;let o=n.length-e;return t>=o&&(t=o),0!==t&&(this.values=new Uint32Array(n.length-t),this.values.set(n.subarray(0,e),0),this.values.set(n.subarray(e+t),e),this.prefixSum=new Uint32Array(this.values.length),e-1<this.prefixSumValidIndex[0]&&(this.prefixSumValidIndex[0]=e-1),
this.prefixSumValidIndex[0]>=0&&this.prefixSum.set(r.subarray(0,this.prefixSumValidIndex[0]+1)),!0)}getTotalValue(){return 0===this.values.length?0:this._getAccumulatedValue(this.values.length-1)}getAccumulatedValue(e){return e<0?0:(e=i.toUint32(e),this._getAccumulatedValue(e))}_getAccumulatedValue(e){if(e<=this.prefixSumValidIndex[0])return this.prefixSum[e];let t=this.prefixSumValidIndex[0]+1;0===t&&(this.prefixSum[0]=this.values[0],t++),e>=this.values.length&&(e=this.values.length-1);for(let i=t;i<=e;i++)this.prefixSum[i]=this.prefixSum[i-1]+this.values[i];return this.prefixSumValidIndex[0]=Math.max(this.prefixSumValidIndex[0],e),this.prefixSum[e]}getIndexOf(e){e=Math.floor(e),this.getTotalValue();let t=0,i=this.values.length-1,r=0,o=0,s=0;for(;t<=i;)if(r=t+(i-t)/2|0,e<(s=(o=this.prefixSum[r])-this.values[r]))i=r-1;else{if(!(e>=o))break;t=r+1}return new n(r,e-s)}}})),define(t[200],i([1,0,49,84]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MirrorTextModel=void 0
;t.MirrorTextModel=class{constructor(e,t,i,n){this._uri=e,this._lines=t,this._eol=i,this._versionId=n,this._lineStarts=null}dispose(){this._lines.length=0}get version(){return this._versionId}getText(){return this._lines.join(this._eol)}onEvents(e){e.eol&&e.eol!==this._eol&&(this._eol=e.eol,this._lineStarts=null);const t=e.changes;for(const e of t)this._acceptDeleteRange(e.range),this._acceptInsertText(new i.Position(e.range.startLineNumber,e.range.startColumn),e.text);this._versionId=e.versionId}_ensureLineStarts(){if(!this._lineStarts){const e=this._eol.length,t=this._lines.length,i=new Uint32Array(t);for(let n=0;n<t;n++)i[n]=this._lines[n].length+e;this._lineStarts=new n.PrefixSumComputer(i)}}_setLineText(e,t){this._lines[e]=t,this._lineStarts&&this._lineStarts.changeValue(e,this._lines[e].length+this._eol.length)}_acceptDeleteRange(e){
if(e.startLineNumber!==e.endLineNumber)this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.endLineNumber-1].substring(e.endColumn-1)),this._lines.splice(e.startLineNumber,e.endLineNumber-e.startLineNumber),this._lineStarts&&this._lineStarts.removeValues(e.startLineNumber,e.endLineNumber-e.startLineNumber);else{if(e.startColumn===e.endColumn)return;this._setLineText(e.startLineNumber-1,this._lines[e.startLineNumber-1].substring(0,e.startColumn-1)+this._lines[e.startLineNumber-1].substring(e.endColumn-1))}}_acceptInsertText(e,t){if(0===t.length)return;let i=t.split(/\r\n|\r|\n/);if(1===i.length)return void this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+i[0]+this._lines[e.lineNumber-1].substring(e.column-1));i[i.length-1]+=this._lines[e.lineNumber-1].substring(e.column-1),this._setLineText(e.lineNumber-1,this._lines[e.lineNumber-1].substring(0,e.column-1)+i[0]);let n=new Uint32Array(i.length-1)
;for(let t=1;t<i.length;t++)this._lines.splice(e.lineNumber+t-1,0,i[t]),n[t-1]=i[t].length+this._eol.length;this._lineStarts&&this._lineStarts.insertValues(e.lineNumber,n)}}})),define(t[189],i([15,17]),(function(e,t){return e.create("vs/base/common/date",t)})),define(t[121],i([1,0,8,189]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const r=60,o=60*r,s=24*o,a=7*s,c=30*s,l=365*s;t.fromNow=function e(t,i){"number"!=typeof t&&(t=t.getTime());const u=Math.round(((new Date).getTime()-t)/1e3);if(u<-30)return n.localize(0,null,e((new Date).getTime()+1e3*u,!1));if(u<30)return n.localize(1,null);let d;return u<r?(d=u,i?1===d?n.localize(2,null,d):n.localize(3,null,d):1===d?n.localize(4,null,d):n.localize(5,null,d)):u<o?(d=Math.floor(u/r),i?1===d?n.localize(6,null,d):n.localize(7,null,d):1===d?n.localize(8,null,d):n.localize(9,null,d)):u<s?(d=Math.floor(u/o),
i?1===d?n.localize(10,null,d):n.localize(11,null,d):1===d?n.localize(12,null,d):n.localize(13,null,d)):u<a?(d=Math.floor(u/s),i?1===d?n.localize(14,null,d):n.localize(15,null,d):1===d?n.localize(16,null,d):n.localize(17,null,d)):u<c?(d=Math.floor(u/a),i?1===d?n.localize(18,null,d):n.localize(19,null,d):1===d?n.localize(20,null,d):n.localize(21,null,d)):u<l?(d=Math.floor(u/c),i?1===d?n.localize(22,null,d):n.localize(23,null,d):1===d?n.localize(24,null,d):n.localize(25,null,d)):(d=Math.floor(u/l),i?1===d?n.localize(26,null,d):n.localize(27,null,d):1===d?n.localize(28,null,d):n.localize(29,null,d))},t.toLocalISOString=function(e){return e.getFullYear()+"-"+i.pad(e.getMonth()+1,2)+"-"+i.pad(e.getDate(),2)+"T"+i.pad(e.getHours(),2)+":"+i.pad(e.getMinutes(),2)+":"+i.pad(e.getSeconds(),2)+"."+(e.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}})),define(t[227],i([15,17]),(function(e,t){return e.create("vs/base/common/errorMessage",t)})),define(t[46],i([1,0,227,12,13]),(function(e,t,i,n,r){"use strict"
;function o(e,t){return t&&(e.stack||e.stacktrace)?i.localize(0,null,a(e),s(e.stack)||s(e.stacktrace)):a(e)}function s(e){return Array.isArray(e)?e.join("\n"):e}function a(e){return"string"==typeof e.code&&"number"==typeof e.errno&&"string"==typeof e.syscall?i.localize(1,null,e.message):e.message||i.localize(2,null)}Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0,t.toErrorMessage=function e(t=null,s=!1){if(!t)return i.localize(3,null);if(Array.isArray(t)){const n=r.coalesce(t),o=e(n[0],s);return n.length>1?i.localize(4,null,o,n.length):o}if(n.isString(t))return t;if(t.detail){const e=t.detail;if(e.error)return o(e.error,s);if(e.exception)return o(e.exception,s)}return t.stack?o(t,s):t.message?t.message:i.localize(5,null)}})),define(t[195],i([15,17]),(function(e,t){return e.create("vs/base/common/severity",t)})),define(t[81],i([1,0,195,8]),(function(e,t,i,n){"use strict";var r;Object.defineProperty(t,"__esModule",{value:!0}),function(e){e[e.Ignore=0]="Ignore",e[e.Info=1]="Info",
e[e.Warning=2]="Warning",e[e.Error=3]="Error"}(r||(r={})),function(e){const t="error",r="warning",o="warn",s="info",a=Object.create(null);a[e.Error]=i.localize(0,null),a[e.Warning]=i.localize(1,null),a[e.Info]=i.localize(2,null),e.fromValue=function(i){return i?n.equalsIgnoreCase(t,i)?e.Error:n.equalsIgnoreCase(r,i)||n.equalsIgnoreCase(o,i)?e.Warning:n.equalsIgnoreCase(s,i)?e.Info:e.Ignore:e.Ignore}}(r||(r={})),t.default=r})),define(t[173],i([15,17]),(function(e,t){return e.create("vs/base/node/processes",t)})),define(t[79],i([1,0,7,35,57,32,173,12,18,34,9,165,64]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h){"use strict";function p(e){switch(e){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function m(){return process.env.comspec||"cmd.exe"}Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,t.getWindowsShell=m;let f=(()=>{class t{constructor(e,t,i,n){
if(void 0!==t&&void 0!==i&&void 0!==n)this.cmd=e,this.args=t,this.shell=i,this.options=n;else{const t=e;this.cmd=t.command,this.shell=t.isShellCommand,this.args=t.args.slice(0),this.options=t.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const e=Object.create(null);Object.keys(process.env).forEach(t=>{e[t]=process.env[t]}),Object.keys(this.options.env).forEach(t=>{e[t]=this.options.env[t]}),this.options.env=e}}getSanitizedCommand(){let e=this.cmd.toLowerCase();const n=e.lastIndexOf(i.sep);return-1!==n&&(e=e.substring(n+1)),t.WellKnowCommands[e]?e:"other"}start(e){return u.isWindows&&(this.options&&this.options.cwd&&l.isUNC(this.options.cwd)||!this.options&&l.isUNC(process.cwd()))?Promise.reject(new Error(s.localize(0,null))):this.useExec().then(t=>{let i,n;const r=new Promise((e,t)=>{i=e,n=t});if(t){let t=this.cmd;this.args&&(t=t+" "+this.args.join(" ")),this.childProcess=o.exec(t,this.options,(t,r,o)=>{this.childProcess=null;t&&t.killed?n({
killed:this.terminateRequested,stdout:r.toString(),stderr:o.toString()}):this.handleExec(i,e,t,r,o)})}else{let t=null;const r=t=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(t,i,e,n);const r={terminated:this.terminateRequested};a.isNumber(t)&&(r.cmdCode=t),i(r)};if(this.shell&&u.isWindows){const e=c.deepClone(this.options);e.windowsVerbatimArguments=!0,e.detached=!1;let i=!1,n=!1;const r=[];let s=this.ensureQuotes(this.cmd);r.push(s.value),i=s.quoted,this.args&&this.args.forEach(e=>{s=this.ensureQuotes(e),r.push(s.value),n=n&&s.quoted});const a=["/s","/c"];i?n?a.push('"'+r.join(" ")+'"'):r.length>1?a.push('"'+r[0]+'" '+r.slice(1).join(" ")):a.push('"'+r[0]+'"'):a.push(r.join(" ")),t=o.spawn(m(),a,e)}else this.cmd&&(t=o.spawn(this.cmd,this.args,this.options));t&&(this.childProcess=t,this.childProcessPromise=Promise.resolve(t),this.pidResolve&&(this.pidResolve(a.isNumber(t.pid)?t.pid:-1),this.pidResolve=void 0),t.on("error",e=>{this.childProcess=null,n({
terminated:this.terminateRequested,error:e})}),t.pid&&(this.childProcess.on("close",r),this.handleSpawn(t,i,e,n,!0)))}return r})}handleClose(e,t,i,n){}ensureQuotes(e){return t.regexp.test(e)?{value:'"'+e+'"',quoted:!0}:{value:e,quoted:e.length>0&&'"'===e[0]&&'"'===e[e.length-1]}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(e=>e.pid,e=>-1):new Promise(e=>{this.pidResolve=e})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(t=>(this.terminateRequested=!0,function(t,i){if(u.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};i&&(e.cwd=i);const n=o.execFile("taskkill",["/T","/F","/PID",t.pid.toString()],e);return new Promise((e,t)=>{n.once("error",t=>{e({success:!1,error:t})}),n.once("exit",(t,i)=>{e(0===t?{success:!0}:{success:!1,code:null!==t?t:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?p(e.status):1})}else if(u.isLinux||u.isMacintosh)try{const i=h.getPathFromAmdModule(e,"vs/base/node/terminateProcess.sh")
;return new Promise((e,n)=>{o.execFile(i,[t.pid.toString()],{encoding:"utf8",shell:!0},(t,i,n)=>{e(t?{success:!1,error:t}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else t.kill("SIGKILL");return Promise.resolve({success:!0})}(t,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),e=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise((e,t)=>{if(!this.shell||!u.isWindows)return e(!1);const i=o.spawn(m(),["/s","/c"]);i.on("error",t=>e(!0)),i.on("exit",t=>e(!1))})}}return t.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},t.regexp=/^[^"].* .*[^"]/,t})();t.AbstractProcess=f;t.LineProcess=class extends f{constructor(e,t,i,n){super(e,t,i,n),this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(e,t,i,n,r){[n,r].forEach((e,i)=>{const n=new d.LineDecoder;n.write(e).forEach(e=>{t({line:e,source:0===i?0:1})})
;const r=n.end();r&&t({line:r,source:0===i?0:1})}),e({terminated:this.terminateRequested,error:i})}handleSpawn(e,t,i,n,r){const o=new d.LineDecoder,s=new d.LineDecoder;e.stdout.on("data",e=>{o.write(e).forEach(e=>i({line:e,source:0}))}),e.stderr.on("data",e=>{s.write(e).forEach(e=>i({line:e,source:1}))}),this.stdoutLineDecoder=o,this.stderrLineDecoder=s}handleClose(e,t,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const o=this.stderrLineDecoder?this.stderrLineDecoder.end():null;o&&i({line:o,source:1})}},t.createQueuedSender=function(e){let t=[],i=!1;const n=function(r){if(i)return void t.push(r);e.send(r,e=>{if(e&&console.error(e),i=!1,t.length>0){const e=t.slice(0);t=[],e.forEach(e=>n(e))}})&&!u.isWindows||(i=!0)};return{send:n}},function(e){e.findExecutable=async function(e,t,o){if(i.isAbsolute(e))return e;if(void 0===t&&(t=process.cwd()),"."!==i.dirname(e))return i.join(t,e);if(void 0===o&&a.isString(process.env.PATH)&&(o=process.env.PATH.split(i.delimiter)),
void 0===o||0===o.length)return i.join(t,e);async function s(e){return!!await r.promisify(n.exists)(e)&&!(await r.promisify(n.stat)(e)).isDirectory}for(let n of o){let r;if(r=i.isAbsolute(n)?i.join(n,e):i.join(t,n,e),await s(r))return r;let o=r+".com";if(await s(o))return o;if(o=r+".exe",await s(o))return o}return i.join(t,e)}}(t.win32||(t.win32={}))})),define(t[124],i([15,17]),(function(e,t){return e.create("vs/editor/common/config/editorOptions",t)})),define(t[125],i([1,0,124,9,85]),(function(e,t,i,n,r){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),
t.EditorOptions=t.EditorOption=t.editorOptionsRegistry=t.EDITOR_MODEL_DEFAULTS=t.EDITOR_FONT_DEFAULTS=t.WrappingIndent=t.filterValidationDecorations=t.RenderLineNumbersType=t.EditorLayoutInfoComputer=t.RenderMinimap=t.EditorFontLigatures=t.cursorStyleToString=t.TextEditorCursorStyle=t.TextEditorCursorBlinkingStyle=t.ComputeOptionsMemory=t.ValidatedEditorOptions=t.ConfigurationChangedEvent=t.MINIMAP_GUTTER_WIDTH=t.EditorAutoIndentStrategy=void 0,function(e){e[e.None=0]="None",e[e.Keep=1]="Keep",e[e.Brackets=2]="Brackets",e[e.Advanced=3]="Advanced",e[e.Full=4]="Full"}(t.EditorAutoIndentStrategy||(t.EditorAutoIndentStrategy={})),t.MINIMAP_GUTTER_WIDTH=8;t.ConfigurationChangedEvent=class{constructor(e){this._values=e}hasChanged(e){return this._values[e]}};t.ValidatedEditorOptions=class{constructor(){this._values=[]}_read(e){return this._values[e]}get(e){return this._values[e]}_write(e,t){this._values[e]=t}};class s{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,
this.stableFitRemainingWidth=0}}t.ComputeOptionsMemory=s;class a{constructor(e,t,i,n){this.id=e,this.name=t,this.defaultValue=i,this.schema=n}compute(e,t,i){return i}}class c{constructor(e,t=null){this.schema=void 0,this.id=e,this.name="_never_",this.defaultValue=void 0,this.deps=t}validate(e){return this.defaultValue}}class l{constructor(e,t,i,n){this.id=e,this.name=t,this.defaultValue=i,this.schema=n}validate(e){return void 0===e?this.defaultValue:e}compute(e,t,i){return i}}class u extends l{static boolean(e,t){return void 0===e?t:"false"!==e&&Boolean(e)}constructor(e,t,i,n){void 0!==n&&(n.type="boolean",n.default=i),super(e,t,i,n)}validate(e){return u.boolean(e,this.defaultValue)}}class d extends l{constructor(e,t,i,n,r,o){void 0!==o&&(o.type="integer",o.default=i,o.minimum=n,o.maximum=r),super(e,t,i,o),this.minimum=n,this.maximum=r}static clampedInt(e,t,i,n){let r;return void 0===e?r=t:(r=parseInt(e,10),isNaN(r)&&(r=t)),r=Math.max(i,r),0|(r=Math.min(n,r))}validate(e){
return d.clampedInt(e,this.defaultValue,this.minimum,this.maximum)}}class h extends l{constructor(e,t,i,n,r){void 0!==r&&(r.type="number",r.default=i),super(e,t,i,r),this.validationFn=n}static clamp(e,t,i){return e<t?t:e>i?i:e}static float(e,t){if("number"==typeof e)return e;if(void 0===e)return t;const i=parseFloat(e);return isNaN(i)?t:i}validate(e){return this.validationFn(h.float(e,this.defaultValue))}}class p extends l{static string(e,t){return"string"!=typeof e?t:e}constructor(e,t,i,n){void 0!==n&&(n.type="string",n.default=i),super(e,t,i,n)}validate(e){return p.string(e,this.defaultValue)}}class m extends l{constructor(e,t,i,n,r){void 0!==r&&(r.type="string",r.enum=n,r.default=i),super(e,t,i,r),this._allowedValues=n}static stringSet(e,t,i){return"string"!=typeof e?t:-1===i.indexOf(e)?t:e}validate(e){return m.stringSet(e,this.defaultValue,this._allowedValues)}}class f extends a{constructor(e,t,i,n,r,o,s){void 0!==s&&(s.type="string",s.enum=r,s.default=n),super(e,t,i,s),this._allowedValues=r,
this._convert=o}validate(e){return"string"!=typeof e?this.defaultValue:-1===this._allowedValues.indexOf(e)?this.defaultValue:this._convert(e)}}!function(e){e[e.Hidden=0]="Hidden",e[e.Blink=1]="Blink",e[e.Smooth=2]="Smooth",e[e.Phase=3]="Phase",e[e.Expand=4]="Expand",e[e.Solid=5]="Solid"}(t.TextEditorCursorBlinkingStyle||(t.TextEditorCursorBlinkingStyle={})),function(e){e[e.Line=1]="Line",e[e.Block=2]="Block",e[e.Underline=3]="Underline",e[e.LineThin=4]="LineThin",e[e.BlockOutline=5]="BlockOutline",e[e.UnderlineThin=6]="UnderlineThin"}(o=t.TextEditorCursorStyle||(t.TextEditorCursorStyle={})),t.cursorStyleToString=function(e){switch(e){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}};let g=(()=>{class e extends a{constructor(){super(37,"fontLigatures",e.OFF,{anyOf:[{type:"boolean",description:i.localize(14,null)},{type:"string",
description:i.localize(15,null)}],description:i.localize(16,null),default:!1})}validate(t){return void 0===t?this.defaultValue:"string"==typeof t?"false"===t?e.OFF:"true"===t?e.ON:t:Boolean(t)?e.ON:e.OFF}}return e.OFF='"liga" off, "calt" off',e.ON='"liga" on, "calt" on',e})();t.EditorFontLigatures=g;!function(e){e[e.None=0]="None",e[e.Text=1]="Text",e[e.Blocks=2]="Blocks"}(t.RenderMinimap||(t.RenderMinimap={}));class v extends c{constructor(){super(115,[42,50,31,56,84,52,53,86,105,108,109,2])}compute(e,t,i){return v.computeLayout(t,{memory:e.memory,outerWidth:e.outerWidth,outerHeight:e.outerHeight,isDominatedByLongLines:e.isDominatedByLongLines,lineHeight:e.fontInfo.lineHeight,viewLineCount:e.viewLineCount,lineNumbersDigitCount:e.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:e.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:e.fontInfo.maxDigitWidth,pixelRatio:e.pixelRatio})}static computeContainedMinimapLineCount(e){
const t=e.height/e.lineHeight,i=e.scrollBeyondLastLine?t-1:0,n=(e.viewLineCount+i)/(e.pixelRatio*e.height);return{typicalViewportLineCount:t,extraLinesBeyondLastLine:i,desiredRatio:n,minimapLineCount:Math.floor(e.viewLineCount/n)}}static _computeMinimapLayout(e,i){const n=e.outerWidth,r=e.outerHeight,o=e.pixelRatio;if(!e.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(o*r),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:r}
;const s=i.stableMinimapLayoutInput,a=s&&e.outerHeight===s.outerHeight&&e.lineHeight===s.lineHeight&&e.typicalHalfwidthCharacterWidth===s.typicalHalfwidthCharacterWidth&&e.pixelRatio===s.pixelRatio&&e.scrollBeyondLastLine===s.scrollBeyondLastLine&&e.minimap.enabled===s.minimap.enabled&&e.minimap.side===s.minimap.side&&e.minimap.size===s.minimap.size&&e.minimap.showSlider===s.minimap.showSlider&&e.minimap.renderCharacters===s.minimap.renderCharacters&&e.minimap.maxColumn===s.minimap.maxColumn&&e.minimap.scale===s.minimap.scale&&e.verticalScrollbarWidth===s.verticalScrollbarWidth&&e.isViewportWrapping===s.isViewportWrapping,c=e.lineHeight,l=e.typicalHalfwidthCharacterWidth,u=e.scrollBeyondLastLine,d=e.minimap.renderCharacters;let h=o>=2?Math.round(2*e.minimap.scale):e.minimap.scale;const p=e.minimap.maxColumn,m=e.minimap.size,f=e.minimap.side,g=e.verticalScrollbarWidth,_=e.viewLineCount,y=e.remainingWidth,w=e.isViewportWrapping,b=d?2:3;let E=Math.floor(o*r);const x=E/o;let C=!1,S=!1,k=b*h,T=h/o,I=1
;if("fill"===m||"fit"===m){const{typicalViewportLineCount:t,extraLinesBeyondLastLine:n,desiredRatio:s,minimapLineCount:l}=v.computeContainedMinimapLineCount({viewLineCount:_,scrollBeyondLastLine:u,height:r,lineHeight:c,pixelRatio:o});if(_/l>1)C=!0,S=!0,k=1,T=(h=1)/o;else{let r=!1,l=h+1;if("fit"===m){const t=Math.ceil((_+n)*k);w&&a&&y<=i.stableFitRemainingWidth?(r=!0,l=i.stableFitMaxMinimapScale):(r=t>E,w&&r?(i.stableMinimapLayoutInput=e,i.stableFitRemainingWidth=y):(i.stableMinimapLayoutInput=null,i.stableFitRemainingWidth=0))}if("fill"===m||r){C=!0;const e=h;k=Math.min(c*o,Math.max(1,Math.floor(1/s))),(h=Math.min(l,Math.max(1,Math.floor(k/b))))>e&&(I=Math.min(2,h/e)),T=h/o/I,E=Math.ceil(Math.max(t,_+n)*k),w&&r&&(i.stableFitMaxMinimapScale=h)}}}const D=Math.floor(p*T),P=Math.min(D,Math.max(0,Math.floor((y-g-2)*T/(l+T)))+t.MINIMAP_GUTTER_WIDTH);let R=Math.floor(o*P);const A=R/o;return{renderMinimap:d?1:2,minimapLeft:"left"===f?0:n-P-g,minimapWidth:P,minimapHeightIsEditorHeight:C,minimapIsSampling:S,
minimapScale:h,minimapLineHeight:k,minimapCanvasInnerWidth:R=Math.floor(R*I),minimapCanvasInnerHeight:E,minimapCanvasOuterWidth:A,minimapCanvasOuterHeight:x}}static computeLayout(e,t){const i=0|t.outerWidth,n=0|t.outerHeight,r=0|t.lineHeight,o=0|t.lineNumbersDigitCount,a=t.typicalHalfwidthCharacterWidth,c=t.maxDigitWidth,l=t.pixelRatio,u=t.viewLineCount,h=e.get(105),p=e.get(108),m=e.get(109),f=e.get(2),g=t.isDominatedByLongLines,_=e.get(42),y=0!==e.get(52).renderType,w=e.get(53),b=e.get(86),E=e.get(56),x=e.get(84),C=x.verticalScrollbarSize,S=x.verticalHasArrows,k=x.arrowSize,T=x.horizontalScrollbarSize,I=e.get(50),D=e.get(31);let P;if("string"==typeof I&&/^\d+(\.\d+)?ch$/.test(I)){const e=parseFloat(I.substr(0,I.length-2));P=d.clampedInt(e*a,0,0,1e3)}else P=d.clampedInt(I,0,0,1e3);D&&(P+=16);let R=0;if(y){const e=Math.max(o,w);R=Math.round(e*c)}let A=0;_&&(A=r);let O=0,L=O+A,M=L+R,N=M+P;const F=i-A-R-P;let U=!1,H=!1,$=-1;2!==f&&(m&&g?(U=!0,H=!0):"on"===h||"bounded"===h?H=!0:"wordWrapColumn"===h&&($=p))
;const W=v._computeMinimapLayout({outerWidth:i,outerHeight:n,lineHeight:r,typicalHalfwidthCharacterWidth:a,pixelRatio:l,scrollBeyondLastLine:b,minimap:E,verticalScrollbarWidth:C,viewLineCount:u,remainingWidth:F,isViewportWrapping:H},t.memory||new s);0!==W.renderMinimap&&0===W.minimapLeft&&(O+=W.minimapWidth,L+=W.minimapWidth,M+=W.minimapWidth,N+=W.minimapWidth);const z=F-W.minimapWidth,B=Math.max(1,Math.floor((z-C-2)/a)),j=S?k:0;return H&&($=Math.max(1,B),"bounded"===h&&($=Math.min($,p))),{width:i,height:n,glyphMarginLeft:O,glyphMarginWidth:A,lineNumbersLeft:L,lineNumbersWidth:R,decorationsLeft:M,decorationsWidth:P,contentLeft:N,contentWidth:z,minimap:W,viewportColumn:B,isWordWrapMinified:U,isViewportWrapping:H,wrappingColumn:$,verticalScrollbarWidth:C,horizontalScrollbarHeight:T,overviewRuler:{top:j,width:C,height:n-2*j,right:0}}}}t.EditorLayoutInfoComputer=v;!function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative",e[e.Interval=3]="Interval",e[e.Custom=4]="Custom"
}(t.RenderLineNumbersType||(t.RenderLineNumbersType={}));t.filterValidationDecorations=function(e){const t=e.get(79);return"editable"===t?e.get(72):"on"!==t};function _(e,t){if("string"!=typeof e)return t;switch(e){case"hidden":return 2;case"visible":return 3;default:return 1}}!function(e){e[e.None=0]="None",e[e.Same=1]="Same",e[e.Indent=2]="Indent",e[e.DeepIndent=3]="DeepIndent"}(t.WrappingIndent||(t.WrappingIndent={}));function y(e){return t.editorOptionsRegistry[e.id]=e,e}t.EDITOR_FONT_DEFAULTS={fontFamily:n.isMacintosh?"Menlo, Monaco, 'Courier New', monospace":n.isLinux?"'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'":"Consolas, 'Courier New', monospace",fontWeight:"normal",fontSize:n.isMacintosh?12:14,lineHeight:0,letterSpacing:0},t.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0},t.editorOptionsRegistry=[],function(e){e[e.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",
e[e.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",e[e.accessibilitySupport=2]="accessibilitySupport",e[e.accessibilityPageSize=3]="accessibilityPageSize",e[e.ariaLabel=4]="ariaLabel",e[e.autoClosingBrackets=5]="autoClosingBrackets",e[e.autoClosingOvertype=6]="autoClosingOvertype",e[e.autoClosingQuotes=7]="autoClosingQuotes",e[e.autoIndent=8]="autoIndent",e[e.automaticLayout=9]="automaticLayout",e[e.autoSurround=10]="autoSurround",e[e.codeLens=11]="codeLens",e[e.colorDecorators=12]="colorDecorators",e[e.columnSelection=13]="columnSelection",e[e.comments=14]="comments",e[e.contextmenu=15]="contextmenu",e[e.copyWithSyntaxHighlighting=16]="copyWithSyntaxHighlighting",e[e.cursorBlinking=17]="cursorBlinking",e[e.cursorSmoothCaretAnimation=18]="cursorSmoothCaretAnimation",e[e.cursorStyle=19]="cursorStyle",e[e.cursorSurroundingLines=20]="cursorSurroundingLines",e[e.cursorSurroundingLinesStyle=21]="cursorSurroundingLinesStyle",e[e.cursorWidth=22]="cursorWidth",e[e.disableLayerHinting=23]="disableLayerHinting",
e[e.disableMonospaceOptimizations=24]="disableMonospaceOptimizations",e[e.dragAndDrop=25]="dragAndDrop",e[e.emptySelectionClipboard=26]="emptySelectionClipboard",e[e.extraEditorClassName=27]="extraEditorClassName",e[e.fastScrollSensitivity=28]="fastScrollSensitivity",e[e.find=29]="find",e[e.fixedOverflowWidgets=30]="fixedOverflowWidgets",e[e.folding=31]="folding",e[e.foldingStrategy=32]="foldingStrategy",e[e.foldingHighlight=33]="foldingHighlight",e[e.unfoldOnClickAfterEndOfLine=34]="unfoldOnClickAfterEndOfLine",e[e.fontFamily=35]="fontFamily",e[e.fontInfo=36]="fontInfo",e[e.fontLigatures=37]="fontLigatures",e[e.fontSize=38]="fontSize",e[e.fontWeight=39]="fontWeight",e[e.formatOnPaste=40]="formatOnPaste",e[e.formatOnType=41]="formatOnType",e[e.glyphMargin=42]="glyphMargin",e[e.gotoLocation=43]="gotoLocation",e[e.hideCursorInOverviewRuler=44]="hideCursorInOverviewRuler",e[e.highlightActiveIndentGuide=45]="highlightActiveIndentGuide",e[e.hover=46]="hover",e[e.inDiffEditor=47]="inDiffEditor",
e[e.letterSpacing=48]="letterSpacing",e[e.lightbulb=49]="lightbulb",e[e.lineDecorationsWidth=50]="lineDecorationsWidth",e[e.lineHeight=51]="lineHeight",e[e.lineNumbers=52]="lineNumbers",e[e.lineNumbersMinChars=53]="lineNumbersMinChars",e[e.links=54]="links",e[e.matchBrackets=55]="matchBrackets",e[e.minimap=56]="minimap",e[e.mouseStyle=57]="mouseStyle",e[e.mouseWheelScrollSensitivity=58]="mouseWheelScrollSensitivity",e[e.mouseWheelZoom=59]="mouseWheelZoom",e[e.multiCursorMergeOverlapping=60]="multiCursorMergeOverlapping",e[e.multiCursorModifier=61]="multiCursorModifier",e[e.multiCursorPaste=62]="multiCursorPaste",e[e.occurrencesHighlight=63]="occurrencesHighlight",e[e.overviewRulerBorder=64]="overviewRulerBorder",e[e.overviewRulerLanes=65]="overviewRulerLanes",e[e.padding=66]="padding",e[e.parameterHints=67]="parameterHints",e[e.peekWidgetDefaultFocus=68]="peekWidgetDefaultFocus",e[e.definitionLinkOpensInPeek=69]="definitionLinkOpensInPeek",e[e.quickSuggestions=70]="quickSuggestions",
e[e.quickSuggestionsDelay=71]="quickSuggestionsDelay",e[e.readOnly=72]="readOnly",e[e.renameOnType=73]="renameOnType",e[e.renderControlCharacters=74]="renderControlCharacters",e[e.renderIndentGuides=75]="renderIndentGuides",e[e.renderFinalNewline=76]="renderFinalNewline",e[e.renderLineHighlight=77]="renderLineHighlight",e[e.renderLineHighlightOnlyWhenFocus=78]="renderLineHighlightOnlyWhenFocus",e[e.renderValidationDecorations=79]="renderValidationDecorations",e[e.renderWhitespace=80]="renderWhitespace",e[e.revealHorizontalRightPadding=81]="revealHorizontalRightPadding",e[e.roundedSelection=82]="roundedSelection",e[e.rulers=83]="rulers",e[e.scrollbar=84]="scrollbar",e[e.scrollBeyondLastColumn=85]="scrollBeyondLastColumn",e[e.scrollBeyondLastLine=86]="scrollBeyondLastLine",e[e.scrollPredominantAxis=87]="scrollPredominantAxis",e[e.selectionClipboard=88]="selectionClipboard",e[e.selectionHighlight=89]="selectionHighlight",e[e.selectOnLineNumbers=90]="selectOnLineNumbers",
e[e.showFoldingControls=91]="showFoldingControls",e[e.showUnused=92]="showUnused",e[e.snippetSuggestions=93]="snippetSuggestions",e[e.smoothScrolling=94]="smoothScrolling",e[e.stopRenderingLineAfter=95]="stopRenderingLineAfter",e[e.suggest=96]="suggest",e[e.suggestFontSize=97]="suggestFontSize",e[e.suggestLineHeight=98]="suggestLineHeight",e[e.suggestOnTriggerCharacters=99]="suggestOnTriggerCharacters",e[e.suggestSelection=100]="suggestSelection",e[e.tabCompletion=101]="tabCompletion",e[e.unusualLineTerminators=102]="unusualLineTerminators",e[e.useTabStops=103]="useTabStops",e[e.wordSeparators=104]="wordSeparators",e[e.wordWrap=105]="wordWrap",e[e.wordWrapBreakAfterCharacters=106]="wordWrapBreakAfterCharacters",e[e.wordWrapBreakBeforeCharacters=107]="wordWrapBreakBeforeCharacters",e[e.wordWrapColumn=108]="wordWrapColumn",e[e.wordWrapMinified=109]="wordWrapMinified",e[e.wrappingIndent=110]="wrappingIndent",e[e.wrappingStrategy=111]="wrappingStrategy",e[e.editorClassName=112]="editorClassName",
e[e.pixelRatio=113]="pixelRatio",e[e.tabFocusMode=114]="tabFocusMode",e[e.layoutInfo=115]="layoutInfo",e[e.wrappingInfo=116]="wrappingInfo"}(t.EditorOption||(t.EditorOption={})),t.EditorOptions={acceptSuggestionOnCommitCharacter:y(new u(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:i.localize(102,null)})),acceptSuggestionOnEnter:y(new m(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",i.localize(103,null),""],markdownDescription:i.localize(104,null)})),accessibilitySupport:y(new class extends a{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[i.localize(0,null),i.localize(1,null),i.localize(2,null)],default:"auto",description:i.localize(3,null)})}validate(e){switch(e){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(e,t,i){return 0===i?e.accessibilitySupport:i}}),accessibilityPageSize:y(new d(3,"accessibilityPageSize",10,1,1073741824,{
description:i.localize(105,null)})),ariaLabel:y(new p(4,"ariaLabel",i.localize(106,null))),autoClosingBrackets:y(new m(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(107,null),i.localize(108,null),""],description:i.localize(109,null)})),autoClosingOvertype:y(new m(6,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",i.localize(110,null),""],description:i.localize(111,null)})),autoClosingQuotes:y(new m(7,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",i.localize(112,null),i.localize(113,null),""],description:i.localize(114,null)})),autoIndent:y(new f(8,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],(function(e){switch(e){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}),{
enumDescriptions:[i.localize(115,null),i.localize(116,null),i.localize(117,null),i.localize(118,null),i.localize(119,null)],description:i.localize(120,null)})),automaticLayout:y(new u(9,"automaticLayout",!1)),autoSurround:y(new m(10,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[i.localize(121,null),i.localize(122,null),i.localize(123,null),""],description:i.localize(124,null)})),codeLens:y(new u(11,"codeLens",!0,{description:i.localize(125,null)})),colorDecorators:y(new u(12,"colorDecorators",!0,{description:i.localize(126,null)})),columnSelection:y(new u(13,"columnSelection",!1,{description:i.localize(127,null)})),comments:y(new class extends a{constructor(){const e={insertSpace:!0};super(14,"comments",e,{"editor.comments.insertSpace":{type:"boolean",default:e.insertSpace,description:i.localize(4,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{insertSpace:u.boolean(t.insertSpace,this.defaultValue.insertSpace)}}}),
contextmenu:y(new u(15,"contextmenu",!0)),copyWithSyntaxHighlighting:y(new u(16,"copyWithSyntaxHighlighting",!0,{description:i.localize(128,null)})),cursorBlinking:y(new f(17,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],(function(e){switch(e){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}),{description:i.localize(129,null)})),cursorSmoothCaretAnimation:y(new u(18,"cursorSmoothCaretAnimation",!1,{description:i.localize(130,null)})),cursorStyle:y(new f(19,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],(function(e){switch(e){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}),{description:i.localize(131,null)})),cursorSurroundingLines:y(new d(20,"cursorSurroundingLines",0,0,1073741824,{
description:i.localize(132,null)})),cursorSurroundingLinesStyle:y(new m(21,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[i.localize(133,null),i.localize(134,null)],description:i.localize(135,null)})),cursorWidth:y(new d(22,"cursorWidth",0,0,1073741824,{markdownDescription:i.localize(136,null)})),disableLayerHinting:y(new u(23,"disableLayerHinting",!1)),disableMonospaceOptimizations:y(new u(24,"disableMonospaceOptimizations",!1)),dragAndDrop:y(new u(25,"dragAndDrop",!0,{description:i.localize(137,null)})),emptySelectionClipboard:y(new class extends u{constructor(){super(26,"emptySelectionClipboard",!0,{description:i.localize(5,null)})}compute(e,t,i){return i&&e.emptySelectionClipboard}}),extraEditorClassName:y(new p(27,"extraEditorClassName","")),fastScrollSensitivity:y(new h(28,"fastScrollSensitivity",5,e=>e<=0?5:e,{markdownDescription:i.localize(138,null)})),find:y(new class extends a{constructor(){const e={seedSearchStringFromSelection:!0,autoFindInSelection:"never",
globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(29,"find",e,{"editor.find.seedSearchStringFromSelection":{type:"boolean",default:e.seedSearchStringFromSelection,description:i.localize(6,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:e.autoFindInSelection,enumDescriptions:[i.localize(7,null),i.localize(8,null),i.localize(9,null)],description:i.localize(10,null)},"editor.find.globalFindClipboard":{type:"boolean",default:e.globalFindClipboard,description:i.localize(11,null),included:n.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:e.addExtraSpaceOnTop,description:i.localize(12,null)},"editor.find.loop":{type:"boolean",default:e.loop,description:i.localize(13,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{seedSearchStringFromSelection:u.boolean(t.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection),
autoFindInSelection:"boolean"==typeof e.autoFindInSelection?e.autoFindInSelection?"always":"never":m.stringSet(t.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u.boolean(t.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u.boolean(t.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u.boolean(t.loop,this.defaultValue.loop)}}}),fixedOverflowWidgets:y(new u(30,"fixedOverflowWidgets",!1)),folding:y(new u(31,"folding",!0,{description:i.localize(139,null)})),foldingStrategy:y(new m(32,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[i.localize(140,null),i.localize(141,null)],description:i.localize(142,null)})),foldingHighlight:y(new u(33,"foldingHighlight",!0,{description:i.localize(143,null)})),unfoldOnClickAfterEndOfLine:y(new u(34,"unfoldOnClickAfterEndOfLine",!1,{description:i.localize(144,null)})),fontFamily:y(new p(35,"fontFamily",t.EDITOR_FONT_DEFAULTS.fontFamily,{
description:i.localize(145,null)})),fontInfo:y(new class extends c{constructor(){super(36)}compute(e,t,i){return e.fontInfo}}),fontLigatures2:y(new g),fontSize:y(new class extends l{constructor(){super(38,"fontSize",t.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:t.EDITOR_FONT_DEFAULTS.fontSize,description:i.localize(17,null)})}validate(e){let i=h.float(e,this.defaultValue);return 0===i?t.EDITOR_FONT_DEFAULTS.fontSize:h.clamp(i,6,100)}compute(e,t,i){return e.fontInfo.fontSize}}),fontWeight:y(new p(39,"fontWeight",t.EDITOR_FONT_DEFAULTS.fontWeight,{enum:["normal","bold","100","200","300","400","500","600","700","800","900"],description:i.localize(146,null)})),formatOnPaste:y(new u(40,"formatOnPaste",!1,{description:i.localize(147,null)})),formatOnType:y(new u(41,"formatOnType",!1,{description:i.localize(148,null)})),glyphMargin:y(new u(42,"glyphMargin",!0,{description:i.localize(149,null)})),gotoLocation:y(new class extends a{constructor(){const e={multiple:"peek",
multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},t={type:"string",enum:["peek","gotoAndPeek","goto"],default:e.multiple,enumDescriptions:[i.localize(18,null),i.localize(19,null),i.localize(20,null)]};super(43,"gotoLocation",e,{"editor.gotoLocation.multiple":{deprecationMessage:i.localize(21,null)},"editor.gotoLocation.multipleDefinitions":Object.assign({description:i.localize(22,null)},t),"editor.gotoLocation.multipleTypeDefinitions":Object.assign({description:i.localize(23,null)},t),"editor.gotoLocation.multipleDeclarations":Object.assign({description:i.localize(24,null)},t),"editor.gotoLocation.multipleImplementations":Object.assign({description:i.localize(25,null)
},t),"editor.gotoLocation.multipleReferences":Object.assign({description:i.localize(26,null)},t),"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:e.alternativeDefinitionCommand,description:i.localize(27,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:e.alternativeTypeDefinitionCommand,description:i.localize(28,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:e.alternativeDeclarationCommand,description:i.localize(29,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:e.alternativeImplementationCommand,description:i.localize(30,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:e.alternativeReferenceCommand,description:i.localize(31,null)}})}validate(e){var t,i,n,r,o;if(!e||"object"!=typeof e)return this.defaultValue;const s=e;return{multiple:m.stringSet(s.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),
multipleDefinitions:null!==(t=s.multipleDefinitions)&&void 0!==t?t:m.stringSet(s.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:null!==(i=s.multipleTypeDefinitions)&&void 0!==i?i:m.stringSet(s.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:null!==(n=s.multipleDeclarations)&&void 0!==n?n:m.stringSet(s.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:null!==(r=s.multipleImplementations)&&void 0!==r?r:m.stringSet(s.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:null!==(o=s.multipleReferences)&&void 0!==o?o:m.stringSet(s.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:p.string(s.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:p.string(s.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),
alternativeDeclarationCommand:p.string(s.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:p.string(s.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:p.string(s.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}),hideCursorInOverviewRuler:y(new u(44,"hideCursorInOverviewRuler",!1,{description:i.localize(150,null)})),highlightActiveIndentGuide:y(new u(45,"highlightActiveIndentGuide",!0,{description:i.localize(151,null)})),hover:y(new class extends a{constructor(){const e={enabled:!0,delay:300,sticky:!0};super(46,"hover",e,{"editor.hover.enabled":{type:"boolean",default:e.enabled,description:i.localize(32,null)},"editor.hover.delay":{type:"number",default:e.delay,description:i.localize(33,null)},"editor.hover.sticky":{type:"boolean",default:e.sticky,description:i.localize(34,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e
;return{enabled:u.boolean(t.enabled,this.defaultValue.enabled),delay:d.clampedInt(t.delay,this.defaultValue.delay,0,1e4),sticky:u.boolean(t.sticky,this.defaultValue.sticky)}}}),inDiffEditor:y(new u(47,"inDiffEditor",!1)),letterSpacing:y(new h(48,"letterSpacing",t.EDITOR_FONT_DEFAULTS.letterSpacing,e=>h.clamp(e,-5,20),{description:i.localize(152,null)})),lightbulb:y(new class extends a{constructor(){const e={enabled:!0};super(49,"lightbulb",e,{"editor.lightbulb.enabled":{type:"boolean",default:e.enabled,description:i.localize(35,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:u.boolean(t.enabled,this.defaultValue.enabled)}}}),lineDecorationsWidth:y(new l(50,"lineDecorationsWidth",10)),lineHeight:y(new class extends d{constructor(){super(51,"lineHeight",t.EDITOR_FONT_DEFAULTS.lineHeight,0,150,{description:i.localize(36,null)})}compute(e,t,i){return e.fontInfo.lineHeight}}),lineNumbers:y(new class extends a{constructor(){super(52,"lineNumbers",{renderType:1,
renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[i.localize(55,null),i.localize(56,null),i.localize(57,null),i.localize(58,null)],default:"on",description:i.localize(59,null)})}validate(e){let t=this.defaultValue.renderType,i=this.defaultValue.renderFn;return void 0!==e&&("function"==typeof e?(t=4,i=e):t="interval"===e?3:"relative"===e?2:"on"===e?1:0),{renderType:t,renderFn:i}}}),lineNumbersMinChars:y(new d(53,"lineNumbersMinChars",5,1,300)),links:y(new u(54,"links",!0,{description:i.localize(153,null)})),matchBrackets:y(new m(55,"matchBrackets","always",["always","near","never"],{description:i.localize(154,null)})),minimap:y(new class extends a{constructor(){const e={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(56,"minimap",e,{"editor.minimap.enabled":{type:"boolean",default:e.enabled,description:i.localize(37,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],
enumDescriptions:[i.localize(38,null),i.localize(39,null),i.localize(40,null)],default:e.size,description:i.localize(41,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:e.side,description:i.localize(42,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:e.showSlider,description:i.localize(43,null)},"editor.minimap.scale":{type:"number",default:e.scale,minimum:1,maximum:3,enum:[1,2,3],description:i.localize(44,null)},"editor.minimap.renderCharacters":{type:"boolean",default:e.renderCharacters,description:i.localize(45,null)},"editor.minimap.maxColumn":{type:"number",default:e.maxColumn,description:i.localize(46,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:u.boolean(t.enabled,this.defaultValue.enabled),size:m.stringSet(t.size,this.defaultValue.size,["proportional","fill","fit"]),side:m.stringSet(t.side,this.defaultValue.side,["right","left"]),
showSlider:m.stringSet(t.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u.boolean(t.renderCharacters,this.defaultValue.renderCharacters),scale:d.clampedInt(t.scale,1,1,3),maxColumn:d.clampedInt(t.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}),mouseStyle:y(new m(57,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:y(new h(58,"mouseWheelScrollSensitivity",1,e=>0===e?1:e,{markdownDescription:i.localize(155,null)})),mouseWheelZoom:y(new u(59,"mouseWheelZoom",!1,{markdownDescription:i.localize(156,null)})),multiCursorMergeOverlapping:y(new u(60,"multiCursorMergeOverlapping",!0,{description:i.localize(157,null)})),multiCursorModifier:y(new f(61,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],(function(e){return"ctrlCmd"===e?n.isMacintosh?"metaKey":"ctrlKey":"altKey"}),{markdownEnumDescriptions:[i.localize(158,null),i.localize(159,null)],markdownDescription:i.localize(160,null)})),
multiCursorPaste:y(new m(62,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[i.localize(161,null),i.localize(162,null)],markdownDescription:i.localize(163,null)})),occurrencesHighlight:y(new u(63,"occurrencesHighlight",!0,{description:i.localize(164,null)})),overviewRulerBorder:y(new u(64,"overviewRulerBorder",!0,{description:i.localize(165,null)})),overviewRulerLanes:y(new d(65,"overviewRulerLanes",3,0,3)),padding:y(new class extends a{constructor(){super(66,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(47,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:i.localize(48,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{top:d.clampedInt(t.top,0,0,1e3),bottom:d.clampedInt(t.bottom,0,0,1e3)}}}),parameterHints:y(new class extends a{constructor(){const e={enabled:!0,cycle:!1};super(67,"parameterHints",e,{"editor.parameterHints.enabled":{
type:"boolean",default:e.enabled,description:i.localize(49,null)},"editor.parameterHints.cycle":{type:"boolean",default:e.cycle,description:i.localize(50,null)}})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e;return{enabled:u.boolean(t.enabled,this.defaultValue.enabled),cycle:u.boolean(t.cycle,this.defaultValue.cycle)}}}),peekWidgetDefaultFocus:y(new m(68,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[i.localize(166,null),i.localize(167,null)],description:i.localize(168,null)})),definitionLinkOpensInPeek:y(new u(69,"definitionLinkOpensInPeek",!1,{description:i.localize(169,null)})),quickSuggestions:y(new class extends a{constructor(){const e={other:!0,comments:!1,strings:!1};super(70,"quickSuggestions",e,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:e.strings,description:i.localize(51,null)},comments:{type:"boolean",default:e.comments,description:i.localize(52,null)},other:{type:"boolean",default:e.other,
description:i.localize(53,null)}}}],default:e,description:i.localize(54,null)}),this.defaultValue=e}validate(e){if("boolean"==typeof e)return e;if(e&&"object"==typeof e){const t=e,i={other:u.boolean(t.other,this.defaultValue.other),comments:u.boolean(t.comments,this.defaultValue.comments),strings:u.boolean(t.strings,this.defaultValue.strings)};return!!(i.other&&i.comments&&i.strings)||!!(i.other||i.comments||i.strings)&&i}return this.defaultValue}}),quickSuggestionsDelay:y(new d(71,"quickSuggestionsDelay",10,0,1073741824,{description:i.localize(170,null)})),readOnly:y(new u(72,"readOnly",!1)),renameOnType:y(new u(73,"renameOnType",!1,{description:i.localize(171,null)})),renderControlCharacters:y(new u(74,"renderControlCharacters",!1,{description:i.localize(172,null)})),renderIndentGuides:y(new u(75,"renderIndentGuides",!0,{description:i.localize(173,null)})),renderFinalNewline:y(new u(76,"renderFinalNewline",!0,{description:i.localize(174,null)})),
renderLineHighlight:y(new m(77,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",i.localize(175,null)],description:i.localize(176,null)})),renderLineHighlightOnlyWhenFocus:y(new u(78,"renderLineHighlightOnlyWhenFocus",!1,{description:i.localize(177,null)})),renderValidationDecorations:y(new m(79,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:y(new m(80,"renderWhitespace","selection",["none","boundary","selection","all"],{enumDescriptions:["",i.localize(178,null),i.localize(179,null),""],description:i.localize(180,null)})),revealHorizontalRightPadding:y(new d(81,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:y(new u(82,"roundedSelection",!0,{description:i.localize(181,null)})),rulers:y(new class extends a{constructor(){const e=[],t={type:"number",description:i.localize(60,null)};super(83,"rulers",e,{type:"array",items:{anyOf:[t,{type:["object"],properties:{column:t,color:{type:"string",description:i.localize(61,null),
format:"color-hex"}}}]},default:e,description:i.localize(62,null)})}validate(e){if(Array.isArray(e)){let t=[];for(let i of e)if("number"==typeof i)t.push({column:d.clampedInt(i,0,0,1e4),color:null});else if(i&&"object"==typeof i){const e=i;t.push({column:d.clampedInt(e.column,0,0,1e4),color:e.color})}return t.sort((e,t)=>e.column-t.column),t}return this.defaultValue}}),scrollbar:y(new class extends a{constructor(){super(84,"scrollbar",{vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0})}validate(e){if(!e||"object"!=typeof e)return this.defaultValue;const t=e,i=d.clampedInt(t.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),n=d.clampedInt(t.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:d.clampedInt(t.arrowSize,this.defaultValue.arrowSize,0,1e3),
vertical:_(t.vertical,this.defaultValue.vertical),horizontal:_(t.horizontal,this.defaultValue.horizontal),useShadows:u.boolean(t.useShadows,this.defaultValue.useShadows),verticalHasArrows:u.boolean(t.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u.boolean(t.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u.boolean(t.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u.boolean(t.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:i,horizontalSliderSize:d.clampedInt(t.horizontalSliderSize,i,0,1e3),verticalScrollbarSize:n,verticalSliderSize:d.clampedInt(t.verticalSliderSize,n,0,1e3)}}}),scrollBeyondLastColumn:y(new d(85,"scrollBeyondLastColumn",5,0,1073741824,{description:i.localize(182,null)})),scrollBeyondLastLine:y(new u(86,"scrollBeyondLastLine",!0,{description:i.localize(183,null)})),scrollPredominantAxis:y(new u(87,"scrollPredominantAxis",!0,{description:i.localize(184,null)})),
selectionClipboard:y(new u(88,"selectionClipboard",!0,{description:i.localize(185,null),included:n.isLinux})),selectionHighlight:y(new u(89,"selectionHighlight",!0,{description:i.localize(186,null)})),selectOnLineNumbers:y(new u(90,"selectOnLineNumbers",!0)),showFoldingControls:y(new m(91,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[i.localize(187,null),i.localize(188,null)],description:i.localize(189,null)})),showUnused:y(new u(92,"showUnused",!0,{description:i.localize(190,null)})),snippetSuggestions:y(new m(93,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[i.localize(191,null),i.localize(192,null),i.localize(193,null),i.localize(194,null)],description:i.localize(195,null)})),smoothScrolling:y(new u(94,"smoothScrolling",!1,{description:i.localize(196,null)})),stopRenderingLineAfter:y(new d(95,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:y(new class extends a{constructor(){const e={insertMode:"insert",filterGraceful:!0,
snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,maxVisibleSuggestions:12,showMethods:!0,showFunctions:!0,showConstructors:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0,statusBar:{visible:!1}};super(96,"suggest",e,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[i.localize(63,null),i.localize(64,null)],default:e.insertMode,description:i.localize(65,null)},"editor.suggest.filterGraceful":{type:"boolean",default:e.filterGraceful,description:i.localize(66,null)},"editor.suggest.localityBonus":{type:"boolean",default:e.localityBonus,description:i.localize(67,null)},"editor.suggest.shareSuggestSelections":{
type:"boolean",default:e.shareSuggestSelections,markdownDescription:i.localize(68,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:e.snippetsPreventQuickSuggestions,description:i.localize(69,null)},"editor.suggest.showIcons":{type:"boolean",default:e.showIcons,description:i.localize(70,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",default:e.maxVisibleSuggestions,minimum:1,maximum:15,description:i.localize(71,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:i.localize(72,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:i.localize(73,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:i.localize(74,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:i.localize(75,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:i.localize(76,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,
markdownDescription:i.localize(77,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:i.localize(78,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:i.localize(79,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:i.localize(80,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:i.localize(81,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:i.localize(82,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:i.localize(83,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:i.localize(84,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:i.localize(85,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:i.localize(86,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:i.localize(87,null)},
"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:i.localize(88,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:i.localize(89,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:i.localize(90,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:i.localize(91,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:i.localize(92,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:i.localize(93,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:i.localize(94,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:i.localize(95,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:i.localize(96,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:i.localize(97,null)},"editor.suggest.showSnippets":{
type:"boolean",default:!0,markdownDescription:i.localize(98,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:i.localize(99,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:i.localize(100,null)},"editor.suggest.statusBar.visible":{type:"boolean",default:!1,markdownDescription:i.localize(101,null)}})}validate(e){var t;if(!e||"object"!=typeof e)return this.defaultValue;const i=e;return{insertMode:m.stringSet(i.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u.boolean(i.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u.boolean(i.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u.boolean(i.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u.boolean(i.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:u.boolean(i.showIcons,this.defaultValue.showIcons),
maxVisibleSuggestions:d.clampedInt(i.maxVisibleSuggestions,this.defaultValue.maxVisibleSuggestions,1,15),showMethods:u.boolean(i.showMethods,this.defaultValue.showMethods),showFunctions:u.boolean(i.showFunctions,this.defaultValue.showFunctions),showConstructors:u.boolean(i.showConstructors,this.defaultValue.showConstructors),showFields:u.boolean(i.showFields,this.defaultValue.showFields),showVariables:u.boolean(i.showVariables,this.defaultValue.showVariables),showClasses:u.boolean(i.showClasses,this.defaultValue.showClasses),showStructs:u.boolean(i.showStructs,this.defaultValue.showStructs),showInterfaces:u.boolean(i.showInterfaces,this.defaultValue.showInterfaces),showModules:u.boolean(i.showModules,this.defaultValue.showModules),showProperties:u.boolean(i.showProperties,this.defaultValue.showProperties),showEvents:u.boolean(i.showEvents,this.defaultValue.showEvents),showOperators:u.boolean(i.showOperators,this.defaultValue.showOperators),showUnits:u.boolean(i.showUnits,this.defaultValue.showUnits),
showValues:u.boolean(i.showValues,this.defaultValue.showValues),showConstants:u.boolean(i.showConstants,this.defaultValue.showConstants),showEnums:u.boolean(i.showEnums,this.defaultValue.showEnums),showEnumMembers:u.boolean(i.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u.boolean(i.showKeywords,this.defaultValue.showKeywords),showWords:u.boolean(i.showWords,this.defaultValue.showWords),showColors:u.boolean(i.showColors,this.defaultValue.showColors),showFiles:u.boolean(i.showFiles,this.defaultValue.showFiles),showReferences:u.boolean(i.showReferences,this.defaultValue.showReferences),showFolders:u.boolean(i.showFolders,this.defaultValue.showFolders),showTypeParameters:u.boolean(i.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u.boolean(i.showSnippets,this.defaultValue.showSnippets),showUsers:u.boolean(i.showUsers,this.defaultValue.showUsers),showIssues:u.boolean(i.showIssues,this.defaultValue.showIssues),statusBar:{
visible:u.boolean(null===(t=i.statusBar)||void 0===t?void 0:t.visible,!!this.defaultValue.statusBar.visible)}}}}),suggestFontSize:y(new d(97,"suggestFontSize",0,0,1e3,{markdownDescription:i.localize(197,null)})),suggestLineHeight:y(new d(98,"suggestLineHeight",0,0,1e3,{markdownDescription:i.localize(198,null)})),suggestOnTriggerCharacters:y(new u(99,"suggestOnTriggerCharacters",!0,{description:i.localize(199,null)})),suggestSelection:y(new m(100,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[i.localize(200,null),i.localize(201,null),i.localize(202,null)],description:i.localize(203,null)})),tabCompletion:y(new m(101,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[i.localize(204,null),i.localize(205,null),i.localize(206,null)],description:i.localize(207,null)})),unusualLineTerminators:y(new m(102,"unusualLineTerminators","prompt",["off","prompt","auto"],{
enumDescriptions:[i.localize(208,null),i.localize(209,null),i.localize(210,null)],description:i.localize(211,null)})),useTabStops:y(new u(103,"useTabStops",!0,{description:i.localize(212,null)})),wordSeparators:y(new p(104,"wordSeparators",r.USUAL_WORD_SEPARATORS,{description:i.localize(213,null)})),wordWrap:y(new m(105,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[i.localize(214,null),i.localize(215,null),i.localize(216,null),i.localize(217,null)],description:i.localize(218,null)})),wordWrapBreakAfterCharacters:y(new p(106,"wordWrapBreakAfterCharacters"," \t})]?|/&.,;¢°′″‰℃、。｡､￠，．：；？！％・･ゝゞヽヾーァィゥェォッャュョヮヵヶぁぃぅぇぉっゃゅょゎゕゖㇰㇱㇲㇳㇴㇵㇶㇷㇸㇹㇺㇻㇼㇽㇾㇿ々〻ｧｨｩｪｫｬｭｮｯｰ”〉》」』】〕）］｝｣")),wordWrapBreakBeforeCharacters:y(new p(107,"wordWrapBreakBeforeCharacters","([{‘“〈《「『【〔（［｛｢£¥＄￡￥+＋")),wordWrapColumn:y(new d(108,"wordWrapColumn",80,1,1073741824,{markdownDescription:i.localize(219,null)})),wordWrapMinified:y(new u(109,"wordWrapMinified",!0)),
wrappingIndent:y(new f(110,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],(function(e){switch(e){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}),{enumDescriptions:[i.localize(220,null),i.localize(221,null),i.localize(222,null),i.localize(223,null)],description:i.localize(224,null)})),wrappingStrategy:y(new m(111,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[i.localize(225,null),i.localize(226,null)],description:i.localize(227,null)})),editorClassName:y(new class extends c{constructor(){super(112,[57,27])}compute(e,t,i){let n="monaco-editor";return t.get(27)&&(n+=" "+t.get(27)),e.extraEditorClassName&&(n+=" "+e.extraEditorClassName),"default"===t.get(57)?n+=" mouse-default":"copy"===t.get(57)&&(n+=" mouse-copy"),t.get(92)&&(n+=" showUnused"),n}}),pixelRatio:y(new class extends c{constructor(){super(113)}compute(e,t,i){return e.pixelRatio}}),tabFocusMode:y(new class extends c{constructor(){super(114,[72])}compute(e,t,i){
return!!t.get(72)||e.tabFocusMode}}),layoutInfo:y(new v),wrappingInfo:y(new class extends c{constructor(){super(116,[115])}compute(e,t,i){const n=t.get(115);return{isDominatedByLongLines:e.isDominatedByLongLines,isWordWrapMinified:n.isWordWrapMinified,isViewportWrapping:n.isViewportWrapping,wrappingColumn:n.wrappingColumn}}})}})),define(t[127],i([15,17]),(function(e,t){return e.create("vs/platform/configuration/common/configurationRegistry",t)})),define(t[132],i([15,17]),(function(e,t){return e.create("vs/platform/extensionManagement/common/extensionManagement",t)})),define(t[134],i([15,17]),(function(e,t){return e.create("vs/platform/files/common/files",t)})),define(t[135],i([15,17]),(function(e,t){return e.create("vs/platform/markers/common/markers",t)})),define(t[137],i([15,17]),(function(e,t){return e.create("vs/platform/workspaces/common/workspaces",t)})),define(t[138],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHost.api.impl",t)})),define(t[139],i([15,17]),(function(e,t){
return e.create("vs/workbench/api/common/extHostDiagnostics",t)})),define(t[140],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostExtensionActivator",t)})),define(t[142],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostExtensionService",t)})),define(t[149],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostProgress",t)})),define(t[153],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostStatusBar",t)})),define(t[159],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostTreeViews",t)})),define(t[168],i([15,17]),(function(e,t){return e.create("vs/workbench/api/common/extHostWorkspace",t)})),define(t[169],i([15,17]),(function(e,t){return e.create("vs/workbench/api/node/extHostDebugService",t)})),define(t[174],i([15,17]),(function(e,t){return e.create("vs/workbench/contrib/debug/node/debugAdapter",t)})),define(t[180],i([15,17]),(function(e,t){
return e.create("vs/workbench/contrib/externalTerminal/node/externalTerminalService",t)})),define(t[183],i([15,17]),(function(e,t){return e.create("vs/workbench/contrib/terminal/common/terminal",t)})),define(t[188],i([15,17]),(function(e,t){return e.create("vs/workbench/services/configurationResolver/common/variableResolver",t)})),define(t[28],i([1,0,8]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.isIExtensionIdentifier=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},function(e){e[e.System=0]="System",e[e.User=1]="User"}(t.ExtensionType||(t.ExtensionType={}));t.ExtensionIdentifier=class{constructor(e){this.value=e,
this._lower=e.toLowerCase()}static equals(e,t){if(null==e)return null==t;if(null==t)return!1;if("string"==typeof e||"string"==typeof t){let n="string"==typeof e?e:e.value,r="string"==typeof t?t:t.value;return i.equalsIgnoreCase(n,r)}return e._lower===t._lower}static toKey(e){return"string"==typeof e?e.toLowerCase():e._lower}},t.isLanguagePackExtension=function(e){return!(!e.contributes||!e.contributes.localizations)&&e.contributes.localizations.length>0}})),define(t[190],i([1,0,8,28]),(function(e,t,i,n){"use strict";function r(e,t){return e.uuid&&t.uuid?e.uuid===t.uuid:e.id===t.id||0===i.compareIgnoreCase(e.id,t.id)}Object.defineProperty(t,"__esModule",{value:!0}),t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0,t.areSameExtensions=r;class o{constructor(e,t){this.identifier=e,this.version=t}key(){
return`${this.identifier.id}-${this.version}`}equals(e){return e instanceof o&&(r(this.identifier,e.identifier)&&this.version===e.version)}}t.ExtensionIdentifierWithVersion=o,t.adoptToGalleryExtensionId=function(e){return e.toLocaleLowerCase()},t.getGalleryExtensionId=function(e,t){return`${e.toLocaleLowerCase()}.${t.toLocaleLowerCase()}`},t.groupByExtension=function(e,t){const i=[],n=e=>{for(const n of i)if(n.some(i=>r(t(i),t(e))))return n;return null};for(const t of e){const e=n(t);e?e.push(t):i.push([t])}return i},t.getLocalExtensionTelemetryData=function(e){return{id:e.identifier.id,name:e.manifest.name,galleryId:null,publisherId:e.publisherId,publisherName:e.manifest.publisher,publisherDisplayName:e.publisherDisplayName,dependencies:e.manifest.extensionDependencies&&e.manifest.extensionDependencies.length>0}},t.getGalleryExtensionTelemetryData=function(e){return Object.assign({id:e.identifier.id,name:e.name,galleryId:e.identifier.uuid,publisherId:e.publisherId,publisherName:e.publisher,
publisherDisplayName:e.publisherDisplayName,dependencies:!!(e.properties.dependencies&&e.properties.dependencies.length>0)},e.telemetryData)},t.BetterMergeId=new n.ExtensionIdentifier("pprice.better-merge"),t.getMaliciousExtensionsSet=function(e){const t=new Set;for(const i of e)i.malicious&&t.add(i.id.id);return t}})),define(t[101],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createSyncDescriptor=t.SyncDescriptor=void 0;class i{constructor(e,t=[],i=!1){this.ctor=e,this.staticArguments=t,this.supportsDelayedInstantiation=i}}t.SyncDescriptor=i,t.createSyncDescriptor=(e,...t)=>new i(e,t)})),define(t[74],i([1,0,101]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const n=[];t.registerSingleton=function(e,t,r){n.push([e,new i.SyncDescriptor(t,[],r)])},t.getSingletonServiceDescriptors=function(){return n}})),define(t[208],i([1,0]),(function(e,t){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class i{constructor(e){this.incoming=new Map,this.outgoing=new Map,this.data=e}}t.Node=i;t.Graph=class{constructor(e){this._hashFn=e,this._nodes=new Map}roots(){const e=[];for(let t of this._nodes.values())0===t.outgoing.size&&e.push(t);return e}insertEdge(e,t){const i=this.lookupOrInsertNode(e),n=this.lookupOrInsertNode(t);i.outgoing.set(this._hashFn(t),n),n.incoming.set(this._hashFn(e),i)}removeNode(e){const t=this._hashFn(e);this._nodes.delete(t);for(let e of this._nodes.values())e.outgoing.delete(t),e.incoming.delete(t)}lookupOrInsertNode(e){const t=this._hashFn(e);let n=this._nodes.get(t);return n||(n=new i(e),this._nodes.set(t,n)),n}lookup(e){return this._nodes.get(this._hashFn(e))}isEmpty(){return 0===this._nodes.size}toString(){let e=[];for(let[t,i]of this._nodes)e.push(`${t}, (incoming)[${[...i.incoming.keys()].join(", ")}], (outgoing)[${[...i.outgoing.keys()].join(",")}]`);return e.join("\n")}}})),
define(t[4],i([1,0]),(function(e,t){"use strict";var i;function n(e,t,n,r){t[i.DI_TARGET]===t?t[i.DI_DEPENDENCIES].push({id:e,index:n,optional:r}):(t[i.DI_DEPENDENCIES]=[{id:e,index:n,optional:r}],t[i.DI_TARGET]=t)}function r(e){if(i.serviceIds.has(e))return i.serviceIds.get(e);const t=function(e,i,r){if(3!==arguments.length)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(t,e,r,!1)};return t.toString=()=>e,i.serviceIds.set(e,t),t}Object.defineProperty(t,"__esModule",{value:!0}),t.optional=t.createDecorator=t.IInstantiationService=t._util=void 0,function(e){e.serviceIds=new Map,e.DI_TARGET="$di$target",e.DI_DEPENDENCIES="$di$dependencies",e.getServiceDependencies=function(t){return t[e.DI_DEPENDENCIES]||[]}}(i=t._util||(t._util={})),t.IInstantiationService=r("instantiationService"),t.createDecorator=r,t.optional=function(e){return function(t,i,r){if(3!==arguments.length)throw new Error("@optional-decorator can only be used to decorate a parameter");n(e,t,r,!0)}}})),
define(t[231],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IModeService=void 0,t.IModeService=i.createDecorator("modeService")})),define(t[233],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.shouldSynchronizeModel=t.IModelService=void 0,t.IModelService=i.createDecorator("modelService"),t.shouldSynchronizeModel=function(e){return!e.isTooLargeForSyncing()&&!e.isForSimpleWidget}})),define(t[239],i([1,0,3,6,70,233]),(function(e,t,i,n,r,o){"use strict";function s(e){return"string"!=typeof e&&(Array.isArray(e)?e.every(s):!!e.exclusive)}Object.defineProperty(t,"__esModule",{value:!0}),t.LanguageFeatureRegistry=void 0;class a{constructor(){this._clock=0,this._entries=[],this._onDidChange=new i.Emitter}get onDidChange(){return this._onDidChange.event}register(e,t){let i={selector:e,provider:t,_score:-1,_time:this._clock++};return this._entries.push(i),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),
n.toDisposable(()=>{if(i){let e=this._entries.indexOf(i);e>=0&&(this._entries.splice(e,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),i=void 0)}})}has(e){return this.all(e).length>0}all(e){if(!e)return[];this._updateScores(e);const t=[];for(let e of this._entries)e._score>0&&t.push(e.provider);return t}ordered(e){const t=[];return this._orderedForEach(e,e=>t.push(e.provider)),t}orderedGroups(e){const t=[];let i,n;return this._orderedForEach(e,e=>{i&&n===e._score?i.push(e.provider):(n=e._score,i=[e.provider],t.push(i))}),t}_orderedForEach(e,t){if(e){this._updateScores(e);for(const e of this._entries)e._score>0&&t(e)}}_updateScores(e){let t={uri:e.uri.toString(),language:e.getLanguageIdentifier().language};if(!this._lastCandidate||this._lastCandidate.language!==t.language||this._lastCandidate.uri!==t.uri){this._lastCandidate=t;for(let t of this._entries)if(t._score=r.score(t.selector,e.uri,e.getLanguageIdentifier().language,o.shouldSynchronizeModel(e)),s(t.selector)&&t._score>0){
for(let e of this._entries)e._score=0;t._score=1e3;break}this._entries.sort(a._compareByScoreAndTime)}}static _compareByScoreAndTime(e,t){return e._score<t._score?1:e._score>t._score?-1:e._time<t._time?1:e._time>t._time?-1:0}}t.LanguageFeatureRegistry=a})),define(t[72],i([1,0,12,2,47,239,240,78]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.TokenizationRegistry=t.DocumentRangeSemanticTokensProviderRegistry=t.DocumentSemanticTokensProviderRegistry=t.FoldingRangeProviderRegistry=t.SelectionRangeRegistry=t.ColorProviderRegistry=t.LinkProviderRegistry=t.OnTypeFormattingEditProviderRegistry=t.DocumentRangeFormattingEditProviderRegistry=t.DocumentFormattingEditProviderRegistry=t.CodeActionProviderRegistry=t.CodeLensProviderRegistry=t.TypeDefinitionProviderRegistry=t.ImplementationProviderRegistry=t.DeclarationProviderRegistry=t.DefinitionProviderRegistry=t.OnTypeRenameProviderRegistry=t.DocumentHighlightProviderRegistry=t.DocumentSymbolProviderRegistry=t.EvaluatableExpressionProviderRegistry=t.HoverProviderRegistry=t.SignatureHelpProviderRegistry=t.CompletionProviderRegistry=t.RenameProviderRegistry=t.ReferenceProviderRegistry=t.CommentMode=t.CommentThreadCollapsibleState=t.WorkspaceTextEdit=t.WorkspaceFileEdit=t.FoldingRangeKind=t.SymbolKinds=t.SymbolTag=t.SymbolKind=t.isLocationLink=t.DocumentHighlightKind=t.SignatureHelpTriggerKind=t.CodeActionTriggerType=t.CompletionTriggerKind=t.CompletionItemInsertTextRule=t.CompletionItemTag=t.completionKindFromString=t.completionKindToCssClass=t.CompletionItemKind=t.TokenMetadata=t.MetadataConsts=t.StandardTokenType=t.ColorId=t.FontStyle=t.LanguageIdentifier=t.LanguageId=void 0,
function(e){e[e.Null=0]="Null",e[e.PlainText=1]="PlainText"}(t.LanguageId||(t.LanguageId={}));t.LanguageIdentifier=class{constructor(e,t){this.language=e,this.id=t}},function(e){e[e.NotSet=-1]="NotSet",e[e.None=0]="None",e[e.Italic=1]="Italic",e[e.Bold=2]="Bold",e[e.Underline=4]="Underline"}(t.FontStyle||(t.FontStyle={})),function(e){e[e.None=0]="None",e[e.DefaultForeground=1]="DefaultForeground",e[e.DefaultBackground=2]="DefaultBackground"}(t.ColorId||(t.ColorId={})),function(e){e[e.Other=0]="Other",e[e.Comment=1]="Comment",e[e.String=2]="String",e[e.RegEx=4]="RegEx"}(t.StandardTokenType||(t.StandardTokenType={})),function(e){e[e.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",e[e.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",e[e.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",e[e.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",e[e.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",e[e.ITALIC_MASK=2048]="ITALIC_MASK",e[e.BOLD_MASK=4096]="BOLD_MASK",e[e.UNDERLINE_MASK=8192]="UNDERLINE_MASK",e[e.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",
e[e.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",e[e.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",e[e.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",e[e.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",e[e.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",e[e.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",e[e.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",e[e.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",e[e.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"}(t.MetadataConsts||(t.MetadataConsts={}));t.TokenMetadata=class{static getLanguageId(e){return(255&e)>>>0}static getTokenType(e){return(1792&e)>>>8}static getFontStyle(e){return(14336&e)>>>11}static getForeground(e){return(8372224&e)>>>14}static getBackground(e){return(4286578688&e)>>>23}static getClassNameFromMetadata(e){let t="mtk"+this.getForeground(e),i=this.getFontStyle(e);return 1&i&&(t+=" mtki"),2&i&&(t+=" mtkb"),4&i&&(t+=" mtku"),t}static getInlineStyleFromMetadata(e,t){const i=this.getForeground(e),n=this.getFontStyle(e);let r=`color: ${t[i]};`
;return 1&n&&(r+="font-style: italic;"),2&n&&(r+="font-weight: bold;"),4&n&&(r+="text-decoration: underline;"),r}},function(e){e[e.Method=0]="Method",e[e.Function=1]="Function",e[e.Constructor=2]="Constructor",e[e.Field=3]="Field",e[e.Variable=4]="Variable",e[e.Class=5]="Class",e[e.Struct=6]="Struct",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Event=10]="Event",e[e.Operator=11]="Operator",e[e.Unit=12]="Unit",e[e.Value=13]="Value",e[e.Constant=14]="Constant",e[e.Enum=15]="Enum",e[e.EnumMember=16]="EnumMember",e[e.Keyword=17]="Keyword",e[e.Text=18]="Text",e[e.Color=19]="Color",e[e.File=20]="File",e[e.Reference=21]="Reference",e[e.Customcolor=22]="Customcolor",e[e.Folder=23]="Folder",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue",e[e.Snippet=27]="Snippet"}(t.CompletionItemKind||(t.CompletionItemKind={})),t.completionKindToCssClass=function(){let e=Object.create(null);return e[0]="symbol-method",e[1]="symbol-function",
e[2]="symbol-constructor",e[3]="symbol-field",e[4]="symbol-variable",e[5]="symbol-class",e[6]="symbol-struct",e[7]="symbol-interface",e[8]="symbol-module",e[9]="symbol-property",e[10]="symbol-event",e[11]="symbol-operator",e[12]="symbol-unit",e[13]="symbol-value",e[14]="symbol-constant",e[15]="symbol-enum",e[16]="symbol-enum-member",e[17]="symbol-keyword",e[27]="symbol-snippet",e[18]="symbol-text",e[19]="symbol-color",e[20]="symbol-file",e[21]="symbol-reference",e[22]="symbol-customcolor",e[23]="symbol-folder",e[24]="symbol-type-parameter",e[25]="account",e[26]="issues",function(t){const i=e[t];let n=i&&a.iconRegistry.get(i);return n||(console.info("No codicon found for CompletionItemKind "+t),n=a.Codicon.symbolProperty),n.classNames}}(),t.completionKindFromString=function(){let e=Object.create(null);return e.method=0,e.function=1,e.constructor=2,e.field=3,e.variable=4,e.class=5,e.struct=6,e.interface=7,e.module=8,e.property=9,e.event=10,e.operator=11,e.unit=12,e.value=13,e.constant=14,e.enum=15,
e["enum-member"]=16,e.enumMember=16,e.keyword=17,e.snippet=27,e.text=18,e.color=19,e.file=20,e.reference=21,e.customcolor=22,e.folder=23,e["type-parameter"]=24,e.typeParameter=24,e.account=25,e.issue=26,function(t,i){let n=e[t];return void 0!==n||i||(n=9),n}}(),function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={})),function(e){e[e.KeepWhitespace=1]="KeepWhitespace",e[e.InsertAsSnippet=4]="InsertAsSnippet"}(t.CompletionItemInsertTextRule||(t.CompletionItemInsertTextRule={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e[e.Auto=1]="Auto",e[e.Manual=2]="Manual"}(t.CodeActionTriggerType||(t.CodeActionTriggerType={})),function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){
e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(t.DocumentHighlightKind||(t.DocumentHighlightKind={})),t.isLocationLink=function(e){return e&&n.URI.isUri(e.uri)&&r.Range.isIRange(e.range)&&(r.Range.isIRange(e.originSelectionRange)||r.Range.isIRange(e.targetSelectionRange))},function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",e[e.TypeParameter=25]="TypeParameter"}(t.SymbolKind||(t.SymbolKind={})),function(e){
e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={})),function(e){const t=new Map;t.set("file",0),t.set("module",1),t.set("namespace",2),t.set("package",3),t.set("class",4),t.set("method",5),t.set("property",6),t.set("field",7),t.set("constructor",8),t.set("enum",9),t.set("interface",10),t.set("function",11),t.set("variable",12),t.set("constant",13),t.set("string",14),t.set("number",15),t.set("boolean",16),t.set("array",17),t.set("object",18),t.set("key",19),t.set("null",20),t.set("enum-member",21),t.set("struct",22),t.set("event",23),t.set("operator",24),t.set("type-parameter",25);const i=new Map;i.set(0,"file"),i.set(1,"module"),i.set(2,"namespace"),i.set(3,"package"),i.set(4,"class"),i.set(5,"method"),i.set(6,"property"),i.set(7,"field"),i.set(8,"constructor"),i.set(9,"enum"),i.set(10,"interface"),i.set(11,"function"),i.set(12,"variable"),i.set(13,"constant"),i.set(14,"string"),i.set(15,"number"),i.set(16,"boolean"),i.set(17,"array"),i.set(18,"object"),i.set(19,"key"),i.set(20,"null"),
i.set(21,"enum-member"),i.set(22,"struct"),i.set(23,"event"),i.set(24,"operator"),i.set(25,"type-parameter"),e.fromString=function(e){return t.get(e)},e.toString=function(e){return i.get(e)},e.toCssClassName=function(e,t){const n=i.get(e);let r=n&&a.iconRegistry.get("symbol-"+n);return r||(console.info("No codicon found for SymbolKind "+e),r=a.Codicon.symbolProperty),`${t?"inline":"block"} ${r.classNames}`}}(t.SymbolKinds||(t.SymbolKinds={}));let c=(()=>{class e{constructor(e){this.value=e}}return e.Comment=new e("comment"),e.Imports=new e("imports"),e.Region=new e("region"),e})();t.FoldingRangeKind=c,function(e){e.is=function(e){return i.isObject(e)&&(Boolean(e.newUri)||Boolean(e.oldUri))}}(t.WorkspaceFileEdit||(t.WorkspaceFileEdit={})),function(e){e.is=function(e){return i.isObject(e)&&n.URI.isUri(e.resource)&&i.isObject(e.edit)}}(t.WorkspaceTextEdit||(t.WorkspaceTextEdit={})),function(e){e[e.Collapsed=0]="Collapsed",e[e.Expanded=1]="Expanded"
}(t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={})),function(e){e[e.Editing=0]="Editing",e[e.Preview=1]="Preview"}(t.CommentMode||(t.CommentMode={})),t.ReferenceProviderRegistry=new o.LanguageFeatureRegistry,t.RenameProviderRegistry=new o.LanguageFeatureRegistry,t.CompletionProviderRegistry=new o.LanguageFeatureRegistry,t.SignatureHelpProviderRegistry=new o.LanguageFeatureRegistry,t.HoverProviderRegistry=new o.LanguageFeatureRegistry,t.EvaluatableExpressionProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentSymbolProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentHighlightProviderRegistry=new o.LanguageFeatureRegistry,t.OnTypeRenameProviderRegistry=new o.LanguageFeatureRegistry,t.DefinitionProviderRegistry=new o.LanguageFeatureRegistry,t.DeclarationProviderRegistry=new o.LanguageFeatureRegistry,t.ImplementationProviderRegistry=new o.LanguageFeatureRegistry,t.TypeDefinitionProviderRegistry=new o.LanguageFeatureRegistry,t.CodeLensProviderRegistry=new o.LanguageFeatureRegistry,
t.CodeActionProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentFormattingEditProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentRangeFormattingEditProviderRegistry=new o.LanguageFeatureRegistry,t.OnTypeFormattingEditProviderRegistry=new o.LanguageFeatureRegistry,t.LinkProviderRegistry=new o.LanguageFeatureRegistry,t.ColorProviderRegistry=new o.LanguageFeatureRegistry,t.SelectionRangeRegistry=new o.LanguageFeatureRegistry,t.FoldingRangeProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentSemanticTokensProviderRegistry=new o.LanguageFeatureRegistry,t.DocumentRangeSemanticTokensProviderRegistry=new o.LanguageFeatureRegistry,t.TokenizationRegistry=new s.TokenizationRegistryImpl})),define(t[241],i([1,0,6,12,4,3,73,112]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullCommandService=t.CommandsRegistry=t.ICommandService=void 0,t.ICommandService=r.createDecorator("commandService"),t.CommandsRegistry=new class{constructor(){this._commands=new Map,
this._onDidRegisterCommand=new o.Emitter,this.onDidRegisterCommand=this._onDidRegisterCommand.event}registerCommand(e,t){if(!e)throw new Error("invalid command");if("string"==typeof e){if(!t)throw new Error("invalid command");return this.registerCommand({id:e,handler:t})}if(e.description){const t=[];for(let i of e.description.args)t.push(i.constraint);const i=e.handler;e.handler=function(e,...r){return n.validateConstraints(r,t),i(e,...r)}}const{id:r}=e;let o=this._commands.get(r);o||(o=new s.LinkedList,this._commands.set(r,o));let a=o.unshift(e),c=i.toDisposable(()=>{a();const e=this._commands.get(r);(null==e?void 0:e.isEmpty())&&this._commands.delete(r)});return this._onDidRegisterCommand.fire(r),c}registerCommandAlias(e,i){return t.CommandsRegistry.registerCommand(e,(e,...n)=>e.get(t.ICommandService).executeCommand(i,...n))}getCommand(e){const t=this._commands.get(e);if(t&&!t.isEmpty())return a.Iterable.first(t)}getCommands(){const e=new Map;for(const t of this._commands.keys()){const i=this.getCommand(t)
;i&&e.set(t,i)}return e}},t.NullCommandService={_serviceBrand:void 0,onWillExecuteCommand:()=>i.Disposable.None,onDidExecuteCommand:()=>i.Disposable.None,executeCommand:()=>Promise.resolve(void 0)}})),define(t[71],i([1,0,8,4,9]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SET_CONTEXT_COMMAND_ID=t.IContextKeyService=t.RawContextKey=t.ContextKeyOrExpr=t.ContextKeyAndExpr=t.ContextKeyNotRegexExpr=t.ContextKeyRegexExpr=t.ContextKeyNotExpr=t.ContextKeyNotEqualsExpr=t.ContextKeyEqualsExpr=t.ContextKeyDefinedExpr=t.ContextKeyTrueExpr=t.ContextKeyFalseExpr=t.ContextKeyExpr=t.ContextKeyExprType=void 0;const o=new Map;o.set("false",!1),o.set("true",!0),o.set("isMac",r.isMacintosh),o.set("isLinux",r.isLinux),o.set("isWindows",r.isWindows),o.set("isWeb",r.isWeb),o.set("isMacNative",r.isMacintosh&&!r.isWeb),function(e){e[e.False=0]="False",e[e.True=1]="True",e[e.Defined=2]="Defined",e[e.Not=3]="Not",e[e.Equals=4]="Equals",e[e.NotEquals=5]="NotEquals",e[e.And=6]="And",
e[e.Regex=7]="Regex",e[e.NotRegex=8]="NotRegex",e[e.Or=9]="Or"}(t.ContextKeyExprType||(t.ContextKeyExprType={}));class s{static false(){return c.INSTANCE}static true(){return l.INSTANCE}static has(e){return u.create(e)}static equals(e,t){return d.create(e,t)}static notEquals(e,t){return h.create(e,t)}static regex(e,t){return m.create(e,t)}static not(e){return p.create(e)}static and(...e){return g.create(e)}static or(...e){return v.create(e)}static deserialize(e,t=!1){if(e)return this._deserializeOrExpression(e,t)}static _deserializeOrExpression(e,t){let i=e.split("||");return v.create(i.map(e=>this._deserializeAndExpression(e,t)))}static _deserializeAndExpression(e,t){let i=e.split("&&");return g.create(i.map(e=>this._deserializeOne(e,t)))}static _deserializeOne(e,t){if((e=e.trim()).indexOf("!=")>=0){let i=e.split("!=");return h.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("==")>=0){let i=e.split("==");return d.create(i[0].trim(),this._deserializeValue(i[1],t))}if(e.indexOf("=~")>=0){
let i=e.split("=~");return m.create(i[0].trim(),this._deserializeRegexValue(i[1],t))}return/^\!\s*/.test(e)?p.create(e.substr(1).trim()):u.create(e)}static _deserializeValue(e,t){if("true"===(e=e.trim()))return!0;if("false"===e)return!1;let i=/^'([^']*)'$/.exec(e);return i?i[1].trim():e}static _deserializeRegexValue(e,t){if(i.isFalsyOrWhitespace(e)){if(t)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let n=e.indexOf("/"),r=e.lastIndexOf("/");if(n===r||n<0){if(t)throw new Error(`bad regexp-value '${e}', missing /-enclosure`);return console.warn(`bad regexp-value '${e}', missing /-enclosure`),null}let o=e.slice(n+1,r),s="i"===e[r+1]?"i":"";try{return new RegExp(o,s)}catch(i){if(t)throw new Error(`bad regexp-value '${e}', parse error: ${i}`);return console.warn(`bad regexp-value '${e}', parse error: ${i}`),null}}}function a(e,t){return e.cmp(t)}t.ContextKeyExpr=s;let c=(()=>{class e{constructor(){this.type=0}cmp(e){
return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!1}serialize(){return"false"}keys(){return[]}map(e){return this}negate(){return l.INSTANCE}}return e.INSTANCE=new e,e})();t.ContextKeyFalseExpr=c;let l=(()=>{class e{constructor(){this.type=1}cmp(e){return this.type-e.type}equals(e){return e.type===this.type}evaluate(e){return!0}serialize(){return"true"}keys(){return[]}map(e){return this}negate(){return c.INSTANCE}}return e.INSTANCE=new e,e})();t.ContextKeyTrueExpr=l;class u{constructor(e){this.key=e,this.type=2}static create(e){const t=o.get(e);return"boolean"==typeof t?t?l.INSTANCE:c.INSTANCE:new u(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!!e.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(e){return e.mapDefined(this.key)}negate(){return p.create(this.key)}}t.ContextKeyDefinedExpr=u;class d{constructor(e,t){this.key=e,this.value=t,
this.type=4}static create(e,t){if("boolean"==typeof t)return t?u.create(e):p.create(e);const i=o.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?l.INSTANCE:c.INSTANCE}return new d(e,t)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)==this.value}serialize(){return this.key+" == '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}t.ContextKeyEqualsExpr=d;class h{constructor(e,t){this.key=e,this.value=t,this.type=5}static create(e,t){if("boolean"==typeof t)return t?p.create(e):u.create(e);const i=o.get(e);if("boolean"==typeof i){return t===(i?"true":"false")?c.INSTANCE:l.INSTANCE}return new h(e,t)}cmp(e){
return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:this.value<e.value?-1:this.value>e.value?1:0}equals(e){return e.type===this.type&&(this.key===e.key&&this.value===e.value)}evaluate(e){return e.getValue(this.key)!=this.value}serialize(){return this.key+" != '"+this.value+"'"}keys(){return[this.key]}map(e){return e.mapNotEquals(this.key,this.value)}negate(){return d.create(this.key,this.value)}}t.ContextKeyNotEqualsExpr=h;class p{constructor(e){this.key=e,this.type=3}static create(e){const t=o.get(e);return"boolean"==typeof t?t?c.INSTANCE:l.INSTANCE:new p(e)}cmp(e){return e.type!==this.type?this.type-e.type:this.key<e.key?-1:this.key>e.key?1:0}equals(e){return e.type===this.type&&this.key===e.key}evaluate(e){return!e.getValue(this.key)}serialize(){return"!"+this.key}keys(){return[this.key]}map(e){return e.mapNot(this.key)}negate(){return u.create(this.key)}}t.ContextKeyNotExpr=p;class m{constructor(e,t){this.key=e,this.regexp=t,this.type=7}static create(e,t){return new m(e,t)}
cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.key<e.key)return-1;if(this.key>e.key)return 1;const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return t<i?-1:t>i?1:0}equals(e){if(e.type===this.type){const t=this.regexp?this.regexp.source:"",i=e.regexp?e.regexp.source:"";return this.key===e.key&&t===i}return!1}evaluate(e){let t=e.getValue(this.key);return!!this.regexp&&this.regexp.test(t)}serialize(){const e=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${e}`}keys(){return[this.key]}map(e){return e.mapRegex(this.key,this.regexp)}negate(){return f.create(this)}}t.ContextKeyRegexExpr=m;class f{constructor(e){this._actual=e,this.type=8}static create(e){return new f(e)}cmp(e){return e.type!==this.type?this.type-e.type:this._actual.cmp(e._actual)}equals(e){return e.type===this.type&&this._actual.equals(e._actual)}evaluate(e){return!this._actual.evaluate(e)}serialize(){throw new Error("Method not implemented.")}keys(){
return this._actual.keys()}map(e){return new f(this._actual.map(e))}negate(){return this._actual}}t.ContextKeyNotRegexExpr=f;class g{constructor(e){this.expr=e,this.type=6}static create(e){const t=g._normalizeArr(e);if(0!==t.length)return 1===t.length?t[0]:new g(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){const i=a(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].evaluate(e))return!1;return!0}static _normalizeArr(e){const t=[];let i=!1;for(const n of e)if(n)if(1!==n.type){if(0===n.type)return[c.INSTANCE];if(6!==n.type){
if(9===n.type)throw new Error('It is not allowed to have an or expression here due to lack of parens! For example "a && (b||c)" is not supported, use "(a&&b) || (a&&c)" instead.');t.push(n)}else t.push(...n.expr)}else i=!0;return 0===t.length&&i?[l.INSTANCE]:(t.sort(a),t)}serialize(){return this.expr.map(e=>e.serialize()).join(" && ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new g(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());return v.create(e)}}t.ContextKeyAndExpr=g;class v{constructor(e){this.expr=e,this.type=9}static create(e){const t=v._normalizeArr(e);if(0!==t.length)return 1===t.length?t[0]:new v(t)}cmp(e){if(e.type!==this.type)return this.type-e.type;if(this.expr.length<e.expr.length)return-1;if(this.expr.length>e.expr.length)return 1;for(let t=0,i=this.expr.length;t<i;t++){const i=a(this.expr[t],e.expr[t]);if(0!==i)return i}return 0}equals(e){if(e.type===this.type){if(this.expr.length!==e.expr.length)return!1
;for(let t=0,i=this.expr.length;t<i;t++)if(!this.expr[t].equals(e.expr[t]))return!1;return!0}return!1}evaluate(e){for(let t=0,i=this.expr.length;t<i;t++)if(this.expr[t].evaluate(e))return!0;return!1}static _normalizeArr(e){let t=[],i=!1;if(e){for(let n=0,r=e.length;n<r;n++){const r=e[n];if(r)if(0!==r.type){if(1===r.type)return[l.INSTANCE];9!==r.type?t.push(r):t=t.concat(r.expr)}else i=!0}if(0===t.length&&i)return[c.INSTANCE];t.sort(a)}return t}serialize(){return this.expr.map(e=>e.serialize()).join(" || ")}keys(){const e=[];for(let t of this.expr)e.push(...t.keys());return e}map(e){return new v(this.expr.map(t=>t.map(e)))}negate(){let e=[];for(let t of this.expr)e.push(t.negate());const t=e=>9===e.type?e.expr:[e];for(;e.length>1;){const i=e.shift(),n=e.shift(),r=[];for(const e of t(i))for(const i of t(n))r.push(s.and(e,i));e.unshift(s.or(...r))}return e[0]}}t.ContextKeyOrExpr=v;t.RawContextKey=class extends u{constructor(e,t){super(e),this._defaultValue=t}bindTo(e){
return e.createKey(this.key,this._defaultValue)}getValue(e){return e.getContextKeyValue(this.key)}toNegated(){return s.not(this.key)}isEqualTo(e){return s.equals(this.key,e)}notEqualsTo(e){return s.notEquals(this.key,e)}},t.IContextKeyService=n.createDecorator("contextKeyService"),t.SET_CONTEXT_COMMAND_ID="setContext"})),define(t[244],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BACKUPS=t.IEnvironmentService=void 0,t.IEnvironmentService=i.createDecorator("environmentService"),t.BACKUPS="Backups"})),define(t[248],i([1,0,132,4]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.IExtensionGalleryService=t.IExtensionManagementService=t.isIExtensionIdentifier=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.isIExtensionIdentifier=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&(!e.uuid||"string"==typeof e.uuid)},t.IExtensionManagementService=n.createDecorator("extensionManagementService"),t.IExtensionGalleryService=n.createDecorator("extensionGalleryService"),function(e){e[e.NoneOrRelevance=0]="NoneOrRelevance",
e[e.LastUpdatedDate=1]="LastUpdatedDate",e[e.Title=2]="Title",e[e.PublisherName=3]="PublisherName",e[e.InstallCount=4]="InstallCount",e[e.PublishedDate=5]="PublishedDate",e[e.AverageRating=6]="AverageRating",e[e.WeightedRating=12]="WeightedRating"}(t.SortBy||(t.SortBy={})),function(e){e[e.Default=0]="Default",e[e.Ascending=1]="Ascending",e[e.Descending=2]="Descending"}(t.SortOrder||(t.SortOrder={})),function(e){e.Uninstall="uninstall"}(t.StatisticType||(t.StatisticType={})),function(e){e[e.None=0]="None",e[e.Install=1]="Install",e[e.Update=2]="Update"}(t.InstallOperation||(t.InstallOperation={})),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(e,t){super(e),this.code=t}}t.ExtensionManagementError=r,t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",
t.IGlobalExtensionEnablementService=n.createDecorator("IGlobalExtensionEnablementService"),t.IExtensionTipsService=n.createDecorator("IExtensionTipsService"),t.DefaultIconPath=e.toUrl("./media/defaultIcon.png"),t.ExtensionsLabel=i.localize(0,null),t.ExtensionsChannelId="extensions",t.PreferencesLabel=i.localize(1,null)})),define(t[45],i([1,0,134,7,2,4,8,12]),(function(e,t,i,n,r,o,s,a){"use strict";var c;Object.defineProperty(t,"__esModule",{value:!0}),
t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FileType=t.IFileService=void 0,t.IFileService=o.createDecorator("fileService"),function(e){e[e.Unknown=0]="Unknown",e[e.File=1]="File",e[e.Directory=2]="Directory",e[e.SymbolicLink=64]="SymbolicLink"}(t.FileType||(t.FileType={})),function(e){e[e.FileReadWrite=2]="FileReadWrite",
e[e.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",e[e.FileReadStream=16]="FileReadStream",e[e.FileFolderCopy=8]="FileFolderCopy",e[e.PathCaseSensitive=1024]="PathCaseSensitive",e[e.Readonly=2048]="Readonly",e[e.Trash=4096]="Trash"}(t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={})),t.hasReadWriteCapability=function(e){return!!(2&e.capabilities)},t.hasFileFolderCopyCapability=function(e){return!!(8&e.capabilities)},t.hasOpenReadWriteCloseCapability=function(e){return!!(4&e.capabilities)},t.hasFileReadStreamCapability=function(e){return!!(16&e.capabilities)},function(e){e.FileExists="EntryExists",e.FileNotFound="EntryNotFound",e.FileNotADirectory="EntryNotADirectory",e.FileIsADirectory="EntryIsADirectory",e.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",e.FileTooLarge="EntryTooLarge",e.NoPermissions="NoPermissions",e.Unavailable="Unavailable",e.Unknown="Unknown"}(c=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class l extends Error{constructor(e,t){super(e),
this.code=t}}function u(e,t){const i=new l(e.toString(),t);return d(i,t),i}function d(e,t){return e.name=t?`${t} (FileSystemError)`:"FileSystemError",e}function h(e){if(!e)return c.Unknown;if(e instanceof l)return e.code;const t=/^(.+) \(FileSystemError\)$/.exec(e.name);if(!t)return c.Unknown;switch(t[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}t.FileSystemProviderError=l,t.createFileSystemProviderError=u,t.ensureFileSystemProviderError=function(e){return e||u(i.localize(0,null),c.Unknown)},t.markAsFileSystemProviderError=d,t.toFileSystemProviderErrorCode=h,t.toFileOperationResult=function(e){if(e instanceof m)return e.fileOperationResult;switch(h(e)){
case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}},function(e){e[e.CREATE=0]="CREATE",e[e.DELETE=1]="DELETE",e[e.MOVE=2]="MOVE",e[e.COPY=3]="COPY"}(t.FileOperation||(t.FileOperation={}));t.FileOperationEvent=class{constructor(e,t,i){this.resource=e,this.operation=t,this.target=i}isOperation(e){return this.operation===e}},function(e){e[e.UPDATED=0]="UPDATED",e[e.ADDED=1]="ADDED",e[e.DELETED=2]="DELETED"}(t.FileChangeType||(t.FileChangeType={}));class p{constructor(e,t){this.changes=e,this.extUri=t}contains(e,t){if(!e)return!1;const i=!a.isUndefinedOrNull(t);return this.changes.some(n=>(!i||n.type===t)&&(2===n.type?this.extUri.isEqualOrParent(e,n.resource):this.extUri.isEqual(e,n.resource)))}getAdded(){return this.getOfType(1)}gotAdded(){return this.hasType(1)}getDeleted(){return this.getOfType(2)}gotDeleted(){
return this.hasType(2)}getUpdated(){return this.getOfType(0)}gotUpdated(){return this.hasType(0)}getOfType(e){return this.changes.filter(t=>t.type===e)}hasType(e){return this.changes.some(t=>t.type===e)}filter(e){return new p(this.changes.filter(t=>e(t)),this.extUri)}}t.FileChangesEvent=p,t.isParent=function(e,t,i){return!(!e||!t||e===t)&&(!(t.length>e.length)&&(t.charAt(t.length-1)!==n.sep&&(t+=n.sep),i?s.startsWithIgnoreCase(e,t):0===e.indexOf(t)))};class m extends Error{constructor(e,t,i){super(e),this.fileOperationResult=t,this.options=i}static isFileOperationError(e){return e instanceof Error&&!a.isUndefinedOrNull(e.fileOperationResult)}}t.FileOperationError=m,function(e){e[e.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",e[e.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",e[e.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",e[e.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",e[e.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",e[e.FILE_READ_ONLY=5]="FILE_READ_ONLY",e[e.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",
e[e.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",e[e.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",e[e.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",e[e.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",e[e.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"}(t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude",function(e){e[e.FILE=0]="FILE",e[e.FOLDER=1]="FOLDER",e[e.ROOT_FOLDER=2]="ROOT_FOLDER"}(t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="",t.etag=function(e){if("number"==typeof e.size&&"number"==typeof e.mtime)return e.mtime.toString(29)+e.size.toString(31)},t.whenProviderRegistered=function(e,t){return t.canHandleResource(r.URI.from({scheme:e.scheme}))?Promise.resolve():new Promise((i,n)=>{
const r=t.onDidChangeFileSystemProviderRegistrations(t=>{t.scheme===e.scheme&&t.added&&(r.dispose(),i())})})},t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096})),define(t[68],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;t.ServiceCollection=class{constructor(...e){this._entries=new Map;for(let[t,i]of e)this.set(t,i)}set(e,t){const i=this._entries.get(e);return this._entries.set(e,t),i}forEach(e){this._entries.forEach((t,i)=>e(i,t))}has(e){return this._entries.has(e)}get(e){return this._entries.get(e)}}})),define(t[122],i([1,0,19,208,101,4,68,16]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const c=!1;class l extends Error{constructor(e){super("cyclic dependency between services"),this.message=e.toString()}}class u{constructor(e=new s.ServiceCollection,t=!1,i){this._services=e,this._strict=t,this._parent=i,this._services.set(o.IInstantiationService,this)}
createChild(e){return new u(e,this._strict,this)}invokeFunction(e,...t){let n=h.traceInvocation(e),r=!1;try{return e({get:(e,t)=>{if(r)throw i.illegalState("service accessor is only valid during the invocation of its target method");const s=this._getOrCreateServiceInstance(e,n);if(!s&&t!==o.optional)throw new Error(`[invokeFunction] unknown service '${e}'`);return s}},...t)}finally{r=!0,n.stop()}}createInstance(e,...t){let i,n;return e instanceof r.SyncDescriptor?(i=h.traceCreation(e.ctor),n=this._createInstance(e.ctor,e.staticArguments.concat(t),i)):(i=h.traceCreation(e),n=this._createInstance(e,t,i)),i.stop(),n}_createInstance(e,t=[],i){let n=o._util.getServiceDependencies(e).sort((e,t)=>e.index-t.index),r=[];for(const t of n){let n=this._getOrCreateServiceInstance(t.id,i);if(!n&&this._strict&&!t.optional)throw new Error(`[createInstance] ${e.name} depends on UNKNOWN service ${t.id}.`);r.push(n)}let s=n.length>0?n[0].index:t.length;if(t.length!==s){
console.warn(`[createInstance] First service dependency of ${e.name} at position ${s+1} conflicts with ${t.length} static arguments`);let i=s-t.length;t=i>0?t.concat(new Array(i)):t.slice(0,s)}return new e(...[...t,...r])}_setServiceInstance(e,t){if(this._services.get(e)instanceof r.SyncDescriptor)this._services.set(e,t);else{if(!this._parent)throw new Error("illegalState - setting UNKNOWN service instance");this._parent._setServiceInstance(e,t)}}_getServiceInstanceOrDescriptor(e){let t=this._services.get(e);return!t&&this._parent?this._parent._getServiceInstanceOrDescriptor(e):t}_getOrCreateServiceInstance(e,t){let i=this._getServiceInstanceOrDescriptor(e);return i instanceof r.SyncDescriptor?this._createAndCacheServiceInstance(e,i,t.branch(e,!0)):(t.branch(e,!1),i)}_createAndCacheServiceInstance(e,t,i){const s=new n.Graph(e=>e.id.toString());let a=0;const c=[{id:e,desc:t,_trace:i}];for(;c.length;){const t=c.pop();if(s.lookupOrInsertNode(t),a++>1e3)throw new l(s)
;for(let i of o._util.getServiceDependencies(t.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(i.id);if(n||i.optional||console.warn(`[createInstance] ${e} depends on ${i.id} which is NOT registered.`),n instanceof r.SyncDescriptor){const e={id:i.id,desc:n,_trace:t._trace.branch(i.id,!0)};s.insertEdge(t,e),c.push(e)}}}for(;;){const e=s.roots();if(0===e.length){if(!s.isEmpty())throw new l(s);break}for(const{data:t}of e){const e=this._createServiceInstanceWithOwner(t.id,t.desc.ctor,t.desc.staticArguments,t.desc.supportsDelayedInstantiation,t._trace);this._setServiceInstance(t.id,e),s.removeNode(t)}}return this._getServiceInstanceOrDescriptor(e)}_createServiceInstanceWithOwner(e,t,i=[],n,o){if(this._services.get(e)instanceof r.SyncDescriptor)return this._createServiceInstance(t,i,n,o);if(this._parent)return this._parent._createServiceInstanceWithOwner(e,t,i,n,o);throw new Error(`illegalState - creating UNKNOWN service instance ${t.name}`)}_createServiceInstance(e,t=[],i,n){if(i){
const i=new a.IdleValue(()=>this._createInstance(e,t,n));return new Proxy(Object.create(null),{get(e,t){if(t in e)return e[t];let n=i.value,r=n[t];return"function"!=typeof r?r:(r=r.bind(n),e[t]=r,r)},set:(e,t,n)=>(i.value[t]=n,!0)})}return this._createInstance(e,t,n)}}var d;t.InstantiationService=u,function(e){e[e.Creation=0]="Creation",e[e.Invocation=1]="Invocation",e[e.Branch=2]="Branch"}(d||(d={}));let h=(()=>{class e{constructor(e,t){this.type=e,this.name=t,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return c?new e(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):e._None}static traceCreation(t){return c?new e(0,t.name):e._None}branch(t,i){let n=new e(2,t.toString());return this._dep.push([t,i,n]),n}stop(){let t=Date.now()-this._start;e._totals+=t;let i=!1;let n=[`${0===this.type?"CREATE":"CALL"} ${this.name}`,`${function e(t,n){let r=[],o=new Array(t+1).join("\t");for(const[s,a,c]of n._dep)if(a&&c){i=!0,r.push(`${o}CREATES -> ${s}`);let n=e(t+1,c);n&&r.push(n)
}else r.push(`${o}uses -> ${s}`);return r.join("\n")}(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${e._totals.toFixed(2)}ms)`];(t>2||i)&&console.log(n.join("\n"))}}return e._None=new class extends e{constructor(){super(-1,null)}stop(){}branch(){return this}},e._totals=0,e})()})),define(t[11],i([1,0,4,6,9,3,46]),(function(e,t,i,n,r,o,s){"use strict";function a(){return(new Date).toISOString()}var c;Object.defineProperty(t,"__esModule",{value:!0}),t.getLogLevel=t.NullLogService=t.DelegatedLogService=t.MultiplexLogService=t.ConsoleLogInMainService=t.LogServiceAdapter=t.ConsoleLogService=t.ConsoleLogMainService=t.AbstractLogService=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=i.createDecorator("logService"),t.ILoggerService=i.createDecorator("loggerService"),function(e){e[e.Trace=0]="Trace",e[e.Debug=1]="Debug",e[e.Info=2]="Info",e[e.Warning=3]="Warning",e[e.Error=4]="Error",e[e.Critical=5]="Critical",e[e.Off=6]="Off"}(c=t.LogLevel||(t.LogLevel={})),
t.DEFAULT_LOG_LEVEL=c.Info;class l extends n.Disposable{constructor(){super(...arguments),this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new o.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogService=l;t.ConsoleLogMainService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e),this.useColors=!r.isWindows}trace(e,...t){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}debug(e,...t){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}info(e,...t){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${a()}][0m`,e,...t):console.log(`[main ${a()}]`,e,...t))}warn(e,...t){
this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${a()}][0m`,e,...t):console.warn(`[main ${a()}]`,e,...t))}error(e,...t){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}critical(e,...t){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${a()}][0m`,e,...t):console.error(`[main ${a()}]`,e,...t))}dispose(){}flush(){}};t.ConsoleLogService=class extends l{constructor(e=t.DEFAULT_LOG_LEVEL){super(),this.setLevel(e)}trace(e,...t){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...t)}debug(e,...t){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...t)}info(e,...t){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...t)}warn(e,...t){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...t)}error(e,...t){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...t)}critical(e,...t){
this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...t)}dispose(){}flush(){}};class u extends l{constructor(e,i=t.DEFAULT_LOG_LEVEL){super(),this.adapter=e,this.setLevel(i)}trace(e,...t){this.getLevel()<=c.Trace&&this.adapter.consoleLog("trace",[this.extractMessage(e),...t])}debug(e,...t){this.getLevel()<=c.Debug&&this.adapter.consoleLog("debug",[this.extractMessage(e),...t])}info(e,...t){this.getLevel()<=c.Info&&this.adapter.consoleLog("info",[this.extractMessage(e),...t])}warn(e,...t){this.getLevel()<=c.Warning&&this.adapter.consoleLog("warn",[this.extractMessage(e),...t])}error(e,...t){this.getLevel()<=c.Error&&this.adapter.consoleLog("error",[this.extractMessage(e),...t])}critical(e,...t){this.getLevel()<=c.Critical&&this.adapter.consoleLog("critical",[this.extractMessage(e),...t])}extractMessage(e){return"string"==typeof e?e:s.toErrorMessage(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.LogServiceAdapter=u;t.ConsoleLogInMainService=class extends u{
constructor(e,i=t.DEFAULT_LOG_LEVEL){super({consoleLog:(t,i)=>e.consoleLog(t,i)},i)}};t.MultiplexLogService=class extends l{constructor(e){super(),this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const t of this.logServices)t.setLevel(e);super.setLevel(e)}trace(e,...t){for(const i of this.logServices)i.trace(e,...t)}debug(e,...t){for(const i of this.logServices)i.debug(e,...t)}info(e,...t){for(const i of this.logServices)i.info(e,...t)}warn(e,...t){for(const i of this.logServices)i.warn(e,...t)}error(e,...t){for(const i of this.logServices)i.error(e,...t)}critical(e,...t){for(const i of this.logServices)i.critical(e,...t)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}};class d extends n.Disposable{constructor(e){super(),this.logService=e,this._register(e)}get onDidChangeLogLevel(){return this.logService.onDidChangeLogLevel}setLevel(e){this.logService.setLevel(e)}getLevel(){return this.logService.getLevel()}trace(e,...t){
this.logService.trace(e,...t)}debug(e,...t){this.logService.debug(e,...t)}info(e,...t){this.logService.info(e,...t)}warn(e,...t){this.logService.warn(e,...t)}error(e,...t){this.logService.error(e,...t)}critical(e,...t){this.logService.critical(e,...t)}flush(){this.logService.flush()}}t.DelegatedLogService=d;t.NullLogService=class{constructor(){this.onDidChangeLogLevel=(new o.Emitter).event}setLevel(e){}getLevel(){return c.Info}trace(e,...t){}debug(e,...t){}info(e,...t){}warn(e,...t){}error(e,...t){}critical(e,...t){}dispose(){}flush(){}},t.getLogLevel=function(e){if(e.verbose)return c.Trace;if("string"==typeof e.logLevel){switch(e.logLevel.toLowerCase()){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}return t.DEFAULT_LOG_LEVEL}})),define(t[86],i([1,0,7,11]),(function(e,t,i,n){"use strict";function r(e,t,i){switch(t){case n.LogLevel.Trace:e.trace(i);break
;case n.LogLevel.Debug:e.debug(i);break;case n.LogLevel.Info:e.info(i);break;case n.LogLevel.Warning:e.warn(i);break;case n.LogLevel.Error:e.error(i);break;case n.LogLevel.Critical:e.critical(i);break;default:throw new Error("Invalid log level")}}Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogService=t.createRotatingLogger=void 0,t.createRotatingLogger=function(t,i,n,r){return e.__$__nodeRequire("spdlog").createRotatingLogger(t,i,n,r)};class o extends n.AbstractLogService{constructor(e,t,i){super(),this.name=e,this.logsFolder=t,this.buffer=[],this._loggerCreationPromise=void 0,this.setLevel(i),this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(e=>{this._logger&&this._logger.setLevel(e)}))}_createSpdLogLogger(){return this._loggerCreationPromise||(this._loggerCreationPromise=async function(t,n){try{const r=await new Promise((t,i)=>{e(["spdlog"],t,i)});r.setAsyncMode(8192,500);const o=i.join(n,`${t}.log`);return r.createRotatingLoggerAsync(t,o,5242880,6)}catch(e){console.error(e)}
return null}(this.name,this.logsFolder).then(e=>{if(e){this._logger=e,this._logger.setLevel(this.getLevel());for(const{level:e,message:t}of this.buffer)r(this._logger,e,t);this.buffer=[]}})),this._loggerCreationPromise}_log(e,t){this._logger?r(this._logger,e,t):this.getLevel()<=e&&this.buffer.push({level:e,message:t})}trace(e,...t){this.getLevel()<=n.LogLevel.Trace&&this._log(n.LogLevel.Trace,this.format([e,...t]))}debug(e,...t){this.getLevel()<=n.LogLevel.Debug&&this._log(n.LogLevel.Debug,this.format([e,...t]))}info(e,...t){this.getLevel()<=n.LogLevel.Info&&this._log(n.LogLevel.Info,this.format([e,...t]))}warn(e,...t){this.getLevel()<=n.LogLevel.Warning&&this._log(n.LogLevel.Warning,this.format([e,...t]))}error(e,...t){if(this.getLevel()<=n.LogLevel.Error)if(e instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=e.stack,this._log(n.LogLevel.Error,this.format(t))}else this._log(n.LogLevel.Error,this.format([e,...t]))}critical(e,...t){
this.getLevel()<=n.LogLevel.Critical&&this._log(n.LogLevel.Critical,this.format([e,...t]))}flush(){this._logger?this._logger.flush():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise&&this._loggerCreationPromise.then(()=>this.disposeLogger()),this._loggerCreationPromise=void 0}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}format(e){let t="";for(let i=0;i<e.length;i++){let n=e[i];if("object"==typeof n)try{n=JSON.stringify(n)}catch(e){}t+=(i>0?" ":"")+n}return t}}t.SpdLogService=o})),define(t[87],i([1,0,4,135,81]),(function(e,t,i,n,r){"use strict";var o;Object.defineProperty(t,"__esModule",{value:!0}),t.IMarkerService=t.IMarkerData=t.MarkerSeverity=t.MarkerTag=void 0,function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.MarkerTag||(t.MarkerTag={})),function(e){e[e.Hint=1]="Hint",e[e.Info=2]="Info",e[e.Warning=4]="Warning",e[e.Error=8]="Error"
}(o=t.MarkerSeverity||(t.MarkerSeverity={})),function(e){e.compare=function(e,t){return t-e};const t=Object.create(null);t[e.Error]=n.localize(0,null),t[e.Warning]=n.localize(1,null),t[e.Info]=n.localize(2,null),e.toString=function(e){return t[e]||""},e.fromSeverity=function(t){switch(t){case r.default.Error:return e.Error;case r.default.Warning:return e.Warning;case r.default.Info:return e.Info;case r.default.Ignore:return e.Hint}},e.toSeverity=function(t){switch(t){case e.Error:return r.default.Error;case e.Warning:return r.default.Warning;case e.Info:return r.default.Info;case e.Hint:return r.default.Ignore}}}(o=t.MarkerSeverity||(t.MarkerSeverity={})),function(e){const t="";function i(e,i){let n=[t];return e.source?n.push(e.source.replace("¦","\\¦")):n.push(t),e.code?"string"==typeof e.code?n.push(e.code.replace("¦","\\¦")):n.push(e.code.value.replace("¦","\\¦")):n.push(t),void 0!==e.severity&&null!==e.severity?n.push(o.toString(e.severity)):n.push(t),
e.message&&i?n.push(e.message.replace("¦","\\¦")):n.push(t),void 0!==e.startLineNumber&&null!==e.startLineNumber?n.push(e.startLineNumber.toString()):n.push(t),void 0!==e.startColumn&&null!==e.startColumn?n.push(e.startColumn.toString()):n.push(t),void 0!==e.endLineNumber&&null!==e.endLineNumber?n.push(e.endLineNumber.toString()):n.push(t),void 0!==e.endColumn&&null!==e.endColumn?n.push(e.endColumn.toString()):n.push(t),n.push(t),n.join("¦")}e.makeKey=function(e){return i(e,!0)},e.makeKeyOptionalMessage=i}(t.IMarkerData||(t.IMarkerData={})),t.IMarkerService=i.createDecorator("markerService")})),define(t[126],i([1,0,81,4,3]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NoOpProgress=t.NoOpNotification=t.NotificationsFilter=t.NeverShowAgainScope=t.INotificationService=t.Severity=void 0,t.Severity=i.default,t.INotificationService=n.createDecorator("notificationService"),function(e){e[e.WORKSPACE=0]="WORKSPACE",e[e.GLOBAL=1]="GLOBAL"
}(t.NeverShowAgainScope||(t.NeverShowAgainScope={})),function(e){e[e.OFF=0]="OFF",e[e.SILENT=1]="SILENT",e[e.ERROR=2]="ERROR"}(t.NotificationsFilter||(t.NotificationsFilter={}));t.NoOpNotification=class{constructor(){this.progress=new o,this.onDidClose=r.Event.None,this.onDidChangeVisibility=r.Event.None}updateSeverity(e){}updateMessage(e){}updateActions(e){}close(){}};class o{infinite(){}done(){}total(e){}worked(e){}}t.NoOpProgress=o})),define(t[88],i([1,0,9,7,64,36]),(function(e,t,i,n,r,o){"use strict";let s;if(Object.defineProperty(t,"__esModule",{value:!0}),i.isWeb)s={},0===Object.keys(s).length&&Object.assign(s,{version:"1.46.0-dev",nameLong:"Visual Studio Code Web Dev",nameShort:"VSCode Web Dev",urlProtocol:"code-oss"});else{if(void 0===e||"function"!=typeof e.__$__nodeRequire)throw new Error("Unable to resolve product configuration");{const t=n.dirname(r.getPathFromAmdModule(e,""));s=e.__$__nodeRequire(n.join(t,"product.json"));const i=e.__$__nodeRequire(n.join(t,"package.json"))
;o.env.VSCODE_DEV&&Object.assign(s,{nameShort:`${s.nameShort} Dev`,nameLong:`${s.nameLong} Dev`,dataFolderName:`${s.dataFolderName}-dev`}),Object.assign(s,{version:i.version})}}t.default=s})),define(t[128],i([1,0,4,22,6]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IEditorProgressService=t.LongRunningOperation=t.Progress=t.emptyProgressRunner=t.ProgressLocation=t.IProgressService=void 0,t.IProgressService=i.createDecorator("progressService"),function(e){e[e.Explorer=1]="Explorer",e[e.Scm=3]="Scm",e[e.Extensions=5]="Extensions",e[e.Window=10]="Window",e[e.Notification=15]="Notification",e[e.Dialog=20]="Dialog"}(t.ProgressLocation||(t.ProgressLocation={})),t.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});let o=(()=>{class e{constructor(e){this.callback=e}get value(){return this._value}report(e){this._value=e,this.callback(this._value)}}return e.None=Object.freeze({report(){}}),e})();t.Progress=o;class s extends r.Disposable{constructor(e){super(),
this.progressIndicator=e,this.currentOperationId=0,this.currentOperationDisposables=this._register(new r.DisposableStore)}start(e){this.stop();const t=++this.currentOperationId,i=new n.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{t===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},e),this.currentOperationDisposables.add(r.toDisposable(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add(r.toDisposable(()=>i.cancel())),this.currentOperationDisposables.add(r.toDisposable(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:t,token:i.token,stop:()=>this.doStop(t),isCurrent:()=>this.currentOperationId===t}}stop(){this.doStop(this.currentOperationId)}doStop(e){this.currentOperationId===e&&this.currentOperationDisposables.clear()}}t.LongRunningOperation=s,t.IEditorProgressService=i.createDecorator("editorProgressService")})),define(t[48],i([1,0,12,56]),(function(e,t,i,n){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;t.Registry=new class{constructor(){this.data=new Map}add(e,t){n.ok(i.isString(e)),n.ok(i.isObject(t)),n.ok(!this.data.has(e),"There is already an extension with this id"),this.data.set(e,t)}knows(e){return this.data.has(e)}as(e){return this.data.get(e)||null}}})),define(t[130],i([1,0,48,3]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};const r=new class{constructor(){this._onDidChangeSchema=new n.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(e,t){var i;this.schemasById[(i=e,i.length>0&&"#"===i.charAt(i.length-1)?i.substring(0,i.length-1):i)]=t,this._onDidChangeSchema.fire(e)}notifySchemaChanged(e){this._onDidChangeSchema.fire(e)}getSchemaContributions(){return{schemas:this.schemasById}}};i.Registry.add(t.Extensions.JSONContribution,r)})),
define(t[50],i([1,0,127,3,48,12,130,26]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=void 0,t.Extensions={Configuration:"base.contributions.configuration"},function(e){e[e.APPLICATION=1]="APPLICATION",e[e.MACHINE=2]="MACHINE",e[e.WINDOW=3]="WINDOW",e[e.RESOURCE=4]="RESOURCE",e[e.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",e[e.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"}(t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},
t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const c=r.Registry.as(s.Extensions.JSONContribution);function l(e){switch(Array.isArray(e)?e[0]:e){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.OVERRIDE_PROPERTY_PATTERN=new RegExp("\\[.*\\]$"),t.getDefaultValue=l;const u=new class{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultOverridesConfigurationNode={id:"defaultOverrides",title:i.localize(0,null),properties:{}},this.configurationContributors=[this.defaultOverridesConfigurationNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,
errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(e,t=!0){this.registerConfigurations([e],t)}registerConfigurations(e,i=!0){const n=[];e.forEach(e=>{n.push(...this.validateAndRegisterProperties(e,i)),this.configurationContributors.push(e),this.registerJSONConfiguration(e)}),c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}deregisterConfigurations(e){const i=[],n=e=>{if(e.properties)for(const n in e.properties)switch(i.push(n),delete this.configurationProperties[n],delete t.allSettings.properties[n],e.properties[n].scope){case 1:delete t.applicationSettings.properties[n];break;case 2:delete t.machineSettings.properties[n];break;case 6:
delete t.machineOverridableSettings.properties[n];break;case 3:delete t.windowSettings.properties[n];break;case 4:case 5:delete t.resourceSettings.properties[n]}e.allOf&&e.allOf.forEach(e=>n(e))};for(const t of e){n(t);const e=this.configurationContributors.indexOf(t);-1!==e&&this.configurationContributors.splice(e,1)}c.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}registerDefaultConfigurations(e){const n=[];for(const r of e)for(const e in r.defaults){const o=r.defaults[e];if(t.OVERRIDE_PROPERTY_PATTERN.test(e)&&"object"==typeof o){const r={type:"object",default:o,description:i.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.properties[e]=r,this.defaultOverridesConfigurationNode.properties[e]=r,this.configurationProperties[e]=r,n.push(e)}}this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(n)}deregisterDefaultConfigurations(e){const i=[]
;for(const n of e)for(const e in n.defaults)i.push(e),delete t.allSettings.properties[e],delete this.defaultOverridesConfigurationNode.properties[e],delete this.configurationProperties[e];this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(i)}notifyConfigurationSchemaUpdated(...e){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(e){for(const t of e)this.overrideIdentifiers.add(t);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(e,i=!0,n=3){n=o.isUndefinedOrNull(e.scope)?n:e.scope;let r=[],s=e.properties;if(s)for(let e in s){if(i&&d(e)){delete s[e];continue}let a=s[e],c=a.default;o.isUndefined(c)&&(a.default=l(a.type)),t.OVERRIDE_PROPERTY_PATTERN.test(e)?a.scope=void 0:a.scope=o.isUndefinedOrNull(a.scope)?n:a.scope,!s[e].hasOwnProperty("included")||s[e].included?(this.configurationProperties[e]=s[e],!s[e].deprecationMessage&&s[e].markdownDeprecationMessage&&(s[e].deprecationMessage=s[e].markdownDeprecationMessage),
r.push(e)):(this.excludedConfigurationProperties[e]=s[e],delete s[e])}let a=e.allOf;if(a)for(let e of a)r.push(...this.validateAndRegisterProperties(e,i,n));return r}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(e){const i=e=>{let n=e.properties;if(n)for(const e in n)switch(t.allSettings.properties[e]=n[e],n[e].scope){case 1:t.applicationSettings.properties[e]=n[e];break;case 2:t.machineSettings.properties[e]=n[e];break;case 6:t.machineOverridableSettings.properties[e]=n[e];break;case 3:t.windowSettings.properties[e]=n[e];break;case 4:t.resourceSettings.properties[e]=n[e];break;case 5:t.resourceSettings.properties[e]=n[e],this.resourceLanguageSettingsSchema.properties[e]=n[e]}let r=e.allOf;r&&r.forEach(i)};i(e)}updateOverridePropertyPatternKey(){var e;for(const n of a.values(this.overrideIdentifiers)){const r=`[${n}]`,o={
type:"object",description:i.localize(2,null),errorMessage:i.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId,default:null===(e=this.defaultOverridesConfigurationNode.properties[r])||void 0===e?void 0:e.default};t.allSettings.properties[r]=o,t.applicationSettings.properties[r]=o,t.machineSettings.properties[r]=o,t.machineOverridableSettings.properties[r]=o,t.windowSettings.properties[r]=o,t.resourceSettings.properties[r]=o}this._onDidSchemaChange.fire()}};function d(e){return t.OVERRIDE_PROPERTY_PATTERN.test(e)?i.localize(4,null,e):void 0!==u.getConfigurationProperties()[e]?i.localize(5,null,e):null}r.Registry.add(t.Extensions.Configuration,u),t.validateProperty=d,t.getScopes=function(){const e=[],t=u.getConfigurationProperties();for(const i of Object.keys(t))e.push([i,t[i].scope]);return e.push(["launch",4]),e.push(["task",4]),e}})),define(t[80],i([1,0,18,12,2,48,4,50]),(function(e,t,i,n,r,o,s,a){"use strict";function c(e,t){const i=Object.create(null);for(let n in e)l(i,n,e[n],t);return i}
function l(e,t,i,n){const r=t.split("."),o=r.pop();let s=e;for(let e=0;e<r.length;e++){let i=r[e],o=s[i];switch(typeof o){case"undefined":o=s[i]=Object.create(null);break;case"object":break;default:return void n(`Ignoring ${t} as ${r.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`)}s=o}if("object"==typeof s&&null!==s)try{s[o]=i}catch(e){n(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(s)}`)}else n(`Ignoring ${t} as ${r.join(".")} is ${JSON.stringify(s)}`)}function u(e,t,i){const n=function(e,t){let i=e;for(const e of t){if("object"!=typeof i||null===i)return;i=i[e]}return i}(e,t.split("."));return void 0===n?i:n}function d(e){return e.substring(1,e.length-1)}function h(e){return`[${e}]`}Object.defineProperty(t,"__esModule",{value:!0}),
t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.overrideIdentifierFromKey=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=s.createDecorator("configurationService"),t.isConfigurationOverrides=function(e){return e&&"object"==typeof e&&(!e.overrideIdentifier||"string"==typeof e.overrideIdentifier)&&(!e.resource||e.resource instanceof r.URI)},function(e){e[e.USER=1]="USER",e[e.USER_LOCAL=2]="USER_LOCAL",e[e.USER_REMOTE=3]="USER_REMOTE",e[e.WORKSPACE=4]="WORKSPACE",e[e.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",e[e.DEFAULT=6]="DEFAULT",e[e.MEMORY=7]="MEMORY"}(t.ConfigurationTarget||(t.ConfigurationTarget={})),t.ConfigurationTargetToString=function(e){switch(e){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:
return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}},t.compare=function e(t,n){const r=n?t?n.keys.filter(e=>-1===t.keys.indexOf(e)):[...n.keys]:[],o=t?n?t.keys.filter(e=>-1===n.keys.indexOf(e)):[...t.keys]:[],s=[];if(n&&t)for(const e of t.keys)if(-1!==n.keys.indexOf(e)){const r=u(t.contents,e),o=u(n.contents,e);i.equals(r,o)||s.push(e)}const a=[],c=e=>{const t={};for(const i of e)for(const e of i.identifiers)t[h(e)]=i;return t},l=n?c(n.overrides):{},p=t?c(t.overrides):{};if(Object.keys(l).length)for(const e of r){const t=l[e];t&&a.push([d(e),t.keys])}if(Object.keys(p).length)for(const e of o){const t=p[e];t&&a.push([d(e),t.keys])}if(Object.keys(l).length&&Object.keys(p).length)for(const t of s){const i=p[t],n=l[t];if(i&&n){const r=e({contents:i.contents,keys:i.keys,overrides:[]},{contents:n.contents,keys:n.keys,overrides:[]});a.push([d(t),[...r.added,...r.removed,...r.updated]])}}return{added:r,removed:o,updated:s,overrides:a}},t.toOverrides=function(e,t){const i=[]
;for(const n of Object.keys(e))if(a.OVERRIDE_PROPERTY_PATTERN.test(n)){const r={};for(const t in e[n])r[t]=e[n][t];i.push({identifiers:[d(n).trim()],keys:Object.keys(r),contents:c(r,t)})}return i},t.toValuesTree=c,t.addToValueTree=l,t.removeFromValueTree=function(e,t){!function e(t,i){const n=i.shift();if(0===i.length)return void delete t[n];if(-1!==Object.keys(t).indexOf(n)){const r=t[n];"object"!=typeof r||Array.isArray(r)||(e(r,i),0===Object.keys(r).length&&delete t[n])}}(e,t.split("."))},t.getConfigurationValue=u,t.merge=function e(t,i,r){Object.keys(i).forEach(o=>{o in t?n.isObject(t[o])&&n.isObject(i[o])?e(t[o],i[o],r):r&&(t[o]=i[o]):t[o]=i[o]})},t.getConfigurationKeys=function(){const e=o.Registry.as(a.Extensions.Configuration).getConfigurationProperties();return Object.keys(e)},t.getDefaultValues=function(){const e=Object.create(null),t=o.Registry.as(a.Extensions.Configuration).getConfigurationProperties();for(let i in t){l(e,i,t[i].default,e=>console.error(`Conflict in default settings: ${e}`))}
return e},t.overrideIdentifierFromKey=d,t.keyFromOverrideIdentifier=h,t.getMigratedSettingValue=function(e,t,i){const n=e.inspect(t),r=e.inspect(i);return void 0!==n.userValue||void 0!==n.workspaceValue||void 0!==n.workspaceFolderValue?n.value:void 0!==r.userValue||void 0!==r.workspaceValue||void 0!==r.workspaceFolderValue?r.value:n.defaultValue}})),define(t[133],i([1,0,55,26,13,12,18,2,50,80,48,6,3,23]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class m{constructor(e={},t=[],i=[]){this._contents=e,this._keys=t,this._overrides=i,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){
return 0===this._keys.length&&0===Object.keys(this._contents).length&&0===this._overrides.length}getValue(e){return e?l.getConfigurationValue(this.contents,e):this.contents}getOverrideValue(e,t){const i=this.getContentsForOverrideIdentifer(t);return i?e?l.getConfigurationValue(i,e):i:void 0}getKeysForOverrideIdentifier(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.keys;return[]}override(e){const t=this.getContentsForOverrideIdentifer(e);if(!t||"object"!=typeof t||!Object.keys(t).length)return this;let i={};for(const e of r.distinct([...Object.keys(this.contents),...Object.keys(t)])){let n=this.contents[e],r=t[e];r&&("object"==typeof n&&"object"==typeof r?(n=s.deepClone(n),this.mergeContents(n,r)):n=r),i[e]=n}return new m(i,this.keys,this.overrides)}merge(...e){const t=s.deepClone(this.contents),i=s.deepClone(this.overrides),n=[...this.keys];for(const o of e){this.mergeContents(t,o.contents);for(const e of o.overrides){const[t]=i.filter(t=>r.equals(t.identifiers,e.identifiers))
;t?this.mergeContents(t.contents,e.contents):i.push(s.deepClone(e))}for(const e of o.keys)-1===n.indexOf(e)&&n.push(e)}return new m(t,n,i)}freeze(){return this.isFrozen=!0,this}mergeContents(e,t){for(const i of Object.keys(t))i in e&&o.isObject(e[i])&&o.isObject(t[i])?this.mergeContents(e[i],t[i]):e[i]=s.deepClone(t[i])}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?s.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const t of this.overrides)if(-1!==t.identifiers.indexOf(e))return t.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,t){this.addKey(e),l.addToValueTree(this.contents,e,t,e=>{throw new Error(e)})}removeValue(e){this.removeKey(e)&&l.removeFromValueTree(this.contents,e)}addKey(e){let t=this.keys.length;for(let i=0;i<t;i++)0===e.indexOf(this.keys[i])&&(t=i);this.keys.splice(t,1,e)}removeKey(e){let t=this.keys.indexOf(e);return-1!==t&&(this.keys.splice(t,1),!0)}}t.ConfigurationModel=m
;t.DefaultConfigurationModel=class extends m{constructor(){const e=l.getDefaultValues(),t=l.getConfigurationKeys(),i=[];for(const t of Object.keys(e))c.OVERRIDE_PROPERTY_PATTERN.test(t)&&i.push({identifiers:[l.overrideIdentifierFromKey(t).trim()],keys:Object.keys(e[t]),contents:l.toValuesTree(e[t],e=>console.error(`Conflict in default settings file: ${e}`))});super(e,t,i)}};class f{constructor(e,t){this._name=e,this._scopes=t,this._raw=null,this._configurationModel=null,this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get errors(){return this._parseErrors}parseContent(e){if(!o.isUndefinedOrNull(e)){const t=this.doParseContent(e);this.parseRaw(t)}}parseRaw(e){this._raw=e;const t=this.doParseRaw(e);this._configurationModel=new m(t.contents,t.keys,t.overrides)}parse(){this._raw&&this.parseRaw(this._raw)}doParseContent(e){let t={},n=null,r=[],o=[],s=[];function a(e){Array.isArray(r)?r.push(e):n&&(r[n]=e)}let c={onObjectBegin:()=>{let e={};a(e),o.push(r),r=e,n=null},
onObjectProperty:e=>{n=e},onObjectEnd:()=>{r=o.pop()},onArrayBegin:()=>{let e=[];a(e),o.push(r),r=e,n=null},onArrayEnd:()=>{r=o.pop()},onLiteralValue:a,onError:(e,t,i)=>{s.push({error:e,offset:t,length:i})}};if(e)try{i.visit(e,c),t=r[0]||{}}catch(e){console.error(`Error while parsing settings file ${this._name}: ${e}`),this._parseErrors=[e]}return t}doParseRaw(e){if(this._scopes){const t=u.Registry.as(c.Extensions.Configuration).getConfigurationProperties();e=this.filterByScope(e,t,!0,this._scopes)}return{contents:l.toValuesTree(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`)),keys:Object.keys(e),overrides:l.toOverrides(e,e=>console.error(`Conflict in settings file ${this._name}: ${e}`))}}filterByScope(e,t,i,n){const r={};for(let o in e)if(c.OVERRIDE_PROPERTY_PATTERN.test(o)&&i)r[o]=this.filterByScope(e[o],t,!1,n);else{const i=this.getScope(o,t);void 0!==i&&-1===n.indexOf(i)||(r[o]=e[o])}return r}getScope(e,t){const i=t[e];return i?void 0!==i.scope?i.scope:3:void 0}}
t.ConfigurationModelParser=f;class g extends d.Disposable{constructor(e,t,i){super(),this.userSettingsResource=e,this.scopes=t,this.fileService=i,this._onDidChange=this._register(new h.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString(),this.scopes),this._register(this.fileService.watch(p.dirname(this.userSettingsResource))),this._register(h.Event.filter(this.fileService.onDidFilesChange,e=>e.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parseContent(e.value.toString()||"{}"),this.parser.configurationModel}catch(e){return new m}}reprocess(){return this.parser.parse(),this.parser.configurationModel}}t.UserSettings=g;class v{constructor(e,t,i=new m,r=new m,o=new n.ResourceMap,s=new m,a=new n.ResourceMap,c=!0){this._defaultConfiguration=e,this._localUserConfiguration=t,this._remoteUserConfiguration=i,
this._workspaceConfiguration=r,this._folderConfigurations=o,this._memoryConfiguration=s,this._memoryConfigurationByResource=a,this._freeze=c,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new n.ResourceMap,this._userConfiguration=null}getValue(e,t,i){return this.getConsolidateConfigurationModel(t,i).getValue(e)}updateValue(e,t,i={}){let n;i.resource?(n=this._memoryConfigurationByResource.get(i.resource))||(n=new m,this._memoryConfigurationByResource.set(i.resource,n)):n=this._memoryConfiguration,void 0===t?n.removeValue(e):n.setValue(e,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,t,i){
const n=this.getConsolidateConfigurationModel(t,i),o=this.getFolderConfigurationModelForResource(t.resource,i),s=t.resource&&this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration,a=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),c=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),l=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),u=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),d=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,h=o?t.overrideIdentifier?o.freeze().override(t.overrideIdentifier).getValue(e):o.freeze().getValue(e):void 0,p=t.overrideIdentifier?s.override(t.overrideIdentifier).getValue(e):s.getValue(e),m=n.getValue(e),f=r.distinct(r.flatten(n.overrides.map(e=>e.identifiers))).filter(t=>void 0!==n.getOverrideValue(e,t))
;return{defaultValue:a,userValue:c,userLocalValue:l,userRemoteValue:u,workspaceValue:d,workspaceFolderValue:h,memoryValue:p,value:m,default:void 0!==a?{value:this._defaultConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,user:void 0!==c?{value:this.userConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userLocal:void 0!==l?{value:this.localUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,userRemote:void 0!==u?{value:this.remoteUserConfiguration.freeze().getValue(e),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspace:void 0!==d?{value:this._workspaceConfiguration.freeze().getValue(e),
override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,workspaceFolder:void 0!==h?{value:null==o?void 0:o.freeze().getValue(e),override:t.overrideIdentifier?null==o?void 0:o.freeze().getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,memory:void 0!==p?{value:s.getValue(e),override:t.overrideIdentifier?s.getOverrideValue(e,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:f.length?f:void 0}}keys(e){const t=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,
this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,t){this._folderConfigurations.set(e,t),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,t){const i=t.filter(e=>c.OVERRIDE_PROPERTY_PATTERN.test(e)).map(t=>{
const i=l.overrideIdentifierFromKey(t),n=this._defaultConfiguration.getKeysForOverrideIdentifier(i),r=e.getKeysForOverrideIdentifier(i),o=[...r.filter(e=>-1===n.indexOf(e)),...n.filter(e=>-1===r.indexOf(e)),...n.filter(t=>!s.equals(this._defaultConfiguration.override(i).getValue(t),e.override(i).getValue(t)))];return[i,o]});return this.updateDefaultConfiguration(e),{keys:t,overrides:i}}compareAndUpdateLocalUserConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.localUserConfiguration,e),o=[...t,...i,...n];return o.length&&this.updateLocalUserConfiguration(e),{keys:o,overrides:r}}compareAndUpdateRemoteUserConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.remoteUserConfiguration,e);let o=[...t,...i,...n];return o.length&&this.updateRemoteUserConfiguration(e),{keys:o,overrides:r}}compareAndUpdateWorkspaceConfiguration(e){const{added:t,updated:i,removed:n,overrides:r}=l.compare(this.workspaceConfiguration,e);let o=[...t,...i,...n]
;return o.length&&this.updateWorkspaceConfiguration(e),{keys:o,overrides:r}}compareAndUpdateFolderConfiguration(e,t){const i=this.folderConfigurations.get(e),{added:n,updated:r,removed:o,overrides:s}=l.compare(i,t);let a=[...n,...r,...o];return!a.length&&i||this.updateFolderConfiguration(e,t),{keys:a,overrides:s}}compareAndDeleteFolderConfiguration(e){const t=this.folderConfigurations.get(e);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:i,updated:n,removed:r,overrides:o}=l.compare(t,void 0);return{keys:[...i,...n,...r],overrides:o}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){
return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,t){let i=this.getConsolidatedConfigurationModelForResource(e,t);return e.overrideIdentifier?i.override(e.overrideIdentifier):i}getConsolidatedConfigurationModelForResource({resource:e},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&e){const n=t.getFolder(e);n&&(i=this.getFolderConsolidatedConfiguration(n.uri)||i);const r=this._memoryConfigurationByResource.get(e);r&&(i=i.merge(r))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){
let t=this._foldersConsolidatedConfigurations.get(e);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),n=this._folderConfigurations.get(e);n?(t=i.merge(n),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(e,t)):t=i}return t}getFolderConfigurationModelForResource(e,t){if(t&&e){const i=t.getFolder(e);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,t)=>{const{contents:i,overrides:n,keys:r}=this._folderConfigurations.get(t);return e.push([t,{contents:i,overrides:n,keys:r}]),e},[])}}allKeys(){
const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>e.add(t)),this.userConfiguration.freeze().keys.forEach(t=>e.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>e.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(t=>e.add(t))),n.values(e)}getAllKeysForOverrideIdentifier(e){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(e).forEach(e=>t.add(e))),n.values(t)}static parse(e){const t=this.parseConfigurationModel(e.defaults),i=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),o=e.folders.reduce((e,t)=>(e.set(a.URI.revive(t[0]),this.parseConfigurationModel(t[1])),e),new n.ResourceMap);return new v(t,i,new m,r,o,new m,new n.ResourceMap,!1)}
static parseConfigurationModel(e){return new m(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v,t.mergeChanges=function(...e){if(0===e.length)return{keys:[],overrides:[]};if(1===e.length)return e[0];const t=new Set,i=new Map;for(const r of e)r.keys.forEach(e=>t.add(e)),r.overrides.forEach(([e,t])=>{const r=n.getOrSet(i,e,new Set);t.forEach(e=>r.add(e))});const r=[];return i.forEach((e,t)=>r.push([t,n.values(e)])),{keys:n.values(t),overrides:r}};class _{constructor(e,t,i,r){this.change=e,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const o=new Set;e.keys.forEach(e=>o.add(e)),e.overrides.forEach(([,e])=>e.forEach(e=>o.add(e))),this.affectedKeys=n.values(o);const s=new m;this.affectedKeys.forEach(e=>s.setValue(e,{})),this.affectedKeysTree=s.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,t){var i
;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(t){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,t,null===(i=this.previous)||void 0===i?void 0:i.workspace):void 0,r=this.currentConfiguraiton.getValue(e,t,this.currentWorkspace);return!s.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,t){let i,n=l.toValuesTree({[t]:!0},()=>{});for(;"object"==typeof n&&(i=Object.keys(n)[0]);){if(!(e=e[i]))return!1;n=n[i]}return!0}}t.ConfigurationChangeEvent=_;t.AllKeysConfigurationChangeEvent=class extends _{constructor(e,t,i,n){super({keys:e.allKeys(),overrides:[]},void 0,e,t),this.source=i,this.sourceConfig=n}}})),define(t[90],i([1,0,4]),(function(e,t,i){"use strict";var n;Object.defineProperty(t,"__esModule",{value:!0}),t.RemoteAuthorityResolverError=t.RemoteAuthorityResolverErrorCode=t.IRemoteAuthorityResolverService=void 0,t.IRemoteAuthorityResolverService=i.createDecorator("remoteAuthorityResolverService"),function(e){e.Unknown="Unknown",
e.NotAvailable="NotAvailable",e.TemporarilyNotAvailable="TemporarilyNotAvailable",e.NoResolverFound="NoResolverFound"}(n=t.RemoteAuthorityResolverErrorCode||(t.RemoteAuthorityResolverErrorCode={}));class r extends Error{constructor(e,t=n.Unknown,i){super(e),this._message=e,this._code=t,this._detail=i,this.isHandled=t===n.NotAvailable&&!0===i,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,r.prototype)}static isTemporarilyNotAvailable(e){return e instanceof r&&e._code===n.TemporarilyNotAvailable}static isNoResolverFound(e){return e instanceof r&&e._code===n.NoResolverFound}static isHandled(e){return e instanceof r&&e.isHandled}}t.RemoteAuthorityResolverError=r})),define(t[91],i([1,0,20]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getRemoteName=t.getRemoteAuthority=t.REMOTE_HOST_SCHEME=void 0,t.REMOTE_HOST_SCHEME=i.Schemas.vscodeRemote,t.getRemoteAuthority=function(e){return e.scheme===t.REMOTE_HOST_SCHEME?e.authority:void 0},
t.getRemoteName=function(e){if(!e)return;const t=e.indexOf("+");return t<0?e:e.substr(0,t)}})),define(t[136],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SignService=void 0;t.SignService=class{vsda(){return new Promise((t,i)=>e(["vsda"],t,i))}async sign(e){try{const t=new((await this.vsda()).signer);if(t)return t.sign(e)}catch(e){}return e}}})),define(t[61],i([1,0,4,137,2,9,7,23,229,55,20,104,34,91]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p){"use strict";function m(e){return e.hasOwnProperty("folderUri")}function f(e){return g(e)||v(e)}function g(e){return e&&"object"==typeof e&&"string"==typeof e.path&&(!e.name||"string"==typeof e.name)}function v(e){return e&&"object"==typeof e&&"string"==typeof e.uri&&(!e.name||"string"==typeof e.name)}function _(e){return e instanceof r.URI}Object.defineProperty(t,"__esModule",{value:!0}),
t.toStoreData=t.restoreRecentlyOpened=t.useSlashForPath=t.rewriteWorkspaceFileForNewLocation=t.getStoredWorkspaceFolder=t.hasWorkspaceFileExtension=t.isSingleFolderWorkspaceInitializationPayload=t.isUntitledWorkspace=t.toWorkspaceIdentifier=t.isWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.isRawUriWorkspaceFolder=t.isRawFileWorkspaceFolder=t.isStoredWorkspaceFolder=t.reviveWorkspaceIdentifier=t.isRecentFile=t.isRecentFolder=t.isRecentWorkspace=t.IWorkspacesService=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=void 0,t.WORKSPACE_EXTENSION="code-workspace",t.WORKSPACE_FILTER=[{name:n.localize(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json",t.IWorkspacesService=i.createDecorator("workspacesService"),t.isRecentWorkspace=function(e){return e.hasOwnProperty("workspace")},t.isRecentFolder=m,t.isRecentFile=function(e){return e.hasOwnProperty("fileUri")},t.reviveWorkspaceIdentifier=function(e){return{id:e.id,configPath:r.URI.revive(e.configPath)}
},t.isStoredWorkspaceFolder=f,t.isRawFileWorkspaceFolder=g,t.isRawUriWorkspaceFolder=v,t.isSingleFolderWorkspaceIdentifier=_,t.isWorkspaceIdentifier=function(e){const t=e;return t&&"string"==typeof t.id&&t.configPath instanceof r.URI},t.toWorkspaceIdentifier=function(e){return e.configuration?{configPath:e.configuration,id:e.id}:1===e.folders.length?e.folders[0].uri:void 0},t.isUntitledWorkspace=function(e,t){return a.isEqualOrParent(e,t.untitledWorkspacesHome)},t.isSingleFolderWorkspaceInitializationPayload=function(e){return _(e.folder)};const y="."+t.WORKSPACE_EXTENSION;t.hasWorkspaceFileExtension=function(e){return("string"==typeof e?s.extname(e):a.extname(e))===y};const w="/";function b(e,t,i,n,r=!o.isWindows){if(e.scheme!==n.scheme)return{name:i,uri:e.toString(!0)};let s=t?void 0:a.relativePath(n,e);if(void 0!==s)0===s.length?s=".":o.isWindows&&e.scheme===u.Schemas.file&&!r&&(s=s.replace(/\//g,"\\"));else if(e.scheme===u.Schemas.file)s=e.fsPath,o.isWindows&&(s=d.normalizeDriveLetter(s),
r&&(s=h.toSlashes(s)));else{if(!a.isEqualAuthority(e.authority,n.authority))return{name:i,uri:e.toString(!0)};s=e.path}return{name:i,path:s}}function E(e){return!o.isWindows||e.some(e=>g(e)&&e.path.indexOf(w)>=0)}t.getStoredWorkspaceFolder=b,t.rewriteWorkspaceFileForNewLocation=function(e,t,i,n){let u=function(e,t){let i=l.parse(t);if(!i||!Array.isArray(i.folders))throw new Error(`${e} looks like an invalid workspace file.`);i.folders=i.folders.filter(e=>f(e));return i}(t,e);const d=a.dirname(t),h=a.dirname(n),m=[],v=E(u.folders);for(const e of u.folders){const t=g(e)?a.resolvePath(d,e.path):r.URI.parse(e.uri);let n;n=!i&&(!g(e)||s.isAbsolute(e.path)),m.push(b(t,n,e.name,h,v))}const _={insertSpaces:!1,tabSize:4,eol:o.isLinux||o.isMacintosh?"\n":"\r\n"},y=c.setProperty(e,["folders"],m,_);let w=c.applyEdits(e,y);return u.remoteAuthority===p.getRemoteAuthority(n)&&(w=c.applyEdits(w,c.removeProperty(w,["remoteAuthority"],_))),w},t.useSlashForPath=E,t.restoreRecentlyOpened=function(e,t){const i={workspaces:[],
files:[]};if(e){const n=function(e,i){for(let n=0;n<e.length;n++)try{i(e[n],n)}catch(i){t.warn(`Error restoring recent entry ${JSON.stringify(e[n])}: ${i.toString()}. Skip entry.`)}},o=e;Array.isArray(o.workspaces3)?n(o.workspaces3,(e,t)=>{const n=Array.isArray(o.workspaceLabels)&&o.workspaceLabels[t]||void 0;"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configURIPath?i.workspaces.push({label:n,workspace:{id:e.id,configPath:r.URI.parse(e.configURIPath)}}):"string"==typeof e&&i.workspaces.push({label:n,folderUri:r.URI.parse(e)})}):Array.isArray(o.workspaces2)?n(o.workspaces2,e=>{"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configPath?i.workspaces.push({workspace:{id:e.id,configPath:r.URI.file(e.configPath)}}):"string"==typeof e&&i.workspaces.push({folderUri:r.URI.parse(e)})}):Array.isArray(o.workspaces)&&n(o.workspaces,e=>{"string"==typeof e?i.workspaces.push({folderUri:r.URI.file(e)}):!function(e){return"object"==typeof e&&"string"==typeof e.id&&"string"==typeof e.configPath
}(e)?function(e){return e&&"string"==typeof e.path&&"string"==typeof e.scheme}(e)&&i.workspaces.push({folderUri:r.URI.revive(e)}):i.workspaces.push({workspace:{id:e.id,configPath:r.URI.file(e.configPath)}})}),Array.isArray(o.files2)?n(o.files2,(e,t)=>{const n=Array.isArray(o.fileLabels)&&o.fileLabels[t]||void 0;"string"==typeof e&&i.files.push({label:n,fileUri:r.URI.parse(e)})}):Array.isArray(o.files)&&n(o.files,e=>{"string"==typeof e&&i.files.push({fileUri:r.URI.file(e)})})}return i},t.toStoreData=function(e){const t={workspaces3:[],files2:[]};let i=!1;const n=[];for(const r of e.workspaces)m(r)?t.workspaces3.push(r.folderUri.toString()):t.workspaces3.push({id:r.workspace.id,configURIPath:r.workspace.configPath.toString()}),n.push(r.label||null),i=i||!!r.label;i&&(t.workspaceLabels=n),i=!1;const r=[];for(const n of e.files)t.files2.push(n.fileUri.toString()),r.push(n.label||null),i=i||!!n.label;return i&&(t.fileLabels=r),t}})),define(t[93],i([1,0,2,23,4,26,61]),(function(e,t,i,n,r,o,s){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.toWorkspaceFolders=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.IWorkspaceFolder=t.IWorkspace=t.WorkbenchState=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=r.createDecorator("contextService"),function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"}(t.WorkbenchState||(t.WorkbenchState={})),function(e){e.isIWorkspace=function(e){return e&&"object"==typeof e&&"string"==typeof e.id&&Array.isArray(e.folders)}}(t.IWorkspace||(t.IWorkspace={})),function(e){e.isIWorkspaceFolder=function(e){return e&&"object"==typeof e&&i.URI.isUri(e.uri)&&"string"==typeof e.name&&"function"==typeof e.toResource}}(t.IWorkspaceFolder||(t.IWorkspaceFolder={}));t.Workspace=class{constructor(e,t=[],i=null){this._id=e,this._configuration=i,this._foldersMap=o.TernarySearchTree.forUris(),this.folders=t}update(e){this._id=e.id,this._configuration=e.configuration,this.folders=e.folders}get folders(){return this._folders}set folders(e){
this._folders=e,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(e){this._configuration=e}getFolder(e){return e&&this._foldersMap.findSubstr(e.with({scheme:e.scheme,authority:e.authority,path:e.path}))||null}updateFoldersMap(){this._foldersMap=o.TernarySearchTree.forUris();for(const e of this.folders)this._foldersMap.set(e.uri,e)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}};class a{constructor(e,t){this.raw=t,this.uri=e.uri,this.index=e.index,this.name=e.name}toResource(e){return n.joinPath(this.uri,e)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=a,t.toWorkspaceFolder=function(e){return new a({uri:e,index:0,name:n.basenameOrAuthority(e)},{uri:e.toString()})},t.toWorkspaceFolders=function(e,t){let r=[],o=new Set;const c=n.dirname(t);for(let t of e){let e=null;if(s.isRawFileWorkspaceFolder(t))t.path&&(e=n.resolvePath(c,t.path));else if(s.isRawUriWorkspaceFolder(t))try{
"/"!==(e=i.URI.parse(t.uri)).path[0]&&(e=e.with({path:"/"+e.path}))}catch(e){console.warn(e)}if(e){let i=n.getComparisonKey(e);if(!o.has(i)){o.add(i);const s=t.name||n.basenameOrAuthority(e);r.push(new a({uri:e,name:s,index:r.length},t))}}}return r}})),define(t[94],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Cache=void 0;let i=(()=>{class e{constructor(e){this.id=e,this._data=new Map,this._idPool=1}add(e){const t=this._idPool++;return this._data.set(t,e),this.logDebugInfo(),t}get(e,t){return this._data.has(e)?this._data.get(e)[t]:void 0}delete(e){this._data.delete(e),this.logDebugInfo()}logDebugInfo(){e.enableDebugLogging&&console.log(`${this.id} cache size — ${this._data.size}`)}}return e.enableDebugLogging=!1,e})();t.Cache=i})),define(t[25],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostInitDataService=void 0,t.IExtHostInitDataService=i.createDecorator("IExtHostInitDataService")})),
define(t[141],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionMemento=void 0;t.ExtensionMemento=class{constructor(e,t,i){this._id=e,this._shared=t,this._storage=i,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(e=>(this._value=e,this)),this._storageListener=this._storage.onDidChangeStorage(e=>{e.shared===this._shared&&e.key===this._id&&(this._value=e.value)})}get whenReady(){return this._init}get(e,t){let i=this._value[e];return void 0===i&&(i=t),i}update(e,t){return this._value[e]=t,this._storage.setValue(this._shared,this._id,this._value)}dispose(){this._storageListener.dispose()}}})),define(t[14],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostRpcService=t.IExtHostRpcService=void 0,t.IExtHostRpcService=i.createDecorator("IExtHostRpcService");t.ExtHostRpcService=class{constructor(e){this.getProxy=e.getProxy.bind(e),this.set=e.set.bind(e),
this.assertRegistered=e.assertRegistered.bind(e)}}})),define(t[58],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionStoragePaths=void 0,t.IExtensionStoragePaths=i.createDecorator("IExtensionStoragePaths")}));var n=this&&this.__decorate||function(e,t,i,n){var r,o=arguments.length,s=o<3?t:null===n?n=Object.getOwnPropertyDescriptor(t,i):n;if("object"==typeof Reflect&&"function"==typeof Reflect.decorate)s=Reflect.decorate(e,t,i,n);else for(var a=e.length-1;a>=0;a--)(r=e[a])&&(s=(o<3?r(s):o>3?r(t,i,s):r(t,i))||s);return o>3&&s&&Object.defineProperty(t,i,s),s},r=this&&this.__classPrivateFieldSet||function(e,t,i){if(!t.has(e))throw new TypeError("attempted to set private field on non-instance");return t.set(e,i),i},o=this&&this.__classPrivateFieldGet||function(e,t){if(!t.has(e))throw new TypeError("attempted to get private field on non-instance");return t.get(e)};define(t[10],i([1,0,13,78,19,106,8,12,2,41,45,90]),(function(e,t,i,s,a,c,l,u,d,h,p,m){"use strict"
;function f(e){function t(){return Reflect.construct(e,arguments,this.constructor)}return Object.defineProperty(t,"name",Object.getOwnPropertyDescriptor(e,"name")),Object.setPrototypeOf(t,e),Object.setPrototypeOf(t.prototype,e.prototype),t}Object.defineProperty(t,"__esModule",{value:!0}),
t.StandardTokenType=t.AuthenticationSession=t.ExtensionMode=t.TimelineItem=t.NotebookCellRunState=t.CellOutputKind=t.CellKind=t.ColorThemeKind=t.ColorTheme=t.Decoration=t.ExtensionKind=t.QuickInputButtons=t.DebugConfigurationProviderTriggerKind=t.DebugConsoleMode=t.SemanticTokensEdits=t.SemanticTokensEdit=t.SemanticTokens=t.SemanticTokensBuilder=t.SemanticTokensLegend=t.CommentMode=t.CommentThreadCollapsibleState=t.FoldingRangeKind=t.FoldingRange=t.FileSystemError=t.FileChangeType=t.LogLevel=t.EvaluatableExpression=t.DebugAdapterInlineImplementation=t.DebugAdapterServer=t.DebugAdapterExecutable=t.DataBreakpoint=t.FunctionBreakpoint=t.SourceBreakpoint=t.Breakpoint=t.RelativePattern=t.ConfigurationTarget=t.ThemeColor=t.ThemeIcon=t.TreeItemCollapsibleState=t.TreeItem=t.ProgressLocation=t.Task=t.CustomExecution=t.TaskScope=t.ShellQuoting=t.ShellExecution=t.ProcessExecution=t.TaskGroup=t.TaskPanelKind=t.TaskRevealKind=t.SourceControlInputBoxValidationType=t.ColorFormat=t.ColorPresentation=t.ColorInformation=t.Color=t.DocumentLink=t.DecorationRangeBehavior=t.TextEditorSelectionChangeKind=t.TextEditorRevealType=t.TextDocumentSaveReason=t.TextEditorLineNumbersStyle=t.StatusBarAlignment=t.ViewColumn=t.CompletionList=t.CompletionItem=t.CompletionItemTag=t.CompletionItemKind=t.CompletionTriggerKind=t.SignatureHelpTriggerKind=t.SignatureHelp=t.SignatureInformation=t.ParameterInformation=t.MarkdownString=t.CodeInset=t.CodeLens=t.CallHierarchyOutgoingCall=t.CallHierarchyIncomingCall=t.CallHierarchyItem=t.SelectionRange=t.CodeActionKind=t.CodeAction=t.CodeActionTrigger=t.DocumentSymbol=t.SymbolInformation=t.SymbolTag=t.SymbolKind=t.DocumentHighlight=t.DocumentHighlightKind=t.Hover=t.Diagnostic=t.DiagnosticRelatedInformation=t.Location=t.DiagnosticSeverity=t.DiagnosticTag=t.SnippetString=t.WorkspaceEdit=t.TextEdit=t.EnvironmentVariableMutatorType=t.EndOfLine=t.RemoteAuthorityResolverError=t.ResolvedAuthority=t.Selection=t.Range=t.Position=t.Disposable=void 0
;let g=(()=>{var e,t;let i=t=class{constructor(t){e.set(this,void 0),r(this,e,t)}static from(...e){let i=e;return new t((function(){if(i){for(const e of i)e&&"function"==typeof e.dispose&&e.dispose();i=void 0}}))}dispose(){"function"==typeof o(this,e)&&(o(this,e).call(this),r(this,e,void 0))}};return e=new WeakMap,i=t=n([f],i)})();t.Disposable=g;let v=(()=>{var e;let t=e=class{constructor(e,t){if(e<0)throw a.illegalArgument("line must be non-negative");if(t<0)throw a.illegalArgument("character must be non-negative");this._line=e,this._character=t}static Min(...e){if(0===e.length)throw new TypeError;let t=e[0];for(let i=1;i<e.length;i++){const n=e[i];n.isBefore(t)&&(t=n)}return t}static Max(...e){if(0===e.length)throw new TypeError;let t=e[0];for(let i=1;i<e.length;i++){const n=e[i];n.isAfter(t)&&(t=n)}return t}static isPosition(t){if(!t)return!1;if(t instanceof e)return!0;let{line:i,character:n}=t;return"number"==typeof i&&"number"==typeof n}get line(){return this._line}get character(){return this._character}
isBefore(e){return this._line<e._line||!(e._line<this._line)&&this._character<e._character}isBeforeOrEqual(e){return this._line<e._line||!(e._line<this._line)&&this._character<=e._character}isAfter(e){return!this.isBeforeOrEqual(e)}isAfterOrEqual(e){return!this.isBefore(e)}isEqual(e){return this._line===e._line&&this._character===e._character}compareTo(e){return this._line<e._line?-1:this._line>e.line?1:this._character<e._character?-1:this._character>e._character?1:0}translate(t,i=0){if(null===t||null===i)throw a.illegalArgument();let n;return void 0===t?n=0:"number"==typeof t?n=t:(n="number"==typeof t.lineDelta?t.lineDelta:0,i="number"==typeof t.characterDelta?t.characterDelta:0),0===n&&0===i?this:new e(this.line+n,this.character+i)}with(t,i=this.character){if(null===t||null===i)throw a.illegalArgument();let n;return void 0===t?n=this.line:"number"==typeof t?n=t:(n="number"==typeof t.line?t.line:this.line,i="number"==typeof t.character?t.character:this.character),
n===this.line&&i===this.character?this:new e(n,i)}toJSON(){return{line:this.line,character:this.character}}};return t=e=n([f],t)})();t.Position=v;let _=(()=>{var e;let t=e=class{constructor(e,t,i,n){let r,o;if("number"==typeof e&&"number"==typeof t&&"number"==typeof i&&"number"==typeof n?(r=new v(e,t),o=new v(i,n)):e instanceof v&&t instanceof v&&(r=e,o=t),!r||!o)throw new Error("Invalid arguments");r.isBefore(o)?(this._start=r,this._end=o):(this._start=o,this._end=r)}static isRange(t){return t instanceof e||!!t&&(v.isPosition(t.start)&&v.isPosition(t.end))}get start(){return this._start}get end(){return this._end}contains(t){return t instanceof e?this.contains(t._start)&&this.contains(t._end):t instanceof v&&(!t.isBefore(this._start)&&!this._end.isBefore(t))}isEqual(e){return this._start.isEqual(e._start)&&this._end.isEqual(e._end)}intersection(t){const i=v.Max(t.start,this._start),n=v.Min(t.end,this._end);if(!i.isAfter(n))return new e(i,n)}union(t){if(this.contains(t))return this
;if(t.contains(this))return t;const i=v.Min(t.start,this._start),n=v.Max(t.end,this.end);return new e(i,n)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(t,i=this.end){if(null===t||null===i)throw a.illegalArgument();let n;return t?v.isPosition(t)?n=t:(n=t.start||this.start,i=t.end||this.end):n=this.start,n.isEqual(this._start)&&i.isEqual(this.end)?this:new e(n,i)}toJSON(){return[this.start,this.end]}};return t=e=n([f],t)})();t.Range=_;let y=(()=>{var e;let t=e=class extends _{constructor(e,t,i,n){let r,o;if("number"==typeof e&&"number"==typeof t&&"number"==typeof i&&"number"==typeof n?(r=new v(e,t),o=new v(i,n)):e instanceof v&&t instanceof v&&(r=e,o=t),!r||!o)throw new Error("Invalid arguments");super(r,o),this._anchor=r,this._active=o}static isSelection(t){return t instanceof e||!!t&&(_.isRange(t)&&v.isPosition(t.anchor)&&v.isPosition(t.active)&&"boolean"==typeof t.isReversed)}get anchor(){return this._anchor}get active(){
return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};return t=e=n([f],t)})();t.Selection=y;t.ResolvedAuthority=class{constructor(e,t){if("string"!=typeof e||0===e.length)throw a.illegalArgument("host");if("number"!=typeof t||0===t||Math.round(t)!==t)throw a.illegalArgument("port");this.host=e,this.port=Math.round(t)}};class w extends Error{constructor(e,t=m.RemoteAuthorityResolverErrorCode.Unknown,i){super(e),this._message=e,this._code=t,this._detail=i,"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,w.prototype)}static NotAvailable(e,t){return new w(e,m.RemoteAuthorityResolverErrorCode.NotAvailable,t)}static TemporarilyNotAvailable(e){return new w(e,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}t.RemoteAuthorityResolverError=w,function(e){e[e.LF=1]="LF",e[e.CRLF=2]="CRLF"}(t.EndOfLine||(t.EndOfLine={})),function(e){e[e.Replace=1]="Replace",e[e.Append=2]="Append",
e[e.Prepend=3]="Prepend"}(t.EnvironmentVariableMutatorType||(t.EnvironmentVariableMutatorType={}));let b=(()=>{var e;let t=e=class{constructor(e,t){this._range=e,this._newText=t}static isTextEdit(t){return t instanceof e||!!t&&(_.isRange(t)&&"string"==typeof t.newText)}static replace(t,i){return new e(t,i)}static insert(t,i){return e.replace(new _(t,t),i)}static delete(t){return e.replace(t,"")}static setEndOfLine(t){const i=new e(new _(new v(0,0),new v(0,0)),"");return i.newEol=t,i}get range(){return this._range}set range(e){if(e&&!_.isRange(e))throw a.illegalArgument("range");this._range=e}get newText(){return this._newText||""}set newText(e){if(e&&"string"!=typeof e)throw a.illegalArgument("newText");this._newText=e}get newEol(){return this._newEol}set newEol(e){if(e&&"number"!=typeof e)throw a.illegalArgument("newEol");this._newEol=e}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};return t=e=n([f],t)})();t.TextEdit=b;let E=(()=>{let e=class{constructor(){this._edits=new Array}
renameFile(e,t,i,n){this._edits.push({_type:1,from:e,to:t,options:i,metadata:n})}createFile(e,t,i){this._edits.push({_type:1,from:void 0,to:e,options:t,metadata:i})}deleteFile(e,t,i){this._edits.push({_type:1,from:e,to:void 0,options:t,metadata:i})}replace(e,t,i,n){this._edits.push({_type:2,uri:e,edit:new b(t,i),metadata:n})}insert(e,t,i,n){this.replace(e,new _(t,t),i,n)}delete(e,t,i){this.replace(e,t,"",i)}has(e){return this._edits.some(t=>2===t._type&&t.uri.toString()===e.toString())}set(e,t){if(t)for(const i of t)i&&this._edits.push({_type:2,uri:e,edit:i});else{for(let t=0;t<this._edits.length;t++){const i=this._edits[t];2===i._type&&i.uri.toString()===e.toString()&&(this._edits[t]=void 0)}this._edits=i.coalesce(this._edits)}}get(e){const t=[];for(let i of this._edits)2===i._type&&i.uri.toString()===e.toString()&&t.push(i.edit);return t}entries(){const e=new Map;for(let t of this._edits)if(2===t._type){let i=e.get(t.uri.toString());i||(i=[t.uri,[]],e.set(t.uri.toString(),i)),i[1].push(t.edit)}
return[...e.values()]}allEntries(){return this._edits}get size(){return this.entries().length}toJSON(){return this.entries()}};return e=n([f],e)})();t.WorkspaceEdit=E;let x=(()=>{var e;let t=e=class{constructor(e){this._tabstop=1,this.value=e||""}static isSnippetString(t){return t instanceof e||!!t&&"string"==typeof t.value}static _escape(e){return e.replace(/\$|}|\\/g,"\\$&")}appendText(t){return this.value+=e._escape(t),this}appendTabstop(e=this._tabstop++){return this.value+="$",this.value+=e,this}appendPlaceholder(t,i=this._tabstop++){if("function"==typeof t){const i=new e;i._tabstop=this._tabstop,t(i),this._tabstop=i._tabstop,t=i.value}else t=e._escape(t);return this.value+="${",this.value+=i,this.value+=":",this.value+=t,this.value+="}",this}appendChoice(t,i=this._tabstop++){const n=e._escape(t.toString());return this.value+="${",this.value+=i,this.value+="|",this.value+=n,this.value+="|}",this}appendVariable(t,i){if("function"==typeof i){const t=new e;t._tabstop=this._tabstop,i(t),
this._tabstop=t._tabstop,i=t.value}else"string"==typeof i&&(i=i.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=t,i&&(this.value+=":",this.value+=i),this.value+="}",this}};return t=e=n([f],t)})();var C;t.SnippetString=x,function(e){e[e.Unnecessary=1]="Unnecessary",e[e.Deprecated=2]="Deprecated"}(t.DiagnosticTag||(t.DiagnosticTag={})),function(e){e[e.Hint=3]="Hint",e[e.Information=2]="Information",e[e.Warning=1]="Warning",e[e.Error=0]="Error"}(C=t.DiagnosticSeverity||(t.DiagnosticSeverity={}));let S=(()=>{var e;let t=e=class{constructor(e,t){if(this.uri=e,t)if(t instanceof _)this.range=t;else{if(!(t instanceof v))throw new Error("Illegal argument");this.range=new _(t,t)}else;}static isLocation(t){return t instanceof e||!!t&&(_.isRange(t.range)&&d.URI.isUri(t.uri))}toJSON(){return{uri:this.uri,range:this.range}}};return t=e=n([f],t)})();t.Location=S;let k=(()=>{let e=class{constructor(e,t){this.location=e,this.message=t}static is(e){
return!!e&&("string"==typeof e.message&&e.location&&_.isRange(e.location.range)&&d.URI.isUri(e.location.uri))}static isEqual(e,t){return e===t||!(!e||!t)&&(e.message===t.message&&e.location.range.isEqual(t.location.range)&&e.location.uri.toString()===t.location.uri.toString())}};return e=n([f],e)})();t.DiagnosticRelatedInformation=k;let T=(()=>{let e=class{constructor(e,t,i=C.Error){this.range=e,this.message=t,this.severity=i}toJSON(){return{severity:C[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(e,t){return e===t||!(!e||!t)&&(e.message===t.message&&e.severity===t.severity&&e.code===t.code&&e.severity===t.severity&&e.source===t.source&&e.range.isEqual(t.range)&&i.equals(e.tags,t.tags)&&i.equals(e.relatedInformation,t.relatedInformation,k.isEqual))}};return e=n([f],e)})();t.Diagnostic=T;let I=(()=>{let e=class{constructor(e,t){if(!e)throw new Error("Illegal argument, contents must be defined");Array.isArray(e)?this.contents=e:(c.isMarkdownString(e),
this.contents=[e]),this.range=t}};return e=n([f],e)})();var D;t.Hover=I,function(e){e[e.Text=0]="Text",e[e.Read=1]="Read",e[e.Write=2]="Write"}(D=t.DocumentHighlightKind||(t.DocumentHighlightKind={}));let P=(()=>{let e=class{constructor(e,t=D.Text){this.range=e,this.kind=t}toJSON(){return{range:this.range,kind:D[this.kind]}}};return e=n([f],e)})();var R;t.DocumentHighlight=P,function(e){e[e.File=0]="File",e[e.Module=1]="Module",e[e.Namespace=2]="Namespace",e[e.Package=3]="Package",e[e.Class=4]="Class",e[e.Method=5]="Method",e[e.Property=6]="Property",e[e.Field=7]="Field",e[e.Constructor=8]="Constructor",e[e.Enum=9]="Enum",e[e.Interface=10]="Interface",e[e.Function=11]="Function",e[e.Variable=12]="Variable",e[e.Constant=13]="Constant",e[e.String=14]="String",e[e.Number=15]="Number",e[e.Boolean=16]="Boolean",e[e.Array=17]="Array",e[e.Object=18]="Object",e[e.Key=19]="Key",e[e.Null=20]="Null",e[e.EnumMember=21]="EnumMember",e[e.Struct=22]="Struct",e[e.Event=23]="Event",e[e.Operator=24]="Operator",
e[e.TypeParameter=25]="TypeParameter"}(R=t.SymbolKind||(t.SymbolKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.SymbolTag||(t.SymbolTag={}));let A=(()=>{var e;let t=e=class{constructor(t,i,n,r,o){this.name=t,this.kind=i,this.containerName=o,"string"==typeof n&&(this.containerName=n),r instanceof S?this.location=r:n instanceof _&&(this.location=new S(r,n)),e.validate(this)}static validate(e){if(!e.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:R[this.kind],location:this.location,containerName:this.containerName}}};return t=e=n([f],t)})();t.SymbolInformation=A;let O=(()=>{var e;let t=e=class{constructor(t,i,n,r,o){this.name=t,this.detail=i,this.kind=n,this.range=r,this.selectionRange=o,this.children=[],e.validate(this)}static validate(t){if(!t.name)throw new Error("name must not be falsy");if(!t.range.contains(t.selectionRange))throw new Error("selectionRange must be contained in fullRange");t.children&&t.children.forEach(e.validate)}};return t=e=n([f],t)})()
;t.DocumentSymbol=O,function(e){e[e.Automatic=1]="Automatic",e[e.Manual=2]="Manual"}(t.CodeActionTrigger||(t.CodeActionTrigger={}));let L=(()=>{let e=class{constructor(e,t){this.title=e,this.kind=t}};return e=n([f],e)})();t.CodeAction=L;let M=(()=>{var e;let t=e=class{constructor(e){this.value=e}append(t){return new e(this.value?this.value+e.sep+t:t)}intersects(e){return this.contains(e)||e.contains(this)}contains(t){return this.value===t.value||l.startsWith(t.value,this.value+e.sep)}};return t.sep=".",t=e=n([f],t)})();t.CodeActionKind=M,M.Empty=new M(""),M.QuickFix=M.Empty.append("quickfix"),M.Refactor=M.Empty.append("refactor"),M.RefactorExtract=M.Refactor.append("extract"),M.RefactorInline=M.Refactor.append("inline"),M.RefactorRewrite=M.Refactor.append("rewrite"),M.Source=M.Empty.append("source"),M.SourceOrganizeImports=M.Source.append("organizeImports"),M.SourceFixAll=M.Source.append("fixAll");let N=(()=>{let e=class{constructor(e,t){if(this.range=e,this.parent=t,
t&&!t.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};return e=n([f],e)})();t.SelectionRange=N;t.CallHierarchyItem=class{constructor(e,t,i,n,r,o){this.kind=e,this.name=t,this.detail=i,this.uri=n,this.range=r,this.selectionRange=o}};t.CallHierarchyIncomingCall=class{constructor(e,t){this.fromRanges=t,this.from=e}};t.CallHierarchyOutgoingCall=class{constructor(e,t){this.fromRanges=t,this.to=e}};let F=(()=>{let e=class{constructor(e,t){this.range=e,this.command=t}get isResolved(){return!!this.command}};return e=n([f],e)})();t.CodeLens=F;t.CodeInset=class{constructor(e,t){this.range=e,this.height=t}};let U=(()=>{let e=class{constructor(e,t=!1){this.value=null!=e?e:"",this.supportThemeIcons=t}appendText(e){return this.value+=(this.supportThemeIcons?s.escapeCodicons(e):e).replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&").replace("\n","\n\n"),this}appendMarkdown(e){return this.value+=e,this}appendCodeblock(e,t=""){return this.value+="\n```",this.value+=t,this.value+="\n",
this.value+=e,this.value+="\n```\n",this}};return e=n([f],e)})();t.MarkdownString=U;let H=(()=>{let e=class{constructor(e,t){this.label=e,this.documentation=t}};return e=n([f],e)})();t.ParameterInformation=H;let $=(()=>{let e=class{constructor(e,t){this.label=e,this.documentation=t,this.parameters=[]}};return e=n([f],e)})();t.SignatureInformation=$;let W=(()=>{let e=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};return e=n([f],e)})();var z;t.SignatureHelp=W,function(e){e[e.Invoke=1]="Invoke",e[e.TriggerCharacter=2]="TriggerCharacter",e[e.ContentChange=3]="ContentChange"}(t.SignatureHelpTriggerKind||(t.SignatureHelpTriggerKind={})),function(e){e[e.Invoke=0]="Invoke",e[e.TriggerCharacter=1]="TriggerCharacter",e[e.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"}(t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e[e.Text=0]="Text",e[e.Method=1]="Method",e[e.Function=2]="Function",e[e.Constructor=3]="Constructor",e[e.Field=4]="Field",
e[e.Variable=5]="Variable",e[e.Class=6]="Class",e[e.Interface=7]="Interface",e[e.Module=8]="Module",e[e.Property=9]="Property",e[e.Unit=10]="Unit",e[e.Value=11]="Value",e[e.Enum=12]="Enum",e[e.Keyword=13]="Keyword",e[e.Snippet=14]="Snippet",e[e.Color=15]="Color",e[e.File=16]="File",e[e.Reference=17]="Reference",e[e.Folder=18]="Folder",e[e.EnumMember=19]="EnumMember",e[e.Constant=20]="Constant",e[e.Struct=21]="Struct",e[e.Event=22]="Event",e[e.Operator=23]="Operator",e[e.TypeParameter=24]="TypeParameter",e[e.User=25]="User",e[e.Issue=26]="Issue"}(z=t.CompletionItemKind||(t.CompletionItemKind={})),function(e){e[e.Deprecated=1]="Deprecated"}(t.CompletionItemTag||(t.CompletionItemTag={}));let B=(()=>{let e=class{constructor(e,t){this.label=e,this.kind=t}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&z[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}}
;return e=n([f],e)})();t.CompletionItem=B;let j=(()=>{let e=class{constructor(e=[],t=!1){this.items=e,this.isIncomplete=t}};return e=n([f],e)})();t.CompletionList=j,function(e){e[e.Active=-1]="Active",e[e.Beside=-2]="Beside",e[e.One=1]="One",e[e.Two=2]="Two",e[e.Three=3]="Three",e[e.Four=4]="Four",e[e.Five=5]="Five",e[e.Six=6]="Six",e[e.Seven=7]="Seven",e[e.Eight=8]="Eight",e[e.Nine=9]="Nine"}(t.ViewColumn||(t.ViewColumn={})),function(e){e[e.Left=1]="Left",e[e.Right=2]="Right"}(t.StatusBarAlignment||(t.StatusBarAlignment={})),function(e){e[e.Off=0]="Off",e[e.On=1]="On",e[e.Relative=2]="Relative"}(t.TextEditorLineNumbersStyle||(t.TextEditorLineNumbersStyle={})),function(e){e[e.Manual=1]="Manual",e[e.AfterDelay=2]="AfterDelay",e[e.FocusOut=3]="FocusOut"}(t.TextDocumentSaveReason||(t.TextDocumentSaveReason={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",e[e.AtTop=3]="AtTop"}(t.TextEditorRevealType||(t.TextEditorRevealType={})),
function(e){e[e.Keyboard=1]="Keyboard",e[e.Mouse=2]="Mouse",e[e.Command=3]="Command"}(t.TextEditorSelectionChangeKind||(t.TextEditorSelectionChangeKind={})),function(e){e[e.OpenOpen=0]="OpenOpen",e[e.ClosedClosed=1]="ClosedClosed",e[e.OpenClosed=2]="OpenClosed",e[e.ClosedOpen=3]="ClosedOpen"}(t.DecorationRangeBehavior||(t.DecorationRangeBehavior={})),function(e){e.fromValue=function(t){switch(t){case"keyboard":return e.Keyboard;case"mouse":return e.Mouse;case"api":return e.Command}}}(t.TextEditorSelectionChangeKind||(t.TextEditorSelectionChangeKind={}));let V=(()=>{let e=class{constructor(e,t){if(t&&!d.URI.isUri(t))throw a.illegalArgument("target");if(!_.isRange(e)||e.isEmpty)throw a.illegalArgument("range");this.range=e,this.target=t}};return e=n([f],e)})();t.DocumentLink=V;let K=(()=>{let e=class{constructor(e,t,i,n){this.red=e,this.green=t,this.blue=i,this.alpha=n}};return e=n([f],e)})();t.Color=K;let q=(()=>{let e=class{constructor(e,t){if(t&&!(t instanceof K))throw a.illegalArgument("color")
;if(!_.isRange(e)||e.isEmpty)throw a.illegalArgument("range");this.range=e,this.color=t}};return e=n([f],e)})();t.ColorInformation=q;let G=(()=>{let e=class{constructor(e){if(!e||"string"!=typeof e)throw a.illegalArgument("label");this.label=e}};return e=n([f],e)})();t.ColorPresentation=G,function(e){e[e.RGB=0]="RGB",e[e.HEX=1]="HEX",e[e.HSL=2]="HSL"}(t.ColorFormat||(t.ColorFormat={})),function(e){e[e.Error=0]="Error",e[e.Warning=1]="Warning",e[e.Information=2]="Information"}(t.SourceControlInputBoxValidationType||(t.SourceControlInputBoxValidationType={})),function(e){e[e.Always=1]="Always",e[e.Silent=2]="Silent",e[e.Never=3]="Never"}(t.TaskRevealKind||(t.TaskRevealKind={})),function(e){e[e.Shared=1]="Shared",e[e.Dedicated=2]="Dedicated",e[e.New=3]="New"}(t.TaskPanelKind||(t.TaskPanelKind={}));let X=(()=>{var e;let t=e=class{constructor(e,t){if("string"!=typeof e)throw a.illegalArgument("name");if("string"!=typeof t)throw a.illegalArgument("name");this._id=e}static from(t){switch(t){case"clean":
return e.Clean;case"build":return e.Build;case"rebuild":return e.Rebuild;case"test":return e.Test;default:return}}get id(){return this._id}};return t.Clean=new e("clean","Clean"),t.Build=new e("build","Build"),t.Rebuild=new e("rebuild","Rebuild"),t.Test=new e("test","Test"),t=e=n([f],t)})();function Q(e){let t="";for(let i=0;i<e.length;i++)t+=e[i].replace(/,/g,",,")+",";return t}t.TaskGroup=X;let Y=(()=>{let e=class{constructor(e,t,i){if("string"!=typeof e)throw a.illegalArgument("process");this._args=[],this._process=e,void 0!==t&&(Array.isArray(t)?(this._args=t,this._options=i):this._options=t)}get process(){return this._process}set process(e){if("string"!=typeof e)throw a.illegalArgument("process");this._process=e}get args(){return this._args}set args(e){Array.isArray(e)||(e=[]),this._args=e}get options(){return this._options}set options(e){this._options=e}computeId(){const e=[];if(e.push("process"),void 0!==this._process&&e.push(this._process),
this._args&&this._args.length>0)for(let t of this._args)e.push(t);return Q(e)}};return e=n([f],e)})();t.ProcessExecution=Y;let J=(()=>{let e=class{constructor(e,t,i){if(this._args=[],Array.isArray(t)){if(!e)throw a.illegalArgument("command can't be undefined or null");if("string"!=typeof e&&"string"!=typeof e.value)throw a.illegalArgument("command");this._command=e,this._args=t,this._options=i}else{if("string"!=typeof e)throw a.illegalArgument("commandLine");this._commandLine=e,this._options=t}}get commandLine(){return this._commandLine}set commandLine(e){if("string"!=typeof e)throw a.illegalArgument("commandLine");this._commandLine=e}get command(){return this._command?this._command:""}set command(e){if("string"!=typeof e&&"string"!=typeof e.value)throw a.illegalArgument("command");this._command=e}get args(){return this._args}set args(e){this._args=e||[]}get options(){return this._options}set options(e){this._options=e}computeId(){const e=[];if(e.push("shell"),
void 0!==this._commandLine&&e.push(this._commandLine),void 0!==this._command&&e.push("string"==typeof this._command?this._command:this._command.value),this._args&&this._args.length>0)for(let t of this._args)e.push("string"==typeof t?t:t.value);return Q(e)}};return e=n([f],e)})();var Z;t.ShellExecution=J,function(e){e[e.Escape=1]="Escape",e[e.Strong=2]="Strong",e[e.Weak=3]="Weak"}(t.ShellQuoting||(t.ShellQuoting={})),function(e){e[e.Global=1]="Global",e[e.Workspace=2]="Workspace"}(Z=t.TaskScope||(t.TaskScope={}));class ee{constructor(e){this._callback=e}computeId(){return"customExecution"+h.generateUuid()}set callback(e){this._callback=e}get callback(){return this._callback}}t.CustomExecution=ee;let te=(()=>{var e;let t=e=class{constructor(e,t,i,n,r,o){let s;this.__deprecated=!1,this._definition=this.definition=e,"string"==typeof t?(this._name=this.name=t,this._source=this.source=i,this.execution=n,s=r,this.__deprecated=!0):(t===Z.Global||Z.Workspace,this.target=t,this._name=this.name=i,
this._source=this.source=n,this.execution=r,s=o),"string"==typeof s?(this._problemMatchers=[s],this._hasDefinedMatchers=!0):Array.isArray(s)?(this._problemMatchers=s,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(e){this.__id=e}get _deprecated(){return this.__deprecated}clear(){void 0!==this.__id&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Y?this._definition={type:e.ProcessType,id:this._execution.computeId()}:this._execution instanceof J?this._definition={type:e.ShellType,id:this._execution.computeId()}:this._execution instanceof ee?this._definition={type:e.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:e.EmptyType,id:h.generateUuid()}}get definition(){return this._definition}set definition(e){
if(null==e)throw a.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=e}get scope(){return this._scope}set target(e){this.clear(),this._scope=e}get name(){return this._name}set name(e){if("string"!=typeof e)throw a.illegalArgument("name");this.clear(),this._name=e}get execution(){return this._execution}set execution(t){null===t&&(t=void 0),this.clear(),this._execution=t;const i=this._definition.type;e.EmptyType!==i&&e.ProcessType!==i&&e.ShellType!==i&&e.ExtensionCallbackType!==i||this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(e){if(!Array.isArray(e))return this.clear(),this._problemMatchers=[],void(this._hasDefinedMatchers=!1);this.clear(),this._problemMatchers=e,this._hasDefinedMatchers=!0}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(e){!0!==e&&!1!==e&&(e=!1),this.clear(),this._isBackground=e}get source(){return this._source}set source(e){
if("string"!=typeof e||0===e.length)throw a.illegalArgument("source must be a string of length > 0");this.clear(),this._source=e}get group(){return this._group}set group(e){null===e&&(e=void 0),this.clear(),this._group=e}get detail(){return this._detail}set detail(e){null===e&&(e=void 0),this._detail=e}get presentationOptions(){return this._presentationOptions}set presentationOptions(e){null==e&&(e=Object.create(null)),this.clear(),this._presentationOptions=e}get runOptions(){return this._runOptions}set runOptions(e){null==e&&(e=Object.create(null)),this.clear(),this._runOptions=e}};return t.ExtensionCallbackType="customExecution",t.ProcessType="process",t.ShellType="shell",t.EmptyType="$empty",t=e=n([f],t)})();t.Task=te,function(e){e[e.SourceControl=1]="SourceControl",e[e.Window=10]="Window",e[e.Notification=15]="Notification"}(t.ProgressLocation||(t.ProgressLocation={}));let ie=(()=>{let e=class{constructor(e,t=ne.None){this.collapsibleState=t,d.URI.isUri(e)?this.resourceUri=e:this.label=e}}
;return e=n([f],e)})();var ne;t.TreeItem=ie,function(e){e[e.None=0]="None",e[e.Collapsed=1]="Collapsed",e[e.Expanded=2]="Expanded"}(ne=t.TreeItemCollapsibleState||(t.TreeItemCollapsibleState={}));let re=(()=>{let e=class{constructor(e){this.id=e}};return e=n([f],e)})();t.ThemeIcon=re,re.File=new re("file"),re.Folder=new re("folder");let oe=(()=>{let e=class{constructor(e){this.id=e}};return e=n([f],e)})();t.ThemeColor=oe,function(e){e[e.Global=1]="Global",e[e.Workspace=2]="Workspace",e[e.WorkspaceFolder=3]="WorkspaceFolder"}(t.ConfigurationTarget||(t.ConfigurationTarget={}));let se=(()=>{let e=class{constructor(e,t){if(!("string"==typeof e||e&&d.URI.isUri(e.uri)))throw a.illegalArgument("base");if("string"!=typeof t)throw a.illegalArgument("pattern");"string"==typeof e?this.base=e:(this.baseFolder=e.uri,this.base=e.uri.fsPath),this.pattern=t}};return e=n([f],e)})();t.RelativePattern=se;let ae=(()=>{let e=class{constructor(e,t,i,n){this.enabled="boolean"!=typeof e||e,"string"==typeof t&&(this.condition=t),
"string"==typeof i&&(this.hitCondition=i),"string"==typeof n&&(this.logMessage=n)}get id(){return this._id||(this._id=h.generateUuid()),this._id}};return e=n([f],e)})();t.Breakpoint=ae;let ce=(()=>{let e=class extends ae{constructor(e,t,i,n,r){if(super(t,i,n,r),null===e)throw a.illegalArgument("location");this.location=e}};return e=n([f],e)})();t.SourceBreakpoint=ce;let le=(()=>{let e=class extends ae{constructor(e,t,i,n,r){if(super(t,i,n,r),!e)throw a.illegalArgument("functionName");this.functionName=e}};return e=n([f],e)})();t.FunctionBreakpoint=le;let ue=(()=>{let e=class extends ae{constructor(e,t,i,n,r,o,s){if(super(n,r,o,s),!t)throw a.illegalArgument("dataId");this.label=e,this.dataId=t,this.canPersist=i}};return e=n([f],e)})();t.DataBreakpoint=ue;let de=(()=>{let e=class{constructor(e,t,i){this.command=e,this.args=t||[],this.options=i}};return e=n([f],e)})();t.DebugAdapterExecutable=de;let he=(()=>{let e=class{constructor(e,t){this.port=e,this.host=t}};return e=n([f],e)})();t.DebugAdapterServer=he
;let pe=(()=>{let e=class{constructor(e){this.implementation=e}};return e=n([f],e)})();t.DebugAdapterInlineImplementation=pe;let me=(()=>{let e=class{constructor(e,t){this.range=e,this.expression=t}};return e=n([f],e)})();t.EvaluatableExpression=me,function(e){e[e.Trace=1]="Trace",e[e.Debug=2]="Debug",e[e.Info=3]="Info",e[e.Warning=4]="Warning",e[e.Error=5]="Error",e[e.Critical=6]="Critical",e[e.Off=7]="Off"}(t.LogLevel||(t.LogLevel={})),function(e){e[e.Changed=1]="Changed",e[e.Created=2]="Created",e[e.Deleted=3]="Deleted"}(t.FileChangeType||(t.FileChangeType={}));let fe=(()=>{var e;let t=e=class extends Error{constructor(t,i=p.FileSystemProviderErrorCode.Unknown,n){var r;super(d.URI.isUri(t)?t.toString(!0):t),this.code=null!==(r=null==n?void 0:n.name)&&void 0!==r?r:"Unknown",p.markAsFileSystemProviderError(this,i),"function"==typeof Object.setPrototypeOf&&Object.setPrototypeOf(this,e.prototype),"function"==typeof Error.captureStackTrace&&"function"==typeof n&&Error.captureStackTrace(this,n)}
static FileExists(t){return new e(t,p.FileSystemProviderErrorCode.FileExists,e.FileExists)}static FileNotFound(t){return new e(t,p.FileSystemProviderErrorCode.FileNotFound,e.FileNotFound)}static FileNotADirectory(t){return new e(t,p.FileSystemProviderErrorCode.FileNotADirectory,e.FileNotADirectory)}static FileIsADirectory(t){return new e(t,p.FileSystemProviderErrorCode.FileIsADirectory,e.FileIsADirectory)}static NoPermissions(t){return new e(t,p.FileSystemProviderErrorCode.NoPermissions,e.NoPermissions)}static Unavailable(t){return new e(t,p.FileSystemProviderErrorCode.Unavailable,e.Unavailable)}};return t=e=n([f],t)})();t.FileSystemError=fe;let ge=(()=>{let e=class{constructor(e,t,i){this.start=e,this.end=t,this.kind=i}};return e=n([f],e)})();t.FoldingRange=ge,function(e){e[e.Comment=1]="Comment",e[e.Imports=2]="Imports",e[e.Region=3]="Region"}(t.FoldingRangeKind||(t.FoldingRangeKind={})),function(e){e[e.Collapsed=0]="Collapsed",e[e.Expanded=1]="Expanded"
}(t.CommentThreadCollapsibleState||(t.CommentThreadCollapsibleState={})),function(e){e[e.Editing=0]="Editing",e[e.Preview=1]="Preview"}(t.CommentMode||(t.CommentMode={}));t.SemanticTokensLegend=class{constructor(e,t=[]){this.tokenTypes=e,this.tokenModifiers=t}};class ve{constructor(e){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,e){this._hasLegend=!0;for(let t=0,i=e.tokenTypes.length;t<i;t++)this._tokenTypeStrToInt.set(e.tokenTypes[t],t);for(let t=0,i=e.tokenModifiers.length;t<i;t++)this._tokenModifierStrToInt.set(e.tokenModifiers[t],t)}}push(e,t,i,n,r){if("number"==typeof e&&"number"==typeof t&&"number"==typeof i&&"number"==typeof n&&("number"==typeof r||void 0===r))return void 0===r&&(r=0),this._pushEncoded(e,t,i,n,r);if(_.isRange(e)&&"string"==typeof t&&(void 0===(o=i)||u.isStringArray(o)))return this._push(e,t,i);var o;throw a.illegalArgument()}_push(e,t,i){
if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(e.start.line!==e.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(t))throw new Error("`tokenType` is not in the provided legend");const n=e.start.line,r=e.start.character,o=e.end.character-e.start.character,s=this._tokenTypeStrToInt.get(t);let a=0;if(i)for(const e of i){if(!this._tokenModifierStrToInt.has(e))throw new Error("`tokenModifier` is not in the provided legend");a|=1<<this._tokenModifierStrToInt.get(e)>>>0}this._pushEncoded(n,r,o,s,a)}_pushEncoded(e,t,i,n,r){if(this._dataIsSortedAndDeltaEncoded&&(e<this._prevLine||e===this._prevLine&&t<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const e=this._data.length/5|0;let t=0,i=0;for(let n=0;n<e;n++){let e=this._data[5*n],r=this._data[5*n+1];0===e?(e=t,r+=i):e+=t,this._data[5*n]=e,this._data[5*n+1]=r,t=e,i=r}}let o=e,s=t;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&0===(o-=this._prevLine)&&(s-=this._prevChar),
this._data[this._dataLen++]=o,this._data[this._dataLen++]=s,this._data[this._dataLen++]=i,this._data[this._dataLen++]=n,this._data[this._dataLen++]=r,this._prevLine=e,this._prevChar=t}static _sortAndDeltaEncode(e){let t=[];const i=e.length/5|0;for(let e=0;e<i;e++)t[e]=e;t.sort((t,i)=>{const n=e[5*t],r=e[5*i];if(n===r){return e[5*t+1]-e[5*i+1]}return n-r});const n=new Uint32Array(e.length);let r=0,o=0;for(let s=0;s<i;s++){const i=5*t[s],a=e[i+0],c=e[i+1],l=e[i+2],u=e[i+3],d=e[i+4],h=a-r,p=0===h?c-o:c,m=5*s;n[m+0]=h,n[m+1]=p,n[m+2]=l,n[m+3]=u,n[m+4]=d,r=a,o=c}return n}build(e){return this._dataIsSortedAndDeltaEncoded?new _e(new Uint32Array(this._data),e):new _e(ve._sortAndDeltaEncode(this._data),e)}}t.SemanticTokensBuilder=ve;class _e{constructor(e,t){this.resultId=t,this.data=e}}t.SemanticTokens=_e;t.SemanticTokensEdit=class{constructor(e,t,i){this.start=e,this.deleteCount=t,this.data=i}};t.SemanticTokensEdits=class{constructor(e,t){this.resultId=t,this.edits=e}},function(e){e[e.Separate=0]="Separate",
e[e.MergeWithParent=1]="MergeWithParent"}(t.DebugConsoleMode||(t.DebugConsoleMode={})),function(e){e[e.Initial=1]="Initial",e[e.Dynamic=2]="Dynamic"}(t.DebugConfigurationProviderTriggerKind||(t.DebugConfigurationProviderTriggerKind={}));let ye=(()=>{let e=class{constructor(){}};return e.Back={iconPath:"back.svg"},e=n([f],e)})();t.QuickInputButtons=ye,function(e){e[e.UI=1]="UI",e[e.Workspace=2]="Workspace"}(t.ExtensionKind||(t.ExtensionKind={}));t.Decoration=class{static validate(e){if(e.letter&&1!==e.letter.length)throw new Error("The 'letter'-property must be undefined or a single character");if(!(e.bubble||e.color||e.letter||e.priority||e.title))throw new Error("The decoration is empty")}};let we=(()=>{let e=class{constructor(e){this.kind=e}};return e=n([f],e)})();t.ColorTheme=we,function(e){e[e.Light=1]="Light",e[e.Dark=2]="Dark",e[e.HighContrast=3]="HighContrast"}(t.ColorThemeKind||(t.ColorThemeKind={})),function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){
e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(t.CellOutputKind||(t.CellOutputKind={})),function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle",e[e.Success=3]="Success",e[e.Error=4]="Error"}(t.NotebookCellRunState||(t.NotebookCellRunState={}));let be=(()=>{let e=class{constructor(e,t){this.label=e,this.timestamp=t}};return e=n([f],e)})();t.TimelineItem=be,function(e){e[e.Release=1]="Release",e[e.Development=2]="Development",e[e.Test=3]="Test"}(t.ExtensionMode||(t.ExtensionMode={}));t.AuthenticationSession=class{constructor(e,t,i,n){this.id=e,this.accessToken=t,this.account=i,this.scopes=n}},function(e){e[e.Other=0]="Other",e[e.Comment=1]="Comment",e[e.String=2]="String",e[e.RegEx=4]="RegEx"}(t.StandardTokenType||(t.StandardTokenType={}))})),define(t[75],i([1,0,56,20,8,200,85,10,13]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDocumentLine=t.ExtHostDocumentData=t.getWordDefinitionFor=t.setWordDefinitionFor=void 0;const l=new Map
;function u(e){return l.get(e)}t.setWordDefinitionFor=function(e,t){t?l.set(e,t):l.delete(e)},t.getWordDefinitionFor=u;class d extends o.MirrorTextModel{constructor(e,t,i,n,r,o,s){super(t,i,n,o),this._isDisposed=!1,this._proxy=e,this._languageId=r,this._isDirty=s}dispose(){i.ok(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(e){return c.equals(this._lines,e)}get document(){if(!this._document){const e=this;this._document={get uri(){return e._uri},get fileName(){return e._uri.fsPath},get isUntitled(){return e._uri.scheme===n.Schemas.untitled},get languageId(){return e._languageId},get version(){return e._versionId},get isClosed(){return e._isDisposed},get isDirty(){return e._isDirty},save:()=>e._save(),getText:t=>t?e._getTextInRange(t):e.getText(),get eol(){return"\n"===e._eol?a.EndOfLine.LF:a.EndOfLine.CRLF},get lineCount(){return e._lines.length},lineAt:t=>e._lineAt(t),offsetAt:t=>e._offsetAt(t),positionAt:t=>e._positionAt(t),validateRange:t=>e._validateRange(t),
validatePosition:t=>e._validatePosition(t),getWordRangeAtPosition:(t,i)=>e._getWordRangeAtPosition(t,i)}}return Object.freeze(this._document)}_acceptLanguageId(e){i.ok(!this._isDisposed),this._languageId=e}_acceptIsDirty(e){i.ok(!this._isDisposed),this._isDirty=e}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(e){const t=this._validateRange(e);if(t.isEmpty)return"";if(t.isSingleLine)return this._lines[t.start.line].substring(t.start.character,t.end.character);const i=this._eol,n=t.start.line,r=t.end.line,o=[];o.push(this._lines[n].substring(t.start.character));for(let e=n+1;e<r;e++)o.push(this._lines[e]);return o.push(this._lines[r].substring(0,t.end.character)),o.join(i)}_lineAt(e){let t;if(e instanceof a.Position?t=e.line:"number"==typeof e&&(t=e),"number"!=typeof t||t<0||t>=this._lines.length||Math.floor(t)!==t)throw new Error("Illegal value for `line`");return new h(t,this._lines[t],t===this._lines.length-1)}
_offsetAt(e){return e=this._validatePosition(e),this._ensureLineStarts(),this._lineStarts.getAccumulatedValue(e.line-1)+e.character}_positionAt(e){e=Math.floor(e),e=Math.max(0,e),this._ensureLineStarts();const t=this._lineStarts.getIndexOf(e),i=this._lines[t.index].length;return new a.Position(t.index,Math.min(t.remainder,i))}_validateRange(e){if(!(e instanceof a.Range))throw new Error("Invalid argument");const t=this._validatePosition(e.start),i=this._validatePosition(e.end);return t===e.start&&i===e.end?e:new a.Range(t.line,t.character,i.line,i.character)}_validatePosition(e){if(!(e instanceof a.Position))throw new Error("Invalid argument");if(0===this._lines.length)return e.with(0,0);let{line:t,character:i}=e,n=!1;if(t<0)t=0,i=0,n=!0;else if(t>=this._lines.length)t=this._lines.length-1,i=this._lines[t].length,n=!0;else{const e=this._lines[t].length;i<0?(i=0,n=!0):i>e&&(i=e,n=!0)}return n?new a.Position(t,i):e}_getWordRangeAtPosition(e,t){const i=this._validatePosition(e);if(t){
if(r.regExpLeadsToEndlessLoop(t))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${t.source}' because it matches the empty string.`)}else t=u(this._languageId);const n=s.getWordAtText(i.character+1,s.ensureValidWordDefinition(t),this._lines[i.line],0);if(n)return new a.Range(i.line,n.startColumn-1,i.line,n.endColumn-1)}}t.ExtHostDocumentData=d;class h{constructor(e,t,i){this._line=e,this._text=t,this._isLastLine=i}get lineNumber(){return this._line}get text(){return this._text}get range(){return new a.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new a.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}t.ExtHostDocumentLine=h}));var s=this&&this.__param||function(e,t){return function(i,n){t(i,n,e)}};define(t[146],i([1,0,10,14,3]),(function(e,t,i,r,o){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTheming=void 0;let a=(()=>{let e=class{constructor(e){this._actual=new i.ColorTheme(i.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new o.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(e){let t="light"===e?i.ColorThemeKind.Light:"dark"===e?i.ColorThemeKind.Dark:i.ColorThemeKind.HighContrast;this._actual=new i.ColorTheme(t),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};return e=n([s(0,r.IExtHostRpcService)],e)})();t.ExtHostTheming=a})),define(t[51],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.URITransformerService=t.IURITransformerService=void 0,t.IURITransformerService=i.createDecorator("IURITransformerService");t.URITransformerService=class{constructor(e){e?(this.transformIncoming=e.transformIncoming.bind(e),this.transformOutgoing=e.transformOutgoing.bind(e),
this.transformOutgoingURI=e.transformOutgoingURI.bind(e),this.transformOutgoingScheme=e.transformOutgoingScheme.bind(e)):(this.transformIncoming=e=>e,this.transformOutgoing=e=>e,this.transformOutgoingURI=e=>e,this.transformOutgoingScheme=e=>e)}}})),define(t[148],i([1,0,29,9]),(function(e,t,i,n){"use strict";var r;function o(e){for(let t=0,i=e.length;t<i;t+=4){const i=e[t+0],n=e[t+1],r=e[t+2],o=e[t+3];e[t+0]=o,e[t+1]=r,e[t+2]=n,e[t+3]=i}}Object.defineProperty(t,"__esModule",{value:!0}),t.decodeSemanticTokensDto=t.encodeSemanticTokensDto=void 0,function(e){e[e.Full=1]="Full",e[e.Delta=2]="Delta"}(r||(r={})),t.encodeSemanticTokensDto=function(e){const t=new Uint32Array(function(e){let t=0;if(t+=2,"full"===e.type)t+=1+e.data.length;else{t+=1,t+=3*e.deltas.length;for(const i of e.deltas)i.data&&(t+=i.data.length)}return t}(e));let r=0;if(t[r++]=e.id,"full"===e.type)t[r++]=1,t[r++]=e.data.length,t.set(e.data,r),r+=e.data.length;else{t[r++]=2,t[r++]=e.deltas.length;for(const i of e.deltas)t[r++]=i.start,
t[r++]=i.deleteCount,i.data?(t[r++]=i.data.length,t.set(i.data,r),r+=i.data.length):t[r++]=0}return function(e){const t=new Uint8Array(e.buffer,e.byteOffset,4*e.length);return n.isLittleEndian()||o(t),i.VSBuffer.wrap(t)}(t)},t.decodeSemanticTokensDto=function(e){const t=function(e){const t=e.buffer;if(n.isLittleEndian()||o(t),t.byteOffset%4==0)return new Uint32Array(t.buffer,t.byteOffset,t.length/4);{const e=new Uint8Array(t.byteLength);return e.set(t),new Uint32Array(e.buffer,e.byteOffset,e.length/4)}}(e);let i=0;const r=t[i++];if(1===t[i++]){const e=t[i++],n=t.subarray(i,i+e);return i+=e,{id:r,type:"full",data:n}}const s=t[i++];let a=[];for(let e=0;e<s;e++){const n=t[i++],r=t[i++],o=t[i++];let s;o>0&&(s=t.subarray(i,i+o),i+=o),a[e]={start:n,deleteCount:r,data:s}}return{id:r,type:"delta",deltas:a}}})),define(t[69],i([1,0,2]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.asWebviewUri=void 0,t.asWebviewUri=function(e,t,n){
const r=e.webviewResourceRoot.replace("{{resource}}",n.scheme+function(e){return e.toString().replace(/^\S+?:/,"")}(n)).replace("{{uuid}}",t);return i.URI.parse(r)}})),define(t[150],i([1,0,3,6,69,41]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostEditorInsets=void 0;t.ExtHostEditorInsets=class{constructor(e,t,i){this._proxy=e,this._editors=t,this._initData=i,this._handlePool=0,this._disposables=new n.DisposableStore,this._insets=new Map,this._disposables.add(t.onDidChangeVisibleTextEditors(()=>{const e=t.getVisibleTextEditors();this._insets.forEach(t=>{e.indexOf(t.editor)<0&&t.inset.dispose()})}))}dispose(){this._insets.forEach(e=>e.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(e,t,n,s,a){let c;for(const t of this._editors.getVisibleTextEditors())if(t===e){c=t;break}if(!c)throw new Error("not a visible editor");const l=this,u=this._handlePool++,d=new i.Emitter,h=new i.Emitter,p=new class{constructor(){this._uuid=o.generateUuid(),
this._html="",this._options=Object.create(null)}asWebviewUri(e){return r.asWebviewUri(l._initData,this._uuid,e)}get cspSource(){return l._initData.webviewCspSource}set options(e){this._options=e,l._proxy.$setOptions(u,e)}get options(){return this._options}set html(e){this._html=e,l._proxy.$setHtml(u,e)}get html(){return this._html}get onDidReceiveMessage(){return d.event}postMessage(e){return l._proxy.$postMessage(u,e)}},m=new class{constructor(){this.editor=e,this.line=t,this.height=n,this.webview=p,this.onDidDispose=h.event}dispose(){l._insets.has(u)&&(l._insets.delete(u),l._proxy.$disposeEditorInset(u),h.fire(),h.dispose(),d.dispose())}};return this._proxy.$createEditorInset(u,c.id,c.document.uri,t+1,n,s||{},a.identifier,a.extensionLocation),this._insets.set(u,{editor:e,inset:m,onDidReceiveMessage:d}),m}$onDidDispose(e){const t=this._insets.get(e);t&&t.inset.dispose()}$onDidReceiveMessage(e,t){const i=this._insets.get(e);i&&i.onDidReceiveMessage.fire(t)}}})),
define(t[151],i([1,0,7,2,24,25,12,11]),(function(e,t,i,r,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionStoragePaths=void 0;let u=(()=>{let e=class{constructor(e,t){this._logService=t,this._workspace=c.withNullAsUndefined(e.workspace),this._environment=e.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(e=>this._value=e)}workspaceValue(e){if(this._value)return i.join(this._value,e.identifier.value)}globalValue(e){return i.join(this._environment.globalStorageHome.fsPath,e.identifier.value.toLowerCase())}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);if(!this._environment.appSettingsHome)return;const e=this._workspace.id,t=i.join(this._environment.appSettingsHome.fsPath,"workspaceStorage",e);if(await o.dirExists(t))return t;try{return await o.mkdirp(t),await o.writeFile(i.join(t,"meta.json"),JSON.stringify({id:this._workspace.id,
configuration:this._workspace.configuration&&r.URI.revive(this._workspace.configuration).toString(),name:this._workspace.name},void 0,2)),t}catch(e){return void this._logService.error(e)}}};return e=n([s(0,a.IExtHostInitDataService),s(1,l.ILogService)],e)})();t.ExtensionStoragePaths=u})),define(t[152],i([1,0,2,18,3,23,71,231,45,6,27,93,80,12]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResourceGlobMatcher=t.ResourceContextKey=void 0;let g=(()=>{let e=class e extends d.Disposable{constructor(t,i,n){super(),this._fileService=i,this._modeService=n,this._schemeKey=e.Scheme.bindTo(t),this._filenameKey=e.Filename.bindTo(t),this._langIdKey=e.LangId.bindTo(t),this._resourceKey=e.Resource.bindTo(t),this._extensionKey=e.Extension.bindTo(t),this._hasResource=e.HasResource.bindTo(t),this._isFileSystemResource=e.IsFileSystemResource.bindTo(t),this._register(i.onDidChangeFileSystemProviderRegistrations(()=>{const e=this._resourceKey.get()
;this._isFileSystemResource.set(Boolean(e&&i.canHandleResource(e)))})),this._register(n.onDidCreateMode(()=>{const e=this._resourceKey.get();this._langIdKey.set(e?this._modeService.getModeIdByFilepathOrFirstLine(e):null)}))}set(t){e._uriEquals(this._resourceKey.get(),t)||(this._resourceKey.set(t),this._schemeKey.set(t?t.scheme:null),this._filenameKey.set(t?a.basename(t):null),this._langIdKey.set(t?this._modeService.getModeIdByFilepathOrFirstLine(t):null),this._extensionKey.set(t?a.extname(t):null),this._hasResource.set(!!t),this._isFileSystemResource.set(!!t&&this._fileService.canHandleResource(t)))}reset(){this._schemeKey.reset(),this._langIdKey.reset(),this._resourceKey.reset(),this._langIdKey.reset(),this._extensionKey.reset(),this._hasResource.reset(),this._isFileSystemResource.reset()}get(){return f.withNullAsUndefined(this._resourceKey.get())}static _uriEquals(e,t){
return e===t||!(!e||!t)&&(e.scheme===t.scheme&&e.authority===t.authority&&e.path===t.path&&e.query===t.query&&e.fragment===t.fragment&&e.toString()===t.toString())}};return e.Scheme=new c.RawContextKey("resourceScheme",void 0),e.Filename=new c.RawContextKey("resourceFilename",void 0),e.LangId=new c.RawContextKey("resourceLangId",void 0),e.Resource=new c.RawContextKey("resource",void 0),e.Extension=new c.RawContextKey("resourceExtname",void 0),e.HasResource=new c.RawContextKey("resourceSet",void 0),e.IsFileSystemResource=new c.RawContextKey("isFileSystemResource",void 0),e=n([s(0,c.IContextKeyService),s(1,u.IFileService),s(2,l.IModeService)],e)})();t.ResourceContextKey=g;let v=(()=>{let e=class e extends d.Disposable{constructor(e,t,i,n){super(),this.globFn=e,this.shouldUpdate=t,this.contextService=i,this.configurationService=n,this._onExpressionChange=this._register(new o.Emitter),this.onExpressionChange=this._onExpressionChange.event,this.mapRootToParsedExpression=new Map,
this.mapRootToExpressionConfig=new Map,this.updateExcludes(!1),this.registerListeners()}registerListeners(){this._register(this.configurationService.onDidChangeConfiguration(e=>{this.shouldUpdate(e)&&this.updateExcludes(!0)})),this._register(this.contextService.onDidChangeWorkspaceFolders(()=>this.updateExcludes(!0)))}updateExcludes(t){let n=!1;this.contextService.getWorkspace().folders.forEach(e=>{const t=this.globFn(e.uri);this.mapRootToExpressionConfig.has(e.uri.toString())&&r.equals(this.mapRootToExpressionConfig.get(e.uri.toString()),t)||(n=!0,this.mapRootToParsedExpression.set(e.uri.toString(),h.parse(t)),this.mapRootToExpressionConfig.set(e.uri.toString(),r.deepClone(t)))}),this.mapRootToExpressionConfig.forEach((t,r)=>{r!==e.NO_ROOT&&r&&!this.contextService.getWorkspaceFolder(i.URI.parse(r))&&(this.mapRootToParsedExpression.delete(r),this.mapRootToExpressionConfig.delete(r),n=!0)});const o=this.globFn()
;this.mapRootToExpressionConfig.has(e.NO_ROOT)&&r.equals(this.mapRootToExpressionConfig.get(e.NO_ROOT),o)||(n=!0,this.mapRootToParsedExpression.set(e.NO_ROOT,h.parse(o)),this.mapRootToExpressionConfig.set(e.NO_ROOT,r.deepClone(o))),t&&n&&this._onExpressionChange.fire()}matches(t){const i=this.contextService.getWorkspaceFolder(t);let n,r;return n=i&&this.mapRootToParsedExpression.has(i.uri.toString())?this.mapRootToParsedExpression.get(i.uri.toString()):this.mapRootToParsedExpression.get(e.NO_ROOT),r=i?a.relativePath(i.uri,t):t.fsPath,!!n&&"string"==typeof r&&!!n(r)}};return e.NO_ROOT=null,e=n([s(2,p.IWorkspaceContextService),s(3,m.IConfigurationService)],e)})();t.ResourceGlobMatcher=v})),define(t[98],i([1,0,3,16]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDebugAdapter=void 0;t.AbstractDebugAdapter=class{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new i.Emitter,this._onExit=new i.Emitter,this.sequence=1}get onError(){
return this._onError.event}get onExit(){return this._onExit.event}onMessage(e){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=e}onEvent(e){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=e}onRequest(e){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=e}sendResponse(e){e.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${e.command}`)):this.internalSend("response",e)}sendRequest(e,t,i,n){const r={command:e};if(t&&Object.keys(t).length>0&&(r.arguments=t),this.internalSend("request",r),"number"==typeof n){const t=setTimeout(()=>{clearTimeout(t);const i=this.pendingRequests.get(r.seq);if(i){this.pendingRequests.delete(r.seq),i({type:"response",seq:0,request_seq:r.seq,success:!1,command:e,message:`timeout after ${n} ms`})}},n)}
return i&&this.pendingRequests.set(r.seq,i),r.seq}acceptMessage(e){this.messageCallback?this.messageCallback(e):(this.queue.push(e),1===this.queue.length&&this.processQueue())}needsTaskBoundaryBetween(e,t){return"event"!==e.type||"event"!==t.type}async processQueue(){let e;for(;this.queue.length;){if(e&&!this.needsTaskBoundaryBetween(this.queue[0],e)||await n.timeout(0),!(e=this.queue.shift()))return;switch(e.type){case"event":this.eventCallback&&this.eventCallback(e);break;case"request":this.requestCallback&&this.requestCallback(e);break;case"response":const t=e,i=this.pendingRequests.get(t.request_seq);i&&(this.pendingRequests.delete(t.request_seq),i(t))}}}internalSend(e,t){t.type=e,t.seq=this.sequence++,this.sendMessage(t)}async cancelPendingRequests(){if(0===this.pendingRequests.size)return Promise.resolve();const e=new Map;this.pendingRequests.forEach((t,i)=>e.set(i,t)),await n.timeout(500),e.forEach((e,t)=>{e({type:"response",seq:0,request_seq:t,success:!1,command:"canceled",message:"canceled"}),
this.pendingRequests.delete(t)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}})),define(t[154],i([1,0,8,2,7,18]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getVisibleAndSorted=t.convertToVSCPaths=t.convertToDAPaths=t.isUri=t.getExactExpressionStartAndEnd=t.isDebuggerMainContribution=t.getExtensionHostDebugSession=t.isSessionAttach=t.filterExceptionsFromTelemetry=t.formatPII=void 0;const s=/{([^}]+)}/g;function a(e){let t=e.configuration.type;if(t)return"vslsShare"===t&&(t=e.configuration.adapterProxy.configuration.type),i.equalsIgnoreCase(t,"extensionhost")||i.equalsIgnoreCase(t,"pwa-extensionhost")?e:e.parentSession?a(e.parentSession):void 0}t.formatPII=function(e,t,i){return e.replace(s,(function(e,n){return t&&n.length>0&&"_"!==n[0]?e:i&&i.hasOwnProperty(n)?i[n]:e}))},t.filterExceptionsFromTelemetry=function(e){const t={};for(const i of Object.keys(e))i.startsWith("!")||(t[i]=e[i]);return t},
t.isSessionAttach=function(e){return"attach"===e.configuration.request&&!a(e)},t.getExtensionHostDebugSession=a,t.isDebuggerMainContribution=function(e){return e.type&&(e.label||e.program||e.runtime)},t.getExactExpressionStartAndEnd=function(e,t,i){let n=void 0,r=0,o=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,s=null;for(;s=o.exec(e);){let e=s.index+1,o=e+s[0].length;if(e<=t&&o>=i){n=s[0],r=e;break}}if(n){let e=/\w+/g,t=null;for(;t=e.exec(n);){if(t.index+1+r+t[0].length>=i)break}t&&(n=n.substring(0,e.lastIndex))}return n?{start:r,end:r+n.length-1}:{start:0,end:0}};const c=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(e){return!(!e||!e.match(c))}function u(e){if("string"==typeof e.path)if("number"==typeof e.sourceReference&&e.sourceReference>0);else{if(l(e.path))return n.URI.parse(e.path);if(r.isAbsolute(e.path))return n.URI.file(e.path)}return e.path}function d(e){if("object"==typeof e.path){const t=n.URI.revive(e.path);if(t)return"file"===t.scheme?t.fsPath:t.toString()}return e.path}function h(e,t){switch(e.type){
case"event":const i=e;switch(i.event){case"output":case"loadedSource":t(!1,i.body.source);break;case"breakpoint":t(!1,i.body.breakpoint.source)}break;case"request":const n=e;switch(n.command){case"setBreakpoints":case"breakpointLocations":case"source":case"gotoTargets":t(!0,n.arguments.source);break;case"launchVSCode":n.arguments.args.forEach(e=>t(!1,e))}break;case"response":const r=e;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(e=>t(!1,e.source));break;case"loadedSources":r.body.sources.forEach(e=>t(!1,e));break;case"scopes":r.body.scopes.forEach(e=>t(!1,e.source));break;case"setFunctionBreakpoints":case"setBreakpoints":r.body.breakpoints.forEach(e=>t(!1,e.source))}}}function p(e,t){return"number"!=typeof e?"number"!=typeof t?0:1:"number"!=typeof t?-1:e-t}t.isUri=l,t.convertToDAPaths=function(e,t){const i=t?u:d,n=o.deepClone(e);return h(n,(e,t)=>{e&&t&&(t.path=i(t))}),n},t.convertToVSCPaths=function(e,t){const i=t?u:d,n=o.deepClone(e);return h(n,(e,t)=>{
!e&&t&&(t.path=i(t))}),n},t.getVisibleAndSorted=function(e){return e.filter(e=>{var t;return!(null===(t=e.presentation)||void 0===t?void 0:t.hidden)}).sort((e,t)=>e.presentation?t.presentation?e.presentation.group?t.presentation.group?e.presentation.group!==t.presentation.group?e.presentation.group.localeCompare(t.presentation.group):p(e.presentation.order,t.presentation.order):-1:t.presentation.group?1:p(e.presentation.order,t.presentation.order):-1:t.presentation?1:0)}})),define(t[155],i([1,0,24,32,174,89,7,8,18,9,248,98]),(function(e,t,i,n,r,o,s,a,c,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExecutableDebugAdapter=t.SocketDebugAdapter=t.StreamDebugAdapter=void 0;let h=(()=>{class e extends d.AbstractDebugAdapter{constructor(){super(),this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1}connect(e,t){this.outputStream=t,this.rawData=Buffer.allocUnsafe(0),this.contentLength=-1,e.on("data",e=>this.handleData(e))}sendMessage(t){if(this.outputStream){const i=JSON.stringify(t)
;this.outputStream.write(`Content-Length: ${Buffer.byteLength(i,"utf8")}${e.TWO_CRLF}${i}`,"utf8")}}handleData(t){for(this.rawData=Buffer.concat([this.rawData,t]);;){if(this.contentLength>=0){if(this.rawData.length>=this.contentLength){const e=this.rawData.toString("utf8",0,this.contentLength);if(this.rawData=this.rawData.slice(this.contentLength),this.contentLength=-1,e.length>0)try{this.acceptMessage(JSON.parse(e))}catch(t){this._onError.fire(new Error((t.message||t)+"\n"+e))}continue}}else{const t=this.rawData.indexOf(e.TWO_CRLF);if(-1!==t){const i=this.rawData.toString("utf8",0,t).split(e.HEADER_LINESEPARATOR);for(const t of i){const i=t.split(e.HEADER_FIELDSEPARATOR);"Content-Length"===i[0]&&(this.contentLength=Number(i[1]))}this.rawData=this.rawData.slice(t+e.TWO_CRLF.length);continue}}break}}}return e.TWO_CRLF="\r\n\r\n",e.HEADER_LINESEPARATOR=/\r?\n/,e.HEADER_FIELDSEPARATOR=/: */,e})();t.StreamDebugAdapter=h;t.SocketDebugAdapter=class extends h{constructor(e){super(),this.adapterServer=e}
startSession(){return new Promise((e,t)=>{let i=!1;this.socket=o.createConnection(this.adapterServer.port,this.adapterServer.host||"127.0.0.1",()=>{this.connect(this.socket,this.socket),e(),i=!0}),this.socket.on("close",()=>{i?this._onError.fire(new Error("connection closed")):t(new Error("connection closed"))}),this.socket.on("error",e=>{i?this._onError.fire(e):t(e)})})}async stopSession(){await this.cancelPendingRequests(),this.socket&&(this.socket.end(),this.socket=void 0)}};class p extends h{constructor(e,t,i){super(),this.adapterExecutable=e,this.debugType=t,this.outputService=i}async startSession(){const e=this.adapterExecutable.command,t=this.adapterExecutable.args,o=this.adapterExecutable.options||{};try{if(!e)throw new Error(r.localize(1,null,this.debugType));if(s.isAbsolute(e)){if(!await i.exists(e))throw new Error(r.localize(0,null,e))}else e.indexOf("/")<0&&e.indexOf("\\");let a=c.mixin({},process.env);if(o.env&&(a=c.mixin(a,o.env)),"node"===e){
if(!(Array.isArray(t)&&t.length>0))throw new Error(r.localize(3,null));{const e={env:a,execArgv:!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};o.cwd&&(e.cwd=o.cwd);const i=n.fork(t[0],t.slice(1),e);if(!i.pid)throw new Error(r.localize(2,null,t[0]));this.serverProcess=i}}else{const i={env:a};o.cwd&&(i.cwd=o.cwd),this.serverProcess=n.spawn(e,t,i)}this.serverProcess.on("error",e=>{this._onError.fire(e)}),this.serverProcess.on("exit",(e,t)=>{this._onExit.fire(e)}),this.serverProcess.stdout.on("close",()=>{this._onError.fire(new Error("read error"))}),this.serverProcess.stdout.on("error",e=>{this._onError.fire(e)}),this.serverProcess.stdin.on("error",e=>{this._onError.fire(e)});const l=this.outputService;if(l){const e=e=>e.toString().replace(/\r?\n$/gm,"");this.serverProcess.stderr.on("data",t=>{const i=l.getChannel(u.ExtensionsChannelId);i&&i.append(e(t))})}
this.connect(this.serverProcess.stdout,this.serverProcess.stdin)}catch(e){this._onError.fire(e)}}async stopSession(){return this.serverProcess?(await this.cancelPendingRequests(),l.isWindows?new Promise((e,t)=>{const i=n.exec(`taskkill /F /T /PID ${this.serverProcess.pid}`,(function(e,i,n){if(e)return t(e)}));i.on("exit",e),i.on("error",t)}):(this.serverProcess.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static extract(e,t){if(!e)return;const i=Object.create(null);e.runtime&&(0===e.runtime.indexOf("./")?i.runtime=s.join(t,e.runtime):i.runtime=e.runtime),e.runtimeArgs&&(i.runtimeArgs=e.runtimeArgs),e.program&&(s.isAbsolute(e.program)?i.program=e.program:i.program=s.join(t,e.program)),e.args&&(i.args=e.args);const n=e;return n.win&&(i.win=p.extract(n.win,t)),n.winx86&&(i.winx86=p.extract(n.winx86,t)),n.windows&&(i.windows=p.extract(n.windows,t)),n.osx&&(i.osx=p.extract(n.osx,t)),n.linux&&(i.linux=p.extract(n.linux,t)),i}static platformAdapterExecutable(e,t){let i,n=Object.create(null)
;t=t.toLowerCase();for(const i of e)if(i.contributes){const e=i.contributes.debuggers;e&&e.length>0&&e.filter(e=>"string"==typeof e.type&&a.equalsIgnoreCase(e.type,t)).forEach(e=>{const t=p.extract(e,i.extensionLocation.fsPath);n=c.mixin(n,t,i.isBuiltin)})}l.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?i=n.winx86||n.win||n.windows:l.isWindows?i=n.win||n.windows:l.isMacintosh?i=n.osx:l.isLinux&&(i=n.linux);let r=(i=i||n).program||n.program;const o=i.args||n.args;let s=i.runtime||n.runtime;const u=i.runtimeArgs||n.runtimeArgs;return s?{type:"executable",command:s,args:(u||[]).concat("string"==typeof r?[r]:[]).concat(o||[])}:r?{type:"executable",command:r,args:o||[]}:void 0}}t.ExecutableDebugAdapter=p})),define(t[156],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExternalTerminalService=void 0,t.IExternalTerminalService=i.createDecorator("nativeTerminalService")})),
define(t[157],i([1,0,32,7,79,180,24,9,18,156,80,64,50,74,48,4]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinuxExternalTerminalService=t.MacExternalTerminalService=t.WindowsExternalTerminalService=t.DEFAULT_TERMINAL_OSX=void 0;const _=a.localize(0,null);t.DEFAULT_TERMINAL_OSX="Terminal.app";let y=(()=>{let e=class e{constructor(e){this._configurationService=e}openTerminal(e){if(this._configurationService){const t=this._configurationService.getValue();this.spawnTerminal(i,t,o.getWindowsShell(),e)}}runInTerminal(t,n,r,o,s){const a=s.windowsExec||e.getDefaultTerminalWindows();return new Promise((t,s)=>{const c=`"${n} - ${_}"`,l=`""${r.join('" "')}" & pause"`,d=["/c","start",c,"/wait",a,"/c",l],h=u.assign({},process.env,o);Object.keys(h).filter(e=>null===h[e]).forEach(e=>delete h[e]);const p={cwd:n,env:h,windowsVerbatimArguments:!0};i.spawn(e.CMD,d,p).on("error",e=>{s(E(e))}),t(void 0)})}spawnTerminal(t,i,n,o){
const s=i.terminal.external.windowsExec||e.getDefaultTerminalWindows();o&&":"===o[1]&&(o=o[0].toUpperCase()+o.substr(1));const a=r.basename(s).toLowerCase();if("cmder"===a||"cmder.exe"===a)return t.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return s.indexOf(" ")>=0&&c.push('""'),c.push(s),"wt"!==a&&"wt.exe"!==a||c.push("-d ."),new Promise((e,i)=>{const r=o?{cwd:o}:void 0,s=t.spawn(n,c,r);s.on("error",i),s.on("exit",()=>e())})}static getDefaultTerminalWindows(){if(!e._DEFAULT_TERMINAL_WINDOWS){const t=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");e._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${t?"Sysnative":"System32"}\\cmd.exe`}return e._DEFAULT_TERMINAL_WINDOWS}};return e.CMD="cmd.exe",e=n([s(0,v.optional(h.IConfigurationService))],e)})();t.WindowsExternalTerminalService=y;let w=(()=>{let r=class n{constructor(e){this._configurationService=e}openTerminal(e){if(this._configurationService){
const t=this._configurationService.getValue();this.spawnTerminal(i,t,e)}}runInTerminal(r,o,s,c,l){const u=l.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((l,d)=>{if(u===t.DEFAULT_TERMINAL_OSX||"iTerm.app"===u){const h=u===t.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",m=[p.getPathFromAmdModule(e,`vs/workbench/contrib/externalTerminal/node/${h}.scpt`),"-t",r||_,"-w",o];for(let e of s)m.push("-a"),m.push(e);if(c)for(let e in c){const t=c[e];null===t?(m.push("-u"),m.push(e)):(m.push("-e"),m.push(`${e}=${t}`))}let f="";const g=i.spawn(n.OSASCRIPT,m);g.on("error",e=>{d(E(e))}),g.stderr.on("data",e=>{f+=e.toString()}),g.on("exit",e=>{if(0===e)l(void 0);else if(f){const e=f.split("\n",1);d(new Error(e[0]))}else d(new Error(a.localize(1,null,h,e)))})}else d(new Error(a.localize(2,null,u)))})}spawnTerminal(e,i,n){const r=i.terminal.external.osxExec||t.DEFAULT_TERMINAL_OSX;return new Promise((t,i)=>{const o=["-a",r];n&&o.push(n);const s=e.spawn("/usr/bin/open",o);s.on("error",i),s.on("exit",()=>t())})}}
;return r.OSASCRIPT="/usr/bin/osascript",r=n([s(0,v.optional(h.IConfigurationService))],r)})();t.MacExternalTerminalService=w;let b=(()=>{let e=class e{constructor(e){this._configurationService=e}openTerminal(e){if(this._configurationService){const t=this._configurationService.getValue();this.spawnTerminal(i,t,e)}}runInTerminal(t,n,r,o,s){const c=s.linuxExec?Promise.resolve(s.linuxExec):e.getDefaultTerminalLinuxReady();return new Promise((t,s)=>{let l=[];c.then(c=>{c.indexOf("gnome-terminal")>=0?l.push("-x"):l.push("-e"),l.push("bash"),l.push("-c");const d=`${function(e){let t="";for(let i of e)i.indexOf(" ")>=0?t+='"'+i+'"':t+=i,t+=" ";return t}(r)}; echo; read -p "${e.WAIT_MESSAGE}" -n1;`;l.push(`''${d}''`);const h=u.assign({},process.env,o);Object.keys(h).filter(e=>null===h[e]).forEach(e=>delete h[e]);const p={cwd:n,env:h};let m="";const f=i.spawn(c,l,p);f.on("error",e=>{s(E(e))}),f.stderr.on("data",e=>{m+=e.toString()}),f.on("exit",e=>{if(0===e)t(void 0);else if(m){const e=m.split("\n",1)
;s(new Error(e[0]))}else s(new Error(a.localize(4,null,c,e)))})})})}spawnTerminal(t,i,n){const r=i.terminal.external,o=r.linuxExec?Promise.resolve(r.linuxExec):e.getDefaultTerminalLinuxReady();return new Promise((e,i)=>{o.then(r=>{const o=n?{cwd:n}:void 0,s=t.spawn(r,[],o);s.on("error",i),s.on("exit",()=>e())})})}static async getDefaultTerminalLinuxReady(){return e._DEFAULT_TERMINAL_LINUX_READY||(e._DEFAULT_TERMINAL_LINUX_READY=new Promise(async e=>{if(l.isLinux){const t=await c.exists("/etc/debian_version");await process.lazyEnv,t?e("x-terminal-emulator"):"gnome"===process.env.DESKTOP_SESSION||"gnome-classic"===process.env.DESKTOP_SESSION?e("gnome-terminal"):"kde-plasma"===process.env.DESKTOP_SESSION?e("konsole"):process.env.COLORTERM?e(process.env.COLORTERM):process.env.TERM?e(process.env.TERM):e("xterm")}else e("xterm")})),e._DEFAULT_TERMINAL_LINUX_READY}};return e.WAIT_MESSAGE=a.localize(3,null),e=n([s(0,v.optional(h.IConfigurationService))],e)})();function E(e){
return"errno"in e&&"ENOENT"===e.errno&&"path"in e&&"string"==typeof e.path?new Error(a.localize(5,null,e.path)):e}t.LinuxExternalTerminalService=b,l.isWindows?f.registerSingleton(d.IExternalTerminalService,y,!0):l.isMacintosh?f.registerSingleton(d.IExternalTerminalService,w,!0):l.isLinux&&f.registerSingleton(d.IExternalTerminalService,b,!0),b.getDefaultTerminalLinuxReady().then(e=>{g.Registry.as(m.Extensions.Configuration).registerConfiguration({id:"externalTerminal",order:100,title:a.localize(6,null),type:"object",properties:{"terminal.explorerKind":{type:"string",enum:["integrated","external"],enumDescriptions:[a.localize(7,null),a.localize(8,null)],description:a.localize(9,null),default:"integrated"},"terminal.external.windowsExec":{type:"string",description:a.localize(10,null),default:y.getDefaultTerminalWindows(),scope:1},"terminal.external.osxExec":{type:"string",description:a.localize(11,null),default:t.DEFAULT_TERMINAL_OSX,scope:1},"terminal.external.linuxExec":{type:"string",
description:a.localize(12,null),default:e,scope:1}}})})})),define(t[158],i([1,0,32,9,157]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareCommand=t.hasChildProcesses=t.runInExternalTerminal=void 0;let o=void 0;function s(e,t){return new Promise((n,r)=>{let o="";const s=i.spawn(e,t);s.pid&&s.stdout.on("data",e=>{o+=e.toString()}),s.on("error",e=>{r(e)}),s.on("close",e=>{n(o)})})}var a;t.runInExternalTerminal=function(e,t){if(!o)if(n.isWindows)o=new r.WindowsExternalTerminalService(void 0);else if(n.isMacintosh)o=new r.MacExternalTerminalService(void 0);else{if(!n.isLinux)throw new Error("external terminals not supported on this platform");o=new r.LinuxExternalTerminalService(void 0)}const i=t.getConfiguration("terminal");return o.runInTerminal(e.title,e.cwd,e.args,e.env||{},i.external||{})},t.hasChildProcesses=function(e){return e?n.isWindows?s("wmic",["process","get","ParentProcessId"]).then(t=>{return t.split("\r\n").some(t=>parseInt(t)===e)
},e=>!0):s("/usr/bin/pgrep",["-lP",String(e)]).then(e=>{const t=e.trim();return!(0===t.length||t.indexOf(" tmux")>=0)},e=>!0):Promise.resolve(!0)},function(e){e[e.cmd=0]="cmd",e[e.powershell=1]="powershell",e[e.bash=2]="bash"}(a||(a={})),t.prepareCommand=function(e,t){let i,r,o=" ";switch(i=(t=t.trim().toLowerCase()).indexOf("powershell")>=0||t.indexOf("pwsh")>=0?1:t.indexOf("cmd.exe")>=0?0:t.indexOf("bash")>=0?2:n.isWindows?0:2){case 1:if(r=e=>(e=e.replace(/\'/g,"''")).length>0&&"\\"===e.charAt(e.length-1)?`'${e}\\'`:`'${e}'`,e.cwd&&(o+=`cd '${e.cwd}'; `),e.env)for(let t in e.env){const i=e.env[t];o+=null===i?`Remove-Item env:${t}; `:`\${env:${t}}='${i}'; `}if(e.args&&e.args.length>0){const t=r(e.args.shift());o+="'"===t[0]?`& ${t} `:`${t} `;for(let t of e.args)o+=`${r(t)} `}break;case 0:if(r=e=>(e=e.replace(/\"/g,'""')).indexOf(" ")>=0||e.indexOf('"')>=0||0===e.length?`"${e}"`:e,e.cwd&&(o+=`cd ${r(e.cwd)} && `),e.env){o+='cmd /C "';for(let t in e.env){let i=e.env[t]
;o+=null===i?`set "${t}=" && `:`set "${t}=${i=i.replace(/[\^\&\|\<\>]/g,e=>`^${e}`)}" && `}}for(let t of e.args)o+=`${r(t)} `;e.env&&(o+='"');break;case 2:r=e=>(e=e.replace(/(["'\\\$])/g,"\\$1")).indexOf(" ")>=0||e.indexOf(";")>=0||0===e.length?`"${e}"`:e;const t=e=>/[^\w@%\/+=,.:^-]/.test(e)?`'${e.replace(/'/g,"'\\''")}'`:e;if(e.cwd&&(o+=`cd ${r(e.cwd)} ; `),e.env){o+="env";for(let i in e.env){const n=e.env[i];o+=null===n?` -u ${t(i)}`:` ${t(`${i}=${n}`)}`}o+=" "}for(let t of e.args)o+=`${r(t)} `}return o}})),define(t[99],i([1,0,27,9,71,20]),(function(e,t,i,n,r,o){"use strict";function s(e,t){return n.isWindows&&(e=e.replace(/\//g,"\\"),t=t.replace(/\//g,"\\")),i.match(e,t)}function a(e,t,i,n){let r=0;for(let i=0;i<t.length;i++){if(s(t[i],e))return r;r++}for(let t=0;t<i.length;t++){if(s(i[t],e))return r;r++}for(let t=0;t<n.length;t++){if(s(n[t],e))return r;r++}return r}Object.defineProperty(t,"__esModule",{value:!0}),
t.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=t.diff=t.sortMimeTypes=t.mimeTypeSupportedByCore=t.CellUri=t.CellEditType=t.NotebookCellsChangeType=t.MimeTypeRendererResolver=t.NotebookCellRunState=t.notebookDocumentMetadataDefaults=t.BUILTIN_RENDERER_ID=t.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=t.NOTEBOOK_DISPLAY_ORDER=t.CellOutputKind=t.CellKind=void 0,function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(t.CellOutputKind||(t.CellOutputKind={})),t.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],t.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],t.BUILTIN_RENDERER_ID="_builtin",t.notebookDocumentMetadataDefaults={editable:!0,runnable:!0,cellEditable:!0,cellRunnable:!0,cellHasExecutionOrder:!0,displayOrder:t.NOTEBOOK_DISPLAY_ORDER,
custom:{}},function(e){e[e.Running=1]="Running",e[e.Idle=2]="Idle",e[e.Success=3]="Success",e[e.Error=4]="Error"}(t.NotebookCellRunState||(t.NotebookCellRunState={})),function(e){e[e.Core=0]="Core",e[e.Active=1]="Active",e[e.Lazy=2]="Lazy"}(t.MimeTypeRendererResolver||(t.MimeTypeRendererResolver={})),function(e){e[e.ModelChange=1]="ModelChange",e[e.Move=2]="Move",e[e.CellClearOutput=3]="CellClearOutput",e[e.CellsClearOutput=4]="CellsClearOutput",e[e.ChangeLanguage=5]="ChangeLanguage",e[e.Initialize=6]="Initialize"}(t.NotebookCellsChangeType||(t.NotebookCellsChangeType={})),function(e){e[e.Insert=1]="Insert",e[e.Delete=2]="Delete"}(t.CellEditType||(t.CellEditType={})),function(e){e.scheme="vscode-notebook-cell";const t=/^\d{7,}/;e.generate=function(t,i){return t.with({scheme:e.scheme,fragment:`${i.toString().padStart(7,"0")}${t.scheme!==o.Schemas.file?t.scheme:""}`})},e.parse=function(i){if(i.scheme!==e.scheme)return;const n=t.exec(i.fragment);return n?{handle:Number(n[0]),notebook:i.with({
scheme:i.fragment.substr(n[0].length)||o.Schemas.file,fragment:null})}:void 0}}(t.CellUri||(t.CellUri={})),t.mimeTypeSupportedByCore=function(e){return["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain","text/x-javascript"].indexOf(e)>-1},t.sortMimeTypes=function(e,t,i,n){return e.sort((e,r)=>a(e,t,i,n)-a(r,t,i,n))},t.diff=function(e,t,i){const n=[];function r(e,t,i){if(0===t&&0===i.length)return;const r=n[n.length-1];r&&r.start+r.deleteCount===e?(r.deleteCount+=t,r.toInsert.push(...i)):n.push({start:e,deleteCount:t,toInsert:i})}let o=0,s=0;for(;;){if(o===e.length){r(o,0,t.slice(s));break}if(s===t.length){r(o,e.length-o,[]);break}const n=e[o],a=t[s];n!==a?i(a)?(r(o,1,[]),o+=1):(r(o,0,[a]),s+=1):(o+=1,s+=1)}return n},t.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new r.RawContextKey("notebookEditorCursorAtBoundary","none")})),define(t[160],i([1,0,10,3,84,6,70,99,23]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.ExtHostNotebookConcatDocument=void 0;t.ExtHostNotebookConcatDocument=class{constructor(e,t,i,r){this._notebook=i,this._selector=r,this._disposables=new o.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._init(),this._disposables.add(t.onDidChangeDocument(e=>{let t=this._cells.findIndex(t=>c.isEqual(t.uri,e.document.uri));t>=0&&(this._cellLengths.changeValue(t,this._cells[t].document.getText().length+1),this._cellLines.changeValue(t,this._cells[t].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const s=e=>{e===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(e.onDidChangeCellLanguage(e=>s(e.document))),this._disposables.add(e.onDidChangeCellOutputs(e=>s(e.document))),this._disposables.add(e.onDidChangeNotebookCells(e=>s(e.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){
this._cells=[];const e=[],t=[];for(let i of this._notebook.cells)i.cellKind!==a.CellKind.Code||this._selector&&!s.score(this._selector,i.uri,i.language,!0)||(this._cells.push(i),e.push(i.document.getText().length+1),t.push(i.document.lineCount));this._cellLengths=new r.PrefixSumComputer(new Uint32Array(e)),this._cellLines=new r.PrefixSumComputer(new Uint32Array(t))}get version(){return this._versionId}getText(e){if(!e){let e="";for(let t of this._cells)e+=t.document.getText()+"\n";return e=e.slice(0,-1)}if(e.isEmpty)return"";const t=this.locationAt(e.start),n=this.locationAt(e.end),r=this._cells.find(e=>c.isEqual(e.uri,t.uri)),o=this._cells.find(e=>c.isEqual(e.uri,n.uri));if(r&&o){if(r===o)return r.document.getText(new i.Range(t.range.start,n.range.end));return r.document.getText(new i.Range(t.range.start,new i.Position(r.document.lineCount,0)))+"\n"+o.document.getText(new i.Range(new i.Position(0,0),n.range.end))}return""}offsetAt(e){const t=this._cellLines.getIndexOf(e.line)
;return this._cellLengths.getAccumulatedValue(t.index-1)+this._cells[t.index].document.offsetAt(e.with(t.remainder))}positionAt(e){if("number"==typeof e){const t=this._cellLengths.getIndexOf(e),i=this._cellLines.getAccumulatedValue(t.index-1);return this._cells[t.index].document.positionAt(t.remainder).translate(i)}const t=this._cells.findIndex(t=>c.isEqual(t.uri,e.uri));if(t>=0){let n=this._cellLines.getAccumulatedValue(t-1);return new i.Position(n+e.range.start.line,e.range.start.character)}return new i.Position(0,0)}locationAt(e){i.Range.isRange(e)||(e=new i.Range(e,e));const t=this._cellLines.getIndexOf(e.start.line);let n=t;e.isEmpty||(n=this._cellLines.getIndexOf(e.end.line));let r=new i.Position(t.remainder,e.start.character),o=new i.Position(n.remainder,e.end.character),s=new i.Range(r,o);const a=this._cells[t.index];return new i.Location(a.uri,a.document.validateRange(s))}}})),define(t[161],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.USER_TASKS_GROUP_KEY=t.ITaskService=void 0,t.ITaskService=i.createDecorator("taskService"),t.USER_TASKS_GROUP_KEY="settings"})),define(t[162],i([1,0,4]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.EnvironmentVariableMutatorType=t.IEnvironmentVariableService=void 0,t.IEnvironmentVariableService=i.createDecorator("environmentVariableService"),function(e){e[e.Replace=1]="Replace",e[e.Append=2]="Append",e[e.Prepend=3]="Prepend"}(t.EnvironmentVariableMutatorType||(t.EnvironmentVariableMutatorType={}))})),define(t[163],i([1,0,162,9]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MergedEnvironmentVariableCollection=void 0;function r(e,t){if(!t)return e;const i=new Set;t.forEach(e=>i.add(e.extensionIdentifier));const n=[];return e.forEach(e=>{i.has(e.extensionIdentifier)||n.push(e)}),0===n.length?void 0:n}t.MergedEnvironmentVariableCollection=class{constructor(e){this.map=new Map,e.forEach((e,t)=>{const n=e.map.entries();let r=n.next()
;for(;!r.done;){const e=r.value[0];let o=this.map.get(e);if(o||(o=[],this.map.set(e,o)),o.length>0&&o[0].type===i.EnvironmentVariableMutatorType.Replace){r=n.next();continue}const s=r.value[1];o.unshift({extensionIdentifier:t,value:s.value,type:s.type}),r=n.next()}})}applyToProcessEnvironment(e){let t;n.isWindows&&(t={},Object.keys(e).forEach(e=>t[e.toLowerCase()]=e)),this.map.forEach((r,o)=>{const s=n.isWindows&&t[o.toLowerCase()]||o;r.forEach(t=>{switch(t.type){case i.EnvironmentVariableMutatorType.Append:e[s]=(e[s]||"")+t.value;break;case i.EnvironmentVariableMutatorType.Prepend:e[s]=t.value+(e[s]||"");break;case i.EnvironmentVariableMutatorType.Replace:e[s]=t.value}})})}diff(e){const t=new Map,i=new Map,n=new Map;if(e.map.forEach((e,i)=>{const n=r(e,this.map.get(i));n&&t.set(i,n)}),this.map.forEach((t,i)=>{const o=r(t,e.map.get(i));o&&n.set(i,o)}),this.map.forEach((t,n)=>{const r=function(e,t){if(!t)return;const i=new Map;t.forEach(e=>i.set(e.extensionIdentifier,e));const n=[];return e.forEach(e=>{
const t=i.get(e.extensionIdentifier);!t||e.type===t.type&&e.value===t.value||n.push(t)}),0===n.length?void 0:n}(t,e.map.get(n));r&&i.set(n,r)}),0!==t.size||0!==i.size||0!==n.size)return{added:t,changed:i,removed:n}}}})),define(t[164],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.deserializeEnvironmentVariableCollection=t.serializeEnvironmentVariableCollection=void 0,t.serializeEnvironmentVariableCollection=function(e){return[...e.entries()]},t.deserializeEnvironmentVariableCollection=function(e){return new Map(e)}})),define(t[67],i([1,0,183,71,4]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.DEFAULT_COMMANDS_TO_SKIP_SHELL=t.TERMINAL_COMMAND_ID=t.TitleEventSource=t.LinuxDistro=t.ProcessState=t.LEGACY_CONSOLE_MODE_EXIT_CODE=t.SHELL_CWD_INVALID_EXIT_CODE=t.SHELL_PATH_DIRECTORY_EXIT_CODE=t.SHELL_PATH_INVALID_EXIT_CODE=t.DEFAULT_LINE_HEIGHT=t.MINIMUM_LETTER_SPACING=t.DEFAULT_LETTER_SPACING=t.TERMINAL_ACTION_CATEGORY=t.TERMINAL_CONFIG_SECTION=t.TerminalCursorStyle=t.ITerminalNativeService=t.EXT_HOST_CREATION_DELAY=t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY=t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=t.TERMINAL_VIEW_ID=void 0,
t.TERMINAL_VIEW_ID="workbench.panel.terminal",t.KEYBINDING_CONTEXT_TERMINAL_IS_OPEN=new n.RawContextKey("terminalIsOpen",!1),t.KEYBINDING_CONTEXT_TERMINAL_FOCUS=new n.RawContextKey("terminalFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY="terminalShellType",t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE=new n.RawContextKey(t.KEYBINDING_CONTEXT_TERMINAL_SHELL_TYPE_KEY,void 0),t.KEYBINDING_CONTEXT_TERMINAL_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FOCUS.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_A11Y_TREE_FOCUS=new n.RawContextKey("terminalA11yTreeFocus",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED=new n.RawContextKey("terminalTextSelected",!1),t.KEYBINDING_CONTEXT_TERMINAL_TEXT_NOT_SELECTED=t.KEYBINDING_CONTEXT_TERMINAL_TEXT_SELECTED.toNegated(),t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE=new n.RawContextKey("terminalFindVisible",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_NOT_VISIBLE=t.KEYBINDING_CONTEXT_TERMINAL_FIND_VISIBLE.toNegated(),
t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED=new n.RawContextKey("terminalFindInputFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_FOCUSED=new n.RawContextKey("terminalFindFocused",!1),t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_NOT_FOCUSED=t.KEYBINDING_CONTEXT_TERMINAL_FIND_INPUT_FOCUSED.toNegated(),t.IS_WORKSPACE_SHELL_ALLOWED_STORAGE_KEY="terminal.integrated.isWorkspaceShellAllowed",t.NEVER_MEASURE_RENDER_TIME_STORAGE_KEY="terminal.integrated.neverMeasureRenderTime",t.EXT_HOST_CREATION_DELAY=100,t.ITerminalNativeService=r.createDecorator("terminalNativeService"),t.TerminalCursorStyle={BLOCK:"block",LINE:"line",UNDERLINE:"underline"},t.TERMINAL_CONFIG_SECTION="terminal.integrated",t.TERMINAL_ACTION_CATEGORY=i.localize(0,null),t.DEFAULT_LETTER_SPACING=0,t.MINIMUM_LETTER_SPACING=-5,t.DEFAULT_LINE_HEIGHT=1,t.SHELL_PATH_INVALID_EXIT_CODE=-1,t.SHELL_PATH_DIRECTORY_EXIT_CODE=-2,t.SHELL_CWD_INVALID_EXIT_CODE=-3,t.LEGACY_CONSOLE_MODE_EXIT_CODE=3221225786,function(e){e[e.UNINITIALIZED=0]="UNINITIALIZED",
e[e.LAUNCHING=1]="LAUNCHING",e[e.RUNNING=2]="RUNNING",e[e.KILLED_DURING_LAUNCH=3]="KILLED_DURING_LAUNCH",e[e.KILLED_BY_USER=4]="KILLED_BY_USER",e[e.KILLED_BY_PROCESS=5]="KILLED_BY_PROCESS"}(t.ProcessState||(t.ProcessState={})),function(e){e[e.Fedora=0]="Fedora",e[e.Ubuntu=1]="Ubuntu",e[e.Unknown=2]="Unknown"}(t.LinuxDistro||(t.LinuxDistro={})),function(e){e[e.Api=0]="Api",e[e.Process=1]="Process",e[e.Sequence=2]="Sequence"}(t.TitleEventSource||(t.TitleEventSource={})),function(e){e.FIND_NEXT="workbench.action.terminal.findNext",e.FIND_PREVIOUS="workbench.action.terminal.findPrevious",e.TOGGLE="workbench.action.terminal.toggleTerminal",e.KILL="workbench.action.terminal.kill",e.QUICK_KILL="workbench.action.terminal.quickKill",e.COPY_SELECTION="workbench.action.terminal.copySelection",e.SELECT_ALL="workbench.action.terminal.selectAll",e.DELETE_WORD_LEFT="workbench.action.terminal.deleteWordLeft",e.DELETE_WORD_RIGHT="workbench.action.terminal.deleteWordRight",
e.DELETE_TO_LINE_START="workbench.action.terminal.deleteToLineStart",e.MOVE_TO_LINE_START="workbench.action.terminal.moveToLineStart",e.MOVE_TO_LINE_END="workbench.action.terminal.moveToLineEnd",e.NEW="workbench.action.terminal.new",e.NEW_WITH_CWD="workbench.action.terminal.newWithCwd",e.NEW_LOCAL="workbench.action.terminal.newLocal",e.NEW_IN_ACTIVE_WORKSPACE="workbench.action.terminal.newInActiveWorkspace",e.SPLIT="workbench.action.terminal.split",e.SPLIT_IN_ACTIVE_WORKSPACE="workbench.action.terminal.splitInActiveWorkspace",e.RELAUNCH="workbench.action.terminal.relaunch",e.FOCUS_PREVIOUS_PANE="workbench.action.terminal.focusPreviousPane",e.FOCUS_NEXT_PANE="workbench.action.terminal.focusNextPane",e.RESIZE_PANE_LEFT="workbench.action.terminal.resizePaneLeft",e.RESIZE_PANE_RIGHT="workbench.action.terminal.resizePaneRight",e.RESIZE_PANE_UP="workbench.action.terminal.resizePaneUp",e.RESIZE_PANE_DOWN="workbench.action.terminal.resizePaneDown",e.FOCUS="workbench.action.terminal.focus",
e.FOCUS_NEXT="workbench.action.terminal.focusNext",e.FOCUS_PREVIOUS="workbench.action.terminal.focusPrevious",e.PASTE="workbench.action.terminal.paste",e.SELECT_DEFAULT_SHELL="workbench.action.terminal.selectDefaultShell",e.RUN_SELECTED_TEXT="workbench.action.terminal.runSelectedText",e.RUN_ACTIVE_FILE="workbench.action.terminal.runActiveFile",e.SWITCH_TERMINAL="workbench.action.terminal.switchTerminal",e.SCROLL_DOWN_LINE="workbench.action.terminal.scrollDown",e.SCROLL_DOWN_PAGE="workbench.action.terminal.scrollDownPage",e.SCROLL_TO_BOTTOM="workbench.action.terminal.scrollToBottom",e.SCROLL_UP_LINE="workbench.action.terminal.scrollUp",e.SCROLL_UP_PAGE="workbench.action.terminal.scrollUpPage",e.SCROLL_TO_TOP="workbench.action.terminal.scrollToTop",e.CLEAR="workbench.action.terminal.clear",e.CLEAR_SELECTION="workbench.action.terminal.clearSelection",e.MANAGE_WORKSPACE_SHELL_PERMISSIONS="workbench.action.terminal.manageWorkspaceShellPermissions",e.RENAME="workbench.action.terminal.rename",
e.RENAME_WITH_ARG="workbench.action.terminal.renameWithArg",e.FIND_FOCUS="workbench.action.terminal.focusFind",e.FIND_HIDE="workbench.action.terminal.hideFind",e.QUICK_OPEN_TERM="workbench.action.quickOpenTerm",e.SCROLL_TO_PREVIOUS_COMMAND="workbench.action.terminal.scrollToPreviousCommand",e.SCROLL_TO_NEXT_COMMAND="workbench.action.terminal.scrollToNextCommand",e.SELECT_TO_PREVIOUS_COMMAND="workbench.action.terminal.selectToPreviousCommand",e.SELECT_TO_NEXT_COMMAND="workbench.action.terminal.selectToNextCommand",e.SELECT_TO_PREVIOUS_LINE="workbench.action.terminal.selectToPreviousLine",e.SELECT_TO_NEXT_LINE="workbench.action.terminal.selectToNextLine",e.TOGGLE_ESCAPE_SEQUENCE_LOGGING="toggleEscapeSequenceLogging",e.SEND_SEQUENCE="workbench.action.terminal.sendSequence",e.TOGGLE_FIND_REGEX="workbench.action.terminal.toggleFindRegex",e.TOGGLE_FIND_WHOLE_WORD="workbench.action.terminal.toggleFindWholeWord",e.TOGGLE_FIND_CASE_SENSITIVE="workbench.action.terminal.toggleFindCaseSensitive",
e.NAVIGATION_MODE_EXIT="workbench.action.terminal.navigationModeExit",e.NAVIGATION_MODE_FOCUS_NEXT="workbench.action.terminal.navigationModeFocusNext",e.NAVIGATION_MODE_FOCUS_PREVIOUS="workbench.action.terminal.navigationModeFocusPrevious",e.SHOW_ENVIRONMENT_INFORMATION="workbench.action.terminal.showEnvironmentInformation"}(t.TERMINAL_COMMAND_ID||(t.TERMINAL_COMMAND_ID={})),
t.DEFAULT_COMMANDS_TO_SKIP_SHELL=["workbench.action.terminal.clearSelection","workbench.action.terminal.clear","workbench.action.terminal.copySelection","workbench.action.terminal.deleteToLineStart","workbench.action.terminal.deleteWordLeft","workbench.action.terminal.deleteWordRight","workbench.action.terminal.focusFind","workbench.action.terminal.hideFind","workbench.action.terminal.findNext","workbench.action.terminal.findPrevious","workbench.action.terminal.toggleFindRegex","workbench.action.terminal.toggleFindWholeWord","workbench.action.terminal.toggleFindCaseSensitive","workbench.action.terminal.focusNextPane","workbench.action.terminal.focusNext","workbench.action.terminal.focusPreviousPane","workbench.action.terminal.focusPrevious","workbench.action.terminal.focus","workbench.action.terminal.kill","workbench.action.terminal.moveToLineEnd","workbench.action.terminal.moveToLineStart","workbench.action.terminal.newInActiveWorkspace","workbench.action.terminal.new","workbench.action.terminal.paste","workbench.action.terminal.resizePaneDown","workbench.action.terminal.resizePaneLeft","workbench.action.terminal.resizePaneRight","workbench.action.terminal.resizePaneUp","workbench.action.terminal.runActiveFile","workbench.action.terminal.runSelectedText","workbench.action.terminal.scrollDown","workbench.action.terminal.scrollDownPage","workbench.action.terminal.scrollToBottom","workbench.action.terminal.scrollToNextCommand","workbench.action.terminal.scrollToPreviousCommand","workbench.action.terminal.scrollToTop","workbench.action.terminal.scrollUp","workbench.action.terminal.scrollUpPage","workbench.action.terminal.sendSequence","workbench.action.terminal.selectAll","workbench.action.terminal.selectToNextCommand","workbench.action.terminal.selectToNextLine","workbench.action.terminal.selectToPreviousCommand","workbench.action.terminal.selectToPreviousLine","workbench.action.terminal.splitInActiveWorkspace","workbench.action.terminal.split","workbench.action.terminal.toggleTerminal","workbench.action.terminal.navigationModeExit","workbench.action.terminal.navigationModeFocusNext","workbench.action.terminal.navigationModeFocusPrevious","editor.action.toggleTabFocusMode","workbench.action.quickOpen","workbench.action.quickOpenPreviousEditor","workbench.action.showCommands","workbench.action.tasks.build","workbench.action.tasks.restartTask","workbench.action.tasks.runTask","workbench.action.tasks.reRunTask","workbench.action.tasks.showLog","workbench.action.tasks.showTasks","workbench.action.tasks.terminate","workbench.action.tasks.test","workbench.action.toggleFullScreen","workbench.action.terminal.focusAtIndex1","workbench.action.terminal.focusAtIndex2","workbench.action.terminal.focusAtIndex3","workbench.action.terminal.focusAtIndex4","workbench.action.terminal.focusAtIndex5","workbench.action.terminal.focusAtIndex6","workbench.action.terminal.focusAtIndex7","workbench.action.terminal.focusAtIndex8","workbench.action.terminal.focusAtIndex9","workbench.action.focusSecondEditorGroup","workbench.action.focusThirdEditorGroup","workbench.action.focusFourthEditorGroup","workbench.action.focusFifthEditorGroup","workbench.action.focusSixthEditorGroup","workbench.action.focusSeventhEditorGroup","workbench.action.focusEighthEditorGroup","workbench.action.focusNextPart","workbench.action.focusPreviousPart","workbench.action.nextPanelView","workbench.action.previousPanelView","workbench.action.nextSideBarView","workbench.action.previousSideBarView","workbench.action.debug.start","workbench.action.debug.stop","workbench.action.debug.run","workbench.action.debug.restart","workbench.action.debug.continue","workbench.action.debug.pause","workbench.action.debug.stepInto","workbench.action.debug.stepOut","workbench.action.debug.stepOver","workbench.action.nextEditor","workbench.action.previousEditor","workbench.action.nextEditorInGroup","workbench.action.previousEditorInGroup","workbench.action.openNextRecentlyUsedEditor","workbench.action.openPreviousRecentlyUsedEditor","workbench.action.openNextRecentlyUsedEditorInGroup","workbench.action.openPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenPreviousRecentlyUsedEditor","workbench.action.quickOpenLeastRecentlyUsedEditor","workbench.action.quickOpenPreviousRecentlyUsedEditorInGroup","workbench.action.quickOpenLeastRecentlyUsedEditorInGroup","workbench.action.focusActiveEditorGroup","workbench.action.focusFirstEditorGroup","workbench.action.focusLastEditorGroup","workbench.action.firstEditorInGroup","workbench.action.lastEditorInGroup","workbench.action.navigateUp","workbench.action.navigateDown","workbench.action.navigateRight","workbench.action.navigateLeft","workbench.action.togglePanel","workbench.action.quickOpenView","workbench.action.toggleMaximizedPanel"]
})),define(t[166],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalDataBufferer=void 0;t.TerminalDataBufferer=class{constructor(e){this._callback=e,this._terminalBufferMap=new Map}dispose(){for(const e of this._terminalBufferMap.values())e.dispose()}startBuffering(e,t,i=5){let n;return n=t(t=>{let r=this._terminalBufferMap.get(e);if(r)return void r.data.push(t);const o=setTimeout(()=>this._flushBuffer(e),i);r={data:[t],timeoutId:o,dispose:()=>{clearTimeout(o),this._flushBuffer(e),n.dispose()}},this._terminalBufferMap.set(e,r)})}stopBuffering(e){const t=this._terminalBufferMap.get(e);t&&t.dispose()}_flushBuffer(e){const t=this._terminalBufferMap.get(e);t&&(this._terminalBufferMap.delete(e),this._callback(e,t.data.join("")))}}})),define(t[167],i([1,0,7,9,216]),(function(e,t,i,n,r){"use strict";function o(e,t){if(t)if(n.isWindows)for(const i in t){let n=i;for(const t in e)if(i.toLowerCase()===t.toLowerCase()){n=t;break}const r=t[i];s(e,n,r)
}else Object.keys(t).forEach(i=>{const n=t[i];s(e,i,n)})}function s(e,t,i){"string"==typeof i?e[t]=i:delete e[t]}function a(e,t,i,n){e.TERM_PROGRAM="vscode",t&&(e.TERM_PROGRAM_VERSION=t),u(e,n)&&(e.LANG=d(i)),e.COLORTERM="truecolor"}function c(e,t){if(t)for(const i of Object.keys(t)){const n=t[i];n&&(e[i]=n)}}function l(e,t,i){return Object.keys(t).forEach(n=>{const r=t[n];if("string"==typeof r)try{t[n]=e.resolve(i,r)}catch(e){t[n]=r}}),t}function u(e,t){return"on"===t||"auto"===t&&(!e.LANG||-1===e.LANG.search(/\.UTF\-8$/))}function d(e){const t=e?e.split("-"):[],i=t.length;if(0===i)return"en_US.UTF-8";if(1===i){const e={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};t[0]in e&&t.push(e[t[0]])}else t[1]=t[1].toUpperCase();return t.join("_")+".UTF-8"}
function h(e,t,i,n){if(i)try{return i.resolve(t,e)}catch(e){return void(null==n||n.error("Could not resolve terminal cwd",e))}return e}function p(e){return 3===n.platform&&e&&":"===e[1]?e[0].toUpperCase()+e.substr(1):e}function m(e,t,i,r=n.platform){const o=e(`terminal.integrated.${i}.${3===r?"windows":1===r?"osx":"linux"}`);return(t?o.value:o.userValue)||o.defaultValue}Object.defineProperty(t,"__esModule",{value:!0}),t.createTerminalEnvironment=t.getDefaultShellArgs=t.getDefaultShell=t.escapeNonWindowsPath=t.getCwd=t.getLangEnvVariable=t.shouldSetLangEnvVariable=t.addTerminalEnvironmentKeys=t.mergeEnvironments=void 0,t.mergeEnvironments=o,t.addTerminalEnvironmentKeys=a,t.shouldSetLangEnvVariable=u,t.getLangEnvVariable=d,t.getCwd=function(e,t,n,r,o,s,a){if(e.cwd){const t="object"==typeof e.cwd?e.cwd.fsPath:e.cwd;return p(h(t,n,r)||t)}let c;return!e.ignoreConfigurationCwd&&s&&(r&&(s=h(s,n,r,a)),s&&(i.isAbsolute(s)?c=s:o&&(c=i.join(o.fsPath,s)))),c||(c=o?o.fsPath:t||""),p(c)},t.escapeNonWindowsPath=function(e){
let t=e;return 0!==t.indexOf("\\")&&(t=t.replace(/\\/g,"\\\\")),t||-1===t.indexOf('"')?-1!==t.indexOf(" ")&&(t=t.replace(/ /g,"\\ ")):t="'"+t+"'",t},t.getDefaultShell=function(e,t,r,o,s,a,c,l,u,d=n.platform){let h=null;u&&(h=m(e,t,"automationShell",d)),h||(h=m(e,t,"shell",d));let p=h||r;if(3===d&&!o&&s){const e=i.join(s,"Sysnative").replace(/\//g,"\\").toLowerCase();p&&0===p.toLowerCase().indexOf(e)&&(p=i.join(s,"System32",p.substr(e.length+1)))}if(p&&3===d&&(p=p.replace(/\//g,"\\")),c)try{p=c.resolve(a,p)}catch(e){l.error("Could not resolve shell",e)}return p},t.getDefaultShellArgs=function(e,t,i,r,o,s,a=n.platform){if(i&&m(e,t,"automationShell",a))return[];const c=3===a?"windows":1===a?"osx":"linux",l=e(`terminal.integrated.shellArgs.${c}`);let u=(t?l.value:l.userValue)||l.defaultValue;if(!u)return[];if("string"==typeof u&&3===a)return o?o.resolve(r,u):u;if(o){const e=[];for(const t of u)try{e.push(o.resolve(r,t))}catch(i){s.error(`Could not resolve terminal.integrated.shellArgs.${c}`,i),e.push(t)}u=e}
return u},t.createTerminalEnvironment=function(e,t,i,s,u,d,h,p){let m={};if(e.strictEnv)c(m,e.env);else{c(m,p);const f=Object.assign({},u?i.value:i.userValue);s&&(f&&l(s,f,t),e.env&&l(s,e.env,t)),r.sanitizeProcessEnvironment(m,"VSCODE_IPC_HOOK_CLI"),o(m,f),o(m,e.env),a(m,d,n.locale,h)}return m}})),define(t[100],i([1,0,40,9,79,24,67,13,7]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.detectAvailableShells=t.getWindowsBuildNumber=t.linuxDistro=t.getSystemShell=void 0,t.getSystemShell=function(e){return 3===e?n.isWindows?function(){if(!u){const e=n.isWindows&&parseFloat(i.release())>=10,t=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),o=`${process.env.windir}\\${t?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;u=e?o:r.getWindowsShell()}return u}():r.getWindowsShell():n.isLinux&&1===e||n.isMacintosh&&2===e?"/bin/bash":function(){if(!l){let e="sh";!n.isWindows&&process.env.SHELL&&"/bin/false"===(e=process.env.SHELL)&&(e="/bin/bash"),
n.isWindows&&(e="/bin/bash"),l=e}return l}()};let l=null;let u=null;let d=s.LinuxDistro.Unknown;if(n.isLinux){const e="/etc/os-release";o.fileExists(e).then(async t=>{if(!t)return;const i=(await o.readFile(e)).toString();/NAME="?Fedora"?/.test(i)?d=s.LinuxDistro.Fedora:/NAME="?Ubuntu"?/.test(i)&&(d=s.LinuxDistro.Ubuntu)})}function h(){const e=/(\d+)\.(\d+)\.(\d+)/g.exec(i.release());let t=0;return e&&4===e.length&&(t=parseInt(e[3])),t}async function p(t){const i=await new Promise((t,i)=>{e(["vscode-windows-registry"],t,i)});try{const e=i.GetStringRegKey("HKEY_LOCAL_MACHINE",`SOFTWARE\\Microsoft\\Windows\\CurrentVersion\\App Paths\\${t}.exe`,"");return e||""}catch(e){return""}}t.linuxDistro=d,t.getWindowsBuildNumber=h,t.detectAvailableShells=function(){return n.isWindows?async function(){const e=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),t=`${process.env.windir}\\${e?"Sysnative":"System32"}`;let i=!1;h()>=16299&&(i=!0);const n={"Command Prompt":[`${t}\\cmd.exe`],
"Windows PowerShell":[`${t}\\WindowsPowerShell\\v1.0\\powershell.exe`],PowerShell:[await p("pwsh")],"WSL Bash":[`${t}\\${i?"wsl.exe":"bash.exe"}`],"Git Bash":[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`]},r=[];Object.keys(n).forEach(e=>r.push(async function e(t,i){if(0===i.length)return Promise.resolve(void 0);const n=i.shift();if(""===n)return e(t,i);try{const e=await o.stat(c.normalize(n));if(e.isFile||e.isSymbolicLink)return{label:t,path:n}}catch(e){}return e(t,i)}(e,n[e])));const s=await Promise.all(r);return a.coalesce(s)}():async function(){return(await o.readFile("/etc/shells","utf8")).split("\n").filter(e=>0!==e.trim().indexOf("#")&&e.trim().length>0).map(e=>({label:c.basename(e),path:e}))}()}})),define(t[82],i([1,0,9,24,7,12]),(function(e,t,i,n,r,o){"use strict";let s
;Object.defineProperty(t,"__esModule",{value:!0}),t.findExecutable=t.getMainProcessParentEnv=void 0,t.getMainProcessParentEnv=async function(){if(s)return s;if(i.isLinux){const e=process.ppid,t=r.basename(process.argv[0]);let i=0,o=e,a=t;do{i=o,(await n.readFile(`/proc/${i}/status`,"utf8")).split("\n").forEach(e=>{0===e.indexOf("Name:")&&(a=e.replace(/^Name:\s+/,"")),0===e.indexOf("PPid:")&&(o=parseInt(e.replace(/^PPid:\s+/,"")))})}while(a===t);const c=await n.readFile(`/proc/${i}/environ`,"utf8"),l={};c.split("\0").forEach(e=>{const t=e.indexOf("=");l[e.substr(0,t)]=e.substr(t+1)}),s=l}if(i.isMacintosh){s={},["SHELL","SSH_AUTH_SOCK","Apple_PubSub_Socket_Render","XPC_FLAGS","XPC_SERVICE_NAME","HOME","LOGNAME","TMPDIR"].forEach(e=>{process.env[e]&&(s[e]=process.env[e])})}return i.isWindows&&(s=process.env),s},t.findExecutable=async function(e,t,s){if(r.isAbsolute(e))return await n.exists(e)?e:void 0;if(void 0===t&&(t=process.cwd()),"."!==r.dirname(e)){const i=r.join(t,e);return await n.exists(i)?i:void 0}
if(void 0===s&&o.isString(process.env.PATH)&&(s=process.env.PATH.split(r.delimiter)),void 0===s||0===s.length){const i=r.join(t,e);return await n.exists(i)?i:void 0}for(let o of s){let s;if(s=r.isAbsolute(o)?r.join(o,e):r.join(t,o,e),await n.exists(s))return s;if(i.isWindows){let e=s+".com";if(await n.exists(e))return e;if(e=s+".exe",await n.exists(e))return e}}const a=r.join(t,e);return await n.exists(a)?a:void 0}})),define(t[170],i([1,0,40,7,9,260,35,3,100,6,67,32,11,24,82,2]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TerminalProcess=void 0;let _=(()=>{let e=class extends d.Disposable{constructor(e,t,n,o,s,a,c){let d;super(),this._logService=c,this._currentTitle="",this._isDisposed=!1,this._titleInterval=null,this._onProcessData=this._register(new l.Emitter),this._onProcessExit=this._register(new l.Emitter),this._onProcessReady=this._register(new l.Emitter),this._onProcessTitleChanged=this._register(new l.Emitter),
d="win32"===i.platform()?r.basename(e.executable||""):"xterm-256color",this._initialCwd=t;const p=a&&"win32"===process.platform&&u.getWindowsBuildNumber()>=18309,m={name:d,cwd:t,env:s,cols:n,rows:o,useConpty:p,conptyInheritCursor:p&&!!e.initialText},_=f.stat(t).then(async e=>{if(!e.isDirectory())return Promise.reject(h.SHELL_CWD_INVALID_EXIT_CODE)},async i=>{if(i&&"ENOENT"===i.code)return e.cwd=t,Promise.reject(h.SHELL_CWD_INVALID_EXIT_CODE)}),y=f.stat(e.executable).then(async e=>{if(!e.isFile()&&!e.isSymbolicLink())return Promise.reject(e.isDirectory()?h.SHELL_PATH_DIRECTORY_EXIT_CODE:h.SHELL_PATH_INVALID_EXIT_CODE)},async t=>{if(t&&"ENOENT"===t.code){let t=e.cwd instanceof v.URI?e.cwd.path:e.cwd;const i=e.env&&e.env.PATH?e.env.PATH.split(r.delimiter):void 0;if(!await g.findExecutable(e.executable,t,i))return Promise.reject(h.SHELL_PATH_INVALID_EXIT_CODE)}});Promise.all([_,y]).then(()=>{this.setupPtyProcess(e,m)}).catch(e=>this._launchFailed(e))}get onProcessData(){return this._onProcessData.event}
get onProcessExit(){return this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}get onProcessTitleChanged(){return this._onProcessTitleChanged.event}_launchFailed(e){this._exitCode=e,this._queueProcessExit(),this._processStartupComplete=Promise.resolve(void 0)}setupPtyProcess(e,t){const i=e.args||[];this._logService.trace("IPty#spawn",e.executable,i,t);const n=a.spawn(e.executable,i,t);this._ptyProcess=n,this._processStartupComplete=new Promise(e=>{this.onProcessReady(()=>e())}),n.on("data",e=>{this._onProcessData.fire(e),this._closeTimeout&&(clearTimeout(this._closeTimeout),this._queueProcessExit())}),n.on("exit",e=>{this._exitCode=e,this._queueProcessExit()}),this._setupTitlePolling(n),setTimeout(()=>{this._sendProcessId(n)},500)}dispose(){this._isDisposed=!0,this._titleInterval&&clearInterval(this._titleInterval),this._titleInterval=null,this._onProcessData.dispose(),this._onProcessExit.dispose(),this._onProcessReady.dispose(),this._onProcessTitleChanged.dispose(),
super.dispose()}_setupTitlePolling(e){setTimeout(()=>{this._sendProcessTitle(e)},0),o.isWindows||(this._titleInterval=setInterval(()=>{this._currentTitle!==e.process&&this._sendProcessTitle(e)},200))}_queueProcessExit(){this._closeTimeout&&clearTimeout(this._closeTimeout),this._closeTimeout=setTimeout(()=>this._kill(),250)}async _kill(){if(await this._processStartupComplete,!this._isDisposed){try{this._ptyProcess&&(this._logService.trace("IPty#kill"),this._ptyProcess.kill())}catch(e){}this._onProcessExit.fire(this._exitCode||0),this.dispose()}}_sendProcessId(e){this._onProcessReady.fire({pid:e.pid,cwd:this._initialCwd})}_sendProcessTitle(e){this._isDisposed||(this._currentTitle=e.process,this._onProcessTitleChanged.fire(this._currentTitle))}shutdown(e){e?this._kill():this._queueProcessExit()}input(e){!this._isDisposed&&this._ptyProcess&&(this._logService.trace("IPty#write",`${e.length} characters`),this._ptyProcess.write(e))}resize(e,t){
if(!this._isDisposed&&"number"==typeof e&&"number"==typeof t&&!isNaN(e)&&!isNaN(t)&&this._ptyProcess){e=Math.max(e,1),t=Math.max(t,1),this._logService.trace("IPty#resize",e,t);try{this._ptyProcess.resize(e,t)}catch(e){if(void 0!==this._exitCode)throw e}}}getInitialCwd(){return Promise.resolve(this._initialCwd)}getCwd(){return o.isMacintosh?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),p.exec("lsof -OPl -p "+this._ptyProcess.pid+" | grep cwd",(t,i,n)=>{""!==i&&e(i.substring(i.indexOf("/"),i.length-1))})):e(this._initialCwd)}):o.isLinux?new Promise(e=>{this._ptyProcess?(this._logService.trace("IPty#pid"),c.readlink("/proc/"+this._ptyProcess.pid+"/cwd",(t,i)=>{t&&e(this._initialCwd),e(i)})):e(this._initialCwd)}):new Promise(e=>{e(this._initialCwd)})}getLatency(){return Promise.resolve(0)}};return e=n([s(6,m.ILogService)],e)})();t.TerminalProcess=_})),define(t[172],i([1,0,7,36,12,18,9,104,188]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.AbstractVariableResolverService=void 0;let l=(()=>{class e{constructor(e,t){if(this._contributedVariables=new Map,this._context=e,t)if(s.isWindows){const e=Object.create(null);this._envVariables=e,Object.keys(t).forEach(i=>{e[i.toLowerCase()]=t[i]})}else this._envVariables=t}resolve(e,t){return this.recursiveResolve(e?e.uri:void 0,t)}resolveAnyBase(e,t,i,n){const r=o.deepClone(t);return s.isWindows&&r.windows?Object.keys(r.windows).forEach(e=>r[e]=r.windows[e]):s.isMacintosh&&r.osx?Object.keys(r.osx).forEach(e=>r[e]=r.osx[e]):s.isLinux&&r.linux&&Object.keys(r.linux).forEach(e=>r[e]=r.linux[e]),delete r.windows,delete r.osx,delete r.linux,this.recursiveResolve(e?e.uri:void 0,r,i,n)}resolveAny(e,t,i){return this.resolveAnyBase(e,t,i)}resolveAnyMap(e,t,i){const n=new Map;return{newConfig:this.resolveAnyBase(e,t,i,n),resolvedVariables:n}}resolveWithInteractionReplace(e,t,i,n){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(e,t,i,n){
throw new Error("resolveWithInteraction not implemented.")}contributeVariable(e,t){if(this._contributedVariables.has(e))throw new Error("Variable "+e+" is contributed twice.");this._contributedVariables.set(e,t)}recursiveResolve(e,t,i,n){if(r.isString(t))return this.resolveString(e,t,i,n);if(r.isArray(t))return t.map(t=>this.recursiveResolve(e,t,i,n));if(r.isObject(t)){let r=Object.create(null);return Object.keys(t).forEach(o=>{const s=this.resolveString(e,o,i,n);r[s]=this.recursiveResolve(e,t[o],i,n)}),r}return t}resolveString(t,i,n,r){return i.replace(e.VARIABLE_REGEXP,(e,i)=>{let o=this.evaluateSingleVariable(e,i,t,n);return r&&r.set(i,o),o})}evaluateSingleVariable(e,t,o,l){let u;const d=t.split(":");d.length>1&&(t=d[0],u=d[1]);const h=()=>{const t=this._context.getFilePath();if(t)return t;throw new Error(c.localize(0,null,e))},p=(t=!0)=>{if(t&&u){const t=this._context.getFolderUri(u);if(t)return t;throw new Error(c.localize(1,null,e,u))}if(o)return o
;if(this._context.getWorkspaceFolderCount()>1)throw new Error(c.localize(2,null,e));throw new Error(c.localize(3,null,e))};switch(t){case"env":if(u){if(this._envVariables){const e=this._envVariables[s.isWindows?u.toLowerCase():u];if(r.isString(e))return e}return""}throw new Error(c.localize(4,null,e));case"config":if(u){const t=this._context.getConfigurationValue(p(!1),u);if(r.isUndefinedOrNull(t))throw new Error(c.localize(5,null,e,u));if(r.isObject(t))throw new Error(c.localize(6,null,e,u));return t}throw new Error(c.localize(7,null,e));case"command":return this.resolveFromMap(e,u,l,"command");case"input":return this.resolveFromMap(e,u,l,"input");default:switch(t){case"workspaceRoot":case"workspaceFolder":return a.normalizeDriveLetter(p().fsPath);case"cwd":return o||u?a.normalizeDriveLetter(p().fsPath):n.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return i.basename(p().fsPath);case"lineNumber":const r=this._context.getLineNumber();if(r)return r;throw new Error(c.localize(8,null,e))
;case"selectedText":const s=this._context.getSelectedText();if(s)return s;throw new Error(c.localize(9,null,e));case"file":return h();case"relativeFile":return o||u?i.normalize(i.relative(p().fsPath,h())):h();case"relativeFileDirname":const d=i.dirname(h());return o||u?i.normalize(i.relative(p().fsPath,d)):d;case"fileDirname":return i.dirname(h());case"fileExtname":return i.extname(h());case"fileBasename":return i.basename(h());case"fileBasenameNoExtension":const m=i.basename(h());return m.slice(0,m.length-i.extname(m).length);case"execPath":const f=this._context.getExecPath();return f||e;default:try{return this.resolveFromMap(e,t,l,void 0)}catch(t){return e}}}}resolveFromMap(e,t,i,n){if(t&&i){const r=void 0===n?i[t]:i[n+":"+t];if("string"==typeof r)return r;throw new Error(c.localize(10,null,e))}return e}}return e.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.VARIABLE_REGEXP_SINGLE=/\$\{(.*?)\}/,e})();t.AbstractVariableResolverService=l})),define(t[119],i([1,0,4]),(function(e,t,i){"use strict"
;Object.defineProperty(t,"__esModule",{value:!0}),t.SIDE_GROUP=t.ACTIVE_GROUP=t.IEditorService=void 0,t.IEditorService=i.createDecorator("editorService"),t.ACTIVE_GROUP=-1,t.SIDE_GROUP=-2})),define(t[21],i([1,0,72,10,2,47,106,87,119,12,258,53,18,11,13]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m){"use strict";var f,g,v,_,y,w,b,E,x,C,S,k,T,I,D,P,R,A,O,L,M;function N(e){return 0===e.length||!!function(e){return void 0!==e.range}(e[0])}function F(e){return void 0===e?e:"string"==typeof e?r.URI.file(e):e}Object.defineProperty(t,"__esModule",{value:!0}),
t.LogLevel=t.LanguageSelector=t.GlobPattern=t.TextEditorOptions=t.FoldingRangeKind=t.FoldingRange=t.ProgressLocation=t.EndOfLine=t.TextEditorLineNumbersStyle=t.TextDocumentSaveReason=t.SelectionRange=t.Color=t.ColorPresentation=t.DocumentLink=t.SignatureHelp=t.SignatureInformation=t.ParameterInformation=t.CompletionItem=t.CompletionItemKind=t.CompletionItemTag=t.CompletionContext=t.CompletionTriggerKind=t.DocumentHighlight=t.EvaluatableExpression=t.Hover=t.DefinitionLink=t.location=t.CallHierarchyOutgoingCall=t.CallHierarchyIncomingCall=t.CallHierarchyItem=t.DocumentSymbol=t.WorkspaceSymbol=t.SymbolTag=t.SymbolKind=t.WorkspaceEdit=t.TextEdit=t.DecorationRenderOptions=t.DecorationRangeBehavior=t.ThemableDecorationRenderOptions=t.ThemableDecorationAttachmentRenderOptions=t.pathOrURIToURI=t.fromRangeOrRangeWithMessage=t.MarkdownString=t.isDecorationOptionsArr=t.ViewColumn=t.DiagnosticSeverity=t.DiagnosticRelatedInformation=t.Diagnostic=t.DiagnosticTag=t.Position=t.TokenType=t.Range=t.Selection=void 0,
function(e){e.to=function(e){const{selectionStartLineNumber:t,selectionStartColumn:i,positionLineNumber:r,positionColumn:o}=e,s=new n.Position(t-1,i-1),a=new n.Position(r-1,o-1);return new n.Selection(s,a)},e.from=function(e){const{anchor:t,active:i}=e;return{selectionStartLineNumber:t.line+1,selectionStartColumn:t.character+1,positionLineNumber:i.line+1,positionColumn:i.character+1}}}(t.Selection||(t.Selection={})),function(e){e.from=function(e){if(!e)return;const{start:t,end:i}=e;return{startLineNumber:t.line+1,startColumn:t.character+1,endLineNumber:i.line+1,endColumn:i.character+1}},e.to=function(e){if(!e)return;const{startLineNumber:t,startColumn:i,endLineNumber:r,endColumn:o}=e;return new n.Range(t-1,i-1,r-1,o-1)}}(f=t.Range||(t.Range={})),function(e){e.to=function(e){switch(e){case 1:return n.StandardTokenType.Comment;case 0:return n.StandardTokenType.Other;case 4:return n.StandardTokenType.RegEx;case 2:return n.StandardTokenType.String}}}(t.TokenType||(t.TokenType={})),function(e){e.to=function(e){
return new n.Position(e.lineNumber-1,e.column-1)},e.from=function(e){return{lineNumber:e.line+1,column:e.character+1}}}(t.Position||(t.Position={})),function(e){e.from=function(e){switch(e){case n.DiagnosticTag.Unnecessary:return 1;case n.DiagnosticTag.Deprecated:return 2}},e.to=function(e){switch(e){case 1:return n.DiagnosticTag.Unnecessary;case 2:return n.DiagnosticTag.Deprecated}}}(g=t.DiagnosticTag||(t.DiagnosticTag={})),function(e){e.from=function(e){let t;return e.code&&(t=l.isString(e.code)||l.isNumber(e.code)?String(e.code):{value:String(e.code.value),target:e.code.target}),Object.assign(Object.assign({},f.from(e.range)),{message:e.message,source:e.source,code:t,severity:_.from(e.severity),relatedInformation:e.relatedInformation&&e.relatedInformation.map(v.from),tags:Array.isArray(e.tags)?m.coalesce(e.tags.map(g.from)):void 0})},e.to=function(e){var t;const i=new n.Diagnostic(f.to(e),e.message,_.to(e.severity));return i.source=e.source,
i.code=l.isString(e.code)?e.code:null===(t=e.code)||void 0===t?void 0:t.value,i.relatedInformation=e.relatedInformation&&e.relatedInformation.map(v.to),i.tags=e.tags&&m.coalesce(e.tags.map(g.to)),i}}(t.Diagnostic||(t.Diagnostic={})),function(e){e.from=function(e){return Object.assign(Object.assign({},f.from(e.location.range)),{message:e.message,resource:e.location.uri})},e.to=function(e){return new n.DiagnosticRelatedInformation(new n.Location(e.resource,f.to(e)),e.message)}}(v=t.DiagnosticRelatedInformation||(t.DiagnosticRelatedInformation={})),function(e){e.from=function(e){switch(e){case n.DiagnosticSeverity.Error:return a.MarkerSeverity.Error;case n.DiagnosticSeverity.Warning:return a.MarkerSeverity.Warning;case n.DiagnosticSeverity.Information:return a.MarkerSeverity.Info;case n.DiagnosticSeverity.Hint:return a.MarkerSeverity.Hint}return a.MarkerSeverity.Error},e.to=function(e){switch(e){case a.MarkerSeverity.Info:return n.DiagnosticSeverity.Information;case a.MarkerSeverity.Warning:
return n.DiagnosticSeverity.Warning;case a.MarkerSeverity.Error:return n.DiagnosticSeverity.Error;case a.MarkerSeverity.Hint:return n.DiagnosticSeverity.Hint}return n.DiagnosticSeverity.Error}}(_=t.DiagnosticSeverity||(t.DiagnosticSeverity={})),function(e){e.from=function(e){return"number"==typeof e&&e>=n.ViewColumn.One?e-1:e===n.ViewColumn.Beside?c.SIDE_GROUP:c.ACTIVE_GROUP},e.to=function(e){if("number"==typeof e&&e>=0)return e+1;throw new Error("invalid 'EditorViewColumn'")}}(t.ViewColumn||(t.ViewColumn={})),t.isDecorationOptionsArr=N,function(e){function t(e,t){if(!e)return e;let i;try{i=d.parse(e)}catch(e){}if(!i)return e;let n=!1;return i=h.cloneAndChange(i,e=>{if(r.URI.isUri(e)){const i=`__uri_${Math.random().toString(16).slice(2,8)}`;return t[i]=e,n=!0,i}}),n?JSON.stringify(i):e}e.fromMany=function(t){return t.map(e.from)},e.from=function(e){let i;if((n=e)&&"object"==typeof n&&"string"==typeof n.language&&"string"==typeof n.value){const{language:t,value:n}=e;i={value:"```"+t+"\n"+n+"\n```\n"}
}else i=s.isMarkdownString(e)?e:"string"==typeof e?{value:e}:{value:""};var n;const o=Object.create(null);i.uris=o;const a=e=>{try{let i=r.URI.parse(e,!0);i=i.with({query:t(i.query,o)}),o[e]=i}catch(e){}return""},c=new u.Renderer;return c.link=a,c.image=e=>a(s.parseHrefAndDimensions(e).href),u(i.value,{renderer:c}),i},e.to=function(e){return new s.MarkdownString(e.value,{isTrusted:e.isTrusted,supportThemeIcons:e.supportThemeIcons})},e.fromStrict=function(t){if(t)return"string"==typeof t?t:e.from(t)}}(y=t.MarkdownString||(t.MarkdownString={})),t.fromRangeOrRangeWithMessage=function(e){return N(e)?e.map(e=>({range:f.from(e.range),hoverMessage:Array.isArray(e.hoverMessage)?y.fromMany(e.hoverMessage):e.hoverMessage?y.from(e.hoverMessage):void 0,renderOptions:e.renderOptions})):e.map(e=>({range:f.from(e)}))},t.pathOrURIToURI=F,function(e){e.from=function(e){return void 0===e?e:{contentText:e.contentText,contentIconPath:e.contentIconPath?F(e.contentIconPath):void 0,border:e.border,borderColor:e.borderColor,
fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,color:e.color,backgroundColor:e.backgroundColor,margin:e.margin,width:e.width,height:e.height}}}(w=t.ThemableDecorationAttachmentRenderOptions||(t.ThemableDecorationAttachmentRenderOptions={})),function(e){e.from=function(e){return void 0===e?e:{backgroundColor:e.backgroundColor,outline:e.outline,outlineColor:e.outlineColor,outlineStyle:e.outlineStyle,outlineWidth:e.outlineWidth,border:e.border,borderColor:e.borderColor,borderRadius:e.borderRadius,borderSpacing:e.borderSpacing,borderStyle:e.borderStyle,borderWidth:e.borderWidth,fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,cursor:e.cursor,color:e.color,opacity:e.opacity,letterSpacing:e.letterSpacing,gutterIconPath:e.gutterIconPath?F(e.gutterIconPath):void 0,gutterIconSize:e.gutterIconSize,overviewRulerColor:e.overviewRulerColor,before:e.before?w.from(e.before):void 0,after:e.after?w.from(e.after):void 0}}
}(b=t.ThemableDecorationRenderOptions||(t.ThemableDecorationRenderOptions={})),function(e){e.from=function(e){if(void 0===e)return e;switch(e){case n.DecorationRangeBehavior.OpenOpen:return 0;case n.DecorationRangeBehavior.ClosedClosed:return 1;case n.DecorationRangeBehavior.OpenClosed:return 2;case n.DecorationRangeBehavior.ClosedOpen:return 3}}}(E=t.DecorationRangeBehavior||(t.DecorationRangeBehavior={})),function(e){e.from=function(e){return{isWholeLine:e.isWholeLine,rangeBehavior:e.rangeBehavior?E.from(e.rangeBehavior):void 0,overviewRulerLane:e.overviewRulerLane,light:e.light?b.from(e.light):void 0,dark:e.dark?b.from(e.dark):void 0,backgroundColor:e.backgroundColor,outline:e.outline,outlineColor:e.outlineColor,outlineStyle:e.outlineStyle,outlineWidth:e.outlineWidth,border:e.border,borderColor:e.borderColor,borderRadius:e.borderRadius,borderSpacing:e.borderSpacing,borderStyle:e.borderStyle,borderWidth:e.borderWidth,fontStyle:e.fontStyle,fontWeight:e.fontWeight,textDecoration:e.textDecoration,
cursor:e.cursor,color:e.color,opacity:e.opacity,letterSpacing:e.letterSpacing,gutterIconPath:e.gutterIconPath?F(e.gutterIconPath):void 0,gutterIconSize:e.gutterIconSize,overviewRulerColor:e.overviewRulerColor,before:e.before?w.from(e.before):void 0,after:e.after?w.from(e.after):void 0}}}(t.DecorationRenderOptions||(t.DecorationRenderOptions={})),function(e){e.from=function(e){return{text:e.newText,eol:e.newEol&&O.from(e.newEol),range:f.from(e.range)}},e.to=function(e){const t=new n.TextEdit(f.to(e.range),e.text);return t.newEol=void 0===e.eol?void 0:O.to(e.eol),t}}(x=t.TextEdit||(t.TextEdit={})),function(e){e.from=function(e,t){const i={edits:[]};if(e instanceof n.WorkspaceEdit)for(let n of e.allEntries())if(1===n._type)i.edits.push({oldUri:n.from,newUri:n.to,options:n.options,metadata:n.metadata});else{const e=null==t?void 0:t.getDocument(n.uri);i.edits.push({resource:n.uri,edit:x.from(n.edit),modelVersionId:null==e?void 0:e.version,metadata:n.metadata})}return i},e.to=function(e){const t=new n.WorkspaceEdit
;for(const i of e.edits)i.edit?t.replace(r.URI.revive(i.resource),f.to(i.edit.range),i.edit.text):t.renameFile(r.URI.revive(i.oldUri),r.URI.revive(i.newUri),i.options);return t}}(t.WorkspaceEdit||(t.WorkspaceEdit={})),function(e){const t=Object.create(null);t[n.SymbolKind.File]=0,t[n.SymbolKind.Module]=1,t[n.SymbolKind.Namespace]=2,t[n.SymbolKind.Package]=3,t[n.SymbolKind.Class]=4,t[n.SymbolKind.Method]=5,t[n.SymbolKind.Property]=6,t[n.SymbolKind.Field]=7,t[n.SymbolKind.Constructor]=8,t[n.SymbolKind.Enum]=9,t[n.SymbolKind.Interface]=10,t[n.SymbolKind.Function]=11,t[n.SymbolKind.Variable]=12,t[n.SymbolKind.Constant]=13,t[n.SymbolKind.String]=14,t[n.SymbolKind.Number]=15,t[n.SymbolKind.Boolean]=16,t[n.SymbolKind.Array]=17,t[n.SymbolKind.Object]=18,t[n.SymbolKind.Key]=19,t[n.SymbolKind.Null]=20,t[n.SymbolKind.EnumMember]=21,t[n.SymbolKind.Struct]=22,t[n.SymbolKind.Event]=23,t[n.SymbolKind.Operator]=24,t[n.SymbolKind.TypeParameter]=25,e.from=function(e){return"number"==typeof t[e]?t[e]:6},e.to=function(e){
for(const i in t)if(t[i]===e)return Number(i);return n.SymbolKind.Property}}(C=t.SymbolKind||(t.SymbolKind={})),function(e){e.from=function(e){switch(e){case n.SymbolTag.Deprecated:return 1}},e.to=function(e){switch(e){case 1:return n.SymbolTag.Deprecated}}}(S=t.SymbolTag||(t.SymbolTag={})),function(e){e.from=function(e){return{name:e.name,kind:C.from(e.kind),tags:e.tags&&e.tags.map(S.from),containerName:e.containerName,location:T.from(e.location)}},e.to=function(e){const t=new n.SymbolInformation(e.name,C.to(e.kind),e.containerName,T.to(e.location));return t.tags=e.tags&&e.tags.map(S.to),t}}(t.WorkspaceSymbol||(t.WorkspaceSymbol={})),function(e){e.from=function e(t){const i={name:t.name||"!!MISSING: name!!",detail:t.detail,range:f.from(t.range),selectionRange:f.from(t.selectionRange),kind:C.from(t.kind),tags:t.tags?t.tags.map(S.from):[]};return t.children&&(i.children=t.children.map(e)),i},e.to=function e(t){const i=new n.DocumentSymbol(t.name,t.detail,C.to(t.kind),f.to(t.range),f.to(t.selectionRange))
;return m.isNonEmptyArray(t.tags)&&(i.tags=t.tags.map(S.to)),t.children&&(i.children=t.children.map(e)),i}}(t.DocumentSymbol||(t.DocumentSymbol={})),function(e){e.to=function(e){const t=new n.CallHierarchyItem(C.to(e.kind),e.name,e.detail||"",r.URI.revive(e.uri),f.to(e.range),f.to(e.selectionRange));return t._sessionId=e._sessionId,t._itemId=e._itemId,t}}(k=t.CallHierarchyItem||(t.CallHierarchyItem={})),function(e){e.to=function(e){return new n.CallHierarchyIncomingCall(k.to(e.from),e.fromRanges.map(e=>f.to(e)))}}(t.CallHierarchyIncomingCall||(t.CallHierarchyIncomingCall={})),function(e){e.to=function(e){return new n.CallHierarchyOutgoingCall(k.to(e.to),e.fromRanges.map(e=>f.to(e)))}}(t.CallHierarchyOutgoingCall||(t.CallHierarchyOutgoingCall={})),function(e){e.from=function(e){return{range:e.range&&f.from(e.range),uri:e.uri}},e.to=function(e){return new n.Location(e.uri,f.to(e.range))}}(T=t.location||(t.location={})),function(e){e.from=function(e){const t=e,i=e;return{
originSelectionRange:t.originSelectionRange?f.from(t.originSelectionRange):void 0,uri:t.targetUri?t.targetUri:i.uri,range:f.from(t.targetRange?t.targetRange:i.range),targetSelectionRange:t.targetSelectionRange?f.from(t.targetSelectionRange):void 0}},e.to=function(e){return{targetUri:e.uri,targetRange:f.to(e.range),targetSelectionRange:e.targetSelectionRange?f.to(e.targetSelectionRange):void 0,originSelectionRange:e.originSelectionRange?f.to(e.originSelectionRange):void 0}}}(t.DefinitionLink||(t.DefinitionLink={})),function(e){e.from=function(e){return{range:f.from(e.range),contents:y.fromMany(e.contents)}},e.to=function(e){return new n.Hover(e.contents.map(y.to),f.to(e.range))}}(t.Hover||(t.Hover={})),function(e){e.from=function(e){return{range:f.from(e.range),expression:e.expression}},e.to=function(e){return new n.EvaluatableExpression(f.to(e.range),e.expression)}}(t.EvaluatableExpression||(t.EvaluatableExpression={})),function(e){e.from=function(e){return{range:f.from(e.range),kind:e.kind}},
e.to=function(e){return new n.DocumentHighlight(f.to(e.range),e.kind)}}(t.DocumentHighlight||(t.DocumentHighlight={})),function(e){e.to=function(e){switch(e){case 1:return n.CompletionTriggerKind.TriggerCharacter;case 2:return n.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return n.CompletionTriggerKind.Invoke}}}(I=t.CompletionTriggerKind||(t.CompletionTriggerKind={})),function(e){e.to=function(e){return{triggerKind:I.to(e.triggerKind),triggerCharacter:e.triggerCharacter}}}(t.CompletionContext||(t.CompletionContext={})),function(e){e.from=function(e){switch(e){case n.CompletionItemTag.Deprecated:return 1}},e.to=function(e){switch(e){case 1:return n.CompletionItemTag.Deprecated}}}(D=t.CompletionItemTag||(t.CompletionItemTag={})),function(e){
const t=new Map([[n.CompletionItemKind.Method,0],[n.CompletionItemKind.Function,1],[n.CompletionItemKind.Constructor,2],[n.CompletionItemKind.Field,3],[n.CompletionItemKind.Variable,4],[n.CompletionItemKind.Class,5],[n.CompletionItemKind.Interface,7],[n.CompletionItemKind.Struct,6],[n.CompletionItemKind.Module,8],[n.CompletionItemKind.Property,9],[n.CompletionItemKind.Unit,12],[n.CompletionItemKind.Value,13],[n.CompletionItemKind.Constant,14],[n.CompletionItemKind.Enum,15],[n.CompletionItemKind.EnumMember,16],[n.CompletionItemKind.Keyword,17],[n.CompletionItemKind.Snippet,27],[n.CompletionItemKind.Text,18],[n.CompletionItemKind.Color,19],[n.CompletionItemKind.File,20],[n.CompletionItemKind.Reference,21],[n.CompletionItemKind.Folder,23],[n.CompletionItemKind.Event,10],[n.CompletionItemKind.Operator,11],[n.CompletionItemKind.TypeParameter,24],[n.CompletionItemKind.Issue,26],[n.CompletionItemKind.User,25]]);e.from=function(e){var i;return null!==(i=t.get(e))&&void 0!==i?i:9}
;const i=new Map([[0,n.CompletionItemKind.Method],[1,n.CompletionItemKind.Function],[2,n.CompletionItemKind.Constructor],[3,n.CompletionItemKind.Field],[4,n.CompletionItemKind.Variable],[5,n.CompletionItemKind.Class],[7,n.CompletionItemKind.Interface],[6,n.CompletionItemKind.Struct],[8,n.CompletionItemKind.Module],[9,n.CompletionItemKind.Property],[12,n.CompletionItemKind.Unit],[13,n.CompletionItemKind.Value],[14,n.CompletionItemKind.Constant],[15,n.CompletionItemKind.Enum],[16,n.CompletionItemKind.EnumMember],[17,n.CompletionItemKind.Keyword],[27,n.CompletionItemKind.Snippet],[18,n.CompletionItemKind.Text],[19,n.CompletionItemKind.Color],[20,n.CompletionItemKind.File],[21,n.CompletionItemKind.Reference],[23,n.CompletionItemKind.Folder],[10,n.CompletionItemKind.Event],[11,n.CompletionItemKind.Operator],[24,n.CompletionItemKind.TypeParameter],[25,n.CompletionItemKind.User],[26,n.CompletionItemKind.Issue]]);e.to=function(e){var t;return null!==(t=i.get(e))&&void 0!==t?t:n.CompletionItemKind.Property}
}(P=t.CompletionItemKind||(t.CompletionItemKind={})),function(e){e.to=function(e,t){const i=new n.CompletionItem("string"==typeof e.label?e.label:e.label.name);return"string"!=typeof e.label&&(i.label2=e.label),i.insertText=e.insertText,i.kind=P.to(e.kind),i.tags=e.tags&&e.tags.map(D.to),i.detail=e.detail,i.documentation=s.isMarkdownString(e.documentation)?y.to(e.documentation):e.documentation,i.sortText=e.sortText,i.filterText=e.filterText,i.preselect=e.preselect,i.commitCharacters=e.commitCharacters,o.Range.isIRange(e.range)?i.range=f.to(e.range):"object"==typeof e.range&&(i.range={inserting:f.to(e.range.insert),replacing:f.to(e.range.replace)}),i.keepWhitespace=void 0!==e.insertTextRules&&Boolean(1&e.insertTextRules),void 0!==e.insertTextRules&&4&e.insertTextRules?i.insertText=new n.SnippetString(e.insertText):(i.insertText=e.insertText,i.textEdit=i.range instanceof n.Range?new n.TextEdit(i.range,i.insertText):void 0),
e.additionalTextEdits&&e.additionalTextEdits.length>0&&(i.additionalTextEdits=e.additionalTextEdits.map(e=>x.to(e))),i.command=t&&e.command?t.fromInternal(e.command):void 0,i}}(t.CompletionItem||(t.CompletionItem={})),function(e){e.from=function(e){return{label:e.label,documentation:e.documentation?y.fromStrict(e.documentation):void 0}},e.to=function(e){return{label:e.label,documentation:s.isMarkdownString(e.documentation)?y.to(e.documentation):e.documentation}}}(R=t.ParameterInformation||(t.ParameterInformation={})),function(e){e.from=function(e){return{label:e.label,documentation:e.documentation?y.fromStrict(e.documentation):void 0,parameters:Array.isArray(e.parameters)?e.parameters.map(R.from):[],activeParameter:e.activeParameter}},e.to=function(e){return{label:e.label,documentation:s.isMarkdownString(e.documentation)?y.to(e.documentation):e.documentation,parameters:Array.isArray(e.parameters)?e.parameters.map(R.to):[],activeParameter:e.activeParameter}}
}(A=t.SignatureInformation||(t.SignatureInformation={})),function(e){e.from=function(e){return{activeSignature:e.activeSignature,activeParameter:e.activeParameter,signatures:Array.isArray(e.signatures)?e.signatures.map(A.from):[]}},e.to=function(e){return{activeSignature:e.activeSignature,activeParameter:e.activeParameter,signatures:Array.isArray(e.signatures)?e.signatures.map(A.to):[]}}}(t.SignatureHelp||(t.SignatureHelp={})),function(e){e.from=function(e){return{range:f.from(e.range),url:e.target,tooltip:e.tooltip}},e.to=function(e){let t=void 0;if(e.url)try{t="string"==typeof e.url?r.URI.parse(e.url,!0):r.URI.revive(e.url)}catch(e){}return new n.DocumentLink(f.to(e.range),t)}}(t.DocumentLink||(t.DocumentLink={})),function(e){e.to=function(e){const t=new n.ColorPresentation(e.label);return e.textEdit&&(t.textEdit=x.to(e.textEdit)),e.additionalTextEdits&&(t.additionalTextEdits=e.additionalTextEdits.map(e=>x.to(e))),t},e.from=function(e){return{label:e.label,textEdit:e.textEdit?x.from(e.textEdit):void 0,
additionalTextEdits:e.additionalTextEdits?e.additionalTextEdits.map(e=>x.from(e)):void 0}}}(t.ColorPresentation||(t.ColorPresentation={})),function(e){e.to=function(e){return new n.Color(e[0],e[1],e[2],e[3])},e.from=function(e){return[e.red,e.green,e.blue,e.alpha]}}(t.Color||(t.Color={})),function(e){e.from=function(e){return{range:f.from(e.range)}},e.to=function(e){return new n.SelectionRange(f.to(e.range))}}(t.SelectionRange||(t.SelectionRange={})),function(e){e.to=function(e){switch(e){case 2:return n.TextDocumentSaveReason.AfterDelay;case 1:return n.TextDocumentSaveReason.Manual;case 3:case 4:return n.TextDocumentSaveReason.FocusOut}}}(t.TextDocumentSaveReason||(t.TextDocumentSaveReason={})),function(e){e.from=function(e){switch(e){case n.TextEditorLineNumbersStyle.Off:return 0;case n.TextEditorLineNumbersStyle.Relative:return 2;case n.TextEditorLineNumbersStyle.On:default:return 1}},e.to=function(e){switch(e){case 0:return n.TextEditorLineNumbersStyle.Off;case 2:
return n.TextEditorLineNumbersStyle.Relative;case 1:default:return n.TextEditorLineNumbersStyle.On}}}(t.TextEditorLineNumbersStyle||(t.TextEditorLineNumbersStyle={})),function(e){e.from=function(e){return e===n.EndOfLine.CRLF?1:e===n.EndOfLine.LF?0:void 0},e.to=function(e){return 1===e?n.EndOfLine.CRLF:0===e?n.EndOfLine.LF:void 0}}(O=t.EndOfLine||(t.EndOfLine={})),function(e){e.from=function(e){if("object"==typeof e)return e.viewId;switch(e){case n.ProgressLocation.SourceControl:return 3;case n.ProgressLocation.Window:return 10;case n.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}}(t.ProgressLocation||(t.ProgressLocation={})),function(e){e.from=function(e){const t={start:e.start+1,end:e.end+1};return e.kind&&(t.kind=L.from(e.kind)),t}}(t.FoldingRange||(t.FoldingRange={})),function(e){e.from=function(e){if(e)switch(e){case n.FoldingRangeKind.Comment:return i.FoldingRangeKind.Comment;case n.FoldingRangeKind.Imports:return i.FoldingRangeKind.Imports
;case n.FoldingRangeKind.Region:return i.FoldingRangeKind.Region}}}(L=t.FoldingRangeKind||(t.FoldingRangeKind={})),function(e){e.from=function(e){if(e)return{pinned:"boolean"==typeof e.preview?!e.preview:void 0,preserveFocus:e.preserveFocus,selection:"object"==typeof e.selection?f.from(e.selection):void 0}}}(t.TextEditorOptions||(t.TextEditorOptions={})),function(e){e.from=function(e){return e instanceof n.RelativePattern?e:"string"==typeof e?e:function(e){const t=e;return t&&"string"==typeof t.base&&"string"==typeof t.pattern}(e)?new n.RelativePattern(e.base,e.pattern):e}}(M=t.GlobPattern||(t.GlobPattern={})),function(e){e.from=function e(t){return t?Array.isArray(t)?t.map(e):"string"==typeof t?t:{language:t.language,scheme:t.scheme,pattern:void 0===t.pattern?void 0:M.from(t.pattern),exclusive:t.exclusive}:void 0}}(t.LanguageSelector||(t.LanguageSelector={})),function(e){e.from=function(e){switch(e){case n.LogLevel.Trace:return p.LogLevel.Trace;case n.LogLevel.Debug:return p.LogLevel.Debug
;case n.LogLevel.Info:return p.LogLevel.Info;case n.LogLevel.Warning:return p.LogLevel.Warning;case n.LogLevel.Error:return p.LogLevel.Error;case n.LogLevel.Critical:return p.LogLevel.Critical;case n.LogLevel.Off:return p.LogLevel.Off}return p.LogLevel.Info},e.to=function(e){switch(e){case p.LogLevel.Trace:return n.LogLevel.Trace;case p.LogLevel.Debug:return n.LogLevel.Debug;case p.LogLevel.Info:return n.LogLevel.Info;case p.LogLevel.Warning:return n.LogLevel.Warning;case p.LogLevel.Error:return n.LogLevel.Error;case p.LogLevel.Critical:return n.LogLevel.Critical;case p.LogLevel.Off:return n.LogLevel.Off}return n.LogLevel.Info}}(t.LogLevel||(t.LogLevel={}))})),define(t[176],i([1,0,2,21,241,61,20,11,244]),(function(e,t,i,n,r,o,s,a,c){"use strict";function l(e){return(t,...i)=>e(t.get(r.ICommandService),...i)}Object.defineProperty(t,"__esModule",{value:!0}),
t.SetEditorLayoutAPICommand=t.OpenIssueReporter=t.RemoveFromRecentlyOpenedAPICommand=t.OpenWithAPICommand=t.OpenAPICommand=t.DiffAPICommand=t.NewWindowAPICommand=t.OpenFolderAPICommand=void 0;let u=(()=>{class e{static execute(e,t,n={}){if("boolean"==typeof n&&(n={forceNewWindow:n}),!t)return e.executeCommand("_files.pickFolderAndOpen",{forceNewWindow:n.forceNewWindow});const r={forceNewWindow:n.forceNewWindow,forceReuseWindow:n.forceReuseWindow,noRecentEntry:n.noRecentEntry};t=i.URI.revive(t);const a=o.hasWorkspaceFileExtension(t)||t.scheme===s.Schemas.untitled?{workspaceUri:t}:{folderUri:t};return e.executeCommand("_files.windowOpen",[a],r)}}return e.ID="vscode.openFolder",e})();t.OpenFolderAPICommand=u,r.CommandsRegistry.registerCommand({id:u.ID,handler:l(u.execute),description:{
description:"Open a folder or workspace in the current window or new window depending on the newWindow argument. Note that opening in the same window will shutdown the current extension host process and start a new one on the given folder/workspace unless the newWindow parameter is set to true.",args:[{name:"uri",description:"(optional) Uri of the folder or workspace file to open. If not provided, a native dialog will ask the user for the folder",constraint:e=>void 0===e||e instanceof i.URI},{name:"options",description:"(optional) Options. Object with the following properties: `forceNewWindow `: Whether to open the folder/workspace in a new window or the same. Defaults to opening in the same window. `noRecentEntry`: Wheter the opened URI will appear in the 'Open Recent' list. Defaults to true.  Note, for backward compatibility, options can also be of type boolean, representing the `forceNewWindow` setting.",constraint:e=>void 0===e||"object"==typeof e||"boolean"==typeof e}]}});let d=(()=>{class e{
static execute(e,t){const i={forceReuseWindow:t&&t.reuseWindow,remoteAuthority:t&&t.remoteAuthority};return e.executeCommand("_files.newWindow",i)}}return e.ID="vscode.newWindow",e})();t.NewWindowAPICommand=d,r.CommandsRegistry.registerCommand({id:d.ID,handler:l(d.execute),description:{description:"Opens an new window",args:[]}});let h=(()=>{class e{static execute(e,t,i,r,o){return e.executeCommand("_workbench.diff",[t,i,r,void 0,n.TextEditorOptions.from(o),o?n.ViewColumn.from(o.viewColumn):void 0])}}return e.ID="vscode.diff",e})();t.DiffAPICommand=h,r.CommandsRegistry.registerCommand(h.ID,l(h.execute));let p=(()=>{class e{static execute(e,t,i,r){let o,s;return i&&("number"==typeof i?s=n.ViewColumn.from(i):(o=n.TextEditorOptions.from(i),s=n.ViewColumn.from(i.viewColumn))),e.executeCommand("_workbench.open",[t,o,s,r])}}return e.ID="vscode.open",e})();t.OpenAPICommand=p,r.CommandsRegistry.registerCommand(p.ID,l(p.execute));let m=(()=>{class e{static execute(e,t,i,r){let o,s
;return"number"==typeof r?s=n.ViewColumn.from(r):void 0!==r&&(o=n.TextEditorOptions.from(r)),e.executeCommand("_workbench.openWith",[t,i,o,s])}}return e.ID="vscode.openWith",e})();t.OpenWithAPICommand=m,r.CommandsRegistry.registerCommand(m.ID,l(m.execute)),r.CommandsRegistry.registerCommand("_workbench.removeFromRecentlyOpened",(function(e,t){return e.get(o.IWorkspacesService).removeRecentlyOpened([t])}));let f=(()=>{class e{static execute(e,t){return t="string"==typeof t?t.match(/^[^:/?#]+:\/\//)?i.URI.parse(t):i.URI.file(t):i.URI.revive(t),e.executeCommand("_workbench.removeFromRecentlyOpened",t)}}return e.ID="vscode.removeFromRecentlyOpened",e})();t.RemoveFromRecentlyOpenedAPICommand=f,r.CommandsRegistry.registerCommand(f.ID,l(f.execute));let g=(()=>{class e{static execute(e,t){const i="string"==typeof t?{extensionId:t}:t;return e.executeCommand("workbench.action.openIssueReporter",i)}}return e.ID="vscode.openIssueReporter",e})();t.OpenIssueReporter=g,
r.CommandsRegistry.registerCommand("_workbench.addToRecentlyOpened",(async function(e,t){const i=e.get(o.IWorkspacesService);let n=void 0;const r=t.uri,s=t.label;if("workspace"===t.type){n={workspace:await i.getWorkspaceIdentifier(r),label:s}}else n="folder"===t.type?{folderUri:r,label:s}:{fileUri:r,label:s};return i.addRecentlyOpened([n])})),r.CommandsRegistry.registerCommand("_workbench.getRecentlyOpened",(async function(e){return e.get(o.IWorkspacesService).getRecentlyOpened()}));let v=(()=>{class e{static execute(e,t){return e.executeCommand("layoutEditorGroups",t)}}return e.ID="vscode.setEditorLayout",e})();t.SetEditorLayoutAPICommand=v,r.CommandsRegistry.registerCommand({id:v.ID,handler:l(v.execute),description:{description:"Set Editor Layout",args:[{name:"args",schema:{type:"object",required:["groups"],properties:{orientation:{type:"number",default:0,enum:[0,1]},groups:{$ref:"#/definitions/editorGroupsSchema",default:[{},{}]}}}}]}}),
r.CommandsRegistry.registerCommand("_extensionTests.setLogLevel",(function(e,t){const i=e.get(a.ILogService),n=e.get(c.IEnvironmentService);n.isExtensionDevelopment&&n.extensionTestsLocationURI&&i.setLevel(t)})),r.CommandsRegistry.registerCommand("_extensionTests.getLogLevel",(function(e){return e.get(a.ILogService).getLevel()}))})),define(t[177],i([1,0,2,6,21,10,72,176,13]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostApiCommands=t.ApiCommand=t.ApiCommandResult=t.ApiCommandArgument=void 0;let l=(()=>{class e{constructor(e,t,i,n){this.name=e,this.description=t,this.validate=i,this.convert=n}}return e.Uri=new e("uri","Uri of a text document",e=>i.URI.isUri(e),e=>e),e.Position=new e("position","A position in a text document",e=>o.Position.isPosition(e),r.Position.from),e.Range=new e("range","A range in a text document",e=>o.Range.isRange(e),r.Range.from),
e.CallHierarchyItem=new e("item","A call hierarchy item",e=>e instanceof o.CallHierarchyItem,r.CallHierarchyItem.to),e})();t.ApiCommandArgument=l;class u{constructor(e,t){this.description=e,this.convert=t}}t.ApiCommandResult=u;class d{constructor(e,t,i,n,r){this.id=e,this.internalId=t,this.description=i,this.args=n,this.result=r}register(e){return e.registerCommand(!1,this.id,async(...t)=>{const i=this.args.map((e,i)=>{if(!e.validate(t[i]))throw new Error(`Invalid argument '${e.name}' when running '${this.id}', receieved: ${t[i]}`);return e.convert(t[i])}),n=await e.executeCommand(this.internalId,...i);return this.result.convert(n,t)},void 0,this._getCommandHandlerDesc())}_getCommandHandlerDesc(){return{description:this.description,args:this.args,returns:this.result.description}}}t.ApiCommand=d
;const h=[new d("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[l.Uri,l.Position],new u("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",m(r.DocumentHighlight.to))),new d("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[l.Uri],new u("A promise that resolves to an array of DocumentHighlight-instances.",(e,t)=>{if(!c.isFalsyOrEmpty(e)){class i extends o.SymbolInformation{static to(e){const n=new i(e.name,r.SymbolKind.to(e.kind),e.containerName||"",new o.Location(t[0],r.Range.to(e.range)));return n.detail=e.detail,n.range=n.location.range,n.selectionRange=r.Range.to(e.selectionRange),n.children=e.children?e.children.map(i.to):[],n}}return e.map(i.to)}
})),new d("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[l.Uri,new l("options","Formatting options",e=>!0,e=>e)],new u("A promise that resolves to an array of TextEdits.",m(r.TextEdit.to))),new d("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[l.Uri,l.Range,new l("options","Formatting options",e=>!0,e=>e)],new u("A promise that resolves to an array of TextEdits.",m(r.TextEdit.to))),new d("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[l.Uri,l.Position,new l("ch","Trigger character",e=>"string"==typeof e,e=>e),new l("options","Formatting options",e=>!0,e=>e)],new u("A promise that resolves to an array of TextEdits.",m(r.TextEdit.to))),new d("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Location or LocationLink instances.",f)),new d("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Location or LocationLink instances.",f)),new d("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Location or LocationLink instances.",f)),new d("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Location or LocationLink instances.",f)),new d("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Location-instances.",m(r.location.to))),new d("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[l.Uri,l.Position],new u("A promise that resolves to an array of Hover-instances.",m(r.Hover.to))),new d("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[l.Uri,new l("position","A positions in a text document",e=>Array.isArray(e)&&e.every(e=>o.Position.isPosition(e)),e=>e.map(r.Position.from))],new u("A promise that resolves to an array of ranges.",e=>e.map(e=>{
let t;for(const i of e.reverse())t=new o.SelectionRange(r.Range.to(i),t);return t}))),new d("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[new l("query","Search string",e=>"string"==typeof e,e=>e)],new u("A promise that resolves to an array of SymbolInformation-instances.",e=>{const t=[];if(Array.isArray(e))for(let i of e)t.push(...i[1].map(r.WorkspaceSymbol.to));return t
})),new d("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[l.Uri,l.Position],new u("A CallHierarchyItem or undefined",e=>e.map(r.CallHierarchyItem.to))),new d("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[l.CallHierarchyItem],new u("A CallHierarchyItem or undefined",e=>e.map(r.CallHierarchyIncomingCall.to))),new d("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[l.CallHierarchyItem],new u("A CallHierarchyItem or undefined",e=>e.map(r.CallHierarchyOutgoingCall.to)))];class p{constructor(e){this._disposables=new n.DisposableStore,this._commands=e}static register(e){return h.forEach(t=>t.register(e)),new p(e).registerCommands()}registerCommands(){this._register("vscode.executeDocumentRenameProvider",this._executeDocumentRenameProvider,{description:"Execute rename provider.",args:[{name:"uri",description:"Uri of a text document",
constraint:i.URI},{name:"position",description:"Position in a text document",constraint:o.Position},{name:"newName",description:"The new symbol name",constraint:String}],returns:"A promise that resolves to a WorkspaceEdit."}),this._register("vscode.executeSignatureHelpProvider",this._executeSignatureHelpProvider,{description:"Execute signature help provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI},{name:"position",description:"Position in a text document",constraint:o.Position},{name:"triggerCharacter",description:"(optional) Trigger signature help when the user types the character, like `,` or `(`",constraint:e=>void 0===e||"string"==typeof e}],returns:"A promise that resolves to SignatureHelp."}),this._register("vscode.executeCompletionItemProvider",this._executeCompletionItemProvider,{description:"Execute completion item provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI},{name:"position",description:"Position in a text document",
constraint:o.Position},{name:"triggerCharacter",description:"(optional) Trigger completion when the user types the character, like `,` or `(`",constraint:e=>void 0===e||"string"==typeof e},{name:"itemResolveCount",description:"(optional) Number of completions to resolve (too large numbers slow down completions)",constraint:e=>void 0===e||"number"==typeof e}],returns:"A promise that resolves to a CompletionList-instance."}),this._register("vscode.executeCodeActionProvider",this._executeCodeActionProvider,{description:"Execute code action provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI},{name:"rangeOrSelection",description:"Range in a text document. Some refactoring provider requires Selection object.",constraint:o.Range},{name:"kind",description:"(optional) Code action kind to return code actions for",constraint:e=>!e||"string"==typeof e.value}],returns:"A promise that resolves to an array of Command-instances."}),
this._register("vscode.executeCodeLensProvider",this._executeCodeLensProvider,{description:"Execute CodeLens provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI},{name:"itemResolveCount",description:"(optional) Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)",constraint:e=>void 0===e||"number"==typeof e}],returns:"A promise that resolves to an array of CodeLens-instances."}),this._register("vscode.executeLinkProvider",this._executeDocumentLinkProvider,{description:"Execute document link provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI}],returns:"A promise that resolves to an array of DocumentLink-instances."}),this._register("vscode.executeDocumentColorProvider",this._executeDocumentColorProvider,{description:"Execute document color provider.",args:[{name:"uri",description:"Uri of a text document",constraint:i.URI}],
returns:"A promise that resolves to an array of ColorInformation objects."}),this._register("vscode.executeColorPresentationProvider",this._executeColorPresentationProvider,{description:"Execute color presentation provider.",args:[{name:"color",description:"The color to show and insert",constraint:o.Color},{name:"context",description:"Context object with uri and range"}],returns:"A promise that resolves to an array of ColorPresentation objects."});const e=e=>(...t)=>e(this._commands,...t);this._register(a.OpenFolderAPICommand.ID,e(a.OpenFolderAPICommand.execute),{description:"Open a folder or workspace in the current window or new window depending on the newWindow argument. Note that opening in the same window will shutdown the current extension host process and start a new one on the given folder/workspace unless the newWindow parameter is set to true.",args:[{name:"uri",description:"(optional) Uri of the folder or workspace file to open. If not provided, a native dialog will ask the user for the folder",
constraint:e=>void 0===e||i.URI.isUri(e)},{name:"options",description:"(optional) Options. Object with the following properties: `forceNewWindow `: Whether to open the folder/workspace in a new window or the same. Defaults to opening in the same window. `noRecentEntry`: Whether the opened URI will appear in the 'Open Recent' list. Defaults to true. Note, for backward compatibility, options can also be of type boolean, representing the `forceNewWindow` setting.",constraint:e=>void 0===e||"object"==typeof e||"boolean"==typeof e}]}),this._register(a.DiffAPICommand.ID,e(a.DiffAPICommand.execute),{description:"Opens the provided resources in the diff editor to compare their contents.",args:[{name:"left",description:"Left-hand side resource of the diff editor",constraint:i.URI},{name:"right",description:"Right-hand side resource of the diff editor",constraint:i.URI},{name:"title",description:"(optional) Human readable title for the diff editor",constraint:e=>void 0===e||"string"==typeof e},{name:"options",
description:"(optional) Editor options, see vscode.TextDocumentShowOptions"}]}),this._register(a.OpenAPICommand.ID,e(a.OpenAPICommand.execute),{description:"Opens the provided resource in the editor. Can be a text or binary file, or a http(s) url. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",args:[{name:"resource",description:"Resource to open",constraint:i.URI},{name:"columnOrOptions",description:"(optional) Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",constraint:e=>void 0===e||"number"==typeof e||"object"==typeof e}]}),this._register(a.RemoveFromRecentlyOpenedAPICommand.ID,e(a.RemoveFromRecentlyOpenedAPICommand.execute),{description:"Removes an entry with the given path from the recently opened list.",args:[{name:"path",description:"Path to remove from recently opened.",constraint:e=>"string"==typeof e}]}),this._register(a.SetEditorLayoutAPICommand.ID,e(a.SetEditorLayoutAPICommand.execute),{
description:"Sets the editor layout. The layout is described as object with an initial (optional) orientation (0 = horizontal, 1 = vertical) and an array of editor groups within. Each editor group can have a size and another array of editor groups that will be laid out orthogonal to the orientation. If editor group sizes are provided, their sum must be 1 to be applied per row or column. Example for a 2x2 grid: `{ orientation: 0, groups: [{ groups: [{}, {}], size: 0.5 }, { groups: [{}, {}], size: 0.5 }] }`",args:[{name:"layout",description:"The editor layout to set.",constraint:e=>"object"==typeof e&&Array.isArray(e.groups)}]}),this._register(a.OpenIssueReporter.ID,e(a.OpenIssueReporter.execute),{description:"Opens the issue reporter with the provided extension id as the selected source",args:[{name:"extensionId",description:"extensionId to report an issue on",constraint:e=>"string"==typeof e||"object"==typeof e&&"string"==typeof e.extensionId}]})}_register(e,t,i){
const n=this._commands.registerCommand(!1,e,t,this,i);this._disposables.add(n)}_executeDocumentRenameProvider(e,t,i){const n={resource:e,position:t&&r.Position.from(t),newName:i};return this._commands.executeCommand("_executeDocumentRenameProvider",n).then(e=>{if(e)return e.rejectReason?Promise.reject(new Error(e.rejectReason)):r.WorkspaceEdit.to(e)})}_executeSignatureHelpProvider(e,t,i){const n={resource:e,position:t&&r.Position.from(t),triggerCharacter:i};return this._commands.executeCommand("_executeSignatureHelpProvider",n).then(e=>{if(e)return r.SignatureHelp.to(e)})}_executeCompletionItemProvider(e,t,i,n){const s={resource:e,position:t&&r.Position.from(t),triggerCharacter:i,maxItemsToResolve:n};return this._commands.executeCommand("_executeCompletionItemProvider",s).then(e=>{if(e){const t=e.suggestions.map(e=>r.CompletionItem.to(e,this._commands.converter));return new o.CompletionList(t,e.incomplete)}})}_executeDocumentColorProvider(e){const t={resource:e}
;return this._commands.executeCommand("_executeDocumentColorProvider",t).then(e=>e?e.map(e=>({range:r.Range.to(e.range),color:r.Color.to(e.color)})):[])}_executeColorPresentationProvider(e,t){const i={resource:t.uri,color:r.Color.from(e),range:r.Range.from(t.range)};return this._commands.executeCommand("_executeColorPresentationProvider",i).then(e=>e?e.map(r.ColorPresentation.to):[])}_executeCodeActionProvider(e,t,i){const n={resource:e,rangeOrSelection:o.Selection.isSelection(t)?r.Selection.from(t):r.Range.from(t),kind:i};return this._commands.executeCommand("_executeCodeActionProvider",n).then(m(e=>{if(e._isSynthetic){if(!e.command)throw new Error("Synthetic code actions must have a command");return this._commands.converter.fromInternal(e.command)}{const t=new o.CodeAction(e.title,e.kind?new o.CodeActionKind(e.kind):void 0);return e.edit&&(t.edit=r.WorkspaceEdit.to(e.edit)),e.command&&(t.command=this._commands.converter.fromInternal(e.command)),t.isPreferred=e.isPreferred,t}}))}
_executeCodeLensProvider(e,t){const i={resource:e,itemResolveCount:t};return this._commands.executeCommand("_executeCodeLensProvider",i).then(m(e=>new o.CodeLens(r.Range.to(e.range),e.command?this._commands.converter.fromInternal(e.command):void 0)))}_executeDocumentLinkProvider(e){return this._commands.executeCommand("_executeLinkProvider",e).then(m(r.DocumentLink.to))}}function m(e){return t=>{if(Array.isArray(t))return t.map(e)}}function f(e){if(!Array.isArray(e))return;const t=[];for(const i of e)s.isLocationLink(i)?t.push(r.DefinitionLink.to(i)):t.push(r.location.to(i));return t}t.ExtHostApiCommands=p})),define(t[178],i([1,0,2,19,10,21,73]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDocumentSaveParticipant=void 0;t.ExtHostDocumentSaveParticipant=class{constructor(e,t,i,n={timeout:1500,errors:3}){this._logService=e,this._documents=t,this._mainThreadEditors=i,this._thresholds=n,this._callbacks=new s.LinkedList,this._badListeners=new WeakMap}dispose(){
this._callbacks.clear()}getOnWillSaveTextDocumentEvent(e){return(t,i,n)=>{const r={dispose:this._callbacks.push([t,i,e])};return Array.isArray(n)&&n.push(r),r}}async $participateInSave(e,t){const n=i.URI.revive(e);let r=!1;const s=setTimeout(()=>r=!0,this._thresholds.timeout),a=[];try{for(let e of[...this._callbacks]){if(r)break;const i=this._documents.getDocument(n),s=await this._deliverEventAsyncAndBlameBadListeners(e,{document:i,reason:o.TextDocumentSaveReason.to(t)});a.push(s)}}finally{clearTimeout(s)}return a}_deliverEventAsyncAndBlameBadListeners([e,t,i],n){const r=this._badListeners.get(e);return"number"==typeof r&&r>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(i,e,t,n).then(()=>!0,t=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' threw ERROR`),this._logService.error(t),!(t instanceof Error)||"concurrent_edits"!==t.message){const t=this._badListeners.get(e);this._badListeners.set(e,t?t+1:1),
"number"==typeof t&&t>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${i.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(e,t,i,s){const a=[],c=Date.now(),{document:l,reason:u}=s,{version:d}=l,h=Object.freeze({document:l,reason:u,waitUntil(e){if(Object.isFrozen(a))throw n.illegalState("waitUntil can not be called async");a.push(Promise.resolve(e))}});try{t.apply(i,[h])}catch(e){return Promise.reject(e)}return Object.freeze(a),new Promise((t,i)=>{const n=setTimeout(()=>i(new Error("timeout")),this._thresholds.timeout);return Promise.all(a).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${e.identifier.value}' finished after ${Date.now()-c}ms`),clearTimeout(n),t(i)}).catch(e=>{clearTimeout(n),i(e)})}).then(e=>{const t={edits:[]};for(const i of e)if(Array.isArray(i)&&i.every(e=>e instanceof r.TextEdit))for(const{newText:e,newEol:n,range:r}of i)t.edits.push({resource:l.uri,
edit:{range:r&&o.Range.from(r),text:e,eol:n&&o.EndOfLine.from(n)}});if(0!==t.edits.length)return d===l.version?this._mainThreadEditors.$tryApplyWorkspaceEdit(t):Promise.reject(new Error("concurrent_edits"))})}}})),define(t[179],i([1,0,21,128,149,22,77]),(function(e,t,i,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostProgress=void 0;t.ExtHostProgress=class{constructor(e){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=e}withProgress(e,t,n){const r=this._handles++,{title:s,location:a,cancellable:c}=t,l=o.localize(0,null,e.displayName||e.name);return this._proxy.$startProgress(r,{location:i.ProgressLocation.from(a),title:s,source:l,cancellable:c},e),this._withProgress(r,n,!!c)}_withProgress(e,t,i){let n;i&&(n=new s.CancellationTokenSource,this._mapHandleToCancellationSource.set(e,n));const r=e=>{this._proxy.$progressEnd(e),this._mapHandleToCancellationSource.delete(e),n&&n.dispose()};let o;try{o=t(new c(this._proxy,e),i&&n?n.token:s.CancellationToken.None)
}catch(t){throw r(e),t}return o.then(t=>r(e),t=>r(e)),o}$acceptProgressCanceled(e){const t=this._mapHandleToCancellationSource.get(e);t&&(t.cancel(),this._mapHandleToCancellationSource.delete(e))}};let c=(()=>{class e extends r.Progress{constructor(e,t){super(e=>this.throttledReport(e)),this._proxy=e,this._handle=t}throttledReport(e){this._proxy.$progressReport(this._handle,e)}}return n([a.throttle(100,(e,t)=>(function(e,t){return e.message=t.message,"number"==typeof t.increment&&("number"==typeof e.increment?e.increment+=t.increment:e.increment=t.increment),e})(e,t),()=>Object.create(null))],e.prototype,"throttledReport",null),e})()})),define(t[103],i([1,0,56,19,113,21,10]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTextEditor=t.ExtHostTextEditorOptions=t.TextEditorEdit=t.TextEditorDecorationType=void 0;let a=(()=>{class e{constructor(t,i){this.key=e._Keys.nextId(),this._proxy=t,
this._proxy.$registerTextEditorDecorationType(this.key,o.DecorationRenderOptions.from(i))}dispose(){this._proxy.$removeTextEditorDecorationType(this.key)}}return e._Keys=new r.IdGenerator("TextEditorDecorationType"),e})();t.TextEditorDecorationType=a;class c{constructor(e,t){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=e,this._documentVersionId=e.version,this._undoStopBefore=t.undoStopBefore,this._undoStopAfter=t.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(e,t){this._throwIfFinalized();let i=null;if(e instanceof s.Position)i=new s.Range(e,e);else{if(!(e instanceof s.Range))throw new Error("Unrecognized location");i=e}this._pushEdit(i,t,!1)}insert(e,t){this._throwIfFinalized(),
this._pushEdit(new s.Range(e,e),t,!0)}delete(e){this._throwIfFinalized();let t=null;if(!(e instanceof s.Range))throw new Error("Unrecognized location");t=e,this._pushEdit(t,null,!0)}_pushEdit(e,t,i){const n=this._document.validateRange(e);this._collectedEdits.push({range:n,text:t,forceMoveMarkers:i})}setEndOfLine(e){if(this._throwIfFinalized(),e!==s.EndOfLine.LF&&e!==s.EndOfLine.CRLF)throw n.illegalArgument("endOfLine");this._setEndOfLine=e}}t.TextEditorEdit=c;class l{constructor(e,t,i,n){this._proxy=e,this._id=t,this._accept(i),this._logService=n}_accept(e){this._tabSize=e.tabSize,this._indentSize=e.indentSize,this._insertSpaces=e.insertSpaces,this._cursorStyle=e.cursorStyle,this._lineNumbers=o.TextEditorLineNumbersStyle.to(e.lineNumbers)}get tabSize(){return this._tabSize}_validateTabSize(e){if("auto"===e)return"auto";if("number"==typeof e){const t=Math.floor(e);return t>0?t:null}if("string"==typeof e){const t=parseInt(e,10);return isNaN(t)?null:t>0?t:null}return null}set tabSize(e){
const t=this._validateTabSize(e);if(null!==t){if("number"==typeof t){if(this._tabSize===t)return;this._tabSize=t}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:t}))}}get indentSize(){return this._indentSize}_validateIndentSize(e){if("tabSize"===e)return"tabSize";if("number"==typeof e){const t=Math.floor(e);return t>0?t:null}if("string"==typeof e){const t=parseInt(e,10);return isNaN(t)?null:t>0?t:null}return null}set indentSize(e){const t=this._validateIndentSize(e);if(null!==t){if("number"==typeof t){if(this._indentSize===t)return;this._indentSize=t}this._warnOnError(this._proxy.$trySetOptions(this._id,{indentSize:t}))}}get insertSpaces(){return this._insertSpaces}_validateInsertSpaces(e){return"auto"===e?"auto":"false"!==e&&Boolean(e)}set insertSpaces(e){const t=this._validateInsertSpaces(e);if("boolean"==typeof t){if(this._insertSpaces===t)return;this._insertSpaces=t}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:t}))}get cursorStyle(){return this._cursorStyle}
set cursorStyle(e){this._cursorStyle!==e&&(this._cursorStyle=e,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:e})))}get lineNumbers(){return this._lineNumbers}set lineNumbers(e){this._lineNumbers!==e&&(this._lineNumbers=e,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:o.TextEditorLineNumbersStyle.from(e)})))}assign(e){const t={};let i=!1;if(void 0!==e.tabSize){const n=this._validateTabSize(e.tabSize);"auto"===n?(i=!0,t.tabSize=n):"number"==typeof n&&this._tabSize!==n&&(this._tabSize=n,i=!0,t.tabSize=n)}if(void 0!==e.insertSpaces){const n=this._validateInsertSpaces(e.insertSpaces);"auto"===n?(i=!0,t.insertSpaces=n):this._insertSpaces!==n&&(this._insertSpaces=n,i=!0,t.insertSpaces=n)}void 0!==e.cursorStyle&&this._cursorStyle!==e.cursorStyle&&(this._cursorStyle=e.cursorStyle,i=!0,t.cursorStyle=e.cursorStyle),void 0!==e.lineNumbers&&this._lineNumbers!==e.lineNumbers&&(this._lineNumbers=e.lineNumbers,i=!0,t.lineNumbers=o.TextEditorLineNumbersStyle.from(e.lineNumbers)),
i&&this._warnOnError(this._proxy.$trySetOptions(this._id,t))}_warnOnError(e){e.catch(e=>this._logService.warn(e))}}t.ExtHostTextEditorOptions=l;t.ExtHostTextEditor=class{constructor(e,t,i,n,r,o,s,a){this.id=e,this._proxy=t,this._logService=i,this._disposed=!1,this._documentData=n,this._selections=r,this._options=new l(this._proxy,this.id,o,i),this._visibleRanges=s,this._viewColumn=a,this._hasDecorationsForKey=Object.create(null)}dispose(){i.ok(!this._disposed),this._disposed=!0}show(e){this._proxy.$tryShowEditor(this.id,o.ViewColumn.from(e))}hide(){this._proxy.$tryHideEditor(this.id)}get document(){return this._documentData.document}set document(e){throw n.readonly("document")}get options(){return this._options}set options(e){this._disposed||this._options.assign(e)}_acceptOptions(e){i.ok(!this._disposed),this._options._accept(e)}get visibleRanges(){return this._visibleRanges}set visibleRanges(e){throw n.readonly("visibleRanges")}_acceptVisibleRanges(e){i.ok(!this._disposed),this._visibleRanges=e}
get viewColumn(){return this._viewColumn}set viewColumn(e){throw n.readonly("viewColumn")}_acceptViewColumn(e){i.ok(!this._disposed),this._viewColumn=e}get selection(){return this._selections&&this._selections[0]}set selection(e){if(!(e instanceof s.Selection))throw n.illegalArgument("selection");this._selections=[e],this._trySetSelection()}get selections(){return this._selections}set selections(e){if(!Array.isArray(e)||e.some(e=>!(e instanceof s.Selection)))throw n.illegalArgument("selections");this._selections=e,this._trySetSelection()}setDecorations(e,t){const i=0===t.length;i&&!this._hasDecorationsForKey[e.key]||(i?delete this._hasDecorationsForKey[e.key]:this._hasDecorationsForKey[e.key]=!0,this._runOnProxy(()=>{if(o.isDecorationOptionsArr(t))return this._proxy.$trySetDecorations(this.id,e.key,o.fromRangeOrRangeWithMessage(t));{const i=new Array(4*t.length);for(let e=0,n=t.length;e<n;e++){const n=t[e];i[4*e]=n.start.line+1,i[4*e+1]=n.start.character+1,i[4*e+2]=n.end.line+1,i[4*e+3]=n.end.character+1}
return this._proxy.$trySetDecorationsFast(this.id,e.key,i)}}))}revealRange(e,t){this._runOnProxy(()=>this._proxy.$tryRevealRange(this.id,o.Range.from(e),t||s.TextEditorRevealType.Default))}_trySetSelection(){const e=this._selections.map(o.Selection.from);return this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,e))}_acceptSelections(e){i.ok(!this._disposed),this._selections=e}edit(e,t={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const i=new c(this._documentData.document,t);return e(i),this._applyEdit(i)}_applyEdit(e){const t=e.finalize();if(0===t.edits.length&&!t.setEndOfLine)return Promise.resolve(!0);const i=t.edits.map(e=>e.range);i.sort((e,t)=>e.end.line===t.end.line?e.end.character===t.end.character?e.start.line===t.start.line?e.start.character-t.start.character:e.start.line-t.start.line:e.end.character-t.end.character:e.end.line-t.end.line);for(let e=0,t=i.length-1;e<t;e++){const t=i[e].end
;if(i[e+1].start.isBefore(t))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const n=t.edits.map(e=>({range:o.Range.from(e.range),text:e.text,forceMoveMarkers:e.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,t.documentVersionId,n,{setEndOfLine:"number"==typeof t.setEndOfLine?o.EndOfLine.from(t.setEndOfLine):void 0,undoStopBefore:t.undoStopBefore,undoStopAfter:t.undoStopAfter})}insertSnippet(e,t,i={undoStopBefore:!0,undoStopAfter:!0}){if(this._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!t||Array.isArray(t)&&0===t.length)n=this._selections.map(e=>o.Range.from(e));else if(t instanceof s.Position){const{lineNumber:e,column:i}=o.Position.from(t);n=[{startLineNumber:e,startColumn:i,endLineNumber:e,endColumn:i}]}else if(t instanceof s.Range)n=[o.Range.from(t)];else{n=[];for(const e of t)if(e instanceof s.Range)n.push(o.Range.from(e));else{const{lineNumber:t,column:i}=o.Position.from(e);n.push({startLineNumber:t,
startColumn:i,endLineNumber:t,endColumn:i})}}return this._proxy.$tryInsertSnippet(this.id,e.value,n,i)}_runOnProxy(e){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):e().then(()=>this,e=>(e instanceof Error&&"DISPOSED"===e.name||this._logService.warn(e),null))}}})),define(t[181],i([1,0,28,3,7]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionDescriptionRegistry=t.DeltaExtensionsResult=void 0;class o{constructor(e){this.removedDueToLooping=e}}t.DeltaExtensionsResult=o;class s{constructor(e){this._onDidChange=new n.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=e,this._initialize()}_initialize(){this._extensionDescriptions.sort(c),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map
;for(const e of this._extensionDescriptions)if(this._extensionsMap.has(i.ExtensionIdentifier.toKey(e.identifier)))console.error("Extension `"+e.identifier.value+"` is already registered");else if(this._extensionsMap.set(i.ExtensionIdentifier.toKey(e.identifier),e),this._extensionsArr.push(e),Array.isArray(e.activationEvents))for(let t of e.activationEvents)"onUri"===t&&(t=`onUri:${i.ExtensionIdentifier.toKey(e.identifier)}`),this._activationMap.has(t)||this._activationMap.set(t,[]),this._activationMap.get(t).push(e)}keepOnly(e){const t=new Set;e.forEach(e=>t.add(i.ExtensionIdentifier.toKey(e))),this._extensionDescriptions=this._extensionDescriptions.filter(e=>t.has(i.ExtensionIdentifier.toKey(e.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(e,t){e.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(e));const n=s._findLoopingExtensions(this._extensionDescriptions);if((t=t.concat(n.map(e=>e.identifier))).length>0){const e=new Set
;t.forEach(t=>e.add(i.ExtensionIdentifier.toKey(t))),this._extensionDescriptions=this._extensionDescriptions.filter(t=>!e.has(i.ExtensionIdentifier.toKey(t.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new o(n)}static _findLoopingExtensions(e){const t=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(e){this._nodesSet.has(e)||(this._nodesSet.add(e),this._nodesArr.push(e))}addArc(e,t){this.addNode(e),this.addNode(t),this._arcs.has(e)?this._arcs.get(e).push(t):this._arcs.set(e,[t])}getArcs(e){return this._arcs.has(e)?this._arcs.get(e):[]}hasOnlyGoodArcs(e,i){const n=t.getArcs(e);for(let e=0;e<n.length;e++)if(!i.has(n[e]))return!1;return!0}getNodes(){return this._nodesArr}};let n=new Map;for(let r of e){const e=i.ExtensionIdentifier.toKey(r.identifier);if(n.set(e,r),r.extensionDependencies)for(let n of r.extensionDependencies){const r=i.ExtensionIdentifier.toKey(n);t.addArc(e,r)}}let r=new Set
;t.getNodes().filter(e=>0===t.getArcs(e).length).forEach(e=>r.add(e));let o,s=t.getNodes().filter(e=>!r.has(e));do{o=!1;for(let e=0;e<s.length;e++){const i=s[e];t.hasOnlyGoodArcs(i,r)&&(s.splice(e,1),e--,r.add(i),o=!0)}}while(o);return s.map(e=>n.get(e))}containsActivationEvent(e){return this._activationMap.has(e)}containsExtension(e){return this._extensionsMap.has(i.ExtensionIdentifier.toKey(e))}getExtensionDescriptionsForActivationEvent(e){const t=this._activationMap.get(e);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(e){const t=this._extensionsMap.get(i.ExtensionIdentifier.toKey(e));return t||void 0}}var a;function c(e,t){const i=e.isBuiltin?0:e.isUnderDevelopment?2:1,n=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(i!==n)return i-n;const o=r.posix.basename(e.extensionLocation.path),s=r.posix.basename(t.extensionLocation.path);return o<s?-1:o>s?1:0}t.ExtensionDescriptionRegistry=s,function(e){e[e.Builtin=0]="Builtin",e[e.User=1]="User",
e[e.Dev=2]="Dev"}(a||(a={}))})),define(t[182],i([1,0,29]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isMessageOfType=t.createMessageOfType=t.MessageType=void 0,function(e){e[e.Initialized=0]="Initialized",e[e.Ready=1]="Ready",e[e.Terminate=2]="Terminate"}(t.MessageType||(t.MessageType={})),t.createMessageOfType=function(e){const t=i.VSBuffer.alloc(1);switch(e){case 0:t.writeUInt8(1,0);break;case 1:t.writeUInt8(2,0);break;case 2:t.writeUInt8(3,0)}return t},t.isMessageOfType=function(e,t){if(1!==e.byteLength)return!1;switch(e.readUInt8(0)){case 1:return 0===t;case 2:return 1===t;case 3:return 2===t;default:return!1}}})),define(t[42],i([1,0,3,2,4,28,190]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NullExtensionService=t.toExtension=t.throwProposedApiError=t.checkProposedApiEnabled=t.ExtensionHostLogFileName=t.ExtensionPointContribution=t.ActivationTimes=t.MissingDependencyError=t.IExtensionService=t.nullExtensionDescription=void 0,t.nullExtensionDescription=Object.freeze({identifier:new o.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:n.URI.parse("void:location"),isBuiltin:!1}),t.IExtensionService=r.createDecorator("extensionService");t.MissingDependencyError=class{constructor(e){this.dependency=e}};t.ActivationTimes=class{constructor(e,t,i,n){this.codeLoadingTime=e,this.activateCallTime=t,this.activateResolvedTime=i,this.activationReason=n}};function a(e){throw new Error(`[${e.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${e.identifier.value}`)}t.ExtensionPointContribution=class{
constructor(e,t){this.description=e,this.value=t}},t.ExtensionHostLogFileName="exthost",t.checkProposedApiEnabled=function(e){e.enableProposedApi||a(e)},t.throwProposedApiError=a,t.toExtension=function(e){return{type:e.isBuiltin?0:1,identifier:{id:s.getGalleryExtensionId(e.publisher,e.name),uuid:e.uuid},manifest:e,location:e.extensionLocation}};t.NullExtensionService=class{constructor(){this.onDidRegisterExtensions=i.Event.None,this.onDidChangeExtensionsStatus=i.Event.None,this.onDidChangeExtensions=i.Event.None,this.onWillActivateByEvent=i.Event.None,this.onDidChangeResponsiveChange=i.Event.None}activateByEvent(e){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(e){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(e){return Promise.resolve(0)}restartExtensionHost(){}
async setRemoteEnvironment(e){}canAddExtension(){return!1}canRemoveExtension(){return!1}_logOrShowMessage(e,t){}_activateById(e,t){return Promise.resolve()}_onWillActivateExtension(e){}_onDidActivateExtension(e,t,i,n,r){}_onExtensionRuntimeError(e,t){}_onExtensionHostExit(e){}}})),define(t[184],i([1,0,140,28,42,11]),(function(e,t,i,r,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsActivator=t.FailedExtension=t.HostExtension=t.EmptyExtension=t.ActivatedExtension=t.ExtensionActivationTimesBuilder=t.ExtensionActivationTimes=void 0;const c=Promise.resolve(void 0);let l=(()=>{class e{constructor(e,t,i,n){this.startup=e,this.codeLoadingTime=t,this.activateCallTime=i,this.activateResolvedTime=n}}return e.NONE=new e(!1,-1,-1,-1),e})();t.ExtensionActivationTimes=l;t.ExtensionActivationTimesBuilder=class{constructor(e){this._startup=e,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,
this._activateResolveStop=-1}_delta(e,t){return-1===e||-1===t?-1:t-e}build(){return new l(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}};class u{constructor(e,t,i,n,r,o){this.activationFailed=e,this.activationFailedError=t,this.activationTimes=i,this.module=n,this.exports=r,this.subscriptions=o}}t.ActivatedExtension=u;t.EmptyExtension=class extends u{constructor(e){super(!1,null,e,{activate:void 0,deactivate:void 0},void 0,[])}};t.HostExtension=class extends u{constructor(){super(!1,null,l.NONE,{activate:void 0,deactivate:void 0
},void 0,[])}};class d extends u{constructor(e){super(!0,e,l.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}t.FailedExtension=d;let h=(()=>{let e=class{constructor(e,t,i,n,o){this._logService=o,this._registry=e,this._resolvedExtensionsSet=new Set,t.forEach(e=>this._resolvedExtensionsSet.add(r.ExtensionIdentifier.toKey(e))),this._hostExtensionsMap=new Map,i.forEach(e=>this._hostExtensionsMap.set(r.ExtensionIdentifier.toKey(e),e)),this._host=n,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(e){const t=r.ExtensionIdentifier.toKey(e);return this._activatedExtensions.has(t)}getActivatedExtension(e){const t=r.ExtensionIdentifier.toKey(e),i=this._activatedExtensions.get(t);if(!i)throw new Error("Extension `"+e.value+"` is not known or not activated");return i}activateByEvent(e,t){if(this._alreadyActivatedEvents[e])return c;const i=this._registry.getExtensionDescriptionsForActivationEvent(e)
;return this._activateExtensions(i.map(i=>({id:i.identifier,reason:{startup:t,extensionId:i.identifier,activationEvent:e}}))).then(()=>{this._alreadyActivatedEvents[e]=!0})}activateById(e,t){const i=this._registry.getExtensionDescription(e);if(!i)throw new Error("Extension `"+e+"` is not known");return this._activateExtensions([{id:i.identifier,reason:t}])}_handleActivateRequest(e,t,n){if(this._hostExtensionsMap.has(r.ExtensionIdentifier.toKey(e.id)))return void(t[r.ExtensionIdentifier.toKey(e.id)]=e);const s=this._registry.getExtensionDescription(e.id);if(!s){this._host.onExtensionActivationError(e.id,new o.MissingDependencyError(e.id.value));const t=new Error(`Unknown dependency '${e.id.value}'`);return void this._activatedExtensions.set(r.ExtensionIdentifier.toKey(e.id),new d(t))}const a=void 0===s.extensionDependencies?[]:s.extensionDependencies;let c=!0;for(let n=0,l=a.length;n<l;n++){const l=a[n];if(this._resolvedExtensionsSet.has(r.ExtensionIdentifier.toKey(l)))continue
;const u=this._activatedExtensions.get(r.ExtensionIdentifier.toKey(l));if(u&&!u.activationFailed)continue;if(u&&u.activationFailed){this._host.onExtensionActivationError(s.identifier,i.localize(0,null,s.displayName||s.identifier.value,l));const e=new Error(`Dependency ${l} failed to activate`);return e.detail=u.activationFailedError,void this._activatedExtensions.set(r.ExtensionIdentifier.toKey(s.identifier),new d(e))}if(this._hostExtensionsMap.has(r.ExtensionIdentifier.toKey(l))){c=!1,t[r.ExtensionIdentifier.toKey(l)]={id:this._hostExtensionsMap.get(r.ExtensionIdentifier.toKey(l)),reason:e.reason};continue}const h=this._registry.getExtensionDescription(l);if(h){c=!1,t[r.ExtensionIdentifier.toKey(l)]={id:h.identifier,reason:e.reason};continue}this._host.onExtensionActivationError(s.identifier,new o.MissingDependencyError(l));const p=new Error(`Unknown dependency '${l}'`);return void this._activatedExtensions.set(r.ExtensionIdentifier.toKey(s.identifier),new d(p))}
c?t[r.ExtensionIdentifier.toKey(s.identifier)]=e:n.push(e)}_activateExtensions(e){if(0===e.length)return Promise.resolve(void 0);if(0===(e=e.filter(e=>!this._activatedExtensions.has(r.ExtensionIdentifier.toKey(e.id)))).length)return Promise.resolve(void 0);const t=Object.create(null),i=[];for(let n=0,r=e.length;n<r;n++)this._handleActivateRequest(e[n],t,i);for(let e=0,n=i.length;e<n;e++){const n=r.ExtensionIdentifier.toKey(i[e].id);t[n]&&delete t[n]}const n=Object.keys(t).map(e=>t[e]);return 0===i.length?Promise.all(n.map(e=>this._activateExtension(e.id,e.reason))).then(e=>void 0):this._activateExtensions(n).then(e=>this._activateExtensions(i))}_activateExtension(e,t){const n=r.ExtensionIdentifier.toKey(e);if(this._activatedExtensions.has(n))return Promise.resolve(void 0);const o=this._activatingExtensions.get(n);if(o)return o;const s=this._host.actualActivateExtension(e,t).then(void 0,t=>(this._host.onExtensionActivationError(e,i.localize(1,null,e.value,t.message)),
this._logService.error(`Activating extension ${e.value} failed due to an error:`),this._logService.error(t),new d(t))).then(e=>{this._activatedExtensions.set(n,e),this._activatingExtensions.delete(n)});return this._activatingExtensions.set(n,s),s}};return e=n([s(4,a.ILogService)],e)})();t.ExtensionsActivator=h})),define(t[185],i([1,0,159,23,2,3,6,16,10,12,13,42]),(function(e,t,i,n,r,o,s,a,c,l,u,d){"use strict";function h(e,t){if(l.isString(e))return{label:e};if(e&&"object"==typeof e&&"string"==typeof e.label){d.checkProposedApiEnabled(t);let i=void 0;return Array.isArray(e.highlights)&&(i=(i=e.highlights.filter(e=>2===e.length&&"number"==typeof e[0]&&"number"==typeof e[1])).length?i:void 0),{label:e.label,highlights:i}}}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTreeViews=void 0;t.ExtHostTreeViews=class{constructor(e,t,i){function n(e){return e&&e.$treeViewId&&e.$treeItemHandle}this._proxy=e,this.commands=t,this.logService=i,this.treeViews=new Map,t.registerArgumentProcessor({
processArgument:e=>n(e)?this.convertArgument(e):Array.isArray(e)&&e.length>0?e.map(e=>n(e)?this.convertArgument(e):e):e})}registerTreeDataProvider(e,t,i){const n=this.createTreeView(e,{treeDataProvider:t},i);return{dispose:()=>n.dispose()}}createTreeView(e,t,i){if(!t||!t.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const n=this.createExtHostTreeView(e,t,i);return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get message(){return n.message},set message(e){n.message=e},get title(){return n.title},set title(e){n.title=e},reveal:(e,t)=>n.reveal(e,t),dispose:()=>{this.treeViews.delete(e),n.dispose()}}}$getChildren(e,t){const n=this.treeViews.get(e);return n?n.getChildren(t):Promise.reject(new Error(i.localize(0,null,e)))}
$setExpanded(e,t,n){const r=this.treeViews.get(e);if(!r)throw new Error(i.localize(1,null,e));r.setExpanded(t,n)}$setSelection(e,t){const n=this.treeViews.get(e);if(!n)throw new Error(i.localize(2,null,e));n.setSelection(t)}$setVisible(e,t){const n=this.treeViews.get(e);if(!n)throw new Error(i.localize(3,null,e));n.setVisible(t)}createExtHostTreeView(e,t,i){const n=new p(e,t,this._proxy,this.commands.converter,this.logService,i);return this.treeViews.set(e,n),n}convertArgument(e){const t=this.treeViews.get(e.$treeViewId);return t?t.getExtensionElement(e.$treeItemHandle):null}};let p=(()=>{class e extends s.Disposable{constructor(e,t,i,n,r,s){if(super(),this.viewId=e,this.proxy=i,this.commands=n,this.logService=r,this.extension=s,this.roots=null,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new o.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new o.Emitter),
this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new o.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new o.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new o.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",s.contributes&&s.contributes.views)for(const t in s.contributes.views)for(const i of s.contributes.views[t])i.id===e&&(this._title=i.name);let a,c;this.dataProvider=t.treeDataProvider,this.proxy.$registerTreeViewDataProvider(e,{showCollapseAll:!!t.showCollapseAll,canSelectMany:!!t.canSelectMany}),this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(e=>this._onDidChangeData.fire({message:!1,element:e}))),this._register(o.Event.debounce(this._onDidChangeData.event,(e,t)=>(e||(e={message:!1,elements:[]}),
!1!==t.element&&(a||(a=new Promise(e=>c=e),this.refreshPromise=this.refreshPromise.then(()=>a)),e.elements.push(t.element)),t.message&&(e.message=!0),e),200,!0)(({message:e,elements:t})=>{t.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const e=c;return a=null,this.refresh(t).then(()=>e())})),e&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(e=>this.getExtensionElement(e)).filter(e=>!l.isUndefinedOrNull(e))}getChildren(e){const t=e?this.getExtensionElement(e):void 0;if(e&&!t)return this.logService.error(`No tree item with id '${e}' found.`),Promise.resolve([]);const i=this.getChildrenNodes(e);return(i?Promise.resolve(i):this.fetchChildrenNodes(t)).then(e=>e.map(e=>e.item))}getExtensionElement(e){return this.elements.get(e)}reveal(e,t){t=t||{select:!0,focus:!1};const i=!!l.isUndefinedOrNull(t.select)||t.select,n=!l.isUndefinedOrNull(t.focus)&&t.focus,r=!l.isUndefinedOrNull(t.expand)&&t.expand
;return"function"!=typeof this.dataProvider.getParent?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):this.refreshPromise.then(()=>this.resolveUnknownParentChain(e)).then(t=>this.resolveTreeNode(e,t[t.length-1]).then(e=>this.proxy.$reveal(this.viewId,e.item,t.map(e=>e.item),{select:i,focus:n,expand:r})),e=>this.logService.error(e))}get message(){return this._message}set message(e){this._message=e,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(e){this._title=e,this.proxy.$setTitle(this.viewId,e)}setExpanded(e,t){const i=this.getExtensionElement(e);i&&(t?this._onDidExpandElement.fire(Object.freeze({element:i})):this._onDidCollapseElement.fire(Object.freeze({element:i})))}setSelection(e){u.equals(this._selectedHandles,e)||(this._selectedHandles=e,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(e){e!==this._visible&&(this._visible=e,
this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}resolveUnknownParentChain(e){return this.resolveParent(e).then(e=>e?this.resolveUnknownParentChain(e).then(t=>this.resolveTreeNode(e,t[t.length-1]).then(e=>(t.push(e),t))):Promise.resolve([]))}resolveParent(e){const t=this.nodes.get(e);return t?Promise.resolve(t.parent?this.elements.get(t.parent.item.handle):void 0):a.asPromise(()=>this.dataProvider.getParent(e))}resolveTreeNode(e,t){const i=this.nodes.get(e);return i?Promise.resolve(i):a.asPromise(()=>this.dataProvider.getTreeItem(e)).then(i=>this.createHandle(e,i,t,!0)).then(e=>this.getChildren(t?t.item.handle:void 0).then(()=>{const t=this.getExtensionElement(e);if(t){const e=this.nodes.get(t);if(e)return Promise.resolve(e)}throw new Error(`Cannot resolve tree item for element ${e}`)}))}getChildrenNodes(e){if(e){let t;if("string"==typeof e){const i=this.getExtensionElement(e);t=i?this.nodes.get(i):void 0}else t=e;return t&&t.children||null}return this.roots}fetchChildrenNodes(e){
this.clearChildren(e);const t=e?this.nodes.get(e):void 0;return a.asPromise(()=>this.dataProvider.getChildren(e)).then(e=>Promise.all(u.coalesce(e||[]).map(e=>a.asPromise(()=>this.dataProvider.getTreeItem(e)).then(i=>i?this.createAndRegisterTreeNode(e,i,t):null)))).then(u.coalesce)}refresh(e){if(e.some(e=>!e))return this.clearAll(),this.proxy.$refresh(this.viewId);{const t=this.getHandlesToRefresh(e);if(t.length)return this.refreshHandles(t)}return Promise.resolve(void 0)}getHandlesToRefresh(e){const t=new Set;for(const i of e){const e=this.nodes.get(i);if(e&&!t.has(e.item.handle)){let i=e;for(;i&&i.parent&&!t.has(i.parent.item.handle);){const e=this.elements.get(i.parent.item.handle);i=e?this.nodes.get(e):void 0}i&&!i.parent&&t.add(e.item.handle)}}const i=[];return t.forEach(e=>{const n=this.elements.get(e);if(n){const r=this.nodes.get(n);!r||r.parent&&t.has(r.parent.item.handle)||i.push(e)}}),i}refreshHandles(e){const t={};return Promise.all(e.map(e=>this.refreshNode(e).then(i=>{i&&(t[e]=i.item)
}))).then(()=>Object.keys(t).length?this.proxy.$refresh(this.viewId,t):void 0)}refreshNode(e){const t=this.getExtensionElement(e);if(t){const e=this.nodes.get(t);if(e)return this.clearChildren(t),a.asPromise(()=>this.dataProvider.getTreeItem(t)).then(i=>{if(i){const n=this.createTreeNode(t,i,e.parent);return this.updateNodeCache(t,n,e,e.parent),e.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(e,t,n){const r=this.createTreeNode(e,t,n);if(t.id&&this.elements.has(r.item.handle))throw new Error(i.localize(4,null,t.id));return this.addNodeToCache(e,r),this.addNodeToParentCache(r,n),r}createTreeNode(e,t,i){const n=new s.DisposableStore,r=this.createHandle(e,t,i),o=this.getLightIconPath(t);return{item:{handle:r,parentHandle:i?i.item.handle:void 0,label:h(t.label,this.extension),description:t.description,resourceUri:t.resourceUri,tooltip:"string"==typeof t.tooltip?t.tooltip:void 0,command:t.command?this.commands.toInternal(t.command,n):void 0,contextValue:t.contextValue,icon:o,
iconDark:this.getDarkIconPath(t)||o,themeIcon:t.iconPath instanceof c.ThemeIcon?{id:t.iconPath.id}:void 0,collapsibleState:l.isUndefinedOrNull(t.collapsibleState)?c.TreeItemCollapsibleState.None:t.collapsibleState,accessibilityInformation:t.accessibilityInformation},parent:i,children:void 0,dispose(){n.dispose()}}}createHandle(t,{id:i,label:r,resourceUri:o},s,a){if(i)return`${e.ID_HANDLE_PREFIX}/${i}`;const c=h(r,this.extension),l=s?s.item.handle:e.LABEL_HANDLE_PREFIX;let u=c?c.label:o?n.basename(o):"";u=-1!==u.indexOf("/")?u.replace("/","//"):u;const d=this.nodes.has(t)?this.nodes.get(t).item.handle:void 0,p=this.getChildrenNodes(s)||[];let m,f=0;do{if(m=`${l}/${f}:${u}`,a||!this.elements.has(m)||d===m)break;f++}while(f<=p.length);return m}getLightIconPath(e){if(e.iconPath&&!(e.iconPath instanceof c.ThemeIcon))return"string"==typeof e.iconPath||r.URI.isUri(e.iconPath)?this.getIconPath(e.iconPath):this.getIconPath(e.iconPath.light)}getDarkIconPath(e){
if(e.iconPath&&!(e.iconPath instanceof c.ThemeIcon)&&e.iconPath.dark)return this.getIconPath(e.iconPath.dark)}getIconPath(e){return r.URI.isUri(e)?e:r.URI.file(e)}addNodeToCache(e,t){this.elements.set(t.item.handle,e),this.nodes.set(e,t)}updateNodeCache(e,t,i,n){this.elements.delete(t.item.handle),this.nodes.delete(e),t.item.handle!==i.item.handle&&this.elements.delete(i.item.handle),this.addNodeToCache(e,t);const r=this.getChildrenNodes(n)||[],o=r.filter(e=>e.item.handle===i.item.handle)[0];o&&r.splice(r.indexOf(o),1,t)}addNodeToParentCache(e,t){t?(t.children||(t.children=[]),t.children.push(e)):(this.roots||(this.roots=[]),this.roots.push(e))}clearChildren(e){if(e){const t=this.nodes.get(e);if(t){if(t.children)for(const e of t.children){const t=this.elements.get(e.item.handle);t&&this.clear(t)}t.children=void 0}}else this.clearAll()}clear(e){const t=this.nodes.get(e);if(t){if(t.children)for(const e of t.children){const t=this.elements.get(e.item.handle);t&&this.clear(t)}this.nodes.delete(e),
this.elements.delete(t.item.handle),t.dispose()}}clearAll(){this.roots=null,this.elements.clear(),this.nodes.forEach(e=>e.dispose()),this.nodes.clear()}dispose(){this.clearAll()}}return e.LABEL_HANDLE_PREFIX="0",e.ID_HANDLE_PREFIX="1",e})()})),define(t[186],i([1,0,11,42,25,20,86,23]),(function(e,t,i,r,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostLogService=void 0;let u=(()=>{let e=class extends i.DelegatedLogService{constructor(e){if(e.logFile.scheme!==a.Schemas.file)throw new Error("Only file-logging supported");super(new c.SpdLogService(r.ExtensionHostLogFileName,l.dirname(e.logFile).fsPath,e.logLevel))}$setLevel(e){this.setLevel(e)}};return e=n([s(0,o.IExtHostInitDataService)],e)})();t.ExtHostLogService=u})),define(t[187],i([1,0,19]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LazyPromise=void 0;t.LazyPromise=class{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,
this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((e,t)=>{this._actualOk=e,this._actualErr=t,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(e){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=e,this._actual&&this._actualOk(e))}resolveErr(e){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=e,this._actual?this._actualErr(e):i.onUnexpectedError(e))}then(e,t){return this._ensureActual().then(e,t)}catch(e){return this._ensureActual().then(void 0,e)}finally(e){return this._ensureActual().finally(e)}}})),define(t[105],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getStringIdentifierForProxy=t.createExtHostContextProxyIdentifier=t.createMainContextProxyIdentifier=t.ProxyIdentifier=void 0;let i=(()=>{class e{constructor(t,i){this.isMain=t,this.sid=i,this.nid=++e.count}}return e.count=0,e})()
;t.ProxyIdentifier=i;const n=[];t.createMainContextProxyIdentifier=function(e){const t=new i(!0,e);return n[t.nid]=t,t},t.createExtHostContextProxyIdentifier=function(e){const t=new i(!1,e);return n[t.nid]=t,t},t.getStringIdentifierForProxy=function(e){return n[e].sid}})),define(t[5],i([1,0,2,105,53]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostContext=t.MainContext=t.reviveWorkspaceEditDto=t.ISuggestResultDtoField=t.ISuggestDataDtoField=t.IdObject=t.ObjectIdentifier=t.CellOutputKind=t.CellKind=t.WebviewEditorCapabilities=t.TextEditorRevealType=t.UIKind=void 0,function(e){e[e.Desktop=1]="Desktop",e[e.Web=2]="Web"}(t.UIKind||(t.UIKind={})),function(e){e[e.Default=0]="Default",e[e.InCenter=1]="InCenter",e[e.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",e[e.AtTop=3]="AtTop"}(t.TextEditorRevealType||(t.TextEditorRevealType={})),function(e){e[e.Editable=0]="Editable",e[e.SupportsHotExit=1]="SupportsHotExit"
}(t.WebviewEditorCapabilities||(t.WebviewEditorCapabilities={})),function(e){e[e.Markdown=1]="Markdown",e[e.Code=2]="Code"}(t.CellKind||(t.CellKind={})),function(e){e[e.Text=1]="Text",e[e.Error=2]="Error",e[e.Rich=3]="Rich"}(t.CellOutputKind||(t.CellOutputKind={})),function(e){e.name="$ident",e.mixin=function(t,i){return Object.defineProperty(t,e.name,{value:i,enumerable:!0}),t},e.of=function(t){return t[e.name]}}(t.ObjectIdentifier||(t.ObjectIdentifier={}));let o=(()=>{class e{static mixin(t){return t._id=e._n++,t}}return e._n=0,e})();t.IdObject=o,function(e){e.label="a",e.kind="b",e.detail="c",e.documentation="d",e.sortText="e",e.filterText="f",e.preselect="g",e.insertText="h",e.insertTextRules="i",e.range="j",e.commitCharacters="k",e.additionalTextEdits="l",e.command="m",e.kindModifier="n",e.label2="o"}(t.ISuggestDataDtoField||(t.ISuggestDataDtoField={})),function(e){e.defaultRanges="a",e.completions="b",e.isIncomplete="c"}(t.ISuggestResultDtoField||(t.ISuggestResultDtoField={})),
t.reviveWorkspaceEditDto=function(e){if(e&&e.edits)for(const t of e.edits)"object"==typeof t.resource?t.resource=i.URI.revive(t.resource):(t.newUri=i.URI.revive(t.newUri),t.oldUri=i.URI.revive(t.oldUri)),t.metadata&&t.metadata.iconPath&&(t.metadata=r.revive(t.metadata));return e},t.MainContext={MainThreadAuthentication:n.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadClipboard:n.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:n.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:n.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:n.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:n.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:n.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:n.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:n.createMainContextProxyIdentifier("MainThreadDiagnostics"),
MainThreadDialogs:n.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:n.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:n.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:n.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:n.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadErrors:n.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:n.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:n.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:n.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:n.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:n.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:n.createMainContextProxyIdentifier("MainThread"),
MainThreadMessageService:n.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:n.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:n.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:n.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:n.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadStorage:n.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:n.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:n.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:n.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadUrls:n.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadWorkspace:n.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:n.createMainContextProxyIdentifier("MainThreadFileSystem"),
MainThreadExtensionService:n.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:n.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:n.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:n.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:n.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:n.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:n.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadTheming:n.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:n.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:n.createMainContextProxyIdentifier("MainThreadTimeline")},t.ExtHostContext={ExtHostCommands:n.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:n.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:n.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),
ExtHostDebugService:n.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:n.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:n.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:n.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:n.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:n.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:n.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:n.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:n.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemEventService:n.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:n.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),
ExtHostQuickOpen:n.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:n.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:n.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:n.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:n.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:n.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:n.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:n.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:n.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:n.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostEditorInsets:n.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostProgress:n.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:n.createMainContextProxyIdentifier("ExtHostComments"),
ExtHostStorage:n.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:n.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostOutputService:n.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:n.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:n.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostTheming:n.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:n.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:n.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:n.createMainContextProxyIdentifier("ExtHostTimeline")}})),define(t[52],i([1,0,4,11,5,14]),(function(e,t,i,r,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullApiDeprecationService=t.ExtHostApiDeprecationService=t.IExtHostApiDeprecationService=void 0,t.IExtHostApiDeprecationService=i.createDecorator("IExtHostApiDeprecationService");let c=(()=>{let e=class{constructor(e,t){
this._extHostLogService=t,this._reportedUsages=new Set,this._telemetryShape=e.getProxy(o.MainContext.MainThreadTelemetry)}report(e,t,i){const n=this.getUsageKey(e,t);this._reportedUsages.has(n)||(this._reportedUsages.add(n),t.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${e}' is deprecated. ${i}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:t.identifier.value,apiId:e}))}getUsageKey(e,t){return`${e}-${t.identifier.value}`}};return e=n([s(0,a.IExtHostRpcService),s(1,r.ILogService)],e)})();t.ExtHostApiDeprecationService=c,t.NullApiDeprecationService=Object.freeze(new class{report(e,t,i){}})})),define(t[191],i([1,0,3,5,10,28]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostAuthentication=void 0;t.ExtHostAuthentication=class{constructor(e){this._authenticationProviders=new Map,this._onDidChangeAuthenticationProviders=new i.Emitter,
this.onDidChangeAuthenticationProviders=this._onDidChangeAuthenticationProviders.event,this._onDidChangeSessions=new i.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._proxy=e.getProxy(n.MainContext.MainThreadAuthentication)}getProviderIds(){return this._proxy.$getProviderIds()}get providerIds(){const e=[];return this._authenticationProviders.forEach(t=>{e.push(t.id)}),e}async resolveSessions(e){const t=this._authenticationProviders.get(e);let i;return i=t?await t.getSessions():await this._proxy.$getSessions(e)}async hasSessions(e,t){const i=t.sort().join(" ");return!!(await this.resolveSessions(e)).filter(e=>e.scopes.sort().join(" ")===i).length}async getSession(e,t,i,n){const r=this._authenticationProviders.get(t),s=e.displayName||e.name,a=o.ExtensionIdentifier.toKey(e.identifier);if(!r)return this._proxy.$getSession(t,i,a,s,n);const c=i.sort().join(" "),l=(await r.getSessions()).filter(e=>e.scopes.sort().join(" ")===c);if(l.length){if(!r.supportsMultipleAccounts){const e=l[0]
;if(await this._proxy.$getSessionsPrompt(t,e.account.displayName,r.displayName,a,s))return e;throw new Error("User did not consent to login.")}const e=await this._proxy.$selectSession(t,r.displayName,a,s,l,i,!!n.clearSessionPreference);return l.find(t=>t.id===e.id)}if(n.createIfNone){if(!await this._proxy.$loginPrompt(r.displayName,s))throw new Error("User did not consent to login.");const e=await r.login(i);return await this._proxy.$setTrustedExtension(t,e.account.displayName,a,s),e}await this._proxy.$requestNewSession(t,i,a,s)}async getSessions(e,t,i){const n=o.ExtensionIdentifier.toKey(e.identifier),r=i.sort().join(" ");return(await this.resolveSessions(t)).filter(e=>e.scopes.sort().join(" ")===r).map(i=>({id:i.id,account:i.account,scopes:i.scopes,getAccessToken:async()=>{if(!await this._proxy.$getSessionsPrompt(t,i.account.displayName,"",n,e.displayName||e.name))throw new Error("User did not consent to token access.");return i.accessToken}}))}async login(e,t,i){const n=this._authenticationProviders.get(t)
;if(!n)throw new Error(`No authentication provider with id '${t}' is currently registered.`);const r=e.displayName||e.name;if(!await this._proxy.$loginPrompt(n.displayName,r))throw new Error("User did not consent to login.");const s=await n.login(i);return await this._proxy.$setTrustedExtension(n.id,s.account.displayName,o.ExtensionIdentifier.toKey(e.identifier),r),{id:s.id,account:s.account,scopes:s.scopes,getAccessToken:async()=>{if(!await this._proxy.$getSessionsPrompt(n.id,s.account.displayName,n.displayName,o.ExtensionIdentifier.toKey(e.identifier),e.displayName||e.name))throw new Error("User did not consent to token access.");return s.accessToken}}}async logout(e,t){const i=this._authenticationProviders.get(e);return i?i.logout(t):this._proxy.$logout(e,t)}registerAuthenticationProvider(e){if(this._authenticationProviders.get(e.id))throw new Error(`An authentication provider with id '${e.id}' is already registered.`);this._authenticationProviders.set(e.id,e);const t=e.onDidChangeSessions(t=>{
this._proxy.$sendDidChangeSessions(e.id,t)});return this._proxy.$registerAuthenticationProvider(e.id,e.displayName,e.supportsMultipleAccounts),new r.Disposable(()=>{t.dispose(),this._authenticationProviders.delete(e.id),this._proxy.$unregisterAuthenticationProvider(e.id)})}$login(e,t){const i=this._authenticationProviders.get(e);if(i)return Promise.resolve(i.login(t));throw new Error(`Unable to find authentication provider with handle: ${e}`)}$logout(e,t){const i=this._authenticationProviders.get(e);if(i)return Promise.resolve(i.logout(t));throw new Error(`Unable to find authentication provider with handle: ${e}`)}$getSessions(e){const t=this._authenticationProviders.get(e);if(t)return Promise.resolve(t.getSessions());throw new Error(`Unable to find authentication provider with handle: ${e}`)}async $getSessionAccessToken(e,t){const i=this._authenticationProviders.get(e);if(i){const e=(await i.getSessions()).find(e=>e.id===t);if(e)return e.accessToken;throw new Error(`Unable to find session with id: ${t}`)}
throw new Error(`Unable to find authentication provider with handle: ${e}`)}$onDidChangeAuthenticationSessions(e,t){return this._onDidChangeSessions.fire({[e]:t}),Promise.resolve()}$onDidChangeAuthenticationProviders(e,t){return this._onDidChangeAuthenticationProviders.fire({added:e,removed:t}),Promise.resolve()}}})),define(t[192],i([1,0,5]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostClipboard=void 0;t.ExtHostClipboard=class{constructor(e){this._proxy=e.getProxy(i.MainContext.MainThreadClipboard)}readText(){return this._proxy.$readText()}writeText(e){return this._proxy.$writeText(e)}}})),define(t[43],i([1,0,12,10,21,18,5,13,11,53,47,49,2,6,4,14]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostCommands=t.CommandsConverter=t.ExtHostCommands=void 0;let _=(()=>{let e=class{constructor(e,t){this._commands=new Map,this._proxy=e.getProxy(c.MainContext.MainThreadCommands),this._logService=t,
this._converter=new y(this,t),this._argumentProcessors=[{processArgument:e=>d.revive(e)},{processArgument:e=>a.cloneAndChange(e,(function(e){return h.Range.isIRange(e)?o.Range.to(e):p.Position.isIPosition(e)?o.Position.to(e):h.Range.isIRange(e.range)&&m.URI.isUri(e.uri)?o.location.to(e):Array.isArray(e)?void 0:e}))}]}get converter(){return this._converter}registerArgumentProcessor(e){this._argumentProcessors.push(e)}registerCommand(e,t,i,n,o){if(this._logService.trace("ExtHostCommands#registerCommand",t),!t.trim().length)throw new Error("invalid id");if(this._commands.has(t))throw new Error(`command '${t}' already exists`);return this._commands.set(t,{callback:i,thisArg:n,description:o}),e&&this._proxy.$registerCommand(t),new r.Disposable(()=>{this._commands.delete(t)&&e&&this._proxy.$unregisterCommand(t)})}executeCommand(e,...t){return this._logService.trace("ExtHostCommands#executeCommand",e),this._doExecuteCommand(e,t,!0)}async _doExecuteCommand(e,t,i){
if(this._commands.has(e))return this._executeContributedCommand(e,t);{const n=a.cloneAndChange(t,(function(e){return e instanceof r.Position?o.Position.from(e):e instanceof r.Range?o.Range.from(e):e instanceof r.Location?o.location.from(e):Array.isArray(e)?void 0:e}));try{const t=await this._proxy.$executeCommand(e,n,i);return d.revive(t)}catch(i){if(i instanceof Error&&"$executeCommand:retry"===i.message)return this._doExecuteCommand(e,t,!1);throw i}}}_executeContributedCommand(e,t){const n=this._commands.get(e);if(!n)throw new Error("Unknown command");let{callback:r,thisArg:o,description:s}=n;if(s)for(let n=0;n<s.args.length;n++)try{i.validateConstraint(t[n],s.args[n].constraint)}catch(t){return Promise.reject(new Error(`Running the contributed command: '${e}' failed. Illegal argument '${s.args[n].name}' - ${s.args[n].description}`))}try{const e=r.apply(o,t);return Promise.resolve(e)}catch(t){return this._logService.error(t,e),Promise.reject(new Error(`Running the contributed command: '${e}' failed.`))}}
$executeContributedCommand(e,...t){return this._logService.trace("ExtHostCommands#$executeContributedCommand",e),this._commands.has(e)?(t=t.map(e=>this._argumentProcessors.reduce((e,t)=>t.processArgument(e),e)),this._executeContributedCommand(e,t)):Promise.reject(new Error(`Contributed command '${e}' does not exist.`))}getCommands(e=!1){return this._logService.trace("ExtHostCommands#getCommands",e),this._proxy.$getCommands().then(t=>(e&&(t=t.filter(e=>"_"!==e[0])),t))}$getContributedCommandHandlerDescriptions(){const e=Object.create(null);return this._commands.forEach((t,i)=>{let{description:n}=t;n&&(e[i]=n)}),Promise.resolve(e)}};return e=n([s(0,v.IExtHostRpcService),s(1,u.ILogService)],e)})();t.ExtHostCommands=_;class y{constructor(e,t){this._commands=e,this._logService=t,this._cache=new Map,this._cachIdPool=0,this._delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._commands.registerCommand(!0,this._delegatingCommandId,this._executeConvertedCommand,this)}toInternal(e,t){if(!e)return
;const i={$ident:void 0,id:e.command,title:e.title,tooltip:e.tooltip};if(e.command&&l.isNonEmptyArray(e.arguments)){const n=++this._cachIdPool;this._cache.set(n,e),t.add(f.toDisposable(()=>{this._cache.delete(n),this._logService.trace("CommandsConverter#DISPOSE",n)})),i.$ident=n,i.id=this._delegatingCommandId,i.arguments=[n],this._logService.trace("CommandsConverter#CREATE",e.command,n)}return i}fromInternal(e){const t=c.ObjectIdentifier.of(e);return"number"==typeof t?this._cache.get(t):{command:e.id,title:e.title,arguments:e.arguments}}_executeConvertedCommand(...e){const t=this._cache.get(e[0]);return this._logService.trace("CommandsConverter#EXECUTE",e[0],t?t.command:"MISSING"),t?this._commands.executeCommand(t.command,...t.arguments||[]):Promise.reject("actual command NOT FOUND")}}t.CommandsConverter=y,t.IExtHostCommands=g.createDecorator("IExtHostCommands")})),define(t[194],i([1,0,16,77,3,6,2,72,28,21,10,5]),(function(e,t,i,r,o,s,a,c,l,u,d,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.ExtHostCommentThread=t.ExtHostComments=void 0;let p=(()=>{class e{constructor(e,t,i){this._documents=i,this._commentControllers=new Map,this._commentControllersByExtension=new Map,this._proxy=e.getProxy(h.MainContext.MainThreadComments),t.registerArgumentProcessor({processArgument:e=>{if(e&&6===e.$mid){const t=this._commentControllers.get(e.handle);return t||e}if(e&&7===e.$mid){const t=this._commentControllers.get(e.commentControlHandle);if(!t)return e;const i=t.getCommentThread(e.commentThreadHandle);return i||e}if(e&&8===e.$mid){const t=this._commentControllers.get(e.thread.commentControlHandle);if(!t)return e;const i=t.getCommentThread(e.thread.commentThreadHandle);return i?{thread:i,text:e.text}:e}if(e&&9===e.$mid){const t=this._commentControllers.get(e.thread.commentControlHandle);if(!t)return e;const i=t.getCommentThread(e.thread.commentThreadHandle);if(!i)return e;let n=e.commentUniqueId,r=i.getCommentByUniqueId(n);return r||e}if(e&&10===e.$mid){
const t=this._commentControllers.get(e.thread.commentControlHandle);if(!t)return e;const i=t.getCommentThread(e.thread.commentThreadHandle);if(!i)return e;let n=e.text,r=e.commentUniqueId,o=i.getCommentByUniqueId(r);return o?(o.body=n,o):e}return e}})}createCommentController(t,i,n){const r=e.handlePool++,o=new f(t,r,this._proxy,i,n);this._commentControllers.set(o.handle,o);const s=this._commentControllersByExtension.get(l.ExtensionIdentifier.toKey(t.identifier))||[];return s.push(o),this._commentControllersByExtension.set(l.ExtensionIdentifier.toKey(t.identifier),s),o}$createCommentThreadTemplate(e,t,i){const n=this._commentControllers.get(e);n&&n.$createCommentThreadTemplate(t,i)}async $updateCommentThreadTemplate(e,t,i){const n=this._commentControllers.get(e);n&&n.$updateCommentThreadTemplate(t,i)}$deleteCommentThread(e,t){const i=this._commentControllers.get(e);i&&i.$deleteCommentThread(t)}$provideCommentingRanges(e,t,n){const r=this._commentControllers.get(e)
;if(!r||!r.commentingRangeProvider)return Promise.resolve(void 0);const o=this._documents.getDocument(a.URI.revive(t));return i.asPromise(()=>r.commentingRangeProvider.provideCommentingRanges(o,n)).then(e=>e?e.map(e=>u.Range.from(e)):void 0)}$toggleReaction(e,t,n,r,o){const s=this._commentControllers.get(e);return s&&s.reactionHandler?i.asPromise(()=>{const e=s.getCommentThread(t);if(e){const t=e.getCommentByUniqueId(r.uniqueIdInThread);if(void 0!==s&&t&&s.reactionHandler)return s.reactionHandler(t,function(e){return{label:e.label||"",count:e.count||0,iconPath:e.iconPath?a.URI.revive(e.iconPath):"",authorHasReacted:e.hasReacted||!1}}(o))}return Promise.resolve(void 0)}):Promise.resolve(void 0)}dispose(){}}return e.handlePool=0,e})();t.ExtHostComments=p;let m=(()=>{class e{constructor(t,i,n,r,a,c,l){this._proxy=t,this._commentController=i,this._id=n,this._uri=r,this._range=a,this._comments=c,this.handle=e._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),
this._onDidUpdateCommentThread=new o.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._commentsMap=new Map,this._acceptInputDisposables=new s.MutableDisposable,this._acceptInputDisposables.value=new s.DisposableStore,void 0===this._id&&(this._id=`${i.id}.${this.handle}`),this._proxy.$createCommentThread(this._commentController.handle,this.handle,this._id,this._uri,u.Range.from(this._range),l),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=c}set threadId(e){this._id=e}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(e){e.isEqual(this._range)||(this._range=e,this.modifications.range=e,this._onDidUpdateCommentThread.fire())}get range(){return this._range}get label(){return this._label}set label(e){this._label=e,this.modifications.label=e,this._onDidUpdateCommentThread.fire()}get contextValue(){
return this._contextValue}set contextValue(e){this._contextValue=e,this.modifications.contextValue=e,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(e){this._comments=e,this.modifications.comments=e,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(e){this._collapseState=e,this.modifications.collapsibleState=e,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new s.DisposableStore);const e=e=>Object.prototype.hasOwnProperty.call(this.modifications,e),t={};e("range")&&(t.range=u.Range.from(this._range)),e("label")&&(t.label=this.label),e("contextValue")&&(t.contextValue=this.contextValue),e("comments")&&(t.comments=this._comments.map(e=>(function(e,t,i,n){let r=n.get(i);r||(r=++e.commentHandle,n.set(i,r))
;const o=i.author&&i.author.iconPath?i.author.iconPath.toString():void 0;return{mode:i.mode,contextValue:i.contextValue,uniqueIdInThread:r,body:u.MarkdownString.from(i.body),userName:i.author.name,userIconPath:o,label:i.label,commentReactions:i.reactions?i.reactions.map(e=>(function(e){return{label:e.label,iconPath:e.iconPath?u.pathOrURIToURI(e.iconPath):void 0,count:e.count,hasReacted:e.authorHasReacted}})(e)):void 0}})(this,this._commentController,e,this._commentsMap))),e("collapsibleState")&&(t.collapseState=function(e){if(void 0!==e)switch(e){case d.CommentThreadCollapsibleState.Expanded:return c.CommentThreadCollapsibleState.Expanded;case d.CommentThreadCollapsibleState.Collapsed:return c.CommentThreadCollapsibleState.Collapsed}return c.CommentThreadCollapsibleState.Collapsed}(this._collapseState)),this.modifications={},this._proxy.$updateCommentThread(this._commentController.handle,this.handle,this._id,this._uri,t)}getCommentByUniqueId(e){for(let t of this._commentsMap){let i=t[0];if(e===t[1])return i}}
dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(e=>e.dispose()),this._proxy.$deleteCommentThread(this._commentController.handle,this.handle)}}return e._handlePool=0,n([r.debounce(100)],e.prototype,"eventuallyUpdateCommentThread",null),e})();t.ExtHostCommentThread=m;class f{constructor(e,t,i,n,r){this._extension=e,this._handle=t,this._proxy=i,this._id=n,this._label=r,this._threads=new Map,this._proxy.$registerCommentController(this.handle,n,r)}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(e){this._reactionHandler=e,this._proxy.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!e})}get options(){return this._options}set options(e){this._options=e,this._proxy.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(e,t,i,n){if("string"==typeof e){
const r=new m(this._proxy,this,e,t,i,n,this._extension.identifier);return this._threads.set(r.handle,r),r}{const n=new m(this._proxy,this,void 0,e,t,i,this._extension.identifier);return this._threads.set(n.handle,n),n}}$createCommentThreadTemplate(e,t){const i=new m(this._proxy,this,void 0,a.URI.revive(e),u.Range.to(t),[],this._extension.identifier);return i.collapsibleState=c.CommentThreadCollapsibleState.Expanded,this._threads.set(i.handle,i),i}$updateCommentThreadTemplate(e,t){let i=this._threads.get(e);i&&(i.range=u.Range.to(t))}$deleteCommentThread(e){let t=this._threads.get(e);t&&t.dispose(),this._threads.delete(e)}getCommentThread(e){return this._threads.get(e)}dispose(){this._threads.forEach(e=>{e.dispose()}),this._proxy.$unregisterCommentController(this.handle)}}})),define(t[108],i([1,0,2,5,10,4,14,11,13]),(function(e,t,i,r,o,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostDecorations=t.ExtHostDecorations=void 0;let d=(()=>{let e=class e{constructor(e,t){
this._logService=t,this._provider=new Map,this._proxy=e.getProxy(r.MainContext.MainThreadDecorations)}registerDecorationProvider(t,i){const n=e._handlePool++;this._provider.set(n,{provider:t,extensionId:i}),this._proxy.$registerDecorationProvider(n,i.value);const r=t.onDidChangeDecorations(e=>{this._proxy.$onDidChange(n,!e||Array.isArray(e)&&e.length>250?null:u.asArray(e))});return new o.Disposable(()=>{r.dispose(),this._proxy.$unregisterDecorationProvider(n),this._provider.delete(n)})}$provideDecorations(e,t){const n=Object.create(null);return Promise.all(e.map(e=>{const{handle:r,uri:s,id:a}=e,c=this._provider.get(r);if(!c)return;const{provider:l,extensionId:u}=c;return Promise.resolve(l.provideDecoration(i.URI.revive(s),t)).then(e=>{if(e)try{o.Decoration.validate(e),n[a]=[e.priority,e.bubble,e.title,e.letter,e.color]}catch(e){this._logService.warn(`INVALID decoration from extension '${u.value}': ${e}`)}},e=>{this._logService.error(e)})})).then(()=>n)}};return e._handlePool=0,
e=n([s(0,c.IExtHostRpcService),s(1,l.ILogService)],e)})();t.ExtHostDecorations=d,t.IExtHostDecorations=a.createDecorator("IExtHostDecorations")})),define(t[196],i([1,0,139,87,2,5,10,21,13,3,11,26]),(function(e,t,i,r,o,a,c,l,u,d,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDiagnostics=t.DiagnosticCollection=void 0;class m{constructor(e,t,i,n,r){this._name=e,this._owner=t,this._maxDiagnosticsPerFile=i,this._proxy=n,this._onDidChangeDiagnostics=r,this._isDisposed=!1,this._data=new p.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(e,t){if(!e)return void this.clear();this._checkDisposed();let n=[];if(o.URI.isUri(e)){if(!t)return void this.delete(e);this._data.set(e,t.slice()),n=[e]}else if(Array.isArray(e)){let t;n=[],u.mergeSort(e,m._compareIndexedTuplesByUri);for(const i of e){const[e,r]=i
;if(t&&e.toString()===t.toString()||(t&&0===this._data.get(t).length&&this._data.delete(t),t=e,n.push(e),this._data.set(e.toString(),[])),r){const t=this._data.get(e.toString());t&&t.push(...r)}else{const t=this._data.get(e.toString());t&&(t.length=0)}}}if(this._onDidChangeDiagnostics.fire(n),!this._proxy)return;const s=[];for(let e of n){let t=[];const n=this._data.get(e);if(n)if(n.length>this._maxDiagnosticsPerFile){t=[];const e=[c.DiagnosticSeverity.Error,c.DiagnosticSeverity.Warning,c.DiagnosticSeverity.Information,c.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let r of n)if(r.severity===e[i]){if(t.push(l.Diagnostic.from(r))===this._maxDiagnosticsPerFile)break e}t.push({severity:r.MarkerSeverity.Info,message:i.localize(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:t[t.length-1].startLineNumber,startColumn:t[t.length-1].startColumn,endLineNumber:t[t.length-1].endLineNumber,endColumn:t[t.length-1].endColumn})}else t=n.map(e=>l.Diagnostic.from(e));s.push([e,t])}
this._proxy.$changeMany(this._owner,s)}delete(e){this._checkDisposed(),this._onDidChangeDiagnostics.fire([e]),this._data.delete(e),this._proxy&&this._proxy.$changeMany(this._owner,[[e,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(e,t){this._checkDisposed(),this._data.forEach((i,n)=>{e.apply(t,[n,this.get(n),this])})}get(e){this._checkDisposed();const t=this._data.get(e);return Array.isArray(t)?Object.freeze(t.slice(0)):[]}has(e){return this._checkDisposed(),Array.isArray(this._data.get(e))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(e,t){return e[0].toString()<t[0].toString()?-1:e[0].toString()>t[0].toString()?1:0}}t.DiagnosticCollection=m;let f=(()=>{let e=class e{constructor(t,i){this._logService=i,this._collections=new Map,this._onDidChangeDiagnostics=new d.Emitter,
this.onDidChangeDiagnostics=d.Event.map(d.Event.debounce(this._onDidChangeDiagnostics.event,e._debouncer,50),e._mapper),this._proxy=t.getProxy(a.MainContext.MainThreadDiagnostics)}static _debouncer(e,t){return e?e.concat(t):t}static _mapper(e){const t=[],i=new Set;for(const n of e)"string"==typeof n?i.has(n)||(i.add(n),t.push(o.URI.parse(n))):i.has(n.toString())||(i.add(n.toString()),t.push(n));return Object.freeze(t),{uris:t}}createDiagnosticCollection(t,i){const{_collections:n,_proxy:r,_onDidChangeDiagnostics:o,_logService:s}=this,a=new class{$changeMany(e,i){r.$changeMany(e,i),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",t.value,e,0===i.length?"CLEARING":i)}$clear(e){r.$clear(e),s.trace("[DiagnosticCollection] remove all (extension, owner)",t.value,e)}dispose(){r.dispose()}};let c;if(i)if(n.has(i)){this._logService.warn(`DiagnosticCollection with name '${i}' does already exist.`);do{c=i+e._idPool++}while(n.has(c))
}else c=i;else i="_generated_diagnostic_collection_name_#"+e._idPool++,c=i;return new class extends m{constructor(){super(i,c,e._maxDiagnosticsPerFile,a,o),n.set(c,this)}dispose(){super.dispose(),n.delete(c)}}}getDiagnostics(e){if(e)return this._getDiagnostics(e);{const e=new Map,t=[];return this._collections.forEach(i=>{i.forEach((i,n)=>{let r=e.get(i.toString());void 0===r&&(r=t.length,e.set(i.toString(),r),t.push([i,[]])),t[r][1]=t[r][1].concat(...n)})}),t}}_getDiagnostics(e){let t=[];return this._collections.forEach(i=>{i.has(e)&&(t=t.concat(i.get(e)))}),t}$acceptMarkersChange(t){if(!this._mirrorCollection){const t="_generated_mirror",i=new m(t,t,e._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(t,i),this._mirrorCollection=i}for(const[e,i]of t)this._mirrorCollection.set(o.URI.revive(e),i.map(l.Diagnostic.to))}};return e._idPool=0,e._maxDiagnosticsPerFile=1e3,e=n([s(1,h.ILogService)],e)})();t.ExtHostDiagnostics=f})),define(t[197],i([1,0,2,5]),(function(e,t,i,n){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDialogs=void 0;t.ExtHostDialogs=class{constructor(e){this._proxy=e.getProxy(n.MainContext.MainThreadDialogs)}showOpenDialog(e){return this._proxy.$showOpenDialog(e).then(e=>e?e.map(e=>i.URI.revive(e)):void 0)}showSaveDialog(e){return this._proxy.$showSaveDialog(e).then(e=>e?i.URI.revive(e):void 0)}}})),define(t[198],i([1,0,19,2,10,5,20,22]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDocumentContentProvider=void 0;let c=(()=>{class e{constructor(e,t,i){this._documentsAndEditors=t,this._logService=i,this._documentContentProviders=new Map,this._proxy=e.getProxy(o.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(t,n){if(Object.keys(s.Schemas).indexOf(t)>=0)throw new Error(`scheme '${t}' already registered`);const o=e._handlePool++;let a;return this._documentContentProviders.set(o,n),this._proxy.$registerTextContentProvider(o,t),
"function"==typeof n.onDidChange&&(a=n.onDidChange(e=>{e.scheme===t?this._documentsAndEditors.getDocument(e)&&this.$provideTextDocumentContent(o,e).then(t=>{if(!t&&"string"!=typeof t)return;const i=this._documentsAndEditors.getDocument(e);if(!i)return;const n=t.split(/\r\n|\r|\n/);return i.equalLines(n)?void 0:this._proxy.$onVirtualDocumentChange(e,t)},i.onUnexpectedError):this._logService.warn(`Provider for scheme '${t}' is firing event for schema '${e.scheme}' which will be IGNORED`)})),new r.Disposable(()=>{this._documentContentProviders.delete(o)&&this._proxy.$unregisterTextContentProvider(o),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(e,t){const i=this._documentContentProviders.get(e);return i?Promise.resolve(i.provideTextDocumentContent(n.URI.revive(t),a.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${t.scheme}`))}}return e._handlePool=0,e})();t.ExtHostDocumentContentProvider=c})),define(t[199],i([1,0,3,6,2,5,75,21,12,18]),(function(e,t,i,n,r,o,s,a,c,l){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDocuments=void 0;t.ExtHostDocuments=class{constructor(e,t){this._onDidAddDocument=new i.Emitter,this._onDidRemoveDocument=new i.Emitter,this._onDidChangeDocument=new i.Emitter,this._onDidSaveDocument=new i.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new n.DisposableStore,this._documentLoader=new Map,this._proxy=e.getProxy(o.MainContext.MainThreadDocuments),this._documentsAndEditors=t,this._documentsAndEditors.onDidRemoveDocuments(e=>{for(const t of e)this._onDidRemoveDocument.fire(t.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(e=>{for(const t of e)this._onDidAddDocument.fire(t.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){
return this._documentsAndEditors.allDocuments()}getDocumentData(e){if(!e)return;const t=this._documentsAndEditors.getDocument(e);return t||void 0}getDocument(e){const t=this.getDocumentData(e);if(!t||!t.document)throw new Error("Unable to retrieve document from URI");return t.document}ensureDocumentData(e){const t=this._documentsAndEditors.getDocument(e);if(t)return Promise.resolve(t);let i=this._documentLoader.get(e.toString());return i||(i=this._proxy.$tryOpenDocument(e).then(t=>{this._documentLoader.delete(e.toString());const i=r.URI.revive(t);return c.assertIsDefined(this._documentsAndEditors.getDocument(i))},t=>(this._documentLoader.delete(e.toString()),Promise.reject(t))),this._documentLoader.set(e.toString(),i)),i}createDocumentData(e){return this._proxy.$tryCreateDocument(e).then(e=>r.URI.revive(e))}$acceptModelModeChanged(e,t,i){const n=r.URI.revive(e),o=this._documentsAndEditors.getDocument(n);if(!o)throw new Error("unknown document");this._onDidRemoveDocument.fire(o.document),
o._acceptLanguageId(i),this._onDidAddDocument.fire(o.document)}$acceptModelSaved(e){const t=r.URI.revive(e),i=this._documentsAndEditors.getDocument(t);if(!i)throw new Error("unknown document");this.$acceptDirtyStateChanged(e,!1),this._onDidSaveDocument.fire(i.document)}$acceptDirtyStateChanged(e,t){const i=r.URI.revive(e),n=this._documentsAndEditors.getDocument(i);if(!n)throw new Error("unknown document");n._acceptIsDirty(t),this._onDidChangeDocument.fire({document:n.document,contentChanges:[]})}$acceptModelChanged(e,t,i){const n=r.URI.revive(e),o=this._documentsAndEditors.getDocument(n);if(!o)throw new Error("unknown document");o._acceptIsDirty(i),o.onEvents(t),this._onDidChangeDocument.fire(l.deepFreeze({document:o.document,contentChanges:t.changes.map(e=>({range:a.Range.to(e.range),rangeOffset:e.rangeOffset,rangeLength:e.rangeLength,text:e.text}))}))}setWordDefinitionFor(e,t){s.setWordDefinitionFor(e,t)}}})),define(t[39],i([1,0,56,3,6,2,4,5,75,14,103,21,11]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m){
"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostDocumentsAndEditors=t.ExtHostDocumentsAndEditors=void 0;let f=(()=>{let e=class{constructor(e,t){this._extHostRpc=e,this._logService=t,this._activeEditorId=null,this._editors=new Map,this._documents=new Map,this._onDidAddDocuments=new r.Emitter,this._onDidRemoveDocuments=new r.Emitter,this._onDidChangeVisibleTextEditors=new r.Emitter,this._onDidChangeActiveTextEditor=new r.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(e){const t=[],n=[],r=[];if(e.removedDocuments)for(const i of e.removedDocuments){const e=a.URI.revive(i).toString(),n=this._documents.get(e);this._documents.delete(e),n&&t.push(n)}if(e.addedDocuments)for(const t of e.addedDocuments){const e=a.URI.revive(t.uri)
;i.ok(!this._documents.has(e.toString()),`document '${e} already exists!'`);const r=new u.ExtHostDocumentData(this._extHostRpc.getProxy(l.MainContext.MainThreadDocuments),e,t.lines,t.EOL,t.modeId,t.versionId,t.isDirty);this._documents.set(e.toString(),r),n.push(r)}if(e.removedEditors)for(const t of e.removedEditors){const e=this._editors.get(t);this._editors.delete(t),e&&r.push(e)}if(e.addedEditors)for(const t of e.addedEditors){const e=a.URI.revive(t.documentUri);i.ok(this._documents.has(e.toString()),`document '${e}' does not exist`),i.ok(!this._editors.has(t.id),`editor '${t.id}' already exists!`);const n=this._documents.get(e.toString()),r=new h.ExtHostTextEditor(t.id,this._extHostRpc.getProxy(l.MainContext.MainThreadTextEditors),this._logService,n,t.selections.map(p.Selection.to),t.options,t.visibleRanges.map(e=>p.Range.to(e)),"number"==typeof t.editorPosition?p.ViewColumn.to(t.editorPosition):void 0);this._editors.set(t.id,r)}
void 0!==e.newActiveEditor&&(i.ok(null===e.newActiveEditor||this._editors.has(e.newActiveEditor),`active editor '${e.newActiveEditor}' does not exist`),this._activeEditorId=e.newActiveEditor),o.dispose(t),o.dispose(r),e.removedDocuments&&this._onDidRemoveDocuments.fire(t),e.addedDocuments&&this._onDidAddDocuments.fire(n),(e.removedEditors||e.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors()),void 0!==e.newActiveEditor&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(e){return this._documents.get(e.toString())}allDocuments(){const e=[];return this._documents.forEach(t=>e.push(t)),e}getEditor(e){return this._editors.get(e)}activeEditor(){return this._activeEditorId?this._editors.get(this._activeEditorId):void 0}allEditors(){const e=[];return this._editors.forEach(t=>e.push(t)),e}};return e=n([s(0,d.IExtHostRpcService),s(1,m.ILogService)],e)})();t.ExtHostDocumentsAndEditors=f,t.IExtHostDocumentsAndEditors=c.createDecorator("IExtHostDocumentsAndEditors")})),
define(t[201],i([1,0,2,5,45,6,10,21,20,243,8,29]),(function(e,t,i,n,r,o,s,a,c,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostFileSystem=void 0;class h{constructor(){this._schemes=[]}add(e){this._stateMachine=void 0,this._schemes.push(e)}delete(e){const t=this._schemes.indexOf(e);t>=0&&(this._schemes.splice(t,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const e=this._schemes.sort(),t=[];let i,n,r=14,o=14;for(const s of e){let e=i?u.commonPrefixLength(i,s):0;for(n=0===e?1:o;e<s.length;e++)e+1===s.length?(r=o,o=9):o+=1,t.push([n,s.toUpperCase().charCodeAt(e),o]),t.push([n,s.toLowerCase().charCodeAt(e),o]),n=o;i=s,o=r}t.push([9,58,10]),t.push([10,47,12]),this._stateMachine=new l.StateMachine(t)}}provideDocumentLinks(e){this._initStateMachine();const t=[],i=l.LinkComputer.computeLinks({getLineContent:t=>e.lineAt(t-1).text,getLineCount:()=>e.lineCount},this._stateMachine);for(const e of i){const i=a.DocumentLink.to(e);i.target&&t.push(i)}return t}}class p{
constructor(e){this._proxy=e}stat(e){return this._proxy.$stat(e).catch(p._handleError)}readDirectory(e){return this._proxy.$readdir(e).catch(p._handleError)}createDirectory(e){return this._proxy.$mkdir(e).catch(p._handleError)}async readFile(e){return this._proxy.$readFile(e).then(e=>e.buffer).catch(p._handleError)}writeFile(e,t){return this._proxy.$writeFile(e,d.VSBuffer.wrap(t)).catch(p._handleError)}delete(e,t){return this._proxy.$delete(e,Object.assign({recursive:!1,useTrash:!1},t)).catch(p._handleError)}rename(e,t,i){return this._proxy.$rename(e,t,Object.assign({overwrite:!1},i)).catch(p._handleError)}copy(e,t,i){return this._proxy.$copy(e,t,Object.assign({overwrite:!1},i)).catch(p._handleError)}static _handleError(e){if(!(e instanceof Error))throw new s.FileSystemError(String(e));if("ENOPRO"===e.name)throw s.FileSystemError.Unavailable(e.message);switch(e.name){case r.FileSystemProviderErrorCode.FileExists:throw s.FileSystemError.FileExists(e.message);case r.FileSystemProviderErrorCode.FileNotFound:
throw s.FileSystemError.FileNotFound(e.message);case r.FileSystemProviderErrorCode.FileNotADirectory:throw s.FileSystemError.FileNotADirectory(e.message);case r.FileSystemProviderErrorCode.FileIsADirectory:throw s.FileSystemError.FileIsADirectory(e.message);case r.FileSystemProviderErrorCode.NoPermissions:throw s.FileSystemError.NoPermissions(e.message);case r.FileSystemProviderErrorCode.Unavailable:throw s.FileSystemError.Unavailable(e.message);default:throw new s.FileSystemError(e.message,e.name)}}}class m{constructor(e,t){this._extHostLanguageFeatures=t,this._linkProvider=new h,this._fsProvider=new Map,this._usedSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=e.getProxy(n.MainContext.MainThreadFileSystem),this.fileSystem=new p(this._proxy),Object.keys(c.Schemas).forEach(e=>this._usedSchemes.add(e))}dispose(){o.dispose(this._linkProviderRegistration)}_registerLinkProviderIfNotYetRegistered(){
this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(e,t,i={}){if(this._usedSchemes.has(e))throw new Error(`a provider for the scheme '${e}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const n=this._handlePool++;this._linkProvider.add(e),this._usedSchemes.add(e),this._fsProvider.set(n,t);let r=2;i.isCaseSensitive&&(r+=1024),i.isReadonly&&(r+=2048),"function"==typeof t.copy&&(r+=8),"function"==typeof t.open&&"function"==typeof t.close&&"function"==typeof t.read&&"function"==typeof t.write&&(r+=4),this._proxy.$registerFileSystemProvider(n,e,r);const a=t.onDidChangeFile(t=>{const i=[];for(const n of t){let t,{uri:r,type:o}=n;if(r.scheme===e){switch(o){case s.FileChangeType.Changed:t=0;break;case s.FileChangeType.Created:t=1;break;case s.FileChangeType.Deleted:t=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:t})}}
this._proxy.$onFileSystemChange(n,i)});return o.toDisposable(()=>{a.dispose(),this._linkProvider.delete(e),this._usedSchemes.delete(e),this._fsProvider.delete(n),this._proxy.$unregisterProvider(n)})}static _asIStat(e){const{type:t,ctime:i,mtime:n,size:r}=e;return{type:t,ctime:i,mtime:n,size:r}}$stat(e,t){return Promise.resolve(this._getFsProvider(e).stat(i.URI.revive(t))).then(m._asIStat)}$readdir(e,t){return Promise.resolve(this._getFsProvider(e).readDirectory(i.URI.revive(t)))}$readFile(e,t){return Promise.resolve(this._getFsProvider(e).readFile(i.URI.revive(t))).then(e=>d.VSBuffer.wrap(e))}$writeFile(e,t,n,r){return Promise.resolve(this._getFsProvider(e).writeFile(i.URI.revive(t),n.buffer,r))}$delete(e,t,n){return Promise.resolve(this._getFsProvider(e).delete(i.URI.revive(t),n))}$rename(e,t,n,r){return Promise.resolve(this._getFsProvider(e).rename(i.URI.revive(t),i.URI.revive(n),r))}$copy(e,t,n,r){const o=this._getFsProvider(e);if(!o.copy)throw new Error('FileSystemProvider does not implement "copy"')
;return Promise.resolve(o.copy(i.URI.revive(t),i.URI.revive(n),r))}$mkdir(e,t){return Promise.resolve(this._getFsProvider(e).createDirectory(i.URI.revive(t)))}$watch(e,t,n,r){const o=this._getFsProvider(e).watch(i.URI.revive(n),r);this._watches.set(t,o)}$unwatch(e,t){const i=this._watches.get(t);i&&(i.dispose(),this._watches.delete(t))}$open(e,t,n){const r=this._getFsProvider(e);if(!r.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(r.open(i.URI.revive(t),n))}$close(e,t){const i=this._getFsProvider(e);if(!i.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(i.close(t))}$read(e,t,i,n){const r=this._getFsProvider(e);if(!r.read)throw new Error('FileSystemProvider does not implement "read"');const o=d.VSBuffer.alloc(n);return Promise.resolve(r.read(t,i,o.buffer,0,n)).then(e=>o.slice(0,e))}$write(e,t,i,n){const r=this._getFsProvider(e);if(!r.write)throw new Error('FileSystemProvider does not implement "write"')
;return Promise.resolve(r.write(t,i,n.buffer,0,n.byteLength))}_getFsProvider(e){const t=this._fsProvider.get(e);if(!t){const e=new Error;throw e.name="ENOPRO",e.message="no provider",e}return t}}t.ExtHostFileSystem=m})),define(t[202],i([1,0,3,27,2,5,21,10,13]),(function(e,t,i,n,r,o,s,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostFileSystemEventService=void 0;class l{constructor(e,t,o,s,c){this._onDidCreate=new i.Emitter,this._onDidChange=new i.Emitter,this._onDidDelete=new i.Emitter,this._config=0,o&&(this._config+=1),s&&(this._config+=2),c&&(this._config+=4);const l=n.parse(t),u=e(e=>{if(!o)for(let t of e.created){const e=r.URI.revive(t);l(e.fsPath)&&this._onDidCreate.fire(e)}if(!s)for(let t of e.changed){const e=r.URI.revive(t);l(e.fsPath)&&this._onDidChange.fire(e)}if(!c)for(let t of e.deleted){const e=r.URI.revive(t);l(e.fsPath)&&this._onDidDelete.fire(e)}});this._disposable=a.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){
return Boolean(1&this._config)}get ignoreChangeEvents(){return Boolean(2&this._config)}get ignoreDeleteEvents(){return Boolean(4&this._config)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}t.ExtHostFileSystemEventService=class{constructor(e,t,n,r=e.getProxy(o.MainContext.MainThreadTextEditors)){this._logService=t,this._extHostDocumentsAndEditors=n,this._mainThreadTextEditors=r,this._onFileSystemEvent=new i.Emitter,this._onDidRenameFile=new i.Emitter,this._onDidCreateFile=new i.Emitter,this._onDidDeleteFile=new i.Emitter,this._onWillRenameFile=new i.AsyncEmitter,this._onWillCreateFile=new i.AsyncEmitter,this._onWillDeleteFile=new i.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(e,t,i,n){return new l(this._onFileSystemEvent.event,e,t,i,n)}
$onFileEvent(e){this._onFileSystemEvent.fire(e)}$onDidRunFileOperation(e,t,i){switch(e){case 2:this._onDidRenameFile.fire(Object.freeze({files:[{oldUri:r.URI.revive(i),newUri:r.URI.revive(t)}]}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:[r.URI.revive(t)]}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:[r.URI.revive(t)]}))}}getOnWillRenameFileEvent(e){return this._createWillExecuteEvent(e,this._onWillRenameFile)}getOnWillCreateFileEvent(e){return this._createWillExecuteEvent(e,this._onWillCreateFile)}getOnWillDeleteFileEvent(e){return this._createWillExecuteEvent(e,this._onWillDeleteFile)}_createWillExecuteEvent(e,t){return(i,n,r)=>{const o=function(e){i.call(n,e)};return o.extension=e,t.event(o,void 0,r)}}async $onWillRunFileOperation(e,t,i,n,o){switch(e){case 2:await this._fireWillEvent(this._onWillRenameFile,{files:[{oldUri:r.URI.revive(i),newUri:r.URI.revive(t)}]},n,o);break;case 1:await this._fireWillEvent(this._onWillDeleteFile,{files:[r.URI.revive(t)]},n,o);break
;case 0:await this._fireWillEvent(this._onWillCreateFile,{files:[r.URI.revive(t)]},n,o)}}async _fireWillEvent(e,t,i,n){const r=[];if(await e.fireAsync(t,n,async(e,t)=>{var n;const o=Date.now(),s=await Promise.resolve(e);s instanceof a.WorkspaceEdit&&r.push(s),Date.now()-o>i&&this._logService.warn("SLOW file-participant",null===(n=t.extension)||void 0===n?void 0:n.identifier)}),!n.isCancellationRequested&&r.length>0){const e=new Array;for(let t of r){let{edits:i}=s.WorkspaceEdit.from(t,this._extHostDocumentsAndEditors);e.push(i)}return this._mainThreadTextEditors.$tryApplyWorkspaceEdit({edits:c.flatten(e)})}}}})),define(t[203],i([1,0,6,5]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostLabelService=void 0;t.ExtHostLabelService=class{constructor(e){this._handlePool=0,this._proxy=e.getProxy(n.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(e){const t=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(t,e),i.toDisposable(()=>{
this._proxy.$unregisterResourceLabelFormatter(t)})}}})),define(t[204],i([1,0,2,18,21,10,16,5,8,47,13,12,129,6,148,113,94]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostLanguageFeatures=t.DocumentRangeSemanticTokensAdapter=t.DocumentSemanticTokensAdapter=void 0;class v{constructor(e,t){this._documents=e,this._provider=t}provideDocumentSymbols(e,t){const i=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideDocumentSymbols(i,t)).then(e=>u.isFalsyOrEmpty(e)?void 0:e[0]instanceof o.DocumentSymbol?e.map(r.DocumentSymbol.from):v._asDocumentSymbolTree(e))}static _asDocumentSymbolTree(e){e=e.slice(0).sort((e,t)=>{let i=e.location.range.start.compareTo(t.location.range.start);return 0===i&&(i=t.location.range.end.compareTo(e.location.range.end)),i});const t=[],i=[];for(const n of e){const e={name:n.name||"!!MISSING: name!!",kind:r.SymbolKind.from(n.kind),tags:n.tags?n.tags.map(r.SymbolTag.from):[],detail:"",
containerName:n.containerName,range:r.Range.from(n.location.range),selectionRange:r.Range.from(n.location.range),children:[]};for(;;){if(0===i.length){i.push(e),t.push(e);break}const n=i[i.length-1];if(l.Range.containsRange(n.range,e.range)&&!l.Range.equalsRange(n.range,e.range)){n.children&&n.children.push(e),i.push(e);break}i.pop()}}return t}}let _=(()=>{class e{constructor(e,t,i){this._documents=e,this._commands=t,this._provider=i,this._cache=new g.Cache("CodeLens"),this._disposables=new Map}provideCodeLenses(e,t){const i=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideCodeLenses(i,t)).then(e=>{if(!e||t.isCancellationRequested)return;const i=this._cache.add(e),n=new p.DisposableStore;this._disposables.set(i,n);const o={cacheId:i,lenses:[]};for(let t=0;t<e.length;t++)o.lenses.push({cacheId:[i,t],range:r.Range.from(e[t].range),command:this._commands.toInternal(e[t].command,n)});return o})}resolveCodeLens(t,i){const n=t.cacheId&&this._cache.get(...t.cacheId)
;if(!n)return Promise.resolve(void 0);let r;return(r="function"!=typeof this._provider.resolveCodeLens||n.isResolved?Promise.resolve(n):s.asPromise(()=>this._provider.resolveCodeLens(n,i))).then(r=>{if(i.isCancellationRequested)return;const o=t.cacheId&&this._disposables.get(t.cacheId[0]);return o?(r=r||n,t.command=this._commands.toInternal(r.command||e._badCmd,o),t):void 0})}releaseCodeLenses(e){p.dispose(this._disposables.get(e)),this._disposables.delete(e),this._cache.delete(e)}}return e._badCmd={command:"missing",title:"!!MISSING: command!!"},e})();function y(e){return Array.isArray(e)?e.map(r.DefinitionLink.from):e?[r.DefinitionLink.from(e)]:[]}class w{constructor(e,t){this._documents=e,this._provider=t}provideDefinition(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideDefinition(n,o,i)).then(y)}}class b{constructor(e,t){this._documents=e,this._provider=t}provideDeclaration(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t)
;return s.asPromise(()=>this._provider.provideDeclaration(n,o,i)).then(y)}}class E{constructor(e,t){this._documents=e,this._provider=t}provideImplementation(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideImplementation(n,o,i)).then(y)}}class x{constructor(e,t){this._documents=e,this._provider=t}provideTypeDefinition(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideTypeDefinition(n,o,i)).then(y)}}class C{constructor(e,t){this._documents=e,this._provider=t}provideHover(e,t,i){const n=this._documents.getDocument(e),a=r.Position.to(t);return s.asPromise(()=>this._provider.provideHover(n,a,i)).then(e=>{if(e&&!u.isFalsyOrEmpty(e.contents))return e.range||(e.range=n.getWordRangeAtPosition(a)),e.range||(e.range=new o.Range(a,a)),r.Hover.from(e)})}}class S{constructor(e,t){this._documents=e,this._provider=t}provideEvaluatableExpression(e,t,i){
const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideEvaluatableExpression(n,o,i)).then(e=>{if(e)return r.EvaluatableExpression.from(e)})}}class k{constructor(e,t){this._documents=e,this._provider=t}provideDocumentHighlights(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideDocumentHighlights(n,o,i)).then(e=>{if(Array.isArray(e))return e.map(r.DocumentHighlight.from)})}}class T{constructor(e,t){this._documents=e,this._provider=t}provideOnTypeRenameRanges(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t);return s.asPromise(()=>this._provider.provideOnTypeRenameRanges(n,o,i)).then(e=>{if(Array.isArray(e))return u.coalesce(e.map(r.Range.from))})}}class I{constructor(e,t){this._documents=e,this._provider=t}provideReferences(e,t,i,n){const o=this._documents.getDocument(e),a=r.Position.to(t);return s.asPromise(()=>this._provider.provideReferences(o,a,i,n)).then(e=>{
if(Array.isArray(e))return e.map(r.location.from)})}}let D=(()=>{class e{constructor(e,t,i,n,r,o,s){this._documents=e,this._commands=t,this._diagnostics=i,this._provider=n,this._logService=r,this._extension=o,this._apiDeprecation=s,this._cache=new g.Cache("CodeAction"),this._disposables=new Map}provideCodeActions(t,i,n,a){const c=this._documents.getDocument(t),l=h.Selection.isISelection(i)?r.Selection.to(i):r.Range.to(i),d=[];for(const i of this._diagnostics.getDiagnostics(t))if(l.intersection(i.range)){if(d.push(i)>e._maxCodeActionsPerFile)break}const m={diagnostics:d,only:n.only?new o.CodeActionKind(n.only):void 0};return s.asPromise(()=>this._provider.provideCodeActions(c,l,m,a)).then(t=>{var i;if(!u.isNonEmptyArray(t)||a.isCancellationRequested)return;const n=this._cache.add(t),o=new p.DisposableStore;this._disposables.set(n,o);const s=[]
;for(const n of t)n&&(e._isCommand(n)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),s.push({_isSynthetic:!0,title:n.title,command:this._commands.toInternal(n,o)})):(m.only&&(n.kind?m.only.contains(n.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${m.only.value} 'requested but returned code action is of kind '${n.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${m.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),s.push({title:n.title,command:n.command&&this._commands.toInternal(n.command,o),diagnostics:n.diagnostics&&n.diagnostics.map(r.Diagnostic.from),edit:n.edit&&r.WorkspaceEdit.from(n.edit),kind:n.kind&&n.kind.value,
isPreferred:n.isPreferred,disabled:null===(i=n.disabled)||void 0===i?void 0:i.reason})));return{cacheId:n,actions:s}})}releaseCodeActions(e){p.dispose(this._disposables.get(e)),this._disposables.delete(e),this._cache.delete(e)}static _isCommand(e){return"string"==typeof e.command&&"string"==typeof e.title}}return e._maxCodeActionsPerFile=1e3,e})();class P{constructor(e,t){this._documents=e,this._provider=t}provideDocumentFormattingEdits(e,t,i){const n=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideDocumentFormattingEdits(n,t,i)).then(e=>{if(Array.isArray(e))return e.map(r.TextEdit.from)})}}class R{constructor(e,t){this._documents=e,this._provider=t}provideDocumentRangeFormattingEdits(e,t,i,n){const o=this._documents.getDocument(e),a=r.Range.to(t);return s.asPromise(()=>this._provider.provideDocumentRangeFormattingEdits(o,a,i,n)).then(e=>{if(Array.isArray(e))return e.map(r.TextEdit.from)})}}class A{constructor(e,t){this._documents=e,this._provider=t,
this.autoFormatTriggerCharacters=[]}provideOnTypeFormattingEdits(e,t,i,n,o){const a=this._documents.getDocument(e),c=r.Position.to(t);return s.asPromise(()=>this._provider.provideOnTypeFormattingEdits(a,c,i,n,o)).then(e=>{if(Array.isArray(e))return e.map(r.TextEdit.from)})}}class O{constructor(e,t){this._provider=e,this._logService=t,this._symbolCache=new Map,this._resultCache=new Map}provideWorkspaceSymbols(e,t){const i=a.IdObject.mixin({symbols:[]});return s.asPromise(()=>this._provider.provideWorkspaceSymbols(e,t)).then(e=>{if(u.isNonEmptyArray(e))for(const t of e){if(!t)continue;if(!t.name){this._logService.warn("INVALID SymbolInformation, lacks name",t);continue}const e=a.IdObject.mixin(r.WorkspaceSymbol.from(t));this._symbolCache.set(e._id,t),i.symbols.push(e)}}).then(()=>(i.symbols.length>0&&this._resultCache.set(i._id,[i.symbols[0]._id,i.symbols[i.symbols.length-1]._id]),i))}async resolveWorkspaceSymbol(e,t){if("function"!=typeof this._provider.resolveWorkspaceSymbol)return e
;const i=this._symbolCache.get(e._id);if(i){const o=await s.asPromise(()=>this._provider.resolveWorkspaceSymbol(i,t));return o&&n.mixin(e,r.WorkspaceSymbol.from(o),!0)}}releaseWorkspaceSymbols(e){const t=this._resultCache.get(e);if(t){for(let[e,i]=t;e<=i;e++)this._symbolCache.delete(e);this._resultCache.delete(e)}}}class L{constructor(e,t,i){this._documents=e,this._provider=t,this._logService=i}static supportsResolving(e){return"function"==typeof e.prepareRename}provideRenameEdits(e,t,i,n){const o=this._documents.getDocument(e),a=r.Position.to(t);return s.asPromise(()=>this._provider.provideRenameEdits(o,a,i,n)).then(e=>{if(e)return r.WorkspaceEdit.from(e)},e=>{const t=L._asMessage(e);return t?{rejectReason:t,edits:void 0}:Promise.reject(e)})}resolveRenameLocation(e,t,i){if("function"!=typeof this._provider.prepareRename)return Promise.resolve(void 0);const n=this._documents.getDocument(e),a=r.Position.to(t);return s.asPromise(()=>this._provider.prepareRename(n,a,i)).then(e=>{let t,i
;if(o.Range.isRange(e)?(t=e,i=n.getText(e)):d.isObject(e)&&(t=e.range,i=e.placeholder),t){if(!(t.start.line>a.line||t.end.line<a.line))return{range:r.Range.from(t),text:i};this._logService.warn("INVALID rename location: position line must be within range start/end lines")}},e=>{const t=L._asMessage(e);return t?{rejectReason:t,range:void 0,text:void 0}:Promise.reject(e)})}static _asMessage(e){return"string"==typeof e?e:e instanceof Error&&"string"==typeof e.message?e.message:void 0}}class M{constructor(e,t){this.resultId=e,this.tokens=t}}class N{constructor(e,t){this._documents=e,this._provider=t,this._nextResultId=1,this._previousResults=new Map}provideDocumentSemanticTokens(e,t,i){const n=this._documents.getDocument(e),r=0!==t?this._previousResults.get(t):null
;return s.asPromise(()=>r&&"string"==typeof r.resultId&&"function"==typeof this._provider.provideDocumentSemanticTokensEdits?this._provider.provideDocumentSemanticTokensEdits(n,r.resultId,i):this._provider.provideDocumentSemanticTokens(n,i)).then(e=>(r&&this._previousResults.delete(t),e?(e=N._fixProvidedSemanticTokens(e),this._send(N._convertToEdits(r,e),e)):null))}async releaseDocumentSemanticColoring(e){this._previousResults.delete(e)}static _fixProvidedSemanticTokens(e){return N._isSemanticTokens(e)?N._isCorrectSemanticTokens(e)?e:new o.SemanticTokens(new Uint32Array(e.data),e.resultId):N._isSemanticTokensEdits(e)?N._isCorrectSemanticTokensEdits(e)?e:new o.SemanticTokensEdits(e.edits.map(e=>new o.SemanticTokensEdit(e.start,e.deleteCount,e.data?new Uint32Array(e.data):e.data)),e.resultId):e}static _isSemanticTokens(e){return e&&!!e.data}static _isCorrectSemanticTokens(e){return e.data instanceof Uint32Array}static _isSemanticTokensEdits(e){return e&&Array.isArray(e.edits)}
static _isCorrectSemanticTokensEdits(e){for(const t of e.edits)if(!(t.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(e,t){if(!N._isSemanticTokens(t))return t;if(!e||!e.tokens)return t;const i=e.tokens,n=i.length,r=t.data,s=r.length;let a=0;const c=Math.min(n,s);for(;a<c&&i[a]===r[a];)a++;if(a===n&&a===s)return new o.SemanticTokensEdits([],t.resultId);let l=0;const u=c-a;for(;l<u&&i[n-l-1]===r[s-l-1];)l++;return new o.SemanticTokensEdits([{start:a,deleteCount:n-a-l,data:r.subarray(a,s-l)}],t.resultId)}_send(e,t){if(N._isSemanticTokens(e)){const t=this._nextResultId++;return this._previousResults.set(t,new M(e.resultId,e.data)),m.encodeSemanticTokensDto({id:t,type:"full",data:e.data})}if(N._isSemanticTokensEdits(e)){const i=this._nextResultId++;return N._isSemanticTokens(t)?this._previousResults.set(i,new M(t.resultId,t.data)):this._previousResults.set(i,new M(e.resultId)),m.encodeSemanticTokensDto({id:i,type:"delta",deltas:(e.edits||[]).map(e=>({start:e.start,deleteCount:e.deleteCount,
data:e.data}))})}return null}}t.DocumentSemanticTokensAdapter=N;class F{constructor(e,t){this._documents=e,this._provider=t}provideDocumentRangeSemanticTokens(e,t,i){const n=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideDocumentRangeSemanticTokens(n,r.Range.to(t),i)).then(e=>e?this._send(e):null)}_send(e){return m.encodeSemanticTokensDto({id:0,type:"full",data:e.data})}}t.DocumentRangeSemanticTokensAdapter=F;class U{constructor(e,t,i,n,r){this._documents=e,this._commands=t,this._provider=i,this._apiDeprecation=n,this._extension=r,this._cache=new g.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(e){return"function"==typeof e.resolveCompletionItem}async provideCompletionItems(e,t,i,n){const a=this._documents.getDocument(e),c=r.Position.to(t),l=a.getWordRangeAtPosition(c)||new o.Range(c,c),u=l.with({end:c}),d=await s.asPromise(()=>this._provider.provideCompletionItems(a,c,n,r.CompletionContext.to(i)));if(!d)return;if(n.isCancellationRequested)return
;const h=Array.isArray(d)?new o.CompletionList(d):d,m=U.supportsResolving(this._provider)?this._cache.add(h.items):this._cache.add([]),f=new p.DisposableStore;this._disposables.set(m,f);const g=[],v={x:m,b:g,a:{replace:r.Range.from(l),insert:r.Range.from(u)},c:h.isIncomplete||void 0};for(let e=0;e<h.items.length;e++){const t=h.items[e],i=this._convertCompletionItem(t,[m,e],u,l);g.push(i)}return v}async resolveCompletionItem(e,t){if("function"!=typeof this._provider.resolveCompletionItem)return;const i=this._cache.get(...e);if(!i)return;const n=await s.asPromise(()=>this._provider.resolveCompletionItem(i,t));return n?this._convertCompletionItem(n,e):void 0}releaseCompletionItems(e){p.dispose(this._disposables.get(e)),this._disposables.delete(e),this._cache.delete(e)}_convertCompletionItem(e,t,i,n){var s;const a=this._disposables.get(t[0]);if(!a)throw Error("DisposableStore is missing...");const c={x:t,a:null!==(s=e.label)&&void 0!==s?s:"",o:e.label2,b:void 0!==e.kind?r.CompletionItemKind.from(e.kind):void 0,
n:e.tags&&e.tags.map(r.CompletionItemTag.from),c:e.detail,d:void 0===e.documentation?void 0:r.MarkdownString.fromStrict(e.documentation),e:e.sortText!==e.label?e.sortText:void 0,f:e.filterText!==e.label?e.filterText:void 0,g:e.preselect||void 0,i:e.keepWhitespace?1:0,k:e.commitCharacters,l:e.additionalTextEdits&&e.additionalTextEdits.map(r.TextEdit.from),m:this._commands.toInternal(e.command,a)};let l;return e.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),c.h=e.textEdit.newText):"string"==typeof e.insertText?c.h=e.insertText:e.insertText instanceof o.SnippetString&&(c.h=e.insertText.value,c.i|=4),e.textEdit?l=e.textEdit.range:e.range&&(l=e.range),o.Range.isRange(l)?c.j=r.Range.from(l):!l||(null==i?void 0:i.isEqual(l.inserting))&&(null==n?void 0:n.isEqual(l.replacing))||(c.j={insert:r.Range.from(l.inserting),replace:r.Range.from(l.replacing)}),c}}class H{constructor(e,t){this._documents=e,this._provider=t,
this._cache=new g.Cache("SignatureHelp")}provideSignatureHelp(e,t,i,n){const o=this._documents.getDocument(e),a=r.Position.to(t),c=this.reviveContext(i);return s.asPromise(()=>this._provider.provideSignatureHelp(o,a,n,c)).then(e=>{if(e){const t=this._cache.add([e]);return Object.assign(Object.assign({},r.SignatureHelp.from(e)),{id:t})}})}reviveContext(e){let t=void 0;if(e.activeSignatureHelp){const i=r.SignatureHelp.to(e.activeSignatureHelp),n=this._cache.get(e.activeSignatureHelp.id,0);n?((t=n).activeSignature=i.activeSignature,t.activeParameter=i.activeParameter):t=i}return Object.assign(Object.assign({},e),{activeSignatureHelp:t})}releaseSignatureHelp(e){this._cache.delete(e)}}class ${constructor(e,t){this._documents=e,this._provider=t,this._cache=new g.Cache("DocumentLink")}provideLinks(e,t){const i=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideDocumentLinks(i,t)).then(e=>{if(Array.isArray(e)&&0!==e.length&&!t.isCancellationRequested){
if("function"!=typeof this._provider.resolveDocumentLink)return{links:e.map(r.DocumentLink.from)};{const t=this._cache.add(e),i={links:[],id:t};for(let n=0;n<e.length;n++){const o=r.DocumentLink.from(e[n]);o.cacheId=[t,n],i.links.push(o)}return i}}})}resolveLink(e,t){if("function"!=typeof this._provider.resolveDocumentLink)return Promise.resolve(void 0);const i=this._cache.get(...e);return i?s.asPromise(()=>this._provider.resolveDocumentLink(i,t)).then(e=>e&&r.DocumentLink.from(e)||void 0):Promise.resolve(void 0)}releaseLinks(e){this._cache.delete(e)}}class W{constructor(e,t){this._documents=e,this._provider=t}provideColors(e,t){const i=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideDocumentColors(i,t)).then(e=>{if(!Array.isArray(e))return[];return e.map(e=>({color:r.Color.from(e.color),range:r.Range.from(e.range)}))})}provideColorPresentations(e,t,i){const n=this._documents.getDocument(e),o=r.Range.to(t.range),a=r.Color.to(t.color)
;return s.asPromise(()=>this._provider.provideColorPresentations(a,{document:n,range:o},i)).then(e=>{if(Array.isArray(e))return e.map(r.ColorPresentation.from)})}}class z{constructor(e,t){this._documents=e,this._provider=t}provideFoldingRanges(e,t,i){const n=this._documents.getDocument(e);return s.asPromise(()=>this._provider.provideFoldingRanges(n,t,i)).then(e=>{if(Array.isArray(e))return e.map(r.FoldingRange.from)})}}class B{constructor(e,t,i){this._documents=e,this._provider=t,this._logService=i}provideSelectionRanges(e,t,i){const n=this._documents.getDocument(e),o=t.map(r.Position.to);return s.asPromise(()=>this._provider.provideSelectionRanges(n,o,i)).then(e=>{if(!u.isNonEmptyArray(e))return[];if(e.length!==o.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const t=[];for(let i=0;i<o.length;i++){const n=[];t.push(n);let s=o[i],a=e[i];for(;;){if(!a.range.contains(s))throw new Error("INVALID selection range, must contain the previous range")
;if(n.push(r.SelectionRange.from(a)),!a.parent)break;s=a.range,a=a.parent}}return t})}}class j{constructor(e,t){this._documents=e,this._provider=t,this._idPool=new f.IdGenerator(""),this._cache=new Map}async prepareSession(e,t,i){const n=this._documents.getDocument(e),o=r.Position.to(t),s=await this._provider.prepareCallHierarchy(n,o,i);if(!s)return;const a=this._idPool.nextId();return this._cache.set(a,new Map),Array.isArray(s)?s.map(e=>this._cacheAndConvertItem(a,e)):[this._cacheAndConvertItem(a,s)]}async provideCallsTo(e,t,i){const n=this._itemFromCache(e,t);if(!n)throw new Error("missing call hierarchy item");const o=await this._provider.provideCallHierarchyIncomingCalls(n,i);if(o)return o.map(t=>({from:this._cacheAndConvertItem(e,t.from),fromRanges:t.fromRanges.map(e=>r.Range.from(e))}))}async provideCallsFrom(e,t,i){const n=this._itemFromCache(e,t);if(!n)throw new Error("missing call hierarchy item");const o=await this._provider.provideCallHierarchyOutgoingCalls(n,i);if(o)return o.map(t=>({
to:this._cacheAndConvertItem(e,t.to),fromRanges:t.fromRanges.map(e=>r.Range.from(e))}))}releaseSession(e){this._cache.delete(e)}_cacheAndConvertItem(e,t){const i=this._cache.get(e),n={_sessionId:e,_itemId:i.size.toString(36),name:t.name,detail:t.detail,kind:r.SymbolKind.from(t.kind),uri:t.uri,range:r.Range.from(t.range),selectionRange:r.Range.from(t.selectionRange)};return i.set(n._itemId,t),n}_itemFromCache(e,t){const i=this._cache.get(e);return null==i?void 0:i.get(t)}}class V{constructor(e,t){this.adapter=e,this.extension=t}}let K=(()=>{class e{constructor(e,t,i,n,r,o,s){this._adapter=new Map,this._uriTransformer=t,this._proxy=e.getProxy(a.MainContext.MainThreadLanguageFeatures),this._documents=i,this._commands=n,this._diagnostics=r,this._logService=o,this._apiDeprecation=s}_transformDocumentSelector(e){return u.coalesce(u.asArray(e).map(e=>this._doTransformDocumentSelector(e)))}_doTransformDocumentSelector(e){return"string"==typeof e?{$serialized:!0,language:e}:e?{$serialized:!0,language:e.language,
scheme:this._transformScheme(e.scheme),pattern:void 0===e.pattern?void 0:r.GlobPattern.from(e.pattern),exclusive:e.exclusive}:void 0}_transformScheme(e){return this._uriTransformer&&"string"==typeof e?this._uriTransformer.transformOutgoingScheme(e):e}_createDisposable(e){return new o.Disposable(()=>{this._adapter.delete(e),this._proxy.$unregister(e)})}_nextHandle(){return e._handlePool++}_withAdapter(e,t,i,n){const r=this._adapter.get(e);if(!r)return Promise.resolve(n);if(r.adapter instanceof t){let e;r.extension&&(e=Date.now(),this._logService.trace(`[${r.extension.identifier.value}] INVOKE provider '${t.name}'`));const n=i(r.adapter,r.extension),o=r.extension;return o&&Promise.resolve(n).then(()=>this._logService.trace(`[${o.identifier.value}] provider DONE after ${Date.now()-e}ms`),e=>{this._logService.error(`[${o.identifier.value}] provider FAILED`),this._logService.error(e)}),n}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(e,t){const i=this._nextHandle()
;return this._adapter.set(i,new V(e,t)),i}static _extLabel(e){return e.displayName||e.name}registerDocumentSymbolProvider(t,i,n,r){const o=this._addNewAdapter(new v(this._documents,n),t),s=r&&r.label||e._extLabel(t);return this._proxy.$registerDocumentSymbolProvider(o,this._transformDocumentSelector(i),s),this._createDisposable(o)}$provideDocumentSymbols(e,t,n){return this._withAdapter(e,v,e=>e.provideDocumentSymbols(i.URI.revive(t),n),void 0)}registerCodeLensProvider(e,t,i){const n=this._nextHandle(),r="function"==typeof i.onDidChangeCodeLenses?this._nextHandle():void 0;this._adapter.set(n,new V(new _(this._documents,this._commands.converter,i),e)),this._proxy.$registerCodeLensSupport(n,this._transformDocumentSelector(t),r);let s=this._createDisposable(n);if(void 0!==r){const e=i.onDidChangeCodeLenses(e=>this._proxy.$emitCodeLensEvent(r));s=o.Disposable.from(s,e)}return s}$provideCodeLenses(e,t,n){return this._withAdapter(e,_,e=>e.provideCodeLenses(i.URI.revive(t),n),void 0)}$resolveCodeLens(e,t,i){
return this._withAdapter(e,_,e=>e.resolveCodeLens(t,i),void 0)}$releaseCodeLenses(e,t){this._withAdapter(e,_,e=>Promise.resolve(e.releaseCodeLenses(t)),void 0)}registerDefinitionProvider(e,t,i){const n=this._addNewAdapter(new w(this._documents,i),e);return this._proxy.$registerDefinitionSupport(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideDefinition(e,t,n,r){return this._withAdapter(e,w,e=>e.provideDefinition(i.URI.revive(t),n,r),[])}registerDeclarationProvider(e,t,i){const n=this._addNewAdapter(new b(this._documents,i),e);return this._proxy.$registerDeclarationSupport(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideDeclaration(e,t,n,r){return this._withAdapter(e,b,e=>e.provideDeclaration(i.URI.revive(t),n,r),[])}registerImplementationProvider(e,t,i){const n=this._addNewAdapter(new E(this._documents,i),e);return this._proxy.$registerImplementationSupport(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideImplementation(e,t,n,r){
return this._withAdapter(e,E,e=>e.provideImplementation(i.URI.revive(t),n,r),[])}registerTypeDefinitionProvider(e,t,i){const n=this._addNewAdapter(new x(this._documents,i),e);return this._proxy.$registerTypeDefinitionSupport(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideTypeDefinition(e,t,n,r){return this._withAdapter(e,x,e=>e.provideTypeDefinition(i.URI.revive(t),n,r),[])}registerHoverProvider(e,t,i,n){const r=this._addNewAdapter(new C(this._documents,i),e);return this._proxy.$registerHoverProvider(r,this._transformDocumentSelector(t)),this._createDisposable(r)}$provideHover(e,t,n,r){return this._withAdapter(e,C,e=>e.provideHover(i.URI.revive(t),n,r),void 0)}registerEvaluatableExpressionProvider(e,t,i,n){const r=this._addNewAdapter(new S(this._documents,i),e);return this._proxy.$registerEvaluatableExpressionProvider(r,this._transformDocumentSelector(t)),this._createDisposable(r)}$provideEvaluatableExpression(e,t,n,r){
return this._withAdapter(e,S,e=>e.provideEvaluatableExpression(i.URI.revive(t),n,r),void 0)}registerDocumentHighlightProvider(e,t,i){const n=this._addNewAdapter(new k(this._documents,i),e);return this._proxy.$registerDocumentHighlightProvider(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideDocumentHighlights(e,t,n,r){return this._withAdapter(e,k,e=>e.provideDocumentHighlights(i.URI.revive(t),n,r),void 0)}registerOnTypeRenameProvider(t,i,n,r){const o=this._addNewAdapter(new T(this._documents,n),t),s=r?e._serializeRegExp(r):void 0;return this._proxy.$registerOnTypeRenameProvider(o,this._transformDocumentSelector(i),s),this._createDisposable(o)}$provideOnTypeRenameRanges(e,t,n,r){return this._withAdapter(e,T,e=>e.provideOnTypeRenameRanges(i.URI.revive(t),n,r),void 0)}registerReferenceProvider(e,t,i){const n=this._addNewAdapter(new I(this._documents,i),e);return this._proxy.$registerReferenceSupport(n,this._transformDocumentSelector(t)),this._createDisposable(n)}
$provideReferences(e,t,n,r,o){return this._withAdapter(e,I,e=>e.provideReferences(i.URI.revive(t),n,r,o),void 0)}registerCodeActionProvider(t,i,n,r){var o,s;const a=new p.DisposableStore,c=this._addNewAdapter(new D(this._documents,this._commands.converter,this._diagnostics,n,this._logService,t,this._apiDeprecation),t);return this._proxy.$registerQuickFixSupport(c,this._transformDocumentSelector(i),{providedKinds:null===(o=null==r?void 0:r.providedCodeActionKinds)||void 0===o?void 0:o.map(e=>e.value),documentation:null===(s=null==r?void 0:r.documentation)||void 0===s?void 0:s.map(e=>({kind:e.kind.value,command:this._commands.converter.toInternal(e.command,a)}))},e._extLabel(t)),a.add(this._createDisposable(c)),a}$provideCodeActions(e,t,n,r,o){return this._withAdapter(e,D,e=>e.provideCodeActions(i.URI.revive(t),n,r,o),void 0)}$releaseCodeActions(e,t){this._withAdapter(e,D,e=>Promise.resolve(e.releaseCodeActions(t)),void 0)}registerDocumentFormattingEditProvider(e,t,i){
const n=this._addNewAdapter(new P(this._documents,i),e);return this._proxy.$registerDocumentFormattingSupport(n,this._transformDocumentSelector(t),e.identifier,e.displayName||e.name),this._createDisposable(n)}$provideDocumentFormattingEdits(e,t,n,r){return this._withAdapter(e,P,e=>e.provideDocumentFormattingEdits(i.URI.revive(t),n,r),void 0)}registerDocumentRangeFormattingEditProvider(e,t,i){const n=this._addNewAdapter(new R(this._documents,i),e);return this._proxy.$registerRangeFormattingSupport(n,this._transformDocumentSelector(t),e.identifier,e.displayName||e.name),this._createDisposable(n)}$provideDocumentRangeFormattingEdits(e,t,n,r,o){return this._withAdapter(e,R,e=>e.provideDocumentRangeFormattingEdits(i.URI.revive(t),n,r,o),void 0)}registerOnTypeFormattingEditProvider(e,t,i,n){const r=this._addNewAdapter(new A(this._documents,i),e);return this._proxy.$registerOnTypeFormattingSupport(r,this._transformDocumentSelector(t),n,e.identifier),this._createDisposable(r)}
$provideOnTypeFormattingEdits(e,t,n,r,o,s){return this._withAdapter(e,A,e=>e.provideOnTypeFormattingEdits(i.URI.revive(t),n,r,o,s),void 0)}registerWorkspaceSymbolProvider(e,t){const i=this._addNewAdapter(new O(t,this._logService),e);return this._proxy.$registerNavigateTypeSupport(i),this._createDisposable(i)}$provideWorkspaceSymbols(e,t,i){return this._withAdapter(e,O,e=>e.provideWorkspaceSymbols(t,i),{symbols:[]})}$resolveWorkspaceSymbol(e,t,i){return this._withAdapter(e,O,e=>e.resolveWorkspaceSymbol(t,i),void 0)}$releaseWorkspaceSymbols(e,t){this._withAdapter(e,O,e=>e.releaseWorkspaceSymbols(t),void 0)}registerRenameProvider(e,t,i){const n=this._addNewAdapter(new L(this._documents,i,this._logService),e);return this._proxy.$registerRenameSupport(n,this._transformDocumentSelector(t),L.supportsResolving(i)),this._createDisposable(n)}$provideRenameEdits(e,t,n,r,o){return this._withAdapter(e,L,e=>e.provideRenameEdits(i.URI.revive(t),n,r,o),void 0)}$resolveRenameLocation(e,t,n,r){
return this._withAdapter(e,L,e=>e.resolveRenameLocation(i.URI.revive(t),n,r),void 0)}registerDocumentSemanticTokensProvider(e,t,i,n){const r=this._nextHandle(),s="function"==typeof i.onDidChangeSemanticTokens?this._nextHandle():void 0;this._adapter.set(r,new V(new N(this._documents,i),e)),this._proxy.$registerDocumentSemanticTokensProvider(r,this._transformDocumentSelector(t),n,s);let a=this._createDisposable(r);if(s){const e=i.onDidChangeSemanticTokens(e=>this._proxy.$emitDocumentSemanticTokensEvent(s));a=o.Disposable.from(a,e)}return a}$provideDocumentSemanticTokens(e,t,n,r){return this._withAdapter(e,N,e=>e.provideDocumentSemanticTokens(i.URI.revive(t),n,r),null)}$releaseDocumentSemanticTokens(e,t){this._withAdapter(e,N,e=>e.releaseDocumentSemanticColoring(t),void 0)}registerDocumentRangeSemanticTokensProvider(e,t,i,n){const r=this._addNewAdapter(new F(this._documents,i),e);return this._proxy.$registerDocumentRangeSemanticTokensProvider(r,this._transformDocumentSelector(t),n),this._createDisposable(r)}
$provideDocumentRangeSemanticTokens(e,t,n,r){return this._withAdapter(e,F,e=>e.provideDocumentRangeSemanticTokens(i.URI.revive(t),n,r),null)}registerCompletionItemProvider(e,t,i,n){const r=this._addNewAdapter(new U(this._documents,this._commands.converter,i,this._apiDeprecation,e),e);return this._proxy.$registerSuggestSupport(r,this._transformDocumentSelector(t),n,U.supportsResolving(i),e.identifier),this._createDisposable(r)}$provideCompletionItems(e,t,n,r,o){return this._withAdapter(e,U,e=>e.provideCompletionItems(i.URI.revive(t),n,r,o),void 0)}$resolveCompletionItem(e,t,i){return this._withAdapter(e,U,e=>e.resolveCompletionItem(t,i),void 0)}$releaseCompletionItems(e,t){this._withAdapter(e,U,e=>e.releaseCompletionItems(t),void 0)}registerSignatureHelpProvider(e,t,i,n){const r=Array.isArray(n)?{triggerCharacters:n,retriggerCharacters:[]}:n,o=this._addNewAdapter(new H(this._documents,i),e);return this._proxy.$registerSignatureHelpProvider(o,this._transformDocumentSelector(t),r),this._createDisposable(o)}
$provideSignatureHelp(e,t,n,r,o){return this._withAdapter(e,H,e=>e.provideSignatureHelp(i.URI.revive(t),n,r,o),void 0)}$releaseSignatureHelp(e,t){this._withAdapter(e,H,e=>e.releaseSignatureHelp(t),void 0)}registerDocumentLinkProvider(e,t,i){const n=this._addNewAdapter(new $(this._documents,i),e);return this._proxy.$registerDocumentLinkProvider(n,this._transformDocumentSelector(t),"function"==typeof i.resolveDocumentLink),this._createDisposable(n)}$provideDocumentLinks(e,t,n){return this._withAdapter(e,$,e=>e.provideLinks(i.URI.revive(t),n),void 0)}$resolveDocumentLink(e,t,i){return this._withAdapter(e,$,e=>e.resolveLink(t,i),void 0)}$releaseDocumentLinks(e,t){this._withAdapter(e,$,e=>e.releaseLinks(t),void 0)}registerColorProvider(e,t,i){const n=this._addNewAdapter(new W(this._documents,i),e);return this._proxy.$registerDocumentColorProvider(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideDocumentColors(e,t,n){return this._withAdapter(e,W,e=>e.provideColors(i.URI.revive(t),n),[])}
$provideColorPresentations(e,t,n,r){return this._withAdapter(e,W,e=>e.provideColorPresentations(i.URI.revive(t),n,r),void 0)}registerFoldingRangeProvider(e,t,i){const n=this._addNewAdapter(new z(this._documents,i),e);return this._proxy.$registerFoldingRangeProvider(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideFoldingRanges(e,t,n,r){return this._withAdapter(e,z,e=>e.provideFoldingRanges(i.URI.revive(t),n,r),void 0)}registerSelectionRangeProvider(e,t,i){const n=this._addNewAdapter(new B(this._documents,i,this._logService),e);return this._proxy.$registerSelectionRangeProvider(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$provideSelectionRanges(e,t,n,r){return this._withAdapter(e,B,e=>e.provideSelectionRanges(i.URI.revive(t),n,r),[])}registerCallHierarchyProvider(e,t,i){const n=this._addNewAdapter(new j(this._documents,i),e);return this._proxy.$registerCallHierarchyProvider(n,this._transformDocumentSelector(t)),this._createDisposable(n)}$prepareCallHierarchy(e,t,n,r){
return this._withAdapter(e,j,e=>Promise.resolve(e.prepareSession(i.URI.revive(t),n,r)),void 0)}$provideCallHierarchyIncomingCalls(e,t,i,n){return this._withAdapter(e,j,e=>e.provideCallsTo(t,i,n),void 0)}$provideCallHierarchyOutgoingCalls(e,t,i,n){return this._withAdapter(e,j,e=>e.provideCallsFrom(t,i,n),void 0)}$releaseCallHierarchy(e,t){this._withAdapter(e,j,e=>Promise.resolve(e.releaseSession(t)),void 0)}static _serializeRegExp(e){return{pattern:e.source,flags:c.regExpFlags(e)}}static _serializeIndentationRule(t){return{decreaseIndentPattern:e._serializeRegExp(t.decreaseIndentPattern),increaseIndentPattern:e._serializeRegExp(t.increaseIndentPattern),indentNextLinePattern:t.indentNextLinePattern?e._serializeRegExp(t.indentNextLinePattern):void 0,unIndentedLinePattern:t.unIndentedLinePattern?e._serializeRegExp(t.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(t){return{beforeText:e._serializeRegExp(t.beforeText),afterText:t.afterText?e._serializeRegExp(t.afterText):void 0,
oneLineAboveText:t.oneLineAboveText?e._serializeRegExp(t.oneLineAboveText):void 0,action:t.action}}static _serializeOnEnterRules(t){return t.map(e._serializeOnEnterRule)}setLanguageConfiguration(t,i,n){let{wordPattern:r}=n;if(r&&c.regExpLeadsToEndlessLoop(r))throw new Error(`Invalid language configuration: wordPattern '${r}' is not allowed to match the empty string.`);r?this._documents.setWordDefinitionFor(i,r):this._documents.setWordDefinitionFor(i,void 0),n.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",t,"Do not use."),n.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",t,"Do not use.");const o=this._nextHandle(),s={comments:n.comments,brackets:n.brackets,wordPattern:n.wordPattern?e._serializeRegExp(n.wordPattern):void 0,indentationRules:n.indentationRules?e._serializeIndentationRule(n.indentationRules):void 0,onEnterRules:n.onEnterRules?e._serializeOnEnterRules(n.onEnterRules):void 0,
__electricCharacterSupport:n.__electricCharacterSupport,__characterPairSupport:n.__characterPairSupport};return this._proxy.$setLanguageConfiguration(o,i,s),this._createDisposable(o)}$setWordDefinitions(e){for(const t of e)this._documents.setWordDefinitionFor(t.languageId,new RegExp(t.regexSource,t.regexFlags))}}return e._handlePool=0,e})();t.ExtHostLanguageFeatures=K})),define(t[205],i([1,0,5,21,10]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostLanguages=void 0;t.ExtHostLanguages=class{constructor(e,t){this._proxy=e.getProxy(i.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(e,t){await this._proxy.$changeLanguage(e,t);const i=this._documents.getDocumentData(e);if(!i)throw new Error(`document '${e.toString}' NOT found`);return i.document}async tokenAtPosition(e,t){var i;const o=e.version,s=n.Position.from(t),a=await this._proxy.$tokensAtPosition(e.uri,s),c={type:r.StandardTokenType.Other,
range:null!==(i=e.getWordRangeAtPosition(t))&&void 0!==i?i:new r.Range(t.line,t.character,t.line,t.character)};if(!a)return c;const l={range:n.Range.to(a.range),type:n.TokenType.to(a.type)};return l.range.contains(t)?o!==e.version?c:l:c}}})),define(t[206],i([1,0,5,11]),(function(e,t,i,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostMessageService=void 0;let o=(()=>{let e=class{constructor(e,t){this._logService=t,this._proxy=e.getProxy(i.MainContext.MainThreadMessageService)}showMessage(e,t,i,n,r){const o={extension:e};let s;var a;"string"==typeof n||(a=n)&&a.title?s=[n,...r]:(o.modal=n&&n.modal,s=r);const c=[];for(let e=0;e<s.length;e++){const t=s[e];if("string"==typeof t)c.push({title:t,handle:e,isCloseAffordance:!1});else if("object"==typeof t){let{title:i,isCloseAffordance:n}=t;c.push({title:i,isCloseAffordance:!!n,handle:e})}else this._logService.warn("Invalid message item:",t)}return this._proxy.$showMessage(t,i,o,c).then(e=>{if("number"==typeof e)return s[e]})}}
;return e=n([s(1,r.ILogService)],e)})();t.ExtHostMessageService=o})),define(t[207],i([1,0,19,3,6,2,5,99,10,75,12,21,69]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h){"use strict";function p(e){const t=new n.Emitter;return{proxy:new Proxy(e,{set:(e,i,n,r)=>(e[i]=n,t.fire(),!0)}),onDidChange:t.event}}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostNotebookController=t.ExtHostNotebookOutputRenderer=t.ExtHostNotebookEditor=t.NotebookEditorCellEditBuilder=t.ExtHostNotebookDocument=t.ExtHostCell=void 0;class m extends r.Disposable{constructor(e,t,i,r,o,s,a,c,d){super(),this._notebook=e,this.handle=t,this.uri=i,this.cellKind=o,this.language=s,this._proxy=d,this._onDidChangeOutputs=new n.Emitter,this.onDidChangeOutputs=this._onDidChangeOutputs.event,this._outputMapping=new Set,this._documentData=new l.ExtHostDocumentData(new class extends(u.NotImplementedProxy("document")){},i,r.split(/\r|\n|\r\n/g),"\n",s,0,!1),this._outputs=a;const h=p(c||{});this._metadata=h.proxy,
this._metadataChangeListener=this._register(h.onDidChange(()=>{this.updateMetadata()}))}get document(){return this._documentData.document}get notebook(){return this._notebook}get source(){return this._documentData.getText()}get outputs(){return this._outputs}set outputs(e){let t=a.diff(this._outputs||[],e||[],e=>this._outputMapping.has(e));t.forEach(e=>{for(let t=e.start;t<e.start+e.deleteCount;t++)this._outputMapping.delete(this._outputs[t]);e.toInsert.forEach(e=>{this._outputMapping.add(e)})}),this._outputs=e,this._onDidChangeOutputs.fire(t)}get metadata(){return this._metadata}set metadata(e){this._metadataChangeListener.dispose();const t=p(e);this._metadata=t.proxy,this._metadataChangeListener=this._register(t.onDidChange(()=>{this.updateMetadata()})),this.updateMetadata()}updateMetadata(){return this._proxy.$updateNotebookCellMetadata(this._notebook.viewType,this._notebook.uri,this.handle,this._metadata)}attachTextDocument(e){this._documentData=e}detachTextDocument(){}}t.ExtHostCell=m;let f=(()=>{
class e extends r.Disposable{constructor(t,i,n,r,o,s){super(),this._proxy=t,this._documentsAndEditors=i,this._emitter=n,this.viewType=r,this.uri=o,this.renderingHandler=s,this.handle=e._handlePool++,this._cells=[],this._cellDisposableMapping=new Map,this._languages=[],this._metadata=a.notebookDocumentMetadataDefaults,this._displayOrder=[],this._versionId=0,this._disposed=!1;const c=p(a.notebookDocumentMetadataDefaults);this._metadata=c.proxy,this._metadataChangeListener=this._register(c.onDidChange(()=>{this.updateMetadata()}))}get cells(){return this._cells}get languages(){return this._languages=[]}set languages(e){this._languages=e,this._proxy.$updateNotebookLanguages(this.viewType,this.uri,this._languages)}get metadata(){return this._metadata}set metadata(e){this._metadataChangeListener.dispose(),e=Object.assign(Object.assign({},a.notebookDocumentMetadataDefaults),e),this._metadataChangeListener&&this._metadataChangeListener.dispose();const t=p(e);this._metadata=t.proxy,
this._metadataChangeListener=this._register(t.onDidChange(()=>{this.updateMetadata()})),this.updateMetadata()}get displayOrder(){return this._displayOrder}set displayOrder(e){this._displayOrder=e}get versionId(){return this._versionId}updateMetadata(){this._proxy.$updateNotebookMetadata(this.viewType,this.uri,this._metadata)}dispose(){this._disposed=!0,super.dispose(),this._cellDisposableMapping.forEach(e=>e.dispose())}get fileName(){return this.uri.fsPath}get isDirty(){return!1}accpetModelChanged(e){this._versionId=e.versionId,e.kind===a.NotebookCellsChangeType.Initialize&&this.$spliceNotebookCells(e.changes,!0),
e.kind===a.NotebookCellsChangeType.ModelChange?this.$spliceNotebookCells(e.changes,!1):e.kind===a.NotebookCellsChangeType.Move?this.$moveCell(e.index,e.newIdx):e.kind===a.NotebookCellsChangeType.CellClearOutput?this.$clearCellOutputs(e.index):e.kind===a.NotebookCellsChangeType.CellsClearOutput?this.$clearAllCellOutputs():e.kind===a.NotebookCellsChangeType.ChangeLanguage&&this.$changeCellLanguage(e.index,e.language)}$spliceNotebookCells(e,t){if(this._disposed)return;let i=[];e.reverse().forEach(e=>{var t;let n=e[2].map(e=>{const t=new m(this,e.handle,o.URI.revive(e.uri),e.source.join("\n"),e.cellKind,e.language,e.outputs,e.metadata,this._proxy),i=this._documentsAndEditors.getDocument(o.URI.revive(e.uri));return i&&t.attachTextDocument(i),this._cellDisposableMapping.has(t.handle)||this._cellDisposableMapping.set(t.handle,new r.DisposableStore),this._cellDisposableMapping.get(t.handle).add(t.onDidChangeOutputs(e=>{this.eventuallyUpdateCellOutputs(t,e)})),t})
;for(let i=e[0];i<e[0]+e[1];i++)null===(t=this._cellDisposableMapping.get(this.cells[i].handle))||void 0===t||t.dispose(),this._cellDisposableMapping.delete(this.cells[i].handle);this.cells.splice(e[0],e[1],...n);const s={start:e[0],deletedCount:e[1],items:n};i.push(s)}),t||this._emitter.emitModelChange({document:this,changes:i})}$moveCell(e,t){const i=this.cells.splice(e,1);this.cells.splice(t,0,...i);const n=[{start:e,deletedCount:1,items:[]},{start:t,deletedCount:0,items:i}];this._emitter.emitModelChange({document:this,changes:n})}$clearCellOutputs(e){const t=this.cells[e];t.outputs=[];const i={document:this,cells:[t]};this._emitter.emitCellOutputsChange(i)}$clearAllCellOutputs(){const e=[];this.cells.forEach(t=>{0!==t.outputs.length&&(t.outputs=[],e.push(t))});const t={document:this,cells:e};this._emitter.emitCellOutputsChange(t)}$changeCellLanguage(e,t){const i=this.cells[e];i.language=t;const n={document:this,cell:i,language:t};this._emitter.emitCellLanguageChange(n)}
async eventuallyUpdateCellOutputs(e,t){let i=new Set,n=t.map(e=>{let t=e.toInsert;return[e.start,e.deleteCount,t]});await this._proxy.$spliceNotebookCellOutputs(this.viewType,this.uri,e.handle,n,Array.from(i)),this._emitter.emitCellOutputsChange({document:this,cells:[e]})}getCell(e){return this.cells.find(t=>t.handle===e)}getCell2(e){return this.cells.find(t=>t.uri.fragment===e.fragment)}attachCellTextDocument(e){let t=this.cells.find(t=>t.uri.toString()===e.document.uri.toString());t&&t.attachTextDocument(e)}detachCellTextDocument(e){let t=this.cells.find(t=>t.uri.toString()===e.document.uri.toString());t&&t.detachTextDocument()}}return e._handlePool=0,e})();t.ExtHostNotebookDocument=f;class g{constructor(e){this.editor=e,this._finalized=!1,this._collectedEdits=[],this._renderers=new Set,this._documentVersionId=e.document.versionId}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,renderers:Array.from(this._renderers)}}_throwIfFinalized(){
if(this._finalized)throw new Error("Edit is only valid while callback runs")}insert(e,t,i,n,r,o){this._throwIfFinalized();let s={source:Array.isArray(t)?t:t.split(/\r|\n|\r\n/g),language:i,cellKind:n,outputs:r,metadata:o};this._collectedEdits.push({editType:a.CellEditType.Insert,index:e,cells:[s]})}delete(e){this._throwIfFinalized(),this._collectedEdits.push({editType:a.CellEditType.Delete,index:e,count:1})}}t.NotebookEditorCellEditBuilder=g;class v extends r.Disposable{constructor(e,t,i,r,o,s,c,l){super(),this.viewType=e,this.id=t,this.uri=i,this._proxy=r,this._onDidReceiveMessage=o,this._webviewInitData=s,this.document=c,this._documentsAndEditors=l,this.selection=void 0,this._active=!1,this._visible=!1,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this.onDidReceiveMessage=this._onDidReceiveMessage.event,this._register(this._documentsAndEditors.onDidAddDocuments(e=>{for(const t of e){let e=a.CellUri.parse(t.document.uri)
;e&&this.document.uri.fsPath===e.notebook.fsPath&&c.attachCellTextDocument(t)}})),this._register(this._documentsAndEditors.onDidRemoveDocuments(e=>{for(const t of e){let e=a.CellUri.parse(t.document.uri);e&&this.document.uri.fsPath===e.notebook.fsPath&&c.detachCellTextDocument(t)}}))}get active(){return this._active}set active(e){throw i.readonly("active")}get visible(){return this._visible}set visible(e){throw i.readonly("visible")}_acceptVisibility(e){this._visible=e}_acceptActive(e){this._active=e}edit(e){const t=new g(this);return e(t),this._applyEdit(t)}_applyEdit(e){const t=e.finalize();if(0===t.edits.length)return Promise.resolve(!0);let i=[],n=-1;for(let e=0;e<t.edits.length;e++){if(n<0){i.push(t.edits[e]),n++;continue}let r=i[n];r.editType!==a.CellEditType.Insert||t.edits[e].editType!==a.CellEditType.Insert||r.index!==t.edits[e].index?r.editType!==a.CellEditType.Delete||t.edits[e].editType!==a.CellEditType.Delete||r.index!==t.edits[e].index?(i.push(t.edits[e]),
n++):r.count+=t.edits[e].count:r.cells.push(...t.edits[e].cells)}return this._proxy.$tryApplyEdits(this.viewType,this.uri,t.documentVersionId,i,t.renderers)}get viewColumn(){return this._viewColumn}set viewColumn(e){throw i.readonly("viewColumn")}async postMessage(e){return this._proxy.$postMessage(this.document.handle,e)}asWebviewUri(e){return h.asWebviewUri(this._webviewInitData,this.id,e)}dispose(){this._onDidDispose.fire(),super.dispose()}}t.ExtHostNotebookEditor=v;let _=(()=>{class e{constructor(t,i,n){this.type=t,this.filter=i,this.renderer=n,this.handle=e._handlePool++}matches(e){return!!(this.filter.subTypes&&this.filter.subTypes.indexOf(e)>=0)}render(e,t,i){return this.renderer.render(e,t,i)}}return e._handlePool=0,e})();t.ExtHostNotebookOutputRenderer=_;t.ExtHostNotebookController=class{constructor(e,t,i,r){this._documentsAndEditors=i,this._webviewInitData=r,this._notebookContentProviders=new Map,this._notebookKernels=new Map,this._documents=new Map,this._unInitializedDocuments=new Map,
this._editors=new Map,this._notebookOutputRenderers=new Map,this._onDidChangeNotebookCells=new n.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new n.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellLanguage=new n.Emitter,this.onDidChangeCellLanguage=this._onDidChangeCellLanguage.event,this._onDidChangeActiveNotebookEditor=new n.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidOpenNotebookDocument=new n.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new n.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this.visibleNotebookEditors=[],this._onDidChangeVisibleNotebookEditors=new n.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._proxy=e.getProxy(s.MainContext.MainThreadNotebook),t.registerArgumentProcessor({
processArgument:e=>{var t;if(e&&12===e.$mid){const i=null===(t=e.notebookEditor)||void 0===t?void 0:t.notebookHandle,n=e.cell.handle;for(let e of this._editors)if(e[1].editor.document.handle===i){const t=e[1].editor.document.getCell(n);if(t)return t}}return e}})}get outputDisplayOrder(){return this._outputDisplayOrder}get activeNotebookDocument(){return this._activeNotebookDocument}get activeNotebookEditor(){return this._activeNotebookEditor}registerNotebookOutputRenderer(e,t,i,n){if(this._notebookKernels.has(e))throw new Error(`Notebook renderer for '${e}' already registered`);let r=new _(e,i,n);return this._notebookOutputRenderers.set(r.type,r),this._proxy.$registerNotebookRenderer({id:t.identifier,location:t.extensionLocation},e,i,n.preloads||[]),new c.Disposable(()=>{this._notebookOutputRenderers.delete(r.type),this._proxy.$unregisterNotebookRenderer(r.type)})}async $renderOutputs(e,t,i){if(!this._notebookOutputRenderers.has(t))throw new Error(`Notebook renderer for '${t}' is not registered`)
;const n=this._documents.get(o.URI.revive(e).toString());if(!n)return;const r=this._notebookOutputRenderers.get(t);return{items:i.items.map(e=>{const i=n.getCell2(e.key),o=e.outputs.map(e=>({index:e.index,mimeType:e.mimeType,handlerId:t,transformedOutput:r.render(n,i.outputs[e.index],e.mimeType)}));return{key:e.key,outputs:o}})}}async $renderOutputs2(e,t,i){if(!this._notebookOutputRenderers.has(t))throw new Error(`Notebook renderer for '${t}' is not registered`);const n=this._documents.get(o.URI.revive(e).toString());if(!n)return;const r=this._notebookOutputRenderers.get(t);return{items:i.items.map(e=>{const i=e.outputs.map(e=>({index:e.index,mimeType:e.mimeType,handlerId:t,transformedOutput:r.render(n,e.output,e.mimeType)}));return{key:e.key,outputs:i}})}}findBestMatchedRenderer(e){let t=[];for(let i of this._notebookOutputRenderers)i[1].matches(e)&&t.push(i[1]);return t}registerNotebookContentProvider(e,t,i){
if(this._notebookContentProviders.has(t))throw new Error(`Notebook provider for '${t}' already registered`);this._notebookContentProviders.set(t,{extension:e,provider:i});const n=i.onDidChangeNotebook?i.onDidChangeNotebook(e=>this._proxy.$onNotebookChange(t,e.document.uri)):r.Disposable.None;return this._proxy.$registerNotebookProvider({id:e.identifier,location:e.extensionLocation},t,i.kernel?{id:t,label:i.kernel.label,extensionLocation:e.extensionLocation,preloads:i.kernel.preloads}:void 0),new c.Disposable(()=>{n.dispose(),this._notebookContentProviders.delete(t),this._proxy.$unregisterNotebookProvider(t)})}registerNotebookKernel(e,t,i,n){if(this._notebookKernels.has(t))throw new Error(`Notebook kernel for '${t}' already registered`);this._notebookKernels.set(t,{kernel:n,extension:e});const r=i.map(e=>d.GlobPattern.from(e));return this._proxy.$registerNotebookKernel({id:e.identifier,location:e.extensionLocation},t,n.label,r,n.preloads||[]),new c.Disposable(()=>{this._notebookKernels.delete(t),
this._proxy.$unregisterNotebookKernel(t)})}async $resolveNotebookData(e,t){var i;const n=this._notebookContentProviders.get(e),r=o.URI.revive(t);if(n){let s=this._documents.get(o.URI.revive(t).toString());if(!s){const t=this;s=null!==(i=this._unInitializedDocuments.get(r.toString()))&&void 0!==i?i:new f(this._proxy,this._documentsAndEditors,{emitModelChange(e){t._onDidChangeNotebookCells.fire(e)},emitCellOutputsChange(e){t._onDidChangeCellOutputs.fire(e)},emitCellLanguageChange(e){t._onDidChangeCellLanguage.fire(e)}},e,r,this),this._unInitializedDocuments.set(r.toString(),s)}const c=await n.provider.openNotebook(o.URI.revive(t));return{metadata:Object.assign(Object.assign({},a.notebookDocumentMetadataDefaults),c.metadata),languages:c.languages,cells:c.cells}}}async $executeNotebook(e,t,i,n,r){let s=this._documents.get(o.URI.revive(t).toString());if(s&&this._notebookContentProviders.has(e)){const t=void 0!==i?s.getCell(i):void 0,o=this._notebookContentProviders.get(e).provider
;if(o.kernel&&n)return t?o.kernel.executeCell(s,t,r):o.kernel.executeAllCells(s,r)}}async $executeNotebook2(e,t,i,n,r){let s=this._documents.get(o.URI.revive(i).toString());if(!s||s.viewType!==t)return;let a=this._notebookKernels.get(e);if(!a)return;let c=void 0!==n?s.getCell(n):void 0;return c?a.kernel.executeCell(s,c,r):a.kernel.executeAllCells(s,r)}async $saveNotebook(e,t,i){let n=this._documents.get(o.URI.revive(t).toString());if(!n)return!1;if(this._notebookContentProviders.has(e)){try{await this._notebookContentProviders.get(e).provider.saveNotebook(n,i)}catch(e){return!1}return!0}return!1}async $saveNotebookAs(e,t,i,n){let r=this._documents.get(o.URI.revive(t).toString());if(!r)return!1;if(this._notebookContentProviders.has(e)){try{await this._notebookContentProviders.get(e).provider.saveNotebookAs(o.URI.revive(i),r,n)}catch(e){return!1}return!0}return!1}$acceptDisplayOrder(e){this._outputDisplayOrder=e}_getEditorFromURI(e){const t=o.URI.revive(e).toString();let i;return this._editors.forEach(e=>{
e.editor.uri.toString()===t&&(i=e)}),i}$onDidReceiveMessage(e,t){let i=this._editors.get(e);i&&i.onDidReceiveMessage.fire(t)}$acceptModelChanged(e,t){const i=this._documents.get(o.URI.revive(e).toString());i&&i.accpetModelChanged(t)}$acceptEditorPropertiesChanged(e,t){let i=this._getEditorFromURI(e);if(i){if(t.selections){const e=i.editor.document.cells;if(t.selections.selections.length){const n=t.selections.selections[0];i.editor.selection=e.find(e=>e.handle===n)}else i.editor.selection=void 0}t.metadata&&(i.editor.document.metadata=Object.assign(Object.assign({},a.notebookDocumentMetadataDefaults),t.metadata))}}_createExtHostEditor(e,t,i){var r;const o=new n.Emitter,s=e.uri;let a=new v(e.viewType,t,s,this._proxy,o,this._webviewInitData,e,this._documentsAndEditors);const c=a.document.cells;if(i.length){const e=i[0];a.selection=c.find(t=>t.handle===e)}else a.selection=void 0;null===(r=this._editors.get(t))||void 0===r||r.editor.dispose(),this._editors.set(t,{editor:a,onDidReceiveMessage:o})}
async $acceptDocumentAndEditorsDelta(e){var t,i;let n=!1;e.removedDocuments&&e.removedDocuments.forEach(e=>{const t=o.URI.revive(e).toString();let i=this._documents.get(t);i&&(i.dispose(),this._documents.delete(t),this._onDidCloseNotebookDocument.fire(i)),[...this._editors.values()].forEach(e=>{e.editor.uri.toString()===t&&(e.editor.dispose(),e.onDidReceiveMessage.dispose(),this._editors.delete(e.editor.id),n=!0)})}),e.addedDocuments&&e.addedDocuments.forEach(e=>{var t,i;const r=o.URI.revive(e.uri),s=r.toString(),c=e.viewType;if(!this._documents.has(s)){const o=this;let l=null!==(t=this._unInitializedDocuments.get(s))&&void 0!==t?t:new f(this._proxy,this._documentsAndEditors,{emitModelChange(e){o._onDidChangeNotebookCells.fire(e)},emitCellOutputsChange(e){o._onDidChangeCellOutputs.fire(e)},emitCellLanguageChange(e){o._onDidChangeCellLanguage.fire(e)}},c,r,this);this._unInitializedDocuments.delete(s),e.metadata&&(l.metadata=Object.assign(Object.assign({},a.notebookDocumentMetadataDefaults),e.metadata)),
l.accpetModelChanged({kind:a.NotebookCellsChangeType.Initialize,versionId:e.versionId,changes:[[0,0,e.cells]]}),null===(i=this._documents.get(s))||void 0===i||i.dispose(),this._documents.set(s,l),e.attachedEditor&&(this._createExtHostEditor(l,e.attachedEditor.id,e.attachedEditor.selections),n=!0)}const l=this._documents.get(s);this._onDidOpenNotebookDocument.fire(l)}),e.addedEditors&&e.addedEditors.forEach(e=>{if(this._editors.has(e.id))return;const t=o.URI.revive(e.documentUri),i=this._documents.get(t.toString());i&&(this._createExtHostEditor(i,e.id,e.selections),n=!0)});const r=[];if(e.removedEditors&&e.removedEditors.forEach(e=>{var t;const i=this._editors.get(e);i&&(n=!0,this._editors.delete(e),(null===(t=this.activeNotebookEditor)||void 0===t?void 0:t.id)===i.editor.id&&(this._activeNotebookEditor=void 0,this._activeNotebookDocument=void 0),r.push(i))}),n&&r.forEach(e=>{e.editor.dispose(),e.onDidReceiveMessage.dispose()}),e.visibleEditors){
this.visibleNotebookEditors=e.visibleEditors.map(e=>this._editors.get(e).editor).filter(e=>!!e);const t=new Set;this.visibleNotebookEditors.forEach(e=>t.add(e.id)),[...this._editors.values()].forEach(e=>{const i=t.has(e.editor.id);e.editor._acceptVisibility(i)}),this.visibleNotebookEditors=[...this._editors.values()].map(e=>e.editor).filter(e=>e.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}void 0!==e.newActiveEditor&&(e.newActiveEditor?(this._activeNotebookEditor=null===(t=this._editors.get(e.newActiveEditor))||void 0===t?void 0:t.editor,null===(i=this._activeNotebookEditor)||void 0===i||i._acceptActive(!0),this._activeNotebookDocument=this._activeNotebookEditor?this._documents.get(this._activeNotebookEditor.uri.toString()):void 0,[...this._editors.values()].forEach(e=>{e.editor!==this.activeNotebookEditor&&e.editor._acceptActive(!1)})):(this._activeNotebookEditor=void 0,this._activeNotebookDocument=void 0,[...this._editors.values()].forEach(e=>{e.editor._acceptActive(!1)
})),this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor))}}})),define(t[60],i([1,0,5,3,6,29,4,14]),(function(e,t,i,r,o,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostOutputService=t.ExtHostOutputService=t.LazyOutputChannel=t.ExtHostPushOutputChannel=t.AbstractExtHostOutputChannel=void 0;class u extends o.Disposable{constructor(e,t,i,n){super(),this._onDidAppend=this._register(new r.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=e,this._proxy=n,this._id=n.$register(this.name,t,i),this._disposed=!1,this._offset=0}get name(){return this._name}append(e){this.validate(),this._offset+=e?a.VSBuffer.fromString(e).byteLength:0}update(){this._id.then(e=>this._proxy.$update(e))}appendLine(e){this.validate(),this.append(e+"\n")}clear(){this.validate();const e=this._offset;this._id.then(t=>this._proxy.$clear(t,e))}show(e,t){this.validate(),this._id.then(i=>this._proxy.$reveal(i,!!("boolean"==typeof e?e:t)))}hide(){this.validate(),
this._id.then(e=>this._proxy.$close(e))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(e=>this._proxy.$dispose(e)).then(()=>this._disposed=!0)}}t.AbstractExtHostOutputChannel=u;class d extends u{constructor(e,t){super(e,!1,void 0,t)}append(e){super.append(e),this._id.then(t=>this._proxy.$append(t,e)),this._onDidAppend.fire()}}t.ExtHostPushOutputChannel=d;class h extends u{constructor(e,t,i){super(e,!0,t,i)}append(e){throw new Error("Not supported")}}t.LazyOutputChannel=class{constructor(e,t){this.name=e,this._channel=t}append(e){this._channel.then(t=>t.append(e))}appendLine(e){this._channel.then(t=>t.appendLine(e))}clear(){this._channel.then(e=>e.clear())}show(e,t){this._channel.then(i=>i.show(e,t))}hide(){this._channel.then(e=>e.hide())}dispose(){this._channel.then(e=>e.dispose())}};let p=(()=>{let e=class{constructor(e){this._proxy=e.getProxy(i.MainContext.MainThreadOutputService)}$setVisibleChannel(e){}createOutputChannel(e){
if(!(e=e.trim()))throw new Error("illegal argument `name`. must not be falsy");return new d(e,this._proxy)}createOutputChannelFromLogFile(e,t){if(!(e=e.trim()))throw new Error("illegal argument `name`. must not be falsy");if(!t)throw new Error("illegal argument `file`. must not be falsy");return new h(e,t,this._proxy)}};return e=n([s(0,l.IExtHostRpcService)],e)})();t.ExtHostOutputService=p,t.IExtHostOutputService=c.createDecorator("IExtHostOutputService")})),define(t[209],i([1,0,16,22,3,6,5,2,10,19,13]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostQuickOpen=void 0;t.ExtHostQuickOpen=class{constructor(e,t,i){this._sessions=new Map,this._instances=0,this._proxy=e.getProxy(s.MainContext.MainThreadQuickOpen),this._workspace=t,this._commands=i}showQuickPick(e,t,i,r=n.CancellationToken.None){this._onDidSelectItem=void 0;const o=Promise.resolve(e),s=++this._instances,a=this._proxy.$show(s,{placeHolder:i&&i.placeHolder,
matchOnDescription:i&&i.matchOnDescription,matchOnDetail:i&&i.matchOnDetail,ignoreFocusLost:i&&i.ignoreFocusOut,canPickMany:i&&i.canPickMany},r),c={},u=a.then(()=>c);return Promise.race([u,o]).then(e=>{if(e!==c)return o.then(e=>{const t=[];for(let i=0;i<e.length;i++){const n=e[i];let r,o,s,a,c;"string"==typeof n?r=n:(r=n.label,o=n.description,s=n.detail,a=n.picked,c=n.alwaysShow),t.push({label:r,description:o,handle:i,detail:s,picked:a,alwaysShow:c})}return i&&"function"==typeof i.onDidSelectItem&&(this._onDidSelectItem=t=>{i.onDidSelectItem(e[t])}),this._proxy.$setItems(s,t),a.then(t=>"number"==typeof t?e[t]:Array.isArray(t)?t.map(t=>e[t]):void 0)})}).then(void 0,e=>{if(!l.isPromiseCanceledError(e))return this._proxy.$setError(s,e),Promise.reject(e)})}$onItemSelected(e){this._onDidSelectItem&&this._onDidSelectItem(e)}showInput(e,t=n.CancellationToken.None){return this._validateInput=e?e.validateInput:void 0,this._proxy.$input(e,"function"==typeof this._validateInput,t).then(void 0,e=>{
if(!l.isPromiseCanceledError(e))return Promise.reject(e)})}$validateInput(e){return this._validateInput?i.asPromise(()=>this._validateInput(e)):Promise.resolve(void 0)}async showWorkspaceFolderPick(e,t=n.CancellationToken.None){const i=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[e]);if(!i)return;const r=await this._workspace.getWorkspaceFolders2();return r?r.find(e=>e.uri.toString()===i.uri.toString()):void 0}createQuickPick(e,t){const i=new m(this._proxy,e,t,()=>this._sessions.delete(i._id));return this._sessions.set(i._id,i),i}createInputBox(e){const t=new f(this._proxy,e,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(e,t){const i=this._sessions.get(e);i&&i._fireDidChangeValue(t)}$onDidAccept(e){const t=this._sessions.get(e);t&&t._fireDidAccept()}$onDidChangeActive(e,t){const i=this._sessions.get(e);i instanceof m&&i._fireDidChangeActive(t)}$onDidChangeSelection(e,t){const i=this._sessions.get(e);i instanceof m&&i._fireDidChangeSelection(t)
}$onDidTriggerButton(e,t){const i=this._sessions.get(e);i&&i._fireDidTriggerButton(t)}$onDidHide(e){const t=this._sessions.get(e);t&&t._fireDidHide()}};let d=(()=>{class e{constructor(e,t,i){this._proxy=e,this._extensionId=t,this._onDidDispose=i,this._id=m._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new r.Emitter,this._onDidChangeValueEmitter=new r.Emitter,this._onDidTriggerButtonEmitter=new r.Emitter,this._onDidHideEmitter=new r.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}
set title(e){this._title=e,this.update({title:e})}get step(){return this._steps}set step(e){this._steps=e,this.update({step:e})}get totalSteps(){return this._totalSteps}set totalSteps(e){this._totalSteps=e,this.update({totalSteps:e})}get enabled(){return this._enabled}set enabled(e){this._enabled=e,this.update({enabled:e})}get busy(){return this._busy}set busy(e){this._busy=e,this.update({busy:e})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(e){this._ignoreFocusOut=e,this.update({ignoreFocusOut:e})}get value(){return this._value}set value(e){this._value=e,this.update({value:e})}get placeholder(){return this._placeholder}set placeholder(e){this._placeholder=e,this.update({placeholder:e})}get buttons(){return this._buttons}set buttons(e){this._buttons=e.slice(),this._handlesToButtons.clear(),e.forEach((e,t)=>{const i=e===c.QuickInputButtons.Back?-1:t;this._handlesToButtons.set(i,e)}),this.update({buttons:e.map((e,t)=>({iconPath:h(e.iconPath),tooltip:e.tooltip,
handle:e===c.QuickInputButtons.Back?-1:t}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(e){this._value=e,this._onDidChangeValueEmitter.fire(e)}_fireDidTriggerButton(e){const t=this._handlesToButtons.get(e);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=o.dispose(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),this._proxy.$dispose(this._id))}update(e){if(!this._disposed){for(const t of Object.keys(e)){const i=e[t];this._pendingUpdate[t]=void 0===i?null:i}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),
this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){this._proxy.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}return e._nextId=1,e})();function h(e){if(e instanceof c.ThemeIcon)return{id:e.id};return{dark:function(e){return p("object"==typeof e&&"dark"in e?e.dark:e)}(e),light:function(e){return p("object"==typeof e&&"light"in e?e.light:e)}(e)}}function p(e){return a.URI.isUri(e)?e:a.URI.file(e)}class m extends d{constructor(e,t,i,n){super(e,t,n),this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new r.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new r.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,
this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(e){this._items=e.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),e.forEach((e,t)=>{this._handlesToItems.set(t,e),this._itemsToHandles.set(e,t)}),this.update({items:e.map((e,t)=>({label:e.label,description:e.description,handle:t,detail:e.detail,picked:e.picked,alwaysShow:e.alwaysShow}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(e){this._canSelectMany=e,this.update({canSelectMany:e})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(e){this._matchOnDescription=e,this.update({matchOnDescription:e})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(e){this._matchOnDetail=e,this.update({matchOnDetail:e})}get sortByLabel(){return this._sortByLabel}set sortByLabel(e){this._sortByLabel=e,this.update({sortByLabel:e})}get activeItems(){return this._activeItems}
set activeItems(e){this._activeItems=e.filter(e=>this._itemsToHandles.has(e)),this.update({activeItems:this._activeItems.map(e=>this._itemsToHandles.get(e))})}get selectedItems(){return this._selectedItems}set selectedItems(e){this._selectedItems=e.filter(e=>this._itemsToHandles.has(e)),this.update({selectedItems:this._selectedItems.map(e=>this._itemsToHandles.get(e))})}_fireDidChangeActive(e){const t=u.coalesce(e.map(e=>this._handlesToItems.get(e)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(e){const t=u.coalesce(e.map(e=>this._handlesToItems.get(e)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}}class f extends d{constructor(e,t,i){super(e,t,i),this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(e){this._password=e,this.update({password:e})}get prompt(){return this._prompt}set prompt(e){this._prompt=e,this.update({prompt:e})}get validationMessage(){return this._validationMessage}
set validationMessage(e){this._validationMessage=e,this.update({validationMessage:e})}}})),define(t[210],i([1,0,2,3,77,6,16,5,13,111,11,28]),(function(e,t,i,r,o,a,c,l,u,d,h,p){"use strict";function m(e){return e?"string"==typeof e.iconPath?i.URI.file(e.iconPath):e.iconPath:void 0}function f(e,t){if(!e.iconPath&&!t.iconPath)return 0;if(!e.iconPath)return-1;if(!t.iconPath)return 1;const i="string"==typeof e.iconPath?e.iconPath:e.iconPath.fsPath,n="string"==typeof t.iconPath?t.iconPath:t.iconPath.fsPath;return d.comparePaths(i,n)}function g(e,t){let i=d.comparePaths(e.resourceUri.fsPath,t.resourceUri.fsPath,!0);if(0!==i)return i;if(e.decorations&&t.decorations)i=function(e,t){let i=0;if(e.strikeThrough!==t.strikeThrough)return e.strikeThrough?1:-1;if(e.faded!==t.faded)return e.faded?1:-1;if(e.tooltip!==t.tooltip)return(e.tooltip||"").localeCompare(t.tooltip||"");if(0!==(i=f(e,t)))return i;if(e.light&&t.light)i=f(e.light,t.light);else{if(e.light)return 1;if(t.light)return-1}if(0!==i)return i
;if(e.dark&&t.dark)i=f(e.dark,t.dark);else{if(e.dark)return 1;if(t.dark)return-1}return i}(e.decorations,t.decorations);else{if(e.decorations)return 1;if(t.decorations)return-1}return i}function v(e,t){return e.command===t.command&&e.title===t.title&&e.tooltip===t.tooltip&&(e.arguments&&t.arguments?function(e,t){for(let i=0;i<e.length;i++)if(e[i]!==t[i])return!1;return!0}(e.arguments,t.arguments):e.arguments===t.arguments)}Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostSCM=t.ExtHostSCMInputBox=void 0;class _{constructor(e,t,i){this._extension=e,this._proxy=t,this._sourceControlHandle=i,this._value="",this._onDidChange=new r.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(e){this._proxy.$setInputBoxValue(this._sourceControlHandle,e),this.updateValue(e)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(e){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,e),this._placeholder=e}
get validateInput(){if(!this._extension.enableProposedApi)throw new Error(`[${this._extension.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);return this._validateInput}set validateInput(e){if(!this._extension.enableProposedApi)throw new Error(`[${this._extension.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this._extension.identifier.value}`);if(e&&"function"!=typeof e)throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=e,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!e)}get visible(){return this._visible}set visible(e){e=!!e,this._visible!==e&&(this._visible=e,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,e))}$onInputBoxValueChange(e){this.updateValue(e)}updateValue(e){
this._value=e,this._onDidChange.fire(e)}}t.ExtHostSCMInputBox=_;let y=(()=>{class e{constructor(t,i,n,o,s){this._proxy=t,this._commands=i,this._sourceControlHandle=n,this._id=o,this._label=s,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._onDidUpdateResourceStates=new r.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._onDidDispose=new r.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=e._handlePool++,this._proxy.$registerGroup(n,this.handle,o,s)}get id(){return this._id}get label(){return this._label}set label(e){this._label=e,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,e)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(e){this._hideWhenEmpty=e,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,{hideWhenEmpty:e})}get resourceStates(){
return[...this._resourceStates]}set resourceStates(e){this._resourceStates=[...e],this._onDidUpdateResourceStates.fire()}getResourceState(e){return this._resourceStatesMap.get(e)}$executeResourceCommand(e,t){const i=this._resourceStatesCommandsMap.get(e);return i?c.asPromise(()=>this._commands.executeCommand(i.command,...i.arguments||[],t)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const e=[...this._resourceStates].sort(g),t=u.sortedDiff(this._resourceSnapshot,e,g).map(e=>{const t=e.toInsert.map(e=>{const t=this._resourceHandlePool++;this._resourceStatesMap.set(t,e);const i=e.resourceUri,n=m(e.decorations),r=e.decorations&&m(e.decorations.light)||n,o=e.decorations&&m(e.decorations.dark)||n,s=[];return e.command&&this._resourceStatesCommandsMap.set(t,e.command),r&&s.push(r),o&&o.toString()!==(null==r?void 0:r.toString())&&s.push(o),{rawResource:[t,i,s,e.decorations&&e.decorations.tooltip||"",e.decorations&&!!e.decorations.strikeThrough,e.decorations&&!!e.decorations.faded],handle:t}});return{
start:e.start,deleteCount:e.deleteCount,toInsert:t}}),i=t.map(({start:e,deleteCount:t,toInsert:i})=>[e,t,i.map(e=>e.rawResource)]),n=t.reverse();for(const{start:e,deleteCount:t,toInsert:i}of n){const n=i.map(e=>e.handle),r=this._handlesSnapshot.splice(e,t,...n);for(const e of r)this._resourceStatesMap.delete(e),this._resourceStatesCommandsMap.delete(e)}return this._resourceSnapshot=e,i}dispose(){this._proxy.$unregisterGroup(this._sourceControlHandle,this.handle),this._onDidDispose.fire()}}return e._handlePool=0,e})(),w=(()=>{class e{constructor(t,i,n,o,s,c){this._proxy=i,this._commands=n,this._id=o,this._label=s,this._rootUri=c,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new a.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new a.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new r.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,
this.handle=e._handlePool++,this.updatedResourceGroups=new Set,this._inputBox=new _(t,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,o,s,c)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(e){this._count!==e&&(this._count=e,this._proxy.$updateSourceControl(this.handle,{count:e}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(e){this._quickDiffProvider=e,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!e})}get commitTemplate(){return this._commitTemplate}set commitTemplate(e){e!==this._commitTemplate&&(this._commitTemplate=e,this._proxy.$updateSourceControl(this.handle,{commitTemplate:e}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(e){this._acceptInputDisposables.value=new a.DisposableStore,this._acceptInputCommand=e
;const t=this._commands.converter.toInternal(e,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:t})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(e){if(this._statusBarCommands&&e&&(t=this._statusBarCommands,i=e,u.equals(t,i,v)))return;var t,i;this._statusBarDisposables.value=new a.DisposableStore,this._statusBarCommands=e;const n=(e||[]).map(e=>this._commands.converter.toInternal(e,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:n})}get selected(){return this._selected}createResourceGroup(e,t){const i=new y(this._proxy,this._commands,this.handle,e,t),n=i.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(i),this.eventuallyUpdateResourceStates()});return r.Event.once(i.onDidDispose)(()=>{this.updatedResourceGroups.delete(i),n.dispose(),this._groups.delete(i.handle)}),this._groups.set(i.handle,i),i}eventuallyUpdateResourceStates(){const e=[]
;this.updatedResourceGroups.forEach(t=>{const i=t._takeResourceStateSnapshot();0!==i.length&&e.push([t.handle,i])}),e.length>0&&this._proxy.$spliceResourceStates(this.handle,e),this.updatedResourceGroups.clear()}getResourceGroup(e){return this._groups.get(e)}setSelectionState(e){this._selected=e,this._onDidChangeSelection.fire(e)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(e=>e.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}return e._handlePool=0,n([o.debounce(100)],e.prototype,"eventuallyUpdateResourceStates",null),e})(),b=(()=>{let e=class e{constructor(e,t,i){this._commands=t,this.logService=i,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new r.Emitter,this._selectedSourceControlHandles=new Set,this._proxy=e.getProxy(l.MainContext.MainThreadSCM),this._telemetry=e.getProxy(l.MainContext.MainThreadTelemetry),t.registerArgumentProcessor({processArgument:e=>{if(e&&3===e.$mid){
const t=this._sourceControls.get(e.sourceControlHandle);if(!t)return e;const i=t.getResourceGroup(e.groupHandle);return i?i.getResourceState(e.handle):e}if(e&&4===e.$mid){const t=this._sourceControls.get(e.sourceControlHandle);return t?t.getResourceGroup(e.groupHandle):e}if(e&&5===e.$mid){const t=this._sourceControls.get(e.handle);return t||e}return e}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(t,i,n,r){this.logService.trace("ExtHostSCM#createSourceControl",t.identifier.value,i,n,r),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:t.identifier.value});const o=e._handlePool++,s=new w(t,this._proxy,this._commands,i,n,r);this._sourceControls.set(o,s);const a=this._sourceControlsByExtension.get(p.ExtensionIdentifier.toKey(t.identifier))||[];return a.push(s),this._sourceControlsByExtension.set(p.ExtensionIdentifier.toKey(t.identifier),a),s}getLastInputBox(e){this.logService.trace("ExtHostSCM#getLastInputBox",e.identifier.value)
;const t=this._sourceControlsByExtension.get(p.ExtensionIdentifier.toKey(e.identifier)),i=t&&t[t.length-1];return i&&i.inputBox}$provideOriginalResource(e,t,n){const r=i.URI.revive(t);this.logService.trace("ExtHostSCM#$provideOriginalResource",e,r.toString());const o=this._sourceControls.get(e);return o&&o.quickDiffProvider&&o.quickDiffProvider.provideOriginalResource?c.asPromise(()=>o.quickDiffProvider.provideOriginalResource(r,n)).then(e=>e||null):Promise.resolve(null)}$onInputBoxValueChange(e,t){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",e);const i=this._sourceControls.get(e);return i?(i.inputBox.$onInputBoxValueChange(t),Promise.resolve(void 0)):Promise.resolve(void 0)}$executeResourceCommand(e,t,i,n){this.logService.trace("ExtHostSCM#$executeResourceCommand",e,t,i);const r=this._sourceControls.get(e);if(!r)return Promise.resolve(void 0);const o=r.getResourceGroup(t);return o?o.$executeResourceCommand(i,n):Promise.resolve(void 0)}$validateInput(e,t,i){
this.logService.trace("ExtHostSCM#$validateInput",e);const n=this._sourceControls.get(e);return n&&n.inputBox.validateInput?c.asPromise(()=>n.inputBox.validateInput(t,i)).then(e=>e?Promise.resolve([e.message,e.type]):Promise.resolve(void 0)):Promise.resolve(void 0)}$setSelectedSourceControls(e){this.logService.trace("ExtHostSCM#$setSelectedSourceControls",e);const t=new Set;for(const i of e)t.add(i);return t.forEach(e=>{if(!this._selectedSourceControlHandles.has(e)){const t=this._sourceControls.get(e);if(!t)return;t.setSelectionState(!0)}}),this._selectedSourceControlHandles.forEach(e=>{if(!t.has(e)){const t=this._sourceControls.get(e);if(!t)return;t.setSelectionState(!1)}}),this._selectedSourceControlHandles=t,Promise.resolve(void 0)}};return e._handlePool=0,e=n([s(2,h.ILogService)],e)})();t.ExtHostSCM=b})),define(t[211],i([1,0,10,5,153,6]),(function(e,t,i,n,r,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostStatusBar=t.ExtHostStatusBarEntry=void 0;let s=(()=>{class e{
constructor(t,n,r,s,a=i.StatusBarAlignment.Left,c,l){this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new o.DisposableStore,this._id=e.ID_GEN++,this._proxy=t,this._commands=n,this._statusId=r,this._statusName=s,this._alignment=a,this._priority=c,this._accessibilityInformation=l}get id(){return this._id}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get tooltip(){return this._tooltip}get color(){return this._color}get command(){var e;return null===(e=this._command)||void 0===e?void 0:e.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(e){this._text=e,this.update()}set tooltip(e){this._tooltip=e,this.update()}set color(e){this._color=e,this.update()}set command(e){var t;(null===(t=this._command)||void 0===t?void 0:t.fromApi)!==e&&(this._internalCommandRegistration.clear(),this._command="string"==typeof e?{fromApi:e,internal:this._commands.toInternal({title:"",command:e
},this._internalCommandRegistration)}:e?{fromApi:e,internal:this._commands.toInternal(e,this._internalCommandRegistration)}:void 0,this.update())}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,this._proxy.$dispose(this.id)}update(){!this._disposed&&this._visible&&(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{var e;this._timeoutHandle=void 0,this._proxy.$setEntry(this.id,this._statusId,this._statusName,this.text,this.tooltip,null===(e=this._command)||void 0===e?void 0:e.internal,this.color,this._alignment===i.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}return e.ID_GEN=0,e})();t.ExtHostStatusBarEntry=s;class a{constructor(e){this._messages=[],this._item=e.createStatusBarEntry("status.extensionMessage",r.localize(0,null),i.StatusBarAlignment.Left,Number.MIN_VALUE)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(e){const t={message:e}
;return this._messages.unshift(t),this._update(),new i.Disposable(()=>{const e=this._messages.indexOf(t);e>=0&&(this._messages.splice(e,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}t.ExtHostStatusBar=class{constructor(e,t){this._proxy=e.getProxy(n.MainContext.MainThreadStatusBar),this._commands=t,this._statusMessage=new a(this)}createStatusBarEntry(e,t,i,n,r){return new s(this._proxy,this._commands,e,t,i,n,r)}setStatusBarMessage(e,t){const n=this._statusMessage.setMessage(e);let r;return"number"==typeof t?r=setTimeout(()=>n.dispose(),t):void 0!==t&&t.then(()=>n.dispose(),()=>n.dispose()),new i.Disposable(()=>{n.dispose(),clearTimeout(r)})}}})),define(t[76],i([1,0,5,3,4]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostStorage=t.ExtHostStorage=void 0;t.ExtHostStorage=class{constructor(e){this._onDidChangeStorage=new n.Emitter,
this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=e.getProxy(i.MainContext.MainThreadStorage)}getValue(e,t,i){return this._proxy.$getValue(e,t).then(e=>e||i)}setValue(e,t,i){return this._proxy.$setValue(e,t,i)}$acceptValue(e,t,i){this._onDidChangeStorage.fire({shared:e,key:t,value:i})}},t.IExtHostStorage=r.createDecorator("IExtHostStorage")})),define(t[37],i([1,0,3,5,4,2,67,16,14,166,6,10]),(function(e,t,i,r,o,a,c,l,u,d,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WorkerExtHostTerminalService=t.EnvironmentVariableCollection=t.BaseExtHostTerminalService=t.ExtHostPseudoterminal=t.ExtHostTerminal=t.BaseExtHostTerminal=t.IExtHostTerminalService=void 0,t.IExtHostTerminalService=o.createDecorator("IExtHostTerminalService");class m{constructor(e,t){this._proxy=e,this._disposed=!1,this._queuedRequests=[],this._idPromise=new Promise(e=>{void 0!==t?(this._id=t,e(t)):this._idPromiseComplete=e})}dispose(){this._disposed||(this._disposed=!0,
this._queueApiRequest(this._proxy.$dispose,[]))}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}_queueApiRequest(e,t){const i=new g(e,t);this._id?i.run(this._proxy,this._id):this._queuedRequests.push(i)}_runQueuedRequests(e){this._id=e,this._idPromiseComplete&&(this._idPromiseComplete(e),this._idPromiseComplete=void 0),this._queuedRequests.forEach(t=>{t.run(this._proxy,e)}),this._queuedRequests.length=0}}t.BaseExtHostTerminal=m;class f extends m{constructor(e,t,i,n){super(e,n),this._creationOptions=t,this._name=i,this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(e=>this._pidPromiseComplete=e)}async create(e,t,i,n,r,o,s){const a=await this._proxy.$createTerminal({name:this._name,shellPath:e,shellArgs:t,cwd:i,env:n,waitOnExit:r,strictEnv:o,hideFromUser:s});this._name=a.name,this._runQueuedRequests(a.id)}async createExtensionTerminal(){const e=await this._proxy.$createTerminal({name:this._name,isExtensionTerminal:!0})
;return this._name=e.name,this._runQueuedRequests(e.id),e.id}get name(){return this._name||""}set name(e){this._name=e}get exitStatus(){return this._exitStatus}get dimensions(){if(void 0!==this._cols&&void 0!==this._rows)return{columns:this._cols,rows:this._rows}}setExitCode(e){this._exitStatus=Object.freeze({code:e})}setDimensions(e,t){return(e!==this._cols||t!==this._rows)&&(this._cols=e,this._rows=t,!0)}get processId(){return this._pidPromise}get creationOptions(){return this._creationOptions}sendText(e,t=!0){this._checkDisposed(),this._queueApiRequest(this._proxy.$sendText,[e,t])}show(e){this._checkDisposed(),this._queueApiRequest(this._proxy.$show,[e])}hide(){this._checkDisposed(),this._queueApiRequest(this._proxy.$hide,[])}_setProcessId(e){this._pidPromiseComplete?(this._pidPromiseComplete(e),this._pidPromiseComplete=void 0):this._pidPromise.then(t=>{t!==e&&(this._pidPromise=Promise.resolve(e))})}}t.ExtHostTerminal=f;class g{constructor(e,t){this._callback=e,this._args=t}run(e,t){
this._callback.apply(e,[t].concat(this._args))}}class v{constructor(e){this._pty=e,this._onProcessData=new i.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new i.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new i.Emitter,this._onProcessTitleChanged=new i.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new i.Emitter}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}shutdown(){this._pty.close()}input(e){this._pty.handleInput&&this._pty.handleInput(e)}resize(e,t){this._pty.setDimensions&&this._pty.setDimensions({columns:e,rows:t})}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(e){this._pty.onDidWrite(e=>this._onProcessData.fire(e)),this._pty.onDidClose&&this._pty.onDidClose(e=>{this._onProcessExit.fire(void 0===e?void 0:e)}),
this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(e=>this._onProcessOverrideDimensions.fire(e?{cols:e.columns,rows:e.rows}:e)),this._pty.open(e||void 0),this._onProcessReady.fire({pid:-1,cwd:""})}}t.ExtHostPseudoterminal=v;let _=(()=>{let e=class{constructor(e){this._terminals=[],this._terminalProcesses={},this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._linkHandlers=new Set,this._onDidCloseTerminal=new i.Emitter,this._onDidOpenTerminal=new i.Emitter,this._onDidChangeActiveTerminal=new i.Emitter,this._onDidChangeTerminalDimensions=new i.Emitter,this._proxy=e.getProxy(r.MainContext.MainThreadTerminalService),this._bufferer=new d.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new i.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()})}get activeTerminal(){return this._activeTerminal}get terminals(){return this._terminals
}get onDidCloseTerminal(){return this._onDidCloseTerminal&&this._onDidCloseTerminal.event}get onDidOpenTerminal(){return this._onDidOpenTerminal&&this._onDidOpenTerminal.event}get onDidChangeActiveTerminal(){return this._onDidChangeActiveTerminal&&this._onDidChangeActiveTerminal.event}get onDidChangeTerminalDimensions(){return this._onDidChangeTerminalDimensions&&this._onDidChangeTerminalDimensions.event}get onDidWriteTerminalData(){return this._onDidWriteTerminalData&&this._onDidWriteTerminalData.event}createExtensionTerminal(e){const t=new f(this._proxy,e,e.name),i=new v(e.pty);return t.createExtensionTerminal().then(e=>{const t=this._setupExtHostProcessListeners(e,i);this._terminalProcessDisposables[e]=t}),this._terminals.push(t),t}attachPtyToTerminal(e,t){if(!this._getTerminalByIdEventually(e))throw new Error(`Cannot resolve terminal with id ${e} for virtual process`);const i=new v(t),n=this._setupExtHostProcessListeners(e,i);this._terminalProcessDisposables[e]=n}async $acceptActiveTerminalChanged(e){
const t=this._activeTerminal;if(null===e)return this._activeTerminal=void 0,void(t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal));const i=await this._getTerminalByIdEventually(e);i&&(this._activeTerminal=i,t!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal))}async $acceptTerminalProcessData(e,t){const i=await this._getTerminalByIdEventually(e);i&&this._onDidWriteTerminalData.fire({terminal:i,data:t})}async $acceptTerminalDimensions(e,t,i){const n=await this._getTerminalByIdEventually(e);n&&n.setDimensions(t,i)&&this._onDidChangeTerminalDimensions.fire({terminal:n,dimensions:n.dimensions})}async $acceptTerminalMaximumDimensions(e,t,i){var n;await this._getTerminalByIdEventually(e),this._terminalProcesses[e]&&(null===(n=this._terminalProcesses[e])||void 0===n||n.resize(t,i))}async $acceptTerminalTitleChange(e,t){await this._getTerminalByIdEventually(e);const i=this._getTerminalObjectById(this.terminals,e);i&&(i.name=t)}
async $acceptTerminalClosed(e,t){await this._getTerminalByIdEventually(e);const i=this._getTerminalObjectIndexById(this.terminals,e);if(null!==i){const e=this._terminals.splice(i,1)[0];e.setExitCode(t),this._onDidCloseTerminal.fire(e)}}$acceptTerminalOpened(e,t,i){const n=this._getTerminalObjectIndexById(this._terminals,e);if(null!==n)return this._onDidOpenTerminal.fire(this.terminals[n]),void(this.terminals[n].isOpen=!0);const r={name:i.name,shellPath:i.executable,shellArgs:i.args,cwd:"string"==typeof i.cwd?i.cwd:a.URI.revive(i.cwd),env:i.env},o=new f(this._proxy,r,t,e);this._terminals.push(o),this._onDidOpenTerminal.fire(o),o.isOpen=!0}async $acceptTerminalProcessId(e,t){const i=await this._getTerminalByIdEventually(e);i&&i._setProcessId(t)}async $startExtensionTerminal(e,t){const i=await this._getTerminalByIdEventually(e);if(!i)return;let n;n=i.isOpen?Promise.resolve():new Promise(e=>{const t=this.onDidOpenTerminal(async n=>{n===i&&(t.dispose(),e())})}),await n,
this._terminalProcesses[e]?this._terminalProcesses[e].startSendingEvents(t):this._extensionTerminalAwaitingStart[e]={initialDimensions:t}}_setupExtHostProcessListeners(e,t){const i=new h.DisposableStore;i.add(t.onProcessReady(t=>this._proxy.$sendProcessReady(e,t.pid,t.cwd))),i.add(t.onProcessTitleChanged(t=>this._proxy.$sendProcessTitle(e,t))),this._bufferer.startBuffering(e,t.onProcessData),i.add(t.onProcessExit(t=>this._onProcessExit(e,t))),t.onProcessOverrideDimensions&&i.add(t.onProcessOverrideDimensions(t=>this._proxy.$sendOverrideDimensions(e,t))),this._terminalProcesses[e]=t;const n=this._extensionTerminalAwaitingStart[e];return n&&t instanceof v&&(t.startSendingEvents(n.initialDimensions),delete this._extensionTerminalAwaitingStart[e]),i}$acceptProcessInput(e,t){var i;null===(i=this._terminalProcesses[e])||void 0===i||i.input(t)}$acceptProcessResize(e,t,i){var n;try{null===(n=this._terminalProcesses[e])||void 0===n||n.resize(t,i)}catch(e){if("EPIPE"!==e.code&&"ERR_IPC_CHANNEL_CLOSED"!==e.code)throw e}
}$acceptProcessShutdown(e,t){var i;null===(i=this._terminalProcesses[e])||void 0===i||i.shutdown(t)}$acceptProcessRequestInitialCwd(e){var t;null===(t=this._terminalProcesses[e])||void 0===t||t.getInitialCwd().then(t=>this._proxy.$sendProcessInitialCwd(e,t))}$acceptProcessRequestCwd(e){var t;null===(t=this._terminalProcesses[e])||void 0===t||t.getCwd().then(t=>this._proxy.$sendProcessCwd(e,t))}$acceptProcessRequestLatency(e){return e}registerLinkHandler(e){return this._linkHandlers.add(e),1===this._linkHandlers.size&&this._proxy.$startHandlingLinks(),new p.Disposable(()=>{this._linkHandlers.delete(e),0===this._linkHandlers.size&&this._proxy.$stopHandlingLinks()})}async $handleLink(e,t){const i=this._getTerminalById(e);if(!i)return!1;const n=this._linkHandlers.values();let r=n.next();for(;!r.done;){if(await r.value.handleLink(i,t))return!0;r=n.next()}return!1}_onProcessExit(e,t){this._bufferer.stopBuffering(e),delete this._terminalProcesses[e],delete this._extensionTerminalAwaitingStart[e]
;const i=this._terminalProcessDisposables[e];i&&(i.dispose(),delete this._terminalProcessDisposables[e]),this._proxy.$sendProcessExit(e,t)}_getTerminalByIdEventually(e,t=5){return this._getTerminalPromises[e]||(this._getTerminalPromises[e]=this._createGetTerminalPromise(e,t)),this._getTerminalPromises[e]}_createGetTerminalPromise(e,t=5){return new Promise(i=>{if(0===t)return void i(void 0);const n=this._getTerminalById(e);n?i(n):l.timeout(2*c.EXT_HOST_CREATION_DELAY).then(()=>i(this._createGetTerminalPromise(e,t-1)))})}_getTerminalById(e){return this._getTerminalObjectById(this._terminals,e)}_getTerminalObjectById(e,t){const i=this._getTerminalObjectIndexById(e,t);return null!==i?e[i]:null}_getTerminalObjectIndexById(e,t){let i=null;return e.some((e,n)=>{return e._id===t&&(i=n,!0)}),i}};return e=n([s(0,u.IExtHostRpcService)],e)})();t.BaseExtHostTerminalService=_;t.EnvironmentVariableCollection=class{constructor(e){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new i.Emitter,
this.map=new Map(e)}get persistent(){return this._persistent}set persistent(e){this._persistent=e,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(e,t){this._setIfDiffers(e,{value:t,type:p.EnvironmentVariableMutatorType.Replace})}append(e,t){this._setIfDiffers(e,{value:t,type:p.EnvironmentVariableMutatorType.Append})}prepend(e,t){this._setIfDiffers(e,{value:t,type:p.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(e,t){const i=this.map.get(e);i&&i.value===t.value&&i.type===t.type||(this.map.set(e,t),this._onDidChangeCollection.fire())}get(e){return this.map.get(e)}forEach(e,t){this.map.forEach((i,n)=>e.call(t,n,i,this))}delete(e){this.map.delete(e),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}};t.WorkerExtHostTerminalService=class extends _{createTerminal(e,t,i){throw new Error("Not implemented")}createTerminalFromOptions(e){
throw new Error("Not implemented")}getDefaultShell(e,t){throw new Error("Not implemented")}getDefaultShellArgs(e,t){throw new Error("Not implemented")}$spawnExtHostProcess(e,t,i,n,r,o){throw new Error("Not implemented")}$getAvailableShells(){throw new Error("Not implemented")}async $getDefaultShellAndArgs(e){throw new Error("Not implemented")}$acceptWorkspacePermissionsChanged(e){}getEnvironmentVariableCollection(e,t){throw new Error("Not implemented")}$initEnvironmentVariableCollections(e){}}})),define(t[214],i([1,0,3,13,5,103,21,10]),(function(e,t,i,n,r,o,s,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostEditors=void 0;t.ExtHostEditors=class{constructor(e,t){this._onDidChangeTextEditorSelection=new i.Emitter,this._onDidChangeTextEditorOptions=new i.Emitter,this._onDidChangeTextEditorVisibleRanges=new i.Emitter,this._onDidChangeTextEditorViewColumn=new i.Emitter,this._onDidChangeActiveTextEditor=new i.Emitter,this._onDidChangeVisibleTextEditors=new i.Emitter,
this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=e.getProxy(r.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors=t,this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(e=>this._onDidChangeVisibleTextEditors.fire(e)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(e=>this._onDidChangeActiveTextEditor.fire(e))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(){return this._extHostDocumentsAndEditors.allEditors()}showTextDocument(e,t,i){let n;return n="number"==typeof t?{
position:s.ViewColumn.from(t),preserveFocus:i}:"object"==typeof t?{position:s.ViewColumn.from(t.viewColumn),preserveFocus:t.preserveFocus,selection:"object"==typeof t.selection?s.Range.from(t.selection):void 0,pinned:"boolean"==typeof t.preview?!t.preview:void 0}:{preserveFocus:!1},this._proxy.$tryShowTextDocument(e.uri,n).then(t=>{const i=t&&this._extHostDocumentsAndEditors.getEditor(t);if(i)return i;throw new Error(`Failed to show text document ${e.uri.toString()}, should show in editor #${t}`)})}createTextEditorDecorationType(e){return new o.TextEditorDecorationType(this._proxy,e)}applyWorkspaceEdit(e){const t=s.WorkspaceEdit.from(e,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(t)}$acceptEditorPropertiesChanged(e,t){const i=this._extHostDocumentsAndEditors.getEditor(e);if(!i)throw new Error("unknown text editor");if(t.options&&i._acceptOptions(t.options),t.selections){const e=t.selections.selections.map(s.Selection.to);i._acceptSelections(e)}if(t.visibleRanges){
const e=n.coalesce(t.visibleRanges.map(s.Range.to));i._acceptVisibleRanges(e)}if(t.options&&this._onDidChangeTextEditorOptions.fire({textEditor:i,options:Object.assign(Object.assign({},t.options),{lineNumbers:s.TextEditorLineNumbersStyle.to(t.options.lineNumbers)})}),t.selections){const e=a.TextEditorSelectionChangeKind.fromValue(t.selections.source),n=t.selections.selections.map(s.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:i,selections:n,kind:e})}if(t.visibleRanges){const e=n.coalesce(t.visibleRanges.map(s.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:i,visibleRanges:e})}}$acceptEditorPositionData(e){for(const t in e){const i=this._extHostDocumentsAndEditors.getEditor(t);if(!i)throw new Error("Unknown text editor");const n=s.ViewColumn.to(e[t]);i.viewColumn!==n&&(i._acceptViewColumn(n),this._onDidChangeTextEditorViewColumn.fire({textEditor:i,viewColumn:n}))}}getDiffInformation(e){return Promise.resolve(this._proxy.$getDiffInformation(e))}}}))
;var a=this&&this.__rest||function(e,t){var i={};for(var n in e)Object.prototype.hasOwnProperty.call(e,n)&&t.indexOf(n)<0&&(i[n]=e[n]);if(null!=e&&"function"==typeof Object.getOwnPropertySymbols){var r=0;for(n=Object.getOwnPropertySymbols(e);r<n.length;r++)t.indexOf(n[r])<0&&Object.prototype.propertyIsEnumerable.call(e,n[r])&&(i[n[r]]=e[n[r]])}return i};define(t[215],i([1,0,2,4,5,6,10]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTimeline=t.IExtHostTimeline=void 0,t.IExtHostTimeline=n.createDecorator("IExtHostTimeline");function c(e){return null==e?void 0:e.toString()}t.ExtHostTimeline=class{constructor(e,t){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=e.getProxy(r.MainContext.MainThreadTimeline),t.registerArgumentProcessor({processArgument:e=>{var t,n;if(e&&11===e.$mid){const r=void 0===e.uri?void 0:i.URI.revive(e.uri)
;return null===(n=null===(t=this._itemsBySourceAndUriMap.get(e.source))||void 0===t?void 0:t.get(c(r)))||void 0===n?void 0:n.get(e.handle)}return e}})}async $getTimeline(e,t,n,r,o){const s=this._providers.get(e);return null==s?void 0:s.provideTimeline(i.URI.revive(t),n,r,o)}registerTimelineProvider(e,t,i,n){const r=new o.DisposableStore,s=this.convertTimelineItem(t.id,n,r).bind(this);let a;t.onDidChange&&(a=t.onDidChange(e=>this._proxy.$emitTimelineChangeEvent(Object.assign(Object.assign({uri:void 0,reset:!0},e),{id:t.id})),this));const c=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore(Object.assign(Object.assign({},t),{scheme:e,onDidChange:void 0,async provideTimeline(e,i,n,o){var a;(null==o?void 0:o.resetCache)&&(r.clear(),null===(a=c.get(t.id))||void 0===a||a.clear());const l=await t.provideTimeline(e,i,n);if(null==l)return;const u=s(e,o);return Object.assign(Object.assign({},l),{source:t.id,items:l.items.map(u)})},dispose(){var e
;for(const i of c.values())null===(e=i.get(t.id))||void 0===e||e.clear();null==a||a.dispose(),r.dispose()}}))}convertTimelineItem(e,t,n){return(r,o)=>{let l;if(null==o?void 0:o.cacheResults){let t=this._itemsBySourceAndUriMap.get(e);void 0===t&&(t=new Map,this._itemsBySourceAndUriMap.set(e,t));const i=c(r);void 0===(l=t.get(i))&&(l=new Map,t.set(i,l))}return r=>{var o,c;const{iconPath:u}=r,d=a(r,["iconPath"]),h=`${e}|${null!==(o=r.id)&&void 0!==o?o:r.timestamp}`;let p,m,f;return null==l||l.set(h,r),r.iconPath&&(u instanceof s.ThemeIcon?f={id:u.id}:i.URI.isUri(u)?(p=u,m=u):({light:p,dark:m}=u)),Object.assign(Object.assign({},d),{id:null!==(c=d.id)&&void 0!==c?c:void 0,handle:h,source:e,command:r.command?t.toInternal(r.command,n):void 0,icon:p,iconDark:m,themeIcon:f,accessibilityInformation:r.accessibilityInformation})}}}registerTimelineProviderCore(e){if(this._providers.get(e.id))throw new Error(`Timeline Provider ${e.id} already exists.`);return this._proxy.$registerTimelineProvider({id:e.id,label:e.label,
scheme:e.scheme}),this._providers.set(e.id,e),o.toDisposable(()=>{var t;for(const i of this._itemsBySourceAndUriMap.values())null===(t=i.get(e.id))||void 0===t||t.clear();this._providers.delete(e.id),this._proxy.$unregisterTimelineProvider(e.id),e.dispose()})}}})),define(t[54],i([1,0,5,4,3,14]),(function(e,t,i,r,o,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTunnelService=t.IExtHostTunnelService=t.TunnelDto=void 0,function(e){e.fromApiTunnel=function(e){return{remoteAddress:e.remoteAddress,localAddress:e.localAddress}},e.fromServiceTunnel=function(e){return{remoteAddress:{host:e.tunnelRemoteHost,port:e.tunnelRemotePort},localAddress:e.localAddress}}}(t.TunnelDto||(t.TunnelDto={})),t.IExtHostTunnelService=r.createDecorator("IExtHostTunnelService");let c=(()=>{let e=class{constructor(e){this.onDidChangeTunnels=(new o.Emitter).event,this._proxy=e.getProxy(i.MainContext.MainThreadTunnelService)}async openTunnel(e){}async getTunnels(){return[]}async $findCandidatePorts(){return[]}
async $filterCandidates(e){return e.map(()=>!0)}async setTunnelExtensionFunctions(e){return await this._proxy.$tunnelServiceReady(),{dispose:()=>{}}}$forwardPort(e){}async $closeTunnel(e){}async $onDidTunnelsChange(){}};return e=n([s(0,a.IExtHostRpcService)],e)})();t.ExtHostTunnelService=c})),define(t[217],i([1,0,5,2,6,19,28]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostUrls=void 0;let a=(()=>{class e{constructor(e){this.handles=new Set,this.handlers=new Map,this._proxy=e.getProxy(i.MainContext.MainThreadUrls)}registerUriHandler(t,i){if(this.handles.has(s.ExtensionIdentifier.toKey(t)))throw new Error(`Protocol handler already registered for extension ${t}`);const n=e.HandlePool++;return this.handles.add(s.ExtensionIdentifier.toKey(t)),this.handlers.set(n,i),this._proxy.$registerUriHandler(n,t),r.toDisposable(()=>{this.handles.delete(s.ExtensionIdentifier.toKey(t)),this.handlers.delete(n),this._proxy.$unregisterUriHandler(n)})}$handleExternalUri(e,t){
const i=this.handlers.get(e);if(!i)return Promise.resolve(void 0);try{i.handleUri(n.URI.revive(t))}catch(e){o.onUnexpectedError(e)}return Promise.resolve(void 0)}async createAppUri(e){return n.URI.revive(await this._proxy.$createAppUri(e))}}return e.HandlePool=0,e})();t.ExtHostUrls=a}));r=this&&this.__classPrivateFieldSet||function(e,t,i){if(!t.has(e))throw new TypeError("attempted to set private field on non-instance");return t.set(e,i),i},o=this&&this.__classPrivateFieldGet||function(e,t){if(!t.has(e))throw new TypeError("attempted to get private field on non-instance");return t.get(e)};define(t[218],i([1,0,22,3,212,6,20,23,2,41,21,69,94,5,10]),(function(e,t,i,n,s,a,c,l,u,d,h,p,m,f,g){"use strict";var v,_,y,w,b,E,x,C,S,k,T,I,D,P,R,A,O,L,M,N,F,U,H,$;Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostWebviews=t.ExtHostWebviewEditor=t.ExtHostWebview=void 0;class W{constructor(e,t,i,o,s,a,c){v.set(this,void 0),_.set(this,void 0),y.set(this,void 0),w.set(this,void 0),b.set(this,void 0),E.set(this,void 0),
x.set(this,""),C.set(this,void 0),S.set(this,!1),k.set(this,!1),this._onMessageEmitter=new n.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,r(this,v,e),r(this,_,t),r(this,C,i),r(this,w,o),r(this,b,s),r(this,E,a),r(this,y,c)}dispose(){this._onMessageEmitter.dispose()}asWebviewUri(e){return r(this,k,!0),p.asWebviewUri(o(this,w),o(this,v),e)}get cspSource(){return o(this,w).webviewCspSource.replace("{{uuid}}",o(this,v))}get html(){return this.assertNotDisposed(),o(this,x)}set html(e){this.assertNotDisposed(),o(this,x)!==e&&(r(this,x,e),!o(this,k)&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(e)&&(r(this,k,!0),o(this,y).report("Webview vscode-resource: uris",o(this,E),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),o(this,_).$setHtml(o(this,v),e))}get options(){return this.assertNotDisposed(),o(this,C)}set options(e){this.assertNotDisposed(),o(this,_).$setOptions(o(this,v),G(o(this,E),o(this,b),e)),r(this,C,e)}postMessage(e){
return this.assertNotDisposed(),o(this,_).$postMessage(o(this,v),e)}assertNotDisposed(){if(o(this,S))throw new Error("Webview is disposed")}}t.ExtHostWebview=W,v=new WeakMap,_=new WeakMap,y=new WeakMap,w=new WeakMap,b=new WeakMap,E=new WeakMap,x=new WeakMap,C=new WeakMap,S=new WeakMap,k=new WeakMap;class z extends a.Disposable{constructor(e,t,i,s,a,c,l){super(),T.set(this,void 0),I.set(this,void 0),D.set(this,void 0),P.set(this,void 0),R.set(this,void 0),A.set(this,void 0),O.set(this,void 0),L.set(this,void 0),M.set(this,!0),N.set(this,!0),F.set(this,!1),U.set(this,this._register(new n.Emitter)),this.onDidDispose=o(this,U).event,H.set(this,this._register(new n.Emitter)),this.onDidChangeViewState=o(this,H).event,r(this,T,e),r(this,I,t),r(this,D,i),r(this,R,c),r(this,L,a),r(this,A,s),r(this,P,l)}dispose(){o(this,F)||(r(this,F,!0),o(this,U).fire(),o(this,I).$disposeWebview(o(this,T)),o(this,P).dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),o(this,P)}get viewType(){
return this.assertNotDisposed(),o(this,D)}get title(){return this.assertNotDisposed(),o(this,A)}set title(e){this.assertNotDisposed(),o(this,A)!==e&&(r(this,A,e),o(this,I).$setTitle(o(this,T),e))}get iconPath(){return this.assertNotDisposed(),o(this,O)}set iconPath(e){this.assertNotDisposed(),o(this,O)!==e&&(r(this,O,e),o(this,I).$setIconPath(o(this,T),u.URI.isUri(e)?{light:e,dark:e}:e))}get options(){return o(this,R)}get viewColumn(){if(this.assertNotDisposed(),!("number"==typeof o(this,L)&&o(this,L)<0))return o(this,L)}get active(){return this.assertNotDisposed(),o(this,N)}get visible(){return this.assertNotDisposed(),o(this,M)}_updateViewState(e){o(this,F)||this.active===e.active&&this.visible===e.visible&&this.viewColumn===e.viewColumn||(r(this,N,e.active),r(this,M,e.visible),r(this,L,e.viewColumn),o(this,H).fire({webviewPanel:this}))}postMessage(e){return this.assertNotDisposed(),o(this,I).$postMessage(o(this,T),e)}reveal(e,t){this.assertNotDisposed(),o(this,I).$reveal(o(this,T),{
viewColumn:e?h.ViewColumn.from(e):void 0,preserveFocus:!!t})}assertNotDisposed(){if(o(this,F))throw new Error("Webview is disposed")}}t.ExtHostWebviewEditor=z,T=new WeakMap,I=new WeakMap,D=new WeakMap,P=new WeakMap,R=new WeakMap,A=new WeakMap,O=new WeakMap,L=new WeakMap,M=new WeakMap,N=new WeakMap,F=new WeakMap,U=new WeakMap,H=new WeakMap;class B{constructor(e,t){this.document=e,this._storagePath=t,this._backupCounter=1,this._edits=new m.Cache("custom documents")}addEdit(e){return this._edits.add([e])}async undo(e,t){await this.getEdit(e).undo(),t||this.disposeBackup()}async redo(e,t){await this.getEdit(e).redo(),t||this.disposeBackup()}disposeEdits(e){for(const t of e)this._edits.delete(t)}getNewBackupUri(){return l.joinPath(u.URI.file(this._storagePath),function(e){const t=e.scheme===c.Schemas.file||e.scheme===c.Schemas.untitled?e.fsPath:e.toString();return s.hash(t)+""}(this.document.uri)+this._backupCounter++)}updateBackup(e){var t;null===(t=this._backup)||void 0===t||t.delete(),this._backup=e}
disposeBackup(){var e;null===(e=this._backup)||void 0===e||e.delete(),this._backup=void 0}getEdit(e){const t=this._edits.get(e,0);if(!t)throw new Error("No edit found");return t}}class j{constructor(){this._documents=new Map}get(e,t){return this._documents.get(this.key(e,t))}add(e,t,i){const n=this.key(e,t.uri);if(this._documents.has(n))throw new Error(`Document already exists for viewType:${e} resource:${t.uri}`);const r=new B(t,i);return this._documents.set(n,r),r}delete(e,t){const i=this.key(e,t.uri);this._documents.delete(i)}key(e,t){return`${e}@@@${t}`}}!function(e){e[e.Text=0]="Text",e[e.Custom=1]="Custom"}($||($={}));class V{constructor(){this._providers=new Map}addTextProvider(e,t,i){return this.add(0,e,t,i)}addCustomProvider(e,t,i){return this.add(1,e,t,i)}get(e){return this._providers.get(e)}add(e,t,i,n){if(this._providers.has(t))throw new Error(`Provider for viewType:${t} already registered`);return this._providers.set(t,{type:e,extension:i,provider:n}),
new g.Disposable(()=>this._providers.delete(t))}}class K{constructor(e,t,i,n,r,o,s){this.initData=t,this.workspace=i,this._logService=n,this._deprecationService=r,this._extHostDocuments=o,this._extensionStoragePaths=s,this._webviewPanels=new Map,this._serializers=new Map,this._editorProviders=new V,this._documents=new j,this._proxy=e.getProxy(f.MainContext.MainThreadWebviews)}static newHandle(){return d.generateUuid()}createWebviewPanel(e,t,i,n,r={}){const o="object"==typeof n?n.viewColumn:n,s={viewColumn:h.ViewColumn.from(o),preserveFocus:"object"==typeof n&&!!n.preserveFocus},a=K.newHandle();this._proxy.$createWebviewPanel(q(e),a,t,i,s,G(e,this.workspace,r));const c=new W(a,this._proxy,r,this.initData,this.workspace,e,this._deprecationService),l=new z(a,this._proxy,t,i,o,r,c);return this._webviewPanels.set(a,l),l}registerWebviewPanelSerializer(e,t,i){if(this._serializers.has(t))throw new Error(`Serializer for '${t}' already registered`);return this._serializers.set(t,{serializer:i,extension:e}),
this._proxy.$registerSerializer(t),new g.Disposable(()=>{this._serializers.delete(t),this._proxy.$unregisterSerializer(t)})}registerCustomEditorProvider(e,t,i,n){const r=new a.DisposableStore;return"resolveCustomTextEditor"in i?(r.add(this._editorProviders.addTextProvider(t,e,i)),this._proxy.$registerTextEditorProvider(q(e),t,n.webviewOptions||{},{supportsMove:!!i.moveCustomTextEditor})):(r.add(this._editorProviders.addCustomProvider(t,e,i)),this.supportEditing(i)&&r.add(i.onDidChangeCustomDocument(e=>{const i=this.getCustomDocumentEntry(t,e.document.uri);if(function(e){return"function"==typeof e.undo&&"function"==typeof e.redo}(e)){const n=i.addEdit(e);this._proxy.$onDidEdit(e.document.uri,t,n,e.label)}else this._proxy.$onContentChange(e.document.uri,t)})),this._proxy.$registerCustomEditorProvider(q(e),t,n.webviewOptions||{},!!n.supportsMultipleEditorsPerDocument)),g.Disposable.from(r,new g.Disposable(()=>{this._proxy.$unregisterEditorProvider(t)}))}$onMessage(e,t){const i=this.getWebviewPanel(e)
;i&&i.webview._onMessageEmitter.fire(t)}$onMissingCsp(e,t){this._logService.warn(`${t} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}$onDidChangeWebviewPanelViewStates(e){const t=Object.keys(e);t.sort((t,i)=>{const n=e[t],r=e[i];return n.active?1:r.active?-1:+n.visible-+r.visible});for(const i of t){const t=this.getWebviewPanel(i);if(!t)continue;const n=e[i];t._updateViewState({active:n.active,visible:n.visible,viewColumn:h.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(e){const t=this.getWebviewPanel(e);t&&(t.dispose(),this._webviewPanels.delete(e))}async $deserializeWebviewPanel(e,t,i,n,r,o){const s=this._serializers.get(t);if(!s)throw new Error(`No serializer found for '${t}'`);const{serializer:a,extension:c}=s,l=new W(e,this._proxy,X(o),this.initData,this.workspace,c,this._deprecationService),u=new z(e,this._proxy,t,i,"number"==typeof r&&r>=0?h.ViewColumn.to(r):void 0,o,l);this._webviewPanels.set(e,u),await a.deserializeWebviewPanel(u,n)}
async $createCustomDocument(e,t,i,n){var r,o,s;const a=this._editorProviders.get(t);if(!a)throw new Error(`No provider found for '${t}'`);if(1!==a.type)throw new Error(`Invalid provide type for '${t}'`);const c=u.URI.revive(e),l=await a.provider.openCustomDocument(c,{backupId:i},n),d=null!==(o=null===(r=this._extensionStoragePaths)||void 0===r?void 0:r.workspaceValue(a.extension))&&void 0!==o?o:null===(s=this._extensionStoragePaths)||void 0===s?void 0:s.globalValue(a.extension);return this._documents.add(t,l,d),{editable:this.supportEditing(a.provider)}}async $disposeCustomDocument(e,t){const i=this._editorProviders.get(t);if(!i)throw new Error(`No provider found for '${t}'`);if(1!==i.type)throw new Error(`Invalid provider type for '${t}'`);const n=u.URI.revive(e),{document:r}=this.getCustomDocumentEntry(t,n);this._documents.delete(t,r),r.dispose()}async $resolveWebviewEditor(e,t,i,n,r,o,s){const a=this._editorProviders.get(i);if(!a)throw new Error(`No provider found for '${i}'`)
;const c=new W(t,this._proxy,X(o),this.initData,this.workspace,a.extension,this._deprecationService),l=new z(t,this._proxy,i,n,"number"==typeof r&&r>=0?h.ViewColumn.to(r):void 0,o,c);this._webviewPanels.set(t,l);const d=u.URI.revive(e);switch(a.type){case 1:{const{document:e}=this.getCustomDocumentEntry(i,d);return a.provider.resolveCustomEditor(e,l,s)}case 0:{const e=this._extHostDocuments.getDocument(d);return a.provider.resolveCustomTextEditor(e,l,s)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(e,t,i){this.getCustomDocumentEntry(t,e).disposeEdits(i)}async $onMoveCustomEditor(e,t,n){const r=this._editorProviders.get(n);if(!r)throw new Error(`No provider found for '${n}'`);if(!r.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const o=this.getWebviewPanel(e);if(!o)throw new Error("No webview found");const s=u.URI.revive(t),a=this._extHostDocuments.getDocument(s);await r.provider.moveCustomTextEditor(a,o,i.CancellationToken.None)}
async $undo(e,t,i,n){return this.getCustomDocumentEntry(t,e).undo(i,n)}async $redo(e,t,i,n){return this.getCustomDocumentEntry(t,e).redo(i,n)}async $revert(e,t,i){const n=this.getCustomDocumentEntry(t,e),r=this.getCustomEditorProvider(t);await r.revertCustomDocument(n.document,i),n.disposeBackup()}async $onSave(e,t,i){const n=this.getCustomDocumentEntry(t,e),r=this.getCustomEditorProvider(t);await r.saveCustomDocument(n.document,i),n.disposeBackup()}async $onSaveAs(e,t,i,n){const r=this.getCustomDocumentEntry(t,e);return this.getCustomEditorProvider(t).saveCustomDocumentAs(r.document,u.URI.revive(i),n)}async $backup(e,t,i){const n=this.getCustomDocumentEntry(t,e),r=this.getCustomEditorProvider(t),o=await r.backupCustomDocument(n.document,{destination:n.getNewBackupUri()},i);return n.updateBackup(o),o.id}getWebviewPanel(e){return this._webviewPanels.get(e)}getCustomDocumentEntry(e,t){const i=this._documents.get(e,u.URI.revive(t));if(!i)throw new Error("No custom document found");return i}
getCustomEditorProvider(e){const t=this._editorProviders.get(e),i=null==t?void 0:t.provider;if(!i||!this.supportEditing(i))throw new Error("Custom document is not editable");return i}supportEditing(e){return!!e.onDidChangeCustomDocument}}function q(e){return{id:e.identifier,location:e.extensionLocation}}function G(e,t,i){return Object.assign(Object.assign({},i),{localResourceRoots:i.localResourceRoots||Q(e,t)})}function X(e){var t;return Object.assign(Object.assign({},e),{localResourceRoots:null===(t=e.localResourceRoots)||void 0===t?void 0:t.map(e=>u.URI.from(e))})}function Q(e,t){return[...((null==t?void 0:t.getWorkspaceFolders())||[]).map(e=>e.uri),e.extensionLocation]}t.ExtHostWebviews=K})),define(t[219],i([1,0,3,5,2,20,8]),(function(e,t,i,n,r,o,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostWindow=void 0;let a=(()=>{class e{constructor(t){this._onDidChangeWindowState=new i.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=e.InitialState,
this._proxy=t.getProxy(n.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(e=>this.$onDidChangeWindowFocus(e))}get state(){return this._state}$onDidChangeWindowFocus(e){e!==this._state.focused&&(this._state=Object.assign(Object.assign({},this._state),{focused:e}),this._onDidChangeWindowState.fire(this._state))}openUri(e,t){let i;if("string"==typeof e){i=e;try{e=r.URI.parse(e)}catch(t){return Promise.reject(`Invalid uri - '${e}'`)}}return s.isFalsyOrWhitespace(e.scheme)?Promise.reject("Invalid scheme - cannot be empty"):e.scheme===o.Schemas.command?Promise.reject(`Invalid scheme '${e.scheme}'`):this._proxy.$openUri(e,i,t)}async asExternalUri(e,t){if(s.isFalsyOrWhitespace(e.scheme))return Promise.reject("Invalid scheme - cannot be empty");if(!new Set([o.Schemas.http,o.Schemas.https]).has(e.scheme))return Promise.reject(`Invalid scheme '${e.scheme}'`);const i=await this._proxy.$asExternalUri(e,t);return r.URI.from(i)}}return e.InitialState={focused:!0},e})();t.ExtHostWindow=a})),
define(t[220],i([1,0,92,221,35,43,2,61,11]),(function(e,t,i,r,o,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CLIServer=void 0;let d=(()=>{let e=class{constructor(e,t){this._commands=e,this.logService=t,this._server=r.createServer((e,t)=>this.onRequest(e,t)),this.setup().catch(e=>(t.error(e),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){this._ipcHandlePath=i.generateRandomPipeName();try{this._server.listen(this.ipcHandlePath),this._server.on("error",e=>this.logService.error(e))}catch(e){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(e,t){const i=[];e.setEncoding("utf8"),e.on("data",e=>i.push(e)),e.on("end",()=>{const e=JSON.parse(i.join(""));switch(e.type){case"open":this.open(e,t);break;case"status":this.getStatus(e,t);break;case"command":this.runCommand(e,t).catch(this.logService.error);break;default:t.writeHead(404),t.write(`Unknown message type: ${e.type}`,e=>{e&&this.logService.error(e)}),t.end()}})}
open(e,t){let{fileURIs:i,folderURIs:n,forceNewWindow:r,diffMode:o,addMode:s,forceReuseWindow:a,gotoLineMode:u,waitMarkerFilePath:d}=e;const h=[];if(Array.isArray(n))for(const e of n)try{h.push({folderUri:c.URI.parse(e)})}catch(e){}if(Array.isArray(i))for(const e of i)try{l.hasWorkspaceFileExtension(e)?h.push({workspaceUri:c.URI.parse(e)}):h.push({fileUri:c.URI.parse(e)})}catch(e){}if(h.length){const e=d?c.URI.file(d):void 0,t={forceNewWindow:r,diffMode:o,addMode:s,gotoLineMode:u,forceReuseWindow:a,preferNewWindow:!a&&!e&&!s,waitMarkerFileURI:e};this._commands.executeCommand("_files.windowOpen",h,t)}t.writeHead(200),t.end()}async getStatus(e,t){try{const e=await this._commands.executeCommand("_issues.getSystemStatus");t.writeHead(200),t.write(e),t.end()}catch(e){t.writeHead(500),t.write(String(e),e=>{e&&this.logService.error(e)}),t.end()}}async runCommand(e,t){try{const{command:i,args:n}=e,r=await this._commands.executeCommand(i,...n);t.writeHead(200),t.write(JSON.stringify(r),e=>{e&&this.logService.error(e)
}),t.end()}catch(e){t.writeHead(500),t.write(String(e),e=>{e&&this.logService.error(e)}),t.end()}}dispose(){this._server.close(),this._ipcHandlePath&&"win32"!==process.platform&&o.existsSync(this._ipcHandlePath)&&o.unlinkSync(this._ipcHandlePath)}};return e=n([s(0,a.IExtHostCommands),s(1,u.ILogService)],e)})();t.CLIServer=d})),define(t[222],i([1,0,7,40,41,43,6,5,2,14]),(function(e,t,i,r,o,a,c,l,u,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDownloadService=void 0;let h=(()=>{let e=class extends c.Disposable{constructor(e,t){super();const n=e.getProxy(l.MainContext.MainThreadDownloadService);t.registerCommand(!1,"_workbench.downloadResource",async e=>{const t=u.URI.file(i.join(r.tmpdir(),o.generateUuid()));return await n.$download(e,t),t})}};return e=n([s(0,d.IExtHostRpcService),s(1,a.IExtHostCommands)],e)})();t.ExtHostDownloadService=h})),define(t[223],i([1,0,5,14,6,25,2,32,23,35,9,54,16,3]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f){"use strict";Object.defineProperty(t,"__esModule",{
value:!0}),t.ExtHostTunnelService=void 0;class g{constructor(e,t,i){this.remoteAddress=e,this.localAddress=t,this._dispose=i,this._onDispose=new f.Emitter,this.onDidDispose=this._onDispose.event}dispose(){this._onDispose.fire(),this._dispose()}}let v=(()=>{let e=class extends o.Disposable{constructor(e,t){super(),this._showCandidatePort=()=>Promise.resolve(!0),this._extensionTunnels=new Map,this._onDidChangeTunnels=new f.Emitter,this.onDidChangeTunnels=this._onDidChangeTunnels.event,this._proxy=e.getProxy(i.MainContext.MainThreadTunnelService),t.remote.isRemote&&t.remote.authority&&this.registerCandidateFinder()}async openTunnel(e){const t=await this._proxy.$openTunnel(e);if(t){const e=new g(t.remoteAddress,t.localAddress,()=>this._proxy.$closeTunnel(t.remoteAddress));return this._register(e),e}}async getTunnels(){return this._proxy.$getTunnels()}registerCandidateFinder(){return this._proxy.$registerCandidateFinder()}$filterCandidates(e){
return Promise.all(e.map(e=>this._showCandidatePort(e.host,e.port,e.detail)))}async setTunnelExtensionFunctions(e){return e?(e.showCandidatePort&&(this._showCandidatePort=e.showCandidatePort,await this._proxy.$setCandidateFilter()),e.tunnelFactory&&(this._forwardPortProvider=e.tunnelFactory,await this._proxy.$setTunnelProvider())):this._forwardPortProvider=void 0,await this._proxy.$tunnelServiceReady(),o.toDisposable(()=>{this._forwardPortProvider=void 0})}async $closeTunnel(e){if(this._extensionTunnels.has(e.host)){const t=this._extensionTunnels.get(e.host);t.has(e.port)&&(t.get(e.port).dispose(),t.delete(e.port))}}async $onDidTunnelsChange(){this._onDidChangeTunnels.fire()}$forwardPort(e){if(this._forwardPortProvider){const t=this._forwardPortProvider(e);if(void 0!==t)return m.asPromise(()=>t).then(t=>(this._extensionTunnels.has(e.remoteAddress.host)||this._extensionTunnels.set(e.remoteAddress.host,new Map),this._extensionTunnels.get(e.remoteAddress.host).set(e.remoteAddress.port,t),
this._register(t.onDidDispose(()=>this._proxy.$closeTunnel(t.remoteAddress))),Promise.resolve(p.TunnelDto.fromApiTunnel(t))))}}async $findCandidatePorts(){if(!h.isLinux)return[];const e=[];let t="",i="";try{t=d.readFileSync("/proc/net/tcp","utf8"),i=d.readFileSync("/proc/net/tcp6","utf8")}catch(e){}const n=await new Promise(e=>{l.exec("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(t,i,n)=>{e(i)})}),r=d.readdirSync("/proc"),o=[];for(let e of r)try{const t=Number(e),i=u.joinPath(c.URI.file("/proc"),e);if(d.statSync(i.fsPath).isDirectory()&&!isNaN(t)){const e=d.readlinkSync(u.joinPath(i,"cwd").fsPath),n=d.readFileSync(u.joinPath(i,"cmdline").fsPath,"utf8");o.push({pid:t,cwd:e,cmd:n})}}catch(e){}const s=this.loadListeningPorts(t,i),a=this.getSockets(n).reduce((e,t)=>(e[t.socket]=t,e),{}),p=o.reduce((e,t)=>(e[t.pid]=t,e),{});return s.filter(e=>a[e.socket]).forEach(({socket:t,ip:i,port:n})=>{const r=p[a[t].pid].cmd;r.match(".*.vscode-server-[a-zA-Z]+/bin.*")||-1!==r.indexOf("out/vs/server/main.js")||e.push({host:i,
port:n,detail:p[a[t].pid].cmd})}),e}getSockets(e){return e.trim().split("\n").map(e=>{const t=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(e);return{pid:parseInt(t[1],10),socket:parseInt(t[2],10)}})}loadListeningPorts(...e){const t=[].concat(...e.map(this.loadConnectionTable));return[...new Map(t.filter(e=>"0A"===e.st).map(e=>{const t=e.local_address.split(":");return{socket:parseInt(e.inode,10),ip:this.parseIpAddress(t[0]),port:parseInt(t[1],16)}}).map(e=>[e.ip+":"+e.port,e])).values()]}parseIpAddress(e){let t="";if(8===e.length)for(let i=e.length-2;i>=0;i-=2)t+=parseInt(e.substr(i,2),16),0!==i&&(t+=".");else for(let i=e.length-4;i>=0;i-=4)t+=parseInt(e.substr(i,4),16).toString(16),0!==i&&(t+=":");return t}loadConnectionTable(e){const t=e.trim().split("\n"),i=t.shift().trim().split(/\s+/).filter(e=>"rx_queue"!==e&&"tm->when"!==e);return t.map(e=>e.trim().split(/\s+/).reduce((e,t,n)=>(e[i[n]||n]=t,e),{}))}};return e=n([s(0,r.IExtHostRpcService),s(1,a.IExtHostInitDataService)],e)})()
;t.ExtHostTunnelService=v})),define(t[224],i([1,0,16,22,19,3,6,102,187,105,29]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";function d(e,t){try{return JSON.stringify(e,t)}catch(e){return"null"}}function h(e,t){return JSON.stringify(e,t)}Object.defineProperty(t,"__esModule",{value:!0}),t.RPCProtocol=t.ResponsiveState=t.RequestInitiator=void 0,function(e){e[e.LocalSide=0]="LocalSide",e[e.OtherSide=1]="OtherSide"}(t.RequestInitiator||(t.RequestInitiator={})),function(e){e[e.Responsive=0]="Responsive",e[e.Unresponsive=1]="Unresponsive"}(t.ResponsiveState||(t.ResponsiveState={}));const p=()=>{};let m=(()=>{class e extends s.Disposable{constructor(e,t=null,n=null){super(),this._onDidChangeResponsiveState=this._register(new o.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=e,this._logger=t,this._uriTransformer=n,this._uriReplacer=function(e){return e?(t,i)=>i&&1===i.$mid?e.transformOutgoing(i):i:null}(this._uriTransformer),this._isDisposed=!1,this._locals=[],
this._proxies=[];for(let e=0,t=l.ProxyIdentifier.count;e<t;e++)this._locals[e]=null,this._proxies[e]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new i.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(e=>this._receiveOneMessage(e))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(e=>{this._pendingRPCReplies[e].resolveErr(r.canceled())})}_onWillSendRequest(t){0===this._unacknowledgedCount&&(this._unresponsiveTime=Date.now()+e.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(t){this._unresponsiveTime=Date.now()+e.UNRESPONSIVE_TIME,this._unacknowledgedCount--,0===this._unacknowledgedCount&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){
0!==this._unacknowledgedCount&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(e){this._responsiveState!==e&&(this._responsiveState=e,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(e){return this._uriTransformer?a.transformIncomingURIs(e,this._uriTransformer):e}getProxy(e){const t=e.nid;return this._proxies[t]||(this._proxies[t]=this._createProxy(t)),this._proxies[t]}_createProxy(e){let t={get:(t,i)=>("string"!=typeof i||t[i]||36!==i.charCodeAt(0)||(t[i]=(...t)=>this._remoteCall(e,i,t)),t[i])};return new Proxy(Object.create(null),t)}set(e,t){return this._locals[e.nid]=t,t}assertRegistered(e){for(let t=0,i=e.length;t<i;t++){const i=e[t];if(!this._locals[i.nid])throw new Error(`Missing actor ${i.sid} (isMain: ${i.isMain})`)}}_receiveOneMessage(e){if(this._isDisposed)return;const t=e.byteLength,i=f.read(e,0),n=i.readUInt8(),r=i.readUInt32();switch(n){
case 1:case 2:{let{rpcId:e,method:o,args:s}=g.deserializeRequestJSONArgs(i);this._uriTransformer&&(s=a.transformIncomingURIs(s,this._uriTransformer)),this._receiveRequest(t,r,e,o,s,2===n);break}case 3:case 4:{let{rpcId:e,method:o,args:s}=g.deserializeRequestMixedArgs(i);this._uriTransformer&&(s=a.transformIncomingURIs(s,this._uriTransformer)),this._receiveRequest(t,r,e,o,s,4===n);break}case 5:this._logger&&this._logger.logIncoming(t,r,0,"ack"),this._onDidReceiveAcknowledge(r);break;case 6:this._receiveCancel(t,r);break;case 7:this._receiveReply(t,r,void 0);break;case 9:{let e=g.deserializeReplyOKJSON(i);this._uriTransformer&&(e=a.transformIncomingURIs(e,this._uriTransformer)),this._receiveReply(t,r,e);break}case 8:{let e=g.deserializeReplyOKVSBuffer(i);this._receiveReply(t,r,e);break}case 10:{let e=g.deserializeReplyErrError(i);this._uriTransformer&&(e=a.transformIncomingURIs(e,this._uriTransformer)),this._receiveReplyErr(t,r,e);break}case 11:this._receiveReplyErr(t,r,void 0);break;default:
console.error("received unexpected message"),console.error(e)}}_receiveRequest(e,t,i,r,o,s){this._logger&&this._logger.logIncoming(e,t,1,`receiveRequest ${l.getStringIdentifierForProxy(i)}.${r}(`,o);const a=String(t);let c,u;if(s){const e=new n.CancellationTokenSource;o.push(e.token),c=this._invokeHandler(i,r,o),u=()=>e.cancel()}else c=this._invokeHandler(i,r,o),u=p;this._cancelInvokedHandlers[a]=u;const d=g.serializeAcknowledged(t);this._logger&&this._logger.logOutgoing(d.byteLength,t,1,"ack"),this._protocol.send(d),c.then(e=>{delete this._cancelInvokedHandlers[a];const i=g.serializeReplyOK(t,e,this._uriReplacer);this._logger&&this._logger.logOutgoing(i.byteLength,t,1,"reply:",e),this._protocol.send(i)},e=>{delete this._cancelInvokedHandlers[a];const i=g.serializeReplyErr(t,e);this._logger&&this._logger.logOutgoing(i.byteLength,t,1,"replyErr:",e),this._protocol.send(i)})}_receiveCancel(e,t){this._logger&&this._logger.logIncoming(e,t,1,"receiveCancel");const i=String(t)
;this._cancelInvokedHandlers[i]&&this._cancelInvokedHandlers[i]()}_receiveReply(e,t,i){this._logger&&this._logger.logIncoming(e,t,0,"receiveReply:",i);const n=String(t);if(!this._pendingRPCReplies.hasOwnProperty(n))return;const r=this._pendingRPCReplies[n];delete this._pendingRPCReplies[n],r.resolveOk(i)}_receiveReplyErr(e,t,i){this._logger&&this._logger.logIncoming(e,t,0,"receiveReplyErr:",i);const n=String(t);if(!this._pendingRPCReplies.hasOwnProperty(n))return;const r=this._pendingRPCReplies[n];delete this._pendingRPCReplies[n];let o=void 0;i&&(i.$isError?((o=new Error).name=i.name,o.message=i.message,o.stack=i.stack):o=i),r.resolveErr(o)}_invokeHandler(e,t,i){try{return Promise.resolve(this._doInvokeHandler(e,t,i))}catch(e){return Promise.reject(e)}}_doInvokeHandler(e,t,i){const n=this._locals[e];if(!n)throw new Error("Unknown actor "+l.getStringIdentifierForProxy(e));let r=n[t];if("function"!=typeof r)throw new Error("Unknown method "+t+" on actor "+l.getStringIdentifierForProxy(e));return r.apply(n,i)}
_remoteCall(e,t,i){if(this._isDisposed)return Promise.reject(r.canceled());let o=null;if(i.length>0&&n.CancellationToken.isCancellationToken(i[i.length-1])&&(o=i.pop()),o&&o.isCancellationRequested)return Promise.reject(r.canceled());const s=g.serializeRequestArguments(i,this._uriReplacer),a=++this._lastMessageId,u=String(a),d=new c.LazyPromise;o&&o.onCancellationRequested(()=>{const e=g.serializeCancel(a);this._logger&&this._logger.logOutgoing(e.byteLength,a,0,"cancel"),this._protocol.send(g.serializeCancel(a))}),this._pendingRPCReplies[u]=d,this._onWillSendRequest(a);const h=g.serializeRequest(a,e,t,s,!!o);return this._logger&&this._logger.logOutgoing(h.byteLength,a,0,`request: ${l.getStringIdentifierForProxy(e)}.${t}(`,i),this._protocol.send(h),d}}return e.UNRESPONSIVE_TIME=3e3,e})();t.RPCProtocol=m;class f{constructor(e,t){this._buff=e,this._offset=t}static alloc(e,t,i){let n=new f(u.VSBuffer.alloc(i+1+4),0);return n.writeUInt8(e),n.writeUInt32(t),n}static read(e,t){return new f(e,t)}get buffer(){
return this._buff}static sizeUInt8(){return 1}writeUInt8(e){this._buff.writeUInt8(e,this._offset),this._offset+=1}readUInt8(){const e=this._buff.readUInt8(this._offset);return this._offset+=1,e}writeUInt32(e){this._buff.writeUInt32BE(e,this._offset),this._offset+=4}readUInt32(){const e=this._buff.readUInt32BE(this._offset);return this._offset+=4,e}static sizeShortString(e){return 1+e.byteLength}writeShortString(e){this._buff.writeUInt8(e.byteLength,this._offset),this._offset+=1,this._buff.set(e,this._offset),this._offset+=e.byteLength}readShortString(){const e=this._buff.readUInt8(this._offset);this._offset+=1;const t=this._buff.slice(this._offset,this._offset+e).toString();return this._offset+=e,t}static sizeLongString(e){return 4+e.byteLength}writeLongString(e){this._buff.writeUInt32BE(e.byteLength,this._offset),this._offset+=4,this._buff.set(e,this._offset),this._offset+=e.byteLength}readLongString(){const e=this._buff.readUInt32BE(this._offset);this._offset+=4
;const t=this._buff.slice(this._offset,this._offset+e).toString();return this._offset+=e,t}writeBuffer(e){this._buff.writeUInt32BE(e.byteLength,this._offset),this._offset+=4,this._buff.set(e,this._offset),this._offset+=e.byteLength}static sizeVSBuffer(e){return 4+e.byteLength}writeVSBuffer(e){this._buff.writeUInt32BE(e.byteLength,this._offset),this._offset+=4,this._buff.set(e,this._offset),this._offset+=e.byteLength}readVSBuffer(){const e=this._buff.readUInt32BE(this._offset);this._offset+=4;const t=this._buff.slice(this._offset,this._offset+e);return this._offset+=e,t}static sizeMixedArray(e,t){let i=0;i+=1;for(let n=0,r=e.length;n<r;n++){const r=e[n];switch(i+=1,t[n]){case 1:i+=this.sizeLongString(r);break;case 2:i+=this.sizeVSBuffer(r)}}return i}writeMixedArray(e,t){this._buff.writeUInt8(e.length,this._offset),this._offset+=1;for(let i=0,n=e.length;i<n;i++){const n=e[i];switch(t[i]){case 1:this.writeUInt8(1),this.writeLongString(n);break;case 2:this.writeUInt8(2),this.writeVSBuffer(n);break;case 3:
this.writeUInt8(3)}}}readMixedArray(){const e=this._buff.readUInt8(this._offset);this._offset+=1;let t=new Array(e);for(let i=0;i<e;i++){switch(this.readUInt8()){case 1:t[i]=this.readLongString();break;case 2:t[i]=this.readVSBuffer();break;case 3:t[i]=void 0}}return t}}class g{static _arrayContainsBufferOrUndefined(e){for(let t=0,i=e.length;t<i;t++){if(e[t]instanceof u.VSBuffer)return!0;if(void 0===e[t])return!0}return!1}static serializeRequestArguments(e,t){if(this._arrayContainsBufferOrUndefined(e)){let i=[],n=[];for(let r=0,o=e.length;r<o;r++){const o=e[r];o instanceof u.VSBuffer?(i[r]=o,n[r]=2):void 0===o?(i[r]=u.VSBuffer.alloc(0),n[r]=3):(i[r]=u.VSBuffer.fromString(h(o,t)),n[r]=1)}return{type:"mixed",args:i,argsType:n}}return{type:"simple",args:h(e,t)}}static serializeRequest(e,t,i,n,r){return"mixed"===n.type?this._requestMixedArgs(e,t,i,n.args,n.argsType,r):this._requestJSONArgs(e,t,i,n.args,r)}static _requestJSONArgs(e,t,i,n,r){const o=u.VSBuffer.fromString(i),s=u.VSBuffer.fromString(n);let a=0
;a+=f.sizeUInt8(),a+=f.sizeShortString(o),a+=f.sizeLongString(s);let c=f.alloc(r?2:1,e,a);return c.writeUInt8(t),c.writeShortString(o),c.writeLongString(s),c.buffer}static deserializeRequestJSONArgs(e){const t=e.readUInt8(),i=e.readShortString(),n=e.readLongString();return{rpcId:t,method:i,args:JSON.parse(n)}}static _requestMixedArgs(e,t,i,n,r,o){const s=u.VSBuffer.fromString(i);let a=0;a+=f.sizeUInt8(),a+=f.sizeShortString(s),a+=f.sizeMixedArray(n,r);let c=f.alloc(o?4:3,e,a);return c.writeUInt8(t),c.writeShortString(s),c.writeMixedArray(n,r),c.buffer}static deserializeRequestMixedArgs(e){const t=e.readUInt8(),i=e.readShortString(),n=e.readMixedArray(),r=new Array(n.length);for(let e=0,t=n.length;e<t;e++){const t=n[e];r[e]="string"==typeof t?JSON.parse(t):t}return{rpcId:t,method:i,args:r}}static serializeAcknowledged(e){return f.alloc(5,e,0).buffer}static serializeCancel(e){return f.alloc(6,e,0).buffer}static serializeReplyOK(e,t,i){
return void 0===t?this._serializeReplyOKEmpty(e):t instanceof u.VSBuffer?this._serializeReplyOKVSBuffer(e,t):this._serializeReplyOKJSON(e,d(t,i))}static _serializeReplyOKEmpty(e){return f.alloc(7,e,0).buffer}static _serializeReplyOKVSBuffer(e,t){let i=0;i+=f.sizeVSBuffer(t);let n=f.alloc(8,e,i);return n.writeVSBuffer(t),n.buffer}static deserializeReplyOKVSBuffer(e){return e.readVSBuffer()}static _serializeReplyOKJSON(e,t){const i=u.VSBuffer.fromString(t);let n=0;n+=f.sizeLongString(i);let r=f.alloc(9,e,n);return r.writeLongString(i),r.buffer}static deserializeReplyOKJSON(e){const t=e.readLongString();return JSON.parse(t)}static serializeReplyErr(e,t){return t?this._serializeReplyErrEror(e,t):this._serializeReplyErrEmpty(e)}static _serializeReplyErrEror(e,t){const i=u.VSBuffer.fromString(d(r.transformErrorForSerialization(t),null));let n=0;n+=f.sizeLongString(i);let o=f.alloc(10,e,n);return o.writeLongString(i),o.buffer}static deserializeReplyErrError(e){const t=e.readLongString();return JSON.parse(t)}
static _serializeReplyErrEmpty(e){return f.alloc(11,e,0).buffer}}var v,_;!function(e){e[e.RequestJSONArgs=1]="RequestJSONArgs",e[e.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",e[e.RequestMixedArgs=3]="RequestMixedArgs",e[e.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",e[e.Acknowledged=5]="Acknowledged",e[e.Cancel=6]="Cancel",e[e.ReplyOKEmpty=7]="ReplyOKEmpty",e[e.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",e[e.ReplyOKJSON=9]="ReplyOKJSON",e[e.ReplyErrError=10]="ReplyErrError",e[e.ReplyErrEmpty=11]="ReplyErrEmpty"}(v||(v={})),function(e){e[e.String=1]="String",e[e.VSBuffer=2]="VSBuffer",e[e.Undefined=3]="Undefined"}(_||(_={}))})),define(t[225],i([1,0,86]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutputAppender=void 0;t.OutputAppender=class{constructor(e,t){this.file=t,this.appender=i.createRotatingLogger(e,t,31457280,1),this.appender.clearFormatters()}append(e){this.appender.critical(e)}flush(){this.appender.flush()}}})),
define(t[226],i([1,0,2,7,225,121,24,60,25,14,6,11]),(function(e,t,i,r,o,a,c,l,u,d,h,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostOutputService2=t.ExtHostOutputChannelBackedByFile=void 0;class m extends l.AbstractExtHostOutputChannel{constructor(e,t,n){super(e,!1,i.URI.file(t.file),n),this._appender=t}append(e){super.append(e),this._appender.append(e),this._onDidAppend.fire()}update(){this._appender.flush(),super.update()}show(e,t){this._appender.flush(),super.show(e,t)}clear(){this._appender.flush(),super.clear()}}t.ExtHostOutputChannelBackedByFile=m;let f=(()=>{let e=class extends l.ExtHostOutputService{constructor(e,t,i){super(e),this.logService=t,this._namePool=1,this._channels=new Map,this._visibleChannelDisposable=new h.MutableDisposable,this._logsLocation=i.logsLocation}$setVisibleChannel(e){if(e){const t=this._channels.get(e);t&&(this._visibleChannelDisposable.value=t.onDidAppend(()=>t.update()))}}createOutputChannel(e){
if(!(e=e.trim()))throw new Error("illegal argument `name`. must not be falsy");const t=this._doCreateOutChannel(e);return t.then(e=>e._id.then(t=>this._channels.set(t,e))),new l.LazyOutputChannel(e,t)}async _doCreateOutChannel(e){try{const t=r.join(this._logsLocation.fsPath,`output_logging_${a.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"")}`),n=await c.dirExists(t).then(e=>e||c.mkdirp(t).then(()=>!0)).then(()=>t),s=`${this._namePool++}-${e.replace(/[\\/:\*\?"<>\|]/g,"")}`,l=i.URI.file(r.join(n,`${s}.log`)),u=new o.OutputAppender(s,l.fsPath);return new m(e,u,this._proxy)}catch(t){return this.logService.error(t),new l.ExtHostPushOutputChannel(e,this._proxy)}}};return e=n([s(0,d.IExtHostRpcService),s(1,p.ILogService),s(2,u.IExtHostInitDataService)],e)})();t.ExtHostOutputService2=f})),define(t[33],i([1,0,13,27,18,34,8,45,4,7,152]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";var d;Object.defineProperty(t,"__esModule",{value:!0}),
t.QueryGlobTester=t.resolvePatternsForProvider=t.SerializableFileMatch=t.isFilePatternMatch=t.isSerializedFileMatch=t.isSerializedSearchSuccess=t.isSerializedSearchComplete=t.serializeSearchError=t.deserializeSearchError=t.SearchError=t.SearchErrorCode=t.pathIncludedInQuery=t.createResourceExcludeMatcher=t.getExcludes=t.SearchSortOrder=t.OneLineRange=t.SearchRange=t.TextSearchMatch=t.FileMatch=t.SearchCompletionExitCode=t.isProgressMessage=t.isFileMatch=t.resultIsMatch=t.QueryType=t.SearchProviderType=t.ISearchService=t.SEARCH_EXCLUDE_CONFIG=t.VIEW_ID=t.PANEL_ID=t.VIEWLET_ID=void 0,t.VIEWLET_ID="workbench.view.search",t.PANEL_ID="workbench.panel.search",t.VIEW_ID="workbench.view.search",t.SEARCH_EXCLUDE_CONFIG="search.exclude",t.ISearchService=c.createDecorator("searchService"),function(e){e[e.file=0]="file",e[e.text=1]="text"}(t.SearchProviderType||(t.SearchProviderType={})),function(e){e[e.File=1]="File",e[e.Text=2]="Text"}(t.QueryType||(t.QueryType={})),t.resultIsMatch=function(e){return!!e.preview},
t.isFileMatch=function(e){return!!e.resource},t.isProgressMessage=function(e){return!!e.message},function(e){e[e.Normal=0]="Normal",e[e.NewSearchStarted=1]="NewSearchStarted"}(t.SearchCompletionExitCode||(t.SearchCompletionExitCode={}));t.FileMatch=class{constructor(e){this.resource=e,this.results=[]}};t.TextSearchMatch=class{constructor(e,t,n){if(this.ranges=t,!n||1!==n.matchLines||Array.isArray(t)&&1!==t.length||!function(e){return Array.isArray(e)?e[0].startLineNumber===e[0].endLineNumber:e.startLineNumber===e.endLineNumber}(t)){const n=Array.isArray(t)?t[0].startLineNumber:t.startLineNumber;this.preview={text:e,matches:i.mapArrayOrNot(t,e=>new h(e.startLineNumber-n,e.startColumn,e.endLineNumber-n,e.endColumn))}}else{const i=Array.isArray(t)?t[0]:t;e=s.getNLines(e,n.matchLines);const r=Math.floor(n.charsPerLine/5),o=Math.max(i.startColumn-r,0),a=e.substring(o,n.charsPerLine+o),c=i.endLineNumber-i.startLineNumber+1<=n.matchLines?Math.min(a.length,i.endColumn-o):a.length,l=new p(0,i.startColumn-o,c)
;this.preview={text:a,matches:Array.isArray(t)?[l]:l}}}};class h{constructor(e,t,i,n){this.startLineNumber=e,this.startColumn=t,this.endLineNumber=i,this.endColumn=n}}t.SearchRange=h;class p extends h{constructor(e,t,i){super(e,t,e,i)}}function m(e,t=!0){const i=e&&e.files&&e.files.exclude,n=t&&e&&e.search&&e.search.exclude;if(!i&&!n)return;if(!i||!n)return i||n;let o=Object.create(null);return o=r.mixin(o,r.deepClone(i)),o=r.mixin(o,r.deepClone(n),!0)}t.OneLineRange=p,function(e){e.Default="default",e.FileNames="fileNames",e.Type="type",e.Modified="modified",e.CountDescending="countDescending",e.CountAscending="countAscending"}(t.SearchSortOrder||(t.SearchSortOrder={})),t.getExcludes=m,t.createResourceExcludeMatcher=function(e,i){return e.createInstance(u.ResourceGlobMatcher,e=>m(e?i.getValue({resource:e}):i.getValue())||Object.create(null),e=>e.affectsConfiguration(a.FILES_EXCLUDE_CONFIG)||e.affectsConfiguration(t.SEARCH_EXCLUDE_CONFIG))},t.pathIncludedInQuery=function(e,t){
return(!e.excludePattern||!n.match(e.excludePattern,t))&&(!(e.includePattern&&!n.match(e.includePattern,t))&&(!e.usingSearchPaths||!!e.folderQueries&&e.folderQueries.every(e=>{const i=e.folder.fsPath;if(o.isEqualOrParent(t,i)){const r=l.relative(i,t);return!e.includePattern||!!n.match(e.includePattern,r)}return!1})))},function(e){e[e.unknownEncoding=1]="unknownEncoding",e[e.regexParseError=2]="regexParseError",e[e.globParseError=3]="globParseError",e[e.invalidLiteral=4]="invalidLiteral",e[e.rgProcessError=5]="rgProcessError",e[e.other=6]="other"}(d=t.SearchErrorCode||(t.SearchErrorCode={}));class f extends Error{constructor(e,t){super(e),this.code=t}}t.SearchError=f,t.deserializeSearchError=function(e){try{const t=JSON.parse(e);return new f(t.message,t.code)}catch(t){return new f(e,d.other)}},t.serializeSearchError=function(e){const t={message:e.message,code:e.code};return new Error(JSON.stringify(t))},t.isSerializedSearchComplete=function(e){return"error"===e.type||"success"===e.type},
t.isSerializedSearchSuccess=function(e){return"success"===e.type},t.isSerializedFileMatch=function(e){return!!e.path},t.isFilePatternMatch=function(e,t){const i=e.searchPath?e.searchPath:e.relativePath;return s.fuzzyContains(i,t)};t.SerializableFileMatch=class{constructor(e){this.path=e,this.results=[]}addMatch(e){this.results.push(e)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}},t.resolvePatternsForProvider=function(e,t){const i=Object.assign(Object.assign({},e||{}),t||{});return Object.keys(i).filter(e=>{const t=i[e];return"boolean"==typeof t&&t})};t.QueryGlobTester=class{constructor(e,t){this._parsedIncludeExpression=null,this._excludeExpression=Object.assign(Object.assign({},e.excludePattern||{}),t.excludePattern||{}),this._parsedExcludeExpression=n.parse(this._excludeExpression);let i=e.includePattern;t.includePattern&&(i=i?Object.assign(Object.assign({},i),t.includePattern):t.includePattern),i&&(this._parsedIncludeExpression=n.parse(i))}
includedInQuerySync(e,t,i){return(!this._parsedExcludeExpression||!this._parsedExcludeExpression(e,t,i))&&!(this._parsedIncludeExpression&&!this._parsedIncludeExpression(e,t,i))}includedInQuery(e,t,i){return Promise.resolve(this._parsedExcludeExpression(e,t,i)).then(e=>!!e).then(n=>!n&&(this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(e,t,i)).then(e=>!!e):Promise.resolve(!0))).then(e=>e)}hasSiblingExcludeClauses(){return function(e){for(const t in e)if("boolean"!=typeof e[t])return!0;return!1}(this._excludeExpression)}}})),define(t[31],i([1,0,13,16,22,3,26,20,228,23,8,12,2,168,4,11,126,93,25,14,10,33,5]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b,E,x,C){"use strict";function S(e,t){return d.isEqual(e,t)}function k(e,t){return S(e.uri,t.uri)?0:h.compare(e.uri.toString(),t.uri.toString())}function T(e,t){return e.index!==t.index?e.index<t.index?-1:1:S(e.uri,t.uri)?h.compare(e.name,t.name):h.compare(e.uri.toString(),t.uri.toString())}function I(e,t,n){
const r=e.slice(0).sort(n),o=t.slice(0).sort(n);return i.delta(r,o,n)}Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostWorkspace=t.ExtHostWorkspace=void 0;class D extends y.Workspace{constructor(e,t,i,n,r){super(e,i.map(e=>new y.WorkspaceFolder(e)),n),this._name=t,this._isUntitled=r,this._workspaceFolders=[],this._structure=c.TernarySearchTree.forUris(),i.forEach(e=>{this._workspaceFolders.push(e),this._structure.set(e.uri,e)})}static toExtHostWorkspace(e,t,i){if(!e)return{workspace:null,added:[],removed:[]};const{id:n,name:r,folders:o,configuration:s,isUntitled:a}=e,c=[],l=t;t?o.forEach((e,n)=>{const r=m.URI.revive(e.uri),o=D._findFolder(i||t,r);o?(o.name=e.name,o.index=e.index,c.push(o)):c.push({uri:r,name:e.name,index:n})}):c.push(...o.map(({uri:e,name:t,index:i})=>({uri:m.URI.revive(e),name:t,index:i}))),c.sort((e,t)=>e.index<t.index?-1:1);const u=new D(n,r,c,s?m.URI.revive(s):null,!!a),{added:d,removed:h}=I(l?l.workspaceFolders:[],u.workspaceFolders,k);return{workspace:u,added:d,removed:h}}
static _findFolder(e,t){for(let i=0;i<e.folders.length;i++){const n=e.workspaceFolders[i];if(S(n.uri,t))return n}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(e,t){return t&&this._structure.get(e)&&(e=d.dirname(e)),this._structure.findSubstr(e)}resolveWorkspaceFolder(e){return this._structure.get(e)}}let P=(()=>{let e=class{constructor(e,t,i){this._onDidChangeWorkspace=new a.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._activeSearchCallbacks=[],this._logService=i,this._requestIdProvider=new u.Counter,this._barrier=new r.Barrier,this._proxy=e.getProxy(C.MainContext.MainThreadWorkspace),this._messageService=e.getProxy(C.MainContext.MainThreadMessageService);const n=t.workspace;this._confirmedWorkspace=n?new D(n.id,n.name,[],n.configuration?m.URI.revive(n.configuration):null,!!n.isUntitled):void 0}$initializeWorkspace(e){this.$acceptWorkspaceData(e),this._barrier.open()}
waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:l.Schemas.untitled,path:d.basename(d.dirname(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(e,t,i,...n){const r=[];if(Array.isArray(n)&&n.forEach(e=>{m.URI.isUri(e.uri)&&!r.some(t=>S(t.uri,e.uri))&&r.push({uri:e.uri,name:e.name||d.basenameOrAuthority(e.uri)})}),this._unconfirmedWorkspace)return!1
;if([t,i].some(e=>"number"!=typeof e||e<0))return!1;if(0===i&&0===r.length)return!1;const o=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(t+i>o.length)return!1;const s=o.slice(0);s.splice(t,i,...r.map(e=>({uri:e.uri,name:e.name||d.basenameOrAuthority(e.uri),index:void 0})));for(let e=0;e<s.length;e++){const t=s[e];if(s.some((i,n)=>n!==e&&S(t.uri,i.uri)))return!1}s.forEach((e,t)=>e.index=t);const{added:a,removed:c}=I(o,s,T);if(0===a.length&&0===c.length)return!1;if(this._proxy){const n=e.displayName||e.name;this._proxy.$updateWorkspaceFolders(n,t,i,r).then(void 0,t=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(_.Severity.Error,f.localize(0,null,n,t.toString()),{extension:e},[])})}return this.trySetWorkspaceFolders(s),!0}getWorkspaceFolder(e,t){if(this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(e,t)}async getWorkspaceFolder2(e,t){if(await this._barrier.wait(),this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(e,t)}
async resolveWorkspaceFolder(e){if(await this._barrier.wait(),this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(e)}getPath(){if(!this._actualWorkspace)return;const{folders:e}=this._actualWorkspace;return 0!==e.length?e[0].uri.fsPath:void 0}getRelativePath(e,t){let i,n="";if("string"==typeof e?(i=m.URI.file(e),n=e):void 0!==e&&(i=e,n=e.fsPath),!i)return n;const r=this.getWorkspaceFolder(i,!0);if(!r)return n;void 0===t&&this._actualWorkspace&&(t=this._actualWorkspace.folders.length>1);let o=d.relativePath(r.uri,i);return t&&r.name&&(o=`${r.name}/${o}`),o}trySetWorkspaceFolders(e){this._actualWorkspace&&(this._unconfirmedWorkspace=D.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:e,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace).workspace||void 0)}$acceptWorkspaceData(e){
const{workspace:t,added:i,removed:n}=D.toExtHostWorkspace(e,this._confirmedWorkspace,this._unconfirmedWorkspace);this._confirmedWorkspace=t||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:i,removed:n}))}findFiles(e,t,i,n,r=o.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${n.value}, entryPoint: findFiles`);let s=void 0;if(null===t?s=!1:t&&(s="string"==typeof t?t:t.pattern),r&&r.isCancellationRequested)return Promise.resolve([]);const{includePattern:a,folder:c}=function(e){let t,i;e&&("string"==typeof e?t=e:(t=e.pattern,i=e.baseFolder||m.URI.file(e.base)));return{includePattern:t,folder:i}}(e);return this._proxy.$startFileSearch(p.withUndefinedAsNull(a),p.withUndefinedAsNull(c),p.withUndefinedAsNull(s),p.withUndefinedAsNull(i),r).then(e=>Array.isArray(e)?e.map(e=>m.URI.revive(e)):[])}async findTextInFiles(e,t,n,r,s=o.CancellationToken.None){
this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${r.value}, entryPoint: findTextInFiles`);const a=this._requestIdProvider.getNext(),c=void 0===t.previewOptions?{matchLines:100,charsPerLine:1e4}:t.previewOptions;let l,u;t.include&&("string"==typeof t.include?l=t.include:(l=t.include.pattern,u=t.include.baseFolder||m.URI.file(t.include.base)));const d="string"==typeof t.exclude?t.exclude:t.exclude?t.exclude.pattern:void 0,h={ignoreSymlinks:"boolean"==typeof t.followSymlinks?!t.followSymlinks:void 0,disregardIgnoreFiles:"boolean"==typeof t.useIgnoreFiles?!t.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:"boolean"==typeof t.useGlobalIgnoreFiles?!t.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:"boolean"!=typeof t.useDefaultExcludes||!t.useDefaultExcludes,fileEncoding:t.encoding,maxResults:t.maxResults,previewOptions:c,afterContext:t.afterContext,beforeContext:t.beforeContext,includePattern:l,excludePattern:d};if(this._activeSearchCallbacks[a]=e=>{
const t=m.URI.revive(e.resource);e.results.forEach(e=>{x.resultIsMatch(e)?n({uri:t,preview:{text:e.preview.text,matches:i.mapArrayOrNot(e.preview.matches,e=>new E.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn))},ranges:i.mapArrayOrNot(e.ranges,e=>new E.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn))}):n({uri:t,text:e.text,lineNumber:e.lineNumber})})},s.isCancellationRequested)return{};try{const t=await this._proxy.$startTextSearch(e,p.withUndefinedAsNull(u),h,a,s);return delete this._activeSearchCallbacks[a],t||{}}catch(e){throw delete this._activeSearchCallbacks[a],e}}$handleTextSearchResult(e,t){this._activeSearchCallbacks[t]&&this._activeSearchCallbacks[t](e)}saveAll(e){return this._proxy.$saveAll(e)}resolveProxy(e){return this._proxy.$resolveProxy(e)}};return e=n([s(0,b.IExtHostRpcService),s(1,w.IExtHostInitDataService),s(2,v.ILogService)],e)})();t.ExtHostWorkspace=P,t.IExtHostWorkspace=g.createDecorator("IExtHostWorkspace")})),
define(t[30],i([1,0,18,3,31,5,10,133,50,12,16,4,14,11,2]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g){"use strict";function v(e,t){if(t){const i=t.split(".");let n=e;for(let e=0;n&&e<i.length;e++)n=n[i[e]];return n}}function _(e){return e instanceof g.URI?{resource:e}:function(e){return e&&e.uri instanceof g.URI&&e.languageId&&"string"==typeof e.languageId}(e)?{resource:e.uri,overrideIdentifier:e.languageId}:function(e){return e&&!e.uri&&e.languageId&&"string"==typeof e.languageId}(e)?{overrideIdentifier:e.languageId}:function(e){return e&&e.uri instanceof g.URI&&(!e.name||"string"==typeof e.name)&&(!e.index||"number"==typeof e.index)}(e)?{resource:e.uri}:null===e?{resource:null}:void 0}Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostConfiguration=t.ExtHostConfigProvider=t.ExtHostConfiguration=void 0;let y=(()=>{let e=class{constructor(e,t,i){this._proxy=e.getProxy(a.MainContext.MainThreadConfiguration),this._extHostWorkspace=t,this._logService=i,this._barrier=new h.Barrier,this._actual=null}
getConfigProvider(){return this._barrier.wait().then(e=>this._actual)}$initializeConfiguration(e){this._actual=new w(this._proxy,this._extHostWorkspace,e,this._logService),this._barrier.open()}$acceptConfigurationChanged(e,t){this.getConfigProvider().then(i=>i.$acceptConfigurationChanged(e,t))}};return e=n([s(0,m.IExtHostRpcService),s(1,o.IExtHostWorkspace),s(2,f.ILogService)],e)})();t.ExtHostConfiguration=y;class w{constructor(e,t,i,n){this._onDidChangeConfiguration=new r.Emitter,this._proxy=e,this._logService=n,this._extHostWorkspace=t,this._configuration=l.Configuration.parse(i),this._configurationScopes=this._toMap(i.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(e,t){const i={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=l.Configuration.parse(e),this._configurationScopes=this._toMap(e.configurationScopes),
this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(t,i))}getConfiguration(e,t,n){const r=_(t)||{},o=this._toReadonlyValue(e?v(this._configuration.getValue(void 0,r,this._extHostWorkspace.workspace),e):this._configuration.getValue(void 0,r,this._extHostWorkspace.workspace));e&&this._validateConfigurationAccess(e,r,null==n?void 0:n.identifier);const s={has:e=>void 0!==v(o,e),get:(t,s)=>{this._validateConfigurationAccess(e?`${e}.${t}`:t,r,null==n?void 0:n.identifier);let a=v(o,t);if(void 0===a)a=s;else{let e=void 0;const n=(t,r)=>{let s=void 0;const a=()=>{e=e||i.deepClone(o),s=s||v(e,r)};return d.isObject(t)?new Proxy(t,{get:(t,i)=>{if("string"==typeof i&&"tojson"===i.toLowerCase())return a(),()=>s;if(e)return(s=s||v(e,r))[i];const o=t[i];return"string"==typeof i?n(o,`${r}.${i}`):o},set:(e,t,i)=>(a(),s&&(s[t]=i),!0),deleteProperty:(e,t)=>(a(),s&&delete s[t],!0),defineProperty:(e,t,i)=>(a(),s&&Object.defineProperty(s,t,i),!0)}):t};a=n(a,t)}return a},update:(t,i,n,o)=>{t=e?`${e}.${t}`:t
;const s=function(e){if(null==e)return null;if("boolean"==typeof e)return e?1:4;switch(e){case c.ConfigurationTarget.Global:return 1;case c.ConfigurationTarget.Workspace:return 4;case c.ConfigurationTarget.WorkspaceFolder:return 5}}(n);return void 0!==i?this._proxy.$updateConfigurationOption(s,t,i,r,o):this._proxy.$removeConfigurationOption(s,t,r,o)},inspect:t=>{var n,o,s,a,c,l,u,d;t=e?`${e}.${t}`:t;const h=i.deepClone(this._configuration.inspect(t,r,this._extHostWorkspace.workspace));if(h)return{key:t,defaultValue:null===(n=h.default)||void 0===n?void 0:n.value,globalValue:null===(o=h.user)||void 0===o?void 0:o.value,workspaceValue:null===(s=h.workspace)||void 0===s?void 0:s.value,workspaceFolderValue:null===(a=h.workspaceFolder)||void 0===a?void 0:a.value,defaultLanguageValue:null===(c=h.default)||void 0===c?void 0:c.override,globalLanguageValue:null===(l=h.user)||void 0===l?void 0:l.override,workspaceLanguageValue:null===(u=h.workspace)||void 0===u?void 0:u.override,
workspaceFolderLanguageValue:null===(d=h.workspaceFolder)||void 0===d?void 0:d.override,languageIds:h.overrideIdentifiers}}};return"object"==typeof o&&i.mixin(s,o,!1),Object.freeze(s)}_toReadonlyValue(e){const t=e=>d.isObject(e)?new Proxy(e,{get:(e,i)=>t(e[i]),set:(e,t,i)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(t)}' of object`)},deleteProperty:(e,t)=>{throw new Error(`TypeError: Cannot delete read only property '${String(t)}' of object`)},defineProperty:(e,t)=>{throw new Error(`TypeError: Cannot define property '${String(t)}' for a readonly object`)},setPrototypeOf:e=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):e;return t(e)}_validateConfigurationAccess(e,t,i){const n=u.OVERRIDE_PROPERTY_PATTERN.test(e)?4:this._configurationScopes.get(e),r=i?`[${i.value}] `:""
;4!==n?3!==n||(null==t?void 0:t.resource)&&this._logService.warn(`${r}Accessing a window scoped configuration for a resource is not expected. To associate '${e}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`):void 0===(null==t?void 0:t.resource)&&this._logService.warn(`${r}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${e}', provide the URI of a resource or 'null' for any resource.`)}_toConfigurationChangeEvent(e,t){const i=new l.ConfigurationChangeEvent(e,t,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(e,t)=>i.affectsConfiguration(e,_(t))})}_toMap(e){return e.reduce((e,t)=>(e.set(t[0],t[1]),e),new Map)}}t.ExtHostConfigProvider=w,t.IExtHostConfiguration=p.createDecorator("IExtHostConfiguration")})),
define(t[38],i([1,0,142,7,23,16,6,26,2,11,5,30,184,76,31,42,181,22,19,28,20,29,141,10,90,4,25,58,14,68,54,37]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b,E,x,C,S,k,T,I,D,P,R,A,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtHostExtensionService=t.AbstractExtHostExtensionService=t.IHostUtils=void 0,t.IHostUtils=T.createDecorator("IHostUtils");let L=(()=>{let e=class e{constructor(e,t,i,n,r,o,s,l,u,d){this._hostUtils=t,this._extHostContext=i,this._initData=s,this._extHostWorkspace=n,this._extHostConfiguration=r,this._logService=o,this._extHostTunnelService=u,this._extHostTerminalService=d,this._disposables=new c.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(h.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(h.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(h.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new a.Barrier,
this._readyToStartExtensionHost=new a.Barrier,this._readyToRunExtensions=new a.Barrier,this._registry=new _.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new f.ExtHostStorage(this._extHostContext),this._storagePath=l,this._instaService=e.createChild(new R.ServiceCollection([f.IExtHostStorage,this._storage]));const p=new Set;this._initData.hostExtensions.forEach(e=>p.add(b.ExtensionIdentifier.toKey(e))),this._activator=new m.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(e,t)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(e,t)},actualActivateExtension:async(e,t)=>{if(p.has(b.ExtensionIdentifier.toKey(e)))return await this._mainThreadExtensionsProxy.$activateExtension(e,t),new m.HostExtension;const i=this._registry.getExtensionDescription(e);return this._activateExtension(i,t)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1}
async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(e){w.onUnexpectedError(e)}}async deactivateAll(){let e=[];try{e=this._registry.getAllExtensionDescriptions().map(e=>e.identifier).filter(e=>this.isActivated(e)).map(e=>this._deactivate(e))}catch(e){}await Promise.all(e)}isActivated(e){return!!this._readyToRunExtensions.isOpen()&&this._activator.isActivated(e)}_activateByEvent(e,t){return this._activator.activateByEvent(e,t)}_activateById(e,t){return this._activator.activateById(e,t)}activateByIdWithErrors(e,t){return this._activateById(e,t).then(()=>{const t=this._activator.getActivatedExtension(e);if(t.activationFailed)return Promise.reject(t.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(e=>this._registry)}getExtensionExports(e){
return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(e).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const e=l.TernarySearchTree.forPaths(),t=this._registry.getAllExtensionDescriptions().map(t=>{if(t.main)return this._hostUtils.realpath(t.extensionLocation.fsPath).then(i=>e.set(u.URI.file(i).fsPath,t))});this._extensionPathIndex=Promise.all(t).then(()=>e)}return this._extensionPathIndex}_deactivate(e){let t=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen())return t;if(!this._activator.isActivated(e))return t;const i=this._activator.getActivatedExtension(e);if(!i)return t;try{"function"==typeof i.module.deactivate&&(t=Promise.resolve(i.module.deactivate()).then(void 0,e=>Promise.resolve(void 0)))}catch(e){}try{c.dispose(i.subscriptions)}catch(e){}return t}_activateExtension(e,t){return this._mainThreadExtensionsProxy.$onWillActivateExtension(e.identifier),this._doActivateExtension(e,t).then(i=>{const n=i.activationTimes
;return this._mainThreadExtensionsProxy.$onDidActivateExtension(e.identifier,n.codeLoadingTime,n.activateCallTime,n.activateResolvedTime,t),this._logExtensionActivationTimes(e,t,"success",n),i},i=>{throw this._logExtensionActivationTimes(e,t,"failure"),i})}_logExtensionActivationTimes(e,t,i,n){const r=M(e,t);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",Object.assign(Object.assign(Object.assign({},r),n||{}),{outcome:i}))}_doActivateExtension(t,i){const n=M(t,i);if(this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",n),!t.main)return Promise.resolve(new m.EmptyExtension(m.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${t.identifier.value} ${JSON.stringify(i)}`),this._logService.flush();const r=new m.ExtensionActivationTimesBuilder(i.startup);return Promise.all([this._loadCommonJSModule(o.joinPath(t.extensionLocation,t.main),r),this._loadExtensionContext(t)]).then(i=>e._callActivate(this._logService,t.identifier,i[0],i[1],r))}
_loadExtensionContext(e){const t=new C.ExtensionMemento(e.identifier.value,!0,this._storage),i=new C.ExtensionMemento(e.identifier.value,!1,this._storage),n=e.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?S.ExtensionMode.Test:S.ExtensionMode.Development:S.ExtensionMode.Release;return this._logService.trace(`ExtensionService#loadExtensionContext ${e.identifier.value}`),Promise.all([t.whenReady,i.whenReady,this._storagePath.whenReady]).then(()=>{const o=this;return Object.freeze({globalState:t,workspaceState:i,subscriptions:[],get extensionUri(){return e.extensionLocation},get extensionPath(){return e.extensionLocation.fsPath},get storagePath(){return o._storagePath.workspaceValue(e)},get globalStoragePath(){return o._storagePath.globalValue(e)},asAbsolutePath:t=>r.join(e.extensionLocation.fsPath,t),get logPath(){return r.join(o._initData.logsLocation.fsPath,e.identifier.value)},get extensionMode(){return v.checkProposedApiEnabled(e),n},get environmentVariableCollection(){
return o._extHostTerminalService.getEnvironmentVariableCollection(e)}})})}static _callActivate(e,t,i,n,r){return i=i||{activate:void 0,deactivate:void 0},this._callActivateOptional(e,t,i,n,r).then(e=>new m.ActivatedExtension(!1,null,r.build(),i,e,n.subscriptions))}static _callActivateOptional(e,t,i,n,r){if("function"!=typeof i.activate)return Promise.resolve(i);try{r.activateCallStart(),e.trace(`ExtensionService#_callActivateOptional ${t.value}`);const o="object"==typeof global?global:self,s=i.activate.apply(o,[n]);return r.activateCallStop(),r.activateResolveStart(),Promise.resolve(s).then(e=>(r.activateResolveStop(),e))}catch(e){return Promise.reject(e)}}_activateOneStartupFinished(e,t){this._activateById(e.identifier,{startup:!1,extensionId:e.identifier,activationEvent:t}).then(void 0,e=>{this._logService.error(e)})}_activateAllStartupFinished(){
for(const e of this._registry.getAllExtensionDescriptions())if(e.activationEvents)for(const t of e.activationEvents)"onStartupFinished"===t&&this._activateOneStartupFinished(e,t)}_handleEagerExtensions(){const e=this._activateByEvent("*",!0).then(void 0,e=>{this._logService.error(e)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(e=>this._handleWorkspaceContainsEagerExtensions(e.added)));const t=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],i=this._handleWorkspaceContainsEagerExtensions(t),n=Promise.all([e,i]).then(()=>{});return Promise.race([n,a.timeout(1e4)]).then(()=>{this._activateAllStartupFinished()}),n}_handleWorkspaceContainsEagerExtensions(e){return 0===e.length?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(t=>this._handleWorkspaceContainsEagerExtension(e,t))).then(()=>{})}_handleWorkspaceContainsEagerExtension(e,t){const i=t.activationEvents;if(!i)return Promise.resolve(void 0)
;if(this.isActivated(t.identifier))return Promise.resolve(void 0);const n=[],r=[],o=!this._initData.remote.isRemote&&!!this._initData.remote.authority;for(const e of i)if(/^workspaceContains:/.test(e)){const t=e.substr("workspaceContains:".length);t.indexOf("*")>=0||t.indexOf("?")>=0||o?r.push(t):n.push(t)}if(0===n.length&&0===r.length)return Promise.resolve(void 0);const s=Promise.all(n.map(i=>this._activateIfFileName(e,t.identifier,i))).then(()=>{}),a=this._activateIfGlobPatterns(e,t.identifier,r);return Promise.all([s,a]).then(()=>{})}async _activateIfFileName(e,t,i){for(const{uri:n}of e)if(await this._hostUtils.exists(r.join(u.URI.revive(n).fsPath,i)))return this._activateById(t,{startup:!0,extensionId:t,activationEvent:`workspaceContains:${i}`}).then(void 0,e=>this._logService.error(e))}async _activateIfGlobPatterns(t,i,n){if(this._logService.trace(`extensionHostMain#activateIfGlobPatterns: fileSearch, extension: ${i.value}, entryPoint: workspaceContains`),0===n.length)return Promise.resolve(void 0)
;const r=new y.CancellationTokenSource,o=this._mainThreadWorkspaceProxy.$checkExists(t.map(e=>e.uri),n,r.token),s=setTimeout(async()=>{r.cancel(),this._activateById(i,{startup:!0,extensionId:i,activationEvent:`workspaceContainsTimeout:${n.join(",")}`}).then(void 0,e=>this._logService.error(e))},e.WORKSPACE_CONTAINS_TIMEOUT);let a=!1;try{a=await o}catch(e){w.isPromiseCanceledError(e)||this._logService.error(e)}return r.dispose(),clearTimeout(s),a?this._activateById(i,{startup:!0,extensionId:i,activationEvent:`workspaceContains:${n.join(",")}`}).then(void 0,e=>this._logService.error(e)):Promise.resolve(void 0)}_handleExtensionTests(){return this._doHandleExtensionTests().then(void 0,e=>(console.error(e),Promise.reject(e)))}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:e,extensionTestsLocationURI:t}=this._initData.environment;if(!e||!t||t.scheme!==E.Schemas.file)return Promise.resolve(void 0);const n=o.originalFSPath(t);let r,s;try{
r=await this._loadCommonJSModule(u.URI.file(n),new m.ExtensionActivationTimesBuilder(!1))}catch(e){s=e}return r&&"function"==typeof r.run?new Promise((e,t)=>{const i=r.run(n,(i,n)=>{i?t(i.toString()):e(void 0),this._gracefulExit(i||"number"==typeof n&&n>0?1:0)});i&&i.then&&i.then(()=>{e(),this._gracefulExit(0)}).catch(e=>{t(e.toString()),this._gracefulExit(1)})}):(this._gracefulExit(1),Promise.reject(new Error(s?s.toString():i.localize(0,null,n))))}_gracefulExit(e){setTimeout(()=>{this._initData.remote.isRemote&&this._initData.environment.extensionTestsLocationURI?this._mainThreadExtensionsProxy.$onExtensionHostExit(e):this._hostUtils.exit(e)},500)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>this._handleExtensionTests()).then(()=>{this._logService.info("eager extensions activated")})}
registerRemoteAuthorityResolver(e,t){return this._resolvers[e]=t,c.toDisposable(()=>{delete this._resolvers[e]})}async $resolveAuthority(e,t){const i=e.indexOf("+");if(-1===i)throw new Error("Not an authority that can be resolved!");const n=e.substr(0,i);await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${n}`,!1);const r=this._resolvers[n];if(!r)return{type:"error",error:{code:k.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${n}.`,detail:void 0}};try{const i=await r.resolve(e,{resolveAttempt:t});return this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(r)),{type:"ok",value:{authority:{authority:e,host:i.host,port:i.port},options:{extensionHostEnv:i.extensionHostEnv},tunnelInformation:{environmentTunnels:i.environmentTunnels}}}}catch(e){if(e instanceof S.RemoteAuthorityResolverError)return{type:"error",error:{code:e._code,message:e._message,detail:e._detail}};throw e}}
$startExtensionHost(e){return this._registry.keepOnly(e),this._startExtensionHost()}$activateByEvent(e){return this._readyToRunExtensions.wait().then(t=>this._activateByEvent(e,!1))}async $activate(e,t){return await this._readyToRunExtensions.wait(),!!this._registry.getExtensionDescription(e)&&(await this._activateById(e,t),!0)}async $deltaExtensions(e,t){e.forEach(e=>e.extensionLocation=u.URI.revive(e.extensionLocation));const i=await this.getExtensionPathIndex();return await Promise.all(t.map(async e=>{const t=this._registry.getExtensionDescription(e);if(!t)return;const n=await this._hostUtils.realpath(t.extensionLocation.fsPath);i.delete(u.URI.file(n).fsPath)})),await Promise.all(e.map(async e=>{const t=await this._hostUtils.realpath(e.extensionLocation.fsPath);i.set(u.URI.file(t).fsPath,e)})),this._registry.deltaExtensions(e,t),Promise.resolve(void 0)}async $test_latency(e){return e}async $test_up(e){return e.byteLength}async $test_down(e){let t=x.VSBuffer.alloc(e),i=Math.random()%256
;for(let n=0;n<e;n++)t.writeUInt8(i,n);return t}};return e.WORKSPACE_CONTAINS_TIMEOUT=7e3,e=n([s(0,T.IInstantiationService),s(1,t.IHostUtils),s(2,P.IExtHostRpcService),s(3,g.IExtHostWorkspace),s(4,p.IExtHostConfiguration),s(5,d.ILogService),s(6,I.IExtHostInitDataService),s(7,D.IExtensionStoragePaths),s(8,A.IExtHostTunnelService),s(9,O.IExtHostTerminalService)],e)})();function M(e,t){return{id:e.identifier.value,name:e.name,extensionVersion:e.version,publisherDisplayName:e.publisher,activationEvents:e.activationEvents?e.activationEvents.join(","):null,isBuiltin:e.isBuiltin,reason:t.activationEvent,reasonId:t.extensionId.value}}t.AbstractExtHostExtensionService=L,t.IExtHostExtensionService=T.createDecorator("IExtHostExtensionService")})),define(t[44],i([1,0,7,2,3,16,5,10,98,31,38,39,172,30,154,22,43,14,4,12]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.WorkerExtHostDebugService=t.ExtHostVariableResolverService=t.ExtHostDebugConsole=t.ExtHostDebugSession=t.ExtHostDebugServiceBase=t.IExtHostDebugService=void 0,t.IExtHostDebugService=w.createDecorator("IExtHostDebugService");let E=(()=>{let e=class{constructor(e,t,i,n,r,s){this._workspaceService=t,this._extensionService=i,this._editorsService=n,this._configurationService=r,this._commandService=s,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._aexCommands=new Map,this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new o.Emitter,this._onDidTerminateDebugSession=new o.Emitter,this._onDidChangeActiveDebugSession=new o.Emitter,this._onDidReceiveDebugSessionCustomEvent=new o.Emitter,this._debugServiceProxy=e.getProxy(c.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new o.Emitter({
onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new C(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(e=>{e.onDidChange(t=>{this.registerAllDebugTypes(e)}),this.registerAllDebugTypes(e)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole}asDebugSourceUri(e,t){const i=e;if("number"==typeof i.sourceReference){let e=`debug:${encodeURIComponent(i.path||"")}`,n="?";return t&&(e+=`${n}session=${encodeURIComponent(t.id)}`,n="&"),e+=`${n}ref=${i.sourceReference}`,r.URI.parse(e)}if(i.path)return r.URI.file(i.path)
;throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}registerAllDebugTypes(e){const t=[];this._aexCommands.clear();for(const i of e.getAllExtensionDescriptions())if(i.contributes){const e=i.contributes.debuggers;if(e&&e.length>0)for(const i of e)g.isDebuggerMainContribution(i)&&(t.push(i.type),i.adapterExecutableCommand&&this._aexCommands.set(i.type,i.adapterExecutableCommand))}this._debugServiceProxy.$registerDebugTypes(t)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const e=[];return this._breakpoints.forEach(t=>e.push(t)),e}addBreakpoints(e){this.startBreakpoints();const t=e.filter(e=>{const t=e.id;return!this._breakpoints.has(t)&&(this._breakpoints.set(t,e),!0)});this.fireBreakpointChanges(t,[],[]);const i=[],n=new Map;for(const e of t)if(e instanceof l.SourceBreakpoint){let t=n.get(e.location.uri.toString());t||(t={type:"sourceMulti",uri:e.location.uri,lines:[]},
n.set(e.location.uri.toString(),t),i.push(t)),t.lines.push({id:e.id,enabled:e.enabled,condition:e.condition,hitCondition:e.hitCondition,logMessage:e.logMessage,line:e.location.range.start.line,character:e.location.range.start.character})}else e instanceof l.FunctionBreakpoint&&i.push({type:"function",id:e.id,enabled:e.enabled,hitCondition:e.hitCondition,logMessage:e.logMessage,condition:e.condition,functionName:e.functionName});return this._debugServiceProxy.$registerBreakpoints(i)}removeBreakpoints(e){this.startBreakpoints();const t=e.filter(e=>this._breakpoints.delete(e.id));this.fireBreakpointChanges([],t,[]);const i=t.filter(e=>e instanceof l.SourceBreakpoint).map(e=>e.id),n=t.filter(e=>e instanceof l.FunctionBreakpoint).map(e=>e.id),r=t.filter(e=>e instanceof l.DataBreakpoint).map(e=>e.id);return this._debugServiceProxy.$unregisterBreakpoints(i,n,r)}startDebugging(e,t,i){return this._debugServiceProxy.$startDebugging(e?e.uri:void 0,t,{parentSessionID:i.parentSession?i.parentSession.id:void 0,
repl:i.consoleMode===l.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate"})}registerDebugConfigurationProvider(e,t,i){if(!t)return new l.Disposable(()=>{});t.debugAdapterExecutable&&console.error("DebugConfigurationProvider.debugAdapterExecutable is deprecated and will be removed soon; please use DebugAdapterDescriptorFactory.createDebugAdapterDescriptor instead.");const n=this._configProviderHandleCounter++;return this._configProviders.push({type:e,handle:n,provider:t}),this._debugServiceProxy.$registerDebugConfigurationProvider(e,i,!!t.provideDebugConfigurations,!!t.resolveDebugConfiguration,!!t.resolveDebugConfigurationWithSubstitutedVariables,!!t.debugAdapterExecutable,n),new l.Disposable(()=>{this._configProviders=this._configProviders.filter(e=>e.provider!==t),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(e,t,i){if(!i)return new l.Disposable(()=>{})
;if(!this.definesDebugType(e,t))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${t}' debugger.`);if(this.getAdapterDescriptorFactoryByType(t))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:t,handle:n,factory:i}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(t,n),new l.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(e=>e.factory!==i),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(e,t){if(!t)return new l.Disposable(()=>{});const i=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:e,handle:i,factory:t}),new l.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(e=>e.factory!==t)})}async $runInTerminal(e){return Promise.resolve(void 0)}createVariableResolver(e,t,i){return new S(e,t,i)}
async $substituteVariables(e,t){if(!this._variableResolver){const[e,t]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(e||[],this._editorsService,t)}let i;const n=await this.getFolder(e);return n&&(i={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAny(i,t)}createDebugAdapter(e,t){if("implementation"===e.type)return new T(e.implementation)}createSignService(){}async $startDASession(e,t){const i=this,n=await this.getSession(t);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(t=>{if(!t)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const r=this.convertToDto(t),o=this.createDebugAdapter(r,n);if(!o)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const s=o
;return this._debugAdapters.set(e,s),this.getDebugAdapterTrackers(n).then(t=>(t&&this._debugAdaptersTrackers.set(e,t),s.onMessage(async n=>{if("request"===n.type&&"handshake"===n.command){const e=n,t={type:"response",seq:0,command:e.command,request_seq:e.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(!this._signService)throw new Error("no signer");{const i=await this._signService.sign(e.arguments.value);t.body={signature:i},s.sendResponse(t)}}catch(e){t.success=!1,t.message=e.message,s.sendResponse(t)}}else t&&t.onDidSendMessage&&t.onDidSendMessage(n),n=g.convertToVSCPaths(n,!0),i._debugServiceProxy.$acceptDAMessage(e,n)}),s.onError(i=>{t&&t.onError&&t.onError(i),this._debugServiceProxy.$acceptDAError(e,i.name,i.message,i.stack)}),s.onExit(i=>{t&&t.onExit&&t.onExit(b.withNullAsUndefined(i),void 0),this._debugServiceProxy.$acceptDAExit(e,b.withNullAsUndefined(i),void 0)}),t&&t.onWillStartSession&&t.onWillStartSession(),s.startSession()))})}$sendDAMessage(e,t){
t=g.convertToDAPaths(t,!1);const i=this._debugAdaptersTrackers.get(e);i&&i.onWillReceiveMessage&&i.onWillReceiveMessage(t);const n=this._debugAdapters.get(e);n&&n.sendMessage(t)}$stopDASession(e){const t=this._debugAdaptersTrackers.get(e);this._debugAdaptersTrackers.delete(e),t&&t.onWillStopSession&&t.onWillStopSession();const i=this._debugAdapters.get(e);return this._debugAdapters.delete(e),i?i.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(e){const t=[],i=[],n=[];if(e.added)for(const i of e.added){const e=i.id;if(e&&!this._breakpoints.has(e)){let n;if("function"===i.type)n=new l.FunctionBreakpoint(i.functionName,i.enabled,i.condition,i.hitCondition,i.logMessage);else if("data"===i.type)n=new l.DataBreakpoint(i.label,i.dataId,i.canPersist,i.enabled,i.hitCondition,i.condition,i.logMessage);else{const e=r.URI.revive(i.uri);n=new l.SourceBreakpoint(new l.Location(e,new l.Position(i.line,i.character)),i.enabled,i.condition,i.hitCondition,i.logMessage)}n._id=e,this._breakpoints.set(e,n),t.push(n)}}
if(e.removed)for(const t of e.removed){const e=this._breakpoints.get(t);e&&(this._breakpoints.delete(t),i.push(e))}if(e.changed)for(const t of e.changed)if(t.id){const e=this._breakpoints.get(t.id);if(e){if(e instanceof l.FunctionBreakpoint&&"function"===t.type){const i=e;i.enabled=t.enabled,i.condition=t.condition,i.hitCondition=t.hitCondition,i.logMessage=t.logMessage,i.functionName=t.functionName}else if(e instanceof l.SourceBreakpoint&&"source"===t.type){const i=e;i.enabled=t.enabled,i.condition=t.condition,i.hitCondition=t.hitCondition,i.logMessage=t.logMessage,i.location=new l.Location(r.URI.revive(t.uri),new l.Position(t.line,t.character))}n.push(e)}}this.fireBreakpointChanges(t,i,n)}$provideDebugConfigurations(e,t,i){return a.asPromise(async()=>{const n=this.getConfigProviderByHandle(e);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const r=await this.getFolder(t)
;return n.provideDebugConfigurations(r,i)}).then(e=>{if(!e)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return e})}$resolveDebugConfiguration(e,t,i,n){return a.asPromise(async()=>{const r=this.getConfigProviderByHandle(e);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const o=await this.getFolder(t);return r.resolveDebugConfiguration(o,i,n)})}$resolveDebugConfigurationWithSubstitutedVariables(e,t,i,n){return a.asPromise(async()=>{const r=this.getConfigProviderByHandle(e);if(!r)throw new Error("no DebugConfigurationProvider found");if(!r.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const o=await this.getFolder(t);return r.resolveDebugConfigurationWithSubstitutedVariables(o,i,n)})}$legacyDebugAdapterExecutable(e,t){
return a.asPromise(async()=>{const i=this.getConfigProviderByHandle(e);if(!i)throw new Error("no DebugConfigurationProvider found");if(!i.debugAdapterExecutable)throw new Error("DebugConfigurationProvider has no method debugAdapterExecutable");const n=await this.getFolder(t);return i.debugAdapterExecutable(n,v.CancellationToken.None)}).then(e=>{if(!e)throw new Error("nothing returned from DebugConfigurationProvider.debugAdapterExecutable");return this.convertToDto(e)})}async $provideDebugAdapter(e,t){const i=this.getAdapterDescriptorFactoryByHandle(e);if(!i)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(t);return this.getAdapterDescriptor(i,n).then(e=>{if(!e)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(e)})}async $acceptDebugSessionStarted(e){const t=await this.getSession(e);this._onDidStartDebugSession.fire(t)}async $acceptDebugSessionTerminated(e){
const t=await this.getSession(e);t&&(this._onDidTerminateDebugSession.fire(t),this._debugSessions.delete(t.id))}async $acceptDebugSessionActiveChanged(e){this._activeDebugSession=e?await this.getSession(e):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(e,t){const i=await this.getSession(e);i&&i._acceptNameChanged(t)}async $acceptDebugSessionCustomEvent(e,t){const i={session:await this.getSession(e),event:t.event,body:t.body};this._onDidReceiveDebugSessionCustomEvent.fire(i)}convertToDto(e){if(e instanceof l.DebugAdapterExecutable)return{type:"executable",command:e.command,args:e.args,options:e.options};if(e instanceof l.DebugAdapterServer)return{type:"server",port:e.port,host:e.host};if(e instanceof l.DebugAdapterInlineImplementation)return{type:"implementation",implementation:e.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(e){const t=this._adapterFactories.filter(t=>t.type===e)
;if(t.length>0)return t[0].factory}getAdapterDescriptorFactoryByHandle(e){const t=this._adapterFactories.filter(t=>t.handle===e);if(t.length>0)return t[0].factory}getConfigProviderByHandle(e){const t=this._configProviders.filter(t=>t.handle===e);if(t.length>0)return t[0].provider}definesDebugType(e,t){if(e.contributes){const i=e.contributes.debuggers;if(i&&i.length>0)for(const e of i)if(e.label&&e.type&&e.type===t)return!0}return!1}getDebugAdapterTrackers(e){const t=e.configuration.type,i=this._trackerFactories.filter(e=>e.type===t||"*"===e.type).map(t=>a.asPromise(()=>t.factory.createDebugAdapterTracker(e)).then(e=>e,e=>null));return Promise.race([Promise.all(i).then(e=>{const t=e.filter(e=>!!e);if(t.length>0)return new k(t)}),new Promise((e,t)=>{const i=setTimeout(()=>{clearTimeout(i),t(new Error("timeout"))},1e3)})]).catch(e=>{})}async getAdapterDescriptor(e,t){const i=t.configuration.debugServer;if("number"==typeof i)return Promise.resolve(new l.DebugAdapterServer(i))
;const n=this._configProviders.filter(e=>e.type===t.type).pop();if(n&&n.provider.debugAdapterExecutable){const e=n.provider.debugAdapterExecutable;return a.asPromise(()=>e(t.workspaceFolder,v.CancellationToken.None)).then(e=>{if(e)return e})}if(e){const i=await this._extensionService.getExtensionRegistry();return a.asPromise(()=>e.createDebugAdapterDescriptor(t,this.daExecutableFromPackage(t,i))).then(e=>{if(e)return e})}const r=this._aexCommands.get(t.type);if(r){const e=t.workspaceFolder,i=e?e.uri.toString():void 0;return this._commandService.executeCommand(r,i).then(e=>new l.DebugAdapterExecutable(e.command,e.args||[]))}const o=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(t,o))}daExecutableFromPackage(e,t){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(e,t,i){
(e.length>0||t.length>0||i.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:e,removed:t,changed:i}))}async getSession(e){if(e){if("string"!=typeof e){let t=this._debugSessions.get(e.id);if(!t){const i=await this.getFolder(e.folderUri);t=new x(this._debugServiceProxy,e.id,e.type,e.name,i,e.configuration),this._debugSessions.set(t.id,t),this._debugServiceProxy.$sessionCached(t.id)}return t}{const t=this._debugSessions.get(e);if(t)return t}}throw new Error("cannot find session")}getFolder(e){if(e){const t=r.URI.revive(e);return this._workspaceService.resolveWorkspaceFolder(t)}return Promise.resolve(void 0)}};return e=n([s(0,y.IExtHostRpcService),s(1,d.IExtHostWorkspace),s(2,h.IExtHostExtensionService),s(3,p.IExtHostDocumentsAndEditors),s(4,f.IExtHostConfiguration),s(5,_.IExtHostCommands)],e)})();t.ExtHostDebugServiceBase=E;class x{constructor(e,t,i,n,r,o){this._debugServiceProxy=e,this._id=t,this._type=i,this._name=n,this._workspaceFolder=r,this._configuration=o}get id(){return this._id}
get type(){return this._type}get name(){return this._name}set name(e){this._name=e,this._debugServiceProxy.$setDebugSessionName(this._id,e)}_acceptNameChanged(e){this._name=e}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(e,t){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,e,t)}}t.ExtHostDebugSession=x;class C{constructor(e){this._debugServiceProxy=e}append(e){this._debugServiceProxy.$appendDebugConsole(e)}appendLine(e){this.append(e+"\n")}}t.ExtHostDebugConsole=C;class S extends m.AbstractVariableResolverService{constructor(e,t,n,r){super({getFolderUri:t=>{const i=e.filter(e=>e.name===t);if(i&&i.length>0)return i[0].uri},getWorkspaceFolderCount:()=>e.length,getConfigurationValue:(e,t)=>n.getConfiguration(void 0,e).get(t),getExecPath:()=>r?r.VSCODE_EXEC_PATH:void 0,getFilePath:()=>{const e=t.activeEditor();if(e)return i.normalize(e.document.uri.fsPath)},getSelectedText:()=>{const e=t.activeEditor()
;if(e&&!e.selection.isEmpty)return e.document.getText(e.selection)},getLineNumber:()=>{const e=t.activeEditor();if(e)return String(e.selection.end.line+1)}},r)}}t.ExtHostVariableResolverService=S;class k{constructor(e){this.trackers=e}onWillStartSession(){this.trackers.forEach(e=>e.onWillStartSession?e.onWillStartSession():void 0)}onWillReceiveMessage(e){this.trackers.forEach(t=>t.onWillReceiveMessage?t.onWillReceiveMessage(e):void 0)}onDidSendMessage(e){this.trackers.forEach(t=>t.onDidSendMessage?t.onDidSendMessage(e):void 0)}onWillStopSession(){this.trackers.forEach(e=>e.onWillStopSession?e.onWillStopSession():void 0)}onError(e){this.trackers.forEach(t=>t.onError?t.onError(e):void 0)}onExit(e,t){this.trackers.forEach(i=>i.onExit?i.onExit(e,t):void 0)}}class T extends u.AbstractDebugAdapter{constructor(e){super(),this.implementation=e,e.onDidSendMessage(e=>{this.acceptMessage(e)})}startSession(){return Promise.resolve(void 0)}sendMessage(e){this.implementation.handleMessage(e)}stopSession(){
return this.implementation.dispose(),Promise.resolve(void 0)}}let I=(()=>{let e=class extends E{constructor(e,t,i,n,r,o){super(e,t,i,n,r,o)}};return e=n([s(0,y.IExtHostRpcService),s(1,d.IExtHostWorkspace),s(2,h.IExtHostExtensionService),s(3,p.IExtHostDocumentsAndEditors),s(4,f.IExtHostConfiguration),s(5,_.IExtHostCommands)],e)})();t.WorkerExtHostDebugService=I})),define(t[232],i([1,0,2,5,30,42,28,14,25,4,38,36,11]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequireInterceptor=void 0;let f=(()=>{let e=class{constructor(e,t,i,n,r,o,s){this._apiFactory=e,this._extensionRegistry=t,this._instaService=i,this._extHostConfiguration=n,this._extHostExtensionService=r,this._initData=o,this._logService=s,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor();const e=await this._extHostConfiguration.getConfigProvider(),t=await this._extHostExtensionService.getExtensionPathIndex()
;this.register(new g(this._apiFactory,t,this._extensionRegistry,e,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(_,t,this._initData.environment.appUriScheme))}register(e){if(Array.isArray(e.nodeModuleName))for(let t of e.nodeModuleName)this._factories.set(t,e);else this._factories.set(e.nodeModuleName,e);"function"==typeof e.alternativeModuleName&&this._alternatives.push(t=>e.alternativeModuleName(t))}};return e=n([s(2,d.IInstantiationService),s(3,o.IExtHostConfiguration),s(4,h.IExtHostExtensionService),s(5,u.IExtHostInitDataService),s(6,m.ILogService)],e)})();t.RequireInterceptor=f;class g{constructor(e,t,i,n,r){this._apiFactory=e,this._extensionPaths=t,this._extensionRegistry=i,this._configProvider=n,this._logService=r,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(e,t){const i=this._extensionPaths.findSubstr(t.fsPath);if(i){let e=this._extApiImpl.get(c.ExtensionIdentifier.toKey(i.identifier))
;return e||(e=this._apiFactory(i,this._extensionRegistry,this._configProvider),this._extApiImpl.set(c.ExtensionIdentifier.toKey(i.identifier),e)),e}if(!this._defaultApiImpl){let e="";this._extensionPaths.forEach((t,i)=>e+=`\t${i} -> ${t.identifier.value}\n`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${t.fsPath}. These are the extension path mappings: \n${e}`),this._defaultApiImpl=this._apiFactory(a.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=(()=>{let e=class{constructor(e,t){this.nodeModuleName="keytar";const{environment:i}=t,n=e.getProxy(r.MainContext.MainThreadKeytar);if(i.appRoot){let e=i.appRoot.fsPath;"win32"===p.platform&&(e=e.replace(/\\/g,"/")),"/"===e[e.length-1]&&(e=e.substr(0,e.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${e}/node_modules.asar/keytar`),this.alternativeNames.add(`${e}/node_modules/keytar`)}this._impl={getPassword:(e,t)=>n.$getPassword(e,t),
setPassword:(e,t,i)=>n.$setPassword(e,t,i),deletePassword:(e,t)=>n.$deletePassword(e,t),findPassword:e=>n.$findPassword(e),findCredentials:e=>n.$findCredentials(e)}}load(e,t){return this._impl}alternativeModuleName(e){const t=e.length;if(t<=7||!this.alternativeNames)return;const i=t-7;return("/"===e.charAt(i)||"\\"===e.charAt(i))&&e.endsWith("keytar")&&(e=e.replace(/\\/g,"/"),this.alternativeNames.has(e))?"keytar":void 0}};return e=n([s(0,l.IExtHostRpcService),s(1,u.IExtHostInitDataService)],e)})(),_=(()=>{let e=class{constructor(e,t,n){this._extensionPaths=e,this._appUriScheme=t,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=n.getProxy(r.MainContext.MainThreadTelemetry);const o=n.getProxy(r.MainContext.MainThreadWindow);this._impl=(e,t)=>{const n=i.URI.parse(e);return t?this.callOriginal(e,t):"http"===n.scheme||"https"===n.scheme?o.$openUri(n,e,{allowTunneling:!0}):"mailto"===n.scheme||n.scheme===this._appUriScheme?o.$openUri(n,e,{}):this.callOriginal(e,t)}}load(e,t,i){
const n=this._extensionPaths.findSubstr(t.fsPath);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=i(e),this._impl}callOriginal(e,t){return this.sendNoForwardTelemetry(),this._original(e,t)}sendShimmingTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){this._extensionId&&this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};return e=n([s(2,l.IExtHostRpcService)],e)})()})),define(t[66],i([1,0,2,18,16,3,5,10,31,39,30,22,37,14,25,4,20,9,11,52,161]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b,E){"use strict";var x,C,S,k,T,I,D,P,R;Object.defineProperty(t,"__esModule",{value:!0}),
t.IExtHostTask=t.WorkerExtHostTask=t.ExtHostTaskBase=t.TaskExecutionDTO=t.TaskFilterDTO=t.TaskDTO=t.TaskHandleDTO=t.CustomExecutionDTO=t.ShellExecutionDTO=t.ShellExecutionOptionsDTO=t.ProcessExecutionDTO=t.ProcessExecutionOptionsDTO=t.TaskPresentationOptionsDTO=t.TaskDefinitionDTO=void 0,function(e){e.from=function(e){if(null!=e)return e},e.to=function(e){if(null!=e)return e}}(x=t.TaskDefinitionDTO||(t.TaskDefinitionDTO={})),function(e){e.from=function(e){if(null!=e)return e},e.to=function(e){if(null!=e)return e}}(C=t.TaskPresentationOptionsDTO||(t.TaskPresentationOptionsDTO={})),function(e){e.from=function(e){if(null!=e)return e},e.to=function(e){if(null!=e)return e}}(S=t.ProcessExecutionOptionsDTO||(t.ProcessExecutionOptionsDTO={})),function(e){e.is=function(e){if(e){const t=e;return t&&!!t.process}return!1},e.from=function(e){if(null==e)return;const t={process:e.process,args:e.args};return e.options&&(t.options=S.from(e.options)),t},e.to=function(e){
if(null!=e)return new l.ProcessExecution(e.process,e.args,e.options)}}(k=t.ProcessExecutionDTO||(t.ProcessExecutionDTO={})),function(e){e.from=function(e){if(null!=e)return e},e.to=function(e){if(null!=e)return e}}(T=t.ShellExecutionOptionsDTO||(t.ShellExecutionOptionsDTO={})),function(e){e.is=function(e){if(e){const t=e;return t&&(!!t.commandLine||!!t.command)}return!1},e.from=function(e){if(null==e)return;const t={};return void 0!==e.commandLine?t.commandLine=e.commandLine:(t.command=e.command,t.args=e.args),e.options&&(t.options=T.from(e.options)),t},e.to=function(e){if(null!=e&&(void 0!==e.command||void 0!==e.commandLine))return e.commandLine?new l.ShellExecution(e.commandLine,e.options):new l.ShellExecution(e.command,e.args?e.args:[],e.options)}}(I=t.ShellExecutionDTO||(t.ShellExecutionDTO={})),function(e){e.is=function(e){if(e){let t=e;return t&&"customExecution"===t.customExecution}return!1},e.from=function(e){return{customExecution:"customExecution"}}
}(D=t.CustomExecutionDTO||(t.CustomExecutionDTO={})),function(e){e.from=function(e){let t;return void 0!==e.scope&&"number"!=typeof e.scope?t=e.scope.uri:void 0!==e.scope&&"number"==typeof e.scope&&(t=E.USER_TASKS_GROUP_KEY),{id:e._id,workspaceFolder:t}}}(t.TaskHandleDTO||(t.TaskHandleDTO={})),function(e){function t(e,t){if(null==e)return;let i;e.execution instanceof l.ProcessExecution?i=k.from(e.execution):e.execution instanceof l.ShellExecution?i=I.from(e.execution):e.execution&&e.execution instanceof l.CustomExecution&&(i=D.from(e.execution));const n=x.from(e.definition);let r;if(r=e.scope?"number"==typeof e.scope?e.scope:e.scope.uri:l.TaskScope.Workspace,!n||!r)return;const o=e.group?e.group.id:void 0;return{_id:e._id,definition:n,name:e.name,source:{extensionId:t.identifier.value,label:e.source,scope:r},execution:i,isBackground:e.isBackground,group:o,presentationOptions:C.from(e.presentationOptions),problemMatchers:e.problemMatchers,hasDefinedMatchers:e.hasDefinedMatchers,
runOptions:e.runOptions?e.runOptions:{reevaluateOnRerun:!0},detail:e.detail}}e.fromMany=function(e,i){if(null==e)return[];const n=[];for(let r of e){const e=t(r,i);e&&n.push(e)}return n},e.from=t,e.to=async function(e,t){if(null==e)return;let n;k.is(e.execution)?n=k.to(e.execution):I.is(e.execution)&&(n=I.to(e.execution));const r=x.to(e.definition);let o;if(e.source&&(o=void 0!==e.source.scope?"number"==typeof e.source.scope?e.source.scope:await t.resolveWorkspaceFolder(i.URI.revive(e.source.scope)):l.TaskScope.Workspace),!r||!o)return;const s=new l.Task(r,o,e.name,e.source.label,n,e.problemMatchers);return void 0!==e.isBackground&&(s.isBackground=e.isBackground),void 0!==e.group&&(s.group=l.TaskGroup.from(e.group)),e.presentationOptions&&(s.presentationOptions=C.to(e.presentationOptions)),e._id&&(s._id=e._id),e.detail&&(s.detail=e.detail),s}}(P=t.TaskDTO||(t.TaskDTO={})),function(e){e.from=function(e){return e},e.to=function(e){if(e)return r.assign(Object.create(null),e)}
}(R=t.TaskFilterDTO||(t.TaskFilterDTO={}));class A{constructor(e,t,i){this._tasks=e,this._id=t,this._task=i}get task(){return this._task}terminate(){this._tasks.terminateTask(this)}fireDidStartProcess(e){}fireDidEndProcess(e){}}!function(e){e.to=async function(e,t,i){const n=await P.to(e.task,i);if(!n)throw new Error("Unexpected: Task cannot be created.");return new A(t,e.id,n)},e.from=function(e){return{id:e._id,task:void 0}}}(t.TaskExecutionDTO||(t.TaskExecutionDTO={}));let O=(()=>{let e=class{constructor(e,t,i,n,r,o,s,l){this._onDidExecuteTask=new a.Emitter,this._onDidTerminateTask=new a.Emitter,this._onDidTaskProcessStarted=new a.Emitter,this._onDidTaskProcessEnded=new a.Emitter,this._proxy=e.getProxy(c.MainContext.MainThreadTask),this._workspaceProvider=i,this._editorService=n,this._configurationService=r,this._terminalService=o,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,
this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=s,this._deprecationService=l}registerTaskProvider(e,t,i){if(!i)return new l.Disposable(()=>{});const n=this.nextHandle();return this._handlers.set(n,{type:t,provider:i,extension:e}),this._proxy.$registerTaskProvider(n,t),new l.Disposable(()=>{this._handlers.delete(n),this._proxy.$unregisterTaskProvider(n)})}registerTaskSystem(e,t){this._proxy.$registerTaskSystem(e,t)}fetchTasks(e){return this._proxy.$fetchTasks(R.from(e)).then(async e=>{const t=[];for(let i of e){const e=await P.to(i,this._workspaceProvider);e&&t.push(e)}return t})}get taskExecutions(){const e=[];return this._taskExecutions.forEach(t=>e.push(t)),e}terminateTask(e){if(!(e instanceof A))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(e._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async resolveDefinition(e,t){return t}async $onDidStartTask(e,t){var i,n
;const r=this._providedCustomExecutions2.get(e.id);if(r){if(void 0!==this._activeCustomExecutions2.get(e.id))throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(e.id,r),this._terminalService.attachPtyToTerminal(t,await r.callback(await this.resolveDefinition(null===(i=e.task)||void 0===i?void 0:i.source.scope,null===(n=e.task)||void 0===n?void 0:n.definition)))}this._lastStartedTask=e.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(e)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(e){const t=await this.getTaskExecution(e);this._taskExecutionPromises.delete(e.id),this._taskExecutions.delete(e.id),this.customExecutionComplete(e),this._onDidTerminateTask.fire({execution:t})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(e){const t=await this.getTaskExecution(e.id);t&&this._onDidTaskProcessStarted.fire({execution:t,processId:e.processId
})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(e){const t=await this.getTaskExecution(e.id);t&&this._onDidTaskProcessEnded.fire({execution:t,exitCode:e.exitCode})}$provideTasks(e,t){const i=this._handlers.get(e);if(!i)return Promise.reject(new Error("no handler found"));const n=[],r=o.asPromise(()=>i.provider.provideTasks(p.CancellationToken.None)).then(e=>this.provideTasksInternal(t,n,i,e));return new Promise(e=>{r.then(t=>{Promise.all(n).then(()=>{e(t)})})})}async $resolveTask(e,t){const i=this._handlers.get(e);if(!i)return Promise.reject(new Error("no handler found"));if(t.definition.type!==i.type)throw new Error(`Unexpected: Task of type [${t.definition.type}] cannot be resolved by provider of type [${i.type}].`);const n=await P.to(t,this._workspaceProvider);if(!n)throw new Error("Unexpected: Task cannot be resolved.");const r=await i.provider.resolveTask(n,p.CancellationToken.None);if(!r)return;this.checkDeprecation(r,i);const o=P.from(r,i.extension)
;if(!o)throw new Error("Unexpected: Task cannot be resolved.");if(r.definition!==n.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return D.is(o.execution)&&await this.addCustomExecution(o,r,!0),await this.resolveTaskInternal(o)}nextHandle(){return this._handleCounter++}async addCustomExecution(e,t,i){const n=await this._proxy.$createTaskId(e);i||this._providedCustomExecutions2.has(n)||this._notProvidedCustomExecutions.add(n),this._providedCustomExecutions2.set(n,t.execution)}async getTaskExecution(e,t){if("string"==typeof e){const t=this._taskExecutions.get(e);if(!t)throw new Error("Unexpected: The specified task is missing an execution");return t}let i=this._taskExecutionPromises.get(e.id);if(i)return i;const n=new Promise(async(i,n)=>{const r=t||await P.to(e.task,this._workspaceProvider);r?i(new A(this,e.id,r)):n("Unexpected: Task does not exist.")})
;return this._taskExecutionPromises.set(e.id,n),n.then(t=>(this._taskExecutions.set(e.id,t),t))}checkDeprecation(e,t){e._deprecated&&this._deprecationService.report("Task.constructor",t.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(e){this._activeCustomExecutions2.get(e.id)&&this._activeCustomExecutions2.delete(e.id),this._notProvidedCustomExecutions.has(e.id)&&this._lastStartedTask!==e.id&&(this._providedCustomExecutions2.delete(e.id),this._notProvidedCustomExecutions.delete(e.id));let t=this._notProvidedCustomExecutions.values(),i=t.next();for(;!i.done;)this._activeCustomExecutions2.has(i.value)||this._lastStartedTask===i.value||(this._providedCustomExecutions2.delete(i.value),this._notProvidedCustomExecutions.delete(i.value)),i=t.next()}}
;return e=n([s(0,f.IExtHostRpcService),s(1,g.IExtHostInitDataService),s(2,u.IExtHostWorkspace),s(3,d.IExtHostDocumentsAndEditors),s(4,h.IExtHostConfiguration),s(5,m.IExtHostTerminalService),s(6,w.ILogService),s(7,b.IExtHostApiDeprecationService)],e)})();t.ExtHostTaskBase=O;let L=(()=>{let e=class extends O{constructor(e,t,i,n,r,o,s,a){super(e,t,i,n,r,o,s,a),t.remote.isRemote&&t.remote.authority&&this.registerTaskSystem(_.Schemas.vscodeRemote,{scheme:_.Schemas.vscodeRemote,authority:t.remote.authority,platform:y.PlatformToString(0)})}async executeTask(e,t){const i=P.from(t,e);if(void 0===i)return Promise.reject(new Error("Task is not valid"));if(!D.is(i.execution))throw new Error("Not implemented");return await this.addCustomExecution(i,t,!1),this._proxy.$executeTask(i).then(e=>this.getTaskExecution(e,t))}provideTasksInternal(e,t,i,n){const r=[];if(n)for(let o of n){this.checkDeprecation(o,i),
o.definition&&e[o.definition.type]||this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const n=P.from(o,i.extension);n&&D.is(n.execution)?(r.push(n),t.push(this.addCustomExecution(n,o,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:r,extension:i.extension}}async resolveTaskInternal(e){if(D.is(e.execution))return e;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(e,t){return{process:void 0,variables:Object.create(null)}}$getDefaultShellAndArgs(){throw new Error("Not implemented")}async $jsonTasksSupported(){return!1}};return e=n([s(0,f.IExtHostRpcService),s(1,g.IExtHostInitDataService),s(2,u.IExtHostWorkspace),s(3,d.IExtHostDocumentsAndEditors),s(4,h.IExtHostConfiguration),s(5,m.IExtHostTerminalService),s(6,w.ILogService),s(7,b.IExtHostApiDeprecationService)],e)})();t.WorkerExtHostTask=L,t.IExtHostTask=v.createDecorator("IExtHostTask")})),
define(t[234],i([1,0,169,10,155,31,38,39,30,43,37,14,44,136,158]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostDebugService=void 0;let v=(()=>{let e=class extends m.ExtHostDebugServiceBase{constructor(e,t,i,n,r,o,s){super(e,t,i,n,r,s),this._terminalService=o}createDebugAdapter(e,t){switch(e.type){case"server":return new o.SocketDebugAdapter(e);case"executable":return new o.ExecutableDebugAdapter(e,t.type)}return super.createDebugAdapter(e,t)}daExecutableFromPackage(e,t){const i=o.ExecutableDebugAdapter.platformAdapterExecutable(t.getAllExtensionDescriptions(),e.type);if(i)return new r.DebugAdapterExecutable(i.command,i.args,i.options)}createSignService(){return new f.SignService}async $runInTerminal(e){if("integrated"===e.kind){this._terminalDisposedListener||(this._terminalDisposedListener=this._terminalService.onDidCloseTerminal(e=>{
this._integratedTerminalInstance&&this._integratedTerminalInstance===e&&(this._integratedTerminalInstance=void 0)}));let t=!0;if(this._integratedTerminalInstance){const e=await this._integratedTerminalInstance.processId;t=await g.hasChildProcesses(e)}const n=await this._configurationService.getConfigProvider(),r=this._terminalService.getDefaultShell(!0,n);if(t||!this._integratedTerminalInstance){const t={shellPath:r,cwd:e.cwd,name:e.title||i.localize(0,null)};delete e.cwd,this._integratedTerminalInstance=this._terminalService.createTerminalFromOptions(t)}const o=this._integratedTerminalInstance;o.show();const s=await this._integratedTerminalInstance.processId,a=g.prepareCommand(e,r);return o.sendText(a,!0),s}return"external"===e.kind?g.runInExternalTerminal(e,await this._configurationService.getConfigProvider()):super.$runInTerminal(e)}createVariableResolver(e,t,i){return new m.ExtHostVariableResolverService(e,t,i,process.env)}}
;return e=n([s(0,p.IExtHostRpcService),s(1,a.IExtHostWorkspace),s(2,c.IExtHostExtensionService),s(3,l.IExtHostDocumentsAndEditors),s(4,u.IExtHostConfiguration),s(5,h.IExtHostTerminalService),s(6,d.IExtHostCommands)],e)})();t.ExtHostDebugService=v})),define(t[235],i([1,0,7,2,79,31,18,44,39,30,37,14,25,66,20,11,52]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTask=void 0;let y=(()=>{let e=class extends f.ExtHostTaskBase{constructor(e,t,i,n,r,o,s,a){super(e,t,i,n,r,o,s,a),t.remote.isRemote&&t.remote.authority&&this.registerTaskSystem(g.Schemas.vscodeRemote,{scheme:g.Schemas.vscodeRemote,authority:t.remote.authority,platform:process.platform})}async executeTask(e,t){const i=t;if(void 0!==i._id)return this._proxy.$executeTask(f.TaskHandleDTO.from(i)).then(e=>this.getTaskExecution(e,t));{const i=f.TaskDTO.from(t,e)
;return void 0===i?Promise.reject(new Error("Task is not valid")):(f.CustomExecutionDTO.is(i.execution)&&await this.addCustomExecution(i,t,!1),this._proxy.$executeTask(i).then(e=>this.getTaskExecution(e,t)))}}provideTasksInternal(e,t,i,n){const r=[];if(n)for(let o of n){this.checkDeprecation(o,i),o.definition&&e[o.definition.type]||this._logService.warn(`The task [${o.source}, ${o.name}] uses an undefined task type. The task will be ignored in the future.`);const n=f.TaskDTO.from(o,i.extension);n&&(r.push(n),f.CustomExecutionDTO.is(n.execution)&&t.push(this.addCustomExecution(n,o,!0)))}return{tasks:r,extension:i.extension}}async resolveTaskInternal(e){return e}async getVariableResolver(e){if(void 0===this._variableResolver){const t=await this._configurationService.getConfigProvider();this._variableResolver=new l.ExtHostVariableResolverService(e,this._editorService,t,process.env)}return this._variableResolver}async resolveDefinition(e,t){if(!e||"number"==typeof e||!t)return t
;const i=await this._workspaceProvider.resolveWorkspaceFolder(r.URI.revive(e)),n=await this._workspaceProvider.getWorkspaceFolders2();if(!n||!i)return t;const o=await this.getVariableResolver(n),s={uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}},a=c.deepClone(t);for(const e in a)a[e]=o.resolve(s,a[e]);return a}async $resolveVariables(e,t){const n=r.URI.revive(e),s={process:void 0,variables:Object.create(null)},a=await this._workspaceProvider.resolveWorkspaceFolder(n),c=await this._workspaceProvider.getWorkspaceFolders2();if(!c||!a)throw new Error("Unexpected: Tasks can only be run in a workspace folder");const l=await this.getVariableResolver(c),u={uri:a.uri,name:a.name,index:a.index,toResource:()=>{throw new Error("Not implemented")}};for(let e of t.variables)s.variables[e]=l.resolve(u,e);if(void 0!==t.process){let e=void 0;if(void 0!==t.process.path){e=t.process.path.split(i.delimiter);for(let t=0;t<e.length;t++)e[t]=l.resolve(u,e[t])}
s.process=await o.win32.findExecutable(l.resolve(u,t.process.name),void 0!==t.process.cwd?l.resolve(u,t.process.cwd):void 0,e)}return s}$getDefaultShellAndArgs(){return this._terminalService.$getDefaultShellAndArgs(!0)}async $jsonTasksSupported(){return!0}};return e=n([s(0,p.IExtHostRpcService),s(1,m.IExtHostInitDataService),s(2,a.IExtHostWorkspace),s(3,u.IExtHostDocumentsAndEditors),s(4,d.IExtHostConfiguration),s(5,h.IExtHostTerminalService),s(6,v.ILogService),s(7,_.IExtHostApiDeprecationService)],e)})();t.ExtHostTask=y})),define(t[236],i([1,0,88,40,2,9,167,30,11,170,31,44,39,100,82,37,14,164,163]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v,_,y,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostTerminalService=void 0;let b=(()=>{let e=class extends v.BaseExtHostTerminalService{constructor(e,t,i,n,r){super(e),this._extHostConfiguration=t,this._extHostWorkspace=i,this._extHostDocumentsAndEditors=n,this._logService=r,this._environmentVariableCollections=new Map,
this._isWorkspaceShellAllowed=!1,this._updateLastActiveWorkspace(),this._updateVariableResolver(),this._registerListeners()}createTerminal(e,t,i){const n=new v.ExtHostTerminal(this._proxy,{name:e,shellPath:t,shellArgs:i},e);return this._terminals.push(n),n.create(t,i),n}createTerminalFromOptions(e){const t=new v.ExtHostTerminal(this._proxy,e,e.name);return this._terminals.push(t),t.create(e.shellPath,e.shellArgs,e.cwd,e.env,void 0,e.strictEnv,e.hideFromUser),t}getDefaultShell(e,t){return c.getDefaultShell(e=>{const i=t.getConfiguration(e.substr(0,e.lastIndexOf("."))).inspect(e.substr(e.lastIndexOf(".")+1));return this._apiInspectConfigToPlain(i)},this._isWorkspaceShellAllowed,f.getSystemShell(a.platform),process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),process.env.windir,this._lastActiveWorkspace,this._variableResolver,this._logService,e)}getDefaultShellArgs(e,t){return c.getDefaultShellArgs(e=>{const i=t.getConfiguration(e.substr(0,e.lastIndexOf("."))).inspect(e.substr(e.lastIndexOf(".")+1))
;return this._apiInspectConfigToPlain(i)},this._isWorkspaceShellAllowed,e,this._lastActiveWorkspace,this._variableResolver,this._logService)}_apiInspectConfigToPlain(e){return{userValue:e?e.globalValue:void 0,value:e?e.workspaceValue:void 0,defaultValue:e?e.defaultValue:void 0}}async _getNonInheritedEnv(){const e=await g.getMainProcessParentEnv();return e.VSCODE_IPC_HOOK_CLI=process.env.VSCODE_IPC_HOOK_CLI,e}_registerListeners(){this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(()=>this._updateLastActiveWorkspace()),this._extHostWorkspace.onDidChangeWorkspace(()=>this._updateVariableResolver())}_updateLastActiveWorkspace(){const e=this._extHostDocumentsAndEditors.activeEditor();e&&(this._lastActiveWorkspace=this._extHostWorkspace.getWorkspaceFolder(e.document.uri))}async _updateVariableResolver(){const e=await this._extHostConfiguration.getConfigProvider(),t=await this._extHostWorkspace.getWorkspaceFolders2()
;this._variableResolver=new p.ExtHostVariableResolverService(t||[],this._extHostDocumentsAndEditors,e,process.env)}async $spawnExtHostProcess(e,t,n,s,l,u){const h={name:t.name,executable:t.executable,args:t.args,cwd:"string"==typeof t.cwd?t.cwd:o.URI.revive(t.cwd),env:t.env},p=a.isWindows?"windows":a.isMacintosh?"osx":"linux",m=await this._extHostConfiguration.getConfigProvider();if(h.executable){if(this._variableResolver&&(h.executable=this._variableResolver.resolve(this._lastActiveWorkspace,h.executable),h.args))if(Array.isArray(h.args)){const e=[];for(const t of h.args)e.push(this._variableResolver.resolve(this._lastActiveWorkspace,t));h.args=e}else h.args=this._variableResolver.resolve(this._lastActiveWorkspace,h.args)}else h.executable=this.getDefaultShell(!1,m),h.args=this.getDefaultShellArgs(!1,m);const f=o.URI.revive(n);let g;if(n&&f){const e=await this._extHostWorkspace.getWorkspaceFolder(f);e&&(g={uri:e.uri,name:e.name,index:e.index,toResource:()=>{throw new Error("Not implemented")}})}
const v=m.getConfiguration("terminal.integrated"),_=c.getCwd(h,r.homedir(),g,this._variableResolver,f,v.cwd,this._logService);h.cwd=_;const y=this._apiInspectConfigToPlain(m.getConfiguration("terminal.integrated").inspect(`env.${p}`)),b=v.get("inheritEnv",!0)?process.env:await this._getNonInheritedEnv(),E=c.createTerminalEnvironment(h,g,y,this._variableResolver,u,i.default.version,v.get("detectLocale","auto"),b);if(!h.strictEnv){new w.MergedEnvironmentVariableCollection(this._environmentVariableCollections).applyToProcessEnvironment(E)}this._proxy.$sendResolvedLaunchConfig(e,h),this._logService.debug("Terminal process launching on ext host",h,_,s,l,E);this._setupExtHostProcessListeners(e,new d.TerminalProcess(h,_,s,l,E,!1,this._logService))}$getAvailableShells(){return f.detectAvailableShells()}async $getDefaultShellAndArgs(e){const t=await this._extHostConfiguration.getConfigProvider();return{shell:this.getDefaultShell(e,t),args:this.getDefaultShellArgs(e,t)}}$acceptWorkspacePermissionsChanged(e){
this._isWorkspaceShellAllowed=e}getEnvironmentVariableCollection(e){let t=this._environmentVariableCollections.get(e.identifier.value);return t||(t=new v.EnvironmentVariableCollection,this._setEnvironmentVariableCollection(e.identifier.value,t)),t}_syncEnvironmentVariableCollection(e,t){const i=y.serializeEnvironmentVariableCollection(t.map);this._proxy.$setEnvironmentVariableCollection(e,t.persistent,0===i.length?void 0:i)}$initEnvironmentVariableCollections(e){e.forEach(e=>{const t=e[0],i=new v.EnvironmentVariableCollection(e[1]);this._setEnvironmentVariableCollection(t,i)})}_setEnvironmentVariableCollection(e,t){this._environmentVariableCollections.set(e,t),t.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(e,t)})}};return e=n([s(0,_.IExtHostRpcService),s(1,l.IExtHostConfiguration),s(2,h.IExtHostWorkspace),s(3,m.IExtHostDocumentsAndEditors),s(4,u.ILogService)],e)})();t.ExtHostTerminalService=b})),
define(t[237],i([1,0,16,19,6,2,5,224,11,74,68,25,122,14,51,38]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionHostMain=void 0;class g{constructor(e,t,i,o){this._disposables=new r.DisposableStore,this._isTerminating=!1,this._hostUtils=i;const v=new a.RPCProtocol(e,null,o);t=g._transform(t,v);const _=new u.ServiceCollection(...l.getSingletonServiceDescriptors());_.set(d.IExtHostInitDataService,Object.assign({_serviceBrand:void 0},t)),_.set(p.IExtHostRpcService,new p.ExtHostRpcService(v)),_.set(m.IURITransformerService,new m.URITransformerService(o)),_.set(f.IHostUtils,i);const y=new h.InstantiationService(_,!0),w=y.invokeFunction(e=>e.get(c.ILogService));this._disposables.add(w),w.info("extension host started"),w.trace("initData",t),this._extensionService=y.invokeFunction(e=>e.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const b=new WeakMap
;this._extensionService.getExtensionPathIndex().then(e=>{Error.prepareStackTrace=(t,i)=>{let n,r,o="";for(const t of i)o+=`\n\tat ${t.toString()}`,r=t.getFileName(),!n&&r&&(n=e.findSubstr(r));return b.set(t,n),`${t.name||"Error"}: ${t.message||""}${o}`}});const E=v.getProxy(s.MainContext.MainThreadExtensionService),x=v.getProxy(s.MainContext.MainThreadErrors);n.setUnexpectedErrorHandler(e=>{const t=n.transformErrorForSerialization(e),i=b.get(e);i?E.$onExtensionRuntimeError(i.identifier,t):x.$onUnexpectedError(t)})}terminate(){if(this._isTerminating)return;this._isTerminating=!0,this._disposables.dispose(),n.setUnexpectedErrorHandler(e=>{});const e=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([i.timeout(4e3),e]).finally(()=>this._hostUtils.exit())},1e3)}static _transform(e,t){e.extensions.forEach(e=>e.extensionLocation=o.URI.revive(t.transformIncomingURIs(e.extensionLocation))),e.environment.appRoot=o.URI.revive(t.transformIncomingURIs(e.environment.appRoot)),
e.environment.appSettingsHome=o.URI.revive(t.transformIncomingURIs(e.environment.appSettingsHome));const i=e.environment.extensionDevelopmentLocationURI;return i&&(e.environment.extensionDevelopmentLocationURI=i.map(e=>o.URI.revive(t.transformIncomingURIs(e)))),e.environment.extensionTestsLocationURI=o.URI.revive(t.transformIncomingURIs(e.environment.extensionTestsLocationURI)),e.environment.globalStorageHome=o.URI.revive(t.transformIncomingURIs(e.environment.globalStorageHome)),e.environment.userHome=o.URI.revive(t.transformIncomingURIs(e.environment.userHome)),e.logsLocation=o.URI.revive(t.transformIncomingURIs(e.logsLocation)),e.logFile=o.URI.revive(t.transformIncomingURIs(e.logFile)),e.workspace=t.transformIncomingURIs(e.workspace),e}}t.ExtensionHostMain=g})),define(t[238],i([1,0,7,22,46,27,23,63,33,36]),(function(e,t,i,n,r,o,s,a,c,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileSearchManager=void 0;class u{constructor(e,t,i){this.config=e,this.provider=t,this.sessionToken=i,
this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=e.filePattern,this.includePattern=e.includePattern&&o.parse(e.includePattern),this.maxResults=e.maxResults||void 0,this.exists=e.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=e.excludePattern&&o.parse(e.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(e=>e.cancel()),this.activeCancellationTokens=new Set}search(e){const t=this.config.folderQueries||[];return new Promise((n,o)=>{const s=t=>{this.resultCount++,e(t)};if(this.isCanceled)return n({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(e=>{const t=e.toString(),n=i.basename(t);this.globalExcludePattern&&this.globalExcludePattern(t,n)||this.matchFile(s,{base:e,basename:n})}),Promise.all(t.map(e=>this.searchInFolder(e,s))).then(e=>{n({limitHit:this.isLimitHit,stats:e[0]||void 0})},e=>{o(new Error(r.toErrorMessage(e)))})})}searchInFolder(e,t){const r=new n.CancellationTokenSource
;return new Promise((n,o)=>{const s=this.getSearchOptionsForFolder(e),u=this.initDirectoryTree(),d=new c.QueryGlobTester(this.config,e),h=!d.hasSiblingExcludeClauses();let p;new Promise(e=>l.nextTick(e)).then(()=>(this.activeCancellationTokens.add(r),p=a.StopWatch.create(),this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},s,r.token))).then(n=>{const o=p.elapsed(),s=a.StopWatch.create();return this.isCanceled&&!this.isLimitHit?null:(n&&n.forEach(n=>{const r=i.posix.relative(e.folder.path,n.path);if(h){const o=i.basename(n.path);this.matchFile(t,{base:e.folder,relativePath:r,basename:o})}else this.addDirectoryEntries(u,e.folder,r,t)}),this.activeCancellationTokens.delete(r),this.isCanceled&&!this.isLimitHit?null:(this.matchDirectoryTree(u,d,t),{providerTime:o,postProcessTime:s.elapsed()}))}).then(e=>{r.dispose(),n(e)},e=>{r.dispose(),o(e)})})}getSearchOptionsForFolder(e){
const t=c.resolvePatternsForProvider(this.config.includePattern,e.includePattern),i=c.resolvePatternsForProvider(this.config.excludePattern,e.excludePattern);return{folder:e.folder,excludes:i,includes:t,useIgnoreFiles:!e.disregardIgnoreFiles,useGlobalIgnoreFiles:!e.disregardGlobalIgnoreFiles,followSymlinks:!e.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const e={rootEntries:[],pathToEntries:Object.create(null)};return e.pathToEntries["."]=e.rootEntries,e}addDirectoryEntries({pathToEntries:e},t,n,r){if(n===this.filePattern){const e=i.basename(this.filePattern);this.matchFile(r,{base:t,relativePath:this.filePattern,basename:e})}!function n(r){const o=i.basename(r),s=i.dirname(r);let a=e[s];a||(a=e[s]=[],n(s)),a.push({base:t,relativePath:r,basename:o})}(n)}matchDirectoryTree({rootEntries:e,pathToEntries:t},i,n){const r=this,s=this.filePattern;!function e(a){const c=o.hasSiblingFn(()=>a.map(e=>e.basename));for(let o=0,l=a.length;o<l;o++){
const l=a[o],{relativePath:u,basename:d}=l;if(!i.includedInQuerySync(u,d,s!==d?c:void 0))continue;const h=t[u];if(h)e(h);else{if(u===s)continue;r.matchFile(n,l)}if(r.isLimitHit)break}}(e)}matchFile(e,t){(!this.includePattern||t.relativePath&&this.includePattern(t.relativePath,t.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||e(t))}}let d=(()=>{class e{constructor(){this.sessions=new Map}fileSearch(t,i,n,r){const o=this.getSessionTokenSource(t.cacheKey),s=new u(t,i,o&&o.token);let a=0;return this.doSearch(s,e.BATCH_SIZE,e=>{a+=e.length,n(e.map(e=>this.rawMatchToSearchItem(e)))},r).then(e=>({limitHit:e.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:a,detailStats:e.stats}}))}clearCache(e){const t=this.getSessionTokenSource(e);t&&t.cancel()}getSessionTokenSource(e){if(e)return this.sessions.has(e)||this.sessions.set(e,new n.CancellationTokenSource),this.sessions.get(e)}rawMatchToSearchItem(e){
return e.relativePath?{resource:s.joinPath(e.base,e.relativePath)}:{resource:e.base}}doSearch(e,t,i,n){n.onCancellationRequested(()=>{e.cancel()});let r=[];return e.search(e=>{e&&(r.push(e),t>0&&r.length>=t&&(i(r),r=[]))}).then(e=>(r.length&&i(r),e),e=>(r.length&&i(r),Promise.reject(e)))}}return e.BATCH_SIZE=512,e})();t.FileSearchManager=d})),define(t[114],i([1,0]),(function(e,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=t.Position=void 0;class i{constructor(e,t){this.line=e,this.character=t}isBefore(e){return!1}isBeforeOrEqual(e){return!1}isAfter(e){return!1}isAfterOrEqual(e){return!1}isEqual(e){return!1}compareTo(e){return 0}translate(e,t){return new i(0,0)}with(e){return new i(0,0)}}t.Position=i;class n{constructor(e,t,n,r){this.isEmpty=!1,this.isSingleLine=!1,this.start=new i(e,t),this.end=new i(n,r)}contains(e){return!1}isEqual(e){return!1}intersection(e){}union(e){return new n(0,0,0,0)}with(e){return new n(0,0,0,0)}}t.Range=n})),
define(t[115],i([1,0,7,13,22,46,23,27,2,33,36]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BatchedCollector=t.extensionResultIsMatch=t.TextSearchResultsCollector=t.TextSearchManager=void 0;t.TextSearchManager=class{constructor(e,t,i){this.query=e,this.provider=t,this.fileUtils=i,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(e,t){const i=this.query.folderQueries||[],n=new r.CancellationTokenSource;return t.onCancellationRequested(()=>n.cancel()),new Promise((t,r)=>{this.collector=new d(e);let s=!1;const a=(e,t)=>{if(!s&&!this.isLimitHit){const i=this.resultSize(e);h(e)&&"number"==typeof this.query.maxResults&&this.resultCount+i>this.query.maxResults&&(this.isLimitHit=!0,s=!0,n.cancel(),e=this.trimResultToSize(e,this.query.maxResults-this.resultCount));const r=this.resultSize(e);this.resultCount+=r,r>0&&this.collector.add(e,t)}};Promise.all(i.map((e,t)=>this.searchInFolder(e,e=>a(e,t),n.token))).then(e=>{n.dispose(),this.collector.flush()
;const i=e.some(e=>!!e&&!!e.limitHit);t({limitHit:this.isLimitHit||i,stats:{type:"textSearchProvider"}})},e=>{n.dispose();const t=o.toErrorMessage(e);r(new Error(t))})})}resultSize(e){const t=e;return Array.isArray(t.ranges)?t.ranges.length:1}trimResultToSize(e,t){const i=Array.isArray(e.ranges)?e.ranges:[e.ranges],n=Array.isArray(e.preview.matches)?e.preview.matches:[e.preview.matches];return{ranges:i.slice(0,t),preview:{matches:n.slice(0,t),text:e.preview.text},uri:e.uri}}searchInFolder(e,t,n){const r=new l.QueryGlobTester(this.query,e),o=[],c={report:n=>{if(!this.validateProviderResult(n))return;const c="file"===e.folder.scheme?a.hasSiblingPromiseFn(()=>this.fileUtils.readdir(s.dirname(n.uri))):void 0,l=s.relativePath(e.folder,n.uri);l&&o.push(r.includedInQuery(l,i.basename(l),c).then(e=>{e&&t(n)}))}},d=this.getSearchOptionsForFolder(e);return new Promise(e=>u.nextTick(e)).then(()=>this.provider.provideTextSearchResults(function(e){return{isCaseSensitive:e.isCaseSensitive||!1,isRegExp:e.isRegExp||!1,
isWordMatch:e.isWordMatch||!1,isMultiline:e.isMultiline||!1,pattern:e.pattern}}(this.query.contentPattern),d,c,n)).then(e=>Promise.all(o).then(()=>e))}validateProviderResult(e){if(h(e))if(Array.isArray(e.ranges)){if(!Array.isArray(e.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(e.preview.matches.length!==e.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(e.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1;return!0}getSearchOptionsForFolder(e){const t=l.resolvePatternsForProvider(this.query.includePattern,e.includePattern),i=l.resolvePatternsForProvider(this.query.excludePattern,e.excludePattern),n={folder:c.URI.from(e.folder),excludes:i,includes:t,useIgnoreFiles:!e.disregardIgnoreFiles,
useGlobalIgnoreFiles:!e.disregardGlobalIgnoreFiles,followSymlinks:!e.ignoreSymlinks,encoding:e.fileEncoding&&this.fileUtils.toCanonicalName(e.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return n.usePCRE2=this.query.usePCRE2,n}};class d{constructor(e){this._onResult=e,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new p(512,e=>this.sendItems(e))}add(e,t){!this._currentFileMatch||this._currentFolderIdx===t&&s.isEqual(this._currentUri,e.uri)||(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=t,this._currentFileMatch={resource:e.uri,results:[]}),this._currentFileMatch.results.push(function(e){return h(e)?{preview:{matches:n.mapArrayOrNot(e.preview.matches,e=>({startLineNumber:e.start.line,startColumn:e.start.character,endLineNumber:e.end.line,endColumn:e.end.character})),
text:e.preview.text},ranges:n.mapArrayOrNot(e.ranges,e=>({startLineNumber:e.start.line,startColumn:e.start.character,endLineNumber:e.end.line,endColumn:e.end.character}))}:{text:e.text,lineNumber:e.lineNumber}}(e))}pushToCollector(){const e=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,e)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(e){this._onResult(e)}}function h(e){return!!e.preview}t.TextSearchResultsCollector=d,t.extensionResultIsMatch=h;let p=(()=>{class e{constructor(e,t){this.maxBatchSize=e,this.cb=t,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(e,t){e&&this.addItemToBatch(e,t)}addItems(e,t){e&&this.addItemsToBatch(e,t)}addItemToBatch(e,t){this.batch.push(e),this.batchSize+=t,this.onUpdate()}addItemsToBatch(e,t){this.batch=this.batch.concat(e),this.batchSize+=t,this.onUpdate()}onUpdate(){
this.totalNumberCompleted<e.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},e.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}return e.TIMEOUT=4e3,e.START_BATCH_AFTER_COUNT=50,e})();t.BatchedCollector=p})),define(t[65],i([1,0,6,5,4,238,14,51,11,2,115]),(function(e,t,i,r,o,a,c,l,u,d,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.reviveQuery=t.ExtHostSearch=t.IExtHostSearch=void 0,t.IExtHostSearch=o.createDecorator("IExtHostSearch");let p=(()=>{let e=class{constructor(e,t,i){this.extHostRpc=e,this._uriTransformer=t,this._logService=i,this._proxy=this.extHostRpc.getProxy(r.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,
this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new a.FileSearchManager}_transformScheme(e){return this._uriTransformer.transformOutgoingScheme(e)}registerTextSearchProvider(e,t){if(this._textSearchUsedSchemes.has(e))throw new Error(`a text search provider for the scheme '${e}' is already registered`);this._textSearchUsedSchemes.add(e);const n=this._handlePool++;return this._textSearchProvider.set(n,t),this._proxy.$registerTextSearchProvider(n,this._transformScheme(e)),i.toDisposable(()=>{this._textSearchUsedSchemes.delete(e),this._textSearchProvider.delete(n),this._proxy.$unregisterProvider(n)})}registerFileSearchProvider(e,t){if(this._fileSearchUsedSchemes.has(e))throw new Error(`a file search provider for the scheme '${e}' is already registered`);this._fileSearchUsedSchemes.add(e);const n=this._handlePool++;return this._fileSearchProvider.set(n,t),this._proxy.$registerFileSearchProvider(n,this._transformScheme(e)),i.toDisposable(()=>{this._fileSearchUsedSchemes.delete(e),
this._fileSearchProvider.delete(n),this._proxy.$unregisterProvider(n)})}$provideFileSearchResults(e,t,i,n){const r=m(i),o=this._fileSearchProvider.get(e);if(o)return this._fileSearchManager.fileSearch(r,o,i=>{this._proxy.$handleFileMatch(e,t,i.map(e=>e.resource))},n);throw new Error("unknown provider: "+e)}$clearCache(e){return this._fileSearchManager.clearCache(e),Promise.resolve(void 0)}$provideTextSearchResults(e,t,i,n){const r=this._textSearchProvider.get(e);if(!r||!r.provideTextSearchResults)throw new Error(`Unknown provider ${e}`);const o=m(i);return this.createTextSearchManager(o,r).search(i=>this._proxy.$handleTextMatch(e,t,i),n)}createTextSearchManager(e,t){return new h.TextSearchManager(e,t,{readdir:e=>Promise.resolve([]),toCanonicalName:e=>e})}};return e=n([s(0,c.IExtHostRpcService),s(1,l.IURITransformerService),s(2,u.ILogService)],e)})();function m(e){return Object.assign(Object.assign({},e),{folderQueries:e.folderQueries&&e.folderQueries.map(f),
extraFileResources:e.extraFileResources&&e.extraFileResources.map(e=>d.URI.revive(e))})}function f(e){return Object.assign(Object.assign({},e),{folder:d.URI.revive(e.folder)})}t.ExtHostSearch=p,t.reviveQuery=m})),define(t[242],i([1,0,138,22,19,3,7,81,2,125,123,120,70,45,5,177,192,43,194,30,196,197,198,178,199,39,38,201,202,204,205,206,60,179,209,210,211,76,37,214,185,21,10,217,218,219,31,42,23,117,150,203,91,108,66,44,65,11,51,14,25,207,146,54,52,191,215,160,58]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b,E,x,C,S,k,T,I,D,P,R,A,O,L,M,N,F,U,H,$,W,z,B,j,V,K,q,G,X,Q,Y,J,Z,ee,te,ie,ne,re,oe,se,ae,ce,le,ue,de,he,pe,me){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createApiFactoryAndRegisterActors=void 0,t.createApiFactoryAndRegisterActors=function(e){
const t=e.get(se.IExtHostInitDataService),s=e.get(k.IExtHostExtensionService),G=e.get(K.IExtHostWorkspace),ge=e.get(y.IExtHostConfiguration),ve=e.get(re.IURITransformerService),_e=e.get(oe.IExtHostRpcService),ye=e.get(F.IExtHostStorage),we=e.get(me.IExtensionStoragePaths),be=e.get(ne.ILogService),Ee=e.get(le.IExtHostTunnelService),xe=e.get(ue.IExtHostApiDeprecationService);_e.set(m.ExtHostContext.ExtHostLogService,be),_e.set(m.ExtHostContext.ExtHostWorkspace,G),_e.set(m.ExtHostContext.ExtHostConfiguration,ge),_e.set(m.ExtHostContext.ExtHostExtensionService,s),_e.set(m.ExtHostContext.ExtHostStorage,ye),_e.set(m.ExtHostContext.ExtHostTunnelService,Ee)
;const Ce=_e.set(m.ExtHostContext.ExtHostDecorations,e.get(Z.IExtHostDecorations)),Se=_e.set(m.ExtHostContext.ExtHostDocumentsAndEditors,e.get(S.IExtHostDocumentsAndEditors)),ke=_e.set(m.ExtHostContext.ExtHostCommands,e.get(v.IExtHostCommands)),Te=_e.set(m.ExtHostContext.ExtHostTerminalService,e.get(U.IExtHostTerminalService)),Ie=_e.set(m.ExtHostContext.ExtHostDebugService,e.get(te.IExtHostDebugService)),De=_e.set(m.ExtHostContext.ExtHostSearch,e.get(ie.IExtHostSearch)),Pe=_e.set(m.ExtHostContext.ExtHostTask,e.get(ee.IExtHostTask)),Re=_e.set(m.ExtHostContext.ExtHostOutputService,e.get(A.IExtHostOutputService)),Ae=_e.set(m.ExtHostContext.ExtHostUrls,new B.ExtHostUrls(_e)),Oe=_e.set(m.ExtHostContext.ExtHostDocuments,new C.ExtHostDocuments(_e,Se)),Le=_e.set(m.ExtHostContext.ExtHostDocumentContentProviders,new E.ExtHostDocumentContentProvider(_e,Se,be)),Me=_e.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new x.ExtHostDocumentSaveParticipant(be,Oe,_e.getProxy(m.MainContext.MainThreadTextEditors))),Ne=_e.set(m.ExtHostContext.ExtHostEditors,new H.ExtHostEditors(_e,Se)),Fe=_e.set(m.ExtHostContext.ExtHostTreeViews,new $.ExtHostTreeViews(_e.getProxy(m.MainContext.MainThreadTreeViews),ke,be)),Ue=_e.set(m.ExtHostContext.ExtHostEditorInsets,new Q.ExtHostEditorInsets(_e.getProxy(m.MainContext.MainThreadEditorInsets),Ne,t.environment)),He=_e.set(m.ExtHostContext.ExtHostDiagnostics,new w.ExtHostDiagnostics(_e,be)),$e=_e.set(m.ExtHostContext.ExtHostLanguageFeatures,new D.ExtHostLanguageFeatures(_e,ve,Oe,ke,He,be,xe)),We=_e.set(m.ExtHostContext.ExtHostFileSystem,new T.ExtHostFileSystem(_e,$e)),ze=_e.set(m.ExtHostContext.ExtHostFileSystemEventService,new I.ExtHostFileSystemEventService(_e,be,Se)),Be=_e.set(m.ExtHostContext.ExtHostQuickOpen,new L.ExtHostQuickOpen(_e,G,ke)),je=_e.set(m.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(_e,ke,be)),Ve=_e.set(m.ExtHostContext.ExtHostComments,new _.ExtHostComments(_e,ke,Oe)),Ke=_e.set(m.ExtHostContext.ExtHostWindow,new V.ExtHostWindow(_e)),qe=_e.set(m.ExtHostContext.ExtHostProgress,new O.ExtHostProgress(_e.getProxy(m.MainContext.MainThreadProgress))),Ge=_e.set(m.ExtHostContext.ExtHosLabelService,new Y.ExtHostLabelService(_e)),Xe=_e.set(m.ExtHostContext.ExtHostNotebook,new ae.ExtHostNotebookController(_e,ke,Se,t.environment)),Qe=_e.set(m.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(_e)),Ye=_e.set(m.ExtHostContext.ExtHostAuthentication,new de.ExtHostAuthentication(_e)),Je=_e.set(m.ExtHostContext.ExtHostTimeline,new he.ExtHostTimeline(_e,ke)),Ze=_e.set(m.ExtHostContext.ExtHostWebviews,new j.ExtHostWebviews(_e,t.environment,G,be,xe,Oe,we)),et=X.values(m.ExtHostContext)
;_e.assertRegistered(et);const tt=new g.ExtHostClipboard(_e),it=new R.ExtHostMessageService(_e,be),nt=new b.ExtHostDialogs(_e),rt=new N.ExtHostStatusBar(_e,ke.converter),ot=new P.ExtHostLanguages(_e,Oe);return f.ExtHostApiCommands.register(ke),function(e,f,g){const v=function(){let t=!e.isUnderDevelopment;function i(i){t||(be.info(`Extension '${e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),t=!0)}return function t(n){return Array.isArray(n)?n.forEach(t):"string"==typeof n?i():(void 0===n.scheme&&i(),e.enableProposedApi||"boolean"!=typeof n.exclusive||q.throwProposedApiError(e)),n}}(),_={registerAuthenticationProvider:e=>Ye.registerAuthenticationProvider(e),get onDidChangeAuthenticationProviders(){return Ye.onDidChangeAuthenticationProviders},getProviderIds:()=>Ye.getProviderIds(),get providerIds(){return Ye.providerIds},hasSessions:(e,t)=>Ye.hasSessions(e,t),getSession:(t,i,n)=>Ye.getSession(e,t,i,n),
getSessions:(t,i)=>Ye.getSessions(e,t,i),login:(t,i)=>Ye.login(e,t,i),logout:(e,t)=>Ye.logout(e,t),get onDidChangeSessions(){return Ye.onDidChangeSessions}},y={registerCommand:(e,t,i)=>ke.registerCommand(!0,e,t,i),registerTextEditorCommand:(e,t,i)=>ke.registerCommand(!0,e,(...n)=>{const r=Ne.getActiveTextEditor();if(r)return r.edit(e=>{t.apply(i,[r,e,...n])}).then(t=>{t||be.warn("Edits from command "+e+" were not applied.")},t=>{be.warn("An error occurred while running command "+e,t)});be.warn("Cannot execute "+e+" because there is no active text editor.")}),registerDiffInformationCommand:(t,i,n)=>(q.checkProposedApiEnabled(e),ke.registerCommand(!0,t,async(...e)=>{const r=Ne.getActiveTextEditor();if(!r)return void be.warn("Cannot execute "+t+" because there is no active text editor.");const o=await Ne.getDiffInformation(r.id);i.apply(n,[o,...e])})),executeCommand:(e,...t)=>ke.executeCommand(e,...t),getCommands:(e=!1)=>ke.getCommands(e)},w={get machineId(){return t.telemetryInfo.machineId},get sessionId(){
return t.telemetryInfo.sessionId},get language(){return t.environment.appLanguage},get appName(){return t.environment.appName},get appRoot(){var e,i;return null!==(i=null===(e=t.environment.appRoot)||void 0===e?void 0:e.fsPath)&&void 0!==i?i:"<UNKNOWN_APP_ROOT>"},get uriScheme(){return t.environment.appUriScheme},get logLevel(){return q.checkProposedApiEnabled(e),W.LogLevel.to(be.getLevel())},get onDidChangeLogLevel(){return q.checkProposedApiEnabled(e),o.Event.map(be.onDidChangeLogLevel,e=>W.LogLevel.to(e))},get clipboard(){return tt},get shell(){return Te.getDefaultShell(!1,g)},openExternal:e=>Ke.openUri(e,{allowTunneling:!!t.remote.authority}),asExternalUri:e=>e.scheme===t.environment.appUriScheme?Ae.createAppUri(e):Ke.asExternalUri(e,{allowTunneling:!!t.remote.authority}),get remoteName(){return J.getRemoteName(t.remote.authority)},get uiKind(){return t.uiKind}};t.environment.extensionTestsLocationURI||Object.freeze(w);const b=t.remote.isRemote?z.ExtensionKind.Workspace:z.ExtensionKind.UI,E={
getExtension(t){const i=f.getExtensionDescription(t);if(i)return new fe(s,e.identifier,i,b)},get all(){return f.getAllExtensionDescriptions().map(t=>new fe(s,e.identifier,t,b))},get onDidChange(){return f.onDidChange}},x={createDiagnosticCollection:t=>He.createDiagnosticCollection(e.identifier,t),get onDidChangeDiagnostics(){return He.onDidChangeDiagnostics},getDiagnostics:e=>He.getDiagnostics(e),getLanguages:()=>ot.getLanguages(),setTextDocumentLanguage:(e,t)=>ot.changeLanguage(e.uri,t),match:(e,t)=>h.score(W.LanguageSelector.from(e),t.uri,t.languageId,!0),registerCodeActionsProvider:(t,i,n)=>$e.registerCodeActionProvider(e,v(t),i,n),registerCodeLensProvider:(t,i)=>$e.registerCodeLensProvider(e,v(t),i),registerDefinitionProvider:(t,i)=>$e.registerDefinitionProvider(e,v(t),i),registerDeclarationProvider:(t,i)=>$e.registerDeclarationProvider(e,v(t),i),registerImplementationProvider:(t,i)=>$e.registerImplementationProvider(e,v(t),i),
registerTypeDefinitionProvider:(t,i)=>$e.registerTypeDefinitionProvider(e,v(t),i),registerHoverProvider:(t,i)=>$e.registerHoverProvider(e,v(t),i,e.identifier),registerEvaluatableExpressionProvider:(t,i)=>$e.registerEvaluatableExpressionProvider(e,v(t),i,e.identifier),registerDocumentHighlightProvider:(t,i)=>$e.registerDocumentHighlightProvider(e,v(t),i),registerOnTypeRenameProvider:(t,i,n)=>(q.checkProposedApiEnabled(e),$e.registerOnTypeRenameProvider(e,v(t),i,n)),registerReferenceProvider:(t,i)=>$e.registerReferenceProvider(e,v(t),i),registerRenameProvider:(t,i)=>$e.registerRenameProvider(e,v(t),i),registerDocumentSymbolProvider:(t,i,n)=>$e.registerDocumentSymbolProvider(e,v(t),i,n),registerWorkspaceSymbolProvider:t=>$e.registerWorkspaceSymbolProvider(e,t),registerDocumentFormattingEditProvider:(t,i)=>$e.registerDocumentFormattingEditProvider(e,v(t),i),registerDocumentRangeFormattingEditProvider:(t,i)=>$e.registerDocumentRangeFormattingEditProvider(e,v(t),i),
registerOnTypeFormattingEditProvider:(t,i,n,...r)=>$e.registerOnTypeFormattingEditProvider(e,v(t),i,[n].concat(r)),registerDocumentSemanticTokensProvider:(t,i,n)=>$e.registerDocumentSemanticTokensProvider(e,v(t),i,n),registerDocumentRangeSemanticTokensProvider:(t,i,n)=>$e.registerDocumentRangeSemanticTokensProvider(e,v(t),i,n),registerSignatureHelpProvider:(t,i,n,...r)=>"object"==typeof n?$e.registerSignatureHelpProvider(e,v(t),i,n):$e.registerSignatureHelpProvider(e,v(t),i,void 0===n?[]:[n,...r]),registerCompletionItemProvider:(t,i,...n)=>$e.registerCompletionItemProvider(e,v(t),i,n),registerDocumentLinkProvider:(t,i)=>$e.registerDocumentLinkProvider(e,v(t),i),registerColorProvider:(t,i)=>$e.registerColorProvider(e,v(t),i),registerFoldingRangeProvider:(t,i)=>$e.registerFoldingRangeProvider(e,v(t),i),registerSelectionRangeProvider:(t,i)=>$e.registerSelectionRangeProvider(e,t,i),registerCallHierarchyProvider:(t,i)=>$e.registerCallHierarchyProvider(e,t,i),
setLanguageConfiguration:(t,i)=>$e.setLanguageConfiguration(e,t,i),getTokenInformationAtPosition:(t,i)=>(q.checkProposedApiEnabled(e),ot.tokenAtPosition(t,i))},C={get activeTextEditor(){return Ne.getActiveTextEditor()},get visibleTextEditors(){return Ne.getVisibleTextEditors()},get activeTerminal(){return Te.activeTerminal},get terminals(){return Te.terminals},showTextDocument(e,t,i){let n;return(n=c.URI.isUri(e)?Promise.resolve(S.openTextDocument(e)):Promise.resolve(e)).then(e=>Ne.showTextDocument(e,t,i))},createTextEditorDecorationType:e=>Ne.createTextEditorDecorationType(e),onDidChangeActiveTextEditor:(e,t,i)=>Ne.onDidChangeActiveTextEditor(e,t,i),onDidChangeVisibleTextEditors:(e,t,i)=>Ne.onDidChangeVisibleTextEditors(e,t,i),onDidChangeTextEditorSelection:(e,t,i)=>Ne.onDidChangeTextEditorSelection(e,t,i),onDidChangeTextEditorOptions:(e,t,i)=>Ne.onDidChangeTextEditorOptions(e,t,i),onDidChangeTextEditorVisibleRanges:(e,t,i)=>Ne.onDidChangeTextEditorVisibleRanges(e,t,i),
onDidChangeTextEditorViewColumn:(e,t,i)=>Ne.onDidChangeTextEditorViewColumn(e,t,i),onDidCloseTerminal:(e,t,i)=>Te.onDidCloseTerminal(e,t,i),onDidOpenTerminal:(e,t,i)=>Te.onDidOpenTerminal(e,t,i),onDidChangeActiveTerminal:(e,t,i)=>Te.onDidChangeActiveTerminal(e,t,i),onDidChangeTerminalDimensions:(t,i,n)=>(q.checkProposedApiEnabled(e),Te.onDidChangeTerminalDimensions(t,i,n)),onDidWriteTerminalData:(t,i,n)=>(q.checkProposedApiEnabled(e),Te.onDidWriteTerminalData(t,i,n)),get state(){return Ke.state},onDidChangeWindowState:(e,t,i)=>Ke.onDidChangeWindowState(e,t,i),showInformationMessage:(t,...i)=>it.showMessage(e,a.default.Info,t,i[0],i.slice(1)),showWarningMessage:(t,...i)=>it.showMessage(e,a.default.Warning,t,i[0],i.slice(1)),showErrorMessage:(t,...i)=>it.showMessage(e,a.default.Error,t,i[0],i.slice(1)),showQuickPick:(t,i,n)=>Be.showQuickPick(t,!!e.enableProposedApi,i,n),showWorkspaceFolderPick:e=>Be.showWorkspaceFolderPick(e),showInputBox:(e,t)=>Be.showInput(e,t),showOpenDialog:e=>nt.showOpenDialog(e),
showSaveDialog:e=>nt.showSaveDialog(e),createStatusBarItem(t,n){let r,o,s,a=void 0;return t&&"number"!=typeof t?(r=t.id,o=t.name,s=t.alignment,n=t.priority,a=t.accessibilityInformation):(r=e.identifier.value,o=i.localize(0,null,e.displayName||e.name),s=t,n=n),rt.createStatusBarEntry(r,o,s,n,a)},setStatusBarMessage:(e,t)=>rt.setStatusBarMessage(e,t),withScmProgress:t=>(xe.report("window.withScmProgress",e,"Use 'withProgress' instead."),qe.withProgress(e,{location:z.ProgressLocation.SourceControl},(e,i)=>t({report(e){}}))),withProgress:(t,i)=>qe.withProgress(e,t,i),createOutputChannel:e=>Re.createOutputChannel(e),createWebviewPanel:(t,i,n,r)=>Ze.createWebviewPanel(e,t,i,n,r),createWebviewTextEditorInset:(t,i,n,r)=>(q.checkProposedApiEnabled(e),Ue.createWebviewEditorInset(t,i,n,r,e)),createTerminal:(e,t,i)=>"object"==typeof e?"pty"in e?Te.createExtensionTerminal(e):Te.createTerminalFromOptions(e):Te.createTerminal(e,t,i),registerTerminalLinkHandler:t=>(q.checkProposedApiEnabled(e),Te.registerLinkHandler(t)),
registerTreeDataProvider:(t,i)=>Fe.registerTreeDataProvider(t,i,e),createTreeView:(t,i)=>Fe.createTreeView(t,i,e),registerWebviewPanelSerializer:(t,i)=>Ze.registerWebviewPanelSerializer(e,t,i),registerCustomEditorProvider:(t,i,n={})=>Ze.registerCustomEditorProvider(e,t,i,n),registerDecorationProvider:t=>(q.checkProposedApiEnabled(e),Ce.registerDecorationProvider(t,e.identifier)),registerUriHandler:t=>Ae.registerUriHandler(e.identifier,t),createQuickPick:()=>Be.createQuickPick(e.identifier,!!e.enableProposedApi),createInputBox:()=>Be.createInputBox(e.identifier),get activeColorTheme(){return Qe.activeColorTheme},onDidChangeActiveColorTheme:(e,t,i)=>Qe.onDidChangeActiveColorTheme(e,t,i)},S={get rootPath(){return xe.report("workspace.rootPath",e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),G.getPath()},set rootPath(e){throw r.readonly()},getWorkspaceFolder:e=>G.getWorkspaceFolder(e),get workspaceFolders(){return G.getWorkspaceFolders()},get name(){
return G.name},set name(e){throw r.readonly()},get workspaceFile(){return G.workspaceFile},set workspaceFile(e){throw r.readonly()},updateWorkspaceFolders:(t,i,...n)=>G.updateWorkspaceFolders(e,t,i||0,...n),onDidChangeWorkspaceFolders:function(e,t,i){return G.onDidChangeWorkspace(e,t,i)},asRelativePath:(e,t)=>G.getRelativePath(e,t),findFiles:(t,i,n,r)=>G.findFiles(W.GlobPattern.from(t),W.GlobPattern.from(i),n,e.identifier,r),findTextInFiles:(t,i,n,r)=>{let o,s;return"object"==typeof i?(o=i,s=n):(o={},s=i,r=n),G.findTextInFiles(t,o||{},s,e.identifier,r)},saveAll:e=>G.saveAll(e),applyEdit:e=>Ne.applyWorkspaceEdit(e),createFileSystemWatcher:(e,t,i,n)=>ze.createFileSystemWatcher(W.GlobPattern.from(e),t,i,n),get textDocuments(){return Oe.getAllDocumentData().map(e=>e.document)},set textDocuments(e){throw r.readonly()},openTextDocument(e){let t;const i=e;if("string"==typeof e)t=Promise.resolve(c.URI.file(e));else if(c.URI.isUri(e))t=Promise.resolve(e);else{
if(i&&"object"!=typeof i)throw new Error("illegal argument - uriOrFileNameOrOptions");t=Oe.createDocumentData(i)}return t.then(e=>Oe.ensureDocumentData(e).then(e=>e.document))},onDidOpenTextDocument:(e,t,i)=>Oe.onDidAddDocument(e,t,i),onDidCloseTextDocument:(e,t,i)=>Oe.onDidRemoveDocument(e,t,i),onDidChangeTextDocument:(e,t,i)=>Oe.onDidChangeDocument(e,t,i),onDidSaveTextDocument:(e,t,i)=>Oe.onDidSaveDocument(e,t,i),onWillSaveTextDocument:(t,i,n)=>Me.getOnWillSaveTextDocumentEvent(e)(t,i,n),onDidChangeConfiguration:(e,t,i)=>g.onDidChangeConfiguration(e,t,i),getConfiguration(t,i){return i=1===arguments.length?void 0:i,g.getConfiguration(t,i,e)},registerTextDocumentContentProvider:(e,t)=>Le.registerTextDocumentContentProvider(e,t),registerTaskProvider:(t,i)=>(xe.report("window.registerTaskProvider",e,"Use the corresponding function on the 'tasks' namespace instead"),Pe.registerTaskProvider(e,t,i)),registerFileSystemProvider:(e,t,i)=>We.registerFileSystemProvider(e,t,i),get fs(){return We.fileSystem},
registerFileSearchProvider:(t,i)=>(q.checkProposedApiEnabled(e),De.registerFileSearchProvider(t,i)),registerTextSearchProvider:(t,i)=>(q.checkProposedApiEnabled(e),De.registerTextSearchProvider(t,i)),registerRemoteAuthorityResolver:(t,i)=>(q.checkProposedApiEnabled(e),s.registerRemoteAuthorityResolver(t,i)),registerResourceLabelFormatter:t=>(q.checkProposedApiEnabled(e),Ge.$registerResourceLabelFormatter(t)),onDidCreateFiles:(e,t,i)=>ze.onDidCreateFile(e,t,i),onDidDeleteFiles:(e,t,i)=>ze.onDidDeleteFile(e,t,i),onDidRenameFiles:(e,t,i)=>ze.onDidRenameFile(e,t,i),onWillCreateFiles:(t,i,n)=>ze.getOnWillCreateFileEvent(e)(t,i,n),onWillDeleteFiles:(t,i,n)=>ze.getOnWillDeleteFileEvent(e)(t,i,n),onWillRenameFiles:(t,i,n)=>ze.getOnWillRenameFileEvent(e)(t,i,n),openTunnel:t=>(q.checkProposedApiEnabled(e),Ee.openTunnel(t).then(e=>{if(!e)throw new Error("cannot open tunnel");return e})),get tunnels(){return q.checkProposedApiEnabled(e),Ee.getTunnels()},onDidChangeTunnels:(t,i,n)=>(q.checkProposedApiEnabled(e),
Ee.onDidChangeTunnels(t,i,n)),registerTimelineProvider:(t,i)=>(q.checkProposedApiEnabled(e),Je.registerTimelineProvider(t,i,e.identifier,ke.converter))},k={get inputBox(){return xe.report("scm.inputBox",e,"Use 'SourceControl.inputBox' instead"),je.getLastInputBox(e)},createSourceControl:(t,i,n)=>je.createSourceControl(e,t,i,n)},T={createCommentController:(t,i)=>Ve.createCommentController(e,t,i)},I=T,D={get activeDebugSession(){return Ie.activeDebugSession},get activeDebugConsole(){return Ie.activeDebugConsole},get breakpoints(){return Ie.breakpoints},onDidStartDebugSession:(e,t,i)=>Ie.onDidStartDebugSession(e,t,i),onDidTerminateDebugSession:(e,t,i)=>Ie.onDidTerminateDebugSession(e,t,i),onDidChangeActiveDebugSession:(e,t,i)=>Ie.onDidChangeActiveDebugSession(e,t,i),onDidReceiveDebugSessionCustomEvent:(e,t,i)=>Ie.onDidReceiveDebugSessionCustomEvent(e,t,i),onDidChangeBreakpoints:(e,t,i)=>Ie.onDidChangeBreakpoints(e,t,i),
registerDebugConfigurationProvider:(e,t,i)=>Ie.registerDebugConfigurationProvider(e,t,i||z.DebugConfigurationProviderTriggerKind.Initial),registerDebugAdapterDescriptorFactory:(t,i)=>Ie.registerDebugAdapterDescriptorFactory(e,t,i),registerDebugAdapterTrackerFactory:(e,t)=>Ie.registerDebugAdapterTrackerFactory(e,t),startDebugging:(e,t,i)=>!i||"object"==typeof i&&"configuration"in i?Ie.startDebugging(e,t,{parentSession:i}):Ie.startDebugging(e,t,i||{}),addBreakpoints:e=>Ie.addBreakpoints(e),removeBreakpoints:e=>Ie.removeBreakpoints(e),asDebugSourceUri:(e,t)=>Ie.asDebugSourceUri(e,t)},P={registerTaskProvider:(t,i)=>Pe.registerTaskProvider(e,t,i),fetchTasks:e=>Pe.fetchTasks(e),executeTask:t=>Pe.executeTask(e,t),get taskExecutions(){return Pe.taskExecutions},onDidStartTask:(e,t,i)=>Pe.onDidStartTask(e,t,i),onDidEndTask:(e,t,i)=>Pe.onDidEndTask(e,t,i),onDidStartTaskProcess:(e,t,i)=>Pe.onDidStartTaskProcess(e,t,i),onDidEndTaskProcess:(e,t,i)=>Pe.onDidEndTaskProcess(e,t,i)},R={get onDidOpenNotebookDocument(){
return q.checkProposedApiEnabled(e),Xe.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return q.checkProposedApiEnabled(e),Xe.onDidCloseNotebookDocument},get visibleNotebookEditors(){return Xe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Xe.onDidChangeVisibleNotebookEditors},registerNotebookContentProvider:(t,i)=>(q.checkProposedApiEnabled(e),Xe.registerNotebookContentProvider(e,t,i)),registerNotebookKernel:(t,i,n)=>(q.checkProposedApiEnabled(e),Xe.registerNotebookKernel(e,t,i,n)),registerNotebookOutputRenderer:(t,i,n)=>(q.checkProposedApiEnabled(e),Xe.registerNotebookOutputRenderer(t,e,i,n)),get activeNotebookDocument(){return q.checkProposedApiEnabled(e),Xe.activeNotebookDocument},get activeNotebookEditor(){return q.checkProposedApiEnabled(e),Xe.activeNotebookEditor},onDidChangeActiveNotebookEditor:(t,i,n)=>(q.checkProposedApiEnabled(e),Xe.onDidChangeActiveNotebookEditor(t,i,n)),onDidChangeNotebookCells:(t,i,n)=>(q.checkProposedApiEnabled(e),
Xe.onDidChangeNotebookCells(t,i,n)),onDidChangeCellOutputs:(t,i,n)=>(q.checkProposedApiEnabled(e),Xe.onDidChangeCellOutputs(t,i,n)),onDidChangeCellLanguage:(t,i,n)=>(q.checkProposedApiEnabled(e),Xe.onDidChangeCellLanguage(t,i,n)),createConcatTextDocument:(t,i)=>(q.checkProposedApiEnabled(e),new pe.ExtHostNotebookConcatDocument(Xe,Oe,t,i))};return{version:t.version,authentication:_,commands:y,debug:D,env:w,extensions:E,languages:x,scm:k,comment:T,comments:I,tasks:P,notebook:R,window:C,workspace:S,Breakpoint:z.Breakpoint,CancellationTokenSource:n.CancellationTokenSource,CodeAction:z.CodeAction,CodeActionKind:z.CodeActionKind,CodeActionTrigger:z.CodeActionTrigger,CodeLens:z.CodeLens,CodeInset:z.CodeInset,Color:z.Color,ColorInformation:z.ColorInformation,ColorPresentation:z.ColorPresentation,CommentThreadCollapsibleState:z.CommentThreadCollapsibleState,CommentMode:z.CommentMode,CompletionItem:z.CompletionItem,CompletionItemKind:z.CompletionItemKind,CompletionItemTag:z.CompletionItemTag,
CompletionList:z.CompletionList,CompletionTriggerKind:z.CompletionTriggerKind,ConfigurationTarget:z.ConfigurationTarget,DebugAdapterExecutable:z.DebugAdapterExecutable,DebugAdapterServer:z.DebugAdapterServer,DebugAdapterInlineImplementation:z.DebugAdapterInlineImplementation,DecorationRangeBehavior:z.DecorationRangeBehavior,Diagnostic:z.Diagnostic,DiagnosticRelatedInformation:z.DiagnosticRelatedInformation,DiagnosticSeverity:z.DiagnosticSeverity,DiagnosticTag:z.DiagnosticTag,Disposable:z.Disposable,DocumentHighlight:z.DocumentHighlight,DocumentHighlightKind:z.DocumentHighlightKind,DocumentLink:z.DocumentLink,DocumentSymbol:z.DocumentSymbol,EndOfLine:z.EndOfLine,EnvironmentVariableMutatorType:z.EnvironmentVariableMutatorType,EvaluatableExpression:z.EvaluatableExpression,EventEmitter:o.Emitter,ExtensionKind:z.ExtensionKind,ExtensionMode:z.ExtensionMode,CustomExecution:z.CustomExecution,CustomExecution2:z.CustomExecution,FileChangeType:z.FileChangeType,FileSystemError:z.FileSystemError,FileType:p.FileType,
FoldingRange:z.FoldingRange,FoldingRangeKind:z.FoldingRangeKind,FunctionBreakpoint:z.FunctionBreakpoint,Hover:z.Hover,IndentAction:d.IndentAction,Location:z.Location,LogLevel:z.LogLevel,MarkdownString:z.MarkdownString,OverviewRulerLane:u.OverviewRulerLane,ParameterInformation:z.ParameterInformation,Position:z.Position,ProcessExecution:z.ProcessExecution,ProgressLocation:z.ProgressLocation,QuickInputButtons:z.QuickInputButtons,Range:z.Range,RelativePattern:z.RelativePattern,ResolvedAuthority:z.ResolvedAuthority,RemoteAuthorityResolverError:z.RemoteAuthorityResolverError,SemanticTokensLegend:z.SemanticTokensLegend,SemanticTokensBuilder:z.SemanticTokensBuilder,SemanticTokens:z.SemanticTokens,SemanticTokensEdits:z.SemanticTokensEdits,SemanticTokensEdit:z.SemanticTokensEdit,Selection:z.Selection,SelectionRange:z.SelectionRange,ShellExecution:z.ShellExecution,ShellQuoting:z.ShellQuoting,SignatureHelpTriggerKind:z.SignatureHelpTriggerKind,SignatureHelp:z.SignatureHelp,SignatureInformation:z.SignatureInformation,
SnippetString:z.SnippetString,SourceBreakpoint:z.SourceBreakpoint,SourceControlInputBoxValidationType:z.SourceControlInputBoxValidationType,StandardTokenType:z.StandardTokenType,StatusBarAlignment:z.StatusBarAlignment,SymbolInformation:z.SymbolInformation,SymbolKind:z.SymbolKind,SymbolTag:z.SymbolTag,Task:z.Task,Task2:z.Task,TaskGroup:z.TaskGroup,TaskPanelKind:z.TaskPanelKind,TaskRevealKind:z.TaskRevealKind,TaskScope:z.TaskScope,TextDocumentSaveReason:z.TextDocumentSaveReason,TextEdit:z.TextEdit,TextEditorCursorStyle:l.TextEditorCursorStyle,TextEditorLineNumbersStyle:z.TextEditorLineNumbersStyle,TextEditorRevealType:z.TextEditorRevealType,TextEditorSelectionChangeKind:z.TextEditorSelectionChangeKind,ThemeColor:z.ThemeColor,ThemeIcon:z.ThemeIcon,TreeItem:z.TreeItem,TreeItem2:z.TreeItem,TreeItemCollapsibleState:z.TreeItemCollapsibleState,Uri:c.URI,ViewColumn:z.ViewColumn,WorkspaceEdit:z.WorkspaceEdit,CallHierarchyOutgoingCall:z.CallHierarchyOutgoingCall,CallHierarchyIncomingCall:z.CallHierarchyIncomingCall,
CallHierarchyItem:z.CallHierarchyItem,DebugConsoleMode:z.DebugConsoleMode,DebugConfigurationProviderTriggerKind:z.DebugConfigurationProviderTriggerKind,Decoration:z.Decoration,UIKind:m.UIKind,ColorThemeKind:z.ColorThemeKind,TimelineItem:z.TimelineItem,CellKind:z.CellKind,CellOutputKind:z.CellOutputKind,NotebookCellRunState:z.NotebookCellRunState,AuthenticationSession2:z.AuthenticationSession}}};class fe{constructor(e,t,i,n){this._extensionService=e,this._originExtensionId=t,this._identifier=i.identifier,this.id=i.identifier.value,this.extensionUri=i.extensionLocation,this.extensionPath=s.normalize(G.originalFSPath(i.extensionLocation)),this.packageJSON=i,this.extensionKind=n}get isActive(){return this._extensionService.isActivated(this._identifier)}get exports(){if("none"!==this.packageJSON.api)return this._extensionService.getExtensionExports(this._identifier)}activate(){return this._extensionService.activateByIdWithErrors(this._identifier,{startup:!1,extensionId:this._originExtensionId,activationEvent:"api"
}).then(()=>this.exports)}}})),define(t[59],i([1,0,8,11,33,13,114]),(function(e,t,i,r,o,a,c){"use strict";function l(e){return new o.SearchRange(e.start.line,e.start.character,e.end.line,e.end.character)}function u(e){return new c.Range(e.startLineNumber,e.startColumn,e.endLineNumber,e.endColumn)}Object.defineProperty(t,"__esModule",{value:!0}),t.OutputChannel=t.createTextSearchResult=t.anchorGlob=void 0,t.anchorGlob=function(e){return i.startsWith(e,"**")||i.startsWith(e,"/")?e:`/${e}`},t.createTextSearchResult=function(e,t,i,n){const r=a.mapArrayOrNot(i,l),s=new o.TextSearchMatch(t,r,n),c=s.preview.matches;return{ranges:a.mapArrayOrNot(r,u),uri:e,preview:{text:s.preview.text,matches:a.mapArrayOrNot(c,u)}}};let d=(()=>{let e=class{constructor(e){this.logService=e}appendLine(e){this.logService.debug("RipgrepSearchEH#search",e)}};return e=n([s(0,r.ILogService)],e)})();t.OutputChannel=d})),define(t[118],i([1,0,147,24,115]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.NativeTextSearchManager=void 0;class o extends r.TextSearchManager{constructor(e,t,r=n){super(e,t,{readdir:e=>r.readdir(e.fsPath),toCanonicalName:e=>i.toCanonicalName(e)})}}t.NativeTextSearchManager=o})),define(t[245],i([1,0,221,257,256,259,40,35,32,18,8,254,46,2,57]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.connectProxyResolver=void 0,t.connectProxyResolver=function(t,s,d,v,S,k){const T=function(t,i,n,r,s){const l=process.env;let d=_(i.getConfiguration("http").get("proxy"));i.onDidChangeConfiguration(e=>{d=_(i.getConfiguration("http").get("proxy"))});let p,v=_(l.https_proxy||l.HTTPS_PROXY||l.http_proxy||l.HTTP_PROXY),y=function(e){const t=(e||"").trim().toLowerCase();if("*"===t)return()=>!0;const i=t.split(",").map(e=>e.trim().split(":",2)).map(([e,t])=>({name:e,port:t})).filter(e=>!!e.name).map(({name:e,port:t})=>{return{domain:"."===e[0]?e:`.${e}`,port:t}});if(!i.length)return()=>!1
;return(e,t)=>i.some(({domain:i,port:n})=>u.endsWith(`.${e.toLowerCase()}`,i)&&(!n||t===n))}(l.no_proxy||l.NO_PROXY),w=0,b=new Map,S=new Map;function k(e,t){S.set(e,t),S.size>=f&&(b=S,S=new Map,w++,n.trace("ProxyResolver#cacheProxy cacheRolls",w))}let T=0,I=0,D=0,P=0,R=0,A=0,O=0,L=0,M=[];function N(){p=void 0,r.$publicLog2("resolveProxy",{count:T,duration:I,errorCount:D,cacheCount:P,cacheSize:S.size,cacheRolls:w,envCount:R,settingsCount:A,localhostCount:O,envNoProxyCount:L,results:M}),T=I=D=P=R=A=O=L=0,M=[]}return function(i,r,l,u,f){p||(p=setTimeout(N,6e5));const _=s.environment.useHostProxy,w="boolean"==typeof _?_:!s.remote.isRemote;!function(t,i,n,r){i?async function(t){E||(E=async function(){if("win32"===process.platform)return async function(){const t=await new Promise((t,i)=>{e(["vscode-windows-ca-certs"],t,i)});let i=[];const n=t();try{let e;for(;e=n.next();)i.push(e)}finally{n.done()}const r=new Set(i.map(C));return{certs:Array.from(r),append:!0}}()
;if("darwin"===process.platform)return async function(){const e=await new Promise((e,t)=>{const i=c.spawn("/usr/bin/security",["find-certificate","-a","-p"]),n=[];i.stdout.setEncoding("utf8"),i.stdout.on("data",e=>n.push(e)),i.on("error",t),i.on("exit",i=>i?t(i):e(n.join("")))}),t=new Set(e.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(e=>!!e.length));return{certs:Array.from(t),append:!0}}();if("linux"===process.platform)return async function(){for(const e of x)try{const t=await m.promisify(a.readFile)(e,{encoding:"utf8"}),i=new Set(t.split(/(?=-----BEGIN CERTIFICATE-----)/g).filter(e=>!!e.length));return{certs:Array.from(i),append:!1}}catch(e){if("ENOENT"!==e.code)throw e}return}();return}().then(e=>e&&e.certs.length?e:void 0).catch(e=>{t.error("ProxyResolver#getCertificates",h.toErrorMessage(e))}));return E}(t).then(e=>{e&&(e.append?n._vscodeAdditionalCaCerts=e.certs:n.ca=e.certs),r()}).catch(e=>{t.error("ProxyResolver#useSystemCertificates",h.toErrorMessage(e))}):r()}(n,i.useSystemCertificates,l,()=>{
!function(e,i,r,s,a,c){if(!i)return void c("DIRECT");const l=o.parse(a),u=l.hostname;if("localhost"===u||"127.0.0.1"===u||"::1"===u||"::ffff:127.0.0.1"===u)return O++,c("DIRECT"),void n.trace("ProxyResolver#resolveProxy localhost",a,"DIRECT");if("string"==typeof u&&y(u,String(l.port||s.agent.defaultPort)))return L++,c("DIRECT"),void n.trace("ProxyResolver#resolveProxy envNoProxy",a,"DIRECT");if(d)return A++,c(d),void n.trace("ProxyResolver#resolveProxy settings",a,d);if(v)return R++,c(v),void n.trace("ProxyResolver#resolveProxy env",a,v);const p=function(e){return o.format(Object.assign(Object.assign({},e),{pathname:void 0,search:void 0,hash:void 0}))}(l),m=function(e){let t=S.get(e);return t||((t=b.get(e))&&(b.delete(e),k(e,t)),t)}(p);if(m)return P++,g(M,m,"https:"===l.protocol?"HTTPS":"HTTP",r),c(m),void n.trace("ProxyResolver#resolveProxy cached",a,m);if(!e)return c("DIRECT"),void n.trace("ProxyResolver#resolveProxy unconfigured",a,"DIRECT");const f=Date.now();t.resolveProxy(a).then(e=>{e&&(k(p,e),
g(M,e,"https:"===l.protocol?"HTTPS":"HTTP",r)),c(e),n.debug("ProxyResolver#resolveProxy",a,e)}).then(()=>{T++,I=Date.now()-f+I},e=>{D++,c(),n.error("ProxyResolver#resolveProxy",h.toErrorMessage(e))})}(w,i.useProxySettings,r,l,u,f)})}}(t,s,v,S,k);return function(t,i){return t.getExtensionPathIndex().then(t=>{const n=e.__$__nodeRequire("module"),r=n._load;n._load=function(e,n,o){if("tls"===e)return i.tls;if("http"!==e&&"https"!==e)return r.apply(this,arguments);const s=i[e],a=t.findSubstr(p.URI.file(n.filename).fsPath);let c=b.get(a);if(c||b.set(a,c={}),!c[e]){let t=s.default;a&&a.enableProposedApi&&(t=s[a.proxySupport]||s.onRequest),c[e]=Object.assign({},t)}return c[e]}})}(d,function(e,t){const o={config:e.getConfiguration("http").get("proxySupport")||"off"};e.onDidChangeConfiguration(t=>{o.config=e.getConfiguration("http").get("proxySupport")||"off"});const s={config:!!e.getConfiguration("http").get("systemCertificates")};return e.onDidChangeConfiguration(t=>{
s.config=!!e.getConfiguration("http").get("systemCertificates")}),{http:{off:l.assign({},i,y(i,t,{config:"off"},s,!0)),on:l.assign({},i,y(i,t,{config:"on"},s,!0)),override:l.assign({},i,y(i,t,{config:"override"},s,!0)),onRequest:l.assign({},i,y(i,t,o,s,!0)),default:l.assign(i,y(i,t,o,s,!1))},https:{off:l.assign({},n,y(n,t,{config:"off"},s,!0)),on:l.assign({},n,y(n,t,{config:"on"},s,!0)),override:l.assign({},n,y(n,t,{config:"override"},s,!0)),onRequest:l.assign({},n,y(n,t,o,s,!0)),default:l.assign(n,y(n,t,o,s,!1))},tls:l.assign(r,w(r))}}(s,T))};const f=5e3;function g(e,t,i,n){const r=t?String(t).trim().split(/\s+/,1)[0]:"EMPTY";n.on("response",t=>{const n=`HTTP_${t.statusCode}`;v(e,r,i,n).count++}),n.on("error",t=>{const n=t&&"string"==typeof t.code&&t.code||"UNKNOWN_ERROR";v(e,r,i,n).count++})}function v(e,t,i,n){for(const r of e)if(r.proxy===t&&r.connection===i&&r.code===n)return r;const r={proxy:t,connection:i,code:n,count:0};return e.push(r),r}function _(e){const t=(e||"").trim(),i=t.indexOf("://")
;if(-1===i)return;const n=t.substr(0,i).toLowerCase(),r=t.substr(i+3);return"http"===n?"PROXY "+r:"https"===n?"HTTPS "+r:"socks"===n?"SOCKS "+r:void 0}function y(e,t,i,r,s){return{get:a(e.get),request:a(e.request)};function a(a){return function(c,l,u){if("string"==typeof c||c&&c.searchParams||(u=l,l=c,c=null),"function"==typeof l&&(u=l,l=null),(l=l||{}).socketPath)return a.apply(null,arguments);const h=l.agent;if(!0===h)throw new Error("Unexpected agent option: true");const p=h instanceof d.ProxyAgent,m=s&&(l._vscodeProxySupport||l._vscodeSystemProxy)||i.config,f=!p&&("override"===m||"on"===m&&void 0===h),g=!p&&r.config&&e===n&&!l.ca;if(f||g){if(c){const e="string"==typeof c?new o.URL(c):c,t={protocol:e.protocol,hostname:0===e.hostname.lastIndexOf("[",0)?e.hostname.slice(1,-1):e.hostname,port:e.port,path:`${e.pathname}${e.search}`};(e.username||e.password)&&(l.auth=`${e.username}:${e.password}`),l=Object.assign(Object.assign({},t),l)}else l=Object.assign({},l);return l.agent=new d.ProxyAgent({
resolveProxy:t.bind(void 0,{useProxySettings:f,useSystemCertificates:g}),defaultPort:e===n?443:80,originalAgent:h}),a(l,u)}return a.apply(null,arguments)}}}function w(e){return{createSecureContext:(t=e.createSecureContext,function(e){const i=t.apply(null,arguments),n=e._vscodeAdditionalCaCerts;if(n)for(const e of n)i.context.addCACert(e);return i})};var t}const b=new Map;let E;const x=["/etc/ssl/certs/ca-certificates.crt","/etc/ssl/certs/ca-bundle.crt"];function C(e){const t=["-----BEGIN CERTIFICATE-----"],i=e.toString("base64");for(let e=0;e<i.length;e+=64)t.push(i.substr(e,64));return t.push("-----END CERTIFICATE-----",""),t.join(s.EOL)}})),define(t[250],i([1,0,242,232,5,245,38,222,220,2,20]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtHostExtensionService=void 0;class d extends n.RequireInterceptor{_installInterceptor(){const t=this,i=e.__$__nodeRequire("module"),n=i._load;i._load=function(e,i,r){for(let i of t._alternatives){let t=i(e);if(t){e=t
;break}}return t._factories.has(e)?t._factories.get(e).load(e,l.URI.file(i.filename),e=>n.apply(this,[e,i,r])):n.apply(this,arguments)}}}class h extends s.AbstractExtHostExtensionService{async _beforeAlmostReadyToRunExtensions(){const e=this._instaService.invokeFunction(i.createApiFactoryAndRegisterActors);if(this._instaService.createInstance(a.ExtHostDownloadService),this._initData.remote.isRemote&&this._initData.remote.authority){const e=this._instaService.createInstance(c.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=e.ipcHandlePath}const t=this._instaService.createInstance(d,e,this._registry);await t.install();const n=await this._extHostConfiguration.getConfigProvider();await o.connectProxyResolver(this._extHostWorkspace,n,this,this._logService,this._mainThreadTelemetryProxy,this._initData);const s=process.send,l=this._extHostContext.getProxy(r.MainContext.MainThreadConsole);process.send=(...e)=>0!==e.length&&e[0]&&"__$console"===e[0].type?(l.$logExtensionHostMessage(e[0]),!1):s.apply(process,e)}
_loadCommonJSModule(t,i){if(t.scheme!==u.Schemas.file)throw new Error(`Cannot load URI: '${t}', must be of file-scheme`);let n=null;i.codeLoadingStart(),this._logService.info(`ExtensionService#loadCommonJSModule ${t.toString(!0)}`),this._logService.flush();try{n=e.__$__nodeRequire(t.fsPath)}catch(e){return Promise.reject(e)}finally{i.codeLoadingStop()}return Promise.resolve(n)}async $setRemoteEnvironment(e){if(this._initData.remote.isRemote)for(const t in e){const i=e[t];null===i?delete process.env[t]:process.env[t]=i}}}t.ExtHostExtensionService=h})),define(t[251],i([1,0,32,7,62,18,34,9,8,59,252]),(function(e,t,i,n,r,o,s,a,c,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fixDriveC=t.getAbsoluteGlob=t.foldersToIncludeGlobs=t.foldersToRgExcludeGlobs=t.spawnRipgrepCmd=void 0;const d=u.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function h(e,t,i,n=!0){const r=[];let s={};return e.forEach(e=>{
const a=m(o.assign({},e.excludePattern||{},t||{}),n?e.folder.fsPath:void 0,i);r.push(...a.globArgs),a.siblingClauses&&(s=o.assign(s,a.siblingClauses))}),{globArgs:r,siblingClauses:s}}function p(e,t,i=!0){const n=[];return e.forEach(e=>{const r=m(o.assign({},t||{},e.includePattern||{}),i?e.folder.fsPath:void 0);n.push(...r.globArgs)}),n}function m(e,t,i){const n=[],r={};return Object.keys(e).forEach(o=>{if(i&&i.has(o))return;if(!o)return;const s=e[o];o=function(e){return e=c.rtrim(e,"\\"),c.rtrim(e,"/")}(t?f(t,o):o),o=c.startsWith(o,"\\\\")?"\\\\"+o.substr(2).replace(/\\/g,"/"):o.replace(/\\/g,"/"),"boolean"==typeof s&&s?(c.startsWith(o,"\\\\")&&(o+="**"),n.push(g(o))):s&&s.when&&(r[o]=s)}),{globArgs:n,siblingClauses:r}}function f(e,t){return n.isAbsolute(t)?t:n.join(e,t)}function g(e){return"c:/"===s.getRoot(e).toLowerCase()?e.replace(/^c:[/\\]/i,"/"):e}t.spawnRipgrepCmd=function(e,t,n,o){const s=function(e,t,i,n){const o=["--files","--hidden","--case-sensitive"];p([t],i,!1).forEach(e=>{
const t=l.anchorGlob(e);if(o.push("-g",t),a.isMacintosh){const e=r.normalizeNFD(t);e!==t&&o.push("-g",e)}});const s=h([t],n,void 0,!1);s.globArgs.forEach(e=>{const t=`!${l.anchorGlob(e)}`;if(o.push("-g",t),a.isMacintosh){const e=r.normalizeNFD(t);e!==t&&o.push("-g",e)}}),!1!==t.disregardIgnoreFiles?o.push("--no-ignore"):o.push("--no-ignore-parent");t.ignoreSymlinks||o.push("--follow");e.exists&&o.push("--quiet");o.push("--no-config"),t.disregardGlobalIgnoreFiles&&o.push("--no-ignore-global");return{args:o,siblingClauses:s.siblingClauses}}(e,t,n,o),c=t.folder.fsPath;return{cmd:i.spawn(d,s.args,{cwd:c}),siblingClauses:s.siblingClauses,rgArgs:s,cwd:c}},t.foldersToRgExcludeGlobs=h,t.foldersToIncludeGlobs=p,t.getAbsoluteGlob=f,t.fixDriveC=g})),define(t[249],i([1,0,32,35,7,97,13,46,27,62,18,34,9,63,8,12,24,33,251,107]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f,g,v,_,y){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.rgErrorMsgForDisplay=t.Engine=t.FileWalker=void 0;const w=new Set
;process.on("exit",()=>{w.forEach(e=>e())});class b{constructor(e){this.normalizedFilePatternLowercase=null,this.maxFilesize=null,this.isCanceled=!1,this.fileWalkSW=null,this.cmdSW=null,this.cmdResultCount=0,this.config=e,this.filePattern=e.filePattern||"",this.includePattern=e.includePattern&&c.parse(e.includePattern),this.maxResults=e.maxResults||null,this.exists=!!e.exists,this.walkedPaths=Object.create(null),this.resultCount=0,this.isLimitHit=!1,this.directoriesWalked=0,this.filesWalked=0,this.errors=[],this.filePattern&&(this.normalizedFilePatternLowercase=y.prepareQuery(this.filePattern).normalizedLowercase),this.globalExcludePattern=e.excludePattern&&c.parse(e.excludePattern),this.folderExcludePatterns=new Map,e.folderQueries.forEach(t=>{const i=u.assign({},t.excludePattern||{},this.config.excludePattern||{}),n=t.folder.fsPath;e.folderQueries.map(e=>e.folder.fsPath).filter(e=>e!==n).forEach(e=>{d.isEqualOrParent(e,n)&&(i[r.relative(n,e)]=!0)}),this.folderExcludePatterns.set(n,new E(i,n))})}cancel(){
this.isCanceled=!0}walk(e,t,i,n,o){if(this.fileWalkSW=p.StopWatch.create(!1),this.isCanceled)return o(null,this.isLimitHit);t.forEach(e=>{const t=r.basename(e.fsPath);this.globalExcludePattern&&this.globalExcludePattern(e.fsPath,t)||this.matchFile(i,{relativePath:e.fsPath,searchPath:void 0})}),this.cmdSW=p.StopWatch.create(!1),this.parallel(e,(e,t)=>{this.call(this.cmdTraversal,this,e,i,n,e=>{if(e){const i=a.toErrorMessage(e);console.error(i),this.errors.push(i),t(e,void 0)}else t(null,void 0)})},(e,t)=>{this.fileWalkSW.stop();const i=e?s.coalesce(e)[0]:null;o(i,this.isLimitHit)})}parallel(e,t,i){const n=new Array(e.length),r=new Array(e.length);let o=!1,s=0;if(0===e.length)return i(null,[]);e.forEach((a,c)=>{t(a,(t,a)=>{if(t?(o=!0,n[c]=null,r[c]=t):(n[c]=a,r[c]=null),++s===e.length)return i(o?r:null,n)})})}call(e,t,...i){try{e.apply(t,i)}catch(e){i[i.length-1](e)}}cmdTraversal(e,t,i,n){const r=e.folder.fsPath,o=h.isMacintosh;let s;const a=()=>s&&s.kill();w.add(a);let c=e=>{w.delete(a),c=()=>{},n(e)},u=""
;const d=this.initDirectoryTree();let p;const m=_.spawnRipgrepCmd(this.config,e,this.config.includePattern,this.folderExcludePatterns.get(e.folder.fsPath).expression);s=m.cmd,p=!Object.keys(m.siblingClauses).length;let f=`rg ${m.rgArgs.args.map(e=>e.match(/^-/)?e:`'${e}'`).join(" ")}\n - cwd: ${m.cwd}`;m.rgArgs.siblingClauses&&(f+=`\n - Sibling clauses: ${JSON.stringify(m.rgArgs.siblingClauses)}`),i({message:f}),this.cmdResultCount=0,this.collectStdout(s,"utf8",i,(i,n,s)=>{if(i)return void c(i);if(this.isLimitHit)return void c();const h=(u+(o?l.normalizeNFC(n||""):n)).split("\n");if(s){const e=h.length;h[e-1]=h[e-1].trim(),h[e-1]||h.pop()}else u=h.pop()||"";if(h.length&&-1!==h[0].indexOf("\n"))c(new Error("Splitting up files failed"));else if(this.cmdResultCount+=h.length,p){for(const i of h)if(this.matchFile(t,{base:r,relativePath:i,searchPath:this.getSearchPath(e,i)}),this.isLimitHit){a();break}(s||this.isLimitHit)&&c()}else this.addDirectoryEntries(e,d,r,h,t),s&&(this.matchDirectoryTree(d,r,t),c())})}
spawnFindCmd(e){const t=this.folderExcludePatterns.get(e.folder.fsPath),n=t.getBasenameTerms(),r=t.getPathTerms(),o=["-L","."];if(n.length||r.length){o.push("-not","(","(");for(const e of n)o.push("-name",e),o.push("-o");for(const e of r)o.push("-path",e),o.push("-o");o.pop(),o.push(")","-prune",")")}return o.push("-type","f"),i.spawn("find",o,{cwd:e.folder.fsPath})}readStdout(e,t,i){let n="";this.collectStdout(e,t,()=>{},(e,t,r)=>{e?i(e):(n+=t,r&&i(null,n))})}collectStdout(e,t,i,n){let r,o=(e,t,i)=>{(e||i)&&(o=()=>{},this.cmdSW&&this.cmdSW.stop()),n(e,t,i)},s=!1;e.stdout?(this.forwardData(e.stdout,t,o),e.stdout.once("data",()=>s=!0)):i({message:"stdout is null"}),e.stderr?r=this.collectData(e.stderr):i({message:"stderr is null"}),e.on("error",e=>{o(e)}),e.on("close",e=>{let i;!s&&(i=this.decodeData(r,t))&&x(i)?o(new Error(`command failed with error code ${e}: ${this.decodeData(r,t)}`)):(this.exists&&0===e&&(this.isLimitHit=!0),o(null,"",!0))})}forwardData(e,t,i){const n=new o.StringDecoder(t)
;return e.on("data",e=>{i(null,n.write(e))}),n}collectData(e){const t=[];return e.on("data",e=>{t.push(e)}),t}decodeData(e,t){const i=new o.StringDecoder(t);return e.map(e=>i.write(e)).join("")}initDirectoryTree(){const e={rootEntries:[],pathToEntries:Object.create(null)};return e.pathToEntries["."]=e.rootEntries,e}addDirectoryEntries(e,{pathToEntries:t},i,n,o){-1!==n.indexOf(this.filePattern)&&this.matchFile(o,{base:i,relativePath:this.filePattern,searchPath:this.getSearchPath(e,this.filePattern)});const s=n=>{const o=r.basename(n),a=r.dirname(n);let c=t[a];c||(c=t[a]=[],s(a)),c.push({base:i,relativePath:n,basename:o,searchPath:this.getSearchPath(e,n)})};n.forEach(s)}matchDirectoryTree({rootEntries:e,pathToEntries:t},i,n){const r=this,o=this.folderExcludePatterns.get(i),s=this.filePattern;!function e(i){r.directoriesWalked++;const a=c.hasSiblingFn(()=>i.map(e=>e.basename));for(let c=0,l=i.length;c<l;c++){const l=i[c],{relativePath:u,basename:d}=l;if(o.test(u,d,s!==d?a:void 0))continue;const h=t[u]
;if(h)e(h);else{if(r.filesWalked++,u===s)continue;r.matchFile(n,l)}if(r.isLimitHit)break}}(e)}getStats(){return{cmdTime:this.cmdSW.elapsed(),fileWalkTime:this.fileWalkSW.elapsed(),directoriesWalked:this.directoriesWalked,filesWalked:this.filesWalked,cmdResultCount:this.cmdResultCount}}doWalk(e,t,i,o,a){const l=e.folder,u=c.hasSiblingFn(()=>i);this.parallel(i,(i,s)=>{if(this.isCanceled||this.isLimitHit)return s(null);const a=t?[t,i].join(r.sep):i;if(this.folderExcludePatterns.get(e.folder.fsPath).test(a,i,this.config.filePattern!==i?u:void 0))return s(null);const c=[l.fsPath,a].join(r.sep);n.lstat(c,(t,i)=>{if(t||this.isCanceled||this.isLimitHit)return s(null);this.statLinkIfNeeded(c,i,(t,n)=>t||this.isCanceled||this.isLimitHit?s(null):n.isDirectory()?(this.directoriesWalked++,this.realPathIfNeeded(c,i,(t,i)=>t||this.isCanceled||this.isLimitHit?s(null):(i=i||"",this.walkedPaths[i]?s(null):(this.walkedPaths[i]=!0,g.readdir(c).then(t=>{if(this.isCanceled||this.isLimitHit)return s(null)
;this.doWalk(e,a,t,o,e=>s(e||null))},e=>{s(null)}))))):(this.filesWalked++,a===this.filePattern?s(null,void 0):this.maxFilesize&&f.isNumber(n.size)&&n.size>this.maxFilesize?s(null,void 0):(this.matchFile(o,{base:l.fsPath,relativePath:a,searchPath:this.getSearchPath(e,a)}),s(null,void 0))))})},e=>{const t=e?s.coalesce(e):e;return a(t&&t.length>0?t[0]:void 0)})}matchFile(e,t){!this.isFileMatch(t)||this.includePattern&&!this.includePattern(t.relativePath,r.basename(t.relativePath))||(this.resultCount++,(this.exists||this.maxResults&&this.resultCount>this.maxResults)&&(this.isLimitHit=!0),this.isLimitHit||e(t))}isFileMatch(e){if(this.filePattern){if("*"===this.filePattern)return!0;if(this.normalizedFilePatternLowercase)return v.isFilePatternMatch(e,this.normalizedFilePatternLowercase)}return!0}statLinkIfNeeded(e,t,i){return t.isSymbolicLink()?n.stat(e,i):i(null,t)}realPathIfNeeded(e,t,i){return t.isSymbolicLink()?n.realpath(e,(e,t)=>e?i(e):i(null,t)):i(null,e)}getSearchPath(e,t){
return e.folderName?r.join(e.folderName,t):t}}t.FileWalker=b;t.Engine=class{constructor(e){this.folderQueries=e.folderQueries,this.extraFiles=e.extraFileResources||[],this.walker=new b(e)}search(e,t,i){this.walker.walk(this.folderQueries,this.extraFiles,e,t,(e,t)=>{i(e,{limitHit:t,stats:this.walker.getStats()})})}cancel(){this.walker.cancel()}};class E{constructor(e,t){this.expression=e,this.root=t,this.init(e)}init(e){let t,i;Object.keys(e).filter(t=>e[t]).forEach(n=>{r.isAbsolute(n)?(t=t||c.getEmptyExpression())[n]=e[n]:(i=i||c.getEmptyExpression())[n]=e[n]}),this.absoluteParsedExpr=t&&c.parse(t,{trimForExclusions:!0}),this.relativeParsedExpr=i&&c.parse(i,{trimForExclusions:!0})}test(e,t,i){return this.relativeParsedExpr&&this.relativeParsedExpr(e,t,i)||this.absoluteParsedExpr&&this.absoluteParsedExpr(r.join(this.root,e),t,i)}getBasenameTerms(){const e=[];return this.absoluteParsedExpr&&e.push(...c.getBasenameTerms(this.absoluteParsedExpr)),
this.relativeParsedExpr&&e.push(...c.getBasenameTerms(this.relativeParsedExpr)),e}getPathTerms(){const e=[];return this.absoluteParsedExpr&&e.push(...c.getPathTerms(this.absoluteParsedExpr)),this.relativeParsedExpr&&e.push(...c.getPathTerms(this.relativeParsedExpr)),e}}function x(e){const t=e.trim().split("\n"),i=t[0].trim();return m.startsWith(i,"Error parsing regex")?i:m.startsWith(i,"regex parse error")?m.uppercaseFirstLetter(t[t.length-1].trim()):m.startsWith(i,"error parsing glob")||m.startsWith(i,"unsupported encoding")?i.charAt(0).toUpperCase()+i.substr(1):"Literal '\\n' not allowed."===i?"Literal '\\n' currently not supported":m.startsWith(i,"Literal ")?i:void 0}t.rgErrorMsgForDisplay=x})),define(t[83],i([1,0,32,255,7,97,8,2,33,252,59,13,27,117,114]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),
t.fixNewline=t.fixRegexNewline=t.unicodeEscapesToPCRE2=t.spreadGlobComponents=t.RipgrepParser=t.buildRegexParseError=t.rgErrorMsgForDisplay=t.RipgrepTextSearchEngine=void 0;const f=l.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function g(e){const t=e.split("\n"),i=t[0].trim();if(t.some(e=>s.startsWith(e,"regex parse error")))return new c.SearchError(v(t),c.SearchErrorCode.regexParseError);const n=i.match(/grep config error: unknown encoding: (.*)/);return n?new c.SearchError(`Unknown encoding: ${n[1]}`,c.SearchErrorCode.unknownEncoding):s.startsWith(i,"error parsing glob")?new c.SearchError(i.charAt(0).toUpperCase()+i.substr(1),c.SearchErrorCode.globParseError):s.startsWith(i,"the literal")?new c.SearchError(i.charAt(0).toUpperCase()+i.substr(1),c.SearchErrorCode.invalidLiteral):s.startsWith(i,"PCRE2: error compiling pattern")?new c.SearchError(i,c.SearchErrorCode.regexParseError):void 0}function v(e){let t=["Regex parse error"],i=e.filter(e=>s.startsWith(e,"PCRE2:"))
;if(i.length>=1){let e=i[0].replace("PCRE2:","");if(-1!==e.indexOf(":")&&e.split(":").length>=2){let i=e.split(":")[1];t.push(":"+i)}}return t.join("")}t.RipgrepTextSearchEngine=class{constructor(e){this.outputChannel=e}provideTextSearchResults(e,t,n,r){return this.outputChannel.appendLine(`provideTextSearchResults ${e.pattern}, ${JSON.stringify(Object.assign(Object.assign({},t),{folder:t.folder.toString()}))}`),new Promise((o,a)=>{r.onCancellationRequested(()=>S());const l=function(e,t){const i=["--hidden"];i.push(e.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:n,otherIncludes:r}=p.groupBy(t.includes,e=>s.startsWith(e,"**")?"doubleStarIncludes":"otherIncludes");if(r&&r.length){const e=new Set;r.forEach(t=>{s.endsWith(t,"/**")||(t+="/**"),e.add(t)}),i.push("-g","!*"),e.forEach(e=>{w(e).map(u.anchorGlob).forEach(e=>{i.push("-g",e)})})}n&&n.length&&n.forEach(e=>{i.push("-g",e)});t.excludes.map(u.anchorGlob).forEach(e=>i.push("-g",`!${e}`)),
t.maxFileSize&&i.push("--max-filesize",t.maxFileSize+"");t.useIgnoreFiles?i.push("--no-ignore-parent"):i.push("--no-ignore");t.followSymlinks&&i.push("--follow");t.encoding&&"utf8"!==t.encoding&&i.push("--encoding",t.encoding);"--"===e.pattern&&(e.isRegExp=!0,e.pattern="\\-\\-");e.isMultiline&&!e.isRegExp&&(e.pattern=s.escapeRegExpCharacters(e.pattern),e.isRegExp=!0);t.usePCRE2&&i.push("--pcre2");i.push("--crlf"),e.isRegExp&&(e.pattern=b(e.pattern),i.push("--auto-hybrid-regex"));let o;if(e.isWordMatch){const t=s.createRegExp(e.pattern,!!e.isRegExp,{wholeWord:e.isWordMatch}).source.replace(/\\\//g,"/");i.push("--regexp",t)}else if(e.isRegExp){let t=E(e.pattern);t=x(t),i.push("--regexp",t)}else o=e.pattern,i.push("--fixed-strings");i.push("--no-config"),t.useGlobalIgnoreFiles||i.push("--no-ignore-global");i.push("--json"),e.isMultiline&&i.push("--multiline");t.beforeContext&&i.push("--before-context",t.beforeContext+"");t.afterContext&&i.push("--after-context",t.afterContext+"");i.push("--"),o&&i.push(o)
;return i.push("."),i}(e,t),d=t.folder.fsPath,h=l.map(e=>e.match(/^-/)?e:`'${e}'`).join(" ");this.outputChannel.appendLine(`rg ${h}\n - cwd: ${d}`);let m=i.spawn(f,l,{cwd:d});m.on("error",e=>{console.error(e),this.outputChannel.appendLine("Error: "+(e&&e.message)),a(c.serializeSearchError(new c.SearchError(e&&e.message,c.SearchErrorCode.rgProcessError)))});let v=!1;const y=new _(t.maxResults,d,t.previewOptions);y.on("result",e=>{v=!0,n.report(e)});let C=!1;const S=()=>{C=!0,m&&m.kill(),y&&y.cancel()};let k=!1;y.on("hitLimit",()=>{k=!0,S()}),m.stdout.on("data",e=>{y.handleData(e)});let T=!1;m.stdout.once("data",()=>T=!0);let I="";m.stderr.on("data",e=>{const t=e.toString();this.outputChannel.appendLine(t),I+=t}),m.on("close",()=>{if(this.outputChannel.appendLine(T?"Got data from stdout":"No data from stdout"),this.outputChannel.appendLine(v?"Got result from parser":"No result from parser"),this.outputChannel.appendLine(""),C)o({limitHit:k});else{let e;y.flush(),m=null,
I&&!T&&(e=g(I))?a(c.serializeSearchError(new c.SearchError(e.message,e.code))):o({limitHit:k})}})})}},t.rgErrorMsgForDisplay=g,t.buildRegexParseError=v;class _ extends n.EventEmitter{constructor(e,t,i){super(),this.maxResults=e,this.rootFolder=t,this.previewOptions=i,this.remainder="",this.isDone=!1,this.hitLimit=!1,this.numResults=0,this.stringDecoder=new o.StringDecoder}cancel(){this.isDone=!0}flush(){this.handleDecodedData(this.stringDecoder.end())}on(e,t){return super.on(e,t),this}handleData(e){if(this.isDone)return;const t="string"==typeof e?e:this.stringDecoder.write(e);this.handleDecodedData(t)}handleDecodedData(e){let t=e.indexOf("\n");const i=this.remainder+e;if(!(t>=0))return void(this.remainder=i);t+=this.remainder.length;let n=0;for(;t>=0;)this.handleLine(i.substring(n,t).trim()),n=t+1,t=i.indexOf("\n",n);this.remainder=i.substring(n)}handleLine(e){if(this.isDone||!e)return;let t;try{t=JSON.parse(e)}catch(t){throw new Error(`malformed line from rg: ${e}`)}if("match"===t.type){
const e=y(t.data.path),i=a.URI.file(r.join(this.rootFolder,e)),n=this.createTextSearchMatch(t.data,i);this.onResult(n),this.hitLimit&&(this.cancel(),this.emit("hitLimit"))}else if("context"===t.type){const e=y(t.data.path),i=a.URI.file(r.join(this.rootFolder,e));this.createTextSearchContext(t.data,i).forEach(e=>this.onResult(e))}}createTextSearchMatch(e,t){const i=e.line_number-1;let n=!1,r=y(e.lines);0===i&&s.startsWithUTF8BOM(r)&&(n=!0,r=s.stripUTF8BOM(r));const o=Buffer.from(r);let a=0,c=0,l=i;const h=d.coalesce(e.submatches.map((e,t)=>{if(this.hitLimit)return null;this.numResults++,this.numResults>=this.maxResults&&(this.hitLimit=!0);let r=y(e.match);0===i&&0===t&&n&&(r=s.stripUTF8BOM(r),e.start=e.start<=3?0:e.start-3,e.end=e.end<=3?0:e.end-3);const u=o.slice(a,e.start).toString().length;let d=c+u;const h=function(e){const t=/\n/g;let i,n=0,r=-1;for(;i=t.exec(e);)n++,r=i.index;const o=r>=0?e.length-r-1:e.length;return{numLines:n,lastLineLength:o}}(r),p=l,f=h.numLines+p
;let g=h.numLines>0?h.lastLineLength:h.lastLineLength+d;return a=e.end,c=g,l=f,new m.Range(p,d,f,g)}));return u.createTextSearchResult(t,r,h,this.previewOptions)}createTextSearchContext(e,t){const i=y(e.lines),n=e.line_number;return i.replace(/\r?\n$/,"").split("\n").map((e,i)=>({text:e,uri:t,lineNumber:n+i}))}onResult(e){this.emit("result",e)}}function y(e){return e.bytes?Buffer.from(e.bytes,"base64").toString():e.text}function w(e){const t=h.splitGlobAware(e,"/");return"**"!==t[t.length-1]&&t.push("**"),t.map((e,i)=>t.slice(0,i+1).join("/"))}function b(e){const t=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/g;for(;e.match(t);)e=e.replace(t,"$1\\x{$2}");const i=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/g;for(;e.match(i);)e=e.replace(i,"$1\\x{$2}");return e}function E(e){return e.replace(/(?<=[^\\]|^)(\\\\)*\\n/g,"$1\\r?\\n")}function x(e){return e.replace(/\n/g,"\\r?\\n")}t.RipgrepParser=_,t.spreadGlobComponents=w,t.unicodeEscapesToPCRE2=b,t.fixRegexNewline=E,t.fixNewline=x})),
define(t[247],i([1,0,22,83]),(function(e,t,i,n){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RipgrepSearchProvider=void 0;t.RipgrepSearchProvider=class{constructor(e){this.outputChannel=e,this.inProgress=new Set,process.once("exit",()=>this.dispose())}provideTextSearchResults(e,t,i,r){const o=new n.RipgrepTextSearchEngine(this.outputChannel);return this.withToken(r,n=>o.provideTextSearchResults(e,t,i,n))}async withToken(e,t){const n=function(e){const t=new i.CancellationTokenSource;return e.onCancellationRequested(()=>t.cancel()),t}(e);this.inProgress.add(n);const r=await t(n.token);return this.inProgress.delete(n),r}dispose(){this.inProgress.forEach(e=>e.cancel())}}})),define(t[246],i([1,0,24,83,118]),(function(e,t,i,n,r){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TextSearchEngineAdapter=void 0;function o(e){return{path:e.resource&&e.resource.fsPath,results:e.results,numMatches:(e.results||[]).reduce((e,t)=>{if(t.ranges){const i=t
;return e+(Array.isArray(i.ranges)?i.ranges.length:1)}return e+1},0)}}t.TextSearchEngineAdapter=class{constructor(e){this.query=e}search(e,t,s){if(!(this.query.folderQueries&&this.query.folderQueries.length||this.query.extraFileResources&&this.query.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const a={appendLine(e){s({message:e})}},c=new r.NativeTextSearchManager(this.query,new n.RipgrepTextSearchEngine(a),i);return new Promise((i,n)=>c.search(e=>{t(e.map(o))},e).then(e=>i({limitHit:e.limitHit,type:"success"}),n))}}})),define(t[175],i([1,0,35,253,7,13,16,19,3,18,63,8,2,107,24,33,249,246]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SearchService=void 0,n.gracefulify(i);let _=(()=>{class e{constructor(){this.caches=Object.create(null)}fileSearch(e){let t;const i=b(e),n=new c.Emitter({onFirstListenerDidAdd:()=>{
(t=s.createCancelablePromise(e=>this.doFileSearchWithEngine(g.Engine,i,e=>n.fire(e),e))).then(e=>n.fire(e),e=>n.fire({type:"error",error:{message:e.message,stack:e.stack}}))},onLastListenerRemove:()=>{t.cancel()}});return n.event}textSearch(e){let t;const i=b(e),n=new c.Emitter({onFirstListenerDidAdd:()=>{(t=s.createCancelablePromise(e=>this.ripgrepTextSearch(i,e=>n.fire(e),e))).then(e=>n.fire(e),e=>n.fire({type:"error",error:{message:e.message,stack:e.stack}}))},onLastListenerRemove:()=>{t.cancel()}});return n.event}ripgrepTextSearch(e,t,i){return e.maxFileSize=m.MAX_FILE_SIZE,new v.TextSearchEngineAdapter(e).search(i,t,t)}doFileSearch(e,t,i){return this.doFileSearchWithEngine(g.Engine,e,t,i)}doFileSearchWithEngine(t,i,n,r,o=e.BATCH_SIZE){let s=0;const a=e=>{Array.isArray(e)?(s+=e.length,n(e.map(e=>this.rawMatchToSearchItem(e)))):e.relativePath?(s++,n(this.rawMatchToSearchItem(e))):n(e)};if(i.sortByScore){let e=this.trySortedSearchFromCache(i,a,r);if(!e){const o=new t(i.maxResults?l.assign({},i,{
maxResults:null}):i);e=this.doSortedSearch(o,i,n,a,r)}return new Promise((t,i)=>{e.then(([e,i])=>{const r=i.map(e=>this.rawMatchToSearchItem(e));this.sendProgress(r,n,o),t(e)},i)})}const c=new t(i);return this.doSearch(c,a,o,r).then(e=>({limitHit:e.limitHit,type:"success",stats:{detailStats:e.stats,type:"searchProcess",fromCache:!1,resultCount:s,sortingTime:void 0}}))}rawMatchToSearchItem(e){return{path:e.base?r.join(e.base,e.relativePath):e.relativePath}}doSortedSearch(e,t,i,n,r){const o=new c.Emitter;let a,l=s.createCancelablePromise(t=>{let i=[];return this.doSearch(e,e=>{Array.isArray(e)?i=e:(n(e),o.fire(e))},-1,t).then(e=>[e,i])});if(t.cacheKey){a=this.getOrCreateCache(t.cacheKey);const e={promise:l,event:o.event,resolved:!1};a.resultsToSearchCache[t.filePattern||""]=e,l.then(()=>{e.resolved=!0},e=>{delete a.resultsToSearchCache[t.filePattern||""]}),l=this.preventCancellation(l)}return l.then(([e,i])=>{
const n=a?a.scorerCache:Object.create(null),o=("number"!=typeof t.maxResults||t.maxResults>0)&&u.StopWatch.create(!1);return this.sortResults(t,i,n,r).then(n=>{const r=o?o.elapsed():-1;return[{type:"success",stats:{detailStats:e.stats,sortingTime:r,fromCache:!1,type:"searchProcess",workspaceFolderCount:t.folderQueries.length,resultCount:n.length},limitHit:e.limitHit||"number"==typeof t.maxResults&&i.length>t.maxResults},n]})})}getOrCreateCache(e){const t=this.caches[e];return t||(this.caches[e]=new y)}trySortedSearchFromCache(e,t,i){const n=e.cacheKey&&this.caches[e.cacheKey];if(!n)return;const r=this.getResultsFromCache(n,e.filePattern||"",t,i);return r?r.then(([t,r,o])=>{const s=u.StopWatch.create(!1);return this.sortResults(e,r,n.scorerCache,i).then(i=>{const n=s.elapsed(),a={fromCache:!0,detailStats:o,type:"searchProcess",resultCount:r.length,sortingTime:n};return[{type:"success",limitHit:t.limitHit||"number"==typeof e.maxResults&&r.length>e.maxResults,stats:a},i]})}):void 0}sortResults(e,t,i,n){
const r=p.prepareQuery(e.filePattern||""),s="number"==typeof e.maxResults?e.maxResults:Number.MAX_VALUE;return o.topAsync(t,(e,t)=>p.compareItemsByFuzzyScore(e,t,r,!0,w,i),s,1e4,n)}sendProgress(e,t,i){if(i&&i>0)for(let n=0;n<e.length;n+=i)t(e.slice(n,n+i));else t(e)}getResultsFromCache(e,t,i,n){const o=u.StopWatch.create(!1),s=t.indexOf(r.sep)>=0;let c;for(const i in e.resultsToSearchCache)if(d.startsWith(t,i)){if(s&&i.indexOf(r.sep)<0&&""!==i)continue;const t=e.resultsToSearchCache[i];c={promise:this.preventCancellation(t.promise),event:t.event,resolved:t.resolved};break}if(!c)return null;const l=o.elapsed(),h=u.StopWatch.create(!1),m=c.event(i);return n&&n.onCancellationRequested(()=>{m.dispose()}),c.promise.then(([e,i])=>{if(n&&n.isCancellationRequested)throw a.canceled();const r=[],o=p.prepareQuery(t).normalizedLowercase;for(const e of i)f.isFilePatternMatch(e,o)&&r.push(e);return[e,r,{cacheWasResolved:c.resolved,cacheLookupTime:l,cacheFilterTime:h.elapsed(),cacheEntryCount:i.length}]})}doSearch(e,t,i,n){
return new Promise((r,o)=>{let s=[];n&&n.onCancellationRequested(()=>e.cancel()),e.search(e=>{e&&(i?(s.push(e),i>0&&s.length>=i&&(t(s),s=[])):t(e))},e=>{t(e)},(e,i)=>{s.length&&t(s),e?o(e):r(i)})})}clearCache(e){return delete this.caches[e],Promise.resolve(void 0)}preventCancellation(e){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(t,i){return e.then(t,i)}catch(e){return this.then(void 0,e)}finally(t){return e.finally(t)}}}}return e.BATCH_SIZE=512,e})();t.SearchService=_;class y{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const w=new class{getItemLabel(e){return r.basename(e.relativePath)}getItemDescription(e){return r.dirname(e.relativePath)}getItemPath(e){return e.relativePath}};function b(e){return Object.assign(Object.assign({},e),{folderQueries:e.folderQueries&&e.folderQueries.map(E),extraFileResources:e.extraFileResources&&e.extraFileResources.map(e=>h.URI.revive(e))})}function E(e){
return Object.assign(Object.assign({},e),{folder:h.URI.revive(e.folder)})}})),define(t[171],i([1,0,6,2,24,11,33,175,247,59,14,51,25,65,20,118]),(function(e,t,i,r,o,a,c,l,u,d,h,p,m,f,g,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtHostSearch=void 0;let _=(()=>{let e=class extends f.ExtHostSearch{constructor(e,t,i,n){super(e,i,n),this._pfs=o,this._internalFileSearchHandle=-1,this._internalFileSearchProvider=null,t.remote.isRemote&&t.remote.authority&&this._registerEHSearchProviders()}_registerEHSearchProviders(){const e=new d.OutputChannel(this._logService);this.registerTextSearchProvider(g.Schemas.file,new u.RipgrepSearchProvider(e)),this.registerInternalFileSearchProvider(g.Schemas.file,new l.SearchService)}registerInternalFileSearchProvider(e,t){const n=this._handlePool++;return this._internalFileSearchProvider=t,this._internalFileSearchHandle=n,this._proxy.$registerFileSearchProvider(n,this._transformScheme(e)),i.toDisposable(()=>{this._internalFileSearchProvider=null,
this._proxy.$unregisterProvider(n)})}$provideFileSearchResults(e,t,i,n){const r=f.reviveQuery(i);return e===this._internalFileSearchHandle?this.doInternalFileSearch(e,t,r,n):super.$provideFileSearchResults(e,t,i,n)}doInternalFileSearch(e,t,i,n){if(!this._internalFileSearchProvider)throw new Error("No internal file search handler");return this._internalFileSearchProvider.doFileSearch(i,i=>{c.isSerializedFileMatch(i)&&(i=[i]),Array.isArray(i)?this._proxy.$handleFileMatch(e,t,i.map(e=>r.URI.file(e.path))):i.message&&this._logService.debug("ExtHostSearch",i.message)},n)}$clearCache(e){return this._internalFileSearchProvider&&this._internalFileSearchProvider.clearCache(e),super.$clearCache(e)}createTextSearchManager(e,t){return new v.NativeTextSearchManager(e,t)}};return e=n([s(0,h.IExtHostRpcService),s(1,m.IExtHostInitDataService),s(2,p.IURITransformerService),s(3,a.ILogService)],e)})();t.NativeExtHostSearch=_})),
define(t[145],i([1,0,74,60,226,31,108,30,43,39,236,37,66,235,234,44,65,171,151,58,38,250,76,11,186,54,223,52]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m,f,g,v,_,y,w,b,E,x,C,S,k,T){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),i.registerSingleton(x.ILogService,C.ExtHostLogService),i.registerSingleton(T.IExtHostApiDeprecationService,T.ExtHostApiDeprecationService),i.registerSingleton(n.IExtHostOutputService,r.ExtHostOutputService2),i.registerSingleton(o.IExtHostWorkspace,o.ExtHostWorkspace),i.registerSingleton(s.IExtHostDecorations,s.ExtHostDecorations),i.registerSingleton(a.IExtHostConfiguration,a.ExtHostConfiguration),i.registerSingleton(c.IExtHostCommands,c.ExtHostCommands),i.registerSingleton(l.IExtHostDocumentsAndEditors,l.ExtHostDocumentsAndEditors),i.registerSingleton(d.IExtHostTerminalService,u.ExtHostTerminalService),i.registerSingleton(h.IExtHostTask,p.ExtHostTask),i.registerSingleton(f.IExtHostDebugService,m.ExtHostDebugService),
i.registerSingleton(g.IExtHostSearch,v.NativeExtHostSearch),i.registerSingleton(y.IExtensionStoragePaths,_.ExtensionStoragePaths),i.registerSingleton(w.IExtHostExtensionService,b.ExtHostExtensionService),i.registerSingleton(E.IExtHostStorage,E.ExtHostStorage),i.registerSingleton(S.IExtHostTunnelService,k.ExtHostTunnelService)})),define(t[144],i([1,0,89,263,19,95,92,88,182,237,29,102,24,143,16,145]),(function(e,t,i,n,r,o,s,a,c,l,u,d,h,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startExtensionHostProcess=void 0,function(){for(let e=0;e<process.execArgv.length;e++)"--inspect-port=0"===process.execArgv[e]&&(process.execArgv.splice(e,1),e--)}();const f=n(process.argv.slice(2),{string:["uriTransformerPath","useHostProxy"]});!function(){const t=e.__$__nodeRequire("module"),i=t._load;t._load=function(e){
if("natives"===e)throw new Error('Either the extension or a NPM dependency is using the "natives" node module which is unsupported as it can cause a crash of the extension host. Click [here](https://go.microsoft.com/fwlink/?linkid=871887) to find out more');return i.apply(this,arguments)}}();const g=process.exit.bind(process);let v=function(){g()};async function _(){const e=await function(){if(process.env.VSCODE_EXTHOST_WILL_SEND_SOCKET)return new Promise((e,t)=>{let i=null,n=setTimeout(()=>{t(new Error("VSCODE_EXTHOST_IPC_SOCKET timeout"))},6e4);const r=new m.RunOnceScheduler(()=>v(),108e5),a=new m.RunOnceScheduler(()=>v(),3e5);process.on("message",(t,c)=>{if(t&&"VSCODE_EXTHOST_IPC_SOCKET"===t.type){const l=u.VSBuffer.wrap(Buffer.from(t.initialDataChunk,"base64"));let d;d=t.skipWebSocketFrames?new s.NodeSocket(c):new s.WebSocketNodeSocket(new s.NodeSocket(c)),i?(r.cancel(),a.cancel(),i.beginAcceptReconnection(d,l),i.endAcceptReconnection()):(clearTimeout(n),(i=new o.PersistentProtocol(d,l)).onClose(()=>v()),
e(i),i.onSocketClose(()=>{r.schedule()}))}if(t&&"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"===t.type){if(a.isScheduled())return;r.isScheduled()&&a.schedule()}});const c={type:"VSCODE_EXTHOST_IPC_READY"};process.send&&process.send(c)});{const e=process.env.VSCODE_IPC_HOOK_EXTHOST;return new Promise((t,n)=>{const r=i.createConnection(e,()=>{r.removeListener("error",n),t(new o.PersistentProtocol(new s.NodeSocket(r)))});r.once("error",n)})}}();return new class{constructor(){this._onMessage=new o.BufferedEmitter,this.onMessage=this._onMessage.event,this._terminating=!1,e.onMessage(e=>{c.isMessageOfType(e,2)?(this._terminating=!0,v()):this._onMessage.fire(e)})}send(t){this._terminating||e.send(t)}}}t.startExtensionHostProcess=async function(){const t=await _(),i=await function(t){return new Promise(i=>{const n=t.onMessage(o=>{n.dispose();const s=JSON.parse(o.toString()),l=s.commit,u=a.default.commit;l&&u&&l!==u&&g(55);const d=[];let h;process.on("unhandledRejection",(e,t)=>{d.push(t),setTimeout(()=>{const i=d.indexOf(t)
;i>=0&&t.catch(t=>{d.splice(i,1),console.warn(`rejected promise not handled within 1 second: ${t}`),t&&t.stack&&console.warn(`stack trace: ${t.stack}`),r.onUnexpectedError(e)})},1e3)}),process.on("rejectionHandled",e=>{const t=d.indexOf(e);t>=0&&d.splice(t,1)}),process.on("uncaughtException",(function(e){r.onUnexpectedError(e)})),setInterval((function(){try{process.kill(s.parentPid,0)}catch(e){v()}}),1e3);try{(h=e.__$__nodeRequire("native-watchdog")).start(s.parentPid)}catch(e){r.onUnexpectedError(e)}t.send(c.createMessageOfType(0)),i({protocol:t,initData:s})});t.send(c.createMessageOfType(1))})}(t),{initData:n}=i;var o;o=!!n.environment.extensionTestsLocationURI,process.exit=function(e){if(o)g(e);else{const e=new Error("An extension called process.exit() and this was prevented.");console.warn(e.stack)}},process.crash=function(){const e=new Error("An extension called process.crash() and this was prevented.");console.warn(e.stack)},
n.environment.useHostProxy=void 0!==f.useHostProxy?"false"!==f.useHostProxy:void 0;const s=new class{exit(e){g(e)}exists(e){return h.exists(e)}realpath(e){return p.realpath(e)}};let u=null;if(n.remote.authority&&f.uriTransformerPath)try{const t=e.__$__nodeRequire(f.uriTransformerPath)(n.remote.authority);u=new d.URITransformer(t)}catch(e){console.error(e)}const m=new l.ExtensionHostMain(i.protocol,n,s,u);v=()=>m.terminate()}})),define(t[264],i([1,0,144]),(function(e,t,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),i.startExtensionHostProcess().catch(e=>console.log(e))}))}).call(this);
//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/a5d1cc28bb5da32ec67e86cc50f84c67cc690321/core/vs/workbench/services/extensions/node/extensionHostProcess.js.map
